<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

if ($_GET['action'] == 'getSomeArticles') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $searchCategory = $_GET['searchCategory'] ? $_GET['searchCategory'] : '';

        $pagesData = $ArticlesAdmObj->getSomeArticles($start, $aItemsPerPage, $sort, $type, $searchTitle, $searchCategory);

        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}

if ($_GET['action'] == 'getSearchArticlesCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $searchCategory = $_GET['searchCategory'] ? $_GET['searchCategory'] : '';

        $pagesSearchData = $ArticlesAdmObj->getSearchArticlesCount($sort, $type, $searchTitle, $searchCategory);

        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getArticlesCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $pagesData = $ArticlesAdmObj->getArticlesCount();
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}



if ($_GET['action'] == 'getSomeArticlesComments') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : '';
        $searchStatus = $_GET['searchStatus'] ? $_GET['searchStatus'] : '';

        $pagesData = $ArticlesAdmObj->getSomeArticlesComments($start, $aItemsPerPage, $sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo, $searchStatus);

        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getSearchArticlesCommentsCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : '';
        $searchStatus = $_GET['searchStatus'] ? $_GET['searchStatus'] : '';
        $pagesSearchData = $ArticlesAdmObj->getSearchArticlesCommentsCount($sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo, $searchStatus);

        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getArticlesCommentsCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $pagesData = $ArticlesAdmObj->getArticlesCommentsCount();
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}





if ($_GET['action'] == 'getAllCategories') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $type = $_GET['type'] ? $_GET['type'] : 'article';
        $pagesData = $ArticlesAdmObj->getAllCategories($type);
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}





if ($_GET['action'] == 'addEditArticle') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $temp = array();
        $allow_ext = array("jpg", "webp", "gif", "png", "jpeg", "bmp");
        $maxsize = 1024 * 1024 * 5; //kb
        // $uploadFolder = 'wethaq/api/uploads/banks';
        $uploadFolder = $Config['uploads_path'] . 'articles';

        $thumbsConfig = array(
            array(
                'width' => '100',
                'hight' => '100'
            )
        );

        if (strpos($_FILES["file"]['type'], 'image') !== false) {
            $thum = true;
        } else {
            $thum = false;
        }

        $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);

        if (isset($_FILES['file']['name']) and $_FILES['file']['name'] != '') {

            //get file name
            $file['name'] = addslashes($_FILES["file"]["name"]);
            // get file type
            $file['type'] = $_FILES["file"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["file"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["file"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);

                //if uploagetStageByParentIDding successfully
                if ($upfile) {
                    $temp['file'] = $upfile['newname'];
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
        } else {
            $temp = null;
        }

        $pageData = $ArticlesAdmObj->addEditArticle($_REQUEST, $temp['file']);
        $Data = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}


if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);


    if ($_GET['action'] == 'getOneArticle') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $onepageData = $ArticlesAdmObj->getOneArticle($Req);
            $Data = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'checkIfSlugExistInArticles') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $onepageData = $ArticlesAdmObj->checkIfSlugExistInArticles($Req);
            $Data = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'deletePage') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $ArticlesAdmObj->deletePage($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }



    if ($_GET['action'] == 'deleteComment') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $ArticlesAdmObj->deleteComment($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'activeComment') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $ArticlesAdmObj->activeComment($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }



}