<?php

/* * *************************************************************************
 *
 *   PROJECT: BigWish App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

 header('Access-Control-Allow-Origin: *');
 header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
 header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');
 
 require_once 'init.php';


// Handle API requests
if (isset($_GET['action'])) {

    $Data = ['status' => false, 'msg' => 'Invalid action'];

    $config;
    $allowed_ext = ["mp3", "webp", "mp4", "mov", "wmv", "flv", "jpg", "gif", "png", "jpeg", "bmp", "pdf", "doc", "docm", "docx", "dot", "dotx"];
    $maxsize = 5368709120;


    switch ($_GET['action']) {
        case 'uploadAttachment':
            // print_r($_FILES);die();
            if (isset($_GET['course_id'])) {

                $course_id = $_GET['course_id'];
                // $upload_path = $_GET['upload_path'];
                ini_set('memory_limit', '2G');
                ini_set('max_execution_time', 7200);
                ini_set('post_max_size', '5G');
                ini_set('upload_max_filesize', '5G');

                $Data = ['status' => false, 'msg' => ''];

                try {
                    if (!isset($_FILES['file'])) {
                        throw new Exception('No file uploaded');
                    }

                    $file = $_FILES['file'];
                    $fileName = $file['name'];
                    $fileSize = $file['size'];
                    $fileTmp = $file['tmp_name'];
                    $fileType = $file['type'];
                    $fileError = $file['error'];

                    // Validate file size
                    if ($fileSize > $maxsize) {
                        throw new Exception('File size exceeds limit (5GB)');
                    }

                    // Get file extension and validate
                    $fileExt = strtolower(pathinfo($fileName, PATHINFO_EXTENSION));
                    if (!in_array($fileExt, $allowed_ext)) {
                        throw new Exception('File type not allowed');
                    }

                    $uploadPath = $_SERVER['DOCUMENT_ROOT'] . "/uploads/course_videos_and_attachments";
                    // Create module folder if it doesn't exist
                    $moduleFolder = $uploadPath . '/' . $course_id;
                    // echo $moduleFolder;die();
                    if (!is_dir($moduleFolder)) {
                        if (!mkdir($moduleFolder, 0755, true)) {
                            throw new Exception('Failed to create module directory');
                        }
                    }

                    // Generate unique filename
                    $newFileName = uniqid() . '_' . $fileName;
                    $destination = $moduleFolder . '/' . $newFileName;

                    // Move uploaded file
                    if ($fileSize > 5242880) { // 5MB
                        // Use chunk copy for large files
                        if (!copyLargeFile($fileTmp, $destination)) {
                            throw new Exception('Failed to copy large file');
                        }
                    } else {
                        if (!move_uploaded_file($fileTmp, $destination)) {
                            throw new Exception('Failed to move uploaded file');
                        }
                    }

                    // Prepare response
                    $Data['status'] = true;
                    $Data['msg'] = 'File uploaded successfully';
                    $Data['file_name'] = $newFileName;
                    $Data['original_name'] = $fileName;
                    $Data['file_size'] = $fileSize;
                    $Data['file_type'] = $fileType;

                    // Handle video files
                    if (in_array($fileExt, ['mp4', 'mov', 'wmv', 'flv'])) {
                        $duration = getVideoDuration($destination);
                        $Data['duration'] = $duration;
                    }

                } catch (Exception $e) {
                    $Data['status'] = false;
                    $Data['msg'] = $e->getMessage();
                    if (isset($file['error'])) {
                        $Data['error_code'] = $file['error'];
                    }
                }
            } else {
                $Data['msg'] = 'Missing required parameters';
            }
            break;

        case 'deleteAttachment':
            if (isset($_GET['course_id']) && isset($_GET['file_name']) && isset($_GET['upload_path'])) {
                $Data = $attachmentHandler->deleteAttachment($_GET['course_id'], $_GET['file_name'], $_GET['upload_path']);
            } else {
                $Data['msg'] = 'Missing required parameters';
            }
            break;
    }

}

function copyLargeFile($source, $destination, $chunkSize = 1048576) {
    $fsrc = fopen($source, 'rb');
    $fdest = fopen($destination, 'wb');
    
    while (!feof($fsrc)) {
        if (fwrite($fdest, fread($fsrc, $chunkSize)) === false) {
            return false;
        }
    }
    
    fclose($fsrc);
    fclose($fdest);
    
    return true;
}



function getVideoDuration($videoPath) {
    if (class_exists('FFMpeg\\FFMpeg')) {
        try {
            $ffmpeg = FFMpeg\FFMpeg::create();
            $video = $ffmpeg->open($videoPath);
            $duration = $video->getFormat()->get('duration');
            return $duration;
        } catch (Exception $e) {
            return 0;
        }
    }
    return 0;
}

echo json_encode($Data);