<?php

$userAdmObj = new users();

class users
{

    var $mDb;
    var $mConfig;
    var $notificate;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->notificate = new pushmessage();
    }

    function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }


    public function getAllRegisterUsers()
    {
        $sql = "SELECT stage_id, grade_id, user_type FROM `users` where is_deleted != 1";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    function signIn($email, $password)
    {

        $sql = "SELECT `id`, `password` FROM `users` ";
        $sql .= " WHERE ( `email` = '{$email}' OR  `mobile` = '{$email}') AND ( `user_level` IS NOT NULL )";
//        echo $sql;
        $result = $this->mDb->getRow($sql);
        if (count($result) > 0) {
            $login = password_verify($password, $result['password']);
            if ($login === true) {
                $stmt = "SELECT `id`, `mobile`, `email`, `full_name`, `date_added`, `img`, `user_level`,`authentication_code` FROM `users` ";
                $stmt .= " WHERE `id` = '{$result['id']}' AND `user_level` IS NOT NULL ";
                return $this->mDb->getRow($stmt);
            }
        }
    }

    function getUserLevel($request)
    {

        $user_id = $request['user_id'];
        $roles = $request['roles'];

        $select = implode(", ", $roles);

        $query = "SELECT u.`id` AS 'user_id_in_users', {$select} FROM `users` u";
        $query .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        $query .= " WHERE u.`id` = '{$user_id}' ";
//     echo $query; die();
        return $this->mDb->getRow($query);
    }

/////////////////////////////////////// Admins ///////////////////////////////////////////////

    function getSomeUsers($userType, $aStart, $aLimit, $sort, $type, $searchName, $searchEmail, $searchUserPhone, $searchDateFrom, $searchDateTo, $searchUserStatus, $searchUserType, $searchId, $searchCountry, $searchStage, $searchGrade)
    {

        $sql = "SELECT u.id, u.email, u.mobile_is_valid, u.full_name,u.is_deleted, u.date_added, u.mobile ,u.img, ul.level_name, u.`user_type`,u.`status` ";
        if ($userType === "members") {
            $sql .= ",sub.subscription_type,sub.cost_type ";
        }

        $sql .= " FROM `users` u";
        $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        if ($userType === "members") {
            $sql .= " LEFT JOIN `user_subscription` sub ON sub.user_id = u.id  ";
        }
        $sql .= " WHERE u.`id` > 0  ";
        if ($userType === "members") {
            $sql .= "  AND sub.id IN 
( 
SELECT max(id) 
FROM `user_subscription` 
group by user_id 
)  ";
        }
        $sql .= $userType === "members" ? " AND u.`user_type` IS NOT NULL" : "";
        $sql .= $userType === "admins" ? " AND u.`user_level` IS  NOT NULL AND u.`user_type` IS NULL  " : "";
        $sql .= $searchName ? ' AND u.full_name like "%' . $searchName . '%"' : '';
        $sql .= $searchEmail ? ' AND u.email like "%' . $searchEmail . '%"' : '';
        $sql .= $searchUserPhone ? ' AND u.`mobile` like "%' . $searchUserPhone . '%"' : '';
        $sql .= $searchDateFrom ? " AND u.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= $searchUserStatus != '' ? " AND u.`status` = '{$searchUserStatus}'" : "";
        $sql .= $searchUserType ? " AND u.`user_type` = '{$searchUserType}'" : "";
        $sql .= $searchId ? ' AND u.id like "%' . $searchId . '%"' : '';
        $sql .= $searchCountry ? ' AND `country_id` ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND  `stage_id` ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND  `grade_id` = "' . $searchGrade . '"' : '';
        if ($userType === "members") {
            $sql .= " GROUP BY sub.user_id ";
            $sql .= "ORDER BY sub.`date_added` DESC";
        }


        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //   echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function getSearchUsersCount($userType, $sort, $type, $searchName, $searchEmail, $searchUserPhone, $searchDateFrom, $searchDateTo, $searchUserStatus, $searchUserType, $searchId, $searchCountry, $searchStage, $searchGrade)
    {
        $sql = "SELECT COUNT(u.`id`) as 'result_count' FROM `users` u";
        $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        if ($userType === "members") {
            $sql .= " LEFT JOIN `user_subscription` sub ON sub.user_id = u.id ";
        }
        $sql .= " WHERE u.`id` > 0  ";
        if ($userType === "members") {
            $sql .= "  AND sub.id IN 
( 
SELECT max(id) 
FROM `user_subscription` 
group by user_id 
)  ";
        }
        $sql .= $userType === "members" ? " AND u.`user_type` IS NOT NULL " : "";
        $sql .= $userType === "admins" ? " AND u.`user_level` IS  NOT NULL AND `user_type` IS NULL  " : "";
        $sql .= $searchName ? ' AND u.`full_name` like "%' . $searchName . '%"' : '';
        $sql .= $searchEmail ? ' AND u.`email` like "%' . $searchEmail . '%"' : '';
        $sql .= $searchUserPhone ? ' AND u.`mobile` like "%' . $searchUserPhone . '%"' : '';
        $sql .= $searchDateFrom ? " AND u.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= $searchUserStatus != '' ? " AND u.`status` = '{$searchUserStatus}'" : "";
        $sql .= $searchUserType ? " AND u.`user_type` = '{$searchUserType}'" : "";
        $sql .= $searchId ? ' AND u.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchCountry ? ' AND u.`country_id` ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND  u.`stage_id` ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND  u.`grade_id` = "' . $searchGrade . '"' : '';
        $sql .= " ORDER BY u.{$sort} {$type}";
        //  echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function getUsersCount($userType)
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `users`";
        $sql .= $userType === "members" ? " WHERE `user_level` IS NULL  " : "";
        $sql .= $userType === "admins" ? " WHERE `user_level` IS NOT NULL  " : "";
        return $this->mDb->getOne($sql);
    }

    function insertAuthCode($aId, $authentication_code)
    {
        $sql = " UPDATE `users` SET `authentication_code` = '{$authentication_code}'";
        $sql .= " WHERE `id` = '{$aId}'";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }


    function chickEmail($email)
    {

        $sql = "SELECT COUNT(`id`) as 'count' FROM `users`";
        $sql .= " WHERE `email` = '{$email}'";
        return $this->mDb->getOne($sql);
    }


    function chickMobile($mobile)
    {

        $sql = "SELECT COUNT(`id`) as 'count' FROM `users`";
        $sql .= " WHERE `mobile` = '{$mobile}'";
        return $this->mDb->getOne($sql);
    }

    function addEditUser($request, $img, $user_id)
    {

//    print_r($request); die();

        unset($request['action']);
        $request['pin'] = $request['pin'] ? password_hash($request['pin'], PASSWORD_DEFAULT) : "";
        if ($user_id === '' && $request['operation'] === 'add') {
            // Add
            unset($request['operation']);
            $dateTime = date('Y-m-d H:i:s');
            $request['password'] = password_hash($request['password'], PASSWORD_DEFAULT);

            $sql = "INSERT INTO `users` SET ";
            $sql .= " `full_name` = '{$request['full_name']}',";
            $sql .= $request['userType'] === 'admins' ? " `user_level` = '{$request['user_level']}'," : "`user_level` = NULL , ";
            $sql .= $request['userType'] === 'members' ? " `user_type` = '{$request['user_type']}'," : "";
            $sql .= $request['email'] && $request['email'] != '' && $request['email'] != null ? " `email` = '{$request['email']}'," : "";
            $sql .= " `mobile` = '{$request['mobile']}',";
            $sql .= $request['country_code'] ? " `country_code` = '{$request['country_code']}'," : "";
            $sql .= " `password` = '{$request['password']}',";
            if ($request['pin']):
                $sql .= " `pin` = '{$request['pin']}',";
            endif;
            $sql .= $request['notes'] ? " `notes` = '{$request['notes']}'," : "";
            $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
            $sql .= $request['is_deleted'] === 'true' ? " `is_deleted` = '1'," : " `is_deleted` = '0',";
            $sql .= $request['mobile_is_valid'] === 'true' ? " `mobile_is_valid` = '1'," : " `mobile_is_valid` = '0',";

            $sql .= $request['country_id'] && $request['country_id'] != '' ? " `country_id` = '{$request['country_id']}'," : "";
            $sql .= $request['stage_id'] && $request['stage_id'] != '' ? " `stage_id` = '{$request['stage_id']}'," : "";
            $sql .= $request['grade_id'] && $request['grade_id'] != '' ? " `grade_id` = '{$request['grade_id']}'," : "";
            if ($request['specialize_id'] > 0):
                $sql .= " `specialize_id` = '{$request['specialize_id']}',";
            endif;
            $sql .= $request['added_by'] && $request['added_by'] != '' && $request['added_by'] != null ? " `added_by` = '{$request['added_by']}'," : "";
            $sql .= " `img` = '{$img}',";
            $sql .= " `date_added` = '{$dateTime}'";
            //    echo $sql; die();
            $this->mDb->query($sql);
            $id = $this->mDb->getLastInsertId();

            if ($id) {
                $this->insertAuthCode($id, password_hash($id . $this->mConfig['apihash'], PASSWORD_DEFAULT));
                $request['lon'] && $request['lat'] ? $this->addUserLocation($id, $request['lon'], $request['lat'], $request['area']) : "";
                if ($request['user_type'] == 'student') {
                    $data = json_decode($request['parentIDs']);
                    $newDataObj = $this->convert_object_to_array($data);
                    if (count($newDataObj) > 0) {
                        $this->addStudentParent($id, $newDataObj, $request['user_type'], 'add');
                    }
                } elseif ($request['user_type'] == 'parent') {
                    $data = json_decode($request['studentIDs']);
                    $newDataObj = $this->convert_object_to_array($data);
                    if (count($newDataObj) > 0) {
                        $this->addStudentParent($id, $newDataObj, $request['user_type'], 'add');
                    }
                }

                if ($request['user_type'] == 'student' || $request['user_type'] == 'parent' || $request['user_type'] == 'teacher') {
                    $this->addUserSubscription($id);
                }

                if ($request['userType'] === 'admins') {

                    $data = json_decode($request['admin_roles']);
                    $newDataObj = $this->convert_object_to_array($data);
                    // print_r($newDataObj);

                    if (count($newDataObj) > 0) {

                        $this->addAdminRoles($id, $newDataObj);
                    }
                }
            }

            return $id;
        } else {
            // Edit
            $check_query = "SELECT `id` FROM `users` WHERE `id` = '{$user_id}'";
            $check_query .= $request['userType'] === "admins" ? " AND `user_level` IS NOT NULL" : "";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {
                return 403;
            } else {
                $sql = "UPDATE `users` SET ";
                $sql .= $request['userType'] === 'admins' ? " `user_level` = '{$request['user_level']}'," : "`user_level` = NULL , ";
                $sql .= $request['userType'] === 'members' ? " `user_type` = '{$request['user_type']}'," : "";
                $sql .= $request['email'] && $request['email'] != '' && $request['email'] != null ? " `email` = '{$request['email']}'," : " `email` = NULL ,";
                $sql .= $request['notes'] ? " `notes` = '{$request['notes']}'," : "";
                $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
                if ($request['pin']):
                    $sql .= " `pin` = '{$request['pin']}',";
                endif;
                $sql .= $request['mobile_is_valid'] === 'true' ? " `mobile_is_valid` = '1'," : " `mobile_is_valid` = '0',";
                $sql .= $request['is_deleted'] === 'true' ? " `is_deleted` = '1'," : " `is_deleted` = '0',";
                $sql .= $request['country_id'] && $request['country_id'] != '' ? " `country_id` = '{$request['country_id']}'," : "";
                $sql .= $request['stage_id'] && $request['stage_id'] != '' ? " `stage_id` = '{$request['stage_id']}'," : "";
                $sql .= $request['grade_id'] && $request['grade_id'] != '' ? " `grade_id` = '{$request['grade_id']}'," : "";
                if ($request['specialize_id'] > 0):
                    $sql .= " `specialize_id` = '{$request['specialize_id']}',";
                endif;
                $sql .= $request['country_code'] ? " `country_code` = '{$request['country_code']}'," : "";
                $sql .= $request['added_by'] && $request['added_by'] != '' && $request['added_by'] != null ? " `added_by` = '{$request['added_by']}'," : "";
                $sql .= "`full_name`='{$request['full_name']}',`mobile`='{$request['mobile']}' ";
                if ($request['password'] == '' || $request['password'] == null) {
                } else {
                    $request['password'] = password_hash($request['password'], PASSWORD_DEFAULT);
                    $sql .= ", `password`='{$request['password']}' ";
                }

                if ($img != '' && $img != null) {
                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `users` WHERE `id` = '{$user_id}'";
                    $img_query .= $request['userType'] === "admins" ? " AND `user_level` IS NOT NULL" : "";
                    $img_result = $this->mDb->getOne($img_query);
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/' . $img_result;
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                    $sql .= ",`img`='{$img}' ";
                }
                $sql .= " WHERE `id` = '{$user_id}'";
                $res = $this->mDb->query($sql);
                if ($request['lon'] && $request['lat']) {
                    $dateTime = date('Y-m-d H:i:s');
                    $sqllo = "UPDATE `user_location` SET ";
                    $sqllo .= " `lat` = '{$request['lat']}',";
                    $sqllo .= " `lon` = '{$request['lon']}',";
                    $sqllo .= " `area` = '{$request['area']}',";
                    $sqllo .= " `date_updated` = '{$dateTime}'";
                    $sqllo .= " WHERE `user_id` = '{$user_id}'";

                    $this->mDb->query($sqllo);
                }

                if ($request['user_type'] == 'student') {
                    $data = json_decode($request['parentIDs']);
                    $newDataObj = $this->convert_object_to_array($data);
                    if (count($newDataObj) > 0) {
                        $this->addStudentParent($user_id, $newDataObj, $request['user_type'], 'edit');
                    }
                } elseif ($request['user_type'] == 'parent') {
                    $data = json_decode($request['studentIDs']);
                    $newDataObj = $this->convert_object_to_array($data);
                    if (count($newDataObj) > 0) {
                        $this->addStudentParent($user_id, $newDataObj, $request['user_type'], 'edit');
                    }
                }

                if ($request['userType'] === 'admins') {
                    $data = json_decode($request['admin_roles']);
                    $newDataObj = $this->convert_object_to_array($data);
                    if (count($newDataObj) > 0) {
                        $this->addAdminRoles($user_id, $newDataObj);
                    }
                }

                return $res;
            }
        }
    }


    function addUserLocation($user_id, $lon, $lat, $area)
    {
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `user_location` SET ";
        $sql .= " `user_id` = '{$user_id}',";
        $sql .= " `lat` = '{$lat}',";
        $sql .= " `lon` = '{$lon}',";
        $sql .= " `area` = '{$area}',";
        $sql .= " `date_added` = '{$dateTime}',";
        $sql .= " `date_updated` = '{$dateTime}'";
        $this->mDb->query($sql);
    }

    function addStudentParent($user_id, $parents, $user_type, $operation_type)
    {
        if ($operation_type == 'edit') {
            if ($user_type == 'student') {
                $catsql = "DELETE FROM `students_parents` ";
                $catsql .= " WHERE `student_id` = '$user_id'";
                $this->mDb->query($catsql);
            } elseif ($user_type == 'parent') {
                $catsql = "DELETE FROM `students_parents` ";
                $catsql .= " WHERE `parent_id` = '$user_id'";
                $this->mDb->query($catsql);
            }
        }

        $dateTime = date('Y-m-d H:i:s');
        foreach ($parents as $key => $value) {
            $validate = $value['validate'] == 'true' ? '1' : '0';
            $validate == '1' ? "'{$dateTime}'" : '';
            $verified_date = $validate == '1' ? $dateTime : null;
            if (($user_type == 'student' && $value['parent_id'] > 0) || ($user_type == 'parent' && $value['student_id'] > 0)) {
                $stmt = "INSERT INTO `students_parents`(`student_id`, `parent_id`, `validate`,`date_added`,`verified_date`) ";
                if ($user_type == 'student') {
                    $stmt .= " VALUES ('{$user_id}', '{$value['parent_id']}', '{$validate}', '{$dateTime}','{$verified_date}')";
                } elseif ($user_type == 'parent') {
                    $stmt .= " VALUES ('{$value['student_id']}','{$user_id}', '{$validate}', '{$dateTime}','{$verified_date}')";
                }
                $this->mDb->query($stmt);
            }
        }

    }

    function addAdminRoles($user_id, $roles)
    {
        foreach ($roles as $key => $value) {
            $value['country_id'] = $value['country_id'] > 0 ? $value['country_id'] : 0;
            $value['stage_id'] = $value['stage_id'] > 0 ? $value['stage_id'] : 0;
            $value['grade_id'] = $value['grade_id'] > 0 ? $value['grade_id'] : 0;
            $value['subject_id'] = $value['subject_id'] > 0 ? $value['subject_id'] : 0;

            $checkquery = "SELECT `id` FROM `user_roles` ";
            $checkquery .= " WHERE `user_id` = '{$user_id}' AND `role_type` = '{$value['role_type']}' AND `country_id` = '{$value['country_id']}'  AND `stage_id` = '{$value['stage_id']}' AND `grade_id` = '{$value['grade_id'] }' AND `subject_id` = '{$value['subject_id'] }' ";
            $check_value = $this->mDb->getOne($checkquery);
            if ($check_value === false) {
                $stmt = "INSERT INTO `user_roles`(`user_id`, `role_type`, `country_id`,`stage_id`,`grade_id`,`subject_id`) ";
                $stmt .= " VALUES ('{$user_id}', '{$value['role_type']}', '{$value['country_id']}', '{$value['stage_id']}', '{$value['grade_id']}', '{$value['subject_id']}')";
                $this->mDb->query($stmt);
            }
        }

    }

    function addUserSubscription($user_id)
    {

        $dateTime = date('Y-m-d H:i:s');
        $start_date = date('Y-m-d');
        $end_date = date('Y-m-d', strtotime($start_date . ' +3 day'));
        $curentYear = date('Y');
        $curentMonth = date('m');
        if ($curentMonth <= 6) {
            $year_title = date('Y') . " / " . date('Y', strtotime($curentYear . ' -1 year'));
        } else {
            $year_title = date('Y', strtotime($curentYear . ' +1 year')) . " / " . date('Y');
        }

        $stmt = "INSERT INTO `user_subscription`(`user_id`, `start_date`, `end_date`,`subscription_type`,`year_title`,`cost_type`,`date_added`) ";
        $stmt .= " VALUES ('{$user_id}', '{$start_date}', '{$end_date}', 'free_period', '{$year_title}', 'free','{$dateTime}')";
        $this->mDb->query($stmt);

    }

    function getStudentParent($user_id, $user_type)
    {

        $sql = "SELECT * FROM `students_parents` ";
        $sql .= " WHERE `id` > 0 ";
        $sql .= $user_type == 'student' ? " AND `student_id` = '{$user_id}' " : " AND `parent_id` = '{$user_id}' ";

        $result = $this->mDb->getAll($sql);
        return $result;

    }

    function getAdminRoles($user_id)
    {
        $sql = "SELECT ur.* ,";
        $sql .= " stagel.`name` as 'stage',";
        $sql .= " cuntl.`name` as 'country',";
        $sql .= " gradel.`name` as 'grade', ";
        $sql .= " subjectt.`name` as 'subject' ";
        $sql .= "FROM `user_roles` ur ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( ur.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( ur.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( ur.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( ur.`subject_id` = subjectt.`id`)";
        $sql .= " WHERE ur.`user_id`= '{$user_id}'";
        $result = $this->mDb->getAll($sql);
        return $result;
    }

    function getAdminRolesControls($user_id)
    {
        $sql = "SELECT COUNT(`id`) from `user_roles`";
        $sql .= " WHERE `user_id`= '{$user_id}' AND `role_type` = 'all' ";
        $count = $this->mDb->getOne($sql);
        if ($count > 0) {
            return 'all';
        } else {
            $sql = "SELECT * from `user_roles`";
            $sql .= " WHERE `user_id`= '{$user_id}'";
            $results = $this->mDb->getAll($sql);
            if (count($results) > 0) {
                return $results;
            } else {
                return 'noRole';
            }
        }
    }

    function getOneUser($userType, $id)
    {

        $result = array();
        $sql = "SELECT u.`id`, u.`email`, u.`full_name`, u.`is_deleted`, u.`mobile`, u.`img`, u.`user_level`, u.`notes`, ul.`level_name`,u.`user_type`,u.`status`,u.`mobile_is_valid`,u.`country_code`,u.`country_id`,u.`stage_id`,u.`grade_id`,u.`specialize_id` FROM `users` u";
        $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        $sql .= " WHERE u.`id` = '$id'  ";
        $sql .= $userType === "members" ? " AND u.`user_type` IS NOT NULL" : " ";
        $sql .= $userType === "admins" ? " AND u.`user_level` IS  NOT NULL AND u.`user_type` IS NULL " : "";

        // echo $sql;die();
        $result = $this->mDb->getRow($sql);
        if ($result) {
            $stmt1 = "SELECT `id`, `area`, `lon`, `lat`,`date_added` FROM `user_location`";
            $stmt1 .= " WHERE `user_id` = '{$id}' ";
            $result['location'] = $this->mDb->getRow($stmt1);
            if ($result['user_type'] == 'student') {
                $result['parentIDs'] = $this->getStudentParent($id, 'student');
            } elseif ($result['user_type'] == 'parent') {
                $result['studentIDs'] = $this->getStudentParent($id, 'parent');
            } elseif ($result['user_type'] == 'teacher') {
                $_obj = array(
                    'id' => $id
                );
                $result['dataTeacher'] = $this->getTeacherDataByIdTeacher($_obj);

            }

            if ($userType === "admins") {
                $result['admin_roles'] = $this->getAdminRoles($id);
            }
        }


        return $result;
    }

    function getSearchUsersByType($query, $user_type)
    {

        $sql = "SELECT u.`id`, u.`full_name`, u.`img` FROM `users` u";
        $sql .= " WHERE u.`id` >0 AND u.`user_type` ='{$user_type}'";
        $sql .= $query && $user_type != 'teacher' ? ' AND u.`id` like "%' . $query . '%"' : '';
        $sql .= $query && $user_type == 'teacher' ? ' AND u.`full_name` like "%' . $query . '%"' : '';
//     echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function getAllSchoolYears($id)
    {

        $id = $id > 0 ? $id : 1;
        $sql = "SELECT lan.id, lan.title, lan.status, lan.first_semester_start, lan.first_semester_end, lan.second_semester_start, lan.second_semester_end, lan.date_added ,added_by,country_id FROM `school_years` lan";
        $sql .= " WHERE lan.id > 0 AND lan.status ='1' AND lan.country_id ='{$id}'";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function getSubscriptionCosts($subscription_type, $country_id)
    {
        $sql = "SELECT `cost` FROM `subscription_costs` ";
        $sql .= " WHERE  `country_id`='{$country_id}' AND `subscription_type` ='{$subscription_type}'";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function addingDriverToOrder($data)
    {

        $sql = "UPDATE `orders` SET `driver_id` = '{$data['driver_id']}' , `status`='assigned' ";
        $sql .= "WHERE `id` = '{$data['order_id']}' ";
        return $this->mDb->query($sql);
    }

    function addSubscription($requist)
    {
        /*        echo '<pre>';
                print_r($requist);
                echo '</pre>';
        */
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `user_subscription` SET ";
        $sql .= " `user_id` = '{$requist['user_id']}',";
        $sql .= " `start_date` = '{$requist['start_date']}',";
        $sql .= " `end_date` = '{$requist['end_date']}',";
        $sql .= " `subscription_type` = '{$requist['subscription_type']}',";
        $sql .= " `year_title` = '{$requist['year_title']}',";
        $sql .= " `cost` = '{$requist['cost']}',";
        $sql .= " `cost_type` = 'paid',";
        $sql .= " `date_added` = '{$dateTime}'";
//        echo $sql;
        $this->mDb->query($sql);
        $id = $this->mDb->getLastInsertId();

        return $id;
    }

    function deleteUser($userType, $ids)
    {
        $res = false;

        $tempids = '(' . implode(',', $ids) . ')';

//    $sql = "SELECT `img` FROM `users`";
//    $sql .= " WHERE `id` IN ".$tempids;
//    $images = $this -> mDb -> getAll($sql);
//
//    $catsqll = "DELETE FROM `user_location` ";
//    $catsqll.= " WHERE `user_id` IN ".$tempids;
//    $this-> mDb-> query($catsqll);
//
//    $catsqlladminrole = "DELETE FROM `user_roles` ";
//    $catsqlladminrole.= " WHERE `user_id` IN ".$tempids;
//    $this-> mDb-> query($catsqlladminrole);
//
//    $catsqllp = "DELETE FROM `students_parents` ";
//    $catsqllp.= " WHERE `student_id` IN ".$tempids . " OR `parent_id` IN ".$tempids;
//
//
//    $this-> mDb-> query($catsqllp);

//    $catsql = "DELETE FROM `users` ";
//    $catsql.= " WHERE `id` IN ".$tempids;

        $sql = "UPDATE `users` SET ";
        $sql .= " `is_deleted`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;

        $res = $this->mDb->query($sql);

        if ($res > 0) {

//        if(count($images)>0){
//            for ($i=0;$i<count($images);$i++){
//                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/'. $images[$i]['img'];
//                if (file_exists($old_img)) {
//                    @unlink($old_img);
//                }
//            }
//        }
            return $res;
        } else {
            return $res;
        }

    }

    function removeSubscription($ids)
    {
        $res = false;
        $tempids = '(' . implode(',', $ids) . ')';
        $catsql = "DELETE FROM `user_subscription` ";
        $catsql .= " WHERE `id` IN " . $tempids;
        $res = $this->mDb->query($catsql);
        if ($res > 0) {
            return $res;
        } else {
            return $res;
        }
    }

    function deleteStudentsParents($id)
    {
        $catsql = "DELETE FROM `students_parents` ";
        $catsql .= " WHERE `id` = '$id[0]'";
        return $this->mDb->query($catsql);
    }

    function removeTeacher($id)
    {
        $catsql = "DELETE FROM `assigning_test_to_teacher` ";
        $catsql .= " WHERE `id` = '$id[0]'";
        return $this->mDb->query($catsql);
    }

    function deleteAdminRole($id)
    {
        $catsql = "DELETE FROM `user_roles` ";
        $catsql .= " WHERE `id` = '$id[0]'";
        return $this->mDb->query($catsql);
    }


    function getUsersLevels()
    {
        $sql = "SELECT `id`, `level_name` FROM `user_levels`  ";
        return $this->mDb->getAll($sql);
    }

    function getUsersCountRegisteByMe($market_code)
    {
        $sqll = "SELECT count(`id`) FROM `users`";
        $sqll .= " WHERE `marketing_code` = '{$market_code}' ";
        return $this->mDb->getOne($sqll);
    }

    function getUserDetailsInfo($id)
    {

        $result = array();
        $sql = "SELECT u.`id`,u.`country_id`, u.`email`, u.`is_deleted`, u.`full_name`,u.`user_type`,u.`status`,u.`mobile_is_valid`,u.`country_code`, u.`mobile`, u.`img`, u.`notes`, u.`date_added` , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' ";
        $sql .= "  FROM `users` u ";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( u.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( u.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( u.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE u.`id` = '$id' ";

        //  echo $sql; die();
        $result = $this->mDb->getRow($sql);

        $sqlloc = "SELECT * FROM `user_location` ";
        $sqlloc .= " WHERE `user_id` = '$id' ";
        $result['userLocation'] = $this->mDb->getRow($sqlloc);

        if ($result['id'] > 0) {

            $sql = "SELECT us.* , fpt.payment_status, fpt.responce FROM `user_subscription` us ";
            $sql .= "LEFT JOIN `fawry_payment_transactions` fpt ON ( fpt.`id` = us.`fawry_payment_transaction_id` )";
            $sql .= "where us.`user_id` ='{$id}' ";
            $sql .= " GROUP BY us.`date_added` ";
            $result['subscriptions'] = $this->mDb->getAll($sql);

            for ($i = 0; $i < count($result['subscriptions']); $i++) {
                $result['subscriptions'][$i]['responce'] = json_decode($result['subscriptions'][$i]['responce']);
            }
        }

        if ($result['user_type'] == 'teacher') {
            $result['all_tests'] = $this->getTeacherTests($result['id']);
            $result['all_teacher_groups'] = $this->getTeacherGroups($result['id']);
        }

        return $result;
    }


    function getTeacherTests($TeacherId)
    {
        $sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.type,te.sort, te.status, te.date_added, te.name,  ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " unitl.`name` as 'unit_name' , ";
        $sql .= " lessonl.`name` as 'lesson_name' , ";
        $sql .= " subjectt.`name` as 'subject_name' , ";
        $sql .= " subjectt.`subject_direction` as 'subject_direction'";
        $sql .= " FROM `tests` te";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE te.id > 0 ";
        $sql .= " AND te.`teacher_id` = '{$TeacherId}'";

        $sql .= " ORDER BY te.`id` DESC";


//	 echo $sql; die();

        return $this->mDb->getAll($sql);
    }


    function getTeacherGroups($TeacherId)
    {
        $sql = "SELECT o.*, ( SELECT COUNT(ggp.`id`) FROM `group_posts` ggp where ggp.group_id = o.id AND ggp.is_deleted = '0' ) as 'posts_count' ,( SELECT COUNT(gm.`id`) FROM `group_members` gm  where gm.group_id = o.id  ) as 'members_count' , ";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `groups` o ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = o.`teacher_id` ";
        $sql .= " WHERE o.`id` > 0 AND o.is_deleted = '0'";
        $sql .= $TeacherId ? " AND o.`teacher_id` = '{$TeacherId}'" : "";
        $sql .= " ORDER BY o.`id` DESC";
//	 echo $sql; die();
        return $this->mDb->getAll($sql);
    }



///////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////// APP ////////////////////////////////////////////

    function is_email($email)
    {
        //If the email input string is an e-mail, return true
        if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
            return true;
        } else {
            return false;
        }
    }

    function changePassword($id, $aPassword)
    {
        $sql = "UPDATE `users` SET `password` = '{$aPassword}' ";
        $sql .= "WHERE `id` = '{$id}' ";
        return $this->mDb->query($sql);
    }

    function userForgetPassword($email_mobile)
    {

        $check_email = $this->is_email($email_mobile);

        if ($check_email) {
            $checkquery = "SELECT `email` FROM `users` ";
            $checkquery .= " WHERE `email` = '{$email_mobile}' ";
            $email_value = $this->mDb->getOne($checkquery);

            if ($email_value === false) {
                $Data = ['error' => "email_does_not_exist"];
                return $Data;
            } else {
                $Data = ['error' => "email_mobile_already_exists"];
                return $Data;
            }

        } else {
            $checkquery = "SELECT `mobile` FROM `users` ";
            $checkquery .= " WHERE `mobile` = '{$email_mobile}' ";
            $mobile_value = $this->mDb->getOne($checkquery);

            if ($mobile_value === false) {
                $Data = ['error' => "mobile_does_not_exist"];
                return $Data;
            } else {
                $Data = ['error' => "email_mobile_already_exists"];
                return $Data;
            }

        }

    }

    function getUserInfoByEmail($email)
    {
        $query = "SELECT `id`, `email`, `full_name` FROM `users` ";
        $query .= " WHERE `email` = '{$email}' ";
        return $this->mDb->getRow($query);
    }


    function addNotification($receive_user_id, $send_user_id, $page_type, $details, $url)
    {


        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `{$this->mPrefix}notification` SET ";
        $sql .= "receive_user_id='{$receive_user_id}',";
        $sql .= "send_user_id='{$send_user_id}',";
        $sql .= "page_type='{$page_type}',";
        $sql .= "details='{$details}',";
        $sql .= "date_added='{$dateTime}'";
//          echo $sql; die();
        return $this->mDb->queryreturnlastid($sql);

    }

    function checkUserSubscription($requist)
    {
        $sql = "SELECT us.id FROM `user_subscription` us ";
        $sql .= "where us.`user_id` ='{$requist['user_id']}' AND us.`subscription_type` = 'first_semester' AND us.`year_title` = '{$requist['year_title']}'";
//       echo $sql;
        return $this->mDb->getOne($sql);
    }

    function updateTeacherData($data)
    {

        $getTeacherDataByIdTeacher = $this->getTeacherDataByIdTeacher($data);
        if ($getTeacherDataByIdTeacher['id'] == ''):
            return $this->insertTeacherData($data);
        else:
            return $this->updateTeacherDataByIdTeacher($data);
        endif;
    }

    function getTeacherDataByIdTeacher($data)
    {

        $sql = "SELECT * FROM `teachers_data` WHERE `teacher_id` ='{$data['id']}' ";
//        echo $sql;
        $res = $this->mDb->getRow($sql);
        if (!$res['id']):
            $res = array(
                'id' => '',
                'description' => '',
                'teacher_id' => '',
                'file' => '',
                'upload_type' => '',
            );
        else:
            if ($res['file'] && $res['upload_type'] == 'file'):
                $res['file'] = $this->checkFileExistsToTeacher($res) ? $res['file'] : '';
            endif;
        endif;
        return $res;
    }

    function insertTeacherData($data)
    {
        $sql = "INSERT INTO `teachers_data` SET ";
        $sql .= $data['teacher_desc'] ? " `description` ='{$data['teacher_desc']}'," : null;
        $sql .= $data['file'] ? " `file` = '{$data['file']}'," : null;
        $sql .= $data['upload_type'] ? "`upload_type` = '{$data['upload_type']}'," : null;
        $sql .= " `teacher_id` ='{$data['id']}'";
        return $this->mDb->queryreturnlastid($sql);
    }


    function updateTeacherDataByIdTeacher($data)
    {

        $sql = "UPDATE `teachers_data` SET ";
        $sql .= isset($data['teacher_desc']) ? " `description` = '{$data['teacher_desc']}'," : "";
        $sql .= isset($data['file']) ? " `file` =  '{$data['file']}'," : "";
        $sql .= isset($data['upload_type']) ? "`upload_type` = '{$data['upload_type']}'," : "";
        $sql .= " `teacher_id` ='{$data['id']}'";
//        echo $sql;
        $res = $this->mDb->query($sql);
        if ($res):
            if (($data['oldUploadType'] == 'file' && $data['upload_type'] == 'url_video') || $data['newFileUpload']):
                $this->deleteOldFileUploadToTracher($data);
            endif;
        endif;
        return $res;
    }

    function deleteOldFileUploadToTracher($data)
    {

        if ($data['oldUploadFile']):
            $old_val = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teachers_videos/' . $data['oldUploadFile'];
            if (file_exists($old_val)):
                @unlink($old_val);
            endif;
        endif;
    }

    function checkFileExistsToTeacher($data)
    {
        $file = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teachers_videos/' . $data['file'];
        return file_exists($file) ? true : false;
    }


    function deleteTeacherFile($temp)
    {
        $sql = "UPDATE `teachers_data` SET ";
        $sql .= " `file` =  '',";
        $sql .= "`upload_type` = ''";
        $sql .= "WHERE `id` ='{$temp['id']}' AND `teacher_id` = '{$temp['teacher_id']}'";
        $res = $this->mDb->query($sql);
        if ($temp['file']):
            $old_val = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teachers_videos/' . $temp['file'];
            if (file_exists($old_val)):
                @unlink($old_val);
            endif;
        endif;
        return $res;
    }


} ?>