<?php

$admin_notificationObj = new adminnotifications();

class adminnotifications
{

    var $mDb;
    var $mConfig;
    var $pushNotify;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->pushNotify = new pushmessage();
    }

    function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    function getSomeNots($aStart, $aLimit, $sort, $type, $searchTitle)
    {
        $sql = "SELECT p.*,anl.title,anl.details, u.full_name AS 'user_full_name' FROM admin_notification p";
        $sql .= " LEFT JOIN `admin_notification_langs` anl ON ( p.`id` = anl.`admin_notification_id` AND anl.`lang_code` = 'ar' )";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " WHERE p.id > 0 ";

        $sql .= $searchTitle ? ' AND p.title like "%' . $searchTitle . '%"' : '';

        $sql .= " ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchNotsCount($sort, $type, $searchTitle)
    {
        $sql = "SELECT COUNT(p.`id`) as 'result_count' FROM admin_notification p";
        $sql .= " WHERE p.`id` > 0 ";

        $sql .= $searchTitle ? ' AND p.`title` like "%' . $searchTitle . '%"' : '';

        $sql .= " ORDER BY p.{$sort} {$type}";

        //	echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getNotCount()
    {
        $sql = "SELECT COUNT(`id`) as 'admin_notification' FROM `admin_notification`";
        return $this->mDb->getOne($sql);
    }

    function addEditNot($temp)
    {

        // 	var_dump($temp); die();


        $user_id = $temp['user_id'];
        $users_type = $temp['users_type'];
        $stage_id = $temp['stage_id'];
        $usersIDs = $temp['users'];

        $dataLangObj = json_decode($temp['notLangObj'], true);
        $newDataLangObj = $this->convert_object_to_array($dataLangObj);

        unset($temp['action']);
        unset($temp['notLangObj']);

        $id = $temp['id'];

        if ($id === null || $id === '') {
            // add
            $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `admin_notification` SET ";
            $sql .= " `user_id` = '{$user_id}', ";
            $sql .= " `users_type` = '{$users_type}', ";
            $sql .= " `date_added` = '{$dateTime}'";
            $res = $this->mDb->query($sql);
            $last_note_id = $this->mDb->getLastInsertId();
            if ($last_note_id > 0) {

                foreach ($newDataLangObj as $key => $value) {
                    $stmt = "INSERT INTO `admin_notification_langs`(`admin_notification_id`, `lang_code`, `title`, `details`) ";
                    $stmt .= " VALUES ('{$last_note_id}', '{$value['lang_code']}', '{$value['title']}', '{$value['details']}')";
                    //   echo $stmt;die();
                    $resdd = $this->mDb->query($stmt);
                }
                $this->sendNotToUsers($user_id, $users_type, $title, $details, $usersIDs, $last_note_id, $stage_id);
            }

            return $last_note_id;
        } else {
            // edit
            $check_query = "SELECT `id` FROM `admin_notification` WHERE `id` = '{$id}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {
                return 403;
            } else {

                $sql = "UPDATE `admin_notification` SET ";
                $sql .= " `user_id` = '{$user_id}', ";
                $sql .= " `users_type` = '{$users_type}', ";
                $sql .= " `title` = '{$title}', ";
                $sql .= " `details` = '{$details}'";
                $sql .= " WHERE `id` = '{$id}'";
                return $this->mDb->query($sql);
            }
        }
    }

    function getOneNot($id)
    {

        $result = array();

        $sql = "SELECT * FROM `admin_notification`";
        $sql .= " WHERE `id` = '{$id}'";

        $result = $this->mDb->getRow($sql);

        return $result;
    }

    function deleteNot($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';

        $sql = "DELETE FROM `admin_notification` ";
        $sql .= " WHERE `id` IN " . $tempids;

        $res = $this->mDb->query($sql);
        return $res;
    }

    function sendNotToUsers($admid, $usertype, $not, $details, $someusers, $admin_note_id, $stage_id = '')
    {


        $tt = $this->htmlToPlainText($details);
        $body = substr($tt, 0, 200);
        //   $normalmsg=htmlspecialchars(trim(strip_tags($details))) . PHP_EOL;
        $part = $this->htmlToPlainText("<b> " . $not . " </b>");

        $usersIDs = array();
        if ($usertype == 'some') {
            $usersIDs = $someusers;
        } elseif ($usertype == 'all') {
            if ($stage_id > 0) {
                // all users in this stage  students and parents and teachers
                $sqlls = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND `user_type`='student' AND `stage_id` = '{$stage_id}'";
                $rowss = $this->mDb->getAll($sqlls);
                $usersStudents = array_column($rowss, 'id');
                $sqllte = "  SELECT u.`id` FROM `users` u LEFT JOIN teacher_subjects ts on(ts.user_id = u.id) where u.`mobile_is_valid` = '1' AND u.`is_deleted` ='0' AND u.`status` ='1' AND u.`user_type`='teacher' AND ts.`stage_id` = '{$stage_id}' GROUP BY ts.user_id     ";
                $rowste = $this->mDb->getAll($sqllte);
                $usersTeachers = array_column($rowste, 'id');

                $sqllpa = "  SELECT u.`id` FROM `users` u LEFT JOIN students_parents sp on(sp.parent_id = u.id) LEFT JOIN users child on (sp.student_id = child.id ) ";
                $sqllpa .= "where u.`mobile_is_valid` = '1' AND u.`is_deleted` ='0' AND u.`status` ='1'";
                $sqllpa .= "AND child.`user_type`='student' AND child.`stage_id` = '{$stage_id}' ";
                $sqllpa .= "AND u.`user_type`='parent'  GROUP BY u.`id`";
                $rowspa = $this->mDb->getAll($sqllpa);
                $usersparent = array_column($rowspa, 'id');

                $usersIDs = array_merge($usersStudents, $usersTeachers, $usersparent);
            } else {

                $sqll = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND ( `user_type`='teacher' OR `user_type`='student' OR `user_type`='parent' ) ";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            }
        } elseif ($usertype == 'student') {
            if ($stage_id > 0) {
                $sqll = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND `user_type`='student' AND `stage_id` = '{$stage_id}'";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            } else {
                $sqll = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND `user_type`='student'";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            }
        } elseif ($usertype == 'teacher') {
            if ($stage_id > 0) {
                $sqll = "  SELECT u.`id` FROM `users` u LEFT JOIN teacher_subjects ts on(ts.user_id = u.id) where u.`mobile_is_valid` = '1' AND u.`is_deleted` ='0' AND u.`status` ='1' AND u.`user_type`='teacher' AND ts.`stage_id` = '{$stage_id}' GROUP BY ts.user_id     ";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            } else {
                $sqll = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND `user_type`='teacher'";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            }
        } elseif ($usertype == 'parent') {
            if ($stage_id > 0) {
                $sqll = "  SELECT u.`id` FROM `users` u LEFT JOIN students_parents sp on(sp.parent_id = u.id) LEFT JOIN users child on (sp.student_id = child.id ) ";
                $sqll .= "where u.`mobile_is_valid` = '1' AND u.`is_deleted` ='0' AND u.`status` ='1'";
                $sqll .= "AND child.`user_type`='student' AND child.`stage_id` = '{$stage_id}' ";
                $sqll .= "AND u.`user_type`='parent'  GROUP BY u.`id`";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            } else {
                $sqll = "SELECT `id` FROM `users` where `mobile_is_valid` = '1' AND `is_deleted` ='0' AND `status` ='1' AND `user_type`='parent'";
                $rows = $this->mDb->getAll($sqll);
                $usersIDs = array_column($rows, 'id');
            }
        }

        $arrredirecdata = array('admin_notification_id' => $admin_note_id);
        $redirecdata = json_encode($arrredirecdata);
        $dateTime = date('Y-m-d H:i:s');

        $sqladd = "INSERT INTO notifications(receive_user_id, send_user_id,type,redirect_data,is_read,is_push,date_added) VALUES";

        if (count($usersIDs) > 0) {
            for ($i = 0; $i < count($usersIDs); $i++) {
                $sqladd .= "('{$usersIDs[$i]}','{$admid}','adminNotification','{$redirecdata}','0',0,'{$dateTime}'),";
            }

            $sqladd = substr($sqladd, 0, -1);
            //   echo $sqladd; die();
            return $this->mDb->query($sqladd);
        }
    }


    function addNotification($receive_user_id, $send_user_id, $page_type, $details, $url)
    {
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `{$this->mPrefix}notification` SET ";
        $sql .= "receive_user_id='{$receive_user_id}',";
        $sql .= "send_user_id='{$send_user_id}',";
        $sql .= "page_type='{$page_type}',";
        $sql .= "url='{$url}',";
        $sql .= "details='{$details}',";
        $sql .= "date_added='{$dateTime}'";
        //          echo $sql; die();
        return $this->mDb->queryreturnlastid($sql);
    }

    function htmlToPlainText($str)
    {
        $str = str_replace('&nbsp;', ' ', $str);
        $str = html_entity_decode($str, ENT_QUOTES | ENT_COMPAT, 'UTF-8');
        $str = html_entity_decode($str, ENT_HTML5, 'UTF-8');
        $str = html_entity_decode($str);
        $str = htmlspecialchars_decode($str);
        $str = strip_tags($str);

        return $str;
    }

    /*======== Push Notyfiy To User ===========*/
     function sendNoticeToUser($data)
    {
 
        $sql= "INSERT INTO notifications(receive_user_id, send_user_id,type,redirect_data,is_read,is_push,date_added) VALUES";
        $sql.= "('{$data['receive_user_id']}','{$data['send_user_id']}','{$data['type']}','{$data['redirect_data']}','{$data['is_read']}','{$data['is_push']}','{$data['date_added']}')";
        $notifcation_id = $this->mDb->queryReturnLastId($sql);
        if ($notifcation_id) {
            $data['notifcation_id'] = $notifcation_id;
            $this->pushNotifiation($data);
        }
        return $notifcation_id;
    
    }


    public function pushNotifiation($temp)
    {
        $user_devices = $this->getUserDevicesToken($temp['receive_user_id']);
        $unReadMessage = $this->getUnReadNotificationNum($temp['receive_user_id']);
  
         foreach ($user_devices as $value) { 

            $temp['lang_code'] = $value['lang_code'];
            $notify_push['notification_id'] = $temp['notifcation_id'];
            $notify_push['type'] = $temp['type'];
            $notify_push['redirect_data'] = $temp['redirect_data'];
            $notify_push['msgcnt'] = $unReadMessage;
            $notify_push['title'] = $this->makeNotificationTitle($temp);
            $notify_push['content'] = $this->makeNotificationMessage($temp);
            $notify_push['token'] = $value['token'];
            $notify_push['table_id'] = $temp['table_id'];
            $this->pushNotify->pushNoticeAndroidAndIos($notify_push);
     
        }
    }

    function getSenderUserName($aUserId)
    {
        $sql = "SELECT full_name  as sender_full_name FROM `users`";
        $sql .= "WHERE `id`='{$aUserId}' ";
        //echo $sql;die();
        return $this->mDb->getRow($sql);
    }

    function getUserDevicesToken($aUserId)
    {
        $sql = "SELECT  dt.`id` as deviceID, dt.`type`, dt.`token` , d.lang_code FROM `devices` d";
        $sql .= " LEFT JOIN `device_token` dt ON (dt.id = d.device_token_id) ";
        $sql .= " LEFT JOIN `users` u ON (u.id = d.`user_id`) ";
        $sql .= "WHERE d.`user_id`='{$aUserId}' and u.is_deleted != '1' AND d.`login`='1' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function getUnReadNotificationNum($aUserId)
    {
        $sql = " SELECT count(id)  FROM `notifications`";
        $sql .= " WHERE `receive_user_id` = '{$aUserId}'";
        $sql .= " AND `is_read` = '0'";
        // echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function makeNotificationTitle($data)
    {
/*if($data['lang_code'] =='en'){
    $Lang['L_ReplyComment'] = 'Reply to the comment';
$Lang['L_ReplyInquiry'] = 'Reply to the inquiry';
$Lang['L_CommentApproval'] = 'Comment approval';
}else{
    $Lang['L_ReplyComment'] = ' رد علي التعليق ';
$Lang['L_ReplyInquiry'] = ' رد علي الاسفسار ';
$Lang['L_CommentApproval'] = ' الموافقه علي التعليق ';
}
        if ($data['type'] == 'commentReply'):
                return $Lang['L_ReplyComment'];
          elseif($data['type'] == 'inquiryReply'): 
                               return $Lang['L_ReplyInquiry'];
                elseif($data['type'] == 'commentApproval'): 
              return $Lang['L_CommentApproval'];
        endif;*/
        if ($data['type'] == 'commentReply'):
                 return $data['sender_full_name'];
          else : 
                               return "Tastat App";
                endif;
                
       
        
    }

    function makeNotificationMessage($temp)
    {
 
               $userData = $this->getSenderUserName($temp['send_user_id']);
if($temp['lang_code'] =='en'){
$Lang_notification['L_notification_commentReply'] = " {$userData['sender_full_name']} replied to your comment on a video of : {$temp['commentReply']} ";
$Lang_notification['L_notification_commentApproval'] = "The administration approved your comment on a video  : {$temp['commentApproval']} ";
$Lang_notification['L_notification_inquiryReply'] = "Do the management to handle your inquiry on video :  {$temp['inquiryReply']}";
}else{
$Lang_notification['L_notification_commentReply'] = "قام {$userData['sender_full_name']}  بالرد على تعليق خاص بك على فيديو : {$temp['commentReply']} ";
$Lang_notification['L_notification_commentApproval'] =" قامت الادارة بالموافقة على التعليق الخاص بك على فيديو : {$temp['commentApproval']}";
$Lang_notification['L_notification_inquiryReply'] =" قامت الادارة بالرد على استفسار خاص بك على فيديو : {$temp['inquiryReply']} ";
}
        switch ($temp['type']):
            case 'commentReply':
                return $Lang_notification['L_notification_commentReply'];
            case 'inquiryReply':
              return $Lang_notification['L_notification_inquiryReply'];
            case 'commentApproval':
               return $Lang_notification['L_notification_commentApproval'];
        endswitch;
  
    }
    
}
