<?php

$advantagesAdminObj = new Advantages();

class Advantages {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
function getSomeAdvantages($aStart, $aLimit, $sort, $type, $searchTitle) {
	$sql = "SELECT p.id, p.status, p.img,p.sort, p.date_added, pl.title,  u.full_name AS 'user_full_name' FROM advantages p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `advantages_langs` pl ON p.id = pl.advantage_id ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchAdvantagesCount($sort, $type, $searchTitle) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM advantages p";
	$sql .= " LEFT JOIN `advantages_langs` pl ON p.id = pl.advantage_id ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getAdvantagesCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `advantages`";
	return $this -> mDb -> getOne($sql); 
}

function addEditPageAdvantage($temp,$img,$video) {

    $dataLangObj = json_decode($temp['langs']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);
    $dataLangObjitem = json_decode($temp['advantage_items']);
    $newDataLangObjitem = $this->convert_object_to_array($dataLangObjitem);

// 	var_dump($temp); die();

	$user_id = $temp['user_id'];
	$sort=$temp['sort'];
	$status = $temp['status'] == 'true' ? "1" : "0";
	$id = $temp['id'];

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `advantages` SET "; 
        $sql .= " `user_id` = '{$user_id}', ";
         $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
        $sql .= " `status` = '{$status}', ";
          $sql .= " `sort` = '{$sort}', ";
		$sql .= " `video` = '{$video}' , ";
        $sql .= " `img` = '{$img}' , ";
        $sql .= " `date_added` = '{$dateTime}' ";

		$this -> mDb -> query($sql);

		$last_page_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {
            $description = addslashes($value['description']);
			$title = addslashes($value['title']);
			$meta_keywords = addslashes($value['meta_keywords']);
				$alt_image = addslashes($value['alt_image']);
			$meta_title = addslashes($value['meta_title']);
			$meta_description = addslashes($value['meta_description']);

			
            $stmt = "INSERT INTO `advantages_langs` SET "; 
	        $stmt .= " `advantage_id` = '{$last_page_id}', ";
	        $stmt .= " `lang_code` = '{$value['lang_code']}', ";
	        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
	        $stmt .= " `meta_title` = '{$meta_title}', ";
	         $stmt .= " `alt_image` = '{$alt_image}', ";
	        $stmt .= " `meta_description` = '{$meta_description}', ";
	        $stmt .= " `title` = '{$title}', ";
	        $stmt .= " `description` = '{$description}'";
			$res = $this -> mDb -> query($stmt); 
            
        }
		foreach ($newDataLangObjitem as $key => $value) {
            $item = addslashes($value['item']);
            
            $stmts = "INSERT INTO `advantage_items` SET "; 
	        $stmts .= " `advantage_id` = '{$last_page_id}', ";
	        $stmts .= " `lang_code` = '{$value['lang_code']}', ";
	        $stmts .= " `item` = '{$item}' ";
			$res = $this -> mDb -> query($stmts); 
        }
        return $last_page_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `advantages` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `advantages` SET "; 
			$sql .= " `user_id` = '{$user_id}', ";
				$sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
               $sql .= " `sort` = '{$sort}', ";
	        $sql .= " `status` = '{$status}' ";
            if ($img != '' && $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `advantages` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'advantages/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }
            if ($video != '' && $video != null) {

                // Delete old image from the server
                $img_query = "SELECT `video` FROM `advantages` WHERE `id` = '{$id}'";
                $img_resultv = $this -> mDb -> getOne($img_query);

                $old_imgv = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'advantages/' . $img_resultv;

                if (file_exists($old_imgv)) {
                    @unlink($old_imgv);
                }

                $sql .= ",`video`='{$video}' ";
            }
			$sql .= " WHERE `id` = '{$id}'"; 

		$rreess=	$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

	            $description = addslashes($value['description']);
				$title = addslashes($value['title']);
					$meta_title = addslashes($value['meta_title']);
                $meta_keywords = addslashes($value['meta_keywords']);
                $meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);
				
	            $stmt = "UPDATE `advantages_langs` SET "; 
		        $stmt .= " `title` = '{$title}', ";
		         $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
		        $stmt .= " `meta_description` = '{$meta_description}', ";
		         $stmt .= " `alt_image` = '{$alt_image}', ";
		        $stmt .= " `meta_title` = '{$meta_title}', ";
		        $stmt .= " `description` = '{$description}'";
		        $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `advantage_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }

            foreach ($newDataLangObjitem as $key => $value) {

                $item = addslashes($value['item']);
				if($value['id'] && $value['id'] > 0){
                    $stmte = "UPDATE `advantage_items` SET "; 
                    $stmte .= " `item` = '{$item}' ";
                    $stmte .= " WHERE `lang_code`='{$value['lang_code']}' AND `id` = '{$value['id']}' ";
    
                    $res = $this -> mDb -> query($stmte);
                }else{
                    $stmt = "INSERT INTO `advantage_items` SET "; 
                    $stmt .= " `advantage_id` = '{$id}', ";
                    $stmt .= " `lang_code` = '{$value['lang_code']}', ";
                    $stmt .= " `item` = '{$item}' ";
                    $res = $this -> mDb -> query($stmt); 
                }
	            
	        }
        
        	return $rreess;
		}
	}
}

function getOnePage($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `status`,`sort`,`canonical_link`, `img`, `video` FROM `advantages`";
	$sql .= " WHERE `id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql); 

    if($result){
        $stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`meta_keywords`, pl.`meta_description`,pl.`meta_title`, pl.`description` , pl.`alt_image` FROM `advantages_langs` pl";
        $stmt .= " WHERE pl.`advantage_id` = '{$id}'";
        $result['langs'] = $this -> mDb -> getAll($stmt);
    
        
        $stmt = "SELECT ai.* FROM `advantage_items` ai";
        $stmt .= " WHERE ai.`advantage_id` = '{$id}'";
        $result['advantage_items'] = $this -> mDb -> getAll($stmt);
    }
	

	return $result;

}

function deletePage($ids) {

    $oldlenth=count($ids);
// static pages can not delete them


    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `advantages_langs` ";
        $sqll.= " WHERE `advantage_id` IN ".$tempids;
        $this-> mDb-> query($sqll);
        
         $sqlla = "DELETE FROM `advantage_items` ";
        $sqlla.= " WHERE `advantage_id` IN ".$tempids;
        $this-> mDb-> query($sqlla);

        $sql = "SELECT `img` FROM `advantages`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'advantages/'. $images[$i]['img'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
        }

        $catsql = "DELETE FROM `advantages` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }

}
function deleteItems($ids) {

    $oldlenth=count($ids);
// static pages can not delete them

    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `advantage_items` ";
        $sqll.= " WHERE `id` IN ".$tempids;
        return  $this-> mDb-> query($sqll);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }
}









}?>