<?php

$CategoriesAdmObj = new Categories();

class Categories
{

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
function getSomeCategories($aStart, $aLimit, $sort, $type, $searchTitle,$category_type, $searchStage, $searchGrade, $searchSemester) {
	$sql = "SELECT  p.id, p.status, p.img, p.type,p.sort, p.date_added, pl.title, u.full_name AS 'user_full_name' ";
	$sql .=", p.semester, sl.name as stage_name, gl.name as grade_name ";
	$sql .= " FROM `categories` p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `categories_langs` pl ON p.id = pl.`category_id`";
	$sql .= " LEFT JOIN `stages_langs` sl ON p.stage_id = sl.stage_id AND sl.lang_code = 'ar'  ";
	$sql .= " LEFT JOIN `grades_langs` gl ON p.grade_id = gl.grade_id AND gl.lang_code = 'ar'  ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar' AND p.`type`='{$category_type}'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';
    $sql.= $searchStage ? " AND p.`stage_id` = '{$searchStage}' " : '';
    $sql.= $searchGrade ? " AND p.`grade_id` = '{$searchGrade}' " : '';
    $sql.= $searchSemester ? " AND (p.`semester` = 'both' || p.`semester` = '{$searchSemester}') " : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchCategoriesCount($sort, $type, $searchTitle,$category_type, $searchStage, $searchGrade, $searchSemester) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `categories` p";
	$sql .= " LEFT JOIN `categories_langs` pl ON p.id = pl.`category_id` ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar' AND p.`type`='{$category_type}'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';
    $sql.= $searchStage ? " AND p.`stage_id` = '{$searchStage}' " : '';
    $sql.= $searchGrade ? " AND p.`grade_id` = '{$searchGrade}' " : '';
    $sql.= $searchSemester ? " AND (p.`semester` = 'both' || p.`semester` = '{$searchSemester}') " : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

// 	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getCategoriesCount($category_type) {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `categories`  WHERE `type`='{$category_type}'";
	return $this -> mDb -> getOne($sql); 
}

function addEditCategory($temp,$img) {

    $dataLangObj = json_decode($temp['langs']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);

// 	var_dump($temp); die();

	$user_id = $temp['user_id'];
	$status = $temp['status'] == 'true' ? "1" : "0";
	$id = $temp['id'];
		$sort = $temp['sort'];
			$type = $temp['type'];
			$country_id = $temp['country_id'];
			$stage_id = $temp['stage_id'];
			$subject_id = $temp['subject_id'];
			$grade_id = $temp['grade_id'];
			$specialize_id = $temp['specialize_id'];
			$branch_id = $temp['branch_id'] ?? null;
			$semester = $temp['semester'];
			

	

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');


		$sql = "INSERT INTO `categories` SET "; 
        $sql .= " `user_id` = '{$user_id}', ";
         $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
        $sql .= " `status` = '{$status}', ";
         $sql .= " `sort` = '{$sort}', ";
          $sql .= " `semester` = '{$semester}', ";
         $sql .=$country_id > 0? " `country_id` = '{$country_id}', ":"";
         $sql .=$stage_id > 0? " `stage_id` = '{$stage_id}', ":"";
         $sql .=$subject_id > 0 ?" `subject_id` = '{$subject_id}', ":"";
         $sql .=$grade_id > 0 ?" `grade_id` = '{$grade_id}', ":"";
         $sql .=$specialize_id >0 ? " `specialize_id` = '{$specialize_id}', ":"";
         $sql .=$branch_id && $branch_id != 'null'? " `branch_id` = '{$branch_id}', ":"";
          $sql .= " `type` = '{$type}', ";
		$sql .= " `date_added` = '{$dateTime}' ,";
        $sql .= " `img` = '{$img}'";

		$this -> mDb -> query($sql);

		$last_page_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {
            $description = addslashes($value['description']);
			$title = addslashes($value['title']);
			$meta_keywords = addslashes($value['meta_keywords']);
			$meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);
            $stmt = "INSERT INTO `categories_langs` SET "; 
	        $stmt .= " `category_id` = '{$last_page_id}', ";
	        $stmt .= " `alt_image` = '{$alt_image}', ";
	        $stmt .= " `lang_code` = '{$value['lang_code']}', ";
	        $stmt .= " `title` = '{$title}', ";
	        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
	        $stmt .= " `meta_description` = '{$meta_description}', ";
	        $stmt .= " `description` = '{$description}'";

			$res = $this -> mDb -> query($stmt); 
            
        }
        return $last_page_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `categories` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `categories` SET "; 
			$sql .= " `user_id` = '{$user_id}', ";
				$sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
			 $sql .= " `sort` = '{$sort}', ";
			 $sql .= " `semester` = '{$semester}', ";
			 $sql .=$country_id > 0? " `country_id` = '{$country_id}', ":"";
             $sql .=$stage_id > 0? " `stage_id` = '{$stage_id}', ":"";
             $sql .=$subject_id > 0 ?" `subject_id` = '{$subject_id}', ":"";
             $sql .=$branch_id && $branch_id != 'null' ? " `branch_id` = '{$branch_id}', ":"";
              $sql .=$grade_id > 0 ?" `grade_id` = '{$grade_id}', ":"";
             $sql .=$specialize_id >0 ? " `specialize_id` = '{$specialize_id}', ":"";
         
			  $sql .= " `type` = '{$type}', ";
	        $sql .= " `status` = '{$status}' ";
	        
            if ($img != '' && $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `categories` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'categories/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }
			$sql .= " WHERE `id` = '{$id}'"; 
            // echo $sql;die();
			$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

	            $description = addslashes($value['description']);
				$title = addslashes($value['title']);
                $meta_keywords = addslashes($value['meta_keywords']);
                $meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);

                $stmt = "UPDATE `categories_langs` SET ";
		        $stmt .= " `title` = '{$title}', ";
		        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
		        $stmt .= " `meta_description` = '{$meta_description}', ";
		        $stmt .= " `alt_image` = '{$alt_image}', ";
		        $stmt .= " `description` = '{$description}'";
		        $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `category_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }
        	return $res;
		}
	}
}

function getOneCategory($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `country_id`, `stage_id`, `grade_id`, `subject_id`, `status`, `img`,`type`,`sort`,`semester`,`canonical_link`, `branch_id` FROM `categories`";
	$sql .= " WHERE `id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql); 

	$stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`meta_keywords`, pl.`meta_description`, pl.`description`, pl.`alt_image` FROM `categories_langs` pl";
	$stmt .= " WHERE pl.`category_id` = '{$id}'";
	$result['langs'] = $this -> mDb -> getAll($stmt);

	return $result;

}

function deletePage($ids) {

    $oldlenth=count($ids);
// static `categories` can not delete them
   

    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `categories_langs` ";
        $sqll.= " WHERE `category_id` IN ".$tempids;
        $this-> mDb-> query($sqll);

        $sql = "SELECT `img` FROM `categories`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'categories/'. $images[$i]['img'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
        }

        $catsql = "DELETE FROM `categories` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }

}

public function toggleActivationCategories($temp){
        $ids = "(" . implode(",", $temp['categories']) . ")";
        
        $sql = "UPDATE `categories` SET status = '{$temp['status']}' WHERE id IN " . $ids;
        // echo $sql;die();
        return $this->mDb->query($sql);
    }

}?>