<?php

$contactInformationObj = new ContactInformation();

class ContactInformation {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
function getSomeContactInformations($aStart, $aLimit, $sort, $type, $searchTitle) {


	$sql = "SELECT p.id, p.status, p.position, p.img, p.date_added, pl.title, pl.address, u.full_name AS 'user_full_name' FROM `contact_information` p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `contact_information_langs` pl ON p.id = pl.contact_information_id ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchContactInformationsCount($sort, $type, $searchTitle) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `contact_information` p";
	$sql .= " LEFT JOIN `contact_information_langs` pl ON p.id = pl.contact_information_id ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getContactInformationsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `contact_information`";
	return $this -> mDb -> getOne($sql); 
}

function addEditContactInformation($temp) {

    $img = $temp['img'];
    // $dataLangObj = json_decode($temp['langs']);
    $newDataLangObj = $temp['langs'];$this->convert_object_to_array($dataLangObj);

// 	var_dump($temp); die();
    global $ADMIN;
	$user_id = $ADMIN['id'];
	$phone = $temp['phone'];
	$whatsapp = $temp['whatsapp'];
	$position = $temp['position'];
	$email = $temp['email'];
	$status = $temp['status'];
	$id = $temp['id'];

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `contact_information` SET "; 
        $sql .= " `user_id` = '{$user_id}', ";
        $sql .= " `phone` = '{$phone}', ";
        $sql .= " `whatsapp` = '{$whatsapp}', ";
        $sql .= " `position` = '{$position}', ";
        $sql .= " `email` = '{$email}', ";
		$sql .= " `date_added` = '{$dateTime}' ,";
        $sql .= " `img` = '{$img}'";
// echo $sql;
// die();
		$this -> mDb -> query($sql);

		$last_contact_information_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {

			$title = addslashes($value['title']);
			$address = addslashes($value['address']);

            $stmt = "INSERT INTO `contact_information_langs` SET "; 
	        $stmt .= " `contact_information_id` = '{$last_contact_information_id}', ";
	        $stmt .= " `lang_code` = '{$key}', ";
	        $stmt .= " `title` = '{$title}', ";
	        $stmt .= " `address` = '{$address}' ";

			$res = $this -> mDb -> query($stmt); 
            
        }
        return $last_contact_information_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `contact_information` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `contact_information` SET "; 
			$sql .= " `user_id` = '{$user_id}', ";
            $sql .= " `phone` = '{$phone}', ";
            $sql .= " `whatsapp` = '{$whatsapp}', ";
            $sql .= " `position` = '{$position}', ";
            $sql .= " `email` = '{$email}', ";
	        $sql .= " `status` = '{$status}' ";

//            echo $sql;
//die();
            if ($img != '' || $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `contact_information` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'contact_information/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }
			$sql .= " WHERE `id` = '{$id}'"; 

			$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {
				$title = addslashes($value['title']);
				$address = addslashes($value['address']);
	            $stmt = "UPDATE `contact_information_langs` SET "; 
		        $stmt .= " `title` = '{$title}', ";
		        $stmt .= " `address` = '{$address}' ";
		        $stmt .= " WHERE `lang_code`='{$key}' AND `contact_information_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }
        	return $res;
		}
	}
}

function getOneContactInformation($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `status`, `img`,`position`,`email`,`phone`,`whatsapp` FROM `contact_information`";
	$sql .= " WHERE `id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql); 

	$stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`address` FROM `contact_information_langs` pl";
	$stmt .= " WHERE pl.`contact_information_id` = '{$id}'";
	$result['langs'] = $this -> mDb -> getAll($stmt);

	return $result;

}

function deleteContactInformation($ids) {


        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `contact_information_langs` ";
        $sqll.= " WHERE `contact_information_id` IN ".$tempids;
        $this-> mDb-> query($sqll);

        $sql = "SELECT `img` FROM `contact_information`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'contact_information/'. $images[$i]['img'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
        }

        $catsql = "DELETE FROM `contact_information` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);

}


}?>