<?php

$coursesObj = new Courses();

class Courses
{

    var $mDb;
    var $mConfig;
    var $lang;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
    }

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    function getSomeCourses($aStart, $aLimit, $sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus, $searchSource)
    {
        $sql = "SELECT c.`id`,";
        $sql .= " cl.`name`,sl.name stageName,gl.name gradeName,sbj.name subjectName,";
        $sql .= " c.`date_added`,";
        $sql .= " c.`status`,";
        $sql .= " c.`amount`,";
        $sql .= " c.`set_from`,";
        $sql .= " c.`paid`,";
        $sql .= " c.`img`,";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `courses` c ";
        $sql .= " LEFT JOIN `courses_langs` cl ON c.`id` = cl.`course_id` AND cl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `stages_langs` sl ON sl.`stage_id` = c.`stage_id` AND sl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `grades_langs` gl ON gl.`grade_id` = c.`grade_id` AND gl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `subjects` sbj ON sbj.`id` = c.`subject_id` ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' ";
        $sql .= $searchName ? ' AND cl.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        $sql .= $searchSource == 'admin-area' ? " AND c.set_from = 'admin-area'":"";
        $sql .= $searchSource == 'teacher' ? " AND c.set_from = 'teacher'":"";
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql;die();
        return $this->mDb->getAll($sql);

    }
    
    function getSearchCoursesCount($sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus,$searchSource)
    {
        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `courses` c";
        $sql .= " LEFT JOIN `courses_langs` cl ON ( c.`id` = cl.`course_id` AND cl.`lang_code` = '{$this->lang}' ) ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' ";
        $sql .= $searchName ? ' AND cl.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchName ? ' AND cl.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        $sql .= $searchSource == 'admin-area' ? " AND c.set_from = 'admin-area'":"";
        $sql .= $searchSource == 'teacher' ? " AND c.set_from = 'teacher'":"";
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }
    
    function getCoursesCount($searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus, $searchSource)
    {
        $sql = "SELECT COUNT(c.`id`) as 'count' FROM `courses` c ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (c.`id` = cl.`course_id` AND cl.`lang_code` = '{$this->lang}') ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' ";
        $sql .= $searchName ? ' AND cl.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        $sql .= $searchSource == 'admin-area' ? " AND c.set_from = 'admin-area'":"";
        $sql .= $searchSource == 'teacher' ? " AND c.set_from = 'teacher'":"";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    
    function getSomeTeacherVideos($aStart, $aLimit, $sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT v.`id`,";
        $sql .= " v.`title`, cl.name as course_name, un.name as unitName, ul.name as lessonName, ";
        $sql .= " v.`date_added`,";
        $sql .= " v.`status`,";
        $sql .= " v.`set_from`,";
        $sql .= " v.`paid`,";
        $sql .= " v.`img`,";
        // $sql .= " un.name as unit_name_explain";
        // $sql .= " ul.name as lesson_name_explain";
        // $sql .= " sbj.name as subject_name";
        // $sql .= " gl.name as grade_name";
        // $sql .= " sl.name as stage_name";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `videos_courses` v ";
        $sql .= " LEFT JOIN `courses` c ON c.id = v.course_id ";
        $sql .= " LEFT JOIN `units` un ON un.id = v.unit_id_explain ";
        $sql .= " LEFT JOIN `unit_lessons` ul ON ul.id = v.lesson_id_explain ";
        $sql .= " LEFT JOIN `courses_langs` cl ON c.`id` = cl.`course_id` AND cl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `stages_langs` sl ON sl.`stage_id` = c.`stage_id` AND sl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `grades_langs` gl ON gl.`grade_id` = c.`grade_id` AND gl.lang_code = '{$this->lang}' ";
        $sql .= " LEFT JOIN `subjects` sbj ON sbj.`id` = c.`subject_id` ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' AND c.set_from = 'teacher' AND v.status = '0' ";
        $sql .= $searchName ? ' AND v.`title` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= "ORDER BY v.id DESC ";
        // $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        // $sql .= $sort === 'sort' ? " ORDER BY v.`sort` {$type}" : " ORDER BY v.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql;die();
        return $this->mDb->getAll($sql);

    }
    
    function getSearchTeacherVideosCount($sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT COUNT(v.`id`) as 'result_count'";
        $sql .= " FROM `videos_courses` v ";
        $sql .= " LEFT JOIN `courses` c ON c.id = v.course_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON ( c.`id` = cl.`course_id` AND cl.`lang_code` = '{$this->lang}' ) ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' AND c.set_from = 'teacher' AND v.status = '0'";
        $sql .= $searchName ? ' AND v.`title` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        // $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        // $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

     function getTeacherVideosCount($searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT COUNT(v.`id`) as 'count'";
        $sql .= " FROM `videos_courses` v ";
        $sql .= " LEFT JOIN `courses` c ON c.id = v.course_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (c.`id` = cl.`course_id` AND cl.`lang_code` = '{$this->lang}') ";
        $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' AND c.set_from = 'teacher' AND v.status = '0' ";
        $sql .= $searchName ? ' AND v.`title` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        // $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getSomeVideosInCourses($course_id, $aStart, $aLimit, $sort, $type, $searchName, $searchCountry)
    {
        $sql  = "SELECT c.`id`,";
        $sql .= " c.`title`,";
        $sql .= " c.`date_added`,";
        $sql .= " c.`status`,";
        $sql .= " c.`views`,";
        $sql .= " c.`time`,";
        $sql .= " c.`set_from`,";
        $sql .= " c.`paid`,";
        $sql .= " c.`img`,c.`unit_id_explain`,unit.`name` unit_name,c.`lesson_id_explain`,unitLess.name lesson_name,";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `videos_courses` c ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
        $sql .= " LEFT JOIN `units` unit ON unit.`id` = c.`unit_id_explain` ";
        $sql .= " LEFT JOIN `unit_lessons` unitLess ON unitLess.`id` = c.`lesson_id_explain` ";
        $sql .= " WHERE c.`id` > 0  AND c.`is_deleted` = '0' AND c.`course_id`='{$course_id}'";
        $sql .= $searchName ? ' AND c.`title` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
    //  echo $sql;
        $res = $this->mDb->getAll($sql);
        if (count($res) > 0):
            for ($i = 0; $i < count($res); $i++):
                $res[$i]['countAttachFilesVideo'] = $this->countAttachVideosInCourses($res[$i]['id']);
            endfor;
        endif;
        return $res;
    }
    
    function getSomeUnactiveVideosInCourses($aStart, $aLimit, $sort, $type, $searchName, $searchCountry)
    {
        $sql  = "SELECT c.`id`,";
        $sql .= " c.`title`,";
        $sql .= " c.`date_added`,";
        $sql .= " c.`status`,";
        $sql .= " c.`views`,";
        $sql .= " c.`time`,";
        $sql .= " c.`set_from`,";
        $sql .= " c.`paid`,";
        $sql .= " c.`img`,c.`unit_id_explain`,unit.`name` unit_name,c.`lesson_id_explain`,unitLess.name lesson_name,";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `videos_courses` c ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
        $sql .= " LEFT JOIN `units` unit ON unit.`id` = c.`unit_id_explain` ";
        $sql .= " LEFT JOIN `unit_lessons` unitLess ON unitLess.`id` = c.`lesson_id_explain` ";
        $sql .= " WHERE c.`id` > 0  AND c.`is_deleted` = '0' AND c.`set_from` = 'teacher' ";
        $sql .= $searchName ? ' AND c.`title` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//      echo $sql;die();
        $res = $this->mDb->getAll($sql);
        if (count($res) > 0):
            for ($i = 0; $i < count($res); $i++):
                $res[$i]['countAttachFilesVideo'] = $this->countAttachVideosInCourses($res[$i]['id']);
            endfor;
        endif;
        return $res;
    }

    function getSearchVideosCoursesCount($course_id, $sort, $type, $searchName, $searchCountry)
    {
        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `videos_courses` c";
        $sql .= " WHERE c.`id` > 0  AND c.`is_deleted` = '0' AND c.`course_id` ='{$course_id}' ";
        $sql .= $searchName ? ' AND c.`title` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY c.{$sort} {$type}";

        // echo $sql;

        return $this->mDb->getOne($sql);
    }

    function getVideosInCoursesCount($data)
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `videos_courses`  WHERE `id` > 0  AND `is_deleted` = '0' AND `course_id` ='{$data['course_id']}'";
        $sql .= $data['searchName'] ? ' AND `title` like "%' . $data['searchName'] . '%"' : '';
        return $this->mDb->getOne($sql);
    }


    function addEditCourse($request, $course_id)
    {
        global $ADMIN;
        $img = $request['img'];
        $newDataLangObj = $request['languageData'];
        unset($request['action']);
        unset($request['countryLangObj']);

        $res = false;

        if ($course_id === '' && $request['operation'] === 'add') {
            // Add
            unset($request['operation']);
            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `courses` SET ";
            $sql .= " `country_id` = '1',";
            $sql .= " `stage_id` = '{$request['stage_id']}',";
            $sql .= " `grade_id` = '{$request['grade_id']}',";
            $sql .= " `subject_id` = '{$request['subject_id']}',";
            $sql .= " `semester` = '{$request['semester']}',";
            $sql .= " `added_by` = '{$ADMIN['id']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= " `amount` = '{$request['amount']}',";
            $sql .= " `set_from` = '{$request['set_from']}',";
            $sql .= $request['subject_branch_id'] && $request['subject_branch_id'] != null && $request['subject_branch_id'] != 'null'? " `subject_branch_id` = '{$request['subject_branch_id']}'," : "";
            $sql .= " `status` = '{$request['status']}',";
            $sql .= " `paid` = '{$request['paid']}',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= " `img` = '{$img}'";
        // echo $sql; die();
            $last_id = $this->mDb->queryReturnLastId($sql);

            if ($last_id) {
                foreach ($newDataLangObj as $key => $value) {
                    $stmt = "INSERT INTO `courses_langs`(`course_id`, `lang_code`, `name`, `description`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$key}', '{$value['name']}', '{$value['description']}')";
                    // echo $stmt; die();
                    $res = $this->mDb->query($stmt);
                }
            }

            return $last_id;
        } else {

            // Edit

            $check_query = "SELECT `id` FROM `courses` WHERE `id` = '{$course_id}'";
            $check_result = $this->mDb->getOne($check_query);
            // echo $check_result;die();
            if ($check_result === false) {

                return 403;
            } else {

                $sql = "UPDATE `courses` SET ";
                $sql .= " `country_id` = '{1',";
                $sql .= " `stage_id` = '{$request['stage_id']}',";
                $sql .= " `grade_id` = '{$request['grade_id']}',";
                $sql .= " `subject_id` = '{$request['subject_id']}',";
                $sql .= " `semester` = '{$request['semester']}',";
                $sql .= " `added_by` = '{$ADMIN['id']}', ";
                $sql .= " `sort` = '{$request['sort']}', ";
                $sql .= " `amount` = '{$request['amount']}', ";
                $sql .= " `set_from` = '{$request['set_from']}', ";
                $sql .= $request['subject_branch_id'] && $request['subject_branch_id'] != null && $request['subject_branch_id'] != 'null'? " `subject_branch_id` = '{$request['subject_branch_id']}'," : "";
                $sql .= " `status` = '{$request['status']}',";
                $sql .= " `paid` = '{$request['paid']}'";


                if ($img != '' || $img != null) {

                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `courses` WHERE `id` = '{$course_id}'";
                    $img_result = $this->mDb->getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'courses/' . $img_result;

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $sql .= ",`img`='{$img}' ";
                }

                $sql .= " WHERE `id` = '{$course_id}'";

            // echo $sql; die();

                $res = $this->mDb->query($sql);
                if ($res) {
                    foreach ($newDataLangObj as $key => $value) {

                        $stmt = "UPDATE `courses_langs` SET";
                        $stmt .= " `name`='{$value['name']}' , ";
                        $stmt .= " `description`='{$value['description']}' ";

                        $stmt .= " WHERE `lang_code`='{$key}' AND `course_id` = '{$course_id}'";

                        $res = $this->mDb->query($stmt);
                    }
                }


                return $res;
            }
        }
    }

      function addEditVideoOfCourse($data)
    {
        global $ADMIN;

        $res = false;
        $dateTime = date('Y-m-d H:i:s');
        if ($data['request']['id'] == '' && $data['request']['operation'] === 'add') {

            $sql = "INSERT INTO `videos_courses` SET ";
            $sql .= " `course_id` = '{$data['request']['course_id']}',";
            $sql .= " `title` = '{$data['request']['title']}',";
             $sql .= " `file_hls` = '{$data['request']['file_hls']}',";
            $sql .= " `desc` = '{$data['request']['desc']}',";
            $sql .= $data['request']['unit_id_explain'] > 0 ? " `unit_id_explain` = '{$data['request']['unit_id_explain']}'," : "";
            $sql .= $data['request']['lesson_id_explain'] > 0 ? " `lesson_id_explain` = '{$data['request']['lesson_id_explain']}'," : "";
            $sql .= " `added_by` = '{$ADMIN['id']}',";
            $sql .= " `sort` = '{$data['request']['sort']}',";
            $sql .= " `set_from` = '{$data['request']['set_from']}',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
            $sql .= " `status` = '{$data['request']['status']}',";
            $sql .= " `paid` = '{$data['request']['paid']}',";
            $sql .= " `file` = '{$data['request']['file']}',";
            $sql .= " `url_video_youtube` = '{$data['request']['url_video_youtube']}',";
            $sql .= " `time` = '{$data['request']['time']}'";
//   echo $sql; die();
            $last_id = $this->mDb->queryReturnLastId($sql);

            if ($last_id) {
                foreach ($data['request']['doc'] as $key => $value) {
                    $stmt = "INSERT INTO `videos_attachments_courses`(`video_id`, `attach_file`,`file_size`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['file']}','{$value['size']}' )";
                    // echo $stmt;
                    $this->mDb->query($stmt);
                }
               
                foreach ($data['request']['video_tests'] as $key => $value) {
                      $_unit_id= $value['unit_id']> 0 ? $value['unit_id'] : 0;
                      $_lesson_id= $value['lesson_id']> 0 ? $value['lesson_id'] : 0;
                    $stmt = "INSERT INTO `videos_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                    if($value['unit_exercise_id']){
                        
                        $this->mDb->query($stmt);  
                    }
                }
            }

            return $last_id;
        } else {

            // Edit

            $check_query = "SELECT `id` FROM `videos_courses` WHERE `id` = '{$data['request']['id']}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {

                return 403;
            } else {
                $data['request']['unit_id_explain'] = $data['request']['unit_id_explain'] > 0 ? $data['request']['unit_id_explain'] : 0;
                $data['request']['lesson_id_explain'] = $data['request']['lesson_id_explain'] > 0 ? $data['request']['lesson_id_explain'] : 0;
/*                $data['request']['unit_id'] = $data['request']['unit_id'] > 0 ? $data['request']['unit_id'] : 0;
                $data['request']['lesson_id'] = $data['request']['lesson_id'] > 0 ? $data['request']['lesson_id'] : 0;*/

                $sql = "UPDATE `videos_courses` SET ";
                $sql .= " `course_id` = '{$data['request']['course_id']}',";
                $sql .= " `title` = '{$data['request']['title']}',";
                 $sql .= " `file_hls` = '{$data['request']['file_hls']}',";
                $sql .= " `desc` = '{$data['request']['desc']}',";
                // $sql .= " `test_type` = '{$data['request']['test_type']}',";
                $sql .= " `unit_id_explain` = '{$data['request']['unit_id_explain']}',";
                $sql .= " `lesson_id_explain` = '{$data['request']['lesson_id_explain']}',";
/*                $sql .= " `unit_id` = '{$data['request']['unit_id']}',";
                $sql .= " `lesson_id` = '{$data['request']['lesson_id']}',";
                $sql .= " `exercise_id` = '{$data['request']['exercise_id']}',";*/
                $sql .= " `added_by` = '{$data['request']['added_by']}',";
                $sql .= " `sort` = '{$data['request']['sort']}',";
                $sql .= " `set_from` = '{$data['request']['set_from']}',";
                $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
                $sql .= $data['request']['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
                $sql .= $data['request']['paid'] === 'true' ? " `paid` = '1'," : " `paid` = '0',";
                $sql .= $data['request']['file'] ? " `file` = '{$data['request']['file']}',`time` = '{$data['request']['time']}',`url_video_youtube`=NULL, " : "";
                $sql .= $data['request']['url_video_youtube'] ? " `url_video_youtube` = '{$data['request']['url_video_youtube']}',`time` = '{$data['request']['time']}',`file` = NULL, " : "";
                $sql .= " `date_added` = '{$dateTime}'";
                $sql .= " WHERE `id` = '{$data['request']['id']}'";
                //  echo $sql;
                $res = $this->mDb->query($sql);
                if ($res) {

                    if ($data['img_video'] != '' || $data['img_video'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['request']['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['request']['img_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                    if ($data['request']['file'] != '' || $data['request']['file'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['request']['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['request']['file_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                    foreach ($data['request']['doc'] as $key => $value) {
                        $stmt = "INSERT INTO `videos_attachments_courses`(`video_id`, `attach_file`,`file_size`) ";
                        $stmt .= " VALUES ('{$data['request']['id']}', '{$value['file']}','{$value['size']}')";
                        $this->mDb->query($stmt);
                    }
                    // print_r($data['request']);die();

                    foreach ($data['request']['video_tests'] as $key => $value) {
                      $_unit_id= $value['unit_id']> 0 ? $value['unit_id'] : 0;
                      $_lesson_id= $value['lesson_id']> 0 ? $value['lesson_id'] : 0;
                    $stmt = "INSERT INTO `videos_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                    $stmt .= " VALUES ('{$data['request']['id']}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                    if($value['unit_exercise_id']){
                            $this->mDb->query($stmt);  
                        }
                }
                }


                return $res;
            }
        }
    }

    function getOneCourse($id)
    {

        $result = array();

         $sql  = "SELECT c.*, sb.id as branch_id, sbl.name as branch_name FROM `courses` c ";
        $sql .= " LEFT JOIN `subjects_branches` sb ON c.`subject_branch_id` = sb.`id` ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sbl.`subject_branch_id` = sb.`id` AND sbl.lang_code = '{$this->lang}') ";
        $sql .= " WHERE c.`id` = '$id' ";
        // echo $sql;
        $result = $this->mDb->getRow($sql);

        $stmt = "SELECT cl.`lang_code`, cl.`name`, cl.`description` FROM `courses_langs` cl";
        $stmt .= " WHERE cl.`course_id` = '{$id}'";
        $result['langs'] = $this->mDb->getAll($stmt);
        return $result;
    }

    function getAllDataVideosInCourses($id)
    {

        $sql = "SELECT * FROM `videos_courses`";
        $sql .= " WHERE `course_id` = '{$id}'";
        $result = $this->mDb->getAll($sql);
        if (count($result) > 0):
            for ($r = 0; $r < count($result); $r++):
                $result[$r]['allAttachVideosInCourses'] = $this->allAttachVideosInCourses($result[$r]['id']);
            endfor;
        endif;
        return $result;
    }


    function countAttachVideosInCourses($id)
    {
        $sql = "SELECT count(id) FROM `videos_attachments_courses`";
        $sql .= " WHERE `video_id` = '{$id}'";
        return $this->mDb->getOne($sql);
    }

    function allAttachVideosInCourses($id)
    {

        $sql = "SELECT * FROM `videos_attachments_courses`";
        $sql .= " WHERE `video_id` = '{$id}'";
          $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++):
            $dataFile = getFileSizeOne($res[$i]['attach_file'], 'course_videos_and_attachments');
            $res[$i]['file_size'] = $dataFile['human_file_size'];
        endfor;
        return $res;
    }
     function getAllVideoTests($id)
    {

        $sql = "SELECT id,test_type,unit_id,lesson_id,exercise_id as unit_exercise_id FROM `videos_tests`";
        $sql .= " WHERE `video_id` = '{$id}'";
        return $this->mDb->getAll($sql);
    }

    function getOneDataVideosInCourses($id)
    {

        $sql  = "SELECT vc.*, c.semester FROM `videos_courses` vc ";
        $sql .= " LEFT JOIN `courses` c ON c.id = vc.course_id ";
        $sql .= " WHERE vc.`id` = '{$id}'";
        $result = $this->mDb->getRow($sql);
        if (!empty($result)):
            
                    $result['allVideoTests'] = $this->getAllVideoTests($result['id']);
            $result['allAttachVideosInCourses'] = $this->allAttachVideosInCourses($result['id']);
        endif;
        return $result;
    }


    function getCourseByParentID($id)
    {
        $result = array();
        $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `courses` c";
        $sql .= " LEFT JOIN `courses_langs` cl ON c.`id` = cl.`course_id` ";
        $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='{$this->lang}' ";
//    echo $sql;
        $result = $this->mDb->getAll($sql);
        return $result;
    }

    function deleteCourse($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';

//    $sql = "SELECT `img` FROM `courses`";
//    $sql .= " WHERE `id` IN ".$tempids;
//    $images = $this -> mDb -> getAll($sql);
//
//    $sqll = "DELETE FROM `courses_langs` ";
//    $sqll.= " WHERE `course_id` IN ".$tempids;
//
//    $this-> mDb-> query($sqll);

        $sql = "UPDATE `courses` SET ";
        $sql .= " `is_deleted`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;

//    $catsql = "DELETE FROM `courses` ";
//    $catsql.= " WHERE `id` IN ".$tempids;

        if ($this->mDb->query($sql)) {

//
//        if(count($images)>0){
//            for ($i=0;$i<count($images);$i++){
//                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'courses/'. $images[$i]['img'];
//                if (file_exists($old_img)) {
//                    @unlink($old_img);
//                }
//            }
//        }
            return true;
        } else {
            return false;
        }
    }
    
    function deleteVideoTests($request)
    {

        $sqll = "DELETE FROM `videos_tests` ";
        $sqll .= " WHERE `id` = '{$request['id']}'";
        // echo $sqll;die();
        return  $this->mDb->query($sqll);
    }

function deleteVideoAttachment($request)
{
    $sqll = "DELETE FROM `videos_attachments_courses` ";
    $sqll .= " WHERE `attach_file` = '{$request['file']}' AND `id` = '{$request['id']}'";
    // echo $sqll;die();
    return $this->mDb->query($sqll);
    
}
   function deleteAttachment($request)
{
    $sqll = "DELETE FROM `videos_attachments_courses` ";
    $sqll .= " WHERE `attach_file` = '{$request['file']}' AND `id` = '{$request['id']}'";
    // echo $sqll;die();
    $res = $this->mDb->query($sqll);
    
    $sql = "DELETE FROM `videos_courses` ";
    $sql .= " WHERE `file` = '{$request['file']}' AND `course_id` = '{$request['course_id']}'";
    $res = $this->mDb->query($sql);
    
    $sqlll = "DELETE FROM `videos_courses` ";
    $sqlll .= " WHERE `file_hls` = '{$request['file_hls']}' AND `course_id` = '{$request['course_id']}'";
    $res = $this->mDb->query($sqlll);
    
    if ($res) {
        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $request['course_id'] .'/'. $request['file'];
        if (file_exists($old_img)) {
            @unlink($old_img);  
        }

        $old_hls_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $request['course_id'] . '/hls/' . $request['file_hls'];
        if (file_exists($old_hls_img)) {
            @unlink($old_hls_img);  
        }
    }

    return $res;
}


    function getAllUnitExercise($temp)
    {

        $sql = "SELECT id,name FROM `tests` f ";
        $sql .= "WHERE f.`status` ='1' AND f.is_deleted !='1' AND f.type='{$temp['type']}'  ";
        $sql .= $temp['lesson_id'] && $temp['type'] == 'unit_exercise' ? " AND f.`lesson_id` ='{$temp['lesson_id']}'   " : ' ';
        $sql .= $temp['unit_id'] && $temp['type'] == 'unit_test' ? " AND f.`unit_id` ='{$temp['unit_id']}'   " : ' ';
// echo $sql;die();
        $res = $this->mDb->getAll($sql);
        return $res;
    }
    
    function getOneExercise($id)
    {

        $sql = "SELECT id,name FROM `tests` f ";
        $sql .= "WHERE f.`id` ='{$id}'";
// echo $sql;die();
        $res = $this->mDb->getRow($sql);
        return $res;
    }

    function getAllGeneralTestSubjectIdInSemester($temp)
    {

        $sql = "SELECT id,name FROM `tests` f ";
        $sql .= "WHERE f.`status` ='1' AND f.is_deleted !='1' AND f.semester='{$temp['semester']}'  ";
        $sql .= " AND f.`subject_id` ='{$temp['subject_id']}' AND f.`type` ='{$temp['type']}'  ";
// echo $sql;
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    function deleteVideoInCourse($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "UPDATE `videos_courses` SET ";
        $sql .= " `is_deleted`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;

        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    function activateCommentsInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "UPDATE `videos_comments` SET ";
        $sql .= " `status`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;

        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    function deactivateCommentsInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "UPDATE `videos_comments` SET ";
        $sql .= " `status`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;
        
        echo $sql; die();
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    function updateCommentById($temp)
    {
        $sql  = "UPDATE `videos_comments` SET ";
        $sql .= " `status`='{$temp['status']}' ,";
        $sql .= " `comment`='{$temp['comment']}' ";
        $sql .= " WHERE `id`='{$temp['id']}' ";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    function activateVideoCourse($ids)
    {
        
        
        $tempids = '(' . implode(',', $ids) . ')';
        
        $sql = "SELECT * FROM `videos_courses` ";
        // $sql .= " LEFT JOIN "
        $sql .= "WHERE `id` IN " . $tempids;
        $vedios = $this->mDb->getAll($sql);
        // print_r($vedios);die();
        $sqll = "UPDATE `videos_courses` SET `status` = '1' ";
        $sqll .= " WHERE `id` IN " . $tempids;
        // echo $sql; die();
        if ($this->mDb->query($sqll)) {
            return $vedios;
        } else {
            return [];
        }
    }
    
    
    function deleteCommentsInVideo($ids)
    {
        
        // echo $ids[0]['id']; die();
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "DELETE FROM `videos_comments`";
        $sql .= " WHERE `id` IN " . $tempids;
        // echo $sql; die();
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    function getCountCommentsInVideos($data)
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `videos_comments`  WHERE `id` > 0  AND `video_id` ='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `comment` like "%' . $data['searchName'] . '%"' : '';
        return $this->mDb->getOne($sql);
    }

    function getSearchCommentsCountVideos($video_id, $sort, $type, $searchName, $searchCountry)
    {
        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `videos_comments` c";
        $sql .= " WHERE c.`id` > 0 AND c.`video_id` ='{$video_id}' ";
        $sql .= $searchName ? ' AND c.`comment` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY c.{$sort} {$type}";
        return $this->mDb->getOne($sql);
    }

    function getSomeCommentsInVedios($video_id, $aStart, $aLimit, $sort, $type, $searchName, $searchCountry)
    {
        $sql = "SELECT * FROM `videos_comments`  WHERE `id` > 0 AND `video_id` ='{$video_id}'";
        $sql .= $searchName ? ' AND `comment` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY `sort` {$type}" : " ORDER BY `status` DESC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//  echo $sql;
        return $this->mDb->getAll($sql);
    }


  function getCountInquiriesInVideos($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
         $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        // echo $sql;
        $res= $this->mDb->getAll($sql);
        return $res ? count($res):0;
    }

    function getSearchInquiriesCountVideos($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
        $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        $res= $this->mDb->getAll($sql);
        return $res ? count($res):0;
    }

    function getSomeInquiriesInVedios($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
         $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        $sql .= $data['aLimit'] ? " LIMIT {$data['aStart']}, {$data['aLimit']}" : '';
        return $this->mDb->getAll($sql);
    }
function getInvalidCourses()
{
 
    $sql = "
        SELECT vc.*
        FROM videos_courses vc
        LEFT JOIN courses c ON vc.course_id = c.id
        WHERE c.id IS NULL
    ";

    $result = $this->mDb->getAll($sql);
    return $result;
}
function getInvalidCoursesCount()
{
    $sql = "
        SELECT COUNT(*) AS count 
        FROM videos_courses 
        WHERE course_id NOT IN (SELECT id FROM courses)
    ";

    $result = $this->mDb->getAll($sql);
    return $result; 
}
function getCoursesData($course_id) {
    $sql = "SELECT id, file FROM videos_courses 
            WHERE course_id = '{$course_id}' AND file IS NOT NULL AND file != ''";
    $result = $this->mDb->getAll($sql);

    return $result;
}

function organizeCourseVideos() {
 
    $courses = $this->getAllCourses();
    $courseIds = $this->extractIds($courses);
    
    foreach ($courseIds as $courseId) {
        $files = $this->getAllFilesByCourseId($courseId);
        if (!empty($files)) {
          $result=  $this->copyCourseFiles($courseId, $files);
        }
    }
    
    $this->retryFailedMoves();
}


function getAllCourses() {
    $sql = "SELECT id FROM courses";
    $result = $this->mDb->getAll($sql);
    return $result;
}  
function extractIds($array) {
    $ids = [];
    foreach ($array as $item) {
        if (isset($item['id'])) {
            $ids[] = $item['id'];
        }
    }
    return $ids;
}

function getAllFilesByCourseId($courseId) {
    
    $sql = "SELECT id, file FROM videos_courses WHERE course_id = '{$courseId}' AND moved = '0' AND file IS NOT NULL AND file != ''";
    $result = $this->mDb->getAll($sql);
    return $result;
}

function copyCourseFiles($courseId, $files) {
    $sourceDir = $_SERVER['DOCUMENT_ROOT'] . "/uploads/course_videos_and_attachments/";
    $destDir = $_SERVER['DOCUMENT_ROOT'] . "/uploads/organized_course_videos/$courseId/";
   
    if (!is_dir($destDir)) {
        mkdir($destDir, 0777, true);
    }

    foreach ($files as $file) {
        $sourceFile = $sourceDir . $file['file'];
        $destFile = $destDir . basename($file['file']);
        if (copy($sourceFile, $destFile)) {
           $this->updateMoved($file['id'], 1); // Mark as moved
        } else {
            $this->updateMoved($file['id'], 0); // Mark as not moved
        }
    }
}

function updateMoved($video_id, $moved) {
    $sql = "UPDATE videos_courses SET moved = '{$moved}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}

function retryFailedMoves() {
    $sql = "SELECT DISTINCT course_id FROM videos_courses WHERE moved ='0'";
    $courseIds = $this->mDb->getAll($sql);
    $courseIdsArray = array_column($courseIds, 'course_id');
    foreach ($courseIdsArray as $courseId) {
        $files = $this->getAllFilesByCourseId($courseId);
        if (!empty($files)) {
            $this->copyCourseFiles($courseId, $files);
        }
    }
}

    
 public function getVideosNotConverted() {
        $sql = "SELECT id, file,course_id
                    FROM videos_courses 
                    WHERE file IS NOT NULL 
                      AND file != '' 
                      AND (file_hls IS NULL OR file_hls = '') 
                      AND is_deleted = '0'";
       return $this->mDb->getAll($sql);
    }

public function getVideosWithMismatchedTime() {
        $sql = "SELECT id, file ,course_id
                FROM videos_courses 
                WHERE  file IS NOT NULL 
                      AND file != ''  AND (file_hls IS NULL OR file_hls = '') 
                AND time != hls_time AND is_deleted = '0' ";
        return  $this->mDb->getAll($sql);
    } 


function updateHlsTime($video_id, $duration) {
    $sql = "UPDATE videos_courses SET hls_time = '{$duration}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}    

function updateHlsFileName($video_id, $hls_name) {
    $sql = "UPDATE videos_courses SET file_hls = '{$hls_name}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}

//      function getSomeCoursesSubscriptions($aStart, $aLimit, $sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
//     {
//         $sql = "SELECT c.`id`,";
//         $sql .= " cl.`name`,sl.name stageName,gl.name gradeName,sbj.name subjectName,";
//         $sql .= " c.`date_added`,";
//         $sql .= " c.`status`,";
//         $sql .= " c.`amount`,";
//         $sql .= " c.`set_from`,";
//         $sql .= " c.`paid`,";
//         $sql .= " c.`img`,";
//         $sql .= " u.`full_name` AS 'user_full_name'";
//         $sql .= " FROM `paymob_payment_transactions` ppt ";
//         $sql .= " LEFT JOIN `courses_langs` cl ON c.`id` = ppt.`course_id` ";
//         $sql .= " LEFT JOIN `courses_langs` cl ON c.`id` = cl.`course_id` AND cl.lang_code = '{$this->lang}' ";
//         $sql .= " LEFT JOIN `stages_langs` sl ON sl.`stage_id` = c.`stage_id` AND sl.lang_code = '{$this->lang}' ";
//         $sql .= " LEFT JOIN `grades_langs` gl ON gl.`grade_id` = c.`grade_id` AND gl.lang_code = '{$this->lang}' ";
//         $sql .= " LEFT JOIN `subjects` sbj ON sbj.`id` = c.`subject_id` ";
//         $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
//         $sql .= " WHERE c.`id` > 0 AND c.`is_deleted` = '0' ";
//         $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
//         $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
//         $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
//         $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
//         $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
//         $sql .= $searchStatus != '' ? ' AND c.status = "' . $searchStatus . '"' : '';
//         $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";
//         $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// // 	 echo $sql;die();
//         return $this->mDb->getAll($sql);

//     }
}

?>