<?php

$dataTransferObj = new DataTransfer();

class DataTransfer
{

    var $mDb;
    var $mConfig;
    var $TestsObj;
    var $unitsObj;
//     var $TestsObj;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this -> TestsObj = new Tests();
        $this -> unitsObj = new Units();
        $this->questions_table = ["1" => "first_primary","2" => "second_primary",
                    "4" => "third_primary",
                    "9" => "fourth_primary", "10" => "fifth_primary",
                    "11" => "sixth_primary","12" => "first_middle",
                    "13" => "second_middle","14" => "third_middle",
                    "15" => "second_secondary", "16" => "first_secondary",
                    "17" => "third_secondary", "22" => "experimental"];
    }
    

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    public function getUnitsData($source_subject_id, $destination_subject_id, $limit){
              try {
                    $maxSort = $this -> getMaxSortUnit($destination_subject_id);
                    // echo $maxSort;die();
                    $unitSql  = "SELECT * FROM `units` ";
                    $unitSql .= " WHERE subject_id = ? ";
                    $unitSql .=  " LIMIT {$limit} ";
                    $untitValues = [$source_subject_id];

                    $stmt = $this->mDb->connect()->prepare($unitSql);
                    for($i=0; $i<count($untitValues); $i++){
                              $stmt->bindValue($i+1, $untitValues[$i]);
                    }
                    $stmt->execute();
                    $units = $stmt->fetchAll(PDO::FETCH_ASSOC);
                    $units = array_map(function($item) use (&$maxSort, $source_subject_id, $destination_subject_id) {
                              $maxSort++;  
                              $item['unit_lessons'] = $this -> getUnitLessonsData($item['id'], $destination_subject_id, $source_subject_id);
                              $item['tests'] = $this -> getUnitTestsData($item['id'], $destination_subject_id, $source_subject_id);
                              $item['sort'] = $maxSort;  
                              $item['subject_id'] = $destination_subject_id;  
                              unset($item['id']);
                              unset($item['date_added']);
                              if(!$item['subject_branch_id']){
                                        unset($item['subject_branch_id']);
                              }
                              return $item;  
                    }, $units);
                    // print_r($units);die();
                    return $units;
                } catch (PDOException $e) {
                    echo "Error: " . $e->getMessage();die();
                }
    }

    public function getUnitLessonsData($unit_id, $destination_subject_id, $source_subject_id){
          try {
                    // $ids = "(" . implode(", ", $ids) . ")";
                    $sql  = "SELECT * FROM `unit_lessons` ";
                    $sql .= " WHERE unit_id = " . $unit_id;

                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->execute();
                $lessons = $stmt->fetchAll(PDO::FETCH_ASSOC);
                $lessons = array_map(function ($item) use ($unit_id, $destination_subject_id,$source_subject_id){
                    $item['tests'] = $this -> getUnitTestsData($unit_id, $destination_subject_id, $source_subject_id, $item['id']);
                    unset($item['unet_id']);
                    unset($item['id']);
                    unset($item['date_added']);
                    return $item;
                }, $lessons);
                return $lessons;
            } catch (PDOException $e) {
                echo "Error: " . $e->getMessage();die();
            }
}


public function getUnitTestsData($unit_id, $destination_subject_id, $source_subject_id, $lesson_id = NULL){
          try {
                    // $ids = "(" . implode(", ", $ids) . ")";
                    $sql  = "SELECT * FROM `tests` ";
                    $sql .= " WHERE subject_id = '{$source_subject_id}' AND unit_id = " . $unit_id;
                    if($lesson_id){
                              $sql .= " AND lesson_id = {$lesson_id}";
                    }else{
                              $sql .= " AND (lesson_id IS NULL OR lesson_id = '0')";
                    }
                    // $sql .=" LIMIT 1";
                    // echo $sql;die();
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->execute();
                $tests = $stmt->fetchAll(PDO::FETCH_ASSOC);
                $tests = array_map(function ($item) use ($unit_id, $destination_subject_id){
                    $item = $this -> TestsObj -> getOneTest($item['id']);
                    $item['subject_id'] = $destination_subject_id;
                    unset($item['unet_id']);
                    unset($item['lesson_id']);
                    unset($item['id']);
                    unset($item['date_added']);
                    return $item;
                }, $tests);

                return $tests;
            } catch (PDOException $e) {
                echo "Error: " . $e->getMessage();die();
            }
}


// public function getUnitTestQuestionsData($test_id){
//           try {
//                 $testDetails = $this -> TestsObj -> getTestDetailsInfo($test_id);
//                 $testQuestions = $testDetails['test_questions'];
//                 $testQuestions = array_map(function ($item){
//                     unset($item['test_id']);
//                     unset($item['id']);
//                     unset($item['date_added']);
//                     return $item;
//                 }, $testQuestions);

//                 return $testQuestions;
//             } catch (PDOException $e) {
//                 echo "Error: " . $e->getMessage();die();
//             }
// }



    public function unitTransfere($request){

          $limit = $request['limit']?:1;
          $destination_subject_id = $request['destination_subject_id'];
          $source_subject_id = $request['source_subject_id'];
          echo "يرجى مراجعة الكود جيدا قبل العمل بهذه الرابط  ---- in line 159";die();
          $unitsData = $this -> getUnitsData($source_subject_id, $destination_subject_id, $limit);
          return $this -> transferProcces($unitsData);
          
    }


    public function getMaxSortUnit($subject_id){
          $sql  = "SELECT MAX(sort) FROM `units` ";
          $sql .= " WHERE subject_id = :subject_id ";

          $stmt = $this->mDb->connect()->prepare($sql);
          $stmt->bindParam(":subject_id", $subject_id);
          $stmt->execute();
          return $stmt->fetch(PDO::FETCH_COLUMN);
    }

    public function transferProcces($data){
          foreach($data as $request){
                    $res = $this -> insertUnit($request);
          }
          return $res;
    }



    public function insertUnit($request){
          
                    $unitTests = $request['tests'];

                    $dateTime = date('Y-m-d H:i:s');
                    $sql = "INSERT INTO `units` SET ";
                    $sql .= " `added_by` = '{$request['added_by']}',";
                    $sql .= " `country_id` = '{$request['country_id']}',";
                    $sql .= " `stage_id` = '{$request['stage_id']}',";
                    $sql .= " `grade_id` = '{$request['grade_id']}',";
                    $sql .= " `subject_id` = '{$request['subject_id']}',";
                    $sql .= " `semester` = '{$request['semester']}',";
                    $sql .= " `name` = '{$request['name']}',";
                    $sql .= " `sort` = '{$request['sort']}',";
                    $sql .= " `mode` = '{$request['mode']}',";
                    $sql .= " `status` = '{$request['status']}',";
                    $sql .= $request['subject_branch_id'] && $request['subject_branch_id'] != 'null' ? " `subject_branch_id` = '{$request['subject_branch_id']}'," : "";
                    $sql .= " `date_added` = '{$dateTime}'";
                    // echo $sql; die();
                    $this->mDb->query($sql);
                    $last_grade_id = $this->mDb->getLastInsertId();
                    
                    $this->insertUnitLessons($last_grade_id, $request);

                    foreach ($unitTests as &$test) {
                              $test['unit_id'] = $last_grade_id;
                              $test['lesson_id'] = NULL;
                              $this -> insertTest($test);
                    }


                    return $last_grade_id;
    }
    public function insertUnitLessons($unit_id, $request){
          $newDataLangObj = $request['unit_lessons'];
          // print_r($newDataLangObj);die();
          foreach ($newDataLangObj as $value) {
                    $lessonTests = $value['tests'];
                    $stmt = "INSERT INTO `unit_lessons` SET ";
                    $stmt .="`unit_id` = '{$unit_id}'";
                    $stmt .= ", `name` =  '{$value['name']}'";
                    $this->mDb->query($stmt);
                    $lesson_id = $this->mDb->getLastInsertId($stmt);
                    // echo $stmt;die();
                    foreach ($lessonTests as &$test) {
                              $test['unit_id'] = $unit_id;
                              $test['lesson_id'] = $lesson_id;
                              $this -> insertTest($test);
                    }
          }
          return $lesson_id;
    }
    public function insertTest($temp){
          
          $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `tests` SET ";
            $sql .= " `added_by` = '{$temp['added_by']}', ";
            $sql .= " `country_id` = '{$temp['country_id']}', ";
            $sql .= " `stage_id` = '{$temp['stage_id']}', ";
            $sql .= " `grade_id` = '{$temp['grade_id']}', ";
            $sql .= " `subject_id` = '{$temp['subject_id']}', ";
            $sql .= $temp['branch_id'] ? " `subject_branch_id` = '{$temp['branch_id']}', " : "";
            $sql .= $temp['unit_id'] ? " `unit_id` = '{$temp['unit_id']}', " : "";
            $sql .= $temp['lesson_id'] ? " `lesson_id` = '{$temp['lesson_id']}', " : "";
            $sql .= $temp['specialize_id'] ? " `specialize_id` = '{$temp['specialize_id']}', " : "";
            $sql .= " `type` = '{$temp['type']}', ";

            $sql .= " `dedicated_to` = '{$temp['dedicated_to']}', ";
            $sql .= " `name` = '{$temp['name']}', ";
            $sql .= " `semester` = '{$temp['semester']}', ";
            $sql .= " `status` = '{$temp['status']}', ";
            $sql .= " `paid` = '{$temp['paid']}', ";
            $sql .= " `available_to_visitor` = '{$temp['available_to_visitor']}', ";
            $sql .= $temp['printable'] ? " `printable` = '{$temp['printable']}', ":'';
            if ($temp['type'] == 'unit_test') {
                $sql .= $temp['print_mode'] == 'unit' ? " `print_mode` = '{$temp['print_mode']}'," : "";
                $sql .= $temp['print_mode'] == 'month' ? " `print_mode` = '{$temp['print_mode']}', `month_id` = '{$temp['month_id']}', " : "";
            }
            $sql .= " `print_type` = '{$temp['print_type']}', ";
            $sql .= " `total_degree` = '{$temp['total_degree']}', ";
            $sql .= " `sort` = '{$temp['sort']}', ";
            $sql .= " `date_added` = '{$dateTime}', ";
            $sql .= " `random_order` = '{$temp['random_order']}'";
          //    echo $sql;die();

            $this->mDb->query($sql);
            $last_page_id = $this->mDb->getLastInsertId();

          //   $datate = $temp['teachers_id'];
            $newDataObj = $temp['teachers_id'];
            if (count($newDataObj) > 0) {
                $this -> TestsObj ->assigningTestToTeacher($last_page_id, $newDataObj, 'add');
            }


            $this -> TestsObj ->updateDegreeOfTest($last_page_id);

            $questions = $temp['test_questions'];

            foreach($questions as $question){
                    // print_r($question);die();
                    $params['current_quest'] = $question;
                    unset($params['current_quest']['id']);
                    foreach($params['current_quest']['test_question_options'] as &$item){
                              $item['status'] = $item['status'] == "1" ? "true" : "false";
                    }
                    unset($params['current_quest']['test_id']);
                    $params['current_question_test_id'] = $last_page_id;
                    $res = $this -> TestsObj -> addEditQuestion($params, true);
            }
        //   print_r($res);die();
            return $last_page_id;
    }
}?>