<?php

$ExamineQuestionsObj = new ExamineQuestions();

use Spipu\Html2Pdf\Html2Pdf;
use Dompdf\Dompdf;
use Dompdf\Options;

class ExamineQuestions
{

    var $mDb;
    var $mConfig;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    function getSomeTests($aStart, $aLimit, $sort, $type, $searchTitle, $searchCountry, $searchStage, $searchGrade, $searchSubject, $rools, $searchUnit, $searchLesson, $searchTeacherId, $searchDateFrom, $searchDateTo, $searchSource, $questionStatus)
    {
        $sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.type,te.sort, te.status, te.date_added, te.title, u.full_name AS 'user_full_name' , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " unitl.`name` as 'unit_name' , ";
        $sql .= " lessonl.`name` as 'lesson_name' , ";
        $sql .= " subjectt.`name` as 'subject_name' , ";
        $sql .= " subjectt.`subject_direction` as 'subject_direction'";
        $sql .= " FROM `examine_questions` te";
        $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE te.id > 0 AND te.`parent_id` < 1";
        $sql .= $searchTitle ? ' AND te.title like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
        $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
        $sql .= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
        $sql .= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";
        $sql .= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";


        if (count($rools) > 0 && $rools != 'all') {
            $sql .= "AND ( ";
            for ($ii = 0; $ii < count($rools); $ii++) {
                if ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0 && $rools[$ii]['grade_id'] > 0 && $rools[$ii]['subject_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}' AND te.`subject_id` = '{$rools[$ii]['subject_id']}' )";
                } elseif ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0 && $rools[$ii]['grade_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}'  )";
                } elseif ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' )";
                }
                if ($ii < (count($rools) - 1)) {
                    $sql .= " OR ";
                }
            }
            $sql .= " )";
        }
        $sql .= " ORDER BY te.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	 echo $sql; die();

        return $this->mDb->getAll($sql);
    }


    function getSearchTestsCount($sort, $type, $searchTitle, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchUnit, $searchLesson, $searchTeacherId, $searchDateFrom, $searchDateTo, $searchSource, $questionStatus)
    {
        $sql = "SELECT COUNT(te.`id`) as 'result_count' FROM `examine_questions` te";
        $sql .= " WHERE te.`id` > 0  AND te.`parent_id` < 1";

        $sql .= $searchTitle ? ' AND te.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
        $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
        $sql .= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
        $sql .= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";

        $sql .= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= " ORDER BY te.{$sort} {$type}";

// 	echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getTestsCount()
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `examine_questions` WHERE `parent_id` < 1";
        return $this->mDb->getOne($sql);
    }


    function addEditQuestion($temp)
    {
        // print_r($temp);die();
        $testQ = json_decode($temp['current_quest']);
        $current_quest = $this->convert_object_to_array($testQ);
        $questid = $current_quest['id'];

        if ($questid === null || $questid === '' || ($questid < 1)) {
            // add
            $dateTime = date('Y-m-d H:i:s');

            $title = $current_quest['title'];

            if ($title != '') {
                $check_queryy = "SELECT `id` FROM `examine_questions` WHERE `title` = '{$title}'";
                $check_resulty = $this->mDb->getOne($check_queryy);

                if ($check_resulty === false) {

                    $id = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $current_quest['type'], $current_quest['degree'], $temp['status'], $temp['sort'], $current_quest['source'], $current_quest['title'], $current_quest['note'], '', $current_quest['size_article_q'], $current_quest['extra_desc'], $current_quest['answer_form'], $temp['branch_id']);
                    if ($id > 0 && count($current_quest['test_question_options']) > 0) {
                        for ($ii = 0; $ii < count($current_quest['test_question_options']); $ii++) {
                            $nObj = $current_quest["test_question_options"][$ii];
                            $statuss = $nObj['status'] == 'true' ? "1" : "0";
                            $option_id = $this->InsertIntoExamineQuestionOptions($id, $nObj['title'], $statuss);
                            if ($option_id > 0 && $nObj['attachment'] != "" && $nObj['attachment_type'] != "") {
                                $this->addQuestionAttachments($id, $nObj['attachment'], $nObj['attachment_type'], 'option', $option_id);
                            }
                            if ($option_id > 0 && $nObj['attachment_note'] != "" && $nObj['attachment_type_note'] != "") {
                                $this->addQuestionAttachments($id, $nObj['attachment_note'], $nObj['attachment_type_note'], 'note', $option_id);
                            }
                        }
                    }
                    if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                        
                            $this->addQuestionAttachments($id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                    }
                    
                    if ($current_quest['attachment_note'] != "" && $current_quest['attachment_note_type'] != "") {
                      
                       $this->addQuestionAttachments($id, $current_quest['attachment_note'], $current_quest['attachment_note_type'], 'note');
                    }
                    

                    /*Stat section add new row in paragraphs*/
                    if ($id > 0 && $current_quest['type'] == 'paragraphs') {
                        for ($idsub = 0; $idsub < count($current_quest['question_sub_questions']); $idsub++) {
                            $subquestion = $current_quest['question_sub_questions'][$idsub];
                            // print_r($subquestion);die();
                            $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id, 'long', '', '', $temp['branch_id']);
                            // echo $idqsub;die();
                            if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                    $nObjff = $subquestion["test_question_options"][$iirr];
                                    $statuss = $nObjff['status'] == 'true' ? "1" : "0";
                                    $sub_option_id = $this->InsertIntoExamineQuestionOptions($idqsub, $nObjff['title'], $statuss);
                                    if ($sub_option_id > 0 && $nObjff['attachment'] != "" && $nObjff['attachment_type'] != "") {
                                        $this->addQuestionAttachments($idqsub, $nObjff['attachment'], $nObjff['attachment_type'], 'option', $sub_option_id);
                                    }
                                    if ($sub_option_id > 0 && $nObjff['attachment_note'] != "" && $nObjff['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($idqsub, $nObjff['attachment_note'], $nObjff['attachment_type_note'], 'note', $sub_option_id);
                                    }
                                }
                            }
                            if ($idqsub > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                            }


                            if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                    $nObjff = $subquestion["match_questions_items"][$iirr];
                                    $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                }
                            }

                            if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                    $nObjff = $subquestion["sort_questions_words"][$iirr];
                                    $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                }
                            }

                            /*add new some row*/
                            if ($idqsub > 0 && count($subquestion['question_sub_questions']) > 0) {
                                for ($iirrc = 0; $iirrc < count($subquestion['question_sub_questions']); $iirrc++) {
                                  /* echo'<pre>';
                                   print_r($subquestion['question_sub_questions'][$iirrc]);
                                   echo'</pre>';*/
                                    $subsubquestion = $subquestion['question_sub_questions'][$iirrc];
                                    $idqsubsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subsubquestion['type'], $subsubquestion['degree'], $temp['status'], $temp['sort'], $subsubquestion['source'], $subsubquestion['title'], $subsubquestion['note'], $idqsub,$subsubquestion['size_article_q'],$subsubquestion['extra_desc'],$subsubquestion['answer_form']);
                                    if ($idqsubsub > 0 && count($subsubquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subsubquestion['test_questions_complete_words']); $iirr++) {
                                            $nObjff = $subsubquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoTestQuestionCompleteWord($idqsubsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                        }
                                    }
                                }
                            }
                            /*add new some row*/

                        }
                    }
                    /*End section add new row in paragraphs*/

                    /*Start section add new row complete_id*/
                    if ($id > 0 && $current_quest['type'] == 'complete_it') {
                        for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                            $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                             $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id, 'long', '', '', $temp['branch_id']);
                            if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                    $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                    $this->InsertIntoTestQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                }
                            }
                        }
                    }
                    /*End section add new row complete_id*/
                    /*Start section add new row complete_it_writing_auto_correct*/
                    if ($id > 0 && $current_quest['type'] == 'complete_it_writing_auto_correct') {
                        for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                            $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                            $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);
                            if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                    $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                    $this->InsertIntoTestQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                }
                            }
                        }
                    }
                    /*End section add new row complete_it_writing_auto_correct*/
                    /*Start section add new row complete_it_writing_manual_correct*/
                    if ($id > 0 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                        for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                            $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                            $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);
                        }
                    }
                    /*Start section add new row complete_it_writing_manual_correct*/
                    /*Start section add new row match_it*/
                    if ($id > 0 && $current_quest['type'] == 'match_it') {
                        for ($mdsubm = 0; $mdsubm < count($current_quest['match_questions_items']); $mdsubm++) {
                            $subquestion = $current_quest['match_questions_items'][$mdsubm];
                            $this->InsertIntoMatchQuestionItems($id, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                        }
                    }
                    /*Start section add new row match_it*/
                    /*Start section add new row sort_it*/
                    if ($id > 0 && $current_quest['type'] == 'sort_it') {
                        for ($sdsubs = 0; $sdsubs < count($current_quest['sort_questions_words']); $sdsubs++) {
                            $subquestion = $current_quest['sort_questions_words'][$sdsubs];
                            $this->InsertIntoSortQuestionWords($id, $subquestion['title'], $subquestion['word_index']);
                        }
                    }
                    /*Start section add new row sort_it*/
                }
            }

            return $this->getOneQuestion($id);
        } else {

            /**
             **start section edit**
             **/

            $check_query = "SELECT `id` FROM `examine_questions` WHERE `id` = '{$questid}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {
                return 403;
            } else {


                if ($questid > 0) {
                    $statuss = $temp['status'] == 'true' ? "1" : "0";
                    if ($current_quest['title'] != '' && $questid >= 1) {
                        $math_type_view_title = renderMathType($current_quest['title']);
                        $math_type_view_note = renderMathType($current_quest['note']);
                        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                        $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
                        $answer_form_origin = $current_quest['answer_form'];
                        $answer_form = renderMathType($current_quest['answer_form']);
                        $answer_form = str_replace("'", "\'", $answer_form);
                        $answer_form_origin = str_replace("'", "\'", $answer_form_origin);

                        $stmtq = "UPDATE `examine_questions` SET ";
                        $stmtq .= " `added_by` = '{$temp['user_id']}', ";
                        $stmtq .= " `country_id` = '{$temp['country_id']}', ";
                        $stmtq .= $current_quest['parent_id'] && $current_quest['parent_id'] > 0 ? " `parent_id` = '{$current_quest['parent_id']}', " : "";
                        $stmtq .= " `stage_id` = '{$temp['stage_id']}', ";
                        $stmtq .= " `grade_id` = '{$temp['grade_id']}', ";
                        $stmtq .= " `subject_id` = '{$temp['subject_id']}', ";
                        $stmtq .= $temp['branch_id'] ? " `branch_id` = '{$temp['branch_id']}', " : "";
                        $stmtq .= $temp['category_id'] && $temp['category_id'] > 0 ? " `category_id` = '{$temp['category_id']}', " : "";

                        $stmtq .= $temp['unit_id'] && $temp['unit_id'] > 0 ? " `unit_id` = '{$temp['unit_id']}', " : "";
                        $stmtq .= $temp['lesson_id'] && $temp['lesson_id'] > 0 ? " `lesson_id` = '{$temp['lesson_id']}', " : "";
                        $stmtq .= $temp['specialize_id'] ? " `specialize_id` = '{$temp['specialize_id']}', " : "";
                        $stmtq .= " `type` = '{$current_quest['type']}', ";
                        $stmtq .= " `degree` = '{$current_quest['degree']}', ";
                        $stmtq .= " `source` = '{$current_quest['source']}', ";
                        $stmtq .= " `note` = '{$current_quest['note']}', ";
                        $stmtq .= " `size_article_q` = '{$current_quest['size_article_q']}', ";
                        $stmtq .= " `extra_desc` = '{$current_quest['extra_desc']}', ";
                        $stmtq .= " `answer_form` = '{$answer_form}', ";
                        $stmtq .= " `answer_form_origin` = '{$answer_form_origin}', ";
                        $stmtq .= " `title` = '{$current_quest['title']}', ";
                        $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                        $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                        $stmtq .= " `status` = '{$statuss}', ";
                        $stmtq .= " `sort` = '{$temp['sort']}', ";
                        $stmtq .= $temp['semester'] ? "`semester` = '{$temp['semester']}'" : "`semester` = 'both ";

                        $stmtq .= " WHERE `id`='{$questid}'  ";
    // echo $stmtq;die();
                        $this->mDb->query($stmtq);
                        /*echo '<pre>';
                        print_r($current_quest);
                        echo '</pre>';*/
                        if (count($current_quest['test_question_options']) > 0) {
                            foreach ($current_quest['test_question_options'] as $testObjOp) {
                                $statuss = $testObjOp['status'] == 'true' ? "1" : "0";
                                if ($testObjOp['title'] != '' && $testObjOp['id'] < 1) {
                                    $option_id = $this->InsertIntoExamineQuestionOptions($questid, $testObjOp['title'], $statuss);
                                    if ($option_id > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $option_id);
                                    }
                                    if ($option_id > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $option_id);
                                    }
                                } elseif ($testObjOp['title'] != '' && $testObjOp['id'] >= 1) {
                                    $math_type_view_title = renderMathType($testObjOp['title']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                    $stmtqup = "UPDATE `examine_question_options` SET ";
                                    $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                    $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtqup .= " `status` = '{$statuss}'";

                                    $stmtqup .= " WHERE `id`='{$testObjOp['id']}' AND `examine_question_id` = '{$questid}' ";
                                    $this->mDb->query($stmtqup);
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                        if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                        if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                            // delete old files
                                            $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                }
                            }
                        }
                        
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                        
                            $this->addQuestionAttachments($questid, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                            if ($current_quest['file'] && $current_quest['file'] != '') {
                                    // delete old files if exist
                                    $arr = ["file" => $current_quest['file'], "related_to" => "question"];
                                    $this->deleteAttachment($arr);
                                }  
                        }
                    
                    if ($current_quest['attachment_note'] != "" && $current_quest['attachment_note_type'] != "") {
                      
                       $this->addQuestionAttachments($questid, $current_quest['attachment_note'], $current_quest['attachment_note_type'], 'note');
                        if ($current_quest['file_note'] && $current_quest['file_note'] != '') {
                            // delete old files if exist
                            $arr = ["file" => $current_quest['file_note'], "related_to" => "note"];
                            $this->deleteAttachment($arr);
                        }
                    }

                        if ($questid >= 1 && $current_quest['type'] == 'paragraphs') {
//                            echo $current_quest['type'] ;
                            for ($idsub = 0; $idsub < count($current_quest['question_sub_questions']); $idsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$idsub];

                                /*echo '<pre>';
                                print_r($subquestion);
                                echo '</pre>';*/

                                /***
                                 * Add new row if not existing
                                 ***/
//                                echo'<pre>'.$subquestion['id'].'</pre>';
                                if ($subquestion['id'] < 1) {
                                    $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'],$questid, $subquestion['size_article_q'], $subquestion['extra_desc'], $subquestion['answer_form']);
                                    if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                            $subquestionoption = $subquestion["test_question_options"][$iirr];
                                            $titleo = $subquestionoption['title'];
                                            $statuss = $subquestionoption['status'] == 'true' ? "1" : "0";
                                            $note = $subquestionoption['note'];
                                            $subqoption = $this->InsertIntoExamineQuestionOptions($idqsub, $titleo, $statuss);
                                            if ($subqoption > 0 && $subquestionoption['attachment'] != "" && $subquestionoption['attachment_type'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment'], $subquestionoption['attachment_type'], 'option', $subqoption);
                                                if ($subquestionoption['file'] && $subquestionoption['file'] != '') {
                                                    // delete old files
                                                    $arr = ["file" => $subquestionoption['file'], "related_to" => "option"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                            if ($subquestionoption['id'] > 0 && $subquestionoption['attachment_note'] != "" && $subquestionoption['attachment_type_note'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment_note'], $subquestionoption['attachment_type_note'], 'note', $subqoption);
                                                if ($subquestionoption['file_note'] && $subquestionoption['file_note'] != '') {
                                                    // delete old files
                                                    $arr = ["file" => $subquestionoption['file_note'], "related_to" => "note"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                        }
                                    }
                                    if ($idqsub > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if ($subquestion['file'] && $subquestion['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $subquestion['file'], "related_to" => "question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }


                                    if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                            $nObjff = $subquestion["match_questions_items"][$iirr];
                                            $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                        }
                                    }

                                    if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                            $nObjff = $subquestion["sort_questions_words"][$iirr];
                                            $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                        }
                                    }

                                    /*new code edit if user add new data*/
                                    if ($idqsub > 0 && count($subquestion['question_sub_questions']) > 0) {
                                        for ($iirrc = 0; $iirrc < count($subquestion['question_sub_questions']); $iirrc++) {
                                           /* echo '<pre>';
                                            print_r($subquestion['question_sub_questions'][$iirrc]);
                                            echo '</pre>';*/
                                            $subsubquestion = $subquestion['question_sub_questions'][$iirrc];
                                            $idqsubsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subsubquestion['type'], $subsubquestion['degree'], $temp['status'], $temp['sort'], $subsubquestion['source'], $subsubquestion['title'], $subsubquestion['note'], $idqsub, 'long', '', '');
                                            if ($idqsubsub > 0 && count($subsubquestion['test_questions_complete_words']) > 0) {
                                                for ($iirr = 0; $iirr < count($subsubquestion['test_questions_complete_words']); $iirr++) {
                                                    $nObjff = $subsubquestion["test_questions_complete_words"][$iirr];
                                                    $this->InsertIntoTestQuestionCompleteWord($idqsubsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                                }
                                            }
                                        }
                                    }
                                    /*new code edit if user add new data*/


                                } else {
                                    /***
                                     * update row in database existing
                                     ***/
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $answer_form_origin = $subquestion['answer_form'];
                                    $answer_form = renderMathType($subquestion['answer_form']);
                                    $answer_form_origin = str_replace("'", "\'", $answer_form_origin);
                                    $answer_form = str_replace("'", "\'", $answer_form);

                                    $stmtq = "UPDATE `examine_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= " `extra_desc` = '{$subquestion['extra_desc']}', ";
                                    $stmtq .= " `answer_form` = '{$answer_form}', ";
                                    $stmtq .= " `answer_form_origin` = '{$answer_form_origin}', ";
                                    $stmtq .= " `size_article_q` = '{$subquestion['size_article_q']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' ";

                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_question_options']) > 0) {
                                        foreach ($subquestion['test_question_options'] as $testObjOp) {
                                            $statuss = $testObjOp['status'] == 'true' ? "1" : "0";
                                            if ($testObjOp['title'] != '' && $testObjOp['id'] < 1) {
                                                $subquestionoption_id = $this->InsertIntoExamineQuestionOptions($subquestion['id'], $testObjOp['title'], $statuss);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $subquestionoption_id);
                                                    if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $subquestionoption_id);
                                                    if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }

                                            } elseif ($testObjOp['title'] != '' && $testObjOp['id'] >= 1) {
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                                $stmtqup = "UPDATE `examine_question_options` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `status` = '{$statuss}'  ";

                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                                    if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                                    if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if ($subquestion['id'] > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($subquestion['id'], $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if ($subquestion['file'] && $subquestion['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $subquestion['file'], "related_to" => "question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }

                                    if ($subquestion['id'] > 0 && $subquestion['type'] == 'match_it') {
                                        for ($mqii = 0; $mqii < count($subquestion['match_questions_items']); $mqii++) {
                                            $subquestionmatch = $subquestion['match_questions_items'][$mqii];
                                            if ($subquestionmatch['title1'] != '' && $subquestionmatch['id'] < 1) {
                                                $this->InsertIntoMatchQuestionItems($subquestion['id'], $subquestionmatch['title1'], $subquestionmatch['righte_index1'], $subquestionmatch['title2'], $subquestionmatch['righte_index2'], $subquestionmatch['image1'], $subquestionmatch['image2']);
                                            } else {
                                                $math_type_view_title1 = renderMathType($subquestionmatch['title1']);
                                                $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

                                                $math_type_view_title2 = renderMathType($subquestionmatch['title2']);
                                                $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);


                                                $matchqui = "UPDATE `examine_questions_match_items` SET ";
                                                $matchqui .= " `title1` = '{$subquestionmatch['title1']}', ";
                                                $matchqui .= " `title2` = '{$subquestionmatch['title2']}', ";
                                                $matchqui .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
                                                $matchqui .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";

                                                $matchqui .= $subquestionmatch['image1'] && $subquestionmatch['image1'] != '' ? " `image1` = '{$subquestionmatch['image1']}', " : "";
                                                $matchqui .= $subquestionmatch['image2'] && $subquestionmatch['image2'] != '' ? " `image2` = '{$subquestionmatch['image2']}', " : "";

                                                $matchqui .= " `righte_index1` = '{$subquestionmatch['righte_index1']}', ";
                                                $matchqui .= " `righte_index2` = '{$subquestionmatch['righte_index2']}' ";
                                                $matchqui .= " WHERE `id`='{$subquestionmatch['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this->mDb->query($matchqui);
                                            }
                                        }
                                    }
                                    if ($subquestion['id'] > 0 && $subquestion['type'] == 'sort_it') {
                                        for ($sqwdi = 0; $sqwdi < count($subquestion['sort_questions_words']); $sqwdi++) {

                                            $subquestionword = $subquestion['sort_questions_words'][$sqwdi];
                                            if ($subquestionword['title'] != '' && $subquestionword['id'] < 1) {
                                                $this->InsertIntoSortQuestionWords($subquestion['id'], $subquestionword['title'], $subquestionword['word_index']);
                                            } else {
                                                $math_type_view_title = renderMathType($subquestionword['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                                $sortquw = "UPDATE  `examine_questions_sort_words` SET ";
                                                $sortquw .= " `title` = '{$subquestionword['title']}', ";
                                                $sortquw .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $sortquw .= " `word_index` = '{$subquestionword['word_index']}' ";
                                                $sortquw .= " WHERE `id`='{$subquestionword['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this->mDb->query($sortquw);
                                            }
                                        }
                                    }

                                    /*--*/
                                    if ($subquestion['id'] > 0 && (($subquestion['type'] == 'complete_it') || ($subquestion['type'] == 'complete_it_writing_auto_correct') || ($subquestion['type'] == 'complete_it_writing_manual_correct'))) {
                                        for ($cdsub = 0; $cdsub < count($subquestion['question_sub_questions']); $cdsub++) {
                                            /*echo'<pre>';
                                           print_r($subquestion['question_sub_questions'][$cdsub]);
                                           echo'</pre>';
                                           die();*/
                                            $subcomquestion = $subquestion['question_sub_questions'][$cdsub];
                                            if ($subcomquestion['id'] < 1) {
                                                $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subcomquestion['type'], $subcomquestion['degree'], $temp['status'], $temp['sort'], $subcomquestion['source'], $subcomquestion['title'], $subcomquestion['note'], $subquestion['id'], $subcomquestion['extra_desc'],$subcomquestion['$subcomquestion']);
                                                if ($idqsub > 0 && count($subcomquestion['test_questions_complete_words']) > 0) {
                                                    for ($iirr = 0; $iirr < count($subcomquestion['test_questions_complete_words']); $iirr++) {
                                                        $subquestionoption = $subcomquestion["test_questions_complete_words"][$iirr];
                                                        $this->InsertIntoTestQuestionCompleteWord($idqsub, $subquestionoption['title'], $subquestionoption['word_index'], $subquestionoption['note']);
                                                    }
                                                }

                                            } else {

                                                // **** update new code ****//
                                                /*echo '<pre>';
                                                print_r($subquestion['question_sub_questions'][$cdsub]);
                                                echo '</pre>';*/
                                                $math_type_view_title = renderMathType($subcomquestion['title']);
                                                $math_type_view_note = renderMathType($subcomquestion['note']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                                $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                                $answer_form_origin = $subcomquestion['answer_form'];
                                                $answer_form = renderMathType($subcomquestion['answer_form']);
                                                $answer_form_origin = str_replace("'", "\'", $answer_form_origin);
                                                $answer_form = str_replace("'", "\'", $answer_form);
                                                $stmtq = "UPDATE `examine_questions` SET ";
                                                $stmtq .= " `type` = '{$subcomquestion['type']}', ";
                                                $stmtq .= " `source` = '{$subcomquestion['source']}', ";
                                                $stmtq .= " `degree` = '{$subcomquestion['degree']}', ";
                                                $stmtq .= " `note` = '{$subcomquestion['note']}', ";
                                                $stmtq .= " `extra_desc` = '{$subcomquestion['extra_desc']}', ";
                                                $stmtq .= " `answer_form` = '{$answer_form}', ";
                                                $stmtq .= " `answer_form_origin` = '{$answer_form_origin}', ";
                                                $stmtq .= " `size_article_q` = '{$subcomquestion['size_article_q']}', ";
                                                $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                                $stmtq .= " `title` = '{$subcomquestion['title']}' ";
                                                $stmtq .= " WHERE `id`='{$subcomquestion['id']}' ";
                                                $this->mDb->query($stmtq);
                                                //  echo '<pre>';
                                                // print_r($subcomquestion['test_questions_complete_words']);
                                                // echo '</pre>';
                                                if (count($subcomquestion['test_questions_complete_words']) > 0) {
                                                    foreach ($subcomquestion['test_questions_complete_words'] as $testObjOp) {

                                                        if ($testObjOp['title'] != '' && $testObjOp['id'] < 1) {
                                                            $this->InsertIntoTestQuestionCompleteWord($subcomquestion['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                                        } elseif ($testObjOp['title'] != '' && $testObjOp['id'] >= 1) {

                                                            $testObjOp['title'] = trim($testObjOp['title']);
                                                            $math_type_view_title = renderMathType($testObjOp['title']);
                                                            $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                                            $title = str_replace("'", "\'", $testObjOp['title']);
                                                            $stmtqup = "UPDATE `examine_questions_complete_words` SET ";
                                                            $stmtqup .= " `title` = '{$title}', ";
                                                            $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                            $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                            $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                            // echo $stmtqup;
                                                            $this->mDb->query($stmtqup);
                                                        }
                                                    }
                                                }

                                            }
                                        }
                                    }

                                    /*--*/


                                }
                            }

                        }
                        /*End section [edit row exsiting Or add new row ] paragrahpes*/

                        /*Start section [edit row exsiting Or add new row ] complete_it*/
                        if ($questid >= 1 && $current_quest['type'] == 'complete_it') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    /* Start part add new row examine_questions*/
                                    $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $questid);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        /*Start part  add new row in examine_questions_complete_words*/
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoTestQuestionCompleteWord($idqsub, $subquestionoption['title'], $subquestionoption['word_index'], $subquestionoption['note']);
                                        }
                                        /*End part  add new row in examine_questions_complete_words*/
                                    }
                                    /* End part add new row examine_questions*/
                                } else {
                                    /* Start part edit row exsiting examine_questions*/
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
                                    $stmtq = "UPDATE `examine_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND `parent_id` = '{$questid}' ";
                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_questions_complete_words']) > 0) {
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {
                                            if ($testObjOp['title'] != '' && $testObjOp['id'] < 1) {
                                                /*Start part  add new row in examine_questions_complete_words*/
                                                $this->InsertIntoTestQuestionCompleteWord($subquestion['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                                /*End part if user add new  examine_questions_complete_words*/
                                            } elseif ($testObjOp['title'] != '' && $testObjOp['id'] >= 1) {
                                                /*Start part edit row exsiting in examine_questions_complete_words*/
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                                $stmtqup = "UPDATE `examine_questions_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                                /*Start part edit row exsiting in examine_questions_complete_words*/
                                            }
                                        }
                                    }
                                    /* End part edit row exsiting*/
                                }
                            }
                        }
                        /*Start section [edit row exsiting Or add new row ] complete_it*/

                        /*Start section [edit row exsiting Or add new row ] complete_it_writing_auto_correct*/
                        if ($questid >= 1 && $current_quest['type'] == 'complete_it_writing_auto_correct') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    /*Start part add new row in examine_questions*/
                                    $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $subquestion['id']);
                                    /*End part add new row in examine_questions*/
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        /*Start part add new row in examine_questions_complete_words*/
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoTestQuestionCompleteWord($idqsub, $subquestionoption['title'], $subquestionoption['word_index'], $subquestionoption['note']);
                                        }
                                        /*End part add new row in examine_questions_complete_words*/
                                    }
                                } else {
                                    /*Start part edit row exsiting examine_questions*/
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
                                    $stmtq = "UPDATE `examine_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND  `parent_id` = '{$questid}'  ";
                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_questions_complete_words']) > 0) {
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {
                                            if ($testObjOp['title'] != '' && $testObjOp['id'] < 1) {
                                                /*Start part  add new row in examine_questions_complete_words*/
                                                $this->InsertIntoTestQuestionCompleteWord($subquestion['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                                /*End part  add new row in examine_questions_complete_words*/
                                            } elseif ($testObjOp['title'] != '' && $testObjOp['id'] >= 1) {
                                                /*Start part edit row exsiting in examine_questions_complete_words*/
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                                $stmtqup = "UPDATE `examine_questions_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                                /*End part edit row exsiting in examine_questions_complete_words*/
                                            }
                                        }
                                    }
                                    /*End part edit row exsiting examine_questions*/
                                }
                            }
                        }
                        /*End section [edit row exsiting Or add new row ] complete_it_writing_auto_correct*/

                        /*Start section [edit row exsiting Or add new row ] complete_it_writing_manual_correct*/
                        if ($questid >= 1 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    /*Start part add new row in examine_questions*/
                                    $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $questid);
                                    /*End part add new row in examine_questions*/
                                } else {
                                    /*Start part edit row exsiting in examine_questions*/
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
                                    $stmtq = "UPDATE `examine_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND  `parent_id` = '{$questid}'  ";
                                    $this->mDb->query($stmtq);
                                    /*End part edit row exsiting in examine_questions*/
                                }
                            }
                        }
                        /*End section [edit row exsiting Or add new row ] complete_it_writing_manual_correct*/
                        /*Start section [edit row exsiting Or add new row ] match_it*/
                        if ($questid > 0 && $current_quest['type'] == 'match_it') {
                            for ($imgisub = 0; $imgisub < count($current_quest['match_questions_items']); $imgisub++) {
                                $subquestion = $current_quest['match_questions_items'][$imgisub];
                                if ($subquestion['title1'] != '' && $subquestion['id'] < 1) {
                                    $this->InsertIntoMatchQuestionItems($questid, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                                } else {
                                    $math_type_view_title1 = renderMathType($subquestion['title1']);
                                    $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

                                    $math_type_view_title2 = renderMathType($subquestion['title2']);
                                    $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);

                                    $matchqui = "UPDATE `examine_questions_match_items` SET ";
                                    $matchqui .= " `title1` = '{$subquestion['title1']}', ";
                                    $matchqui .= " `title2` = '{$subquestion['title2']}', ";
                                    $matchqui .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
                                    $matchqui .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";

                                    $matchqui .= $subquestion['image1'] && $subquestion['image1'] != '' ? " `image1` = '{$subquestion['image1']}', " : "";
                                    $matchqui .= $subquestion['image2'] && $subquestion['image2'] != '' ? " `image2` = '{$subquestion['image2']}', " : "";

                                    $matchqui .= " `righte_index1` = '{$subquestion['righte_index1']}', ";
                                    $matchqui .= " `righte_index2` = '{$subquestion['righte_index2']}' ";
                                    $matchqui .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";

                                    $this->mDb->query($matchqui);
                                }
                            }
                        }
                        /*End section [edit row exsiting Or add new row ] match_it*/
                        /*Start section [edit row exsiting Or add new row ] sort_it*/
                        if ($questid > 0 && $current_quest['type'] == 'sort_it') {
                            for ($sqwi = 0; $sqwi < count($current_quest['sort_questions_words']); $sqwi++) {
                                $subquestion = $current_quest['sort_questions_words'][$sqwi];
                                if ($subquestion['title'] != '' && $subquestion['id'] < 1) {
                                    $this->InsertIntoSortQuestionWords($questid, $subquestion['title'], $subquestion['word_index']);
                                } else {

                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


                                    $sortquw = "UPDATE  `examine_questions_sort_words` SET ";
                                    $sortquw .= " `title` = '{$subquestion['title']}', ";
                                    $sortquw .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $sortquw .= " `word_index` = '{$subquestion['word_index']}' ";
                                    $sortquw .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";
                                    $this->mDb->query($sortquw);
                                }
                            }
                        }
                        /*End section [edit row exsiting Or add new row ] sort_it*/
                    }

                }

                return $this->getOneQuestion($questid);
            }
        }
    }


    function addTestToExamin($temp)
    {

        $testQ = json_decode($temp['test_questions']);
        $allquestions = $this->convert_object_to_array($testQ);

        $subject_id = $temp['subject_id'];
        $user_id = $temp['user_id'];

        $stmt = "SELECT  `country_id`,`stage_id`,`grade_id` FROM `subjects` ";
        $stmt .= " WHERE `id` = '{$temp['subject_id']}' ";
        $redata = $this->mDb->getRow($stmt);

        $temp['country_id'] = $redata['country_id'];
        $temp['stage_id'] = $redata['stage_id'];
        $temp['grade_id'] = $redata['grade_id'];
        $temp['category_id'] = 0;
        $temp['unit_id'] = 0;
        $temp['lesson_id'] = 0;
        $temp['specialize_id'] = 0;
        $temp['status'] = 'true';
        $temp['sort'] = '0';
        $temp['semester'] = 'both';


        if (count($allquestions) > 0) {
            $dateTime = date('Y-m-d H:i:s');

            for ($iq = 0; $iq < count($allquestions); $iq++) {
                $current_quest = $allquestions[$iq];
                $title = $current_quest['title'];

                if ($title != '') {
                    $check_queryy = "SELECT `id` FROM `examine_questions` WHERE `title` = '{$title}'";
                    $check_resulty = $this->mDb->getOne($check_queryy);

                    if ($check_resulty === false) {

                        $id = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $current_quest['type'], $current_quest['degree'], $temp['status'], $temp['sort'], $current_quest['source'], $current_quest['title'], $current_quest['note'], '');
                        if ($id > 0 && count($current_quest['test_question_options']) > 0) {
                            for ($ii = 0; $ii < count($current_quest['test_question_options']); $ii++) {
                                $nObj = $current_quest["test_question_options"][$ii];
                                $statuss = $nObj['status'];
                                $option_id = $this->InsertIntoExamineQuestionOptions($id, $nObj['title'], $statuss);
                                if ($option_id > 0 && $nObj['attachment'] != "" && $nObj['attachment_type'] != "") {
                                    $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObj['file'];
                                    $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $nObj['file'];
                                    copy($oldFolder, $newFolder);
                                    $this->addQuestionAttachments($id, $nObj['attachment'], $nObj['attachment_type'], 'option', $option_id);
                                }

                            }
                        }
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                            $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $current_quest['file'];
                            $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $current_quest['file'];
                            copy($oldFolder, $newFolder);
                            $this->addQuestionAttachments($id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                        }

                        if ($id > 0 && $current_quest['type'] == 'paragraphs') {
                            for ($idsub = 0; $idsub < count($current_quest['question_sub_questions']); $idsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$idsub];
                                $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);

                                if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                        $nObjff = $subquestion["test_question_options"][$iirr];
                                        $statuss = $nObjff['status'];
                                        $sub_option_id = $this->InsertIntoExamineQuestionOptions($idqsub, $nObjff['title'], $statuss);
                                        if ($sub_option_id > 0 && $nObjff['attachment'] != "" && $nObjff['attachment_type'] != "") {
                                            $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['file'];
                                            $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $nObjff['file'];
                                            copy($oldFolder, $newFolder);
                                            $this->addQuestionAttachments($idqsub, $nObjff['attachment'], $nObjff['attachment_type'], 'option', $sub_option_id);
                                        }
                                    }
                                }
                                if ($idqsub > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                    $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['file'];
                                    $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $subquestion['file'];
                                    copy($oldFolder, $newFolder);
                                    $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                }


                                if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                        $nObjff = $subquestion["match_questions_items"][$iirr];
                                        if ($nObjff['image1'] && $nObjff['image1'] != '') {
                                            $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['image1'];
                                            $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $nObjff['image1'];
                                            copy($oldFolder, $newFolder);
                                        }
                                        if ($nObjff['image2'] && $nObjff['image2'] != '') {
                                            $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['image2'];
                                            $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $nObjff['image2'];
                                            copy($oldFolder, $newFolder);
                                        }

                                        $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                    }
                                }

                                if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                        $nObjff = $subquestion["sort_questions_words"][$iirr];
                                        $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                    }
                                }

                            }
                        }

                        if ($id > 0 && $current_quest['type'] == 'complete_it') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);
                                if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                        $this->InsertIntoTestQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                    }
                                }
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'complete_it_writing_auto_correct') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);
                                if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                        $this->InsertIntoTestQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                    }
                                }
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoExamineQuestions($temp['user_id'], $temp['semester'], $temp['country_id'], $temp['stage_id'], $temp['grade_id'], $temp['subject_id'], $temp['category_id'], $temp['unit_id'], $temp['lesson_id'], $temp['specialize_id'], $subquestion['type'], $subquestion['degree'], $temp['status'], $temp['sort'], $subquestion['source'], $subquestion['title'], $subquestion['note'], $id);

                            }
                        }

                        if ($id > 0 && $current_quest['type'] == 'match_it') {
                            for ($mdsubm = 0; $mdsubm < count($current_quest['match_questions_items']); $mdsubm++) {
                                $subquestion = $current_quest['match_questions_items'][$mdsubm];

                                if ($subquestion['image1'] && $subquestion['image1'] != '') {
                                    $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['image1'];
                                    $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $subquestion['image1'];
                                    copy($oldFolder, $newFolder);
                                }
                                if ($subquestion['image2'] && $subquestion['image2'] != '') {
                                    $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['image2'];
                                    $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions' . '/' . $subquestion['image2'];
                                    copy($oldFolder, $newFolder);
                                }

                                $this->InsertIntoMatchQuestionItems($id, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'sort_it') {
                            for ($sdsubs = 0; $sdsubs < count($current_quest['sort_questions_words']); $sdsubs++) {
                                $subquestion = $current_quest['sort_questions_words'][$sdsubs];
                                $this->InsertIntoSortQuestionWords($id, $subquestion['title'], $subquestion['word_index']);
                            }
                        }
                    }
                }
            }
            return true;
        }

    }


    function getAllCategories($type = 'important_article_questions', $subject_id, $branch_id)
    {
        $sql = "SELECT p.id, pl.title FROM `categories` p";
        $sql .= " LEFT JOIN `categories_langs` pl ON p.id = pl.`category_id` ";
        $sql .= " WHERE p.id > 0 AND pl.lang_code = 'ar' AND p.status = '1'  AND p.type = '{$type}' ";
        $sql .= $subject_id && $subject_id > 0 ? " AND p.`subject_id` = '{$subject_id}'" : "";
        $sql .= $branch_id && $branch_id > 0 ? " AND p.`branch_id` = '{$branch_id}'" : "";
        $sql .= " ORDER BY p.sort";
        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function InsertIntoExamineQuestions($user_id, $semester = 'both', $country_id, $stage_id, $grade_id, $subject_id, $category_id = '0', $unit_id = '', $lesson_id = '', $specialize_id = '0', $type, $degree = '0', $status, $sort, $source, $title, $note = '', $parent_id = '', $size_article_q = '', $extra_desc = '', $answer_form = '', $branch_id)
    {   
        $math_type_view_title = renderMathType($title);
        $math_type_view_note = renderMathType($note);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
        $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

        $titlee = str_replace("'", "\'", $title);
        $note = str_replace("'", "\'", $note);
        $answer_form_origin = $answer_form;
        $answer_form = renderMathType($answer_form);
        $answer_form = str_replace("'", "\'", $answer_form);
        $answer_form_origin = str_replace("'", "\'", $answer_form_origin);

        $statuss = $status == 'true' ? "1" : "0";
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `examine_questions` SET ";
        $sql .= " `added_by` = '{$user_id}', ";
        $sql .= " `semester` = '{$semester}', ";
        $sql .= " `country_id` = '{$country_id}', ";
        $sql .= $parent_id && $parent_id > 0 ? " `parent_id` = '{$parent_id}', " : "";
        $sql .= " `stage_id` = '{$stage_id}', ";
        $sql .= " `grade_id` = '{$grade_id}', ";
        $sql .= " `subject_id` = '{$subject_id}', ";
        $sql .= $branch_id ? " `branch_id` = '{$branch_id}', " : "";
        $sql .= $category_id && $category_id > 0 ? " `category_id` = '{$category_id}', " : "";
        $sql .= $unit_id && $unit_id > 0 ? " `unit_id` = '{$unit_id}', " : "";
        $sql .= $lesson_id && $lesson_id > 0 ? " `lesson_id` = '{$lesson_id}', " : "";
        $sql .= $specialize_id ? " `specialize_id` = '{$specialize_id}', " : "";
        $sql .= " `type` = '{$type}', ";
        $sql .= " `degree` = '{$degree}', ";
        $sql .= " `source` = '{$source}', ";
        $sql .= " `note` = '{$note}', ";
        $sql .= " `size_article_q` = '{$size_article_q}', ";
        $sql .= " `extra_desc` = '{$extra_desc}', ";
        $sql .= " `answer_form` = '{$answer_form}', ";
        $sql .= " `answer_form_origin` = '{$answer_form_origin}', ";
        $sql .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $sql .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
        $sql .= " `title` = '{$titlee}', ";
        $sql .= " `status` = '{$statuss}', ";
        $sql .= " `sort` = '{$sort}', ";
        $sql .= " `date_added` = '{$dateTime}'";
        // if($type == 'article'){
        // echo '<pre>'.$sql.'</pre>';die();
        // }

        return $this->mDb->queryreturnlastid($sql);
    }

    function InsertIntoMatchQuestionItems($test_question_id, $title1, $righte_index1, $title2, $righte_index2, $image1 = '', $image2 = '')
    {

        $math_type_view_title1 = renderMathType($title1);
        $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

        $math_type_view_title2 = renderMathType($title2);
        $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);


        $title1 = str_replace("'", "\'", $title1);
        $title2 = str_replace("'", "\'", $title2);

        $stmto = "INSERT INTO `examine_questions_match_items` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title1` = '{$title1}', ";
        $stmto .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
        $stmto .= " `title2` = '{$title2}', ";
        $stmto .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";
        $stmto .= $image1 && $image1 != '' ? " `image1` = '{$image1}', " : "";
        $stmto .= $image2 && $image2 != '' ? " `image2` = '{$image2}', " : "";
        $stmto .= $righte_index1 ? " `righte_index1` = '{$righte_index1}', " : "";
        $stmto .= " `righte_index2` = '{$righte_index2}' ";
        return $this->mDb->queryreturnlastid($stmto);
    }

    function InsertIntoSortQuestionWords($test_question_id, $title, $word_index)
    {

        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

        $title = str_replace("'", "\'", $title);
        $stmto = "INSERT INTO  `examine_questions_sort_words` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$title}', ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `word_index` = '{$word_index}' ";

        return $this->mDb->queryreturnlastid($stmto);
    }


    function InsertIntoExamineQuestionOptions($test_question_id, $title, $status)
    {
        $titlee = str_replace("'", "\'", $title);

        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

        $stmto = "INSERT INTO `examine_question_options` SET ";
        $stmto .= " `examine_question_id` = '{$test_question_id}', ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `title` = '{$titlee}', ";
        $stmto .= " `status` = '{$status}' ";

        return $this->mDb->queryreturnlastid($stmto);
    }


    function InsertIntoTestQuestionCompleteWord($test_question_id, $title, $word_index, $note = '')
    {

        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


        $title = str_replace("'", "\'", $title);
        $stmto = "INSERT INTO `examine_questions_complete_words` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `title` = '{$title}', ";

        $stmto .= " `word_index` = '{$word_index}' ";
//        echo $stmto;
        return $this->mDb->queryreturnlastid($stmto);
    }


    function getOneQuestion($id)
    {

        $stmt = "SELECT  pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_questions` pl";
        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
        $stmt .= " WHERE pl.`id` = '{$id}'  ";
        $result = $this->mDb->getRow($stmt);
        
        $sql = "SELECT `file`,`attachment_type` FROM `examine_question_attachments` WHERE `question_id` = '{$result['id']}' AND `related_to` = 'note' ";
        $resq = $this->mDb->getRow($sql);
        // echo $sql;
        // die();
        // $resultq = $this->mDb->getAll($stmtq);
        $result['file_note'] = $resq['file'];
        $result['attachment_note_type'] = $resq['attachment_type'];
        
        
        if ($result && count($result) > 0) {
            $stmto = "SELECT DISTINCT tqo.* FROM `examine_question_options` tqo ";
            // $stmto .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['id']}'    AND related_to = 'option')";
            // $stmto .= " LEFT JOIN `examine_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['id']}'    AND qattachfilenote.`related_to` = 'note')";
            $stmto .= " WHERE tqo.`examine_question_id` = " . $result['id'];
            // echo $stmto;
            // die();
            $result['test_question_options'] = $this->mDb->getAll($stmto);
            
            foreach($result['test_question_options'] as &$option){
                $sql = "SELECT `file`,`attachment_type` FROM `examine_question_attachments` WHERE `option_id` = '{$option['id']}' AND `related_to` = 'option' ";
                $res = $this->mDb->getRow($sql);
                
                $sql_note = "SELECT `file`,`attachment_type` FROM `examine_question_attachments` WHERE `option_id` = '{$option['id']}' AND `related_to` = 'note' ";
                $res_note = $this->mDb->getRow($sql_note);
                
                $option['file'] = $res['file'];
                $option['attachment_type'] = $res['attachment_type'];
                $option['file_note'] = $res_note['file'];
                $option['attachment_note_type'] = $res_note['attachment_type'];
                }
            if ($result['type'] == 'paragraphs') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                $stmt .= " WHERE  pl.`parent_id` = '{$result['id']}'  ";
//                pl.`test_id` = '{$result['test_id']}' AND
//                    echo $stmt;
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `examine_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                        $stmtosub .= " LEFT JOIN `examine_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                        $stmtosub .= " WHERE tqo.`examine_question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);


                        if ($result['question_sub_questions'][$iisub]['type'] == 'match_it') {
                            $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);
                        }
                        if ($result['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                            $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);
                        }

                        /*new code*/
//                        echo $result['question_sub_questions'][$iisub]['type'];
                        if (($result['question_sub_questions'][$iisub]['type'] == 'complete_it') || ($result['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') || ($result['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_manual_correct')) {

                            $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                            $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`  AND related_to = 'question')";
                            $stmt .= " WHERE pl.`parent_id` = '{$result['question_sub_questions'][$iisub]['id']}'";
                            /*echo '<pre>'.$stmt.'</pre>';*/
                            $result['question_sub_questions'][$iisub]['question_sub_questions'] = $this->mDb->getAll($stmt);

                            if (count($result['question_sub_questions'][$iisub]['question_sub_questions']) > 0) {
                                for ($iicomsub = 0; $iicomsub < count($result['question_sub_questions'][$iisub]['question_sub_questions']); $iicomsub++) {
                                    $subCom = $result['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub];
                                    $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                                    $stmtosub .= " WHERE tqcw.`question_id` ='{$subCom['id']}' ";
//                                    echo $stmtosub;
                                    $result['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                                }
                            }
                        }
                        /*new code*/

                    }
                }
            }

            /*Start section get all data especially complete_id*/
            if ($result['type'] == 'complete_it') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND related_to = 'question')";
                $stmt .= " WHERE pl.`parent_id` = '{$result['id']}'  ";
                //                    echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                        $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                    }
                }
            }
            /*End section get all data especially complete_id*/

            /*Start section get all data especially complete_it_writing_auto_correct*/
            if ($result['type'] == 'complete_it_writing_auto_correct') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                $stmt .= " WHERE pl.`parent_id` = '{$result['id']}'  ";
                //                    echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);
                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                        $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                    }
                }
            }
            /*End section get all data especially complete_it_writing_auto_correct*/

            /*Start section get all data especially complete_it_writing_manual_correct*/
            if ($result['type'] == 'complete_it_writing_manual_correct') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                $stmt .= " WHERE pl.`parent_id` = '{$result['id']}'  ";
                // echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);
            }
            /*End section get all data especially complete_it_writing_manual_correct*/
            /*Start section get all data especially match_it*/
            if ($result['type'] == 'match_it') {
                $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['match_questions_items'] = $this->mDb->getAll($stmt);
            }
            /*End section get all data especially match_it*/
            /*Start section get all data especially sort_it*/
            if ($result['type'] == 'sort_it') {
                $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['sort_questions_words'] = $this->mDb->getAll($stmt);
            }
            /*End section get all data especially sort_it*/
        }
        return $result;
    }


    function getOneTest($id)
    {

        $result = array();
        $sql = "SELECT te.*,subjectt.`subject_direction` as 'subject_direction' FROM `tests` te";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " WHERE te.`id` = '{$id}'";
        $result = $this->mDb->getRow($sql);

        if ($result) {
            $result['student_test_answers_count'] = $this->getCountOfAnswerOnTest($id);

        }


        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_questions` pl";
        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '0'    order by pl.`id` ASC";

        $result['test_questions'] = $this->mDb->getAll($stmt);
        if (count($result['test_questions']) > 0) {
            $qindex = 0;
            for ($ii = 0; $ii < count($result['test_questions']); $ii++) {
                $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `examine_question_options` tqo ";
                $stmto .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfile.`related_to` = 'option')";
                $stmto .= " LEFT JOIN `examine_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                $stmto .= " WHERE tqo.`examine_question_id` = " . $result['test_questions'][$ii]['id'];
//            echo $stmto;die();
                $result['test_questions'][$ii]['test_question_options'] = $this->mDb->getAll($stmto);
                if ($result['test_questions'][$ii]['type'] == 'paragraphs') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_questions` pl";
                    $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'   ";
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `examine_question_options` tqo ";
                            $stmtosub .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                            $stmtosub .= " LEFT JOIN `examine_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                            $stmtosub .= " WHERE tqo.`examine_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
//                        echo $stmtosub;die();
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);

                            if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                //                    echo $stmt;die();
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);

                            }

                            if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                //                    echo $stmt;die();
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);

                            }

                        }
                    }
                }


                if ($result['test_questions'][$ii]['type'] == 'complete_it') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                    $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                            $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                        }
                    }
                }

                if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                    $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                            $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                        }
                    }
                }

                if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_manual_correct') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                    $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);


                }


                if ($result['test_questions'][$ii]['type'] == 'match_it') {
                    $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
                    $result['test_questions'][$ii]['match_questions_items'] = $this->mDb->getAll($stmt);

                }

                if ($result['test_questions'][$ii]['type'] == 'sort_it') {
                    $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
                    $result['test_questions'][$ii]['sort_questions_words'] = $this->mDb->getAll($stmt);

                }

                if ($result['test_questions'][$ii]['type'] != 'head_question') {
                    $qindex++;
                    $result['test_questions'][$ii]['index'] = $qindex;
                } else {
                    $result['test_questions'][$ii]['index'] = 0;
                }


            }
        }
        return $result;
    }

    function getTestDetailsInfo($id)
    {

        $result = array();

        $sql = "SELECT te.id,te.type,te.dedicated_to,te.set_from,te.teacher_id,te.classification ,te.sort, te.status, te.printable, te.date_added, te.name, u.full_name AS 'user_full_name' , teacher.full_name AS 'teacher_full_name' , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " unitl.`name` as 'unit_name' , ";
        $sql .= " lessonl.`name` as 'lesson_name' , ";
        $sql .= " subjectt.`name` as 'subject_name',";
        $sql .= " subjectt.`subject_direction` as 'subject_direction'";
        $sql .= " FROM `tests` te";
        $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
        $sql .= " LEFT JOIN `users` teacher ON teacher.id = te.teacher_id ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE te.id ='{$id}' ";

        $result = $this->mDb->getRow($sql);

        if (count($result) > 0) {
            $stmt = "SELECT pl.*,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_questions` pl";
            $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
            $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '0'   order by pl.`id` ASC";
//echo $stmt;die();
            $result['test_questions'] = $this->mDb->getAll($stmt);

            if (count($result['test_questions']) > 0) {
                $qindex = 0;
                for ($ii = 0; $ii < count($result['test_questions']); $ii++) {
                    $stmto = "SELECT tqo.`id`,tqo.`title` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_question_options` tqo ";
                    $stmto .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND related_to = 'option')";
                    $stmto .= " WHERE tqo.`examine_question_id` ='{$result['test_questions'][$ii]['id']}' ";
                    $result['test_questions'][$ii]['test_question_options'] = $this->mDb->getAll($stmto);

                    if ($result['test_questions'][$ii]['type'] == 'paragraphs') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_questions` pl";
                        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqo.`id` ,tqo.`title` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `examine_question_options` tqo ";
                                $stmtosub .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND related_to = 'option')";
                                $stmtosub .= " WHERE tqo.`examine_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                    $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    //                    echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);

                                }

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                    $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    //                    echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);

                                }

                            }
                        }
                    }

                    if ($result['test_questions'][$ii]['type'] == 'complete_it') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                            }
                        }
                    }
                    if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `examine_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                            }
                        }
                    }
                    if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_manual_correct') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `examine_questions` pl";
                        $stmt .= " LEFT JOIN `examine_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id`    AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);


                    }


                    if ($result['test_questions'][$ii]['type'] == 'match_it') {
                        $stmt = "SELECT mq.*  FROM `examine_questions_match_items` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['match_questions_items'] = $this->mDb->getAll($stmt);

                    }

                    if ($result['test_questions'][$ii]['type'] == 'sort_it') {
                        $stmt = "SELECT mq.*  FROM  `examine_questions_sort_words` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['sort_questions_words'] = $this->mDb->getAll($stmt);

                    }


                    if ($result['test_questions'][$ii]['type'] != 'head_question') {
                        $qindex++;
                        $result['test_questions'][$ii]['index'] = $qindex;
                    } else {
                        $result['test_questions'][$ii]['index'] = 0;
                    }

                }

            }
        }

        return $result;
    }

    function deleteTest($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';

        $sql = "SELECT `id` FROM `examine_questions`";
        $sql .= " WHERE `id` IN " . $tempids;
        $qids = $this->mDb->getAll($sql);


        $sqll = "DELETE FROM `examine_question_options` ";
        $sqll .= " WHERE `examine_question_id`  IN " . $tempids;
        $this->mDb->query($sqll);


        $sqll2 = "DELETE FROM `examine_questions` ";
        $sqll2 .= " WHERE `id` IN " . $tempids;

        return $this->mDb->query($sqll2);
    }


    function deleteQuestion($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';

        $sql = "SELECT `test_id` FROM `examine_questions`";
        $sql .= " WHERE `id` IN " . $tempids;
        $test_id = $this->mDb->getOne($sql);


        $sqllo = "DELETE FROM `examine_question_options` ";
        $sqllo .= " WHERE `examine_question_id` IN " . $tempids;
        $this->mDb->query($sqllo);

        $sql = "DELETE  from `examine_questions`";
        $sql .= " WHERE  `parent_id`  IN " . $tempids;
        $this->mDb->query($sql);

        $sqll = "DELETE FROM `examine_questions` ";
        $sqll .= " WHERE `id` IN " . $tempids;

        // $sqll = "UPDATE `examine_questions` SET ";
        // $sqll .=" `is_deleted`='1' ";
        // $sqll .= " WHERE `id` IN ".$tempids;
        $res = $this->mDb->query($sqll);


        return $res;
    }


    function deleteSupQuestionByParent($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';


        $sql = "SELECT `test_id` FROM `examine_questions`";
        $sql .= " WHERE `id` IN " . $tempids;
        $test_id = $this->mDb->getOne($sql);


        $sql = "SELECT `id` FROM `examine_questions`";
        $sql .= " WHERE `parent_id` IN " . $tempids;
        $qids = $this->mDb->getAll($sql);

        if (count($qids) > 0) {
            for ($i = 0; $i < count($qids); $i++) {
                $sqll = "DELETE FROM `examine_question_options` ";
                $sqll .= " WHERE `examine_question_id` = '{$qids[$i]['id']}'";
                $this->mDb->query($sqll);
            }
        }


        $sqll = "DELETE FROM `examine_questions` ";
        $sqll .= " WHERE `parent_id` IN " . $tempids;


        $res = $this->mDb->query($sqll);


        // $sqll = "UPDATE `examine_questions` SET ";
        // $sqll .=" `is_deleted`='1' ";
        // $sqll .= " WHERE `parent_id` IN ".$tempids;
        // $this-> mDb-> query($sqll);

        return $res;
    }


    function deleteAttachment($request)
    {
        $sqll = "DELETE FROM `examine_question_attachments` ";
        $sqll .= " WHERE `file` = '{$request['file']}' AND `related_to` = '{$request['related_to']}'";
        // echo $sqll;die();
        $res = $this->mDb->query($sqll);

        if ($res) {
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'examine_questions/' . $request['file'];

            if (file_exists($old_img)) {
                // @unlink($old_img);
            }
        }

        return $res;
    }

    function deleteQuestionOption($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `examine_question_options` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteMatchQuestionsItem($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `examine_questions_match_items` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteSortQuestionsWord($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM  `examine_questions_sort_words` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteCompleteQuestionsWord($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `examine_questions_complete_words` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function addQuestionAttachments($question_id, $attachment, $attachment_type, $related_to, $option_id = '')
    {

        $stmtoatt = "INSERT INTO `examine_question_attachments` SET ";
        $stmtoatt .= " `question_id` = '{$question_id}', ";
        $stmtoatt .= $option_id?" `option_id` = '{$option_id}', ":"";
        $stmtoatt .= " `file` = '{$attachment}', ";
        $stmtoatt .= " `attachment_type` = '{$attachment_type}', ";
        $stmtoatt .= " `related_to` = '{$related_to}' ";
        return $this->mDb->queryreturnlastid($stmtoatt);
    }


    public function toggleActivationQuestions($temp){
        $ids = "(" . implode(",", $temp['questions']) . ")";
        
        $sql = "UPDATE `examine_questions` SET status = '{$temp['status']}' WHERE id IN " . $ids;
        // echo $sql;die();
        return $this->mDb->query($sql);
    }
} ?>