<?php

$explanationsAdminObj = new Explanations();

class Explanations {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function getSomeAdvantages($aStart, $aLimit, $sort, $type, $searchTitle) {
	$sql = "SELECT p.id, p.status, p.img, p.date_added, pl.title,  u.full_name AS 'user_full_name' FROM explanations p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `explanations_langs` pl ON p.id = pl.explanation_id ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchAdvantagesCount($sort, $type, $searchTitle) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM explanations p";
	$sql .= " LEFT JOIN `explanations_langs` pl ON p.id = pl.explanation_id ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getAdvantagesCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `explanations`";
	return $this -> mDb -> getOne($sql); 
}

function addEditExplanation($temp,$img,$video) {

    $dataLangObj = json_decode($temp['langs']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);
  

// 	var_dump($temp); die();

	$user_id = $temp['user_id'];
	$status = $temp['status'] == 'true' ? "1" : "0";
	$id = $temp['id'];

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `explanations` SET "; 
        $sql .= " `user_id` = '{$user_id}', ";
         $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
        $sql .= " `status` = '{$status}', ";
		$sql .= " `video` = '{$video}' , ";
        $sql .= " `img` = '{$img}' , ";
        $sql .= " `date_added` = '{$dateTime}' ";

		$this -> mDb -> query($sql);

		$last_page_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {
            
			$title = addslashes($value['title']);
				$meta_keywords = addslashes($value['meta_keywords']);
			$meta_title = addslashes($value['meta_title']);
			$meta_description = addslashes($value['meta_description']);
				$alt_image = addslashes($value['alt_image']);
            $stmt = "INSERT INTO `explanations_langs` SET "; 
	        $stmt .= " `explanation_id` = '{$last_page_id}', ";
	        $stmt .= " `alt_image` = '{$alt_image}', ";
	        $stmt .= " `lang_code` = '{$value['lang_code']}', ";
	         $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
	          $stmt .= " `meta_title` = '{$meta_title}', ";
	        $stmt .= " `meta_description` = '{$meta_description}', ";
	        $stmt .= " `title` = '{$title}' ";
			$res = $this -> mDb -> query($stmt); 
            
        }
	
        return $last_page_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `explanations` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `explanations` SET "; 
			$sql .= " `user_id` = '{$user_id}', ";
				$sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
         
	        $sql .= " `status` = '{$status}' ";
            if ($img != '' || $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `explanations` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'explanations/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }
            if ($video != '' && $video != null) {

                // Delete old image from the server
                $img_query = "SELECT `video` FROM `explanations` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'explanations/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`video`='{$video}' ";
            }
			$sql .= " WHERE `id` = '{$id}'"; 

		$rreess=	$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

	          $meta_title = addslashes($value['meta_title']);
                $meta_keywords = addslashes($value['meta_keywords']);
                $meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);
				$title = addslashes($value['title']);
				
	            $stmt = "UPDATE `explanations_langs` SET "; 
	            $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
		        $stmt .= " `meta_description` = '{$meta_description}', ";
		        $stmt .= " `alt_image` = '{$alt_image}', ";
		        $stmt .= " `meta_title` = '{$meta_title}', ";
		        $stmt .= " `title` = '{$title}' ";
		       
		       
		        $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `explanation_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }

          
        
        	return $rreess;
		}
	}
}

function getOnePage($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `status`, `img`, `video`,`canonical_link` FROM `explanations`";
	$sql .= " WHERE `id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql); 

    if($result){
        $stmt = "SELECT pl.`lang_code`, pl.`meta_keywords`, pl.`meta_description`,pl.`meta_title`, pl.`title`, pl.`alt_image` FROM `explanations_langs` pl";
        $stmt .= " WHERE pl.`explanation_id` = '{$id}'";
        $result['langs'] = $this -> mDb -> getAll($stmt);
    
        
        $stmt = "SELECT ai.* FROM `advantage_items` ai";
        $stmt .= " WHERE ai.`explanation_id` = '{$id}'";
        $result['advantage_items'] = $this -> mDb -> getAll($stmt);
    }
	
	return $result;

}

function deletePage($ids) {

    $oldlenth=count($ids);
// static pages can not delete them


    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `explanations_langs` ";
        $sqll.= " WHERE `page_id` IN ".$tempids;
        $this-> mDb-> query($sqll);

        $sql = "SELECT `img`,`video` FROM `explanations`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'explanations/'. $images[$i]['img'];
                $old_v= $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'explanations/'. $images[$i]['video'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
                if (file_exists($old_v)) {
                    @unlink($old_v);
                }
            }
        }

       



        $catsql = "DELETE FROM `explanations` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }

}
function deleteItems($ids) {

    $oldlenth=count($ids);
// static pages can not delete them

    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `advantage_items` ";
        $sqll.= " WHERE `id` IN ".$tempids;
        return  $this-> mDb-> query($sqll);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }
}

}?>