<?php

$FinalReviewVideosObj = new FinalReviewVideos();

use Spipu\Html2Pdf\Html2Pdf;
use Dompdf\Dompdf;
use Dompdf\Options;
class FinalReviewVideos {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function getSomeVideos($start, $aItemsPerPage, $sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$rools,$searchUnit,$searchLesson,$searchTeacherId,$searchDateFrom, $searchDateTo,$searchSource, $questionStatus) {
	$sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.type,te.sort, te.status, te.date_added, te.title, u.full_name AS 'user_full_name' , ";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " gradel.`name` as 'grade_name' , ";
    $sql .= " subjectt.`name` as 'subject_name' , ";
    $sql .= " subjectt.`subject_direction` as 'subject_direction'";
    $sql .=" FROM `final_review_videos` te";
	$sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
    $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
 
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
    $sql.= " WHERE te.id > 0 ";
    $sql.= $searchTitle ? ' AND te.title like "%'.$searchTitle.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
    $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
    $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";


    if(count($rools)>0 && $rools !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($rools) ;$ii++){
           if($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0&& $rools[$ii]['subject_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}' AND te.`subject_id` = '{$rools[$ii]['subject_id']}' )";
           }elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}'  )";
           }
           elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' )";
           }
           if($ii < (count($rools)-1)){
               $sql.=" OR ";
           }
        }
        $sql.=" )";
    }
	$sql .= " ORDER BY te.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchVideosCount($sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$searchUnit,$searchLesson,$searchTeacherId,$searchDateFrom, $searchDateTo,$searchSource, $questionStatus) {
	$sql = "SELECT COUNT(te.`id`) as 'result_count' FROM `final_review_videos` te";
	$sql .= " WHERE te.`id` > 0  ";

    $sql .= $searchTitle ? ' AND te.`title` like "%'.$searchTitle.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
    $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
    $sql.= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
   
      $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
	$sql .= " ORDER BY te.{$sort} {$type}";

// 	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getVideosCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `final_review_videos` ";
	return $this -> mDb -> getOne($sql); 
}


function getCountCommentsInVideos($data)
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `final_review_videos_comments`  WHERE `id` > 0  AND `video_id` ='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `comment` like "%' . $data['searchName'] . '%"' : '';
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

function getSearchCommentsCountVideos($video_id, $sort, $type, $searchName, $searchCountry)
    {
        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `final_review_videos_comments` c";
        $sql .= " WHERE c.`id` > 0 AND c.`video_id` ='{$video_id}' ";
        $sql .= $searchName ? ' AND c.`comment` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY c.{$sort} {$type}";
        return $this->mDb->getOne($sql);
    }

    function getSomeCommentsInVedios($video_id, $aStart, $aLimit, $sort, $type, $searchName, $searchCountry)
    {
        $sql = "SELECT * FROM `final_review_videos_comments`  WHERE `id` > 0 AND `video_id` ='{$video_id}'";
        $sql .= $searchName ? ' AND `comment` like "%' . $searchName . '%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY `sort` {$type}" : " ORDER BY `status` DESC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//  echo $sql;
        return $this->mDb->getAll($sql);
    }
    
    
function getAllCategories($type='final_review_videos',$subject_id, $branch_id) {
	$sql = "SELECT p.id, pl.title FROM `categories` p";
	$sql .= " LEFT JOIN `categories_langs` pl ON p.id = pl.`category_id` ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar' AND p.status = '1'  AND p.type = '{$type}' ";
	 $sql.= $subject_id && $subject_id>0 ? " AND p.`subject_id` = '{$subject_id}'" : "";
	 $sql.= $branch_id && $branch_id>0 ? " AND p.`branch_id` = '{$branch_id}'" : "";
	$sql .= " ORDER BY p.sort";
	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}


function getCountInquiriesInVideos($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `final_review_videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
         $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        // echo $sql;
        $res= $this->mDb->getAll($sql);
        return $res ? count($res):0;
    }

    function getSearchInquiriesCountVideos($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `final_review_videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
        $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        $res= $this->mDb->getAll($sql);
        return $res ? count($res):0;
    }

    function getSomeInquiriesInVedios($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `final_review_videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= $data['searchName'] ? ' AND  `p`.`content` like "%' . $data['searchName'] . '%"' : '';
         $sql .= $data['searchUserName'] ? ' AND  `u`.`full_name` like "%' . $data['searchUserName'] . '%"' : '';
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        $sql .= $data['aLimit'] ? " LIMIT {$data['aStart']}, {$data['aLimit']}" : '';
//  echo $sql;
        return $this->mDb->getAll($sql);
    }



    function addEditVideos($data) {

        // print_r($data['request']);die();
        // $data['request']['id'] = $data['request']['video_id'];
        $res = false;
        $data['request']['doc'] = json_decode($data['request']['doc']);
        $data['request']['video_tests'] = json_decode($data['request']['video_tests']);
        $data['request']['doc'] = $this->convert_object_to_array($data['request']['doc']);
        $data['request']['video_tests'] = $this->convert_object_to_array($data['request']['video_tests']);
        $dateTime = date('Y-m-d H:i:s');
        if (($data['request']['id'] == 'null' || $data['request']['id'] == '')&& $data['request']['operation'] === 'add') {

            $sql = "INSERT INTO `final_review_videos` SET ";
            $sql .= " `category_id` = '{$data['request']['catgory_id']}',";
            $sql .= " `country_id` = '{$data['request']['country_id']}',";
            $sql .= " `subject_id` = '{$data['request']['subject_id']}',";
             $sql .= " `branch_id` = '{$data['request']['branch_id']}',";
            $sql .= " `stage_id` = '{$data['request']['stage_id']}',";
            $sql .= " `grade_id` = '{$data['request']['grade_id']}',";
            // $sql .= " `spcialize_id` = '{$data['request']['country_id']}',";
            $sql .= " `title` = '{$data['request']['title']}',";
            $sql .= " `desc` = '{$data['request']['desc']}',";
            $sql .= " `added_by` = '{$data['request']['added_by']}',";
            $sql .= " `sort` = '{$data['request']['sort']}',";
            $sql .= " `set_from` = '{$data['request']['set_from']}',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
            $sql .= $data['request']['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
            $sql .= $data['request']['paid'] === 'true' ? " `paid` = '1'," : " `paid` = '0',";
            $sql .= " `file` = '{$data['request']['file']}',";
            $sql .= " `url_video_youtube` = '{$data['request']['url_video_youtube']}',";
            $sql .= " `time` = '{$data['request']['time']}'";
//   echo $sql;die();
            $last_id = $this->mDb->queryReturnLastId($sql);

            if ($last_id) {
                foreach ($data['request']['doc'] as $key => $value) {
                    $stmt = "INSERT INTO `videos_attachments_final_review`(`video_id`, `attach_file`,`file_size`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['file']}','{$value['size']}' )";
                    // echo $stmt;
                    $this->mDb->query($stmt);
                }
               
                foreach ($data['request']['video_tests'] as $key => $value) {
                      $_unit_id= $value['unit_id']> 0 ? $value['unit_id'] : 0;
                      $_lesson_id= $value['lesson_id']> 0 ? $value['lesson_id'] : 0;
                    $stmt = "INSERT INTO `videos_final_review_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                    $this->mDb->query($stmt);
                }
            }

            return $last_id;
        } else {

// echo "TEST";die();
            // Edit

            $check_query = "SELECT `id` FROM `final_review_videos` WHERE `id` = '{$data['request']['id']}'";
            // echo $check_query;die();
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {

                return 403;
            } else {
                $data['request']['unit_id_explain'] = $data['request']['unit_id_explain'] > 0 ? $data['request']['unit_id_explain'] : 0;
                $data['request']['lesson_id_explain'] = $data['request']['lesson_id_explain'] > 0 ? $data['request']['lesson_id_explain'] : 0;
/*                $data['request']['unit_id'] = $data['request']['unit_id'] > 0 ? $data['request']['unit_id'] : 0;
                $data['request']['lesson_id'] = $data['request']['lesson_id'] > 0 ? $data['request']['lesson_id'] : 0;*/

                $sql = "UPDATE `final_review_videos` SET ";
                $sql .= " `category_id` = '{$data['request']['catgory_id']}',";
                $sql .= " `country_id` = '{$data['request']['country_id']}',";
                $sql .= " `subject_id` = '{$data['request']['subject_id']}',";
                $sql .= " `branch_id` = '{$data['request']['branch_id']}',";
                $sql .= " `stage_id` = '{$data['request']['stage_id']}',";
                $sql .= " `grade_id` = '{$data['request']['grade_id']}',";
                // $sql .= " `spcialize_id` = '{$data['request']['country_id']}',";
                $sql .= " `title` = '{$data['request']['title']}',";
                $sql .= " `desc` = '{$data['request']['desc']}',";
                $sql .= " `type` = '{$data['request']['test_type']}',";
            //     $sql .= " `unit_id_explain` = '{$data['request']['unit_id_explain']}',";
            //   $sql .= " `lesson_id_explain` = '{$data['request']['lesson_id_explain']}',";
            //   $sql .= " `unit_id` = '{$data['request']['unit_id']}',";
            //     $sql .= " `lesson_id` = '{$data['request']['lesson_id']}',";
               /* $sql .= " `exercise_id` = '{$data['request']['exercise_id']}',";*/
                $sql .= " `added_by` = '{$data['request']['added_by']}',";
                $sql .= " `sort` = '{$data['request']['sort']}',";
                $sql .= " `set_from` = '{$data['request']['set_from']}',";
                $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
                $sql .= $data['request']['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
                // $sql .= $data['request']['paid'] === 'true' ? " `paid` = '1'," : " `paid` = '0',";
                $sql .= $data['request']['file'] ? " `file` = '{$data['request']['file']}',`time` = '{$data['request']['time']}',`url_video_youtube`=NULL, " : "";
                $sql .= $data['request']['url_video_youtube'] ? " `url_video_youtube` = '{$data['request']['url_video_youtube']}',`time` = '{$data['request']['time']}',`file` = NULL, " : "";
                $sql .= " `date_added` = '{$dateTime}'";
                $sql .= " WHERE `id` = '{$data['request']['id']}'";
                //  echo $sql;die();
                //  return true;
                $res = $this->mDb->query($sql);
                if ($res) {
                    
                    // echo $res;die();

                    if ($data['img_video'] != '' || $data['img_video'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['request']['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['request']['img_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                    if ($data['request']['file'] != '' || $data['request']['file'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['request']['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['request']['file_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                        foreach ($data['request']['doc'] as $key => $value) {
                            $stmt = "INSERT INTO `videos_attachments_final_review`(`video_id`, `attach_file`,`file_size`) ";
                            $stmt .= " VALUES ('{$data['request']['id']}', '{$value['file']}','{$value['size']}')";
                            $this->mDb->query($stmt);
                        }
                        foreach ($data['request']['video_tests'] as $key => $value) {
                          $_unit_id= $value['unit_id']> 0 ? $value['unit_id'] : 0;
                          $_lesson_id= $value['lesson_id']> 0 ? $value['lesson_id'] : 0;
                        $stmt = "INSERT INTO `videos_final_review_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                        $stmt .= " VALUES ('{$data['request']['id']}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                    //   echo $stmt;
                        $this->mDb->query($stmt);
                        }
                }


                return $res;
            }
        }
    }


    
    

    function getOneTest($id) {

	$result = array();
	$sql = "SELECT te.*,subjectt.`subject_direction` as 'subject_direction' ,subjectt.`semester` as 'subject_semester' FROM `final_review_videos` te";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
	$sql .= " WHERE te.`id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql);
	
	if($result){
	    
        $stmtosub = "SELECT tqcw.file  FROM `final_review_videos_attachments` tqcw ";
        $stmtosub .= " WHERE tqcw.`question_id` ='{$id}' AND tqcw.`question_id` AND tqcw.`related_to` = 'question'";
        $result['attachment']= $this -> mDb -> getOne($stmtosub);
        
        $stmtosubd = "SELECT tqcw.file  FROM `final_review_videos_attachments` tqcw ";
        $stmtosubd .= " WHERE tqcw.`question_id` ='{$id}' AND tqcw.`question_id` AND tqcw.`related_to` = 'answer'";
        $result['attachment_answer']= $this -> mDb -> getOne($stmtosubd);
        
        $stmtosub = "SELECT vfrt.*  FROM `videos_final_review_tests` vfrt ";
        $stmtosub .= " WHERE vfrt.`video_id` ='{$id}' ";
        $result['allVideoTests']= $this -> mDb -> getAll($stmtosub);
        
        $sql = "SELECT * FROM `videos_attachments_final_review`";
        $sql .= " WHERE `video_id` = '{$id}'";
          $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++):
            $dataFile = getFileSizeOne($res[$i]['attach_file'], 'course_videos_and_attachments');
            $res[$i]['file_size'] = $dataFile['human_file_size'];
        endfor;
        $result['allAttachVideosInCourses'] = $res;
    }

	    
	
	
	
	return $result;
}

function deleteVideo($ids) {
    
    $tempids='('.implode(',',$ids).')';
    
      $sql  = "SELECT * FROM `final_review_videos`";
      $sql .= " WHERE `id` IN ".$tempids;
      
      $res1 = $this-> mDb-> getAll($sql);
    
    if(count($res1) > 0){
        $sql2 = "DELETE FROM `final_review_videos` ";
          $sql2.= " WHERE `id` IN ".$tempids;
          $this-> mDb-> query($sql2);
      foreach($res1 as $file){
          $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'courses/' . $file['img'];

            if (file_exists($old_img)) {
                @unlink($old_img);
    	       // return true;
            }
            
            
            if($file['file']){
                
            $old_file = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'courses/' . $file['file'];

            if (file_exists($old_file)) {
                @unlink($old_file);
    	       // return true;
            }
            }
      }
    }
      $sqll  = "SELECT * FROM `videos_attachments_final_review`";
      $sqll .= " WHERE `video_id` IN ".$tempids;
    //   echo $sqll; die();
      $res2 = $this-> mDb-> getAll($sqll);
      
      if(count($res2) > 0){
          $sqll2  = "DELETE FROM `videos_attachments_final_review`";
          $sqll2 .= " WHERE `video_id` IN ".$tempids;
        //   echo $sqll2; die();
          $this-> mDb-> query($sqll2);
      
      
          foreach($res2 as $file){
          $old_attach_file = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'courses/' . $file['attach_file'];

            if (file_exists($old_attach_file)) {
                @unlink($old_attach_file);
    	       // return true;
            }
        }
      }
      
        $sqlll  = "DELETE FROM `videos_final_review_tests`";
        $sqlll .= " WHERE `video_id` IN ".$tempids;
        $this-> mDb-> query($sqlll);
      
      return true;
}







function deleteAttachment($request) {
        $sql  = "UPDATE `final_review_videos` SET `file` = '' ";
        $sql .= " WHERE `file` = '{$request['file']}'";
        // $res = $this -> mDb -> query($sql);
        $res=$this -> mDb -> query($sql);
        
        if($res){
        // echo $res;die();
             $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'final_review_attachments/' . $request['file'];

            if (file_exists($old_img)) {
                @unlink($old_img);
    	        return true;
            }
        }
    
    return false;
}




function addQuestionAttachments($question_id,$attachment,$attachment_type,$related_to) {

        $stmtoatt = "INSERT INTO `final_review_videos_attachments` SET ";
        $stmtoatt .= " `question_id` = '{$question_id}', ";
        $stmtoatt .= " `file` = '{$attachment}', ";
        $stmtoatt .= " `attachment_type` = '{$attachment_type}', ";
        $stmtoatt .= " `related_to` = '{$related_to}' ";
    return  $this -> mDb -> queryreturnlastid($stmtoatt);
}


 function deleteVideoTests($request)
    {
        $sqll = "DELETE FROM `videos_final_review_tests` ";
        $sqll .= " WHERE `id` = '{$request['id']}'";
        // echo $sqll;die();
        return  $this->mDb->query($sqll);
    }


 function deleteCommentsInVideo($ids)
    {
        // print_r($ids);die();
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "DELETE FROM `final_review_videos_comments`";
        $sql .= " WHERE `id` IN " . $tempids;
        
        // echo $sql;die();
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }


function updateCommentById($temp)
    {
        $sql  = "UPDATE `final_review_videos_comments` SET ";
        $sql .= " `status`='{$temp['status']}' ,";
        $sql .= " `comment`='{$temp['comment']}' ";
        $sql .= " WHERE `id`='{$temp['id']}' ";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }
    
    
    
    function getAllInquiriesInVideoChat($data)
    {
        $sql = "SELECT p.id,p.video_id,u.full_name AS 'user_full_name',p.user_from,p.user_to,p.date_added,p.content";
        $sql .= " FROM `final_review_videos_inquiries` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}' AND (`p`.`user_from`='{$data['user_from']}' ||  `p`.`user_to`='{$data['user_from']}')";
        $sql .= " ORDER BY date_added ASC";
        //echo $sql;
        return $this->mDb->getAll($sql);
    }

    function readInquiriesInVideoChat($data)
    {
        $sql = "UPDATE `final_review_videos_inquiries` SET ";
        $sql .= " `read_to`='1' ";
        $sql .= " WHERE video_id='{$data['video_id']}' AND `user_from`='{$data['user_from']}' AND `user_to`='{$data['user_to']}' ";
        // echo $sql;
        return $this->mDb->query($sql);
    }
    
    function addInquiriesToVideoById($items)
    {
        $sql = "INSERT INTO `final_review_videos_inquiries` SET ";
        $sql .= "`video_id`='{$items['id']}',`user_to`='{$items['user_id']}',";
        $sql .= " `user_from`='{$items['user_from']}',`read_from`='{$items['read_from']}',`content`='{$items['content']}'";
        //   echo $sql;
        return $this->mDb->queryReturnLastId($sql);
    }
    
    function getVideoInfoById($temp)
    {
        $sql = "SELECT * FROM `final_review_videos`";
        $sql.= " WHERE `id` = '{$temp['video_id']}'";
    //   echo $sql;
        return $this->mDb->getRow($sql); 
    }
    function activateCommentsInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "UPDATE `final_review_videos_comments` SET ";
        $sql .= " `status`='1' ";
        $sql .= " WHERE `id` IN " . $tempids;
        // echo $sql;die();
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }
    
    function getOneVideoComments($id)
    {
        $result = array();
        $sql = "SELECT * FROM `final_review_videos_comments`";
        $sql .= " WHERE `id` = '{$id}'";
        return $this->mDb->getRow($sql);
    }
    
    public function toggleActivationQuestions($temp){
        $ids = "(" . implode(",", $temp['questions']) . ")";
        
        $sql = "UPDATE `final_review_videos` SET status = '{$temp['status']}' WHERE id IN " . $ids;
        // echo $sql;die();
        return $this->mDb->query($sql);
    }

}?>