<?php

$gradesObj = new Grades();

class Grades {

var $mDb; 
var $mConfig; 
var $lang;

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
	$this->lang = LANGUAGE;
}

function convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__METHOD__, $data);
    }
    else {
        return $data;
    }
}

function getSomeGrades($aStart, $aLimit, $sort, $type, $searchName,$searchCountry,$searchStage) {
	
    $lang = LANGUAGE;
    $sql = "SELECT c.`id`,";
    $sql .= " cl.`name`,";
    $sql .= " gpl.`name` as 'parent_name',";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " c.`date_added`,";
    $sql .= " c.`status`,";
    $sql .= " c.`type`,";
    $sql .= " c.`sort`,";
    $sql .= " c.`img`,";
    $sql .= " u.`full_name` AS 'user_full_name'";
    $sql .= " FROM `grades` c ";
    $sql .= " LEFT JOIN `grades_langs` cl ON c.`id` = cl.`grade_id` ";
    $sql .= " LEFT JOIN `grades_langs` gpl ON ( c.`parent_id` = gpl.`grade_id`  AND gpl.`lang_code` = '{$lang}' )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '{$lang}') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( c.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = '{$lang}') ";
	$sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
	$sql .= " WHERE c.`id` > 0  AND cl.`lang_code` = '{$lang}' AND c.`is_deleted` = '0' ";
    $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND c.`stage_id` = '{$searchStage}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//	 echo $sql; die();
	return $this -> mDb -> getAll($sql); 
}

function getAllCountries($roles) {
    $lang = LANGUAGE;
    $sql = "SELECT cu.* ,";
    $sql .= " cul.`name`";
    $sql .= " FROM `countries` cu ";
    $sql .= " LEFT JOIN `countries_langs` cul ON cu.`id` = cul.`country_id` ";
	$sql .= " WHERE cu.`id` > 0  AND cul.`lang_code` = '{$lang}' ";
    // echo $sql;die();
    if($roles !='all'){
        if(count($roles)>0){
            $sql.="AND ( ";
            for ($ii=0;$ii< count($roles) ;$ii++){
                if($roles[$ii]['country_id'] > 0 ){
                    $sql.="( cu.`id` = '{$roles[$ii]['country_id']}' )";
                }
                if($ii < (count($roles)-1)){
                    $sql.=" OR ";
                }
            }
            $sql.=" )";
        }
    }

	return $this -> mDb -> getAll($sql);
}

function getStagesWithCountryId($country_id,$roles) {
	$sql = "SELECT cu.* ,";
    $sql .= " cul.`name`";
    $sql .= " FROM `stages` cu ";
    $sql .= " LEFT JOIN `stages_langs` cul ON cu.`id` = cul.`stage_id` ";
	$sql .= " WHERE cu.`id` > 0  AND cul.`lang_code` = '{$this->lang}'  AND cu.`country_id` = '{$country_id}'  AND cu.`is_deleted` = '0' ";
    if($roles !='all'){
        if(count($roles)>0){
            $sql.="AND ( ";
            for ($ii=0;$ii< count($roles) ;$ii++){
                if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 ){
                    $sql.="( cu.`country_id` = '{$roles[$ii]['country_id']}' AND cu.`id` = '{$roles[$ii]['stage_id']}' )";
                }
                if($ii < (count($roles)-1)){
                    $sql.=" OR ";
                }
            }
            $sql.=" )";
        } 
    }
//	 echo $sql; die();
	return $this -> mDb -> getAll($sql);
}
function getGradesWithStageId($stage_id,$roles) {
	$sql = "SELECT gr.* ,";
    $sql .= " grl.`name`";
    $sql .= " FROM `grades` gr ";
    $sql .= " LEFT JOIN `grades_langs` grl ON gr.`id` = grl.`grade_id` ";
	$sql .= " WHERE gr.`id` > 0  AND grl.`lang_code` = '{$this->lang}' AND gr.`stage_id` = '{$stage_id}' AND gr.`type` = 'grade' AND gr.`is_deleted` = '0' ";
    if($roles !='all'){
        if(count($roles)>0){
            $sql.="AND ( ";
            for ($ii=0;$ii< count($roles) ;$ii++){
                if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 ){
                    $sql.="( gr.`country_id` = '{$roles[$ii]['country_id']}' AND gr.`stage_id` = '{$roles[$ii]['stage_id']}' AND gr.`id` = '{$roles[$ii]['grade_id']}' )";
                }elseif ($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0){
                    $sql.="( gr.`country_id` = '{$roles[$ii]['country_id']}' AND gr.`stage_id` = '{$roles[$ii]['stage_id']}' )";
                }
                if($ii < (count($roles)-1)){
                    $sql.=" OR ";
                }
            }
            $sql.=" )";
        }
    }
//	 echo $sql; die();
   $graddes=$this -> mDb -> getAll($sql);
    if(count($graddes) > 0){
        for($ii=0;$ii<count($graddes);$ii++){
            $sqll = "SELECT gr.* ,";
            $sqll .= " grl.`name`";
            $sqll .= " FROM `grades` gr ";
            $sqll .= " LEFT JOIN `grades_langs` grl ON gr.`id` = grl.`grade_id` ";
            $sqll .= " WHERE gr.`parent_id` = '{$graddes[$ii]['id']}'  AND grl.`lang_code` = '{$this->lang}'  AND gr.`type` = 'specialize 'AND gr.`is_deleted` = '0'  ";
            $graddes[$ii]['specialties']=$this -> mDb -> getAll($sqll);
          }
        }
	return $graddes;
}

function getSubjectsWithGradeID($grade_id,$semester,$specialize_id,$roles) {
	$sql = "SELECT sub.* ";
    $sql .= " FROM `subjects` sub ";
    // $sql .= " LEFT JOIN `subjects_costs` sc ON sub.id = sc.subject_id ";
	$sql .= " WHERE sub.`id` > 0 AND sub.`grade_id` = '{$grade_id}' AND sub.`is_deleted` = '0' AND sub.`status` = '1' ";
    // $sql .=$semester ? " AND sub.`semester` = '{$semester}' " :"";
    $sql .=$specialize_id ? " AND sub.`specialize_id` = '{$specialize_id}' " :"";
    if($roles !='all'){
        if(count($roles)>0){
            $sql.="AND ( ";
            for ($ii=0;$ii< count($roles) ;$ii++){
                if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 &&$roles[$ii]['subject_id'] > 0 ){
                    $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' AND sub.`grade_id` = '{$roles[$ii]['grade_id']}' AND sub.`id` = '{$roles[$ii]['subject_id']}' )";
                }
                elseif($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 ){
                    $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' AND sub.`grade_id` = '{$roles[$ii]['grade_id']}' )";
                }elseif ($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0){
                    $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' )";
                }
                if($ii < (count($roles)-1)){
                    $sql.=" OR ";
                }
            }
            $sql.=" )";
        }
    }
    // $sql .= "AND sub.`id` NOT IN (SELECT sc.`subject_id` FROM `subjects_costs` sc WHERE sc.grade_id = '{$grade_id}')";
  	 //echo $sql; die();
	return $this -> mDb -> getAll($sql);
}

function getSubjectsWithGradeIDForCosts($grade_id,$semester,$specialize_id,$roles) {
	$sql = "SELECT sub.* ";
    $sql .= " FROM `subjects` sub ";
    // $sql .= " LEFT JOIN `subjects_costs` sc ON sub.id = sc.subject_id ";
	$sql .= " WHERE sub.`id` > 0 AND sub.`grade_id` = '{$grade_id}' AND sub.`is_deleted` = '0' AND sub.`status` = '1' ";
    // $sql .=$semester ? " AND sub.`semester` = '{$semester}' " :"";
    $sql .=$specialize_id ? " AND sub.`specialize_id` = '{$specialize_id}' " :"";
    if(count($roles)>0 && $roles !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($roles) ;$ii++){
            if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 &&$roles[$ii]['subject_id'] > 0 ){
                $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' AND sub.`grade_id` = '{$roles[$ii]['grade_id']}' AND sub.`id` = '{$roles[$ii]['subject_id']}' )";
            }
            elseif($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 ){
                $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' AND sub.`grade_id` = '{$roles[$ii]['grade_id']}' )";
            }elseif ($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0){
                $sql.="( sub.`country_id` = '{$roles[$ii]['country_id']}' AND sub.`stage_id` = '{$roles[$ii]['stage_id']}' )";
            }
            if($ii < (count($roles)-1)){
                $sql.=" OR ";
            }
        }
        $sql.=" )";
    }
    $sql .= "AND sub.`id` NOT IN (SELECT sc.`subject_id` FROM `subjects_costs` sc WHERE sc.grade_id = '{$grade_id}')";
  	 //echo $sql; die();
	return $this -> mDb -> getAll($sql);
}

function getUnitsWithSubjectID($subject_id) {
	$sql = "SELECT un.* ";
    $sql .= " FROM `units` un ";
	$sql .= " WHERE un.`id` > 0 AND un.`subject_id` = '{$subject_id}' AND un.`status` = '1' AND un.`is_deleted` = '0' AND un.`mode` ='test'  ";

//	 echo $sql; die();
	return $this -> mDb -> getAll($sql);
}

function getUnitsWithSubjectIDInSemester($subject_id,$semester) {
	$sql = "SELECT un.* ";
    $sql .= " FROM `units` un ";
	$sql .= " WHERE un.`id` > 0 AND un.`subject_id` = '{$subject_id}' AND un.`is_deleted` = '0' AND un.`mode` ='test' ";
	$sql .= $semester ?" AND un.`semester` = '{$semester}' " : "";

//echo $sql; die();
	return $this -> mDb -> getAll($sql);
}


function getUnitsWithSubjectIDWithExplanationsInSemester($subject_id,$semester) {
        $sql = "SELECT un.* ";
        $sql .= " FROM `units` un ";
        $sql .= " WHERE un.`id` > 0 AND un.`subject_id` = '{$subject_id}' AND un.`is_deleted` = '0' AND un.`mode` ='explanations' ";
        $sql .= $semester ? " AND un.`semester` = '{$semester}' " : "";

// echo $sql; die();
        return $this -> mDb -> getAll($sql);
    }
function getBanksWithSubjectID($subject_id) {
	$sql = "SELECT un.* ";
    $sql .= " FROM `questions_bank` un ";
	$sql .= " WHERE un.`id` > 0 AND un.`subject_id` = '{$subject_id}'  AND un.`is_deleted` = '0' ";

//	 echo $sql; die();
	return $this -> mDb -> getAll($sql);
}

function getLessonsWithUnitID($unit_id) {
	$sql = "SELECT un.* ";
    $sql .= " FROM `unit_lessons` un ";
	$sql .= " WHERE un.`id` > 0 AND un.`unit_id` = '{$unit_id}'  AND un.`is_deleted` = '0'";

//	 echo $sql; die();
	return $this -> mDb -> getAll($sql);
}

function getSearchGradesCount($sort, $type, $searchName,$searchCountry,$searchStage) {
	$sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `grades` c";
    $sql .= " LEFT JOIN `grades_langs` cl ON c.`id` = cl.`grade_id` ";
	$sql .= " WHERE c.`id` > 0 AND cl.`lang_code` = '{$this->lang}' AND c.`is_deleted` = '0' ";
    $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND c.`stage_id` = '{$searchStage}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getGradesCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `grades` where  `is_deleted` = '0'";
	return $this -> mDb -> getOne($sql); 
}

function addEditGrade($request, $grade_id) {

    global $ADMIN;
    $img = $Req['image'];
    $newDataLangObj = $request['languageData']; 

    // unset($request['action']);
    // unset($request['countryLangObj']);

    $res = false; 

    if ($grade_id === '' && $request['operation'] === 'add')
    {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `grades` SET ";
        $sql .= " `added_by` = '{$ADMIN['id']}',"; 
        $sql .= " `country_id` = '1',";
        $sql .= " `stage_id` = '{$request['stage_id']}',";
        $sql .= " `sort` = '{$request['sort']}',";
        $sql .= " `type` = '{$request['type']}',";
        $sql .= " `parent_id` = '{$request['parent_id']}',";
        $sql .= " `status` = '{$request['status']}',";
        $sql .= " `date_added` = '{$dateTime}',";
        $sql .= " `img` = '{$img}'";
//        echo $sql; die();
        $this -> mDb ->query($sql);
        $last_grade_id = $this -> mDb ->getLastInsertId();
        foreach ($newDataLangObj as $key => $value) {

            $stmt = "INSERT INTO `grades_langs`(`grade_id`, `lang_code`, `name`) ";
            $stmt .=" VALUES ('{$last_grade_id}', '{$key}', '{$value['title']}')";
            $res = $this -> mDb -> query($stmt);
        }
            return $res;
    }
    else
    {

        // Edit

        $check_query = "SELECT `id` FROM `grades` WHERE `id` = '{$grade_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            
            return 403;

        }
        else{
                
            $sql = "UPDATE `grades` SET ";
            $sql .= " `added_by` = '{$ADMIN['id']}', ";
            $sql .= " `country_id` = '1', ";
            $sql .= " `stage_id` = '{$request['stage_id']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= " `type` = '{$request['type']}',";
            $sql .= " `parent_id` = '{$request['parent_id']}',";
            $sql .= " `stage_id` = '{$request['stage_id']}', ";
            $sql .= " `status` = '{$request['status']}'";

            if ($img != '' && $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `grades` WHERE `id` = '{$grade_id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'grades/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }

            $sql .= " WHERE `id` = '{$grade_id}'";

//             echo $sql; die();

            $this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

                $stmt = "UPDATE `grades_langs` SET";
                $stmt .=" `name`='{$value['title']}' ";
               
                $stmt .=" WHERE `lang_code`='{$key}' AND `grade_id` = '{$grade_id}'";

                $res = $this -> mDb -> query($stmt);
                
            }

                return $res;

        } 
    }

}

function getOneGrade($id) {

    $result = array();

    $sql = "SELECT `id`, `added_by`, `status`, `img`,`country_id`,`stage_id`,`sort`,`type`,`parent_id` FROM `grades`";
    $sql .= " WHERE `id` = '{$id}' AND `is_deleted` = '0'";
    $result = $this -> mDb -> getRow($sql); 

    $stmt = "SELECT cl.`lang_code`, cl.`name` FROM `grades_langs` cl";
    $stmt .= " WHERE cl.`grade_id` = '{$id}'";
    $result['langs'] = $this -> mDb -> getAll($stmt);

    return $result;

}
function getGradeByParentID($id) {
    $result = array();
    $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `grades` c";
    $sql .= " LEFT JOIN `grades_langs` cl ON c.`id` = cl.`grade_id` ";
    $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='{$this->lang}'  AND c.`is_deleted` = '0'";
//    echo $sql;
    $result = $this -> mDb -> getAll($sql);
    return $result;

}



function deleteGrade($ids) {

    $tempids='('.implode(',',$ids).')';

//    $sql = "SELECT `img` FROM `grades`";
//    $sql .= " WHERE `id` IN ".$tempids;
//    $images = $this -> mDb -> getAll($sql);
//
//    $sqll = "DELETE FROM `grades_langs` ";
//    $sqll.= " WHERE `grade_id` IN ".$tempids;
//
//    $this-> mDb-> query($sqll);
//
//    $catsql = "DELETE FROM `grades` ";
//    $catsql.= " WHERE `id` IN ".$tempids;

    $sql = "UPDATE `grades` SET ";
    $sql .=" `is_deleted`='1' ";
    $sql .= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($sql)){

//        if(count($images)>0){
//            for ($i=0;$i<count($images);$i++){
//                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'grades/'. $images[$i]['img'];
//                if (file_exists($old_img)) {
//                    @unlink($old_img);
//                }
//            }
//        }


        return true;
    }
    else{
        return false;
    }
}






}?>