<?php

$GroupsAdminObj = new Groups(); 

class Groups {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

function getSomeGroups($aStart, $aLimit, $sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo,$searchTeacherId) {

	$sql = "SELECT o.*, ( SELECT COUNT(ggp.`id`) FROM `group_posts` ggp where ggp.group_id = o.id AND ggp.is_deleted = '0' ) as 'posts_count' ,( SELECT COUNT(gm.`id`) FROM `group_members` gm  where gm.group_id = o.id  ) as 'members_count' , ";
    $sql .= " u.`full_name` AS 'user_full_name'";
    $sql .= " FROM `groups` o ";
	$sql .= " LEFT JOIN `users` u ON u.`id` = o.`teacher_id` ";
	$sql .= " WHERE o.`id` > 0 AND o.is_deleted = '0'";
    $sql .= $searchId ? ' AND o.`id` like "%'.$searchId.'%"' : '';
    $sql.= $searchName ? ' AND o.`name` like "%'.$searchName.'%"' : '';

    $sql.= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
    $sql.= $searchTeacherId ? " AND o.`teacher_id` = '{$searchTeacherId}'" : "";
	$sql .= " ORDER BY o.`id` {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//	 echo $sql; die();
	return $this -> mDb -> getAll($sql); 
}

function getSearchGroupsCount($sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo,$searchTeacherId) {
	$sql = "SELECT COUNT(o.`id`) as 'result_count' FROM `groups` o";
    $sql .= " LEFT JOIN `users` u ON u.`id` = o.`teacher_id` ";
	$sql .= " WHERE o.`id` > 0 AND o.is_deleted = '0'";
    $sql .= $searchId ? ' AND o.`id` like "%'.$searchId.'%"' : '';
    $sql.= $searchName ? ' AND o.`name` like "%'.$searchName.'%"' : '';
    $sql.= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
    $sql.= $searchTeacherId ? " AND o.`teacher_id` = '{$searchTeacherId}'" : "";
    $sql .= " ORDER BY o.{$sort} {$type}";

//	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getGroupsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `groups` where is_deleted = '0'";
	return $this -> mDb -> getOne($sql); 
}

function getOneGroup($id) {

    $sql = "SELECT o.*, u.`full_name` AS 'user_full_name', u.`img` AS 'user_img'  FROM `groups` o";
    $sql .= " LEFT JOIN `users` u ON u.`id` = o.`teacher_id` ";
    $sql .= " WHERE o.`id` = '{$id}'";

    $res = $this -> mDb -> getRow($sql);
    if(!empty($res)){

        $sqlm = "SELECT gm.*, u.`full_name`, u.`img` , u.`mobile`   FROM `group_members` gm";
        $sqlm .= " LEFT JOIN `users` u ON u.`id` = gm.`student_id` ";
        $sqlm .= " WHERE gm.`group_id` = '{$id}'";
        $res['groupMembers']=$this -> mDb -> getAll($sqlm);

        $sqlp = "SELECT gp.*   FROM `group_posts` gp";
        $sqlp .= " WHERE gp.`group_id` = '{$id}' AND gp.`is_deleted` = '0'";
        $res['groupPosts']=$this -> mDb -> getAll($sqlp);

        if(!empty($res['groupPosts'])){
            foreach ($res['groupPosts'] as $key => $value) {
                $query = "SELECT `file`,`attachment_type` FROM `group_post_attachments`";
                $query .= " WHERE `post_id` = '{$value['id']}' ";
                $query .= " ORDER BY `id`";
                $res['groupPosts'][$key]['post_attachments'] = $this -> mDb -> getAll($query);
            }
        }

    }

//    if (!empty($res)) {
//        $stmt = "SELECT od.`id`, od.`product_id`, od.`quantity`, od.`price`, od.`amount`, pl.`name` FROM `order_details` od";
//        $stmt .= " LEFT JOIN `products_langs` pl ON pl.`product_id` = od.`product_id` ";
//        $stmt .= " WHERE od.`order_id` = '{$id}' AND pl.`lang_code`='ar' ";
//        $stmt .= " ORDER BY od.`id` ASC";
//        $res['products'] = $this -> mDb -> getAll($stmt);
//
//        if (!empty($res['products'])) {
//            foreach ($res['products'] as $key => $value) {
//                $query = "SELECT `img` FROM `product_images`";
//                $query .= " WHERE `product_id` = '{$value['product_id']}' ";
//                $query .= " ORDER BY `id` ASC LIMIT 0, 1";
//                $res['products'][$key]['img'] = $this -> mDb -> getOne($query);
//            }
//        }
//    }

    return $res;

}

function deleteOrder($ids) {
    $tempids='('.implode(',',$ids).')';

//    $sql = "delete FROM `representatives_offers`";
//    $sql .= " WHERE `order_id` IN ".$tempids;
//    $this -> mDb -> query($sql);
//
//
//    $sqll = "DELETE FROM `groups` ";
//    $sqll.= " WHERE `id` IN ".$tempids;

    $sql = "UPDATE `groups` SET ";
    $sql .=" `is_deleted`='1' ";
    $sql .= " WHERE `id` IN ".$tempids;


//    echo $sql; die();
    return $this-> mDb-> query($sql);
}

function changeOrderStatus($request) {

    // print_r($request); die();

    $res = false;

    if ($request['status'] === 'canceled') {
        // Update Status

        $sql = "UPDATE `groups` SET ";
        $sql .= " `status`='canceled', `rejected_reason`='{$request['rejected_reason']}' ";
        $sql .= " WHERE `id`='{$request['id']}' ";
        $res = $this -> mDb -> query($sql);

    }
    elseif ($request['status'] === 'ok') {
        // Update Status

        $sql = "UPDATE `groups` SET ";
        $sql .= " `status`='ok' ";
        $sql .= " WHERE `id`='{$request['id']}' ";
        $res = $this -> mDb -> query($sql);

    }
    else{
        return;
    }

    return $res;

}


}?>