<?php

$ImportantReviewsObj = new ImportantReviews();

use Spipu\Html2Pdf\Html2Pdf;
use Dompdf\Dompdf;
use Dompdf\Options;
class ImportantReviews {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function getSomeTests($aStart, $aLimit, $sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$rools,$searchUnit,$searchLesson,$searchTeacherId, $searchDateFrom, $searchDateTo,$searchSource, $questionStatus) {
	$sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.type,te.sort, te.status, te.date_added, te.title, u.full_name AS 'user_full_name' , ";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " gradel.`name` as 'grade_name' , ";
    $sql .= " unitl.`name` as 'unit_name' , ";
    $sql .= " subjectt.`name` as 'subject_name' , ";
    $sql .= " subjectt.`subject_direction` as 'subject_direction'";
    $sql .=" FROM `important_article_questions` te";
	$sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
    $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
    $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
    $sql.= " WHERE te.id > 0 ";
    $sql.= $searchTitle ? ' AND te.title like "%'.$searchTitle.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
    $sql.= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
    $sql.= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";
    $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
    $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";


    if(count($rools)>0 && $rools !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($rools) ;$ii++){
           if($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0&& $rools[$ii]['subject_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}' AND te.`subject_id` = '{$rools[$ii]['subject_id']}' )";
           }elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}'  )";
           }
           elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' )";
           }
           if($ii < (count($rools)-1)){
               $sql.=" OR ";
           }
        }
        $sql.=" )";
    }
	$sql .= " ORDER BY te.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchTestsCount($sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$searchUnit,$searchLesson,$searchTeacherId, $searchDateFrom, $searchDateTo,$searchSource, $questionStatus) {
	$sql = "SELECT COUNT(te.`id`) as 'result_count' FROM `important_article_questions` te";
	$sql .= " WHERE te.`id` > 0  ";

    $sql .= $searchTitle ? ' AND te.`title` like "%'.$searchTitle.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";
    $sql.= $questionStatus == '1' || $questionStatus == '0' ? " AND te.`status` = '{$questionStatus}'" : "";
    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
    $sql.= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
   
      $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
	$sql .= " ORDER BY te.{$sort} {$type}";

// 	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getTestsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `important_article_questions` ";
	return $this -> mDb -> getOne($sql); 
}





function getAllCategories($type='important_article_questions',$subject_id, $branch_id = null) {
	$sql = "SELECT p.id, pl.title FROM `categories` p";
	$sql .= " LEFT JOIN `categories_langs` pl ON p.id = pl.`category_id` ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar' AND p.status = '1'  AND p.type = '{$type}' ";
	 $sql.= $subject_id && $subject_id>0 ? " AND p.`subject_id` = '{$subject_id}'" : "";
	 $sql .= $branch_id ? " AND p.branch_id = '{$branch_id}' " : "";
	$sql .= " ORDER BY p.sort";
	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}




    function addEditQuestion($temp) {

        $testQ = json_decode($temp['current_quest']);
        $current_quest = $this->convert_object_to_array($testQ);
        
         $math_type_view_title = renderMathType($current_quest['title']);
   $math_type_view_answer = renderMathType($current_quest['answer']);
    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
    $math_type_view_answer = str_replace("'", "\'", $math_type_view_answer);
     
  $titlee = str_replace("'", "\'", $current_quest['title']);
    $answere = str_replace("'", "\'", $current_quest['answer']);
    
    
        $user_id = $temp['user_id'];
        $status = $temp['status'] == 'true' ? "1" : "0";
       
        $id = $temp['id'];
        
        if ($id === null || $id === ''  || ($id < 1 ) ) {
            // add
            $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `important_article_questions` SET ";
            $sql .= " `added_by` = '{$user_id}', ";
            $sql .= " `country_id` = '{$temp['country_id']}', ";
            $sql .= " `stage_id` = '{$temp['stage_id']}', ";
            $sql .= " `grade_id` = '{$temp['grade_id']}', ";
            $sql .= " `subject_id` = '{$temp['subject_id']}', ";
            $sql .= $temp['branch_id'] ? " `branch_id` = '{$temp['branch_id']}', " : "";
            $sql .= " `semester` = '{$temp['semester']}', ";
            $sql .= $temp['unit_id'] ? " `unit_id` = '{$temp['unit_id']}', ":"";
            $sql .= $temp['category_id'] && $temp['category_id'] > 0 ? " `category_id` = '{$temp['category_id']}', ":"";
           
            $sql .= $temp['specialize_id'] ?" `specialize_id` = '{$temp['specialize_id']}', ":"";
            $sql .= " `type` = '{$temp['type']}', ";

            $sql .= " `title` = '{$titlee}', ";
            $sql .= " `source` = '{$current_quest['source']}', ";
            $sql .= " `answer` = '{$answere}', ";
            $sql .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
             $sql .= $math_type_view_answer && $math_type_view_answer !=''?" `math_type_view_answer` = '{$math_type_view_answer}', ":"";
            $sql .= " `status` = '{$status}', ";
         
            $sql .= " `sort` = '{$temp['sort']}', ";
            $sql .= " `date_added` = '{$dateTime}'";
// echo $sql;
// die();
            $this -> mDb -> query($sql);
            $last_page_id = $this -> mDb -> getLastInsertId();
            
              if ($last_page_id > 0 && $current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                   $this->addQuestionAttachments($last_page_id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                }
            
             if ($last_page_id > 0 && $current_quest['attachment_answer'] != "" && $current_quest['attachment_type_answer'] != "") {
                   $this->addQuestionAttachments($last_page_id, $current_quest['attachment_answer'], $current_quest['attachment_type_answer'], 'answer');
                }
            

            return $last_page_id;
        }
        else{
            // edit
            
                $check_query = "SELECT `id` FROM `important_article_questions` WHERE `id` = '{$id}'";
                $check_result = $this -> mDb -> getOne($check_query);

                if ($check_result === false) {
                    return 403;
                }
                else{
                    $sql = "UPDATE `important_article_questions` SET ";
                    $sql .= " `added_by` = '{$user_id}', ";
                    $sql .= " `country_id` = '{$temp['country_id']}', ";
                    $sql .= " `stage_id` = '{$temp['stage_id']}', ";
                    $sql .= " `grade_id` = '{$temp['grade_id']}', ";
                    $sql .= " `subject_id` = '{$temp['subject_id']}', ";
                    $sql .= " `semester` = '{$temp['semester']}', ";
                    $sql .= $temp['branch_id'] ? " `branch_id` = '{$temp['branch_id']}', " : "";
                    $sql .= $temp['unit_id'] ? " `unit_id` = '{$temp['unit_id']}', ":"";
                    $sql .= $temp['category_id'] && $temp['category_id'] > 0 ? " `category_id` = '{$temp['category_id']}', ":"";
                    $sql .= $temp['specialize_id'] ?" `specialize_id` = '{$temp['specialize_id']}', ":"";
                    $sql .= " `type` = '{$temp['type']}', ";
                    $sql .= " `title` = '{$titlee}', ";
                     $sql .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                     $sql .= $math_type_view_answer && $math_type_view_answer !=''?" `math_type_view_answer` = '{$math_type_view_answer}', ":"";
                     $sql .= " `source` = '{$current_quest['source']}', ";
                    $sql .= " `answer` = '{$answere}', ";
                    $sql .= " `status` = '{$status}', ";
                    $sql .= " `sort` = '{$temp['sort']}' ";
                    $sql .= " WHERE `id` = '{$id}'";
                    $res=$this -> mDb -> query($sql);


                           if ($id > 0 && $current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                                $this->addQuestionAttachments($id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                                if($current_quest['file'] && $current_quest['file'] !=''){
                                    // delete old files
                                    $arr=["file"=>$testObjOp['file'],"related_to"=>"question"];
                                    $this->deleteAttachment($arr);
                                }
                            }
                            if ($id > 0 && $current_quest['attachment_note'] != "" && $current_quest['attachment_type_note'] != "") {
                                $this->addQuestionAttachments($id, $current_quest['attachment_note'], $current_quest['attachment_type_note'], 'answer');
                                if($current_quest['attachment_answer'] && $current_quest['file_answer'] !=''){
                                    // delete old files
                                    $arr=["file"=>$current_quest['attachment_answer'],"related_to"=>"answer"];
                                    $this->deleteAttachment($arr);
                                }
                            }


                    return $id;
            }
        }
    }


    
    

    function getOneTest($id) {

	$result = array();
	$sql = "SELECT te.*,subjectt.`subject_direction` as 'subject_direction' ,subjectt.`semester` as 'subject_semester', branch_id FROM `important_article_questions` te";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
	$sql .= " WHERE te.`id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql);
	
	if($result){
	    
        $stmtosub = "SELECT tqcw.file  FROM `important_article_questions_attachments` tqcw ";
        $stmtosub .= " WHERE tqcw.`question_id` ='{$id}' AND tqcw.`question_id` AND tqcw.`related_to` = 'question'";
        $result['attachment']= $this -> mDb -> getOne($stmtosub);
        
        $stmtosubd = "SELECT tqcw.file  FROM `important_article_questions_attachments` tqcw ";
        $stmtosubd .= " WHERE tqcw.`question_id` ='{$id}' AND tqcw.`question_id` AND tqcw.`related_to` = 'answer'";
        $result['attachment_answer']= $this -> mDb -> getOne($stmtosubd);
    }

	    
	
	
	
	return $result;
}

function deleteTest($ids) {
    
    $tempids='('.implode(',',$ids).')';
    
      $sqll = "DELETE FROM `important_article_questions` ";
    $sqll.= " WHERE `id` IN ".$tempids;
   return  $this-> mDb-> query($sqll);

}







function deleteAttachment($request) {

    $sqll = "DELETE FROM `important_article_questions_attachments` ";
    $sqll.= " WHERE `file` = '{$request['file']}' AND `related_to` = '{$request['related_to']}'";
   
    $res=$this-> mDb-> query($sqll);

    if($res){
        $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'important_article_questions_attachments/' . $request['file'];

        if (file_exists($old_img)) {
            @unlink($old_img);
        }
    }

	return  $res;
}




function addQuestionAttachments($question_id,$attachment,$attachment_type,$related_to) {

        $stmtoatt = "INSERT INTO `important_article_questions_attachments` SET ";
        $stmtoatt .= " `question_id` = '{$question_id}', ";
        $stmtoatt .= " `file` = '{$attachment}', ";
        $stmtoatt .= " `attachment_type` = '{$attachment_type}', ";
        $stmtoatt .= " `related_to` = '{$related_to}' ";
    return  $this -> mDb -> queryreturnlastid($stmtoatt);
}

public function toggleActivationQuestions($temp){
    $ids = "(" . implode(",", $temp['questions']) . ")";
    
    $sql = "UPDATE `important_article_questions` SET status = '{$temp['status']}' WHERE id IN " . $ids;
    
    return $this->mDb->query($sql);
}

}?>