<?php

$NewsAdmObj = new News();

class News
{

    var $mDb;
    var $mConfig;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }


    function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }
    function getSomeNews($aStart, $aLimit, $sort, $type, $searchTitle)
    {
        $sql = "SELECT p.id, p.status, p.type, p.sort, p.img, p.file, p.date_added, pl.title, u.full_name AS 'user_full_name' FROM `articles` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " LEFT JOIN `articles_langs` pl ON p.id = pl.`article_id` ";
        $sql .= " WHERE p.id > 0 AND pl.lang_code = 'ar' AND p.type = 'news'";

        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%"' : '';

        $sql .= " ORDER BY pl.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchNewsCount($sort, $type, $searchTitle)
    {
        $sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `articles` p";
        $sql .= " LEFT JOIN `articles_langs` pl ON p.id = pl.`article_id` ";
        $sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar' AND p.type = 'news' ";
        $sql .= $searchTitle ? ' AND pl.`title` like "%' . $searchTitle . '%"' : '';

        $sql .= " ORDER BY pl.{$sort} {$type}";

        //	echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getNewsCount()
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `articles` where `type` = 'news'";
        return $this->mDb->getOne($sql);
    }

    function addEditNews($temp, $req)
    {
        $img = $req['file'];
        $doc = $req['doc'];
        $dataLangObj = json_decode($temp['langs']);
        $newDataLangObj = $this->convert_object_to_array($dataLangObj);

        // 	var_dump($temp); die();

        $user_id = $temp['user_id'];
        $status = $temp['status'] == 'true' ? "1" : "0";
        $id = $temp['id'];
        $sort = $temp['sort'];
        $slug = $temp['slug'];

        if ($id < 1) {
            // add

            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `articles` SET ";
            $sql .= " `user_id` = '{$user_id}', ";
            $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
            $sql .= " `status` = '{$status}', ";
            $sql .= " `type` = 'news' ,";
            $sql .= " `sort` = '{$sort}', ";
            $sql .= " `slug` = '{$slug}', ";
            $sql .= " `category_id` = NULL, ";
            $sql .= " `date_added` = '{$dateTime}' ,";
            $sql .= " `img` = '{$img}', ";
            $sql .= " `file` = '{$doc}'";
            $this->mDb->query($sql);

            $last_page_id = $this->mDb->getLastInsertId();

            foreach ($newDataLangObj as $key => $value) {
                $description = addslashes($value['description']);
                $title = addslashes($value['title']);
                $meta_keywords = addslashes($value['meta_keywords']);
                $meta_title = addslashes($value['meta_title']);
                $meta_description = addslashes($value['meta_description']);
                $alt_image = addslashes($value['alt_image']);

                $stmt = "INSERT INTO `articles_langs` SET ";
                $stmt .= " `article_id` = '{$last_page_id}', ";
                $stmt .= " `lang_code` = '{$value['lang_code']}', ";
                $stmt .= " `title` = '{$title}', ";
                $stmt .= " `alt_image` = '{$alt_image}', ";
                $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
                $stmt .= " `meta_title` = '{$meta_title}', ";
                $stmt .= " `meta_description` = '{$meta_description}', ";
                $stmt .= " `description` = '{$description}'";

                $res = $this->mDb->query($stmt);

            }
            return $last_page_id;
        } else {
            // edit
            $check_query = "SELECT `id` FROM `articles` WHERE `id` = '{$id}'";
            $check_result = $this->mDb->getOne($check_query);
            if ($check_result === false) {
                return 403;
            } else {
                $sql = "UPDATE `articles` SET ";
                $sql .= " `user_id` = '{$user_id}', ";
                $sql .= " `category_id` = NULL, ";
                $sql .= " `sort` = '{$sort}', ";
                $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
                $sql .= " `slug` = '{$slug}', ";
                $sql .= " `status` = '{$status}' ";
                if ($img != '' && $img != null) {

                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `articles` WHERE `id` = '{$id}'";
                    $img_result = $this->mDb->getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/' . $img_result;

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $sql .= ",`img`='{$img}' ";
                }
                if ($doc != '' && $doc != null) {

                    // Delete old image from the server
                    $doc_query = "SELECT `file` FROM `articles` WHERE `id` = '{$id}'";
                    $doc_result = $this->mDb->getOne($doc_query);

                    $old_doc = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/' . $doc_result;

                    if (file_exists($old_doc)) {
                        @unlink($old_doc);
                    }

                    $sql .= ",`file`='{$doc}' ";
                }
                $sql .= " WHERE `id` = '{$id}'";

                // echo $sql;die();

                $this->mDb->query($sql);

                foreach ($newDataLangObj as $key => $value) {

                    $description = addslashes($value['description']);
                    $title = addslashes($value['title']);
                    $meta_title = addslashes($value['meta_title']);
                    $meta_keywords = addslashes($value['meta_keywords']);
                    $meta_description = addslashes($value['meta_description']);
                    $alt_image = addslashes($value['alt_image']);

                    $stmt = "UPDATE `articles_langs` SET ";
                    $stmt .= " `title` = '{$title}', ";
                    $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
                    $stmt .= " `meta_description` = '{$meta_description}', ";
                    $stmt .= " `meta_title` = '{$meta_title}', ";
                    $stmt .= " `alt_image` = '{$alt_image}', ";
                    $stmt .= " `description` = '{$description}'";
                    $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `article_id` = '{$id}' ";

                    $res = $this->mDb->query($stmt);
                }
                return $res;
            }
        }
    }

    function getOneNews($id)
    {

        $result = array();

        $sql = "SELECT `id`, `user_id`, `status`, `sort`,`slug`,`canonical_link`, `img`, `file` FROM `articles`";
        $sql .= " WHERE `id` = '{$id}'";
        $result = $this->mDb->getRow($sql);

        $stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`meta_keywords`, pl.`meta_description`,pl.`meta_title`, pl.`description` , pl.`alt_image` FROM `articles_langs` pl";
        $stmt .= " WHERE pl.`article_id` = '{$id}'";
        $result['langs'] = $this->mDb->getAll($stmt);

        return $result;

    }


    function checkIfSlugExistInNews($slug)
    {

        $sql = "SELECT `id` FROM `articles`";
        $sql .= " WHERE `slug` = '{$slug}' AND `type` = 'news'";

        return $this->mDb->getRow($sql);

    }



    function deleteNews($ids)
    {

        $oldlenth = count($ids);
        // static `articles` can not delete them


        if (count($ids) > 0) {
            $tempids = '(' . implode(',', $ids) . ')';
            $sqll = "DELETE FROM `articles_langs` ";
            $sqll .= " WHERE `article_id` IN " . $tempids;
            $this->mDb->query($sqll);

            $sql = "SELECT `img` FROM `articles`";
            $sql .= " WHERE `id` IN " . $tempids;
            $images = $this->mDb->getAll($sql);

            $sqlll = "SELECT `file` FROM `articles`";
            $sqlll .= " WHERE `id` IN " . $tempids;
            $docs = $this->mDb->getAll($sqlll);

            if (count($images) > 0) {
                for ($i = 0; $i < count($images); $i++) {
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/' . $images[$i]['img'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
            if (count($docs) > 0) {
                for ($i = 0; $i < count($docs); $i++) {
                    $old_doc = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/' . $images[$i]['file'];
                    if (file_exists($old_doc)) {
                        @unlink($old_doc);
                    }
                }
            }

            $catsql = "DELETE FROM `articles` ";
            $catsql .= " WHERE `id` IN " . $tempids;

            return $this->mDb->query($catsql);
        } else {
            if ($oldlenth > 0) {
                return 403;
            }
        }

    }

} ?>