<?php

$organizeCourseVideosObj = new OrganizeCourseVideos();

class OrganizeCourseVideos
{

    var $mDb;
    var $mConfig;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }
    
  function getCoursesData() {
    $sql = "SELECT id, img, course_id FROM videos_courses ";
    $result = $this->mDb->getAll($sql);
    return $result;
        }
function getAttachmentsByVideoId($videoId) {
   
    $sql = "SELECT id, attach_file FROM videos_attachments_courses WHERE video_id = '{$videoId}'";
    $result = $this->mDb->getAll($sql);
    return $result;
}

function organizeCourseVideos() {
    $courses = $this->getAllCourses();
    $courseIds = $this->extractIds($courses);

    foreach ($courseIds as $courseId) {
        $videos = $this->getAllFilesByCourseId($courseId);

        foreach ($videos as $video) {
            if (isset($video['id'])) {
                $attachments = $this->getAttachmentsByVideoId($video['id']);
                $this->copyCourseFiles($courseId, $attachments);
            }
        }
    }
}

function getAllCourses() {
    $sql = "SELECT id FROM courses";
    $result = $this->mDb->getAll($sql);
    return $result;
}  
function extractIds($array) {
    $ids = [];
    foreach ($array as $item) {
        if (isset($item['id'])) {
            $ids[] = $item['id'];
        }
    }
    return $ids;
}

function getAllFilesByCourseId($courseId) {
    $sql = "SELECT id FROM videos_courses WHERE course_id = '{$courseId}' AND (file_hls IS NULL OR file_hls = '')";
    $result = $this->mDb->getAll($sql);
    return $result;
}


function updateMoved($fileId, $movedStatus) {
    $sql = "UPDATE videos_attachments_courses SET moved = '{$movedStatus}' WHERE id =  '{$fileId}'";
    $this->mDb->query($sql);
}
public function updateHlsFile($courseId, $fileName, $fileHls) {
    $sql = "UPDATE videos_courses SET file_hls = '{$fileHls}' WHERE course_id = '{$courseId}' AND file = '{$fileName}'";
    if ($this->mDb->query($sql)) {
        return true;
    } else {
        error_log("Update failed: " . $this->mDb->error);
        return false;
    }
}

 public function copyCourseFiles() {
        // Define source and destination directories
        $sourceDir = $_SERVER['DOCUMENT_ROOT'] . "/uploads/course_videos_and_attachments/";

        // Step 1: Get all course data (including id, img, course_id)
        $courses = $this->getCoursesData();
        foreach ($courses as $course) {
            // Define destination directory for each course
            $destDir = $_SERVER['DOCUMENT_ROOT'] . "/uploads/course_videos_and_attachments/" . $course['course_id'] . "/";

            // Create destination directory if it doesn't exist
            if (!is_dir($destDir)) {
                mkdir($destDir, 0777, true); // Create folder with appropriate permissions
            }

            // Step 2: Copy the img file for the course
            $imgSource = $sourceDir . $course['img'];
            $imgDest = $destDir . basename($course['img']);

            // Copy img file if it exists
            if (file_exists($imgSource)) {
                if (copy($imgSource, $imgDest)) {
                    echo "Image copied successfully: " . $imgSource . "\n";
                } else {
                    echo "Failed to copy image: " . $imgSource . "\n";
                }
            } else {
                echo "Image not found: " . $imgSource . "\n";
            }

            // Step 3: Get all attachments for the course (videoId)
            $attachments = $this->getAttachmentsByVideoId($course['id']);
            foreach ($attachments as $attachment) {
                // Copy attachment file
                $attachmentSource = $sourceDir . $attachment['attach_file'];
                $attachmentDest = $destDir . basename($attachment['attach_file']);

                // Copy attachment if it exists
                if (file_exists($attachmentSource)) {
                    if (copy($attachmentSource, $attachmentDest)) {
                        echo "Attachment copied successfully: " . $attachmentSource . "\n";
                    } else {
                        echo "Failed to copy attachment: " . $attachmentSource . "\n";
                    }
                } else {
                    echo "Attachment not found: " . $attachmentSource . "\n";
                }
            }
        }
    }

function updateMove($video_id, $transfer) {
    $sql = "UPDATE videos_courses SET transfer = '{$transfer}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}

function retryFailedMoves() {
    $sql = "SELECT DISTINCT course_id FROM videos_courses WHERE transfer ='0'";
    $courseIds = $this->mDb->getAll($sql);
    $courseIdsArray = array_column($courseIds, 'course_id');
    foreach ($courseIdsArray as $courseId) {
        $files = $this->getAllFilesByCourseId($courseId);
        if (!empty($files)) {
            $this->copyCourseFiles($courseId, $files);
        }
    }
}
    
    
    
}