<?php

$pagesObj = new pages(); 

class pages {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
function getSomePages($aStart, $aLimit, $sort, $type, $searchTitle) {
	$sql = "SELECT p.id, p.status, p.disabled, p.img, p.date_added, pl.title, pl.sub_title, u.full_name AS 'user_full_name' FROM pages p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `pages_langs` pl ON p.id = pl.page_id ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchPagesCount($sort, $type, $searchTitle) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM pages p";
	$sql .= " LEFT JOIN `pages_langs` pl ON p.id = pl.page_id ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getPagesCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `pages`";
	return $this -> mDb -> getOne($sql); 
}

function addEditPage($temp) {

global $ADMIN;
// print_r($temp);die();
    $img = $temp['image'];
    $newDataLangObj = $temp['langs'];

	$user_id = $temp['user_id'];
	
// 	$status = $temp['status'] == 'true' ? "1" : "0";
    $status = $temp['status'];
	$id = $temp['id'];

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `pages` SET "; 
        $sql .= " `user_id` = '{$ADMIN['id']}', ";
          $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
        $sql .= " `status` = '{$status}', ";
		$sql .= " `date_added` = '{$dateTime}' ,";
        $sql .= " `img` = '{$img}'";

		$this -> mDb -> query($sql);

		$last_page_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {
            $description = addslashes($value['description']);
			$title = addslashes($value['title']);
			$sub_title = addslashes($value['sub_title']);
			$meta_keywords = addslashes($value['meta_keywords']);
			$meta_title = addslashes($value['meta_title']);
			$alt_image = addslashes($value['alt_image']);
			$meta_description = addslashes($value['meta_description']);

            $stmt = "INSERT INTO `pages_langs` SET "; 
	        $stmt .= " `page_id` = '{$last_page_id}', ";
	        $stmt .= " `lang_code` = '{$key}', ";
	        $stmt .= " `title` = '{$title}', ";
	        $stmt .= " `sub_title` = '{$sub_title}', ";
	        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
	        $stmt .= " `alt_image` = '{$alt_image}', ";
	        $stmt .= " `meta_description` = '{$meta_description}', ";
	         $stmt .= " `meta_title` = '{$meta_title}', ";
	        $stmt .= " `description` = '{$description}'";
			$res = $this -> mDb -> query($stmt); 
            
        }
        return $last_page_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `pages` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `pages` SET "; 
			$sql .= " `user_id` = '{$ADMIN['id']}', ";
			$sql .= " `canonical_link` = '{$temp['canonical_link']}', ";

	        $sql .= " `status` = '{$status}' ";
            if ($img != '' || $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `pages` WHERE `id` = '{$id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'pages/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img`='{$img}' ";
            }
			$sql .= " WHERE `id` = '{$id}'"; 

			$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

	            $description = addslashes($value['description']);
				$title = addslashes($value['title']);
				$sub_title = addslashes($value['sub_title']);
				$meta_keywords = addslashes($value['meta_keywords']);
                $meta_description = addslashes($value['meta_description']);
                  $meta_title = addslashes($value['meta_title']);
            	$alt_image = addslashes($value['alt_image']);
            	
	            $stmt = "UPDATE `pages_langs` SET "; 
		        $stmt .= " `title` = '{$title}', ";
		        $stmt .= " `sub_title` = '{$sub_title}', ";
		        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
		         $stmt .= " `meta_title` = '{$meta_title}', ";
		        $stmt .= " `meta_description` = '{$meta_description}', ";
		        $stmt .= " `alt_image` = '{$alt_image}', ";
		        $stmt .= " `description` = '{$description}'";
		        $stmt .= " WHERE `lang_code`='{$key}' AND `page_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }
        	return $res;
		}
	}
}

function getOnePage($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `status`,`canonical_link`, `img` FROM `pages`";
	$sql .= " WHERE `id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql); 

	$stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`sub_title`, pl.`meta_keywords`, pl.`meta_title`, pl.`meta_description`, pl.`description` , pl.`alt_image` FROM `pages_langs` pl";
	$stmt .= " WHERE pl.`page_id` = '{$id}'";
	$result['langs'] = $this -> mDb -> getAll($stmt);

	return $result;

}

function deletePage($ids) {

    $oldlenth=count($ids);
// static pages can not delete them
    foreach ($ids as $key => $iid) {
        if($iid == '14' ||$iid == '15'||$iid == '16'||$iid == '17'||$iid == '18' || $iid == '1' ||$iid == '7'||$iid == '8'||$iid == '9' ||$iid == '12') {
            unset($ids[$key]);
        }
    }

    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `pages_langs` ";
        $sqll.= " WHERE `page_id` IN ".$tempids;
        $this-> mDb-> query($sqll);

        $sql = "SELECT `img` FROM `pages`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'pages/'. $images[$i]['img'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
        }

        $catsql = "DELETE FROM `pages` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }

}


}?>