<?php

$PagesStaticAdmObj = new PagesStatic();

class PagesStatic
{

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
function getSomePagesStatic($aStart, $aLimit, $sort, $type, $searchTitle) {
	$sql = "SELECT p.id, p.status,  p.date_added, pl.title, u.full_name AS 'user_full_name' FROM `pages_static` p";
	$sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
	$sql .= " LEFT JOIN `pages_static_langs` pl ON p.id = pl.`page_id` ";
	$sql.= " WHERE p.id > 0 AND pl.lang_code = 'ar'";

    $sql.= $searchTitle ? ' AND pl.title like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

	// echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchPagesStaticCount($sort, $type, $searchTitle) {
	$sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `pages_static` p";
	$sql .= " LEFT JOIN `pages_static_langs` pl ON p.id = pl.`page_id` ";
	$sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar'";

    $sql .= $searchTitle ? ' AND pl.`title` like "%'.$searchTitle.'%"' : '';

	$sql .= " ORDER BY pl.{$sort} {$type}";

// 	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getPagesStaticCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `pages_static`";
	return $this -> mDb -> getOne($sql); 
}

function addEditPageStatic($temp) {

    $dataLangObj = json_decode($temp['langs']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);

// 	var_dump($temp); die();

	$user_id = $temp['user_id'];
	$status = $temp['status'] == 'true' ? "1" : "0";
	$id = $temp['id'];

	if ($id  < 1) {
		// add

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `pages_static` SET "; 
        $sql .= " `user_id` = '{$user_id}', ";
         $sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
        $sql .= " `status` = '{$status}', ";
		$sql .= " `date_added` = '{$dateTime}' ";
    //  	echo $sql; die();
		$this -> mDb -> query($sql);

		$last_page_id = $this -> mDb -> getLastInsertId();

		foreach ($newDataLangObj as $key => $value) {
          
			$title = addslashes($value['title']);
			$meta_keywords = addslashes($value['meta_keywords']);
				$meta_title = addslashes($value['meta_title']);
			$meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);
	
            $stmt = "INSERT INTO `pages_static_langs` SET "; 
	        $stmt .= " `page_id` = '{$last_page_id}', ";
	        $stmt .= " `lang_code` = '{$value['lang_code']}', ";
	         $stmt .= " `alt_image` = '{$alt_image}', ";
	        $stmt .= " `title` = '{$title}', ";
	        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
	         $stmt .= " `meta_title` = '{$meta_title}', ";
	        $stmt .= " `meta_description` = '{$meta_description}' ";
	       

			$res = $this -> mDb -> query($stmt); 
            
        }
        return $last_page_id;
	}
	else{
		// edit
		$check_query = "SELECT `id` FROM `pages_static` WHERE `id` = '{$id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
			$sql = "UPDATE `pages_static` SET "; 
			$sql .= " `user_id` = '{$user_id}', ";
				$sql .= " `canonical_link` = '{$temp['canonical_link']}', ";
	        $sql .= " `status` = '{$status}' ";
          
			$sql .= " WHERE `id` = '{$id}'"; 

			$this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

	          
				$title = addslashes($value['title']);
                $meta_keywords = addslashes($value['meta_keywords']);
                $meta_title = addslashes($value['meta_title']);
                $meta_description = addslashes($value['meta_description']);
	$alt_image = addslashes($value['alt_image']);

                $stmt = "UPDATE `pages_static_langs` SET ";
		        $stmt .= " `title` = '{$title}', ";
		        $stmt .= " `meta_keywords` = '{$meta_keywords}', ";
		        $stmt .= " `meta_title` = '{$meta_title}', ";
		        $stmt .= " `alt_image` = '{$alt_image}', ";
		        $stmt .= " `meta_description` = '{$meta_description}' ";
		       
		        $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `page_id` = '{$id}' ";

				$res = $this -> mDb -> query($stmt);
	        }
        	return $res;
		}
	}
}

function getOneArticle($id) {

	$result = array();

	$sql = "SELECT `id`, `user_id`, `status`,`canonical_link` FROM `pages_static`";
	$sql .= " WHERE `id` = '{$id}'";

	$result = $this -> mDb -> getRow($sql); 

	$stmt = "SELECT pl.`lang_code`, pl.`title`, pl.`meta_keywords`, pl.`meta_title`, pl.`meta_description`, pl.`alt_image` FROM `pages_static_langs` pl";
	$stmt .= " WHERE pl.`page_id` = '{$id}'";
	$result['langs'] = $this -> mDb -> getAll($stmt);

	return $result;

}

function deletePage($ids) {

    $oldlenth=count($ids);
// static `pages_static_langs` can not delete them
   

    if(count($ids)>0){
        $tempids='('.implode(',',$ids).')';
        $sqll = "DELETE FROM `pages_static_langs` ";
        $sqll.= " WHERE `page_id` IN ".$tempids;
        $this-> mDb-> query($sqll);


        $catsql = "DELETE FROM `pages_static` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        return  $this-> mDb-> query($catsql);
    }else{
        if($oldlenth > 0){
            return 403;
        }
    }

}


}?>