<?php

$PrintableDataObj = new PrintableData();

class PrintableData {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

function convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__METHOD__, $data);
    }
    else {
        return $data;
    }
}

function getSomePrintableData($aStart, $aLimit, $sort, $type, $searchName,$searchCountry,$searchStage) {
	$sql = "SELECT c.`id`,";
    $sql .= " cl.`name`,";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " gradel.`name` as 'grade_name',";
    $sql .= " c.`date_added`,";
    $sql .= " c.`status`,";
    $sql .= " c.`sort`,";
    $sql .= " u.`full_name` AS 'user_full_name'";
    $sql .= " FROM `printable_data` c ";
    $sql .= " LEFT JOIN `printable_data_langs` cl ON c.`id` = cl.`printable_data_id` ";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( c.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `grades_langs` gradel ON  ( c.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar') ";
	$sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
	$sql .= " WHERE c.`id` > 0  AND cl.`lang_code` = 'ar' AND c.`is_deleted` = '0' ";
    $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND c.`stage_id` = '{$searchStage}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql; die();
	return $this -> mDb -> getAll($sql); 
}

function getAllCountries($roles) {
	$sql = "SELECT cu.* ,";
    $sql .= " cul.`name`";
    $sql .= " FROM `countries` cu ";
    $sql .= " LEFT JOIN `countries_langs` cul ON cu.`id` = cul.`country_id` ";
	$sql .= " WHERE cu.`id` > 0  AND cul.`lang_code` = 'ar' ";
    if(count($roles)>0 && $roles !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($roles) ;$ii++){
            if($roles[$ii]['country_id'] > 0 ){
                $sql.="( cu.`id` = '{$roles[$ii]['country_id']}' )";
            }
            if($ii < (count($roles)-1)){
                $sql.=" OR ";
            }
        }
        $sql.=" )";
    }
	return $this -> mDb -> getAll($sql);
}

function getStagesWithCountryId($country_id,$roles) {
	$sql = "SELECT cu.* ,";
    $sql .= " cul.`name`";
    $sql .= " FROM `stages` cu ";
    $sql .= " LEFT JOIN `stages_langs` cul ON cu.`id` = cul.`stage_id` ";
	$sql .= " WHERE cu.`id` > 0  AND cul.`lang_code` = 'ar'  AND cu.`country_id` = '{$country_id}'  AND cu.`is_deleted` = '0' ";
    if(count($roles)>0 && $roles !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($roles) ;$ii++){
            if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 ){
                $sql.="( cu.`country_id` = '{$roles[$ii]['country_id']}' AND cu.`id` = '{$roles[$ii]['stage_id']}' )";
            }
            if($ii < (count($roles)-1)){
                $sql.=" OR ";
            }
        }
        $sql.=" )";
    }
//	 echo $sql; die();
	return $this -> mDb -> getAll($sql);
}
function getGradesWithStageId($stage_id,$roles) {
	$sql = "SELECT gr.* ,";
    $sql .= " grl.`name`";
    $sql .= " FROM `grades` gr ";
    $sql .= " LEFT JOIN `grades_langs` grl ON gr.`id` = grl.`grade_id` ";
	$sql .= " WHERE gr.`id` > 0  AND grl.`lang_code` = 'ar' AND gr.`stage_id` = '{$stage_id}' AND gr.`type` = 'grade' AND gr.`is_deleted` = '0' ";
    if(count($roles)>0 && $roles !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($roles) ;$ii++){
            if($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0 &&$roles[$ii]['grade_id'] > 0 ){
                $sql.="( gr.`country_id` = '{$roles[$ii]['country_id']}' AND gr.`stage_id` = '{$roles[$ii]['stage_id']}' AND gr.`id` = '{$roles[$ii]['grade_id']}' )";
            }elseif ($roles[$ii]['country_id'] > 0 &&$roles[$ii]['stage_id'] > 0){
                $sql.="( gr.`country_id` = '{$roles[$ii]['country_id']}' AND gr.`stage_id` = '{$roles[$ii]['stage_id']}' )";
            }
            if($ii < (count($roles)-1)){
                $sql.=" OR ";
            }
        }
        $sql.=" )";
    }
//	 echo $sql; die();
   $graddes=$this -> mDb -> getAll($sql);
    if(count($graddes) > 0){
        for($ii=0;$ii<count($graddes);$ii++){
            $sqll = "SELECT gr.* ,";
            $sqll .= " grl.`name`";
            $sqll .= " FROM `grades` gr ";
            $sqll .= " LEFT JOIN `grades_langs` grl ON gr.`id` = grl.`grade_id` ";
            $sqll .= " WHERE gr.`parent_id` = '{$graddes[$ii]['id']}'  AND grl.`lang_code` = 'ar'  AND gr.`type` = 'specialize 'AND gr.`is_deleted` = '0'  ";
            $graddes[$ii]['specialties']=$this -> mDb -> getAll($sqll);
          }
        }
	return $graddes;
}







function getSearchPrintableDataCount($sort, $type, $searchName,$searchCountry,$searchStage) {
	$sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `printable_data` c";
    $sql .= " LEFT JOIN `printable_data_langs` cl ON c.`id` = cl.`printable_data_id` ";
	$sql .= " WHERE c.`id` > 0 AND cl.`lang_code` = 'ar' AND c.`is_deleted` = '0' ";
    $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND c.`stage_id` = '{$searchStage}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getPrintableDataCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `printable_data`  where  `is_deleted` = '0'";
// 	echo  $sql;
	return $this -> mDb -> getOne($sql); 
}

function addEditPrintableData($request, $printable_data_id) {

    $printableDataLangObj = json_decode($request['printableDataLangObj']);
    $newDataLangObj = $this->convert_object_to_array($printableDataLangObj);

    unset($request['action']);
    unset($request['countryLangObj']);

    $res = false; 
// print_r($request);
    if ($printable_data_id === '' && $request['operation'] === 'add')
    {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `printable_data` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',"; 
        $sql .= " `country_id` = '{$request['country_id']}',";
        $sql .= " `stage_id` = '{$request['stage_id']}',";
        $sql .= " `sort` = '{$request['sort']}',";
        $sql .= " `grade_id` = '{$request['grade_id']}',";
        $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}' ";
    //   echo $sql; die();
        $this -> mDb ->query($sql);
        $last_printable_data_id = $this -> mDb ->getLastInsertId();
        foreach ($newDataLangObj as $key => $value) {

            $stmt = "INSERT INTO `printable_data_langs`(`printable_data_id`, `lang_code`, `name`) ";
            $stmt .=" VALUES ('{$last_printable_data_id}', '{$value['lang_code']}', '{$value['name']}')";
            //  echo $stmt;
            $res = $this -> mDb -> query($stmt);
        }
            return $res;
    }
    else
    {

        // Edit

        $check_query = "SELECT `id` FROM `printable_data` WHERE `id` = '{$printable_data_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            
            return 403;

        }
        else{
                
            $sql = "UPDATE `printable_data` SET ";
            $sql .= " `added_by` = '{$request['added_by']}', ";
            $sql .= " `country_id` = '{$request['country_id']}', ";
            $sql .= " `stage_id` = '{$request['stage_id']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= " `grade_id` = '{$request['grade_id']}',";
            $sql .= " `stage_id` = '{$request['stage_id']}', ";
            $sql .= $request['status'] === 'true' ? " `status` = '1'" : " `status` = '0'";

          

            $sql .= " WHERE `id` = '{$printable_data_id}'";

//             echo $sql; die();

            $this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {

                $stmt = "UPDATE `printable_data_langs` SET";
                $stmt .=" `name`='{$value['name']}' ";
               
                $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `printable_data_id` = '{$printable_data_id}'";

                $res = $this -> mDb -> query($stmt);
                
            }

                return $res;

        } 
    }

}

function getOnePrintableData($id) {

    $result = array();

    $sql = "SELECT `id`, `added_by`, `status`, `country_id`,`stage_id`,`sort`,`grade_id` FROM `printable_data`";
    $sql .= " WHERE `id` = '{$id}' AND `is_deleted` = '0'";
    $result = $this -> mDb -> getRow($sql); 

    $stmt = "SELECT cl.`lang_code`, cl.`name` FROM `printable_data_langs` cl";
    $stmt .= " WHERE cl.`printable_data_id` = '{$id}'";
    $result['langs'] = $this -> mDb -> getAll($stmt);

    return $result;

}




function deletePrintableData($ids) {

    $tempids='('.implode(',',$ids).')';


    $sql = "UPDATE `printable_data` SET ";
    $sql .=" `is_deleted`='1' ";
    $sql .= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($sql)){




        return true;
    }
    else{
        return false;
    }
}






}?>