<?php

$QuestionsBankObj = new QuestionsBank();

class QuestionsBank
{

    var $mDb;
    var $mConfig;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    function getSomeTests($aStart, $aLimit, $sort, $type, $searchTitle, $searchQuestion, $searchCountry, $searchStage, $searchGrade, $searchSubject, $rools, $searchUnit, $searchLesson)
    {
        $sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.sort, te.status, te.date_added, te.name, u.full_name AS 'user_full_name' , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " subjectt.`subject_direction` as 'subject_direction' ,";
        $sql .= " subjectt.`name` as 'subject_name'";
        $sql .= " FROM `questions_bank` te";
        $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= $searchQuestion && $searchQuestion != '' ? " LEFT JOIN `questions_bank_questions` tes_quest ON (te.`id` = tes_quest.`questions_bank_id`)" : "";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";

        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE te.id > 0 AND te.`is_deleted` = '0'";
        $sql .= $searchTitle ? ' AND te.name like "%' . $searchTitle . '%"' : '';
        $sql .= $searchQuestion ? ' AND tes_quest.title like "%' . $searchQuestion . '%"' : '';
        $sql .= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";

        $sql .= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";


        if (count($rools) > 0 && $rools != 'all') {
            $sql .= "AND ( ";
            for ($ii = 0; $ii < count($rools); $ii++) {
                if ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0 && $rools[$ii]['grade_id'] > 0 && $rools[$ii]['subject_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}' AND te.`subject_id` = '{$rools[$ii]['subject_id']}' )";
                } elseif ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0 && $rools[$ii]['grade_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}'  )";
                } elseif ($rools[$ii]['country_id'] > 0 && $rools[$ii]['stage_id'] > 0) {
                    $sql .= "( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' )";
                }
                if ($ii < (count($rools) - 1)) {
                    $sql .= " OR ";
                }
            }
            $sql .= " )";
        }
        $sql .= $searchQuestion ? " GROUP BY te.id " : "";
        $sql .= " ORDER BY te.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchTestsCount($sort, $type, $searchTitle, $searchQuestion, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchUnit, $searchLesson)
    {
        $sql = "SELECT COUNT(te.`id`) as 'result_count' FROM `questions_bank` te";
        $sql .= " WHERE te.`id` > 0 AND te.`is_deleted` = '0'";

        $sql .= $searchTitle ? ' AND te.`name` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";

        $sql .= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
        $sql .= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";

        $sql .= " ORDER BY te.{$sort} {$type}";

//	echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getTestsCount()
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `questions_bank` WHERE  `is_deleted` = '0'";
        return $this->mDb->getOne($sql);
    }

    function addEditQuestion($temp)
    {
        $testQ = json_decode($temp['current_quest']);
        $current_quest = $this->convert_object_to_array($testQ);

        $questid = $current_quest['id'];
        if ($questid === null || $questid === '' || ($questid < 1)) {
            // add
            $dateTime = date('Y-m-d H:i:s');

            $last_page_id = $temp['current_question_bank_id'];
            if ($last_page_id > 0) {

                $title = $current_quest['title'];
                $type = $current_quest['type'];
                    $check_queryy = "SELECT `id` FROM `questions_bank_questions` WHERE `questions_bank_id` = '{$last_page_id}' AND `title` = '{$title}'";
                    $check_resulty = $this->mDb->getOne($check_queryy);

                    if ($check_resulty === false) {
                        $id = $this->InsertIntoBankQuestions($last_page_id, $type, $current_quest['source'], $current_quest['degree'], $title, '', $current_quest['note'],$current_quest['answer_form']);
                        if ($id > 0 && count($current_quest['test_question_options']) > 0) {
                            for ($ii = 0; $ii < count($current_quest['test_question_options']); $ii++) {
                                $nObj = $current_quest["test_question_options"][$ii];
                                $statuss = $nObj['status'] == 'true' ? "1" : "0";
                                $option_id = $this->InsertIntoTestQuestionOptions($id, $nObj['title'], $statuss, $nObj['note']);
                                if ($option_id > 0 && $nObj['attachment'] != "" && $nObj['attachment_type'] != "") {
                                    $this->addQuestionAttachments($id, $nObj['attachment'], $nObj['attachment_type'], 'option', $option_id);
                                }
                                if ($option_id > 0 && $nObj['attachment_note'] != "" && $nObj['attachment_type_note'] != "") {
                                    $this->addQuestionAttachments($id, $nObj['attachment_note'], $nObj['attachment_type_note'], 'note', $option_id);
                                }
                            }
                        }
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                            $this->addQuestionAttachments($id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                        }

                        if ($id > 0 && $current_quest['type'] == 'paragraphs') {
                            for ($idsub = 0; $idsub < count($current_quest['question_sub_questions']); $idsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$idsub];
                                $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);
                                if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                        $nObjff = $subquestion["test_question_options"][$iirr];
                                        $statuss = $nObjff['status'] == 'true' ? "1" : "0";
                                        $sub_option_id = $this->InsertIntoTestQuestionOptions($idqsub, $nObjff['title'], $statuss, $nObjff['note']);
                                        if ($sub_option_id > 0 && $nObjff['attachment'] != "" && $nObjff['attachment_type'] != "") {
                                            $this->addQuestionAttachments($idqsub, $nObjff['attachment'], $nObjff['attachment_type'], 'option', $sub_option_id);
                                        }
                                        if ($sub_option_id > 0 && $nObjff['attachment_note'] != "" && $nObjff['attachment_type_note'] != "") {
                                            $this->addQuestionAttachments($idqsub, $nObjff['attachment_note'], $nObjff['attachment_type_note'], 'note', $sub_option_id);
                                        }
                                    }
                                }
                                if ($idqsub > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                    $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                }


                                if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                        $nObjff = $subquestion["match_questions_items"][$iirr];

                                        $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                    }
                                }

                                if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                        $nObjff = $subquestion["sort_questions_words"][$iirr];
                                        $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                    }
                                }
                            }
                        }
                        
                    //       if (($id > 0 && $current_quest['type'] == 'complete_it') || ($id > 0 && $current_quest['type'] == 'complete_it_writing_auto_correct') || $id > 0 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                    //     for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                    //         $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                    //         $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note'], 'long', '', '');
                    //     //   echo '<pre>';
                    //     //             print_r($subquestion['test_questions_complete_words']);
                    //     //             echo '</pre>';
                    //         if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                    //             for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                    //                 $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                    //                 $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                    //             }
                    //         }
                    //     }
                    // }

                        if ($id > 0 && $current_quest['type'] == 'complete_it') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);
                                if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                        $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                    }
                                }
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'complete_it_writing_auto_correct') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);
                                if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                    for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                        $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                    }
                                }
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                            for ($dsubcom = 0; $dsubcom < count($current_quest['question_sub_questions']); $dsubcom++) {
                                $subquestion = $current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);

                            }
                        } 

                        if ($id > 0 && $current_quest['type'] == 'match_it') {
                            for ($mdsubm = 0; $mdsubm < count($current_quest['match_questions_items']); $mdsubm++) {
                                $subquestion = $current_quest['match_questions_items'][$mdsubm];

                                $this->InsertIntoMatchQuestionItems($id, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                            }
                        }
                        if ($id > 0 && $current_quest['type'] == 'sort_it') {
                            for ($sdsubs = 0; $sdsubs < count($current_quest['sort_questions_words']); $sdsubs++) {
                                $subquestion = $current_quest['sort_questions_words'][$sdsubs];
                                $this->InsertIntoSortQuestionWords($id, $subquestion['title'], $subquestion['word_index']);
                            }
                        }
                    }
            }
            return $this->getOneQuestion($id);
        } else {
            // edit
            $check_query = "SELECT `id` FROM `questions_bank_questions` WHERE `id` = '{$questid}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {
                return 403;
            } else {
                $question_bank_id = $temp['current_question_bank_id'];

                if ($questid > 0 && $question_bank_id > 0) {
                    if ($questid >= 1) {
                        $answer_form_origin = $current_quest['answer_form'];
                        $answer_form = renderMathType($current_quest['answer_form']);
                        $math_type_view_title = renderMathType($current_quest['title']);
                        $math_type_view_note = renderMathType($current_quest['note']);
                        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                        $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
                        $answer_form_origin = str_replace("'", "\'", $answer_form_origin);
                        $answer_form = str_replace("'", "\'", $answer_form);

                        $stmtq = "UPDATE `questions_bank_questions` SET ";
                        $stmtq .= " `type` = '{$current_quest['type']}', ";
                        $stmtq .= " `source` = '{$current_quest['source']}', ";
                        $stmtq .= " `note` = '{$current_quest['note']}', ";
                        $stmtq .= " `answer_form` = '{$answer_form}', ";
                       $stmtq .= " `answer_form_origin` = '{$answer_form_origin}', ";
                        $stmtq .= " `degree` = '{$current_quest['degree']}', ";
                        $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                        $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                        $stmtq .= " `title` = '{$current_quest['title']}' ";
                        $stmtq .= " WHERE `id`='{$questid}' AND `questions_bank_id` = '{$question_bank_id}' ";
                        $this->mDb->query($stmtq);
                        if (count($current_quest['test_question_options']) > 0) {
                            foreach ($current_quest['test_question_options'] as $testObjOp) {
                                $statuss = $testObjOp['status'] == 'true' ? "1" : "0";
                                if ( $testObjOp['id'] < 1) {
                                    $option_id = $this->InsertIntoTestQuestionOptions($questid, $testObjOp['title'], $statuss, $testObjOp['note']);
                                    if ($option_id > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $option_id);
                                    }
                                    if ($option_id > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $option_id);
                                    }


                                } elseif ( $testObjOp['id'] >= 1) {
                                    $math_type_view_title = renderMathType($testObjOp['title']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                    $stmtqup = "UPDATE `questions_bank_options` SET ";
                                    $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                    $stmtqup .= " `status` = '{$statuss}', ";
                                    $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtqup .= " `note` = '{$testObjOp['note']}' ";
                                    $stmtqup .= " WHERE `id`='{$testObjOp['id']}' AND `question_bank_id` = '{$questid}' ";
                                    $this->mDb->query($stmtqup);
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                        if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                        if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                            // delete old files
                                            $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                }
                            }
                        }
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                            $this->addQuestionAttachments($questid, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                            if ($current_quest['file'] && $current_quest['file'] != '') {
                                // delete old files if exist
                                $arr = ["file" => $current_quest['file'], "related_to" => "question"];
                                $this->deleteAttachment($arr);
                            }
                        }

                        if ($questid >= 1 && $current_quest['type'] == 'paragraphs') {
                            for ($idsub = 0; $idsub < count($current_quest['question_sub_questions']); $idsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$idsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub = $this->InsertIntoBankQuestions($question_bank_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $questid, $subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                            $subquestionoption = $subquestion["test_question_options"][$iirr];
                                            $titleo = $subquestionoption['title'];
                                            $statuss = $subquestionoption['status'] == 'true' ? "1" : "0";
                                            $note = $subquestionoption['note'];
                                            $subqoption = $this->InsertIntoTestQuestionOptions($idqsub, $titleo, $statuss, $note);
                                            if ($subqoption > 0 && $subquestionoption['attachment'] != "" && $subquestionoption['attachment_type'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment'], $subquestionoption['attachment_type'], 'option', $subqoption);
                                                if ($subquestionoption['file'] && $subquestionoption['file'] != '') {
                                                    // delete old files
                                                    $arr = ["file" => $subquestionoption['file'], "related_to" => "option"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                            if ($subquestionoption['id'] > 0 && $subquestionoption['attachment_note'] != "" && $subquestionoption['attachment_type_note'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment_note'], $subquestionoption['attachment_type_note'], 'note', $subqoption);
                                                if ($subquestionoption['file_note'] && $subquestionoption['file_note'] != '') {
                                                    // delete old files
                                                    $arr = ["file" => $subquestionoption['file_note'], "related_to" => "note"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                        }
                                    }
                                    if ($idqsub > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if ($subquestion['file'] && $subquestion['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $subquestion['file'], "related_to" => "question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }

                                    if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                            $nObjff = $subquestion["match_questions_items"][$iirr];
                                            $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                        }
                                    }

                                    if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                            $nObjff = $subquestion["sort_questions_words"][$iirr];
                                            $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                        }
                                    }

                                } else {
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $stmtq = "UPDATE `questions_bank_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}'  ";
                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_question_options']) > 0) {
                                        foreach ($subquestion['test_question_options'] as $testObjOp) {
                                            $statuss = $testObjOp['status'] == 'true' ? "1" : "0";
                                            if ( $testObjOp['id'] < 1) {
                                                $subquestionoption_id = $this->InsertIntoTestQuestionOptions($subquestion['id'], $testObjOp['title'], $statuss, $testObjOp['note']);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $subquestionoption_id);
                                                    if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $subquestionoption_id);
                                                    if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }

                                            } elseif ( $testObjOp['id'] >= 1) {
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                                $stmtqup = "UPDATE `questions_bank_options` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `status` = '{$statuss}', ";
                                                $stmtqup .= " `note` = '{$testObjOp['note']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                                    if ($testObjOp['file'] && $testObjOp['file'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file'], "related_to" => "option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                                    if ($testObjOp['file_note'] && $testObjOp['file_note'] != '') {
                                                        // delete old files
                                                        $arr = ["file" => $testObjOp['file_note'], "related_to" => "note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if ($subquestion['id'] > 0 && $subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($subquestion['id'], $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if ($subquestion['file'] && $subquestion['file'] != '') {
                                            // delete old files
                                            $arr = ["file" => $subquestion['file'], "related_to" => "question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }

                                    if ($subquestion['id'] > 0 && $subquestion['type'] == 'match_it') {
                                        for ($mqii = 0; $mqii < count($subquestion['match_questions_items']); $mqii++) {
                                            $subquestionmatch = $subquestion['match_questions_items'][$mqii];
                                            if ($subquestionmatch['title1'] != '' && $subquestionmatch['id'] < 1) {
                                                $this->InsertIntoMatchQuestionItems($subquestion['id'], $subquestionmatch['title1'], $subquestionmatch['righte_index1'], $subquestionmatch['title2'], $subquestionmatch['righte_index2'], $subquestionmatch['image1'], $subquestionmatch['image2']);
                                            } else {
                                                $math_type_view_title1 = renderMathType($subquestionmatch['title1']);
                                                $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

                                                $math_type_view_title2 = renderMathType($subquestionmatch['title2']);
                                                $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);

                                                $matchqui = "UPDATE `questions_bank_match_items` SET ";
                                                $matchqui .= " `title1` = '{$subquestionmatch['title1']}', ";
                                                $matchqui .= " `title2` = '{$subquestionmatch['title2']}', ";
                                                $matchqui .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
                                                $matchqui .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";

                                                $matchqui .= " `righte_index1` = '{$subquestionmatch['righte_index1']}', ";
                                                $matchqui .= " `righte_index2` = '{$subquestionmatch['righte_index2']}' ";
                                                $matchqui .= " WHERE `id`='{$subquestionmatch['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this->mDb->query($matchqui);
                                            }
                                        }
                                    }
                                    if ($subquestion['id'] > 0 && $subquestion['type'] == 'sort_it') {
                                        for ($sqwdi = 0; $sqwdi < count($subquestion['sort_questions_words']); $sqwdi++) {
                                            $subquestionword = $subquestion['sort_questions_words'][$sqwdi];
                                            if ($subquestionword['title'] != '' && $subquestionword['id'] < 1) {
                                                $this->InsertIntoSortQuestionWords($subquestion['id'], $subquestionword['title'], $subquestionword['word_index']);
                                            } else {
                                                $math_type_view_title = renderMathType($subquestion['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                                $sortquw = "UPDATE `questions_bank_sort_words` SET ";
                                                $sortquw .= " `title` = '{$subquestionword['title']}', ";
                                                $sortquw .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $sortquw .= " `word_index` = '{$subquestionword['word_index']}' ";
                                                $sortquw .= " WHERE `id`='{$subquestionword['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this->mDb->query($sortquw);
                                            }
                                        }
                                    }

// start of part complete_it & complete_it_writing_auto_correct & complete_it_writing_manual_correct
if ($subquestion['id'] > 0 && (($subquestion['type'] == 'complete_it') || ($subquestion['type'] == 'complete_it_writing_auto_correct') || ($subquestion['type'] == 'complete_it_writing_manual_correct'))) {
                                    
                                    for ($cdsub = 0; $cdsub < count($subquestion['question_sub_questions']); $cdsub++) {
//                                                                                                               echo '<pre>';
// print_r($subquestion['question_sub_questions'][$cdsub]);
// echo '</pre>';
//                                                                                                         echo '<pre>';
// print_r($subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words']);
// echo '</pre>';
                                if ($subquestion['question_sub_questions'][$cdsub]['id'] < 1) {
                                    $idqsub = $this->InsertIntoBankQuestions($question_bank_id, $subquestion['question_sub_questions'][$cdsub]['type'], $subquestion['question_sub_questions'][$cdsub]['source'], $subquestion['question_sub_questions'][$cdsub]['degree'], $subquestion['question_sub_questions'][$cdsub]['title'], $subquestion['question_sub_questions'][$cdsub]['id'], $subquestion['question_sub_questions'][$cdsub]['note']);
                                    if ($idqsub > 0 && count($subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words']); $iirr++) {
                                                                                      $this->InsertIntoBankQuestionCompleteWord($idqsub, $subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words'][$iirr]['title'], $subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words'][$iirr]['word_index'], $subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words'][$iirr]['note']);
                                        }
                                    }

                                }else {
                                    $math_type_view_title = renderMathType($subquestion['question_sub_questions'][$cdsub]['title']);
                                    $math_type_view_note = renderMathType($subquestion['question_sub_questions'][$cdsub]['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $stmtq = "UPDATE `questions_bank_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['question_sub_questions'][$cdsub]['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['question_sub_questions'][$cdsub]['source']}', ";
                                    $stmtq .= " `note` = '{$subquestion['question_sub_questions'][$cdsub]['note']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['question_sub_questions'][$cdsub]['degree']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['question_sub_questions'][$cdsub]['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['question_sub_questions'][$cdsub]['id']}'  ";
                                    $this->mDb->query($stmtq);

                                    if (count($subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words']) > 0) {

                                        foreach ($subquestion['question_sub_questions'][$cdsub]['test_questions_complete_words'] as $testObjOp) {

                                            if ( $testObjOp['id'] < 1) {
                                                $this->InsertIntoBankQuestionCompleteWord($subquestion['question_sub_questions'][$cdsub]['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                            } elseif ( $testObjOp['id'] >= 1) {

                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


                                                $stmtqup = "UPDATE `questions_bank_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                            }
                                        }
                                    }

                                        }
                                    }
                                }
//end of part complete_it & complete_it_writing_auto_correct & complete_it_writing_manual_correct

                                }
                            }
                        }


                        if ($questid >= 1 && $current_quest['type'] == 'complete_it') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub = $this->InsertIntoBankQuestions($question_bank_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $questid, $subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoBankQuestionCompleteWord($idqsub, $subquestionoption['title'], $subquestionoption['word_index'], $subquestionoption['note']);
                                        }
                                    }

                                } else {
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $stmtq = "UPDATE `questions_bank_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}'  ";
                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_questions_complete_words']) > 0) {
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {

                                            if ( $testObjOp['id'] < 1) {
                                                $this->InsertIntoBankQuestionCompleteWord($subquestion['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                            } elseif ( $testObjOp['id'] >= 1) {

                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


                                                $stmtqup = "UPDATE `questions_bank_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                            }
                                        }
                                    }

                                }
                            }
                        }

                        if ($questid >= 1 && $current_quest['type'] == 'complete_it_writing_auto_correct') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub = $this->InsertIntoBankQuestions($question_bank_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $questid, $subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoBankQuestionCompleteWord($idqsub, $subquestionoption['title'], $subquestionoption['word_index'], $subquestionoption['note']);
                                        }
                                    }

                                } else {
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $stmtq = "UPDATE `questions_bank_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}'  ";
                                    $this->mDb->query($stmtq);
                                    if (count($subquestion['test_questions_complete_words']) > 0) {
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {

                                            if ( $testObjOp['id'] < 1) {
                                                $this->InsertIntoBankQuestionCompleteWord($subquestion['id'], $testObjOp['title'], $testObjOp['word_index'], $testObjOp['note']);
                                            } elseif ( $testObjOp['id'] >= 1) {

                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


                                                $stmtqup = "UPDATE `questions_bank_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this->mDb->query($stmtqup);
                                            }
                                        }
                                    }

                                }
                            }
                        }


                        if ($questid >= 1 && $current_quest['type'] == 'complete_it_writing_manual_correct') {
                            for ($cdsub = 0; $cdsub < count($current_quest['question_sub_questions']); $cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub = $this->InsertIntoBankQuestions($question_bank_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $questid, $subquestion['note']);

                                } else {
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_note = renderMathType($subquestion['note']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);

                                    $stmtq = "UPDATE `questions_bank_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `note` = '{$subquestion['note']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                    $stmtq .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $stmtq .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}'  ";
                                    $this->mDb->query($stmtq);


                                }
                            }
                        }


                        if ($questid > 0 && $current_quest['type'] == 'match_it') {
                            for ($imgisub = 0; $imgisub < count($current_quest['match_questions_items']); $imgisub++) {
                                $subquestion = $current_quest['match_questions_items'][$imgisub];
                                if ($subquestion['title1'] != '' && $subquestion['id'] < 1) {
                                    $this->InsertIntoMatchQuestionItems($questid, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                                } else {
                                    $math_type_view_title1 = renderMathType($subquestion['title1']);
                                    $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

                                    $math_type_view_title2 = renderMathType($subquestion['title2']);
                                    $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);

                                    $matchqui = "UPDATE `questions_bank_match_items` SET ";
                                    $matchqui .= " `title1` = '{$subquestion['title1']}', ";
                                    $matchqui .= " `title2` = '{$subquestion['title2']}', ";
                                    $matchqui .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
                                    $matchqui .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";
                                    $matchqui .= " `righte_index1` = '{$subquestion['righte_index1']}', ";
                                    $matchqui .= " `righte_index2` = '{$subquestion['righte_index2']}' ";
                                    $matchqui .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";
                                    $this->mDb->query($matchqui);
                                }
                            }
                        }
                        if ($questid > 0 && $current_quest['type'] == 'sort_it') {
                            for ($sqwi = 0; $sqwi < count($current_quest['sort_questions_words']); $sqwi++) {
                                $subquestion = $current_quest['sort_questions_words'][$sqwi];
                                if ($subquestion['title'] != '' && $subquestion['id'] < 1) {
                                    $this->InsertIntoSortQuestionWords($questid, $subquestion['title'], $subquestion['word_index']);
                                } else {
                                    $math_type_view_title = renderMathType($subquestion['title']);
                                    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                    $sortquw = "UPDATE `questions_bank_sort_words` SET ";
                                    $sortquw .= " `title` = '{$subquestion['title']}', ";
                                    $sortquw .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
                                    $sortquw .= " `word_index` = '{$subquestion['word_index']}' ";
                                    $sortquw .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";
                                    $this->mDb->query($sortquw);
                                }
                            }
                        }

                    }
                }

                return $this->getOneQuestion($questid);
            }
        }
    }


    function copyfilesTest($file)
    {


        $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments/' . $file;
        $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments/test/' . $file;

        if (file_exists($oldFolder)) {
            echo "file_exists trueeeeeeeee";
        } else {
            echo "file_exists no no no";
        }

        $ttt = copy($oldFolder, $newFolder);
        if ($ttt) {
            echo "trueee";
        } else {
            echo "error in copy";
        }

        die();

        return true;
    }

    function addTestToBank($temp)
    {


        // $testQ = json_decode($temp['test_questions']);
    $allquestions = json_decode($temp['test_questions'],true);
    //   $allquestions = $this->convert_object_to_array($testQ);

        $subject_id = $temp['subject_id'];
        $user_id = $temp['user_id'];
        $last_page_id = $temp['current_question_bank_id'];

         
         
        //   echo '<pre>';
        //   print_r($allquestions);
        //   echo '</pre>';
// die();     

        if ($last_page_id < 1) {

            $stmt = "SELECT  `country_id`,`stage_id`,`grade_id` FROM `subjects` ";
            $stmt .= " WHERE `id` = '{$temp['subject_id']}' ";
            $redata = $this->mDb->getRow($stmt);

            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `questions_bank` SET ";
            $sql .= " `added_by`   = '{$user_id}', ";
            $sql .= " `country_id` = '{$redata['country_id']}', ";
            $sql .= " `stage_id`   = '{$redata['stage_id']}', ";
            $sql .= " `grade_id`   = '{$redata['grade_id']}', ";
            $sql .= " `subject_id` = '{$temp['subject_id']}', ";
            $sql .= $temp['semester'] ? " `semester` = '{$temp['semester']}', " : "";
            $sql .= " `name`       = '{$temp['name']}', ";
            $sql .= " `status`     = '1', ";
            $sql .= " `sort`       = '0', ";
            $sql .= " `date_added` = '{$dateTime}'";
            $this->mDb->query($sql);
            $last_page_id = $this->mDb->getLastInsertId();

        }
//  echo $last_page_id;

        if ($last_page_id > 0) {

            if (count($allquestions) > 0) {


                for ($iq = 0; $iq < count($allquestions); $iq++) {
                    // $current_quest = $allquestions[$iq];
                    //   echo '<pre>';
                    //   print_r($allquestions[$iq]);
                    //   echo '</pre>';
                    //  die();
                    $title = $allquestions[$iq]['title'];
                    $type = $allquestions[$iq]['type'];
                    $answerForm = $allquestions[$iq]['answer_form'];
                  
                    // if ($title != '') {
                         $check_queryy = "SELECT `id` FROM `questions_bank_questions` WHERE `questions_bank_id` = '{$last_page_id}' AND `title` = '{$title}'";
                          $check_resulty = $this->mDb->getOne($check_queryy);
                    //   echo '<pre>';
                    //   echo $check_queryy;
                    //   echo '</pre>';
                         //  if ($check_resulty === false) {
                            $id = $this->InsertIntoBankQuestions($last_page_id, $type, $allquestions[$iq]['source'], $allquestions[$iq]['degree'], $title, '', $allquestions[$iq]['note'],$answerForm);
                            if ($id > 0 && count($allquestions[$iq]['test_question_options']) > 0) {
                                for ($ii = 0; $ii < count($allquestions[$iq]['test_question_options']); $ii++) {
                                    $nObj = $allquestions[$iq]["test_question_options"][$ii];
                                    $statuss = $nObj['status'];
                                    $option_id = $this->InsertIntoTestQuestionOptions($id, $nObj['title'], $statuss, $nObj['note']);
                                    if ($option_id > 0 && $nObj['file'] != "" && $nObj['attachment_type'] != "") {

                                        $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObj['file'];
                                        $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $nObj['file'];
                                        copy($oldFolder, $newFolder);
                                        $this->addQuestionAttachments($id, $nObj['file'], $nObj['attachment_type'], 'option', $option_id);
                                    }

                                }
                            }
                            if ($allquestions[$iq]['file'] != "" && $allquestions[$iq]['attachment_type'] != "") {
                                $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $allquestions[$iq]['file'];
                                $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $allquestions[$iq]['file'];
                                copy($oldFolder, $newFolder);
                                $this->addQuestionAttachments($id, $allquestions[$iq]['file'], $allquestions[$iq]['attachment_type'], 'question');
                            }

                            if ($id > 0 && $allquestions[$iq]['type'] == 'paragraphs') {
                                for ($idsub = 0; $idsub < count($allquestions[$iq]['question_sub_questions']); $idsub++) {
                                    //   if($subquestion['type']=='article'){ 
                                    //   echo $subquestion['answer_form'];
                                    //       }
                                    
                                    $subquestion = $allquestions[$iq]['question_sub_questions'][$idsub];
                                    $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note'],$subquestion['answer_form']);

                                    if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                            $nObjff = $subquestion["test_question_options"][$iirr];
                                            $statuss = $nObjff['status'];
                                            $sub_option_id = $this->InsertIntoTestQuestionOptions($idqsub, $nObjff['title'], $statuss, $nObjff['note']);
                                            if ($sub_option_id > 0 && $nObjff['file'] != "" && $nObjff['attachment_type'] != "") {
                                                $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['file'];
                                                $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $nObjff['file'];
                                                copy($oldFolder, $newFolder);
                                                $this->addQuestionAttachments($idqsub, $nObjff['file'], $nObjff['attachment_type'], 'option', $sub_option_id);
                                            }

                                        }
                                    }
                                    if ($idqsub > 0 && $subquestion['file'] != "" && $subquestion['attachment_type'] != "") {
                                        $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['file'];
                                        $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $subquestion['file'];
                                        copy($oldFolder, $newFolder);
                                        $this->addQuestionAttachments($idqsub, $subquestion['file'], $subquestion['attachment_type'], 'question');
                                    }


                                    if ($idqsub > 0 && count($subquestion['match_questions_items']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['match_questions_items']); $iirr++) {
                                            $nObjff = $subquestion["match_questions_items"][$iirr];
                                            if ($nObjff['image1'] && $nObjff['image1'] != '') {
                                                $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['image1'];
                                                $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $nObjff['image1'];
                                                copy($oldFolder, $newFolder);
                                            }
                                            if ($nObjff['image2'] && $nObjff['image2'] != '') {
                                                $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $nObjff['image2'];
                                                $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $nObjff['image2'];
                                                copy($oldFolder, $newFolder);
                                            }


                                            $this->InsertIntoMatchQuestionItems($idqsub, $nObjff['title1'], $nObjff['righte_index1'], $nObjff['title2'], $nObjff['righte_index2'], $nObjff['image1'], $nObjff['image2']);
                                        }
                                    }

                                    if ($idqsub > 0 && count($subquestion['sort_questions_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['sort_questions_words']); $iirr++) {
                                            $nObjff = $subquestion["sort_questions_words"][$iirr];
                                            $this->InsertIntoSortQuestionWords($idqsub, $nObjff['title'], $nObjff['word_index']);
                                        }
                                    }

                                    // if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                    //     for ($iirrc = 0; $iirrc < count($subquestion['test_questions_complete_words']); $iirrc++) {
                                    //         $nObjffc = $subquestion["test_questions_complete_words"][$iirrc];
                                    //         $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjffc['title'], $nObjffc['word_index'],$nObjff['note']);
                                    //     }
                                    // }
                                               
                                              
                                    if ($idqsub > 0 && count($subquestion['question_sub_questions']) > 0) {
 
                                        for ($iirrc = 0; $iirrc < count($subquestion['question_sub_questions']); $iirrc++) {
                                            $subsubquestion = $subquestion['question_sub_questions'][$iirrc];
                                            $idqsubsub = $this->InsertIntoBankQuestions($last_page_id, $subsubquestion['type'], $subsubquestion['source'], $subsubquestion['degree'], $subsubquestion['title'], $idqsub, $subsubquestion['note']);
                                           
                                            if ($idqsubsub > 0 && count($subsubquestion['test_questions_complete_words']) > 0) {
                                                for ($iirr = 0; $iirr < count($subsubquestion['test_questions_complete_words']); $iirr++) {
                                                //  echo '<pre>';
                                                // echo  $idqsubsub .'--'. $subsubquestion['test_questions_complete_words'][$iirr]  ;
                                                // echo '</pre>';
                                                    $nObjff = $subsubquestion["test_questions_complete_words"][$iirr];
                                                    $this->InsertIntoBankQuestionCompleteWord($idqsubsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                                }
                                            }
                                        }
                                    }
                                }
                            }

                            if ($id > 0 && $allquestions[$iq]['type'] == 'complete_it') {
                                for ($comidsub = 0; $comidsub < count($allquestions[$iq]['question_sub_questions']); $comidsub++) {
                                    $subquestion = $allquestions[$iq]['question_sub_questions'][$comidsub];
                                    $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                        }
                                    }
                                }
                            }
                            if ($id > 0 && $allquestions[$iq]['type'] == 'complete_it_writing_auto_correct') {
                                for ($comidsub = 0; $comidsub < count($allquestions[$iq]['question_sub_questions']); $comidsub++) {
                                    $subquestion = $allquestions[$iq]['question_sub_questions'][$comidsub];
                                    $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                            $this->InsertIntoBankQuestionCompleteWord($idqsub, $nObjff['title'], $nObjff['word_index'], $nObjff['note']);
                                        }
                                    }
                                }
                            }
                            if ($id > 0 && $allquestions[$iq]['type'] == 'complete_it_writing_manual_correct') {
                                for ($comidsub = 0; $comidsub < count($allquestions[$iq]['question_sub_questions']); $comidsub++) {
                                    $subquestion = $allquestions[$iq]['question_sub_questions'][$comidsub];
                                    $idqsub = $this->InsertIntoBankQuestions($last_page_id, $subquestion['type'], $subquestion['source'], $subquestion['degree'], $subquestion['title'], $id, $subquestion['note']);

                                }
                            }


                            if ($id > 0 && $allquestions[$iq]['type'] == 'match_it') {
                                for ($matidsub = 0; $matidsub < count($allquestions[$iq]['match_questions_items']); $matidsub++) {
                                    $subquestion = $allquestions[$iq]['match_questions_items'][$matidsub];

                                    if ($subquestion['image1'] && $subquestion['image1'] != '') {
                                        $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['image1'];
                                        $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $subquestion['image1'];
                                        copy($oldFolder, $newFolder);
                                    }
                                    if ($subquestion['image2'] && $subquestion['image2'] != '') {
                                        $oldFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_attachments' . '/' . $subquestion['image2'];
                                        $newFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments' . '/' . $subquestion['image2'];
                                        copy($oldFolder, $newFolder);
                                    }

                                    $this->InsertIntoMatchQuestionItems($id, $subquestion['title1'], $subquestion['righte_index1'], $subquestion['title2'], $subquestion['righte_index2'], $subquestion['image1'], $subquestion['image2']);
                                }
                            }
                            if ($id > 0 && $allquestions[$iq]['type'] == 'sort_it') {
                                for ($sortidsub = 0; $sortidsub < count($allquestions[$iq]['sort_questions_words']); $sortidsub++) {
                                    $subquestion = $allquestions[$iq]['sort_questions_words'][$sortidsub];
                                    $this->InsertIntoSortQuestionWords($id, $subquestion['title'], $subquestion['word_index']);
                                }
                            }


                          //  }
                    //   }

                }

            }

            return true;
        }
        return false;
    }


    function addEditBank($temp)
    {

        // print_r($temp);die();
        $user_id = $temp['user_id'];
        $status = $temp['status'] == 'true' ? "1" : "0";
        $id = $temp['id'];

        if ($id === null || $id === '' || ($id < 1)) {
            // add

            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `questions_bank` SET ";
            $sql .= " `added_by` = '{$user_id}', ";
            $sql .= " `country_id` = '{$temp['country_id']}', ";
            $sql .= " `stage_id` = '{$temp['stage_id']}', ";
            $sql .= " `grade_id` = '{$temp['grade_id']}', ";
            $sql .= " `subject_id` = '{$temp['subject_id']}', ";
            $sql .= $temp['branch_id'] ? " `branch_id` = '{$temp['branch_id']}', ":"";
            $sql .= $temp['semester'] ? " `semester` = '{$temp['semester']}', " : "";
            $sql .= " `name` = '{$temp['name']}', ";
            $sql .= " `status` = '{$status}', ";
            $sql .= " `sort` = '{$temp['sort']}', ";
            $sql .= " `date_added` = '{$dateTime}'"; 
// echo $sql;
// die();
            $this->mDb->query($sql);
            $last_page_id = $this->mDb->getLastInsertId();

            return $last_page_id;
        } else {
            // edit
            $check_query = "SELECT `id` FROM `questions_bank` WHERE `id` = '{$id}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {
                return 403;
            } else {

                $sql = "UPDATE `questions_bank` SET ";
                $sql .= " `added_by` = '{$user_id}', ";
                $sql .= " `country_id` = '{$temp['country_id']}', ";
                $sql .= " `stage_id` = '{$temp['stage_id']}', ";
                $sql .= " `grade_id` = '{$temp['grade_id']}', ";
                $sql .= " `subject_id` = '{$temp['subject_id']}', ";
                $sql .= $temp['semester'] ? " `semester` = '{$temp['semester']}', " : "";
                $sql .= " `name` = '{$temp['name']}', ";
                $sql .= " `sort` = '{$temp['sort']}', ";
                $sql .= " `status` = '{$status}' ";
                $sql .= " WHERE `id` = '{$id}'";
                $res = $this->mDb->query($sql);

                return $id;
            }
        }
    }


    function InsertIntoBankQuestions($questions_bank_id, $type, $source, $degree, $title, $parent_id = '', $note = '',$answer_form = '')
    {

        $answer_form_origin = $answer_form;
        $math_type_view_title = renderMathType($title);
        $math_type_view_note = renderMathType($note);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
        $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
        $answer_form = str_replace("'", "\'", $answer_form);
        $answer_form_origin = str_replace("'", "\'", $answer_form_origin);   
        $titlee = str_replace("'", "\'", $title);
        $note = str_replace("'", "\'", $note);

        $stmt = "INSERT INTO `questions_bank_questions` SET ";
        $stmt .= " `questions_bank_id` = '{$questions_bank_id}', ";
        $stmt .= $parent_id && $parent_id != '' ? " `parent_id` = '{$parent_id}', " : "";
        $stmt .= " `type` = '{$type}', ";
        $stmt .= " `source` = '{$source}', ";
        $stmt .= " `answer_form` = '{$answer_form}', ";
        $stmt .= " `answer_form_origin` = '{$answer_form_origin}', ";
        $stmt .= " `degree` = '{$degree}', ";
        $stmt .= " `note` = '{$note}', ";
        $stmt .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmt .= $math_type_view_note && $math_type_view_note != '' ? " `math_type_view_note` = '{$math_type_view_note}', " : "";
        $stmt .= " `title` = '{$titlee}' ";
        
        
        //   echo '<pre>';
        // echo $stmt;
        // echo '</pre>';
     
        return $this->mDb->queryreturnlastid($stmt);
    }

    function InsertIntoTestQuestionOptions($test_question_id, $title, $status, $note)
    {
        $titlee = str_replace("'", "\'", $title);
        $noteee = str_replace("'", "\'", $note);
        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
        $stmto = "INSERT INTO `questions_bank_options` SET ";
        $stmto .= " `question_bank_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$titlee}', ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `status` = '{$status}', ";
        $stmto .= " `note` = '{$noteee}' ";
        return $this->mDb->queryreturnlastid($stmto);
    }


    function InsertIntoBankQuestionCompleteWord($test_question_id, $title, $word_index, $note = '')
    {

        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

        $title = str_replace("'", "\'", $title);
        $stmto = "INSERT INTO `questions_bank_complete_words` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$title}', ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `word_index` = '{$word_index}' ";
        //   echo '<pre>'.$test_question_id.'_________'.$stmto.'</pre>';
        return $this->mDb->queryreturnlastid($stmto);
    }

    function InsertIntoMatchQuestionItems($test_question_id, $title1, $righte_index1, $title2, $righte_index2, $image1 = '', $image2 = '')
    {


        $math_type_view_title1 = renderMathType($title1);
        $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);

        $math_type_view_title2 = renderMathType($title2);
        $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);


        $title1 = str_replace("'", "\'", $title1);
        $title2 = str_replace("'", "\'", $title2);

        $stmto = "INSERT INTO `questions_bank_match_items` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title1` = '{$title1}', ";
        $stmto .= " `title2` = '{$title2}', ";
        $stmto .= $math_type_view_title1 && $math_type_view_title1 != '' ? " `math_type_view_title1` = '{$math_type_view_title1}', " : "";
        $stmto .= $math_type_view_title2 && $math_type_view_title2 != '' ? " `math_type_view_title2` = '{$math_type_view_title2}', " : "";
        $stmto .= $image1 && $image1 != '' ? " `image1` = '{$image1}', " : "";
        $stmto .= $image2 && $image2 != '' ? " `image2` = '{$image2}', " : "";
        $stmto .= " `righte_index1` = '{$righte_index1}', ";
        $stmto .= " `righte_index2` = '{$righte_index2}' ";

        return $this->mDb->queryreturnlastid($stmto);
    }

    function InsertIntoSortQuestionWords($test_question_id, $title, $word_index)
    {

        $math_type_view_title = renderMathType($title);
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);


        $title = str_replace("'", "\'", $title);
        $stmto = "INSERT INTO `questions_bank_sort_words` SET ";
        $stmto .= $math_type_view_title && $math_type_view_title != '' ? " `math_type_view_title` = '{$math_type_view_title}', " : "";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$title}', ";
        $stmto .= " `word_index` = '{$word_index}' ";

        return $this->mDb->queryreturnlastid($stmto);
    }

    function deleteAttachment($request)
    {

        $sqll = "DELETE FROM `questions_bank_attachments` ";
        $sqll .= " WHERE `file` = '{$request['file']}' AND `related_to` = '{$request['related_to']}'";
        $res = $this->mDb->query($sqll);

        if ($res) {
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'questions_bank_attachments/' . $request['file'];

            if (file_exists($old_img)) {
                // @unlink($old_img);
            }
        }

        return $res;
    }

    function getOneQuestion($id)
    {

        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `questions_bank_questions` pl";
        $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`id` = '{$id}' AND pl.`parent_id` = '0'";
        $result = $this->mDb->getRow($stmt);

        if (count($result) > 0) {
            $result['math_type_answer_form'] = $result['answer_form'];
            $result['answer_form'] = $result['answer_form_origin'];
            $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
            $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['id']}'    AND related_to = 'option')";
            $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['id']}'    AND qattachfilenote.`related_to` = 'note')";
            $stmto .= " WHERE tqo.`question_bank_id` = " . $result['id'];
//            echo $stmto;die();
            $result['test_question_options'] = $this->mDb->getAll($stmto);
            if ($result['type'] == 'paragraphs') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`questions_bank_id` = '{$result['questions_bank_id']}' AND pl.`parent_id` = '{$result['id']}'";
    // echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
                        $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                        $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                        $stmtosub .= " WHERE tqo.`question_bank_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                       //echo $stmtosub;die();
                        $result['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);


                        if ($result['question_sub_questions'][$iisub]['type'] == 'match_it') {
                            $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);
                        }
                        if ($result['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                            $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);
                        }
                        
                         /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */
                               
                                if (($result['question_sub_questions'][$iisub]['type'] == 'complete_it') || 
                                ($result['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') ||
                                ($result['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_manual_correct')) {
                                         $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                                    $stmt .= " WHERE pl.`questions_bank_id` ='{$result['questions_bank_id']}' AND pl.`parent_id` = '{$result['question_sub_questions'][$iisub]['id']}' AND pl.`is_deleted` = '0'";
                            // echo $stmt; 
                                $result['question_sub_questions'][$iisub]['question_sub_questions'] = $this->mDb->getAll($stmt);
  
                                if (count($result['question_sub_questions'][$iisub]['question_sub_questions']) > 0) {
                                    for ($iicomsub = 0; $iicomsub < count($result['question_sub_questions'][$iisub]['question_sub_questions']); $iicomsub++) {
                                        $subCom = $result['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub];
                                        $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                        $stmtosub .= " WHERE tqcw.`question_id` ='{$subCom['id']}' ";
                                        //  echo '<pre>'.$stmtosub.'</pre>'; 
                                        $result['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                                    }

                                }
                            }
                                /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */
                    }
                }
            }

            if ($result['type'] == 'complete_it') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`questions_bank_id` = '{$result['questions_bank_id']}'  AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
                //                    echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                        $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                    }
                }
            }
            
            if ($result['type'] == 'complete_it_writing_auto_correct') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`questions_bank_id` = '{$result['questions_bank_id']}'  AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
                                //   echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                        $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                    }
                }
            }
            if ($result['type'] == 'complete_it_writing_manual_correct') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`questions_bank_id` = '{$result['questions_bank_id']}'  AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
                //                    echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);


            }

            if ($result['type'] == 'match_it') {
                $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
                //                    echo $stmt;die();
                $result['match_questions_items'] = $this->mDb->getAll($stmt);

            }

            if ($result['type'] == 'sort_it') {
                $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
                //                    echo $stmt;die();
                $result['sort_questions_words'] = $this->mDb->getAll($stmt);

            }
        }
        return $result;
    }


    function getOneBank($id)
    {

        $result = array();

        $sql = "SELECT qb.*,subjectt.`subject_direction` as 'subject_direction',subjectt.`semester` suBsem FROM `questions_bank` qb";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( qb.`subject_id` = subjectt.`id`)";
        $sql .= " WHERE qb.`id` = '{$id}'";
        $result = $this->mDb->getRow($sql);
        $result['semester']=$result['semester']?$result['semester']:$result['suBsem'];
        unset($result['suBsem']);
        // echo'<pre>';
        // print_r($result);
        // echo'</pre>';
        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `questions_bank_questions` pl";
        $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '0'";
        $result['test_questions'] = $this->mDb->getAll($stmt);
        if (count($result['test_questions']) > 0) {
            for ($ii = 0; $ii < count($result['test_questions']); $ii++) {
                 $result['test_questions'][$ii]['math_type_answer_form'] = $result['test_questions'][$ii]['answer_form'];
                 $result['test_questions'][$ii]['answer_form'] = $result['test_questions'][$ii]['answer_form_origin'];
                $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
                $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfile.`related_to` = 'option')";
                $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                $stmto .= " WHERE tqo.`question_bank_id` = " . $result['test_questions'][$ii]['id'];
//            echo $stmto;die();
                $result['test_questions'][$ii]['test_question_options'] = $this->mDb->getAll($stmto);
                if ($result['test_questions'][$ii]['type'] == 'paragraphs') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `questions_bank_questions` pl";
                    $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'";
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
                            $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                            $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                            $stmtosub .= " WHERE tqo.`question_bank_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);
                            if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                //                    echo $stmt;die();
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);

                            }

                            if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                //                    echo $stmt;die();
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);

                            }
                             /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */
                               
                                if (($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it') || ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') || ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_manual_correct')) {
                                         $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' AND pl.`is_deleted` = '0'";
           // echo $stmt;die();
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions'] = $this->mDb->getAll($stmt);

                                if (count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions']) > 0) {
                                    for ($iicomsub = 0; $iicomsub < count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions']); $iicomsub++) {
                                        $subCom = $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub];
                                        $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                        $stmtosub .= " WHERE tqcw.`question_id` ='{$subCom['id']}' ";
                                        //   echo $stmtosub;die();
                                        $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                                    }

                                }
                            }
                                /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */
                        }
                    }
                }

                if ($result['test_questions'][$ii]['type'] == 'complete_it') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                            $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                        }
                    }
                }
                if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                    if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                        for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                            $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                            $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                        }
                    }
                }
                if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_manual_correct') {
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                    //                    echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);


                }

                if ($result['test_questions'][$ii]['type'] == 'match_it') {
                    $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
                    $result['test_questions'][$ii]['match_questions_items'] = $this->mDb->getAll($stmt);

                }

                if ($result['test_questions'][$ii]['type'] == 'sort_it') {
                    $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
                    $result['test_questions'][$ii]['sort_questions_words'] = $this->mDb->getAll($stmt);

                }

                if ($result['test_questions'][$ii]['type'] != 'head_question') {
                    $qindex++;
                    $result['test_questions'][$ii]['index'] = $qindex;
                } else {
                    $result['test_questions'][$ii]['index'] = 0;
                }

            }
        }
        return $result;
    }

    function getTestDetailsInfo($id)
    {

        $result = array();

        $sql = "SELECT te.id  ,te.sort, te.status,te.semester, te.date_added, te.name, u.full_name AS 'user_full_name' , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " subjectt.`subject_direction` as 'subject_direction' ,";
        $sql .= " subjectt.`name` as 'subject_name'";
        $sql .= " FROM `questions_bank` te";
        $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
        $sql .= " WHERE te.id ='{$id}' ";

        $result = $this->mDb->getRow($sql);

        if (count($result) > 0) {
            $stmt = "SELECT pl.*,qattachfile.`file`,qattachfile.`attachment_type` FROM `questions_bank_questions` pl";
            $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
            $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '0'";

            $result['test_questions'] = $this->mDb->getAll($stmt);

            if (count($result['test_questions']) > 0) {
                $qindex = 0;
                for ($ii = 0; $ii < count($result['test_questions']); $ii++) {
               $result['test_questions'][$ii]['math_type_answer_form'] = $result['test_questions'][$ii]['answer_form'];
                 $result['test_questions'][$ii]['answer_form'] = $result['test_questions'][$ii]['answer_form_origin'];
                    $stmto = "SELECT tqo.`id`,tqo.`title` ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
                    $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfile.`related_to` = 'option')";
                    $stmto .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                    $stmto .= " WHERE tqo.`question_bank_id` ='{$result['test_questions'][$ii]['id']}' ";
                    $result['test_questions'][$ii]['test_question_options'] = $this->mDb->getAll($stmto);

                    /*start section pragraphs*/
                    if ($result['test_questions'][$ii]['type'] == 'paragraphs') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `questions_bank_questions` pl";
                        $stmt .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'";
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqo.`id` ,tqo.`title` ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `questions_bank_options` tqo ";
                                $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfile ON  ( qattachfile.`question_bank_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                                $stmtosub .= " LEFT JOIN `questions_bank_attachments` qattachfilenote ON  ( qattachfilenote.`question_bank_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                                $stmtosub .= " WHERE tqo.`question_bank_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);

                                /*match_it*/
                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                    $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    //   echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);
                                }
                                /*match_it*/

                                /*sort_it*/
                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                    $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    // echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);

                                }
                                /*sort_it*/

                                /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */
                                if (($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it') || ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') || ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_manual_correct')) {
                                //  echo $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'].'<br />';
                                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                                    $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' AND pl.`is_deleted` = '0'";

                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'] = $this->mDb->getAll($stmt);

                                    // if (count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions']) > 0) {
                                    //     for ($iicomsub = 0; $iicomsub < count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions']); $iicomsub++) {

                                    //         $subCom = $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub];
                                    //         $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                    //         $stmtosub .= " WHERE tqcw.`question_id` ='{$subCom['id']}' ";
                                    //         // echo '<pre>'; echo$stmtosub;echo '</pre>';
                                    //         $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions'][$iicomsub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                                    //         // echo '<pre>';
                                    //         //  print_r($result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_sub_questions']);
                                    //         //  echo'</pre>';
                                    //     }
                                    // }
                                    
                                    if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it' || $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') {
                                        for ($l = 0; $l < count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub']); $l++) {
                                      $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                      $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['id']}' ";
                                        //   echo $stmtosub;
                                            $array2 = $this->mDb->getAll($stmtosub);
                                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['test_questions_complete_it_words'] = $array2;
                                             }

                                    }
                                }
                                /* *
                                 * complete_it
                                 *complete_it_writing_auto_correct
                                 *complete_it_writing_auto_correct
                                 * */

                            }
                        }
                         $result['test_questions'][$ii]['question_sub_questions'] = array_values($result['test_questions'][$ii]['question_sub_questions']);
                    }
                    /* end section pragraphs */


                    if ($result['test_questions'][$ii]['type'] == 'complete_it') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                        //  echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                            }
                        }
                    }
                    if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                        // echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `questions_bank_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this->mDb->getAll($stmtosub);
                            }
                        }
                    }
                    if ($result['test_questions'][$ii]['type'] == 'complete_it_writing_manual_correct') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `questions_bank_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`questions_bank_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                        //  echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);


                    }

                    if ($result['test_questions'][$ii]['type'] == 'match_it') {
                        $stmt = "SELECT mq.*  FROM `questions_bank_match_items` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //  echo $stmt;die();
                        $result['test_questions'][$ii]['match_questions_items'] = $this->mDb->getAll($stmt);
                    }

                    if ($result['test_questions'][$ii]['type'] == 'sort_it') {
                        $stmt = "SELECT mq.*  FROM `questions_bank_sort_words` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //  echo $stmt;die();
                        $result['test_questions'][$ii]['sort_questions_words'] = $this->mDb->getAll($stmt);

                    }

                    if ($result['test_questions'][$ii]['type'] != 'head_question') {
                        $qindex++;
                        $result['test_questions'][$ii]['index'] = $qindex;
                    } else {
                        $result['test_questions'][$ii]['index'] = 0;
                    }

                }

            }

//        33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,
        }

        return $result;
    }

    function deleteTest($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';


        $sql = "SELECT `id` FROM `questions_bank_questions`";
        $sql .= " WHERE `questions_bank_id` IN " . $tempids;
        $qids = $this->mDb->getAll($sql);

        $sqll = "DELETE FROM `questions_bank_questions` ";
        $sqll .= " WHERE `questions_bank_id` IN " . $tempids;
        $this->mDb->query($sqll);

//
        if (count($qids) > 0) {
            for ($i = 0; $i < count($qids); $i++) {
                $sqll = "DELETE FROM `questions_bank_options` ";
                $sqll .= " WHERE `question_bank_id` = '{$qids[$i]['id']}'";
                $this->mDb->query($sqll);
            }
        }

        $catsql = "DELETE FROM `questions_bank` ";
        $catsql .= " WHERE `id` IN " . $tempids;


        // $sql = "UPDATE `questions_bank` SET ";
        // $sql .=" `is_deleted`='1' ";
        // $sql .= " WHERE `id` IN ".$tempids;


        return $this->mDb->query($catsql);
    }


    function deleteQuestionOption($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `questions_bank_options` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteQuestion($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';


        $sql = "SELECT `id` FROM `questions_bank_questions`";
        $sql .= " WHERE `parent_id` IN " . $tempids;
        $qids = $this->mDb->getAll($sql);

        if (count($qids) > 0) {
            for ($i = 0; $i < count($qids); $i++) {
                $sqll = "DELETE FROM `questions_bank_options` ";
                $sqll .= " WHERE `question_bank_id` = '{$qids[$i]['id']}'";
                $this->mDb->query($sqll);
            }
        }

        $sqll = "DELETE FROM `questions_bank_questions` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteSupQuestionByParent($ids)
    {


        $tempids = '(' . implode(',', $ids) . ')';


        $sql = "SELECT `id` FROM `questions_bank_questions`";
        $sql .= " WHERE `parent_id` IN " . $tempids;
        $qids = $this->mDb->getAll($sql);

        if (count($qids) > 0) {
            for ($i = 0; $i < count($qids); $i++) {
                $sqll = "DELETE FROM `questions_bank_options` ";
                $sqll .= " WHERE `question_bank_id` = '{$qids[$i]['id']}'";
                $this->mDb->query($sqll);
            }
        }

        $sqll = "DELETE FROM `questions_bank_questions` ";
        $sqll .= " WHERE `parent_id` IN " . $tempids;

        return $this->mDb->query($sqll);
    }

    function addQuestionAttachments($question_id, $attachment, $attachment_type, $related_to, $option_id = '')
    {

        $stmtoatt = "INSERT INTO `questions_bank_attachments` SET ";
        $stmtoatt .= " `question_bank_id` = '{$question_id}', ";
        // $stmtoatt .= $option_id?" `option_id` = '{$option_id}', ":"";
        $stmtoatt .= " `file` = '{$attachment}', ";
        $stmtoatt .= " `attachment_type` = '{$attachment_type}', ";
        $stmtoatt .= " `related_to` = '{$related_to}' ";
        return $this->mDb->queryreturnlastid($stmtoatt);
    }

    function deleteMatchQuestionsItem($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `questions_bank_match_items` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }


    function removeMatchQuestionsImage($ids, $image_type)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        if ($image_type == 'image1') {
            $sqll = "UPDATE `questions_bank_match_items` SET ";
            $sqll .= " `image1`='' ";
            $sqll .= " WHERE `id` IN " . $tempids;
            return $this->mDb->query($sqll);
        } else {
            $sqll = "UPDATE `questions_bank_match_items` SET ";
            $sqll .= " `image2`='' ";
            $sqll .= " WHERE `id` IN " . $tempids;
            return $this->mDb->query($sqll);
        }
    }

    function deleteSortQuestionsWord($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `questions_bank_sort_words` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

    function deleteCompleteQuestionsWord($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';
        $sqll = "DELETE FROM `questions_bank_complete_words` ";
        $sqll .= " WHERE `id` IN " . $tempids;
        return $this->mDb->query($sqll);
    }

} ?>
