<?php

$questions_reportsObj = new QuestionsReports();

class QuestionsReports {
 
var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
	
	$this->questions_table = [
	                "1" => "first_primary","2" => "second_primary",
                    "4" => "third_primary",
                    "9" => "fourth_primary", "10" => "fifth_primary",
                    "11" => "sixth_primary","12" => "first_middle",
                    "13" => "second_middle","14" => "third_middle",
                    "15" => "second_secondary", "16" => "first_secondary",
                    "17" => "third_secondary", "22" => "experimental"];
                    
}

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function getSomeQuestionsReports($aStart, $aLimit, $sort, $type, $searchName, $searchSubjectName, $searchTestName, $searchUserName) {
    $grades = $this->getAllReportsGrades($sort, $type, $searchName, $searchSubjectName, $searchTestName, $searchUserName);
    
    $data = [];
    foreach($grades as $grade){
        
        $sql  = "SELECT qr.id, qr.comment, q.id as question_id, q.title as question_title, t.id as test_id, t.name as test_name, s.id as subject_id, s.name as subject_name, u.id as user_id, u.full_name as user_name, qr.date_added FROM `questions_reports` qr ";
        $sql .= " LEFT JOIN `".$this->questions_table[$grade]."_test_questions` q ON q.id = qr.question_id ";
        $sql .= " LEFT JOIN `tests` t ON t.id = qr.test_id ";
        $sql .= " LEFT JOIN `subjects` s ON s.id = qr.subject_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = qr.user_id ";
        $sql .= " WHERE qr.id > 0 AND q.id IS NOT NULL ";
        $sql .= $searchName ? ' AND q.title like "%'.$searchName.'%"' : '';
        $sql .= $searchSubjectName ? ' AND s.name like "%'.$searchSubjectName.'%"' : '';
        $sql .= $searchTestName ? ' AND t.name like "%'.$searchTestName.'%"' : '';
        $sql .= $searchUserName ? ' AND u.full_name like "%'.$searchUserName.'%"' : '';
    	$sql .= " ORDER BY q.title {$type}";
    	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
    
    // 	 echo $sql; die();
    
    	$res =  $this -> mDb -> getAll($sql); 
    	
    	$data =  array_merge($data, $res);
    	
    }
    	foreach($data as &$item){
    	    $item['question_title'] = strip_tags($item['question_title']);
    	}
	
	return $data;
}


function getSearchQuestionsReportsCount($sort, $type, $searchName, $searchSubjectName, $searchTestName, $searchUserName) {

    $grades = $this->getAllReportsGrades($sort, $type, $searchName, $searchSubjectName, $searchTestName, $searchUserName);

    $count = 0;
    foreach($grades as $grade){
        
    	$sql = "SELECT COUNT(qr.`id`) as 'result_count' FROM `questions_reports` qr ";
    	$sql .= " LEFT JOIN `".$this->questions_table[$grade]."_test_questions` q ON q.id = qr.question_id ";
        $sql .= " LEFT JOIN `tests` t ON t.id = qr.test_id ";
        $sql .= " LEFT JOIN `subjects` s ON s.id = qr.subject_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = qr.user_id ";
        $sql .= " WHERE qr.id > 0 AND q.id IS NOT NULL ";
        $sql.= $searchName ? ' AND q.title like "%'.$searchName.'%"' : '';
        $sql.= $searchSubjectName ? ' AND s.name like "%'.$searchSubjectName.'%"' : '';
        $sql.= $searchTestName ? ' AND t.name like "%'.$searchTestName.'%"' : '';
        $sql.= $searchUserName ? ' AND u.full_name like "%'.$searchUserName.'%"' : '';
    	$sql .= " ORDER BY q.title {$type}";
    	
    // 	echo $sql;die();
	    $count += $this -> mDb -> getOne($sql); 
    }
    
    return $count;

// 	echo $sql; die();

}

function getQuestionsReportsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `questions_reports`";
// 	echo $sql;die();
	return $this -> mDb -> getOne($sql); 
}

function addEditFrequentlyQuestion($request, $question_id) {

//    print_r($request); die();
    $dataLangObj = json_decode($request['LangObj']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);

    unset($request['action']);

    if ($question_id === '')
    {
        // Add

        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `questions_reports` SET ";
        $sql .= " `added_by` = '{$request['user_id']}',";
        $sql .= " `sort` = '{$request['sort']}',";
        $sql .= " `type` = '{$request['type']}',";
        $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}' ";
        // echo $sql; die();
        $res=$this -> mDb -> query($sql);
        $last_stage_id = $this -> mDb ->getLastInsertId();
        if($last_stage_id >0){
            foreach ($newDataLangObj as $key => $value) {
                $stmt = "INSERT INTO `questions_reports_langs`(`question_id`, `lang_code`, `title`, `description`) ";
                $stmt .=" VALUES ('{$last_stage_id}', '{$value['lang_code']}', '{$value['title']}', '{$value['description']}')";
                $this -> mDb -> query($stmt);
            }
        }
        return $last_stage_id;
    }
    else
    {

        // Edit

        $check_query = "SELECT `id` FROM `questions_reports` WHERE `id` = '{$question_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            
            return 403;

        }
        else{
                
            $sql = "UPDATE `questions_reports` SET ";
            $sql .= " `added_by` = '{$request['user_id']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= " `type` = '{$request['type']}',";
            $sql .= $request['status'] === 'true' ? " `status` = '1' " : " `status` = '0' ";
            $sql .= " WHERE `id` = '{$question_id}'";
           $res= $this -> mDb -> query($sql);

            foreach ($newDataLangObj as $key => $value) {
                $stmt = "UPDATE `questions_reports_langs` SET";
                $stmt .=" `title`='{$value['title']}' ,";
                $stmt .=" `description`='{$value['description']}' ";
                $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `question_id` = '{$question_id}'";
                $this -> mDb -> query($stmt);
            }

            return $res;

        } 
    }

}

function getOneQuestionReport($id) {
    
	$sql  = "SELECT fq.* ";
	$sql .= ", u.id, u.full_name as user_name, u.email, u.mobile, u.img as user_image ";
	$sql .= ", t.name as test_name, t.type as test_type, t.semester ";
	$sql .= ", g.name as grade_name ";
	$sql .= ", s.name as subject_name ";
	$sql .= " FROM `questions_reports` fq ";
	$sql .= " LEFT JOIN `users` u ON u.id = fq.user_id ";
	$sql .= " LEFT JOIN `tests` t ON t.id = fq.test_id ";
	$sql .= " LEFT JOIN `grades_langs` g ON g.grade_id = fq.grade_id AND g.lang_code = 'ar' ";
	$sql .= " LEFT JOIN `subjects` s ON s.id = t.subject_id ";
	$sql .= " WHERE fq.`id` = '$id' ";
	
	// echo $sql;die();
    $result = $this -> mDb -> getRow($sql);
    
    if($result){
        $sql  = "SELECT q.title, q.math_type_view_title ";
        $sql .= " FROM `".$this->questions_table[$result['grade_id']]."_test_questions` q ";
        $sql .= " WHERE q.`id` = '{$result['question_id']}' ";
        
        // echo $sql;die();
        $res = $this -> mDb -> getRow($sql);
        $result['question_title'] = $res['title'] != '' ? $res['title'] : $res['math_type_view_title'];
        // $result['question_math_type_view_title'] = $res['math_type_view_title'];
        // $result['question_title'] = strip_tags($result['question_title']);
    }
    
// 	if($result){
//         $stmt = "SELECT fql.`lang_code`, fql.`title`, fql.`description` FROM `questions_reports_langs` fql";
//         $stmt .= " WHERE fql.`question_id` = '{$id}'";
//         $result['langs'] = $this -> mDb -> getAll($stmt);
//     }
    return $result;
}




function getOneQuestion($id) {
    
	$sql  = "SELECT fq.`id`, fq.`added_by`, fq.status, fq.sort, fq.type, fq.`date_added`, fq.grade_id, fq.question_id ";
	$sql .= ", u.id, u.full_name as user_name, u.email, u.mobile, u.img as user_image ";
	$sql .= ", t.name as test_name ";
	$sql .= ", g.name as grade_name ";
	$sql .= ", s.name as subject_name ";
	$sql .= " FROM `questions_reports` fq ";
	$sql .= " LEFT JOIN `users` u ON u.id = fq.user_id ";
	$sql .= " LEFT JOIN `tests` t ON t.id = fq.tes_id ";
	$sql .= " LEFT JOIN `grades_langs` g ON g.grade_id = fq.grade_id ";
	$sql .= " LEFT JOIN `subjects` s ON s.id = t.subject_id ";
	$sql .= " WHERE fq.`id` = '$id' ";
	
// 	echo $sql;die();
    $result = $this -> mDb -> getRow($sql);
    
    if($result){
        $sql  = "SELECT q.title ";
        $sql .= " FROM `".$result['grade_id']."_test_questions` q ";
        $sql .= " WHERE q.`id` = '{$result['question_id']}' ";
        
        $res = $this -> mDb -> getRow($sql);
        $result['question_title'] = $res['title'];
    }
    
// 	if($result){
//         $stmt = "SELECT fql.`lang_code`, fql.`title`, fql.`description` FROM `questions_reports_langs` fql";
//         $stmt .= " WHERE fql.`question_id` = '{$id}'";
//         $result['langs'] = $this -> mDb -> getAll($stmt);
//     }
    return $result;
}

function deleteFrequentlyQuestion($ids) {

    $res = false;
    $tempids='('.implode(',',$ids).')';

    $sqll = "DELETE FROM `questions_reports_langs` ";
    $sqll.= " WHERE `question_id` IN ".$tempids;
    $this-> mDb-> query($sqll);

    $catsql = "DELETE FROM `questions_reports` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    $res= $this-> mDb-> query($catsql);
    return $res;
}
function getAllQuestionsReports() {
    $sql = "SELECT `id`, `title`, `code`, `lang_image` FROM `questions_reports`";
    echo $sql;die();
    return $this -> mDb -> getAll($sql); 
}

function getAllReportsGrades($sort, $type, $searchName, $searchSubjectName, $searchTestName, $searchUserName){
    
    $sql = "SELECT qr.grade_id FROM `questions_reports` qr ";
    $sql .= " LEFT JOIN `tests` t ON t.id = qr.test_id ";
    $sql .= " LEFT JOIN `subjects` s ON s.id = qr.subject_id ";
    $sql .= " LEFT JOIN `users` u ON u.id = qr.user_id ";
    $sql .= " WHERE qr.id > 0 ";
    $sql .= $searchName ? ' AND q.title like "%'.$searchName.'%"' : '';
    $sql .= $searchSubjectName ? ' AND s.name like "%'.$searchSubjectName.'%"' : '';
    $sql .= $searchTestName ? ' AND t.name like "%'.$searchTestName.'%"' : '';
    $sql .= $searchUserName ? ' AND u.full_name like "%'.$searchUserName.'%"' : '';
    $sql .= " GROUP BY qr.grade_id ";
    
    // 	echo $sql; die();

	$grades = $this -> mDb -> getAll($sql); 
	
	return array_values(array_column($grades, 'grade_id'));
}
}?>