<?php

$SchoolYearsObj = new SchoolYears();

class SchoolYears {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

function getSomeSchoolYears($aStart, $aLimit, $sort, $type, $searchName,$searchCountry) {
	$sql = "SELECT lan.id, lan.title, lan.status, lan.first_semester_start, lan.first_semester_end, lan.second_semester_start, lan.second_semester_end, lan.date_added , u.full_name AS 'user_full_name' , cl.name AS 'country_name' FROM `school_years` lan";
	$sql .= " LEFT JOIN `users` u ON u.id = lan.added_by ";
	$sql .= " LEFT JOIN `countries_langs` cl ON ( lan.`country_id` = cl.`country_id`  AND cl.`lang_code` ='ar')";
	$sql.= " WHERE lan.id > 0";
    $sql.= $searchName ? ' AND lan.title like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND lan.`country_id` = '{$searchCountry}'" : "";

	$sql .= " ORDER BY lan.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

	return $this -> mDb -> getAll($sql);
}

function getSearchSchoolYearsCount($sort, $type, $searchName,$searchCountry) {
	$sql = "SELECT COUNT(`id`) as 'result_count' FROM `school_years`";
	$sql.= " WHERE `id` > 0";
    $sql.= $searchName ? ' AND `title` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND `country_id` = '{$searchCountry}'" : "";
	$sql .= " ORDER BY {$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql);
}

function getSchoolYearsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `school_years`";
	return $this -> mDb -> getOne($sql);
}

function addEditSchoolYear($request, $lang_id) {

    //var_dump($request); die();

    unset($request['action']);
    $title=trim($request['title']);
    $status = $request['status'] == 'true' ? "1" : "0";
    if ($lang_id === '')
    {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `school_years` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',";
        $sql .= " `title` = '{$title}',";
        $sql .= " `country_id` = '{$request['country_id']}',";
        $sql .= " `first_semester_start` = '{$request['first_semester_start']}',";
        $sql .= " `first_semester_end` = '{$request['first_semester_end']}',";
        $sql .= " `second_semester_start` = '{$request['second_semester_start']}',";
        $sql .= " `second_semester_end` = '{$request['second_semester_end']}',";
        $sql .= " `status` = '{$status}',";
        $sql .= " `date_added` = '{$dateTime}' ";
        // echo $sql; die();
        return $this -> mDb -> query($sql);
    }
    else
    {
        // Edit
        $check_query = "SELECT `id` FROM `school_years` WHERE `id` = '{$lang_id}'";
        $check_result = $this -> mDb -> getOne($check_query);
        if ($check_result === false) {
            return 403;
        }
        else{
            $sql = "UPDATE `school_years` SET ";
            $sql .= " `added_by` = '{$request['added_by']}',";
            $sql .= " `country_id` = '{$request['country_id']}',";
            $sql .= " `title` = '{$title}',";
            $sql .= " `first_semester_start` = '{$request['first_semester_start']}',";
            $sql .= " `first_semester_end` = '{$request['first_semester_end']}',";
            $sql .= " `second_semester_start` = '{$request['second_semester_start']}',";
            $sql .= " `second_semester_end` = '{$request['second_semester_end']}',";
            $sql .= " `status` = '{$status}' ";
            $sql .= " WHERE `id` = '{$lang_id}'";
            return $this -> mDb -> query($sql);

        }
    }

}

function getOneSchoolYear($id) {
	$sql = "SELECT `id`, `added_by`, `status`, `title`, `country_id`, `first_semester_start`, `first_semester_end`, `second_semester_start`, `second_semester_end`, `date_added` FROM `school_years`";
	$sql .= " WHERE `id` = '$id' ";
	return $this -> mDb -> getRow($sql);
}

function deleteConfirm($ids) {

    $res = false;

    $tempids='('.implode(',',$ids).')';

    $sql = "DELETE FROM `school_years` ";
    $sql .= " WHERE `id` IN ".$tempids;
    $res = $this-> mDb-> query($sql);
    return $res;
}

function getAllSchoolYears() {
    $sql = "SELECT `id`, `name`, `code`, `lang_image` FROM `school_years`";
    return $this -> mDb -> getAll($sql); 
}


}?>