<?php


$SlidersObj = new Sliders();


class Sliders
{


    var $mDb;

    var $mConfig;


    function __construct()
    {

        global $Config;

        $this->mDb = new iplus();

        $this->mConfig = $Config;

    }


    function convert_object_to_array($data)
    {


        if (is_object($data)) {

            $data = get_object_vars($data);

        }


        if (is_array($data)) {

            return array_map(__METHOD__, $data);

        } else {

            return $data;

        }

    }


    function getSomeSliders($aStart, $aLimit, $sort, $type, $searchName, $slider_type)
    {

        $sql = "SELECT c.`id`,";

        $sql .= " clar.`img` AS 'img_ar' ,";
        $sql .= " clar.`file_type` AS 'file_type_ar' ,";

        $sql .= " clen.`img` AS 'img_en' ,";
        $sql .= " clen.`file_type` AS 'file_type_en' ,";

        $sql .= " c.`date_added`,";

        $sql .= " c.`status`,";

        $sql .= " c.`title`,";

        $sql .= " c.`sort`,";

        $sql .= " u.`full_name` AS 'user_full_name'";

        $sql .= " FROM `sliders` c ";

        $sql .= " LEFT JOIN `sliders_langs` clar ON (c.`id` = clar.`slider_id` AND clar.`lang_code` = 'ar') ";

        $sql .= " LEFT JOIN `sliders_langs` clen ON (c.`id` = clen.`slider_id` AND clen.`lang_code` = 'en') ";

        $sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";

        $sql .= " WHERE c.`id` > 0   AND c.`type` = '{$slider_type}' ";

        $sql .= $searchName ? ' AND c.`title` like "%' . $searchName . '%"' : '';


        $sql .= $sort === 'sort' && $sort != 'name' ? " ORDER BY c.`sort` {$type}" : "";

        $sql .= $sort != 'sort' && $sort == 'name' ? " ORDER BY c.`title` {$type}" : "";

        $sql .= $sort != 'sort' && $sort != 'name' ? " ORDER BY c.{$sort} {$type}" : "";

        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

        return $this->mDb->getAll($sql);

    }


    function getSearchSlidersCount($sort, $type, $searchName, $slider_type)
    {

        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `sliders` c";

        $sql .= " LEFT JOIN `sliders_langs` cl ON c.`id` = cl.`slider_id` AND cl.`lang_code` = 'ar'";

        $sql .= " WHERE c.`id` > 0 AND c.`type` = '{$slider_type}' ";

        $sql .= $searchName ? ' AND c.`title` like "%' . $searchName . '%"' : '';


        $sql .= $sort === 'sort' && $sort != 'name' ? " ORDER BY c.`sort` {$type}" : "";

        $sql .= $sort != 'sort' && $sort == 'name' ? " ORDER BY c.`title` {$type}" : "";

        $sql .= $sort != 'sort' && $sort != 'name' ? " ORDER BY c.{$sort} {$type}" : "";

        // echo $sql; die();


        return $this->mDb->getOne($sql);

    }


    function getSlidersCount($slider_type)
    {

        $sql = "SELECT COUNT(`id`) as 'count' FROM `sliders` where `type` = '{$slider_type}' ";

        return $this->mDb->getOne($sql);

    }


    function addEditSlider($request, $imgar, $imgen, $stage_id)
    {


        $dataLangObj = json_decode($request['sliderLangObj']);

        $newDataLangObj = $this->convert_object_to_array($dataLangObj);


        unset($request['action']);

        unset($request['sliderLangObj']);


        $res = false;


        if ($stage_id === '' && $request['operation'] === 'add') {

            // Add

            unset($request['operation']);

            $dateTime = date('Y-m-d H:i:s');

            $type = $request['slider_type'] ? $request['slider_type'] : "slide";

            $sql = "INSERT INTO `sliders` SET ";

            $sql .= " `added_by` = '{$request['added_by']}',";

            $sql .= " `sort` = '{$request['sort']}',";
            
            $sql .= " `type` = '{$type}',";

            $sql .= " `title` = '{$request['title']}',";

            $sql .= " `url` = '{$request['url']}',";

            $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";

            $sql .= " `date_added` = '{$dateTime}'";


        // echo $sql; die();

            $this->mDb->query($sql);

            $last_stage_id = $this->mDb->getLastInsertId();

            if ($last_stage_id > 0) {

                foreach ($newDataLangObj as $key => $value) {

                    $value['img'] = $value['lang_code'] == 'ar' ? $imgar : $imgen;

                    $stmt = "INSERT INTO `sliders_langs`(`slider_id`, `lang_code`, `img`) ";

                    $stmt .= " VALUES ('{$last_stage_id}', '{$value['lang_code']}', '{$value['img']}')";

                    $res = $this->mDb->query($stmt);

                }

            }


            return $last_stage_id;

        } else {


            // Edit


            $check_query = "SELECT `id` FROM `sliders` WHERE `id` = '{$stage_id}'";

            $check_result = $this->mDb->getOne($check_query);


            if ($check_result === false) {


                return 403;


            } else {

                $type = $request['slider_type'] ? $request['slider_type'] : "slide";

                $sql = "UPDATE `sliders` SET ";

                $sql .= " `added_by` = '{$request['added_by']}', ";

                $sql .= " `sort` = '{$request['sort']}',";

                $sql .= " `type` = '{$type}',";

                $sql .= " `title` = '{$request['title']}',";

                $sql .= " `url` = '{$request['url']}',";

                $sql .= $request['status'] === 'true' ? " `status` = '1'" : " `status` = '0'";

                $sql .= " WHERE `id` = '{$stage_id}'";


//             echo $sql; die();

                $res = $this->mDb->query($sql);


                if ($imgar != '' && $imgar != null) {

                    // Delete old image from the server

                    $img_query = "SELECT `img` FROM `sliders_langs` WHERE `slider_id` = '{$stage_id}' AND `lang_code` ='ar'";

                    $img_result = $this->mDb->getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $img_result;

                    if (file_exists($old_img)) {

                        @unlink($old_img);

                    }

                    $stmt = "UPDATE `sliders_langs` SET";

                    $stmt .= " `img`='{$imgar}' ";

                    $stmt .= " WHERE `lang_code`='ar' AND `slider_id` = '{$stage_id}'";

                    $this->mDb->query($stmt);

                }

                if ($imgen != '' && $imgen != null) {

                    // Delete old image from the server

                    $img_query = "SELECT `img` FROM `sliders_langs` WHERE `slider_id` = '{$stage_id}' AND `lang_code` ='en'";

                    $img_result = $this->mDb->getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $img_result;

                    if (file_exists($old_img)) {

                        @unlink($old_img);

                    }

                    $stmt = "UPDATE `sliders_langs` SET";

                    $stmt .= " `img`='{$imgen}' ";

                    $stmt .= " WHERE `lang_code`='en' AND `slider_id` = '{$stage_id}'";

                    $this->mDb->query($stmt);

                }

                return $res;

            }

        }


    }


    function getOneSlider($id)
    {


        $result = array();

        $sql = "SELECT `id`, `added_by`,`status`, `sort` , `title`,`url`,`place_banner`, `country_id`, `stage_id`  FROM `sliders`";
        $sql .= " WHERE `id` = '{$id}'";

        $result = $this->mDb->getRow($sql);

        if ($result) {

            $stmt = "SELECT cl.`id`,cl.`lang_code`, cl.`img`,cl.`file_type` FROM `sliders_langs` cl";
            $stmt .= " WHERE cl.`slider_id` = '{$id}'";
            $result['langs'] = $this->mDb->getAll($stmt);

        }

        return $result;

    }

    function getStageByParentID($id)
    {

        $result = array();

        $sql = "SELECT c.`id`, cl.`img`, cl.`description` FROM `sliders` c";

        $sql .= " LEFT JOIN `sliders_langs` cl ON c.`id` = cl.`slider_id` ";

        $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='ar' ";

//    echo $sql;

        $result = $this->mDb->getAll($sql);

        return $result;


    }


    function deleteSlider($ids)
    {


        $tempids = '(' . implode(',', $ids) . ')';


        $sql = "SELECT `img` FROM `sliders_langs`";

        $sql .= " WHERE `slider_id` IN " . $tempids;

        $images = $this->mDb->getAll($sql);


        $sqll = "DELETE FROM `sliders_langs` ";

        $sqll .= " WHERE `slider_id` IN " . $tempids;


        $this->mDb->query($sqll);


        $catsql = "DELETE FROM `sliders` ";

        $catsql .= " WHERE `id` IN " . $tempids;


        if ($this->mDb->query($catsql)) {


            if (count($images) > 0) {

                for ($i = 0; $i < count($images); $i++) {

                   /* $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $images[$i]['img'];

                    if (file_exists($old_img)) {

                        @unlink($old_img);

                    }*/
                    
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $images[$i]['img'];
                        if (file_exists($old_img)) :
                            @unlink($old_img);
                        endif;

                        $old_img_thum = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/thums/' . $images[$i]['img'];
                        if (file_exists($old_img_thum)) :
                            @unlink($old_img_thum);
                        endif;
                         
                   

                }

            }

            return true;

        } else {

            return false;

        }

    }

    function addEditSliderGuestBanners($request, $imgs)
    {

        $oldFiles = json_decode($request['fileOld'], true);
        $newFiles = json_decode($request['files'], true);


        if ($request['operation'] === 'add') {
            $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `sliders` SET ";
            $sql .= " `added_by` = '{$request['added_by']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= $request['country_id'] ? " `country_id` = '{$request['country_id']}'," : "";
            $sql .= $request['stage_id'] ? " `stage_id` = '{$request['stage_id']}'," : "";
            $sql .= " `type` = '{$request['slider_type']}',";
            $sql .= " `title` = '{$request['title']}',";
            $sql .= " `url` = '{$request['url']}',";
            $sql .= " `status` = '{$request['status']}',";
            $sql .= " `place_banner` = '{$request['place_banner']}',";
            $sql .= " `date_added` = '{$dateTime}'";

            $this->mDb->query($sql);
            $last_stage_id = $this->mDb->getLastInsertId();
            if ($last_stage_id > 0) {
                
        // print_r($newFiles);die();
                foreach ($newFiles as $value) {
                    $stmt = "INSERT INTO `sliders_langs`(`slider_id`, `lang_code`, `img`,`file_type`) ";
                    $stmt .= " VALUES ('{$last_stage_id}', '{$value['file_code']}', '{$value['file_name']}','{$value['file_type']}')";
                    // echo $stmt;die();
                    $this->mDb->query($stmt);
                }
            }
            return $last_stage_id;
        } else {
            // Edit
            $check_query = "SELECT `id` FROM `sliders` WHERE `id` = '{$request['slider_id']}'";
            $check_result = $this->mDb->getOne($check_query);
            if ($check_result === false) {
                return 403;
            } else {

                $sql = "UPDATE `sliders` SET ";
                $sql .= " `added_by` = '{$request['added_by']}', ";
                $sql .= " `sort` = '{$request['sort']}',";
                $sql .= $request['country_id'] ? " `country_id` = '{$request['country_id']}'," : "";
                $sql .= $request['stage_id'] ? " `stage_id` = '{$request['stage_id']}'," : "";
                $sql .= " `title` = '{$request['title']}',";
                $sql .= " `url` = '{$request['url']}',";
                $sql .= " `place_banner` = '{$request['place_banner']}',";
                $sql .= " `status` = '{$request['status']}'";
                $sql .= " WHERE `id` = '{$request['slider_id']}'";
//             echo $sql; die();
                $res = $this->mDb->query($sql);
                foreach ($newFiles as $value) {
                    $stmt = "INSERT INTO `sliders_langs`(`slider_id`, `lang_code`, `img`,`file_type`) ";
                    $stmt .= " VALUES ('{$request['slider_id']}', '{$value['file_code']}', '{$value['file_name']}','{$value['file_type']}')";
                    // echo $sql;
                    $this->mDb->query($stmt);
                }

                /*    if ($imgar != '' && $imgar != null) {
                        // Delete old image from the server
                        $img_query = "SELECT `img` FROM `sliders_langs` WHERE `slider_id` = '{$stage_id}' AND `lang_code` ='ar'";
                        $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $img_result;
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }

                        $stmt = "UPDATE `sliders_langs` SET";
                        $stmt .= " `img`='{$imgar}' ";
                        $stmt .= " WHERE `lang_code`='ar' AND `slider_id` = '{$stage_id}'";
                        $this->mDb->query($stmt);
                    }*/

                /*if ($imgen != '' && $imgen != null) {
                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `sliders_langs` WHERE `slider_id` = '{$stage_id}' AND `lang_code` ='en'";
                    $img_result = $this->mDb->getOne($img_query);
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $img_result;
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $stmt = "UPDATE `sliders_langs` SET";
                    $stmt .= " `img`='{$imgen}' ";
                    $stmt .= " WHERE `lang_code`='en' AND `slider_id` = '{$stage_id}'";
                    $this->mDb->query($stmt);
                }*/

                return $res;
            }
        }
    }

    public function deleteFileInDataBase($temp)
    {
        // print_r($temp);die();
        $sql = "DELETE FROM `sliders_langs` ";
        $sql .= " WHERE `id` ='{$temp['id']}' ";
        $res = $this->mDb->query($sql);
        if ($res):
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/' . $temp['file_name'];
            // echo $old_img;die();
            if (file_exists($old_img)) :
                @unlink($old_img);
            endif;
            if ($temp['file_type'] == "image") :
                $old_img_thum = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'sliders/thums/' . $temp['file_name'];
                if (file_exists($old_img_thum)) :
                    @unlink($old_img_thum);
                endif;
            endif;
        endif;
        return $res;
    }

} ?>