<?php

$statisticsObj = new Statistics();

class Statistics {

    var $mDb;
    var $mConfig;

    function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function getHomeDriversLocations() {

        $result = array();
        $datenow = date('Y-m-d H:i:s');
        $yesterday = date('Y-m-d H:i:s', strtotime($datenow . ' - 1 days'));

        $sql = "SELECT ul.`user_id`,ul.`lat`,ul.`lon`,u.`full_name` FROM `user_location` ul";
        $sql .=" LEFT JOIN `users` u ON u.`id` = ul.`user_id` ";
        $sql .= " WHERE u.`id` > 0 AND u.`status`='1' AND u.`user_type` ='representative' AND  ( ul.`date_updated` BETWEEN '{$yesterday}'  AND '{$datenow}' )";
//  echo  $sql;die();
        $result = $this->mDb->getAll($sql);
        return $result;
    }

    function getHomeStatistics() {

        $result = array();
        // $sql_products = "SELECT COUNT(`id`) FROM `products`";
        // $result['products'] = $this->mDb->getOne($sql_products);

        // $sql_categories = "SELECT COUNT(`id`) FROM `categories`";
        // $result['categories'] = $this->mDb->getOne($sql_categories);

        // $sql_pages = "SELECT COUNT(`id`) FROM `pages`";
        // $result['pages'] = $this->mDb->getOne($sql_pages);

        $sql_units_test = "SELECT COUNT(`id`) FROM `units` WHERE mode='test'";
        $result['units_test'] = $this->mDb->getOne($sql_units_test);
        
        $sql_units_explanations = "SELECT COUNT(`id`) FROM `units` WHERE mode='explanations'";
        $result['units_explanations'] = $this->mDb->getOne($sql_units_explanations);

        // $sql_groups_count = "SELECT COUNT(`id`) FROM `groups` WHERE is_deleted = '0'";
        // $result['groups_count'] = $this->mDb->getOne($sql_groups_count);

        // $sql_bank = "SELECT COUNT(`id`) FROM `questions_bank`";
        // $result['questions_bank_count'] = $this->mDb->getOne($sql_bank);


        // $sql_languages = "SELECT COUNT(`id`) FROM `languages`";
        // $result['languages'] = $this->mDb->getOne($sql_languages);


        $sql_tests = "SELECT COUNT(`id`) FROM `tests` WHERE `is_deleted` != '1' ";
        $result['tests'] = $this->mDb->getOne($sql_tests);

        // $sql_countries = "SELECT COUNT(`id`) FROM `countries`";

        // $result['countries'] = $this->mDb->getOne($sql_countries);


        $sql_student = "SELECT COUNT(`id`) FROM `users` WHERE `user_type` ='student' ";
        $result['members_students'] = $this->mDb->getOne($sql_student);

        $sql_teacher = "SELECT COUNT(`id`) FROM `users` WHERE `user_type` ='teacher'  ";
        $result['members_teachers'] = $this->mDb->getOne($sql_teacher);

        $sql_parents = "SELECT COUNT(`id`) FROM `users` WHERE `user_type` ='parent'  ";
        $result['members_parents'] = $this->mDb->getOne($sql_parents);



        $sql_answers = "SELECT COUNT(sts.`id`) FROM `student_tests_answers` sts ";
        $sql_answers .= " LEFT JOIN `users` u ON u.id = sts.user_id ";
        $sql_answers .= " WHERE sts.`corrected` = '1' AND  sts.`test_status` = 'completed' AND u.is_visitor = '0'";
        $result['students_answers_count'] = $this->mDb->getOne($sql_answers);
        
        
        $sql_answers = "SELECT COUNT(sts.`id`) FROM `student_tests_answers` sts ";
        $sql_answers .= " LEFT JOIN `users` u ON u.id = sts.user_id ";
        $sql_answers .= " WHERE sts.`corrected` = '1' AND  sts.`test_status` = 'completed' AND u.is_visitor = '1' ";
        $result['visitors_answers_count'] = $this->mDb->getOne($sql_answers);


        $sql_management = "SELECT COUNT(`id`) FROM `users` WHERE `user_level` IS NOT NULL  ";
        $result['management'] = $this->mDb->getOne($sql_management);

        $sql_user_levels = "SELECT COUNT(`id`) FROM `user_levels` ";
        $result['user_levels'] = $this->mDb->getOne($sql_user_levels);

        $sql_stages = "SELECT COUNT(`id`) FROM `stages` WHERE is_deleted != '1' AND status = '1'";
        $result['stages'] = $this->mDb->getOne($sql_stages);
      
        $sql_courses = "SELECT COUNT(`id`) FROM `courses` WHERE is_deleted = '0'  ";
        $result['courses'] = $this->mDb->getOne($sql_courses);

        $sql_grades = "SELECT COUNT(`id`) FROM `grades`";
        $result['grades'] = $this->mDb->getOne($sql_grades);


        return $result;
    }

}

?>