<?php

$StudentsAnswersObj = new StudentsAnswers();

class StudentsAnswers
{

    var $mDb;
    var $mConfig;
    var $mMailer;
    var $lang;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mMailer = new Mailer(); 
        $this->questions_table = ["1" => "first_primary","2" => "second_primary",
                    "4" => "third_primary",
                    "9" => "fourth_primary", "10" => "fifth_primary",
                    "11" => "sixth_primary","12" => "first_middle",
                    "13" => "second_middle","14" => "third_middle",
                    "15" => "second_secondary", "16" => "first_secondary",
                    "17" => "third_secondary", "22" => "experimental"];
                    
        $this->lang = LANGUAGE;
    }

    function getSomeStudentsAnswers($aStart, $aLimit, $sort, $type, $searchId, $searchName, $searchStatus, $searchDateFrom, $searchDateTo, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester,$searchUnit,$searchLesson,$searchUserId,$visitors=null)
    {

        $sql = "SELECT o.*, ";
        $sql .= " t.`name` AS 'test_name' ,";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " unit.`name` as 'unit_name' , ";
        $sql .= " unitLesson.`name` as 'lesson_name' , ";
        $sql .= " subject.`name` as 'subject_name' ,";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `student_tests_answers` o ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = o.`user_id` ";
        $sql .= " LEFT JOIN `tests` t ON t.`id` = o.`test_id` ";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( t.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( t.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( t.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = '{$this->lang}')";
        $sql .= " LEFT JOIN `units` unit ON  ( t.`unit_id` = unit.`id`)";
        $sql .= " LEFT JOIN `unit_lessons` unitLesson ON  ( t.`lesson_id` = unitLesson.`id`)";
        $sql .= " LEFT JOIN `subjects` subject ON  ( t.`subject_id` = subject.`id`)";
        $sql .= " WHERE o.`id` > 0 AND o.`corrected` = '1' AND  o.`test_status` = 'completed' ";
        $sql .= $visitors == 'visitors' ? " AND u.is_visitor = '1' " : " AND u.is_visitor = '0' ";
        $sql .= $searchUserId ? ' AND u.`id` = "' . $searchUserId . '"' : '';
        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchCountry ? " AND t.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND t.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND t.`grade_id` = '{$searchGrade}'" : "";
        $sql .= $searchUnit ? " AND t.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND t.`lesson_id` = '{$searchLesson}'" : "";
        $sql .= $searchSubject ? " AND t.`subject_id` = '{$searchSubject}'" : "";
        $sql .= $searchName ? ' AND u.`full_name` like "%' . $searchName . '%"' : '';
        $sql .= $searchStatus ? ' AND o.`status` = "' . $searchStatus . '"' : '';
        $sql .= $searchTestSemester ? ' AND t.`semester` = "' . $searchTestSemester . '"' : '';
        $sql .= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= " AND u.`user_type` = 'student' " ;
        $sql .= " ORDER BY o.`id` {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//   echo $sql;  die();
        return $this->mDb->getAll($sql);
    }
    
    
    function getSomeVisitordata($aStart, $aLimit, $sort, $type, $searchId, $searchName, $searchStatus, $searchDateFrom, $searchDateTo, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester,$searchUnit,$searchLesson,$searchUserId,$visitors)
    {

        $sql = "SELECT u.full_name, u.mobile ";
        $sql .= " FROM `student_tests_answers` o ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = o.`user_id` ";
        $sql .= " LEFT JOIN `tests` t ON t.`id` = o.`test_id` ";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( t.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( t.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( t.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = '{$this->lang}')";
        $sql .= " LEFT JOIN `units` unit ON  ( t.`unit_id` = unit.`id`)";
        $sql .= " LEFT JOIN `unit_lessons` unitLesson ON  ( t.`lesson_id` = unitLesson.`id`)";
        $sql .= " LEFT JOIN `subjects` subject ON  ( t.`subject_id` = subject.`id`)";
        $sql .= " WHERE o.`id` > 0 AND o.`corrected` = '1' AND  o.`test_status` = 'completed' ";
        $sql .= $visitors == 'visitors' ? " AND u.is_visitor = '1' " : " AND u.is_visitor = '0' ";
        $sql .= $searchUserId ? ' AND u.`id` = "' . $searchUserId . '"' : '';
        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchCountry ? " AND t.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND t.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND t.`grade_id` = '{$searchGrade}'" : "";
        $sql .= $searchUnit ? " AND t.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND t.`lesson_id` = '{$searchLesson}'" : "";
        $sql .= $searchSubject ? " AND t.`subject_id` = '{$searchSubject}'" : "";
        $sql .= $searchName ? ' AND u.`full_name` like "%' . $searchName . '%"' : '';
        $sql .= $searchStatus ? ' AND o.`status` = "' . $searchStatus . '"' : '';
        $sql .= $searchTestSemester ? ' AND t.`semester` = "' . $searchTestSemester . '"' : '';
        $sql .= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= " AND u.`user_type` = 'student' " ;
        $sql .= " ORDER BY o.`id` {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//   echo $sql;  die();
        $data = $this->mDb->getAll($sql);
        // print_r($data);die();
        $books = [
        ['name', 'mobile']
        ];
        foreach ($data as $row) {
            $books[] = $row;
        }
        return $books;
    }

    function getSearchStudentsAnswersCount($aStart, $aLimit, $sort, $type, $searchId, $searchName, $searchStatus, $searchDateFrom, $searchDateTo, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester,$searchUnit,$searchLesson,$searchUserId,$visitors=null)
    {
        $sql = "SELECT COUNT(o.`id`) as 'result_count' FROM `student_tests_answers` o";
        $sql .= " LEFT JOIN `users` u ON u.`id` = o.`user_id` ";
        $sql .= " LEFT JOIN `tests` t ON t.`id` = o.`test_id` ";
        $sql .= " WHERE o.`id` > 0 AND o.`corrected` = '1' AND  o.`test_status` = 'completed' ";
        $sql .= $visitors == 'visitors' ? " AND u.is_visitor = '1' " : " AND u.is_visitor = '0' ";
        $sql .= $searchUserId ? ' AND u.`id` = "' . $searchUserId . '"' : '';
        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchName ? ' AND u.`full_name` like "%' . $searchName . '%"' : '';
        $sql .= $searchStatus ? ' AND o.`status` = "' . $searchStatus . '"' : '';
        $sql .= $searchCountry ? " AND t.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchTestSemester ? ' AND t.`semester` = "' . $searchTestSemester . '"' : '';
        $sql .= $searchStage ? " AND t.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND t.`grade_id` = '{$searchGrade}'" : "";
         $sql .= $searchUnit ? " AND t.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND t.`lesson_id` = '{$searchLesson}'" : "";
        $sql .= $searchSubject ? " AND t.`subject_id` = '{$searchSubject}'" : "";
        $sql .= " AND u.`user_type` = 'student' " ;
        $sql .= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
        $sql .= " ORDER BY o.`id` {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	echo $sql; die();

        return $this->mDb->getOne($sql);
    }


    function getStudentsAnswersCount($searchId, $searchName, $searchStatus, $searchDateFrom, $searchDateTo, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester,$searchUnit,$searchLesson,$searchUserId,$visitors=null)
    {
        $sql = "SELECT COUNT(o.`id`) as 'count' FROM `student_tests_answers` o   ";
        $sql .= " LEFT JOIN `users` u ON  u.`id` = o.`user_id` ";
        $sql .= " LEFT JOIN `tests` t ON  t.`id` = o.`test_id` ";
        $sql .= " where  o.`id` > 0   AND o.`corrected` = '1' AND  o.`test_status` = 'completed' ";
        $sql .= $visitors == 'visitors' ? " AND u.is_visitor = '1' " : " AND u.is_visitor = '0' ";
        $sql .= $searchUserId ? ' AND u.`id` = "' . $searchUserId . '"' : '';
        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchName ? ' AND u.`full_name` like "%' . $searchName . '%"' : '';
        $sql .= $searchStatus ? ' AND o.`status` = "' . $searchStatus . '"' : '';
        $sql .= $searchCountry ? " AND t.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchTestSemester ? ' AND t.`semester` = "' . $searchTestSemester . '"' : '';
        $sql .= $searchStage ? " AND t.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND t.`grade_id` = '{$searchGrade}'" : "";
           $sql .= $searchUnit ? " AND t.`unit_id` = '{$searchUnit}'" : "";
        $sql .= $searchLesson ? " AND t.`lesson_id` = '{$searchLesson}'" : "";
        $sql .= $searchSubject ? " AND t.`subject_id` = '{$searchSubject}'" : "";
        $sql .= " AND u.`user_type` = 'student' " ;
        $sql .= $searchDateFrom ? " AND o.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
    //   echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function getOneStudentsTestAnswer($id)
    {

        $sql = "SELECT o.*, u.`full_name` AS 'user_full_name',u.`mobile` AS 'user_mobile' ";
        $sql .= " FROM `student_tests_answers` o";
        $sql .= " LEFT JOIN `users` u ON u.`id` = o.`user_id` ";
        $sql .= " WHERE o.`id` = '{$id}' ";
//   echo $sql;
//    die();
        $res = $this->mDb->getRow($sql);

        if (!empty($res)) {

            $res['tests_details'] = $this->getTestDetailsInfo($id, $res['test_id']);


            $res['student_answers'] = $this->getAllStudent_tests_answers_details($id, $res['test_id']);

        }

        return $res;

    }


    function getAnswesOfQuestions($student_tests_answers_id, $question_id, $resulte_qustions)
    {
        // echo "<pre>";
        // echo $student_tests_answers_id."--". $question_id."--". $resulte_qustions;
        // echo "</pre>";
        // echo "<hr/>";
        
        $sql = "SELECT  student_option ,student_answer_details, answer , question_id  ,id , question_type ,answer_degree ";
        $sql .= $resulte_qustions ? "  , status , right_option  " : " ";
        $sql .= "  FROM `student_tests_answers_details`  ";
        $sql .= " WHERE  `student_tests_answers_id` = '{$student_tests_answers_id}' AND `question_id` = '{$question_id}'";
    //   echo '<pre>'.$sql.'</pre>';
        // die();
        $answer = $this->mDb->getRow($sql);
        if ($answer) {
            if ($answer['question_type'] == 'article') {
                $answer['answer_attachments'] = $this->getAnswersAttachments($answer['id']);
            }
            if ($answer['question_type'] == 'choose' || $answer['question_type'] == 'check') {
                $answer['student_answer_details'] = json_decode($answer['student_answer_details'], true);
            }

        }
        return $answer;
    }

    function getAnswersAttachments($student_tests_answers_details_id)
    {
        $sql = "SELECT `file`,`attachment_type` FROM `student_tests_answers_details_attachments` ";
        $sql .= " WHERE  `student_tests_answers_details_id` = '{$student_tests_answers_details_id}' ";
         //echo  $sql;
        return $this->mDb->getAll($sql);
    }


    function getAllStudent_tests_answers_details($student_tests_answers_id, $test_id)
    {
        $sql = "SELECT  `question_id`,`right_option`,`student_option`,`question_type`,`answer`,`status` ,`answer_degree`,`student_answer_details` FROM `student_tests_answers_details`  staw ";
        $sql .= " WHERE staw.`student_tests_answers_id` ='{$student_tests_answers_id}'";

        $result = $this->mDb->getAll($sql);
        if (!empty($result)) {
            for ($ii = 0; $ii < count($result); $ii++) {
                $result[$ii]['question'] = $this->getOneQuestion($result[$ii]['question_id'], $test_id);
                if ($result[$ii]['question_type'] == 'choose' || $result[$ii]['question_type'] == 'check') {
                    $result[$ii]['student_answer_details'] = json_decode($result[$ii]['student_answer_details'], true);
                }
            }
        }
        return $result;
    }

    function getOneQuestion($id, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        // echo $table;die();
        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `".$table."_test_questions` pl";
        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`id` = '{$id}' AND pl.`parent_id` = '0'";
        $result = $this->mDb->getRow($stmt);
        if (count($result) > 0) {
            $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['id']}' AND  qattachfile.`option_id`=tqo.`id`  AND related_to = 'option')";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['id']}' AND  qattachfilenote.`option_id`=tqo.`id`  AND qattachfilenote.`related_to` = 'note')";
            $stmto .= " WHERE tqo.`test_question_id` = " . $result['id'];
//            echo $stmto;die();
            $result['test_question_options'] = $this->mDb->getAll($stmto);
            if ($result['type'] == 'paragraphs') {
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`test_id` = '{$result['test_id']}' AND pl.`parent_id` = '{$result['id']}'";
//                    echo $stmt;die();
                $result['question_sub_questions'] = $this->mDb->getAll($stmt);

                if (count($result['question_sub_questions']) > 0) {
                    for ($iisub = 0; $iisub < count($result['question_sub_questions']); $iisub++) {
                        $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' AND  qattachfile.`option_id`=tqo.`id`  AND qattachfile.`related_to` = 'option')";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' AND  qattachfilenote.`option_id`=tqo.`id`  AND qattachfilenote.`related_to` = 'note')";
                        $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);


                        if ($result['question_sub_questions'][$iisub]['type'] == 'match_it') {
                            $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);
                        }
                        if ($result['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                            $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
                            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);
                        }

                    }
                }
            }

            if ($result['type'] == 'match_it') {
                $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['match_questions_items'] = $this->mDb->getAll($stmt);

            }

            if ($result['type'] == 'sort_it') {
                $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['sort_questions_words'] = $this->mDb->getAll($stmt);

            }

        }
        return $result;
    }


    function deleteOrder($ids)
    {

        $tempids = '(' . implode(',', $ids) . ')';

        $catsql = "DELETE FROM `student_tests_answers` ";
        $catsql .= " WHERE `id` IN " . $tempids;

        $res = $this->mDb->query($catsql);


        return $res;
    }

    function changeOrderStatus($request)
    {

        //  print_r($request);

        $sqle = "SELECT o.`id`,u.`full_name`,u.`email` ";
        $sqle .= " FROM `student_tests_answers` o ";
        $sqle .= " LEFT JOIN `users` u ON u.`id` = o.`user_id` ";
        $sqle .= " WHERE o.`id` ='{$request['id']}'";
        $data = $this->mDb->getRow($sqle);

        $res = false;
        $status = '';

        if ($request['status'] === 'canceled') {
            // Update Status
            $sql = "UPDATE `student_tests_answers` SET ";
            $sql .= " `status`='canceled', `rejected_reason`='{$request['rejected_reason']}' ";
            $sql .= " WHERE `id`='{$request['id']}' ";
            $res = $this->mDb->query($sql);
            $status = " طلب ملغي وسبب الالغاء هو" . " " . $request['rejected_reason'];

        } elseif ($request['status'] === 'completed' || $request['status'] === 'shipped') {
            // Update Status
            $sql = "UPDATE `student_tests_answers` SET ";
            $sql .= " `status`='{$request['status']}' ";
            $sql .= " WHERE `id`='{$request['id']}' ";
            $res = $this->mDb->query($sql);
            $status = $request['status'] === 'completed' ? "مكتمل" : "تحت التنفيذ";

        }

        $res = $this->seandToAdminNewOrderEmail($request['id'], $data['email'], $data['full_name'], $status);

        return $res;

    }

    function seandToAdminNewOrderEmail($order_id, $useremail, $username, $status)
    {

        $subject = "عزيزي" . " " . " " . $username . " " . " ";
        $subject .= "تم تغيير حالة طلبك" . "" . " ";

        $msg = " <div style =\" padding-right: 15px;  float: right; text-align: right;\">";
        $msg .= " <h2>   تم تغيير حالة طلبك رقم    " . " <span>$order_id</span>" . "</h2>";
        $msg .= " <h2>   الى    " . " <span>$status</span>" . "</h2>";
        $msg .= " <h2>   يرجي مراجعة الادارة    " . " <span></span>" . "</h2>";

        $msg .= " </div>";

        $adminemail = $this->mConfig['site_email'];

        $send = $this->mMailer->sendEmail($useremail, $subject, $msg, $adminemail, $adminemail);
        return $send;
    }

    function getGradeIdOfTest($test_id){
        $sql = "SELECT grade_id FROM `tests` WHERE id = '{$test_id}' ";
        return $this->mDb->getOne($sql);
    }

    /*%%%%%%%%%%%%%%%%%New Methods In Class%%%%%%%%%%%%%%%%%*/
    function getTestDetailsInfo($answer_id, $id)
    {

        $result = array();

        $sql = "SELECT te.id,te.type,te.dedicated_to,te.set_from,te.teacher_id,te.classification ,te.sort, te.status, te.printable, te.date_added, te.name, u.full_name AS 'user_full_name' , teacher.full_name AS 'teacher_full_name' , ";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gradel.`name` as 'grade_name' , ";
        $sql .= " unitl.`name` as 'unit_name' , ";
        $sql .= " lessonl.`name` as 'lesson_name' , ";
        $sql .= " subjectt.`name` as 'subject_name',";
        $sql .= " subjectt.`subject_direction` as 'subject_direction'";
        $sql .= " FROM `tests` te";
        $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
        $sql .= " LEFT JOIN `users` teacher ON teacher.id = te.teacher_id ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = '{$this->lang}')";
        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = '{$this->lang}') ";
        $sql .= " WHERE te.id ='{$id}' ";

        $result = $this->mDb->getRow($sql);

        if (count($result) > 0) {
            $table = $this->questions_table[$this->getGradeIdOfTest($id)];

            $stmt = "SELECT pl.*,qattachfile.`file`,qattachfile.`attachment_type` FROM `".$table."_test_questions` pl";
            $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
            $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '0' order by pl.`id` ASC";
// echo $stmt;die();
            $result['test_questions'] = $this->mDb->getAll($stmt);

            if (count($result['test_questions']) > 0) {
                $qindex = 0;
                for ($ii = 0; $ii < count($result['test_questions']); $ii++) {
                    $stmto = "SELECT tqo.`id`,tqo.`status`,tqo.`title` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                    $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}' AND  qattachfile.`option_id`=tqo.`id`  AND related_to = 'option')";
                    $stmto .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['id']}' ";
                    $result['test_questions'][$ii]['test_question_options'] = $this->mDb->getAll($stmto);
                    $result['test_questions'][$ii]['question_answer'] = $this->getAnswesOfQuestions($answer_id, $result['test_questions'][$ii]['id'], true);
                    if ($result['test_questions'][$ii]['type'] == 'paragraphs') {
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'";
                        $result['test_questions'][$ii]['question_sub_questions'] = $this->mDb->getAll($stmt);

                        if (count($result['test_questions'][$ii]['question_sub_questions']) > 0) {
                            for ($iisub = 0; $iisub < count($result['test_questions'][$ii]['question_sub_questions']); $iisub++) {
                                $stmtosub = "SELECT tqo.`id` ,tqo.`title`,tqo.`status` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                                $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' AND  qattachfile.`option_id`=tqo.`id`  AND related_to = 'option')";
                                $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->mDb->getAll($stmtosub);
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['question_answer'] = $this->getAnswesOfQuestions($answer_id, $result['test_questions'][$ii]['question_sub_questions'][$iisub]['id'], true);

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                    $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    //                    echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this->mDb->getAll($stmt);

                                }

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                    $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                                    $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                    //                    echo $stmt;die();
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this->mDb->getAll($stmt);

                                }

                                if (
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'choose' ||
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'check'
                                ) {
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this->getQuestionOptions($result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']);
                                }

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it') {
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_match_options'] = $this->getQuestionMatch_it($result['test_questions'][$ii]['test_questions_paragraphs'][$iisub]['id']);
                                }

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it') {
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_sort_words'] = $this->getQuestionSort_it($result['test_questions'][$i]['question_sub_questions'][$iisub]['id']);
                                }

                                if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it' ||
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct' ||
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_manual_correct'
                                ) {
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['degree'] = $this->getSumOfDegreeOfQuestionsByParent($result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']);
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'] = $this->getTestQuestion($id, $result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']);
                                    $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_words'] = [];

                                    if ($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it' || $result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'complete_it_writing_auto_correct') {
                                        for ($l = 0; $l < count($result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub']); $l++) {
                                            $array2 = $this->getQuestionComplete_words($result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['id']);
                                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['test_questions_complete_it_words'] = $array2;
                                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_words'] = array_merge($result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_words'], $array2);
                                            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['title_show'] = $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_it_sub'][$l]['title'];
                                        }

                                    }

                                }

                            }

                        }
                        $result['test_questions'][$ii]['question_sub_questions'] = array_values($result['test_questions'][$ii]['question_sub_questions']);
                    }


                    if ($result['test_questions'][$ii]['type'] == 'match_it') {
                        $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['match_questions_items'] = $this->mDb->getAll($stmt);

                    }

                    if ($result['test_questions'][$ii]['type'] == 'sort_it') {
                        $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                        $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['sort_questions_words'] = $this->mDb->getAll($stmt);

                    }
                    

                    if ($result['test_questions'][$ii]['type'] == 'complete_it' || $result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct' || $result['test_questions'][$ii]['type'] == 'complete_it_writing_manual_correct') {
                        $result['test_questions'][$ii]['degree'] = $this->getSumOfDegreeOfQuestionsByParent($result['test_questions'][$ii]['id']);
                        $result['test_questions'][$ii]['test_questions_complete_it_sub'] = $this->getTestQuestion($id, $result['test_questions'][$ii]['id']);
                        $result['test_questions'][$ii]['test_questions_complete_it_words'] = [];

                        if ($result['test_questions'][$ii]['type'] == 'complete_it' || $result['test_questions'][$ii]['type'] == 'complete_it_writing_auto_correct') {
                             
                            for ($k = 0; $k < count($result['test_questions'][$ii]['test_questions_complete_it_sub']); $k++) {
                                $array2 = $this->getQuestionComplete_words($result['test_questions'][$ii]['test_questions_complete_it_sub'][$k]['id']);
                                $result['test_questions'][$ii]['test_questions_complete_it_sub'][$k]['test_questions_complete_it_words'] = $array2;
                                                               $result['test_questions'][$ii]['test_questions_complete_it_words'] = array_merge($result['test_questions'][$ii]['test_questions_complete_it_words'], $array2);
                                $result['test_questions'][$ii]['test_questions_complete_it_sub'][$k]['title_show'] = $result['test_questions'][$ii]['test_questions_complete_it_sub'][$k]['title'];
                            }
                        }
                        $result['test_questions'][$ii]['test_questions_complete_it_sub'] = array_values($result['test_questions'][$ii]['test_questions_complete_it_sub']);
                    }


                    if ($result['test_questions'][$ii]['type'] != 'head_question') {
                        $qindex++;
                        $result['test_questions'][$ii]['index'] = $qindex;
                    } else {
                        $result['test_questions'][$ii]['index'] = 0;
                    }

                }

            }
        }

        return $result;
    }

    function getQuestionOptions($question_id)
    {
        $sql = "SELECT  `id`, `title` ,`math_type_view_title` ";
        $sql .= " ,`status`  , `note`  ";
        $sql .= " FROM `test_question_options`  ";
        $sql .= " WHERE  `test_question_id` ='{$question_id}' ";
        //  echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {


            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_OptionTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }


            $res[$i]['option_attachments'] = $this->getTestQuestionAttachments($question_id, $res[$i]['id'], 'option');
        }
        return $res;
    }

    function updateMathViewTest_question_OptionTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `test_question_options` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getTestQuestionAttachments($question_id, $option_id, $related_to)
    {
        $sql = "SELECT `file`,`attachment_type` , `id`  FROM `test_question_attachments` ";
        $sql .= " WHERE  `question_id` = '{$question_id}' AND `related_to` = '{$related_to}' ";
        $sql .= $option_id ? " AND `option_id` = '{$option_id}'   " : " ";
        $res = $this->mDb->getAll($sql);
        $res = getFileSizeArr($res, 'questions_attachments');
        return $res;
    }

    function getQuestionMatch_it($question_id)
    {
        $sql = "SELECT `id`,  title1, math_type_view_title1 , title2 ,math_type_view_title2 , image1, image2  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql .= " ORDER BY righte_index2 asc  ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title1'] || !$res[$i]['math_type_view_title2']) {
                $res[$i]['math_type_view_title1'] = renderMathType($res[$i]['title1']);
                $res[$i]['math_type_view_title2'] = renderMathType($res[$i]['title2']);
                $this->updateMathViewTest_question_test_match_itemsTitle($res[$i]['id'], $res[$i]['math_type_view_title1'], $res[$i]['math_type_view_title2']);
            }
        }

        return $res;
    }

    function updateMathViewTest_question_test_match_itemsTitle($id, $math_type_view_title1, $math_type_view_title2)
    {
        if ($id) {
            $sql = "UPDATE `test_questions_match_items` set math_type_view_title1 = '{$math_type_view_title1}' ,  math_type_view_title2 = '{$math_type_view_title2}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getQuestionSort_it($question_id)
    {
        $sql = "SELECT  `id`, `title` ,`math_type_view_title` ,`word_index` ";
        $sql .= " FROM `test_questions_sort_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql .= "  ORDER BY id asc ";
        $res = $this->mDb->getAll($sql);

        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_sort_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function updateMathViewTest_question_sort_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `test_questions_sort_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getSumOfDegreeOfQuestionsByParent($parent_id)
    {
        $sql = "SELECT SUM(degree) From test_questions ";
        $sql .= "where `parent_id`= '{$parent_id}'  AND type!='break'  AND type != 'head_question' AND type != 'paragraphs' AND type != 'complete_it'  AND type != 'complete_it_writing_auto_correct' AND type != 'complete_it_writing_manual_correct'    ";
        return $this->mDb->getOne($sql);
    }

    function getTestQuestion($test_id, $parent_id)
    {
        $sql = "SELECT pl.* ,pl.id as question_id FROM `test_questions` pl";
        $sql .= " WHERE pl.`test_id` = '{$test_id}'";
        $sql .= " AND pl.`parent_id` = '{$parent_id}'";
        $sql .= " ORDER BY pl.`id` ASC";
        // echo $sql;
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewTest_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }


            $res[$i]['question_attachments'] = $this->getTestQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getTestQuestionAttachments($res[$i]['id'], '', 'note');
        }
        return $res;
    }

    function updateMathViewTest_questionsTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `test_questions` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewTest_questionsNote($id, $math_type_view_note)
    {

        if ($id) {
            $sql = "UPDATE `test_questions` set math_type_view_note = '{$math_type_view_note}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getQuestionComplete_words($question_id)
    {
        $sql = "SELECT  `id`,`question_id`, `title` ,`math_type_view_title` ,`word_index` ";
        $sql .= " FROM `test_questions_complete_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql .= "  ORDER BY rand()  ";
        // echo $sql;
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_complete_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function updateMathViewTest_question_complete_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `test_questions_complete_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            // p($sql);

            $this->mDb->query($sql);
        }
    }
    /*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

}
