<?php

$subjectObj = new Subjects();

class Subjects
{

    var $mDb;
    var $mConfig;
    var $lang;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
    }

    function getSomeSubjects($aStart, $aLimit, $sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSpecialize)
    {
        $sql = "SELECT sub.id, sub.name,sub.img,sub.specialize_id ,sub.sort,sub.semester,sub.separate_subject,sub.status, sub.date_added, u.full_name AS 'user_full_name' ,";
        $sql .= " cuntl.`name` as 'country_name',";
        $sql .= " stagel.`name` as 'stage_name',";
        $sql .= " gpl.`name` as 'specialize',";
        $sql .= " gradel.`name` as 'grade_name'";
        $sql .= "  FROM `subjects` sub ";
        $sql .= " LEFT JOIN `grades_langs` gradel ON  ( sub.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = '{$this->lang}')";
        $sql .= " LEFT JOIN `grades_langs` gpl ON ( sub.specialize_id = gpl.`grade_id`  AND gpl.`lang_code` = '{$this->lang}' )";
        $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( sub.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `stages_langs` stagel ON  ( sub.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = '{$this->lang}') ";
        $sql .= " LEFT JOIN `users` u ON u.id = sub.added_by ";
        $sql .= " WHERE sub.id > 0 AND sub.`is_deleted` = '0'";
        $sql .= $searchName ? ' AND sub.name like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? " AND sub.`country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND sub.`stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND sub.`grade_id` = '{$searchGrade}'" : "";
        $sql .= $searchSemester ? " AND sub.`semester` = '{$searchSemester}'" : "";
        $sql .= $searchSpecialize ? " AND sub.`specialize_id` = '{$searchSpecialize}'" : "";
        $sql .= " ORDER BY sub.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchSubjectsCount($sort, $type, $searchName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSpecialize)
    {
        $sql = "SELECT COUNT(`id`) as 'result_count' FROM `subjects`";
        $sql .= " WHERE `id` > 0 AND `is_deleted` = '0'";

        $sql .= $searchName ? ' AND `name` like "%' . $searchName . '%"' : '';
        $sql .= $searchCountry ? " AND `country_id` = '{$searchCountry}'" : "";
        $sql .= $searchStage ? " AND `stage_id` = '{$searchStage}'" : "";
        $sql .= $searchGrade ? " AND `grade_id` = '{$searchGrade}'" : "";
        $sql .= $searchSemester ? " AND `semester` = '{$searchSemester}'" : "";
        $sql .= $searchSpecialize ? " AND sub.`specialize_id` = '{$searchSpecialize}'" : "";
        $sql .= " ORDER BY {$sort} {$type}";

//	echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getSubjectsCount()
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `subjects` WHERE `id` > 0 AND `is_deleted` = '0'";
        return $this->mDb->getOne($sql);
    }

    function addEditSubject($request, $img, $lang_id, $tempBranches = [])
    {
        
        unset($request['action']);
        $request['cover_color'] = $request['cover_color'] ? $request['cover_color'] : "#be393c";
        if ($lang_id === '') {
            // Add
            unset($request['userType']);
            unset($request['operation']);
            $dateTime = date('Y-m-d H:i:s');
            // print_r($img); die();
            $sql = "INSERT INTO `subjects` SET ";
            $sql .= " `added_by` = '{$request['user_id']}',";
            $sql .= " `country_id` = '{$request['country_id']}',";
            $sql .= " `stage_id` = '{$request['stage_id']}',";
            $sql .= " `grade_id` = '{$request['grade_id']}',";
            $sql .= " `semester` = '{$request['semester']}',";
            $sql .= " `separate_subject` = '{$request['separate_subject']}',";
            $sql .= " `subject_direction` = '{$request['subject_direction']}',";
            $sql .= $request['specialize'] > 0 ? " `specialize_id` = '{$request['specialize']}'," : "";
            $sql .= " `name` = '{$request['name']}',";
            $sql .= " `description_ar` = '{$request['description_ar']}',";
            $sql .= " `description_en` = '{$request['description_en']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
            $sql .= $request['show_in_home'] === 'true' ? " `show_in_home` = '1'," : " `show_in_home` = '0',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= " `cover_color` = '{$request['cover_color']}',";
            $sql .= " `img` = '{$img}', ";
            $sql .= "`dont_show_branches_in_general_tests` = '{$request['dont_show_branches_in_general_tests']}'";
//         echo $sql; die();
            $lastSubjectId = $this->mDb->queryReturnLastId($sql);

           $this -> addFields($request['fields'], $lastSubjectId);
        
           if (isset($request['allBranches']) && count($request['allBranches']) > 0) {
                $this -> addBranches($request['allBranches'], $lastSubjectId, $tempBranches);
            }

            return true;
        } else {

            // Edit

            // print_r($tempBranches);die();

            $check_query = "SELECT `id` FROM `subjects` WHERE `id` = '{$lang_id}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {

                return 403;

            } else {

                // print_r($img);die();
                $sql = "UPDATE `subjects` SET ";
                $sql .= " `added_by` = '{$request['user_id']}',";
                $sql .= " `country_id` = '{$request['country_id']}',";
                $sql .= " `stage_id` = '{$request['stage_id']}',";
                $sql .= " `grade_id` = '{$request['grade_id']}',";
                $sql .= " `semester` = '{$request['semester']}',";
                $sql .= " `separate_subject` = '{$request['separate_subject']}',";
                $sql .= " `subject_direction` = '{$request['subject_direction']}',";
                $sql .= $request['specialize'] > 0 ? " `specialize_id` = '{$request['specialize']}'," : "";
                $sql .= " `sort` = '{$request['sort']}',";
                $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
                $sql .= $request['show_in_home'] === 'true' ? " `show_in_home` = '1'," : " `show_in_home` = '0',";
                $sql .= " `description_ar` = '{$request['description_ar']}',";
                $sql .= " `description_en` = '{$request['description_en']}',";
                $sql .= " `cover_color` = '{$request['cover_color']}',";
                $sql .= "`name`='{$request['name']}', ";
                $sql .= "`dont_show_branches_in_general_tests` = '{$request['dont_show_branches_in_general_tests']}'";

                if ($img != '' || $img != null) {

                    // Delete old image from the server
                    $img_query = "SELECT `lang_image` FROM `subjects` WHERE `id` = '{$lang_id}'";
                    $img_result = $this->mDb->getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'subjects/' . $img_result;

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $sql .= ",`img`='{$img}' ";
                }

                $sql .= " WHERE `id` = '{$lang_id}'";
//  echo $sql; die();
                $resEd = $this->mDb->query($sql);


                $stmtrtrt = "DELETE FROM `fields_of_study_subjects` WHERE `subject_id` = '{$lang_id}'";

                // echo $stmt; die();
                $this->mDb->query($stmtrtrt);

                //  print_r(count($request['fields']));die();
                if (isset($request['fields']) && count($request['fields']) > 0) {
                    $this -> addFields($request['fields'], $lang_id);
                }


                if (isset($request['allBranches']) && count($request['allBranches']) > 0) {
                    for ($i = 0; $i < count($request['allBranches']); $i++) {

                        if ($request['allBranches'][$i]->id) {
                    // print_r($request['allBranches']);die();

                            $stmt1 = "SELECT * FROM `subjects_branches` where id = '{$request['allBranches'][$i]->id}'";
                            $res = $this->mDb->getRow($stmt1);
                            $id_of_branch = $res['id'];
                            $roww = $res;
                            // print_r($tempBranches);die();
                            if($tempBranches[$request['allBranches'][$i]->img]){
                    
                                $stmt2 = "UPDATE `subjects_branches` SET ";
                                $stmt2 .="`image` = '{$tempBranches[ $request['allBranches'][$i]->img]}'";
                                $stmt2 .= " where id = '{$id_of_branch}'";
                                // echo $stmt2;die();
                                $res = $this->mDb->getRow($stmt2);
                                
                                
                                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'subjects/' . $roww['image'];

                                if (file_exists($old_img)) {
                                    @unlink($old_img);
                                }
                            }


                            $stmt3 = "UPDATE `subjects_branches_langs` SET ";
                            $stmt3 .= "`name` = '{$request['allBranches'][$i]->name_ar}'";
                            $stmt3 .= " where subject_branch_id = '{$id_of_branch}' AND `lang_code` = '{$this->lang}'";
                            //   echo $stmt3;
                            // die();
                            $res = $this->mDb->getRow($stmt3);


                            $stmt4 = "UPDATE `subjects_branches_langs` SET ";
                            $stmt4 .= "`name` = '{$request['allBranches'][$i]->name_en}'";
                            $stmt4 .= " where subject_branch_id = '{$id_of_branch}' AND `lang_code` = 'en'";
                            //         echo $stmt4;
                            // die();
                            $res = $this->mDb->getRow($stmt4);

                        } else {
                            $stmt = "INSERT INTO `subjects_branches` SET";
                            $stmt .= " `subject_id` = '{$lang_id}'";
                            $stmt .= ", `image` = '{$tempBranches[ $request['allBranches'][$i]->img]}'";
                            // echo $stmt; die();
                            $branch_last_id = $this->mDb->queryReturnLastId($stmt);

                            $stmt2 = "INSERT INTO `subjects_branches_langs` SET";
                            $stmt2 .= " `subject_branch_id` = '{$branch_last_id}'";
                            $stmt2 .= ", `name` = '{$request['allBranches'][$i]->name_ar}'";
                            $stmt2 .= ", `lang_code` = '{$this->lang}' ";

                            $this->mDb->query($stmt2);

                            $stmt3 = "INSERT INTO `subjects_branches_langs` SET";
                            $stmt3 .= " `subject_branch_id` = '{$branch_last_id}'";
                            $stmt3 .= ", `name` = '{$request['allBranches'][$i]->name_en}'";
                            $stmt3 .= ", `lang_code` = 'en' ";
                            // echo $stmt2; die();
                            $this->mDb->query($stmt3);
                        }
                    }
                    
                    //  echo $stmt3;
                    //   echo $stmt4;
                    //         die();

                    return true;


                }else{
                    return $resEd;
                }
            }

        }
    }

    function addFields($fields, $lastSubjectId){
        $fieldValues = [];
            foreach ($fields as $field_id) {
                $fieldValues[] = "($lastSubjectId, $field_id->id)";
            }
            if (!empty($fieldValues)) {
                $sql = "INSERT INTO `fields_of_study_subjects` (`subject_id`, `field_of_study_id`) VALUES " . implode(",", $fieldValues);
                // echo $sql;die();
                $this->mDb->query($sql);
            }
    }
    
    
    function addBranches($allBranches, $lastSubjectId, $tempBranches){
        
        for ($i = 0; $i < count($allBranches); $i++) {
                    $stmt = "INSERT INTO `subjects_branches` SET";
                    $stmt .= " `subject_id` = '{$lastSubjectId}'";
                    $stmt .= ", `image` = '{$tempBranches[ $allBranches[$i]->img]["file"]}'";
                    // echo $stmt; die();
                    $branch_last_id = $this->mDb->queryReturnLastId($stmt);

                    $stmt2 = "INSERT INTO `subjects_branches_langs` SET";
                    $stmt2 .= " `subject_branch_id` = '{$branch_last_id}'";
                    $stmt2 .= ", `name` = '{$allBranches[$i]->name_ar}'";
                    $stmt2 .= ", `lang_code` = '{$this->lang}' ";

                    $this->mDb->query($stmt2);

                    $stmt3 = "INSERT INTO `subjects_branches_langs` SET";
                    $stmt3 .= " `subject_branch_id` = '{$branch_last_id}'";
                    $stmt3 .= ", `name` = '{$allBranches[$i]->name_en}'";
                    $stmt3 .= ", `lang_code` = 'en' ";
                    // echo $stmt2; die();
                    $this->mDb->query($stmt3);
                }
    }
    
    function getOneSubject($id)
    {
        $subject = $this->getSubjectById($id);
        $fields = $this->getFieldsOfStudyBySubjectId($id);
        $branches = $this->getBranchesOfStudyBySubjectId($id);
        $subject['fields'] = $fields;
        $subject['branches'] = $branches;
        return $subject;
    }

    function getSubjectById($id)
    {
        $sql = "SELECT * FROM `subjects` WHERE `id` = '{$id}'";
        $res = $this->mDb->getRow($sql);
        return $res;
    }

    function getFieldsOfStudyBySubjectId($id)
    {
        $sql = "SELECT fos.*, fosl.name FROM `fields_of_study_subjects` foss ";
        $sql .= " LEFT JOIN `fields_of_study` fos ON fos.id = foss.field_of_study_id ";
        $sql .= " LEFT JOIN `fields_of_study_langs` fosl ON fos.id = fosl.fields_of_study_id AND fosl.lang_code = '{$this->lang}' ";
        $sql .= " WHERE foss.subject_id = '{$id}'";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        return $res;
        // return array_column($res, 'id');
    }

    function getBranchesOfStudyBySubjectId($id)
    {
        $sql = "SELECT sb.image,sb.id, sbl.name, sbl.subject_branch_id, sbl.lang_code FROM `subjects_branches` sb ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON sb.id = sbl.subject_branch_id ";
        $sql .= " WHERE sb.subject_id = '{$id}'";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);

        // $data = ['img' => null, 'name_ar' => null, 'name_en' => null];

        // Initial loop to organize data by subject_branch_id and store both Arabic and English names
        foreach ($res as $item) {
            $data[$item['subject_branch_id']]['image'] = $item['image'];
            $data[$item['subject_branch_id']]['id'] = $item['id'];

            if ($item['lang_code'] == '{$this->lang}') {
                $data[$item['subject_branch_id']]['name_ar'] = $item['name'];
            } elseif ($item['lang_code'] == 'en') {
                $data[$item['subject_branch_id']]['name_en'] = $item['name'];
            }
        }

// Secondary loop to ensure that all branches have both Arabic and English names, even if one is missing
        $resultsArray = [];

        foreach ($data as $key => $branch) {
            // Initialize names with empty strings
            $name_ar = '';
            $name_en = '';

            // Check if Arabic and English names exist, otherwise use empty strings
            if (isset($branch['name_ar'])) {
                $name_ar = $branch['name_ar'];
            }
            if (isset($branch['name_en'])) {
                $name_en = $branch['name_en'];
            }

            $resultsArray[] = [
                "id" => $branch['id'],
                'img' => $branch['image'],
                'name_ar' => $name_ar,
                'name_en' => $name_en,
            ];
        }

        // print_r($resultsArray);die();
        return $resultsArray;
    }

    function deleteSubject($ids)
    {

        $res = false;

//    $sql = "DELETE FROM `subjects` ";
//    $sql.= " WHERE `id` = 0";
//

        $sql = "UPDATE `subjects` SET ";
        $sql .= " `is_deleted`='1' ";
        $sql .= " WHERE `id` = 0";

        foreach ($ids as $id) {

//        $query = "SELECT `img` FROM `subjects` WHERE `id` = '{$id}'";
//        $result = $this -> mDb -> getOne($query);
//
//        $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'subjects/' . $result;
//
//        if (file_exists($old_img)) {
//            @unlink($old_img);
//        }

            $sql .= " OR `id` = '{$id}' ";
        }

        $res = $this->mDb->query($sql);
        return $res;
    }

    function getAllSubjects()
    {
        $sql = "SELECT `id`, `name`, `img` FROM `subjects`";
        return $this->mDb->getAll($sql);
    }


    function getAllParentFieldsOfStudy($grade_id)
    {

        $sql = "SELECT fos.*, fosl.name FROM `fields_of_study` fos";
        $sql .= " LEFT JOIN `fields_of_study_grades` as fosg ON fos.id = fosg.field_of_study_id";
        $sql .= " LEFT JOIN `fields_of_study_langs` as fosl ON fos.id = fosl.fields_of_study_id AND fosl.lang_code = '{$this->lang}'";
        $sql .= " WHERE fos.id <= 2 AND fosg.grade_id = '{$grade_id}'";
        $res = $this->mDb->getAll($sql);
        return $res;

    }


    function getAllChildBytFieldsOfStudyId($parent_id)
    {

        $sql = "SELECT fos.*, fosl.name FROM `fields_of_study` fos";
        $sql .= " LEFT JOIN `fields_of_study_langs` as fosl ON fos.id = fosl.fields_of_study_id AND fosl.lang_code = '{$this->lang}'";
        $sql .= " WHERE fos.parent = '{$parent_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res;

    }


    function deleteBranch($id)
    {
        $sql = "SELECT * FROM `subjects_branches` WHERE `id` = '{$id}'";
        $row = $this->mDb->getRow($sql);
        // print_r($row);die();
        if ($row) {
            $stmt = "DELETE FROM `subjects_branches_langs` WHERE `subject_branch_id` = '{$row['id']}'";
            // echo $stmt; die();

            $this->mDb->query($stmt);

            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'subjects/' . $row['image'];
            if (file_exists($old_img)) {
                @unlink($old_img);
            }

            $stmt2 = "DELETE FROM `subjects_branches` WHERE `id` = '{$row['id']}'";

            return $this->mDb->query($stmt2);
        }
    }
    
    
    function getBranchesBySubjectId($id){
        
        $sql  = "SELECT sb.id, sbl.name FROM `subjects_branches` sb ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '{$this->lang}')";
        $sql .= " WHERE sb.subject_id = '{$id}'";
        
        // echo $sql;die();
        return $this -> mDb -> getAll($sql);
    }

} ?>