<?php

$SubscriptionCostsObj = new SubscriptionCosts();

class SubscriptionCosts {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

function convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__METHOD__, $data);
    }
    else {
        return $data;
    }
}

function getSomeSubscriptionCosts($aStart, $aLimit, $sort, $type, $searchName,$searchCountry) {
	$sql = "SELECT c.`id`, c.`subscription_type` ,c.`user_type`, c.`category` ,";
    $sql .= " cl.`title`,";
    $sql .= " cuntl.`name` as 'country_name',";

    $sql .= " c.`date_added`,";
    $sql .= " c.`status`,";
    $sql .= " c.`cost`,";
    $sql .= " c.`cost_year`,";
    $sql .= " c.`cost_semester`,";
    $sql .= " u.`full_name` AS 'user_full_name'";
    $sql .= " FROM `subscription_costs` c ";
    $sql .= " LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code` = 'ar')";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";

	$sql .= " LEFT JOIN `users` u ON u.`id` = c.`added_by` ";
	$sql .= " WHERE c.`id` > 0 ";
    $sql .= $searchName ? ' AND cl.`title` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql; die();
	return $this -> mDb -> getAll($sql); 
}


function getSearchSubscriptionCostsCount($sort, $type, $searchName,$searchCountry) {
	$sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `subscription_costs` c";
    $sql .= " LEFT JOIN `subscription_costs_langs` cl ON c.`id` = cl.`subscription_cost_id` ";
	$sql .= " WHERE c.`id` > 0 AND cl.`lang_code` = 'ar' ";
    $sql .= $searchName ? ' AND cl.`title` like "%'.$searchName.'%"' : '';
    $sql.= $searchCountry ? " AND c.`country_id` = '{$searchCountry}'" : "";
	$sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getSubscriptionCostsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `subscription_costs` ";
	return $this -> mDb -> getOne($sql); 
}

function addEditSubscriptionCost($request,$stage_id) {

    $dataLangObj = json_decode($request['langObj']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);
    unset($request['action']);
    unset($request['langObj']);
    $res = false; 

    if ($stage_id === '' && $request['operation'] === 'add')
    {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `subscription_costs` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',"; 
        $sql .= " `country_id` = '{$request['country_id']}',";
        $sql .=$request['stage_id'] > '0' && $request['stage_id'] !='null' ? " `stage_id` = '{$request['stage_id']}',":"`stage_id` = '0',";
        $sql .= $request['grade_id'] > '0' && $request['grade_id'] !='null' ?" `grade_id` = '{$request['grade_id']}',":"`grade_id` = '0',";
    
        $sql .=$request['subscription_type'] ?" `subscription_type` = '{$request['subscription_type']}', ":"`subscription_type` = null,";
        $sql .= " `user_type` = '{$request['user_type']}',";
        $sql .=$request['cost'] ? " `cost` = '{$request['cost']}'," : " `cost` = '0',";

        $sql .= " `category` = '{$request['category']}',";
        $sql .= $request['cost_year'] ?" `cost_year` = '{$request['cost_year']}',":"`cost_year` = null,";
        $sql .= $request['cost_semester'] ?" `cost_semester` = '{$request['cost_semester']}',":"`cost_semester` = null,";

        $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}'";
        // echo $sql; die();
        $this -> mDb ->query($sql);
        $last_stage_id = $this -> mDb ->getLastInsertId();
        foreach ($newDataLangObj as $key => $value) {
            $stmt = "INSERT INTO `subscription_costs_langs`(`subscription_cost_id`, `lang_code`, `title`, `description`) ";
            $stmt .=" VALUES ('{$last_stage_id}', '{$value['lang_code']}', '{$value['title']}', '{$value['description']}')";
            $res = $this -> mDb -> query($stmt);
        }
            return $res;
    }
    else
    {
        // Edit
        $check_query = "SELECT `id` FROM `subscription_costs` WHERE `id` = '{$stage_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            return 403;
        }
        else{

            $sql = "UPDATE `subscription_costs` SET ";
            $sql .= " `added_by` = '{$request['added_by']}', ";
            $sql .= " `country_id` = '{$request['country_id']}', ";
            
            $sql .= $request['stage_id'] > '0' && $request['stage_id'] !='null' ? " `stage_id` = '{$request['stage_id']}',":"`stage_id` = '0',";
            $sql .= $request['grade_id'] > '0' && $request['grade_id'] !='null' ? " `grade_id` = '{$request['grade_id']}',":"`grade_id` = '0',";
    
            $sql .=$request['subscription_type'] ?" `subscription_type` = '{$request['subscription_type']}', ":"`subscription_type` = null,";
            $sql .= " `user_type` = '{$request['user_type']}',";
            $sql .=$request['cost'] ? " `cost` = '{$request['cost']}'," : " `cost` = '0',";
            $sql .= " `category` = '{$request['category']}',";
            $sql .= $request['cost_year'] ?" `cost_year` = '{$request['cost_year']}',":"`cost_year` = null,";
            $sql .= $request['cost_semester'] ?" `cost_semester` = '{$request['cost_semester']}',":"`cost_semester` = null,";
            $sql .= $request['status'] === 'true' ? " `status` = '1'" : " `status` = '0'";
            $sql .= " WHERE `id` = '{$stage_id}'";
            //  echo $sql; die();

            $this -> mDb -> query($sql);
            foreach ($newDataLangObj as $key => $value) {
                $stmt = "UPDATE `subscription_costs_langs` SET";
                $stmt .=" `description`='{$value['description']}' , ";
                $stmt .=" `title`='{$value['title']}' ";
                $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `subscription_cost_id` = '{$stage_id}'";
                $res = $this -> mDb -> query($stmt);
            }
                return $res;
        } 
    }

}

function addEditSubscriptionContent($request,$stage_id) {

    $dataObj = json_decode($request['current_content']);
    $newDataObj = $this->convert_object_to_array($dataObj);

    if ($stage_id === '' || $stage_id < 1 )
    {
        // Add
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `subscription_cost_content` SET ";
        $sql .= " `added_by` = '{$newDataObj['added_by']}',";
        $sql .= " `sort` = '{$newDataObj['sort']}',";
        $sql .= " `title_ar` = '{$newDataObj['title_ar']}',";
        $sql .= " `title_en` = '{$newDataObj['title_en']}',";
        $sql .= $newDataObj['status'] == true ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}'";
//         echo $sql; die();
        $this -> mDb ->query($sql);
        $last_stage_id = $this -> mDb ->getLastInsertId();
        return $this->getOneSubscriptionCostContent($last_stage_id);
    }
    else
    {


        // Edit;
        $check_query = "SELECT `id` FROM `subscription_cost_content` WHERE `id` = '{$stage_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            return 403;
        }
        else{

            $sql = "UPDATE `subscription_cost_content` SET ";
            $sql .= " `added_by` = '{$newDataObj['added_by']}', ";
            $sql .= " `sort` = '{$newDataObj['sort']}',";
            $sql .= " `title_ar` = '{$newDataObj['title_ar']}',";
            $sql .= " `title_en` = '{$newDataObj['title_en']}',";
            $sql .= $newDataObj['status'] == true ? " `status` = '1' " : " `status` = '0' ";
            $sql .= " WHERE `id` = '{$stage_id}'";

            $this -> mDb -> query($sql);

             return $this->getOneSubscriptionCostContent($stage_id);;
        }
    }

}

function addEditSubscriptionSteps($request,$stage_id) {

    $dataObj = json_decode($request['current_step']);
    $newDataObj = $this->convert_object_to_array($dataObj);


    if ($stage_id === '' || $stage_id < 1 )
    {
        // Add
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `subscription_cost_steps` SET ";
        $sql .= " `added_by` = '{$newDataObj['added_by']}',";
        $sql .= " `sort` = '{$newDataObj['sort']}',";
        $sql .= " `title_ar` = '{$newDataObj['title_ar']}',";
        $sql .= " `title_en` = '{$newDataObj['title_en']}',";
        $sql .= " `description_ar` = '{$newDataObj['description_ar']}',";
        $sql .= " `description_en` = '{$newDataObj['description_en']}',";
        $sql .= $newDataObj['status'] == true ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}'";
        //  echo $sql; die();
        $this -> mDb ->query($sql);
        $last_stage_id = $this -> mDb ->getLastInsertId();
        return $this->getOneSubscriptionCostSteps($last_stage_id);
    }
    else
    {


        // Edit;
        $check_query = "SELECT `id` FROM `subscription_cost_steps` WHERE `id` = '{$stage_id}'";
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            return 403;
        }
        else{

            $sql = "UPDATE `subscription_cost_steps` SET ";
            $sql .= " `added_by` = '{$newDataObj['added_by']}', ";
            $sql .= " `sort` = '{$newDataObj['sort']}',";
            $sql .= " `title_ar` = '{$newDataObj['title_ar']}',";
            $sql .= " `title_en` = '{$newDataObj['title_en']}',";
            $sql .= " `description_ar` = '{$newDataObj['description_ar']}',";
            $sql .= " `description_en` = '{$newDataObj['description_en']}',";
            $sql .= $newDataObj['status'] == true ? " `status` = '1' " : " `status` = '0' ";
            $sql .= " WHERE `id` = '{$stage_id}'";

            $this -> mDb -> query($sql);

             return $this->getOneSubscriptionCostSteps($stage_id);;
        }
    }

}


function addEditSubscriptionVideos($request,$stage_id,$video) {



    if ($stage_id === '' || $stage_id < 1 )
    {
        // Add
        $dateTime = date('Y-m-d H:i:s');
        $sql = "INSERT INTO `subscription_cost_videos` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',";
        $sql .= " `sort` = '{$request['sort']}',";
         $sql .= " `title_ar` = '{$request['title_ar']}',";
         $sql .= " `title_en` = '{$request['title_en']}',";
         $sql .= " `video` = '{$video}',";
        $sql .= $request['status'] == true ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}'";
        //  echo $sql; die();
        $this -> mDb ->query($sql);
        $last_stage_id = $this -> mDb ->getLastInsertId();
        return $this->getOneSubscriptionCostVideos($last_stage_id);
    }


}




function getOneSubscriptionCost($id) {

    $result = array();

    $sql = "SELECT `id`, `added_by`, `status`,`cost`,`user_type`,`subscription_type`,`category`,`cost_year`,`cost_semester`,`country_id`,`stage_id`,`grade_id`  FROM `subscription_costs`";
    $sql .= " WHERE `id` = '{$id}'";
//    echo $sql ;die();
    $result = $this -> mDb -> getRow($sql); 

    $stmt = "SELECT cl.`lang_code`, cl.`title`,cl.`description` FROM `subscription_costs_langs` cl";
    $stmt .= " WHERE cl.`subscription_cost_id` = '{$id}'";
    $result['langs'] = $this -> mDb -> getAll($stmt);

    return $result;

}
function getOneSubscriptionCostContent($id) {

    $sql = "SELECT *  FROM `subscription_cost_content`";
    $sql .= " WHERE `id` = '{$id}' ";
//    echo $sql ;die();
    return  $this -> mDb -> getRow($sql);
}
    function getAllSubscriptionCostContent() {
        $sql = "SELECT *  FROM `subscription_cost_content`";
        $sql .= " WHERE `id` > '0' order by sort";
//    echo $sql ;die();
        return  $this -> mDb -> getAll($sql);
    }
    function getOneSubscriptionCostSteps($id) {

    $sql = "SELECT *  FROM `subscription_cost_steps`";
    $sql .= " WHERE `id` = '{$id}' ";
//    echo $sql ;die();
    return  $this -> mDb -> getRow($sql);
}

    function getOneSubscriptionCostVideos($id) {

    $sql = "SELECT *  FROM `subscription_cost_videos`";
    $sql .= " WHERE `id` = '{$id}' ";
//    echo $sql ;die();
    return  $this -> mDb -> getRow($sql);
}

    function getAllSubscriptionCostSteps() {
        $sql = "SELECT *  FROM `subscription_cost_steps`";
        $sql .= " WHERE `id` > 0 order by sort";
//    echo $sql ;die();
        return  $this -> mDb -> getAll($sql);
    }
    
     function getAllSubscriptionCostVideos() {
        $sql = "SELECT *  FROM `subscription_cost_videos`";
        $sql .= " WHERE `id` > 0 order by id";
//    echo $sql ;die();
        return  $this -> mDb -> getAll($sql);
    }
    
    
    
function getStageByParentID($id) {
    $result = array();
    $sql = "SELECT c.`id`, cl.`title`, cl.`description` FROM `subscription_costs` c";
    $sql .= " LEFT JOIN `subscription_costs_langs` cl ON c.`id` = cl.`subscription_cost_id` ";
    $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='ar' ";
//    echo $sql;
    $result = $this -> mDb -> getAll($sql);
    return $result;

}
function checkThisCost($data) {


    if($data['category'] == 'individuals'){
        if($data['country_id'] && $data['subscription_type'])
        $sql = "SELECT count(`id`) FROM `subscription_costs` c";
        $sql .= " WHERE c.`id` > 0 ";
        $sql .=$data['country_id']  ? " AND c.`country_id` = '{$data['country_id']}'":"";
         $sql .=$data['stage_id']  ? " AND c.`stage_id` = '{$data['stage_id']}'":"";
        $sql .=$data['grade_id']  ? " AND c.`grade_id` = '{$data['grade_id']}'":"";
        $sql .=$data['user_type']  ? " AND c.`user_type` = '{$data['user_type']}'":"";
        $sql .=$data['subscription_type']  ? " AND c.`subscription_type` = '{$data['subscription_type']}'":"";
        $sql .=$data['id']  ? " AND c.`id` != '{$data['id']}'":"";
//    echo $sql;
        return $this -> mDb -> getOne($sql);
    }else{
        $sql = "SELECT count(`id`) FROM `subscription_costs` c";
        $sql .= " WHERE c.`id` > 0 ";
        $sql .=$data['country_id']  ? " AND c.`country_id` = '{$data['country_id']}'":"";
         $sql .=$data['stage_id']  ? " AND c.`stage_id` = '{$data['stage_id']}'":"";
        $sql .=$data['grade_id']  ? " AND c.`grade_id` = '{$data['grade_id']}'":"";
         $sql .=$data['user_type']  ? " AND c.`user_type` = '{$data['user_type']}'":"";
        $sql .=$data['category']  ? " AND c.`category` = 'groups'":"";
        $sql .=$data['id']  ? " AND c.`id` != '{$data['id']}'":"";
//    echo $sql;
        return $this -> mDb -> getOne($sql);
    }


}



function deleteConfirm($ids) {

    $tempids='('.implode(',',$ids).')';

    $sqll = "DELETE FROM `subscription_costs_langs` ";
    $sqll.= " WHERE `subscription_cost_id` IN ".$tempids;
    $this-> mDb-> query($sqll);

    $catsql = "DELETE FROM `subscription_costs` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($catsql)){
        return true;
    }
    else{
        return false;
    }
}
function removeSubscriptionContent($ids) {

    $tempids='('.implode(',',$ids).')';

    $catsql = "DELETE FROM `subscription_cost_content` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($catsql)){
        return true;
    }
    else{
        return false;
    }
}

function removeSubscriptionVideo($ids) {

    $tempids='('.implode(',',$ids).')';

    $catsql = "DELETE FROM `subscription_cost_videos` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($catsql)){
        return true;
    }
    else{
        return false;
    }
}



function removeSubscriptionSteps($ids) {

    $tempids='('.implode(',',$ids).')';

    $catsql = "DELETE FROM `subscription_cost_steps` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($catsql)){
        return true;
    }
    else{
        return false;
    }
}






}?>