<?php

$TeacherGuideAdmObj = new TeacherGuide();

class TeacherGuide
{
    var $mDb;
    var $mConfig;
    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }
    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }
    function getSomeTeacherGuide($aStart, $aLimit, $sort, $type, $searchTitle)
    {
        $sql = "SELECT p.id, p.status, p.sort, p.img, p.date_added, pl.title, u.full_name AS 'user_full_name' FROM `teacher_guide` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " LEFT JOIN `teacher_guide_langs` pl ON p.id = pl.`teacher_guide_id` ";
        $sql .= " WHERE p.id > 0 AND pl.lang_code = 'ar'";
        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%"' : '';
        $sql .= " ORDER BY pl.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function getSearchTeacherGuideCount($sort, $type, $searchTitle)
    {
        $sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `teacher_guide` p";
        $sql .= " LEFT JOIN `teacher_guide_langs` pl ON p.id = pl.`teacher_guide_id` ";
        $sql .= " WHERE p.`id` > 0 AND pl.lang_code = 'ar' ";
        $sql .= $searchTitle ? ' AND pl.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= " ORDER BY pl.{$sort} {$type}";
        //	echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function getTeacherGuideCount()
    {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `teacher_guide`";
        return $this->mDb->getOne($sql);
    }

    function addEditTeacherGuide($temp, $file)
    {
        $img = $file['file'];
        $doc = $file['doc'];
        $dataLangObj = json_decode($temp['langs']);
        $newDataLangObj = $this->convert_object_to_array($dataLangObj);
        $user_id = $temp['user_id'];
        $country_id = $temp['country_id'];
        $stage_id = $temp['stage_id'];
        $grade_id = $temp['grade_id'];
        $subject_id = $temp['subject_id'];
        $semester = $temp['semester'];
        $status = $temp['status'] == 'true' ? "1" : "0";
        $id = $temp['id'];
        $sort = $temp['sort'];
        if ($id < 1) {
            // add condetion
            $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `teacher_guide` SET ";
            $sql .= " `user_id` = '{$user_id}', ";
            $sql .= " `country_id` = '{$country_id}', ";
            $sql .= " `stage_id` = '{$stage_id}', ";
            $sql .= " `grade_id` = '{$grade_id}', ";
            $sql .= " `subject_id` = '{$subject_id}', ";
            $sql .= " `semester` = '{$semester}', ";
            $sql .= " `status` = '{$status}', ";
            $sql .= " `sort` = '{$sort}', ";
            $sql .= " `date_added` = '{$dateTime}' ,";
            $sql .= " `img` = '{$img}',";
            $sql .= " `file` = '{$doc}'";
            // die($sql);
            $this->mDb->query($sql);
            $last_page_id = $this->mDb->getLastInsertId();

            foreach ($newDataLangObj as $key => $value) {
                $description = addslashes($value['description']);
                $title = addslashes($value['title']);
                $stmt = "INSERT INTO `teacher_guide_langs` SET ";
                $stmt .= " `teacher_guide_id` = '{$last_page_id}', ";
                $stmt .= " `lang_code` = '{$value['lang_code']}', ";
                $stmt .= " `title` = '{$title}', ";
                $stmt .= " `description` = '{$description}'";
                $res = $this->mDb->query($stmt);
            }
            return $last_page_id;
        } else {
            // edit condetion
            $check_query = "SELECT `id` FROM `teacher_guide` WHERE `id` = '{$id}'";
            $check_result = $this->mDb->getOne($check_query);
            if ($check_result === false) {
                return 403;
            } else {
                $sql = "UPDATE `teacher_guide` SET ";
                $sql .= " `user_id` = '{$user_id}', ";
                $sql .= " `country_id` = '{$country_id}', ";
                $sql .= " `stage_id` = '{$stage_id}', ";
                $sql .= " `grade_id` = '{$grade_id}', ";
                $sql .= " `subject_id` = '{$subject_id}', ";
                $sql .= " `semester` = '{$semester}', ";
                $sql .= " `sort` = '{$sort}', ";
                $sql .= " `status` = '{$status}' ";
                if ($img != '' && $img != null) {
                    $img_query = "SELECT `img` FROM `teacher_guide` WHERE `id` = '{$id}'";
                    $img_result = $this->mDb->getOne($img_query);
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teacher_guide/' . $img_result;
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                    $sql .= ",`img`='{$img}' ";
                }
                if ($doc != '' && $doc != null) {

                    // Delete old image from the server
                    $doc_query = "SELECT `file` FROM `articles` WHERE `id` = '{$id}'";
                    $doc_result = $this->mDb->getOne($doc_query);

                    $old_doc = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/' . $doc_result;

                    if (file_exists($old_doc)) {
                        @unlink($old_doc);
                    }

                    $sql .= ",`file`='{$doc}' ";
                }
                $sql .= " WHERE `id` = '{$id}'";
                $this->mDb->query($sql);
                foreach ($newDataLangObj as $key => $value) {
                    $description = addslashes($value['description']);
                    $title = addslashes($value['title']);

                    $stmt = "UPDATE `teacher_guide_langs` SET ";
                    $stmt .= " `title` = '{$title}', ";
                    $stmt .= " `description` = '{$description}'";
                    $stmt .= " WHERE `lang_code`='{$value['lang_code']}' AND `teacher_guide_id` = '{$id}' ";
                    $res = $this->mDb->query($stmt);
                }
                return $res;
            }
        }
    }

    function getOneTeacherGuide($id)
    {
        $result = array();
        $sql = "SELECT * FROM `teacher_guide`";
        $sql .= " WHERE `id` = '{$id}'";
        $result = $this->mDb->getRow($sql);
        $stmt = "SELECT * FROM `teacher_guide_langs` pl";
        $stmt .= " WHERE pl.`teacher_guide_id` = '{$id}'";
        $result['langs'] = $this->mDb->getAll($stmt);
        return $result;
    }

    function deleteTeacherGuide($ids)
    {
        $oldlenth = count($ids);
        if (count($ids) > 0) {
            $tempids = '(' . implode(',', $ids) . ')';
            $sqll = "DELETE FROM `teacher_guide_langs` ";
            $sqll .= " WHERE `teacher_guide_id` IN " . $tempids;
            $this->mDb->query($sqll);

            $sql = "SELECT `img` FROM `teacher_guide`";
            $sql .= " WHERE `id` IN " . $tempids;
            $images = $this->mDb->getAll($sql);

            $sqlll = "SELECT `file` FROM `articles`";
            $sqlll .= " WHERE `id` IN " . $tempids;
            $docs = $this->mDb->getAll($sqlll);
            if (count($images) > 0) {
                for ($i = 0; $i < count($images); $i++) {
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teacher_guide/' . $images[$i]['img'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
            if (count($docs) > 0) {
                for ($i = 0; $i < count($docs); $i++) {
                    $old_doc = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'teacher_guide/' . $images[$i]['file'];
                    if (file_exists($old_doc)) {
                        @unlink($old_doc);
                    }
                }
            }
            $catsql = "DELETE FROM `teacher_guide` ";
            $catsql .= " WHERE `id` IN " . $tempids;
            return $this->mDb->query($catsql);
        } else {
            if ($oldlenth > 0) {
                return 403;
            }
        }
    }
} ?>