<?php

$testimonialObj = new Testimonials();

class Testimonials {

var $mDb; 
var $mConfig; 
var $lang;

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
	$this->lang = LANGUAGE;
}

function convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__METHOD__, $data);
    }
    else {
        return $data;
    }
}


function getSomeTestimonials($params) {

    $sql = "SELECT t.*, tl.name, tl.grade, tl.content, tl.lang_code ";
    $sql .= " FROM `testimonials` t ";
    $sql .= " LEFT JOIN `testimonials_langs` tl ON t.id = tl.testimonial_id AND tl.lang_code = '{$this->lang}'";
	$sql .= " WHERE t.`id` > 0  AND t.`is_deleted` = '0' ";
    $sql .= $params['searchName'] ? ' AND tl.`name` like "%'.$params['searchName'].'%"' : '';
    $sql.= $params['searchJob'] ? " AND tl.`grade` LIKE '%{$params['searchJob']}%'" : "";
    $sql.= $params['searchContent'] ? " AND tl.`content` LIKE '%{$params['searchContent']}%'" : "";
    $sql .= $params['searchStatus'] == '0' || $params['searchStatus'] == '1'? "AND t.status = '{$params['searchStatus']}'":"";
	
	if(in_array($params['sort'], ['name', 'grade', 'content', 'lang_code'])){
	    $sql .= " ORDER BY tl.{$params['sort']} {$params['type']}";
	}else if($params['sort'] === 'sort'){
	    $sql .= " ORDER BY t.`sort` {$params['type']}";
	}else{
	    $sql .= " ORDER BY t.{$params['sort']} {$params['type']}";
	}
	
	$sql .= $params['aItemsPerPage'] ? " LIMIT {$params['start']}, {$params['aItemsPerPage']}" : '';
// 	 echo $sql; die();
	return $this -> mDb -> getAll($sql); 
}




function getSearchTestimonialsCount($params) {

    $sql = "SELECT COUNT(t.id) ";
    $sql .= " FROM `testimonials` t ";
    $sql .= " LEFT JOIN `testimonials_langs` tl ON t.id = tl.testimonial_id AND tl.lang_code = '{$this->lang}'";
	$sql .= " WHERE t.`id` > 0  AND t.`is_deleted` = '0' ";
    $sql .= $params['searchName'] ? ' AND tl.`name` like "%'.$params['searchName'].'%"' : '';
    $sql.= $params['searchJob'] ? " AND tl.`grade` LIKE '%{$params['searchJob']}%'" : "";
    $sql.= $params['searchContent'] ? " AND tl.`content` LIKE '%{$params['searchContent']}%'" : "";
	
	if(in_array($params['sort'], ['name', 'grade', 'content', 'lang_code'])){
	    $sql .= " ORDER BY tl.{$params['sort']} {$params['type']}";
	}else if($params['sort'] === 'sort'){
	    $sql .= " ORDER BY t.`sort` {$params['type']}";
	}else{
	    $sql .= " ORDER BY t.{$params['sort']} {$params['type']}";
	}
	$sql .= $params['aItemsPerPage'] ? " LIMIT {$params['start']}, {$params['aItemsPerPage']}" : '';
// 	 echo $sql; die();
	return $this -> mDb -> getOne($sql); 
}



function getTestimonialsCount() {

    $sql = "SELECT COUNT(t.id) ";
    $sql .= " FROM `testimonials` t ";
	$sql .= " WHERE t.`id` > 0 AND t.`is_deleted` = '0' ";
// 	 echo $sql; die();
	return $this -> mDb -> getOne($sql); 
}

function getOneTestimonial($id) {

    $sql = "SELECT t.*, tl.name, tl.grade, tl.content, tl.lang_code ";
$sql .= " FROM `testimonials` t ";
$sql .= " LEFT JOIN `testimonials_langs` tl ON t.id = tl.testimonial_id ";
$sql .= " WHERE t.`id` = '{$id}' ";

$results = $this->mDb->getAll($sql);

$formattedData = [];
if (!empty($results)) {
    $formattedData = [
        "id" => $results[0]['id'],
        "image" => $results[0]['image'],
        "status" => $results[0]['status'],
        "languageData" => []
    ];

    foreach ($results as $row) {
        $formattedData['languageData'][] = [
            "name" => $row['name'],
            "grade" => $row['grade'],
            "content" => $row['content'],
            "lang_code" => $row['lang_code']
        ];
    }
}

return $formattedData;

}

function activeTestimonials($ids)
{
    $ids = '('.implode(',', $ids).')';
    $sql  = 'UPDATE `testimonials` SET ';
    $sql .= "`status` = '1'";
    $sql .= $data['content'] ? ", `content` = '{$data['content']}' ":"";
    $sql .= " WHERE `id` IN '{$ids}'";
    echo $sql; die();
    return $this -> mDb -> query($sql);
}

function deactiveTestimonials($ids)
{
    $ids = '('.implode(',', $ids).')';
    $sql  = 'UPDATE `testimonials` SET ';
    $sql .= "`status` = '0'";
    $sql .= $data['content'] ? ", `content` = '{$data['content']}' ":"";
    $sql .= " WHERE `id` IN '{$ids}'";
    echo $sql; die();
    return $this -> mDb -> query($sql);
}


function deleteTestimonials($ids)
{
    $ids = '('.implode(',', $ids).')';
    $sql  = 'UPDATE `testimonials` SET ';
    $sql .= "`is_deleted` = '1'";
    $sql .= " WHERE `id` IN {$ids}";
    // echo $sql; die();
    return $this -> mDb -> query($sql);
}



function addEditTestimonials($data)
{
    // print_r($data);die();
    if($data['id'] == '' && $data['operation'] == 'add')
    {
        $sql  = 'INSERT INTO `testimonials` SET ';
        $sql .= "`image` = '{$data['image']}'";
        $sql .= ", `status` = '{$data['status']}'";
        // echo $sql; die();
        $this->mDb->query($sql);
        $last_id = $this->mDb->getLastInsertId();
    
    if($last_id)
    {
        foreach($data['languageData'] as $key => $row)
        {
            $sql  = 'INSERT INTO `testimonials_langs` SET ';
            $sql .= "`name` = '{$row['name']}'";
            $sql .= ", `testimonial_id` = '{$last_id}'";
            $sql .= ", `lang_code` = '{$key}'";
            $sql .= ", `grade` = '{$row['grade']}' ";
            $sql .= ", `content` = '{$row['content']}' ";
            // echo $sql;die();
            $res = $this -> mDb -> query($sql);
        }
    }
    
    return $last_id;
    }else{
        $sql = "SELECT id FROM testimonials WHERE id = '{$data['id']}' AND is_deleted = '0' ";
        
        $id = $this -> mDb -> getOne($sql);
    
        if($id)
        {
            $sql = "UPDATE `testimonials` SET ";
            $sql .= "`image` = '{$data['image']}'";
            $sql .= ", `status` = '{$data['status']}'";
            // echo $sql;die();
            $test = $this -> mDb -> query($sql);
            
            if($test)
            {
            foreach($data['languageData'] as $key => $row)
            {
                $sql  = 'UPDATE `testimonials_langs` SET ';
                $sql .= "`name` = '{$row['name']}'";
                $sql .= ", `grade` = '{$row['grade']}' ";
                $sql .= ", `content` = '{$row['content']}' ";
                $sql .= "WHERE `testimonial_id` = '{$id}' AND `lang_code` = '{$key}'";
                $res = $this -> mDb -> query($sql);
            }
            }
            
            return $res;
        }else{
            return false;
        }
    }
}




}?>