<?php

$TestsObj = new Tests();

use Spipu\Html2Pdf\Html2Pdf;
use Dompdf\Dompdf;
use Dompdf\Options;
class Tests {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function getSomeTests($aStart, $aLimit, $sort, $type, $searchTitle,$searchQuestion,$searchCountry,$searchStage,$searchGrade,$searchSubject,$searchTestSemester,$rools,$searchUnit,$searchLesson,$searchTeacherId, $searchDateFrom, $searchDateTo,$searchSource,$searchStatus,$searchTestType,$searchAddedBy) {
	$sql = "SELECT te.id,te.country_id,te.stage_id,te.grade_id,te.subject_id,te.type,te.sort, te.status, te.semester, te.date_added, te.name, u.full_name AS 'user_full_name' , ";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " gradel.`name` as 'grade_name' , ";
    $sql .= " unitl.`name` as 'unit_name' , ";
    $sql .= " lessonl.`name` as 'lesson_name' , ";
    $sql .= " subjectt.`name` as 'subject_name' , ";
    $sql .= " subjectt.`subject_direction` as 'subject_direction'";
    $sql .=" FROM `tests` te";
	$sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
     $sql .= $searchQuestion && $searchQuestion !='' ? " LEFT JOIN `test_questions` tes_quest ON (te.`id` = tes_quest.`test_id`)" :"";
    $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
    $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
    $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
    $sql.= " WHERE te.id > 0 AND te.`is_deleted` = '0'";
    $sql.= $searchTitle ? ' AND te.name like "%'.$searchTitle.'%"' : '';
    $sql.= $searchQuestion ? ' AND tes_quest.title like "%'.$searchQuestion.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";

    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
     $sql.= $searchTestSemester ? " AND te.`semester` = '{$searchTestSemester}'" : "";
    $sql.= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
    $sql.= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";
    $sql.= $searchTeacherId ? " AND te.`teacher_id` = '{$searchTeacherId}'" : "";
     $sql.= $searchStatus !='' ? " AND te.`status` = '{$searchStatus}'" : "";
     $sql.= $searchAddedBy !='' ? " AND te.`added_by` = '{$searchAddedBy}'" : "";
    $sql.= $searchTestType&& $searchTestType!= ''&& $searchTestType!= 'undefined' ? " AND te.`type` = '{$searchTestType}'" : "";
     $sql.= $searchSource == 'ready' ? " AND te.`classification` = 'ready'" : "";
      $sql.= $searchSource == 'teacher' ? " AND ( te.`classification` = 'by_teacher_selected_from_ready' OR te.`classification` = 'by_teacher_selected_from_bank' OR te.`classification` = 'by_teacher_customized' )" : "";
      $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";


    if(count($rools)>0 && $rools !='all'){
        $sql.="AND ( ";
        for ($ii=0;$ii< count($rools) ;$ii++){
           if($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0&& $rools[$ii]['subject_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}' AND te.`subject_id` = '{$rools[$ii]['subject_id']}' )";
           }elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 &&$rools[$ii]['grade_id'] > 0){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' AND te.`grade_id` = '{$rools[$ii]['grade_id']}'  )";
           }
           elseif ($rools[$ii]['country_id'] > 0 &&$rools[$ii]['stage_id'] > 0 ){
               $sql.="( te.`country_id` = '{$rools[$ii]['country_id']}' AND te.`stage_id` = '{$rools[$ii]['stage_id']}' )";
           }
           if($ii < (count($rools)-1)){
               $sql.=" OR ";
           }
        }
        $sql.=" )";
    }
    
    $sql .= $searchQuestion ? " GROUP BY te.id " :"";
       
	$sql .= " ORDER BY te.{$sort} {$type}";
	
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchTestsCount($sort, $type, $searchTitle,$searchQuestion,$searchCountry,$searchStage,$searchGrade,$searchSubject,$searchTestSemester,$searchUnit,$searchLesson,$searchTeacherId, $searchDateFrom, $searchDateTo,$searchSource,$searchStatus,$searchTestType,$searchAddedBy) {
	$sql = "SELECT COUNT(te.`id`) as 'result_count' FROM `tests` te";
    // $sql .= $searchQuestion && $searchQuestion !='' ? " LEFT JOIN `test_questions` tes_quest ON (te.`id` = tes_quest.`test_id`)" :"";
	$sql .= " WHERE te.`id` > 0  AND te.`is_deleted` = '0'";

    $sql .= $searchTitle ? ' AND te.`name` like "%'.$searchTitle.'%"' : '';
    $sql.= $searchCountry ? " AND te.`country_id` = '{$searchCountry}'" : "";
    $sql.= $searchStage ? " AND te.`stage_id` = '{$searchStage}'" : "";
    $sql.= $searchGrade ? " AND te.`grade_id` = '{$searchGrade}'" : "";

    $sql.= $searchSubject ? " AND te.`subject_id` = '{$searchSubject}'" : "";
     $sql.= $searchTestSemester ? " AND te.`semester` = '{$searchTestSemester}'" : "";
    $sql.= $searchUnit ? " AND te.`unit_id` = '{$searchUnit}'" : "";
    $sql.= $searchLesson ? " AND te.`lesson_id` = '{$searchLesson}'" : "";
    $sql.= $searchTeacherId ? " AND te.`teacher_id` = '{$searchTeacherId}'" : "";
    $sql.= $searchStatus !='' ? " AND te.`status` = '{$searchStatus}'" : "";
    $sql.= $searchAddedBy !='' ? " AND te.`added_by` = '{$searchAddedBy}'" : "";
    $sql.= $searchTestType&& $searchTestType!= '' && $searchTestType!= 'undefined' ? " AND te.`type` = '{$searchTestType}'" : "";
    $sql.= $searchSource == 'ready' ? " AND te.`classification` = 'ready'" : "";
    $sql.= $searchSource == 'teacher' ? " AND ( te.`classification` = 'by_teacher_selected_from_ready' OR te.`classification` = 'by_teacher_selected_from_bank' OR te.`classification` = 'by_teacher_customized' )" : "";
     
    $sql.= $searchDateFrom ? " AND te.`date_added` BETWEEN '{$searchDateFrom}' AND '{$searchDateTo}'" : "";
      
	$sql .= " ORDER BY te.{$sort} {$type}";

// 	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getTestsCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `tests` WHERE  `is_deleted` = '0'";
	return $this -> mDb -> getOne($sql); 
}


function movequestionsoptionnotetosquestion() {
	
	

	
	$sql = "SELECT tq.id,tqo.question_bank_id,tqo.note FROM `questions_bank_options` tqo ";
	$sql .= " INNER JOIN `questions_bank_questions` tq ON ( tqo.question_bank_id = tq.id AND tqo.`note` !=''  )";
	$sql .= " WHERE  tqo.`id` > 0 AND tq.id > 88062";
	$sql .= " limit 0,1500 ";
	
	
	
	$result=$this -> mDb -> getAll($sql);
	
	if(count($result) >0 ){
	    for($i=0;$i<count($result);$i++){
	        
	        if($result[$i].note && $result[$i].question_bank_id){
	            $stmtq = "UPDATE `questions_bank_questions` SET ";
                $stmtq .= " `note` = '{$result[$i]['note']}'";
                $stmtq .= " WHERE `id`='{$result[$i]['question_bank_id']}'  ";
                $this -> mDb -> query($stmtq);
	        }
	        
	    }
	}
	
	
return end($result);
}


    function addEditTest($temp) {

        $user_id = $temp['user_id'];
        $status = $temp['status'] == 'true' ? "1" : "0";
        $printable = $temp['printable'] == 'true' ? "1" : "0";
        $id = $temp['id'];

        if ($id === null || $id === ''  || ($id < 1 ) ) {
            // add
            $dateTime = date('Y-m-d H:i:s');
            $sql = "INSERT INTO `tests` SET ";
            $sql .= " `added_by` = '{$user_id}', ";
            $sql .= " `country_id` = '{$temp['country_id']}', ";
            $sql .= " `stage_id` = '{$temp['stage_id']}', ";
            $sql .= " `grade_id` = '{$temp['grade_id']}', ";
            $sql .= " `subject_id` = '{$temp['subject_id']}', ";
            $sql .= $temp['unit_id'] ? " `unit_id` = '{$temp['unit_id']}', ":"";
            $sql .= $temp['lesson_id'] ?" `lesson_id` = '{$temp['lesson_id']}', ":"";
            $sql .= $temp['specialize_id'] ?" `specialize_id` = '{$temp['specialize_id']}', ":"";
            $sql .= " `type` = '{$temp['type']}', ";

            $sql .= " `dedicated_to` = '{$temp['dedicated_to']}', ";
            $sql .= " `name` = '{$temp['name']}', ";
            $sql .= " `semester` = '{$temp['semester']}', ";
            $sql .= " `status` = '{$status}', ";
            $sql .= " `printable` = '{$printable}', ";
            $sql .= " `total_degree` = '{$temp['total_degree']}', ";
            $sql .= " `sort` = '{$temp['sort']}', ";
            $sql .= " `date_added` = '{$dateTime}'";
//echo $sql;
//die();
            $this -> mDb -> query($sql);
            $last_page_id = $this -> mDb -> getLastInsertId();

 $this->updateDegreeOfTest($last_page_id);
            return $last_page_id;
        }
        else{
            // edit
            
                $student_test_answers_count=$this ->getCountOfAnswerOnTest($id);
            
            if($student_test_answers_count && $student_test_answers_count > 0){
                // delete all answers for this test
                
                    $catsql = "DELETE FROM `student_tests_answers` ";
                    $catsql.= " WHERE `test_id` = '{$id}'";
                    
                   $this-> mDb-> query($catsql);
                
            }
            

                $check_query = "SELECT `id` FROM `tests` WHERE `id` = '{$id}'";
                $check_result = $this -> mDb -> getOne($check_query);

                if ($check_result === false) {
                    return 403;
                }
                else{
                    $dateTime = date('Y-m-d H:i:s');
                    $sqladm = "INSERT INTO `admins_edit_tests` SET ";
                    $sqladm .= " `admin_id` = '{$user_id}', ";
                    $sqladm .= " `test_id` = '{$id}', ";
                    $sqladm .= " `date_added` = '{$dateTime}'";

                     $this -> mDb -> query($sqladm);

                    $sql = "UPDATE `tests` SET ";
                    // $sql .= " `added_by` = '{$user_id}', ";
                    $sql .= " `country_id` = '{$temp['country_id']}', ";
                    $sql .= " `stage_id` = '{$temp['stage_id']}', ";
                    $sql .= " `grade_id` = '{$temp['grade_id']}', ";
                    $sql .= " `subject_id` = '{$temp['subject_id']}', ";
                    $sql .= $temp['unit_id'] ? " `unit_id` = '{$temp['unit_id']}', ":"`unit_id` = '0',";
                    $sql .= $temp['lesson_id'] ?" `lesson_id` = '{$temp['lesson_id']}', ":"`lesson_id` = '0',";
                    $sql .= $temp['specialize_id'] ?" `specialize_id` = '{$temp['specialize_id']}', ":"";
                    $sql .= " `type` = '{$temp['type']}', ";
                    $sql .= " `dedicated_to` = '{$temp['dedicated_to']}', ";
                    $sql .= " `name` = '{$temp['name']}', ";
                     $sql .= " `semester` = '{$temp['semester']}', ";
                    $sql .= " `sort` = '{$temp['sort']}', ";

                    $sql .= " `printable` = '{$printable}' ,";
                    $sql .= " `status` = '{$status}' ";
                    $sql .= " WHERE `id` = '{$id}'";
                    $res=$this -> mDb -> query($sql);
 $this->updateDegreeOfTest($id);
                    return $id;
            }
        }
    }



    function addEditQuestion($temp) {
        $testQ = json_decode($temp['current_quest']);
        $current_quest = $this->convert_object_to_array($testQ);

        $questid = $current_quest['id'];
        
      
        
        if ($questid === null || $questid === ''  || ($questid < 1 ) ) {
            // add
            $dateTime = date('Y-m-d H:i:s');

            $last_page_id = $temp['current_question_test_id'];
            
               $student_test_answers_count=$this ->getCountOfAnswerOnTest($last_page_id);
            
            if($student_test_answers_count && $student_test_answers_count > 0){
                // delete all answers for this test
                
                    $catsql = "DELETE FROM `student_tests_answers` ";
                    $catsql.= " WHERE `test_id` = '{$last_page_id}'";
                    
                   $this-> mDb-> query($catsql);
                
            }
            if($last_page_id > 0){

                $title = $current_quest['title'];
                $type = $current_quest['type'];
               // if($title !=''){
                    $check_queryy = "SELECT `id` FROM `test_questions` WHERE `test_id` = '{$last_page_id}' AND `title` = '{$title}'";
                    $check_resulty = $this -> mDb -> getOne($check_queryy);

                    if ($check_resulty === false) {


                        $id = $this -> InsertIntoTestQuestions($last_page_id,$type,$current_quest['source'],$current_quest['degree'],$title,'',$current_quest['note']);
                        if($id > 0 && count($current_quest['test_question_options']) > 0) {
                            for ($ii = 0; $ii < count($current_quest['test_question_options']); $ii++) {
                                $nObj = $current_quest["test_question_options"][$ii];
                                $statuss = $nObj['status'] == 'true' ? "1" : "0";
                                $option_id = $this -> InsertIntoTestQuestionOptions($id,$nObj['title'],$statuss,$nObj['note']);
                                if ($option_id > 0 && $nObj['attachment'] != "" && $nObj['attachment_type'] != "") {
                                    $this->addQuestionAttachments($id, $nObj['attachment'], $nObj['attachment_type'], 'option', $option_id);
                                }
                                if ($option_id > 0 && $nObj['attachment_note'] != "" && $nObj['attachment_type_note'] != "") {
                                    $this->addQuestionAttachments($id, $nObj['attachment_note'], $nObj['attachment_type_note'], 'note', $option_id);
                                }
                            }
                        }
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                            $this->addQuestionAttachments($id, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                        }

                        if($id > 0 && $current_quest['type'] == 'paragraphs'){
                            for($idsub=0;$idsub<count($current_quest['question_sub_questions']) ;$idsub++) {
                                $subquestion=$current_quest['question_sub_questions'][$idsub];
                                $idqsub = $this -> InsertIntoTestQuestions($last_page_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$id,$subquestion['note']);
                                if($idqsub > 0 && count($subquestion['test_question_options']) > 0){
                                    for($iirr=0;$iirr<count($subquestion['test_question_options']) ;$iirr++) {
                                        $nObjff = $subquestion["test_question_options"][$iirr];
                                        $statuss =$nObjff['status'] == 'true' ? "1" : "0";
                                        $sub_option_id= $this -> InsertIntoTestQuestionOptions($idqsub,$nObjff['title'],$statuss,$nObjff['note']);
                                        if ($sub_option_id > 0 && $nObjff['attachment'] != "" && $nObjff['attachment_type'] != "") {
                                            $this->addQuestionAttachments($idqsub, $nObjff['attachment'], $nObjff['attachment_type'], 'option', $sub_option_id);
                                        }
                                        if ($sub_option_id > 0 && $nObjff['attachment_note'] != "" && $nObjff['attachment_type_note'] != "") {
                                            $this->addQuestionAttachments($idqsub, $nObjff['attachment_note'], $nObjff['attachment_type_note'], 'note', $sub_option_id);
                                        }
                                    }
                                }
                                if ($idqsub >0&&$subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                    $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                }

                              
                                if($idqsub > 0 && count($subquestion['match_questions_items']  ) > 0 ){
                                    for($iirr=0;$iirr<count($subquestion['match_questions_items']) ;$iirr++) {
                                        $nObjff = $subquestion["match_questions_items"][$iirr];
                                       $this -> InsertIntoMatchQuestionItems($idqsub,$nObjff['title1'],$nObjff['righte_index1'],$nObjff['title2'],$nObjff['righte_index2'],$nObjff['image1'],$nObjff['image2']);
                                    }
                                }

                                if($idqsub > 0 && count($subquestion['sort_questions_words']  ) > 0 ){
                                    for($iirr=0;$iirr<count($subquestion['sort_questions_words']) ;$iirr++) {
                                        $nObjff = $subquestion["sort_questions_words"][$iirr];
                                       $this -> InsertIntoSortQuestionWords($idqsub,$nObjff['title'],$nObjff['word_index']);
                                    }
                                }

                            }
                        }
                        
                         if($id > 0 && $current_quest['type'] == 'complete_it'){
                            for($dsubcom=0;$dsubcom<count($current_quest['question_sub_questions']) ;$dsubcom++) {
                                $subquestion=$current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this -> InsertIntoTestQuestions($last_page_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$id,$subquestion['note']);
                                if($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0){
                                    for($iirr=0;$iirr<count($subquestion['test_questions_complete_words']) ;$iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                         $this -> InsertIntoTestQuestionCompleteWord($idqsub,$nObjff['title'],$nObjff['word_index'],$nObjff['note']);
                                    }
                                }
                            }
                        }
                        if($id > 0 && $current_quest['type'] == 'complete_it_writing_auto_correct'){
                            for($dsubcom=0;$dsubcom<count($current_quest['question_sub_questions']) ;$dsubcom++) {
                                $subquestion=$current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this -> InsertIntoTestQuestions($last_page_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$id,$subquestion['note']);
                                if($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0){
                                    for($iirr=0;$iirr<count($subquestion['test_questions_complete_words']) ;$iirr++) {
                                        $nObjff = $subquestion["test_questions_complete_words"][$iirr];
                                         $this -> InsertIntoTestQuestionCompleteWord($idqsub,$nObjff['title'],$nObjff['word_index'],$nObjff['note']);
                                    }
                                }
                            }
                        }
                       if($id > 0 && $current_quest['type'] == 'complete_it_writing_manual_correct'){
                            for($dsubcom=0;$dsubcom<count($current_quest['question_sub_questions']) ;$dsubcom++) {
                                $subquestion=$current_quest['question_sub_questions'][$dsubcom];
                                $idqsub = $this -> InsertIntoTestQuestions($last_page_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$id,$subquestion['note']);
                               
                            }
                        }

                        
                        if($id > 0 && $current_quest['type'] == 'match_it'){
                            for($mdsubm=0;$mdsubm<count($current_quest['match_questions_items']) ;$mdsubm++) {
                                $subquestion=$current_quest['match_questions_items'][$mdsubm];
                                 $this -> InsertIntoMatchQuestionItems($id,$subquestion['title1'],$subquestion['righte_index1'],$subquestion['title2'],$subquestion['righte_index2'],$subquestion['image1'],$subquestion['image2']);
                            }
                        }
                        if($id > 0 && $current_quest['type'] == 'sort_it'){
                            for($sdsubs=0;$sdsubs<count($current_quest['sort_questions_words']) ;$sdsubs++) {
                                $subquestion=$current_quest['sort_questions_words'][$sdsubs];
                                 $this -> InsertIntoSortQuestionWords($id,$subquestion['title'],$subquestion['word_index']);
                            }
                        }
                    }
               // }
                $this->updateDegreeOfTest($last_page_id);
            }

            return $this->getOneQuestion($id);
        }
        else{
            // edit
            $check_query = "SELECT `id` FROM `test_questions` WHERE `id` = '{$questid}'";
            $check_result = $this -> mDb -> getOne($check_query);

            if ($check_result === false) {
                return 403;
            }
            else{
                $question_test_id = $temp['current_question_test_id'];


                  $student_test_answers_count=$this ->getCountOfAnswerOnTest($question_test_id);
                    
                    if($student_test_answers_count && $student_test_answers_count > 0){
                        // delete all answers for this test
                        
                            $catsql = "DELETE FROM `student_tests_answers` ";
                            $catsql.= " WHERE `test_id` = '{$question_test_id}'";
                            
                           $this-> mDb-> query($catsql);
                        
                    }

                if($questid > 0 && $question_test_id > 0){
                    if($current_quest['title'] !=''&& $questid >= 1){
                            $math_type_view_title = renderMathType($current_quest['title']);
                            $math_type_view_note = renderMathType($current_quest['note']);
                            $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                            $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
                        $stmtq = "UPDATE `test_questions` SET ";
                        $stmtq .= " `type` = '{$current_quest['type']}', ";
                        $stmtq .= " `source` = '{$current_quest['source']}', ";
                        $stmtq .= " `degree` = '{$current_quest['degree']}', ";
                        $stmtq .= " `note` = '{$current_quest['note']}', ";
                        $stmtq .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                        $stmtq .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
                        $stmtq .= " `title` = '{$current_quest['title']}' ";
                        $stmtq .= " WHERE `id`='{$questid}' AND `test_id` = '{$question_test_id}' ";
                        $this -> mDb -> query($stmtq);
                        if(count($current_quest['test_question_options']) > 0){
                            foreach ($current_quest['test_question_options'] as $testObjOp) {
                                $statuss =$testObjOp['status'] == 'true' ? "1" : "0";
                                if($testObjOp['title'] !='' &&$testObjOp['id'] < 1){
                                    $option_id=$this -> InsertIntoTestQuestionOptions($questid,$testObjOp['title'],$statuss,$testObjOp['note']);
                                    if ($option_id > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $option_id);
                                    }
                                    if ($option_id > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $option_id);
                                    }
                                }elseif($testObjOp['title'] !='' &&$testObjOp['id'] >= 1){
                                     $math_type_view_title = renderMathType($testObjOp['title']); 
                                     $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
         
                                    $stmtqup = "UPDATE `test_question_options` SET ";
                                    $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                     $stmtqup .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                    $stmtqup .= " `status` = '{$statuss}', ";
                                    $stmtqup .= " `note` = '{$testObjOp['note']}' ";
                                    $stmtqup .= " WHERE `id`='{$testObjOp['id']}' AND `test_question_id` = '{$questid}' ";
                                    $this -> mDb -> query($stmtqup);
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                        if($testObjOp['file'] && $testObjOp['file'] !=''){
                                            // delete old files
                                            $arr=["file"=>$testObjOp['file'],"related_to"=>"option"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                    if ($testObjOp['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                        $this->addQuestionAttachments($questid, $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                        if($testObjOp['file_note'] && $testObjOp['file_note'] !=''){
                                            // delete old files
                                            $arr=["file"=>$testObjOp['file_note'],"related_to"=>"note"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }
                                }
                            }
                        }
                        if ($current_quest['attachment'] != "" && $current_quest['attachment_type'] != "") {
                            $this->addQuestionAttachments($questid, $current_quest['attachment'], $current_quest['attachment_type'], 'question');
                            if($current_quest['file'] && $current_quest['file'] !=''){
                                // delete old files if exist
                                $arr=["file"=>$current_quest['file'],"related_to"=>"question"];
                                $this->deleteAttachment($arr);
                            }
                        }

                        if($questid >= 1  && $current_quest['type'] == 'paragraphs'){
                            for($idsub=0;$idsub<count($current_quest['question_sub_questions']) ;$idsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$idsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub =  $this -> InsertIntoTestQuestions($question_test_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$questid,$subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_question_options']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_question_options']); $iirr++) {
                                            $subquestionoption=$subquestion["test_question_options"][$iirr];
                                            $titleo = $subquestionoption['title'];
                                            $statuss = $subquestionoption['status'] == 'true' ? "1" : "0";
                                            $note = $subquestionoption['note'];
                                            $subqoption= $this -> InsertIntoTestQuestionOptions($idqsub,$titleo,$statuss,$note);
                                            if ($subqoption > 0 && $subquestionoption['attachment'] != "" && $subquestionoption['attachment_type'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment'], $subquestionoption['attachment_type'], 'option', $subqoption);
                                                if($subquestionoption['file'] && $subquestionoption['file'] !=''){
                                                    // delete old files
                                                    $arr=["file"=>$subquestionoption['file'],"related_to"=>"option"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                            if ($subquestionoption['id'] > 0 && $subquestionoption['attachment_note'] != "" && $subquestionoption['attachment_type_note'] != "") {
                                                $this->addQuestionAttachments($idqsub, $subquestionoption['attachment_note'], $subquestionoption['attachment_type_note'], 'note', $subqoption);
                                                if($subquestionoption['file_note'] && $subquestionoption['file_note'] !=''){
                                                    // delete old files
                                                    $arr=["file"=>$subquestionoption['file_note'],"related_to"=>"note"];
                                                    $this->deleteAttachment($arr);
                                                }
                                            }
                                        }
                                    }
                                    if ($idqsub >0&&$subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($idqsub, $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if($subquestion['file'] && $subquestion['file'] !=''){
                                            // delete old files
                                            $arr=["file"=>$subquestion['file'],"related_to"=>"question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }


                                    if($idqsub > 0 && count($subquestion['match_questions_items']  ) > 0 ){
                                        for($iirr=0;$iirr<count($subquestion['match_questions_items']) ;$iirr++) {
                                            $nObjff = $subquestion["match_questions_items"][$iirr];
                                           $this -> InsertIntoMatchQuestionItems($idqsub,$nObjff['title1'],$nObjff['righte_index1'],$nObjff['title2'],$nObjff['righte_index2'],$nObjff['image1'],$nObjff['image2']);
                                        }
                                    }
    
                                    if($idqsub > 0 && count($subquestion['sort_questions_words']  ) > 0 ){
                                        for($iirr=0;$iirr<count($subquestion['sort_questions_words']) ;$iirr++) {
                                            $nObjff = $subquestion["sort_questions_words"][$iirr];
                                           $this -> InsertIntoSortQuestionWords($idqsub,$nObjff['title'],$nObjff['word_index']);
                                        }
                                    }

                                }else{
                                      $math_type_view_title = renderMathType($subquestion['title']);
                                      $math_type_view_note = renderMathType($subquestion['note']);
                                      $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                      $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
                                    $stmtq = "UPDATE `test_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                     $stmtq .= " `note` = '{$subquestion['note']}', ";
                                      $stmtq .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                      $stmtq .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                     
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND `test_id` = '{$question_test_id}' ";
                                   
                                    $this -> mDb -> query($stmtq);
                                    if(count($subquestion['test_question_options']) > 0){
                                        foreach ($subquestion['test_question_options'] as $testObjOp) {
                                            $statuss =$testObjOp['status'] == 'true' ? "1" : "0";
                                            if($testObjOp['title'] !='' &&$testObjOp['id'] < 1){
                                                $subquestionoption_id= $this -> InsertIntoTestQuestionOptions($subquestion['id'],$testObjOp['title'],$statuss,$testObjOp['note']);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $subquestionoption_id);
                                                    if($testObjOp['file'] && $testObjOp['file'] !=''){
                                                        // delete old files
                                                        $arr=["file"=>$testObjOp['file'],"related_to"=>"option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $subquestionoption_id);
                                                    if($testObjOp['file_note'] && $testObjOp['file_note'] !=''){
                                                        // delete old files
                                                        $arr=["file"=>$testObjOp['file_note'],"related_to"=>"note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }

                                            }elseif($testObjOp['title'] !='' &&$testObjOp['id'] >= 1){
                                                 $math_type_view_title = renderMathType($testObjOp['title']); 
                                                 $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
         
                                                $stmtqup = "UPDATE `test_question_options` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                $stmtqup .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                                $stmtqup .= " `status` = '{$statuss}', ";
                                                $stmtqup .= " `note` = '{$testObjOp['note']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                                $this -> mDb -> query($stmtqup);
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment'] != "" && $testObjOp['attachment_type'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment'], $testObjOp['attachment_type'], 'option', $testObjOp['id']);
                                                    if($testObjOp['file'] && $testObjOp['file'] !=''){
                                                        // delete old files
                                                        $arr=["file"=>$testObjOp['file'],"related_to"=>"option"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                                if ($subquestion['id'] > 0 && $testObjOp['attachment_note'] != "" && $testObjOp['attachment_type_note'] != "") {
                                                    $this->addQuestionAttachments($subquestion['id'], $testObjOp['attachment_note'], $testObjOp['attachment_type_note'], 'note', $testObjOp['id']);
                                                    if($testObjOp['file_note'] && $testObjOp['file_note'] !=''){
                                                        // delete old files
                                                        $arr=["file"=>$testObjOp['file_note'],"related_to"=>"note"];
                                                        $this->deleteAttachment($arr);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if ($subquestion['id'] >0&&$subquestion['attachment'] != "" && $subquestion['attachment_type'] != "") {
                                        $this->addQuestionAttachments($subquestion['id'], $subquestion['attachment'], $subquestion['attachment_type'], 'question');
                                        if($subquestion['file'] && $subquestion['file'] !=''){
                                            // delete old files
                                            $arr=["file"=>$subquestion['file'],"related_to"=>"question"];
                                            $this->deleteAttachment($arr);
                                        }
                                    }

                                    if($subquestion['id'] > 0 && $subquestion['type'] == 'match_it'){
                                        for($mqii=0;$mqii<count($subquestion['match_questions_items']) ;$mqii++) {
                                            $subquestionmatch=$subquestion['match_questions_items'][$mqii];
                                            if($subquestionmatch['title1'] !='' &&$subquestionmatch['id'] < 1){
                                             $this -> InsertIntoMatchQuestionItems($subquestion['id'],$subquestionmatch['title1'],$subquestionmatch['righte_index1'],$subquestionmatch['title2'],$subquestionmatch['righte_index2'],$subquestionmatch['image1'],$subquestionmatch['image2']);
                                             }else{
                                                $math_type_view_title1 = renderMathType($subquestionmatch['title1']);
                                                $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);
                                                
                                                $math_type_view_title2 = renderMathType($subquestionmatch['title2']);
                                                $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);
        
        
                                                $matchqui = "UPDATE `test_questions_match_items` SET ";
                                                $matchqui .= " `title1` = '{$subquestionmatch['title1']}', ";
                                                $matchqui .= " `title2` = '{$subquestionmatch['title2']}', ";
                                                 $matchqui .= $math_type_view_title1 && $math_type_view_title1 !=''?" `math_type_view_title1` = '{$math_type_view_title1}', ":"";
                                                 $matchqui .= $math_type_view_title2 && $math_type_view_title2 !=''?" `math_type_view_title2` = '{$math_type_view_title2}', ":"";
                                                 $matchqui .= $subquestionmatch['image1'] && $subquestionmatch['image1'] !=''? " `image1` = '{$subquestionmatch['image1']}', ":"";
                                                 $matchqui .= $subquestionmatch['image2'] && $subquestionmatch['image2'] !='' ?" `image2` = '{$subquestionmatch['image2']}', ":"";
                                             
                                                $matchqui .= " `righte_index1` = '{$subquestionmatch['righte_index1']}', ";
                                                $matchqui .= " `righte_index2` = '{$subquestionmatch['righte_index2']}' ";
                                                $matchqui .= " WHERE `id`='{$subquestionmatch['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this -> mDb -> query($matchqui);
                                             }
                                    }
                                }
                                    if($subquestion['id'] > 0 && $subquestion['type'] == 'sort_it'){
                                        for($sqwdi=0;$sqwdi<count($subquestion['sort_questions_words']) ;$sqwdi++) {
                                            
                                            $subquestionword=$subquestion['sort_questions_words'][$sqwdi];
                                            if($subquestionword['title'] !='' &&$subquestionword['id'] < 1){
                                                 $this -> InsertIntoSortQuestionWords($subquestion['id'],$subquestionword['title'],$subquestionword['word_index']);
                                            }else{
                                                  $math_type_view_title = renderMathType($subquestionword['title']); 
                                                  $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                                $sortquw = "UPDATE `test_questions_sort_words` SET ";
                                                $sortquw .= " `title` = '{$subquestionword['title']}', ";
                                                 $sortquw .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                                $sortquw .= " `word_index` = '{$subquestionword['word_index']}' ";
                                                $sortquw .= " WHERE `id`='{$subquestionword['id']}' AND `question_id` = '{$subquestion['id']}' ";
                                                $this -> mDb -> query($sortquw);
                                            }
                                         }
                                    }



                                }
                            }
                           
                        }
                        
                        
                         if($questid >= 1  && $current_quest['type'] == 'complete_it'){
                            for($cdsub=0;$cdsub<count($current_quest['question_sub_questions']) ;$cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub =  $this -> InsertIntoTestQuestions($question_test_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$questid,$subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption=$subquestion["test_questions_complete_words"][$iirr];
                                            $this -> InsertIntoTestQuestionCompleteWord($idqsub,$subquestionoption['title'],$subquestionoption['word_index'],$subquestionoption['note']);
                                        }
                                    }
                                   
                                }else{
                                     $math_type_view_title = renderMathType($subquestion['title']);
                                     $math_type_view_note = renderMathType($subquestion['note']);
                                     $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                     $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
                                    $stmtq = "UPDATE `test_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                     $stmtq .= " `note` = '{$subquestion['note']}', ";
                                      $stmtq .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                      $stmtq .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND `test_id` = '{$question_test_id}' ";
                                    $this -> mDb -> query($stmtq);
                                    if(count($subquestion['test_questions_complete_words']) > 0){
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {
                                           
                                            if($testObjOp['title'] !='' &&$testObjOp['id'] < 1){
                                               $this -> InsertIntoTestQuestionCompleteWord($subquestion['id'],$testObjOp['title'],$testObjOp['word_index'],$testObjOp['note']);
                                            }elseif($testObjOp['title'] !='' &&$testObjOp['id'] >= 1){
                                                
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                     
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    
                                                
                                                $stmtqup = "UPDATE `test_questions_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                 $stmtqup .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                              $this -> mDb -> query($stmtqup);
                                            }
                                        }
                                    }
                                   
                                }
                            }
                        }
                         if($questid >= 1  && $current_quest['type'] == 'complete_it_writing_auto_correct'){
                            for($cdsub=0;$cdsub<count($current_quest['question_sub_questions']) ;$cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub =  $this -> InsertIntoTestQuestions($question_test_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$questid,$subquestion['note']);
                                    if ($idqsub > 0 && count($subquestion['test_questions_complete_words']) > 0) {
                                        for ($iirr = 0; $iirr < count($subquestion['test_questions_complete_words']); $iirr++) {
                                            $subquestionoption=$subquestion["test_questions_complete_words"][$iirr];
                                            $this -> InsertIntoTestQuestionCompleteWord($idqsub,$subquestionoption['title'],$subquestionoption['word_index'],$subquestionoption['note']);
                                        }
                                    }
                                   
                                }else{
                                     $math_type_view_title = renderMathType($subquestion['title']);
                                     $math_type_view_note = renderMathType($subquestion['note']);
                                     $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                     $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
                                    $stmtq = "UPDATE `test_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                     $stmtq .= " `note` = '{$subquestion['note']}', ";
                                      $stmtq .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                      $stmtq .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND `test_id` = '{$question_test_id}' ";
                                    $this -> mDb -> query($stmtq);
                                    if(count($subquestion['test_questions_complete_words']) > 0){
                                        foreach ($subquestion['test_questions_complete_words'] as $testObjOp) {
                                           
                                            if($testObjOp['title'] !='' &&$testObjOp['id'] < 1){
                                               $this -> InsertIntoTestQuestionCompleteWord($subquestion['id'],$testObjOp['title'],$testObjOp['word_index'],$testObjOp['note']);
                                            }elseif($testObjOp['title'] !='' &&$testObjOp['id'] >= 1){
                                                
                                                $math_type_view_title = renderMathType($testObjOp['title']);
                                     
                                                $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                    
                                                
                                                $stmtqup = "UPDATE `test_questions_complete_words` SET ";
                                                $stmtqup .= " `title` = '{$testObjOp['title']}', ";
                                                 $stmtqup .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                                $stmtqup .= " `word_index` = '{$testObjOp['word_index']}' ";
                                                $stmtqup .= " WHERE `id`='{$testObjOp['id']}' ";
                                              $this -> mDb -> query($stmtqup);
                                            }
                                        }
                                    }
                                   
                                }
                            }
                        }
                        
                          if($questid >= 1  && $current_quest['type'] == 'complete_it_writing_manual_correct'){
                            for($cdsub=0;$cdsub<count($current_quest['question_sub_questions']) ;$cdsub++) {
                                $subquestion = $current_quest['question_sub_questions'][$cdsub];
                                if ($subquestion['id'] < 1) {
                                    $idqsub =  $this -> InsertIntoTestQuestions($question_test_id,$subquestion['type'],$subquestion['source'],$subquestion['degree'],$subquestion['title'],$questid,$subquestion['note']);
                                }else{
                                     $math_type_view_title = renderMathType($subquestion['title']);
                                     $math_type_view_note = renderMathType($subquestion['note']);
                                     $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
                                     $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
                                    $stmtq = "UPDATE `test_questions` SET ";
                                    $stmtq .= " `type` = '{$subquestion['type']}', ";
                                    $stmtq .= " `source` = '{$subquestion['source']}', ";
                                    $stmtq .= " `degree` = '{$subquestion['degree']}', ";
                                     $stmtq .= " `note` = '{$subquestion['note']}', ";
                                      $stmtq .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                      $stmtq .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
                                    $stmtq .= " `title` = '{$subquestion['title']}' ";
                                    $stmtq .= " WHERE `id`='{$subquestion['id']}' AND `test_id` = '{$question_test_id}' ";
                                    $this -> mDb -> query($stmtq);
                                  
                                }
                            }
                        }

                        if($questid > 0 && $current_quest['type'] == 'match_it'){
                            for($imgisub=0;$imgisub<count($current_quest['match_questions_items']) ;$imgisub++) {
                                $subquestion=$current_quest['match_questions_items'][$imgisub];
                                if($subquestion['title1'] !='' &&$subquestion['id'] < 1){
                                 $this -> InsertIntoMatchQuestionItems($questid,$subquestion['title1'],$subquestion['righte_index1'],$subquestion['title2'],$subquestion['righte_index2'],$subquestion['image1'],$subquestion['image2']);
                                 }else{
                                     
                                        $math_type_view_title1 = renderMathType($subquestion['title1']);
                                        $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);
                                        
                                        $math_type_view_title2 = renderMathType($subquestion['title2']);
                                        $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);
        
                                     
                                    $matchqui = "UPDATE `test_questions_match_items` SET ";
                                    $matchqui .= " `title1` = '{$subquestion['title1']}', ";
                                    $matchqui .= $math_type_view_title1 && $math_type_view_title1 !=''?" `math_type_view_title1` = '{$math_type_view_title1}', ":"";
                                    $matchqui .= $math_type_view_title2 && $math_type_view_title2 !=''?" `math_type_view_title2` = '{$math_type_view_title2}', ":"";
                                    $matchqui .= " `title2` = '{$subquestion['title2']}', ";
                                    $matchqui .= $subquestion['image1'] && $subquestion['image1'] !=''? " `image1` = '{$subquestion['image1']}', ":"";
                                    $matchqui .= $subquestion['image2'] && $subquestion['image2'] !='' ?" `image2` = '{$subquestion['image2']}', ":"";
                                             
                                    $matchqui .= " `righte_index1` = '{$subquestion['righte_index1']}', ";
                                    $matchqui .= " `righte_index2` = '{$subquestion['righte_index2']}' ";
                                    $matchqui .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";
                                  
                                    $this -> mDb -> query($matchqui);
                                 }
                        }
                    }
                        if($questid > 0 && $current_quest['type'] == 'sort_it'){
                            for($sqwi=0;$sqwi<count($current_quest['sort_questions_words']) ;$sqwi++) {
                                $subquestion=$current_quest['sort_questions_words'][$sqwi];
                                if($subquestion['title'] !='' &&$subquestion['id'] < 1){
                                     $this -> InsertIntoSortQuestionWords($questid,$subquestion['title'],$subquestion['word_index']);
                                }else{
                                     $math_type_view_title = renderMathType($subquestion['title']); 
                                     $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

                                    $sortquw = "UPDATE `test_questions_sort_words` SET ";
                                    $sortquw .= " `title` = '{$subquestion['title']}', ";
                                    $sortquw .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
                                    $sortquw .= " `word_index` = '{$subquestion['word_index']}' ";
                                    $sortquw .= " WHERE `id`='{$subquestion['id']}' AND `question_id` = '{$questid}' ";
                                    $this -> mDb -> query($sortquw);
                                }
                             }
                        }
                    }
                    $this->updateDegreeOfTest($question_test_id);
                }

                return $this->getOneQuestion($questid);
            }
        }
    }

    function updateDegreeOfTest($test_id)
    {
        $total_degree = $this->getSumOfDegreeOfTestQuestions($test_id);
        $sql = "UPDATE `tests` SET";
        $sql .= "`total_degree`='{$total_degree}' ";
        $sql .= "where `id`= $test_id";
        $this->mDb->query($sql);
    }

    function getSumOfDegreeOfTestQuestions($test_id)
    {
        $sql = "SELECT SUM(degree) From test_questions ";
        $sql .= "where `test_id`= '{$test_id}' AND  ( `type` = 'choose' OR  `type` = 'check' OR  `type` = 'article' OR  `type` = 'complete_it_sub' OR  `type` = 'sort_it' OR  `type` = 'match_it') AND `is_deleted` = '0' ";
        return $this->mDb->getOne($sql);
    }



function InsertIntoTestQuestions($test_id,$type,$source,$degree,$title,$parent_id='',$note='') {

    $math_type_view_title = renderMathType($title);
    $math_type_view_note = renderMathType($note);
    $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
    $math_type_view_note = str_replace("'", "\'", $math_type_view_note);
     
     
    $titlee = str_replace("'", "\'", $title);
    $note = str_replace("'", "\'", $note);
    
     
    $stmt = "INSERT INTO `test_questions` SET ";
    $stmt .= " `test_id` = '{$test_id}', ";
    $stmt .= $parent_id && $parent_id !='' ? " `parent_id` = '{$parent_id}', " :"";
    $stmt .= " `type` = '{$type}', ";
    $stmt .= " `source` = '{$source}', ";
    $stmt .= " `note` = '{$note}', ";
    $stmt .= " `degree` = '{$degree}', ";
    $stmt .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
    $stmt .= $math_type_view_note && $math_type_view_note !=''?" `math_type_view_note` = '{$math_type_view_note}', ":"";
    $stmt .= " `title` = '{$titlee}' ";

    return $this -> mDb -> queryreturnlastid($stmt);
}
function InsertIntoMatchQuestionItems($test_question_id,$title1,$righte_index1,$title2,$righte_index2,$image1='',$image2='') {
   
        $math_type_view_title1 = renderMathType($title1);
        $math_type_view_title1 = str_replace("'", "\'", $math_type_view_title1);
        
         $math_type_view_title2 = renderMathType($title2);
        $math_type_view_title2 = str_replace("'", "\'", $math_type_view_title2);
        
        
        $title1 = str_replace("'", "\'", $title1);
        $title2 = str_replace("'", "\'", $title2);
        
        
        $stmto = "INSERT INTO `test_questions_match_items` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title1` = '{$title1}', ";
        $stmto .= $math_type_view_title1 && $math_type_view_title1 !=''?" `math_type_view_title1` = '{$math_type_view_title1}', ":"";
        $stmto .= " `title2` = '{$title2}', ";
        $stmto .= $math_type_view_title2 && $math_type_view_title2 !=''?" `math_type_view_title2` = '{$math_type_view_title2}', ":"";
        $stmto .= $image1 &&$image1!=''?" `image1` = '{$image1}', ":"";
        $stmto .= $image2 &&$image2!=''?" `image2` = '{$image2}', ":"";
        $stmto .= $righte_index1 ?" `righte_index1` = '{$righte_index1}', ":"";
        $stmto .= " `righte_index2` = '{$righte_index2}' ";
        return  $this->mDb->queryreturnlastid($stmto);
}

function InsertIntoSortQuestionWords($test_question_id,$title,$word_index) {

        $math_type_view_title = renderMathType($title); 
        $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

        $title = str_replace("'", "\'", $title);
        $stmto = "INSERT INTO `test_questions_sort_words` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
          $stmto .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
        $stmto .= " `title` = '{$title}', ";
        $stmto .= " `word_index` = '{$word_index}' ";

        return  $this->mDb->queryreturnlastid($stmto);
}




    function InsertIntoTestQuestionOptions($test_question_id,$title,$status,$note) {
        $titlee = str_replace("'", "\'", $title);
        $math_type_view_title = renderMathType($title); 
         $math_type_view_title = str_replace("'", "\'", $math_type_view_title);
        $noteee = str_replace("'", "\'", $note);
        
        $stmto = "INSERT INTO `test_question_options` SET ";
        $stmto .= " `test_question_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$titlee}', ";
          $stmto .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
        $stmto .= " `status` = '{$status}', ";
        $stmto .= " `note` = '{$noteee}' ";
        return  $this->mDb->queryreturnlastid($stmto);
    }
    
    
    
    
    function InsertIntoTestQuestionCompleteWord($test_question_id,$title,$word_index,$note='') {
        
          $math_type_view_title = renderMathType($title); 
         $math_type_view_title = str_replace("'", "\'", $math_type_view_title);

        $title = str_replace("'", "\'", $title);
        
        $stmto = "INSERT INTO `test_questions_complete_words` SET ";
        $stmto .= " `question_id` = '{$test_question_id}', ";
        $stmto .= " `title` = '{$title}', ";
         $stmto .= $math_type_view_title && $math_type_view_title !=''?" `math_type_view_title` = '{$math_type_view_title}', ":"";
        $stmto .= " `word_index` = '{$word_index}' ";

        return  $this->mDb->queryreturnlastid($stmto);
}
    
    


    function getOneQuestion($id){

        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`id` = '{$id}' AND pl.`is_deleted` = '0'";
        $result = $this -> mDb -> getRow($stmt);
        if(count($result) > 0){
            $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['id']}'    AND related_to = 'option')";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['id']}'    AND qattachfilenote.`related_to` = 'note')";
            $stmto .= " WHERE tqo.`test_question_id` = ".$result['id'];
//            echo $stmto;die();
            $result['test_question_options'] = $this -> mDb -> getAll($stmto);
            
            if($result['type'] == 'paragraphs' ){
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`test_id` = '{$result['test_id']}' AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
//                    echo $stmt;die();
                $result['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                if(count($result['question_sub_questions'])>0){
                    for($iisub=0;$iisub< count($result['question_sub_questions']) ;$iisub++) {
                        $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                        $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                        $result['question_sub_questions'][$iisub]['test_question_options'] = $this -> mDb -> getAll($stmtosub);


                        if($result['question_sub_questions'][$iisub]['type'] == 'match_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['match_questions_items'] = $this -> mDb -> getAll($stmt);
                        }
                        if($result['question_sub_questions'][$iisub]['type'] == 'sort_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
                            $result['question_sub_questions'][$iisub]['sort_questions_words'] = $this -> mDb -> getAll($stmt);
                        }

                    }
                }
            }
            
                  if($result['type'] == 'complete_it' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$result['test_id']}' AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                                $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                     if($result['type'] == 'complete_it_writing_auto_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$result['test_id']}' AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['question_sub_questions'][$iisub]['id']}' ";
                                $result['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                     if($result['type'] == 'complete_it_writing_manual_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$result['test_id']}' AND pl.`parent_id` = '{$result['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                    }

            if($result['type'] == 'match_it' ){
                $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['match_questions_items'] = $this -> mDb -> getAll($stmt);

            }

            if($result['type'] == 'sort_it' ){
                $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                $stmt .= " WHERE mq.`question_id` = '{$id}' ";
//                    echo $stmt;die();
                $result['sort_questions_words'] = $this -> mDb -> getAll($stmt);

            }

        }
        return $result;
    }
    
    function getCountOfAnswerOnTest($test_id)
  {
    $sql = "SELECT count( `id` ) from  `student_tests_answers`  ";
    $sql .= "  where `test_id`={$test_id} AND `total_answered_questions_count` > '0'   ";
     return $this->mDb->getOne($sql);
  }

    function getOneTest($id) {

	$result = array();
	$sql = "SELECT te.*,subjectt.`subject_direction` as 'subject_direction' ,subjectt.`semester` as 'subject_semester' FROM `tests` te";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
	$sql .= " WHERE te.`id` = '{$id}'";
	$result = $this -> mDb -> getRow($sql);
	
	if($result){
	    $result['student_test_answers_count']=$this ->getCountOfAnswerOnTest($id);
	    
	}
	
	
	$stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
	$stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '0' AND pl.`is_deleted` = '0'  order by pl.`id` ASC";
	
	$result['test_questions'] = $this -> mDb -> getAll($stmt);
	if(count($result['test_questions']) > 0){
	     $qindex=0;
        for($ii=0;$ii< count($result['test_questions']);$ii++) {
            $stmto = "SELECT tqo.* ,qattachfile.`file`,qattachfile.`attachment_type`,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfile.`related_to` = 'option')";
            $stmto .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND qattachfilenote.`related_to` = 'note')";
            $stmto .= " WHERE tqo.`test_question_id` = ".$result['test_questions'][$ii]['id'];
//            echo $stmto;die();
            $result['test_questions'][$ii]['test_question_options'] = $this -> mDb -> getAll($stmto);
            if($result['test_questions'][$ii]['type'] == 'paragraphs' ){
                $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
                $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}'  AND pl.`is_deleted` = '0'";
                $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                    for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                        $stmtosub = "SELECT tqo.*  ,qattachfile.`file`,qattachfile.`attachment_type` ,qattachfilenote.`file` as 'file_note',qattachfilenote.`attachment_type` as 'attachment_note_type' FROM `test_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfile.`related_to` = 'option')";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfilenote ON  ( qattachfilenote.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND qattachfilenote.`related_to` = 'note')";
                        $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
//                        echo $stmtosub;die();
                        $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this -> mDb -> getAll($stmtosub);

                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this -> mDb -> getAll($stmt);
            
                        }
            
                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this -> mDb -> getAll($stmt);
            
                        }

                    }
                }
            }
            
        
            
                    if($result['test_questions'][$ii]['type']  == 'complete_it' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                       if($result['test_questions'][$ii]['type']  == 'complete_it_writing_auto_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
            
             if($result['test_questions'][$ii]['type']  == 'complete_it_writing_manual_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                       
                    }
            
            


            if($result['test_questions'][$ii]['type'] == 'match_it' ){
                $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
$result['test_questions'][$ii]['match_questions_items'] = $this -> mDb -> getAll($stmt);

            }

            if($result['test_questions'][$ii]['type'] == 'sort_it' ){
                $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
//                    echo $stmt;die();
$result['test_questions'][$ii]['sort_questions_words'] = $this -> mDb -> getAll($stmt);

            }

            if($result['test_questions'][$ii]['type'] != 'head_question'  ){
                $qindex++;
                $result['test_questions'][$ii]['index']=$qindex;
            }else{
                $result['test_questions'][$ii]['index']=0;
            }


        }
    }
	return $result;
}
function getTestDetailsInfo($id) {

	$result = array();

    $sql = "SELECT te.id,te.type,te.dedicated_to,te.semester ,te.set_from,te.teacher_id,te.classification ,te.sort, te.status, te.printable, te.date_added, te.name, u.full_name AS 'user_full_name' , teacher.full_name AS 'teacher_full_name' , ";
    $sql .= " cuntl.`name` as 'country_name',";
    $sql .= " stagel.`name` as 'stage_name',";
    $sql .= " gradel.`name` as 'grade_name' , ";
    $sql .= " unitl.`name` as 'unit_name' , ";
    $sql .= " lessonl.`name` as 'lesson_name' , ";
    $sql .= " subjectt.`name` as 'subject_name',";
    $sql .= " subjectt.`subject_direction` as 'subject_direction'";
    $sql .= " FROM `tests` te";
    $sql .= " LEFT JOIN `users` u ON u.id = te.added_by ";
    $sql .= " LEFT JOIN `users` teacher ON teacher.id = te.teacher_id ";
    $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
    $sql .= " LEFT JOIN `grades_langs` gradel ON  ( te.`grade_id` = gradel.`grade_id` AND gradel.`lang_code` = 'ar')";
    $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
    $sql .= " LEFT JOIN `unit_lessons` lessonl ON  ( te.`lesson_id` = lessonl.`id` )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( te.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = 'ar') ";
    $sql .= " LEFT JOIN `stages_langs` stagel ON  ( te.`stage_id` = stagel.`stage_id` AND stagel.`lang_code` = 'ar') ";
    $sql.= " WHERE te.id ='{$id}' ";

    $result = $this -> mDb -> getRow($sql);

    if(count($result) > 0){
        $stmt = "SELECT pl.*,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '0' AND pl.`is_deleted` = '0' order by pl.`id` ASC";
//echo $stmt;die();
        $result['test_questions'] = $this -> mDb -> getAll($stmt);

        if(count($result['test_questions'])>0){
            $qindex=0;
            for($ii=0;$ii< count($result['test_questions']) ;$ii++) {
                $stmto = "SELECT tqo.`id`,tqo.`title`,tqo.`status` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}'    AND related_to = 'option')";
                $stmto .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['id']}' ";
                $result['test_questions'][$ii]['test_question_options'] = $this -> mDb -> getAll($stmto);

                if($result['test_questions'][$ii]['type'] == 'paragraphs' ){
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                    $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                    if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                        for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                        $stmtosub = "SELECT tqo.`id` ,tqo.`title`,tqo.`status` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'    AND related_to = 'option')";
                        $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                        $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this -> mDb -> getAll($stmtosub);

                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this -> mDb -> getAll($stmt);
            
                        }
            
                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this -> mDb -> getAll($stmt);
            
                        }

                        }
                  }
                }
                
                  if($result['test_questions'][$ii]['type']  == 'complete_it' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                    
                  if($result['test_questions'][$ii]['type']  == 'complete_it_writing_auto_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                     if($result['test_questions'][$ii]['type']  == 'complete_it_writing_manual_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id` = '{$id}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
        //                    echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        
                    }


                if($result['test_questions'][$ii]['type'] == 'match_it' ){
                                $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                //                    echo $stmt;die();
                $result['test_questions'][$ii]['match_questions_items'] = $this -> mDb -> getAll($stmt);

                            }

                            if($result['test_questions'][$ii]['type'] == 'sort_it' ){
                                $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                //                    echo $stmt;die();
                $result['test_questions'][$ii]['sort_questions_words'] = $this -> mDb -> getAll($stmt);

                            }



            if($result['test_questions'][$ii]['type'] != 'head_question'  ){
                $qindex++;
                $result['test_questions'][$ii]['index']=$qindex;
            }else{
                $result['test_questions'][$ii]['index']=0;
            }

            }

        }
   }

 if(count($result) > 0){
        $stmt = "SELECT pl.admin_id	,pl.date_added, u.full_name AS 'admin_name' FROM `admins_edit_tests` pl";
        $stmt .= " LEFT JOIN `users` u ON u.id = pl.admin_id ";
        $stmt .= " WHERE pl.`test_id` = '{$id}' order by pl.id desc ";
        $result['edit_by_admins'] = $this -> mDb -> getAll($stmt);
 }
	return $result;
}

function deleteTest($ids) {
    
    $tempids='('.implode(',',$ids).')';


    $sql = "SELECT `id` FROM `test_questions`";
    $sql .= " WHERE `test_id` IN ".$tempids;
    $qids = $this -> mDb -> getAll($sql);

  


    if(count($qids)>0){
        for ($i=0;$i<count($qids);$i++){
            $sqll = "DELETE FROM `test_question_options` ";
            $sqll.= " WHERE `test_question_id` = '{$qids[$i]['id']}'";
            $this-> mDb-> query($sqll);
        }
    }
    
      $sqll = "DELETE FROM `test_questions` ";
    $sqll.= " WHERE `test_id` IN ".$tempids;
    $this-> mDb-> query($sqll);


    

//    $catsql = "DELETE FROM `tests` ";
//    $catsql.= " WHERE `id` IN ".$tempids;

    $sql = "UPDATE `tests` SET ";
    $sql .=" `is_deleted`='1' ";
    $sql .= " WHERE `id` IN ".$tempids;


    return  $this-> mDb-> query($sql);
}

function getQuestionsWithTestID($ids) {
    
    $tempids='('.implode(',',$ids).')';

	$result = array();
	
   
    
        $stmt = "SELECT pl.*,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
        $stmt .= " WHERE pl.`test_id` IN {$tempids} AND pl.`parent_id` = '0' AND pl.`is_deleted` = '0' order by pl.`id` ASC";
// echo $stmt;die();
        $result['test_questions'] = $this -> mDb -> getAll($stmt);
  
  
  
     if(count($result['test_questions'])>0){
            $qindex=0;
            for($ii=0;$ii< count($result['test_questions']) ;$ii++) {
                $stmto = "SELECT tqo.`id`,tqo.`title` ,tqo.`status`  ,tqo.`note` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                $stmto .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['id']}'   AND related_to = 'option')";
                $stmto .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['id']}' ";
                $result['test_questions'][$ii]['test_question_options'] = $this -> mDb -> getAll($stmto);

                if($result['test_questions'][$ii]['type'] == 'paragraphs' ){
                    $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_questions` pl";
                    $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                    $stmt .= " WHERE pl.`test_id` = '{$result['test_questions'][$ii]['test_id']}' AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                    // echo $stmt;die();
                    $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                    if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                        for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                        $stmtosub = "SELECT tqo.`id` ,tqo.`title` ,tqo.`status`  ,tqo.`note` ,qattachfile.`file`,qattachfile.`attachment_type` FROM `test_question_options` tqo ";
                        $stmtosub .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}'   AND related_to = 'option')";
                        $stmtosub .= " WHERE tqo.`test_question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                        $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_question_options'] = $this -> mDb -> getAll($stmtosub);

                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'match_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['match_questions_items'] = $this -> mDb -> getAll($stmt);
            
                        }
            
                        if($result['test_questions'][$ii]['question_sub_questions'][$iisub]['type'] == 'sort_it' ){
                            $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                            $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
            //                    echo $stmt;die();
            $result['test_questions'][$ii]['question_sub_questions'][$iisub]['sort_questions_words'] = $this -> mDb -> getAll($stmt);
            
                        }

                        }
                  }
                }

                if($result['test_questions'][$ii]['type']  == 'complete_it' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id`IN {$tempids} AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                            // echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                    
                      if($result['test_questions'][$ii]['type']  == 'complete_it_writing_auto_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id`IN {$tempids} AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                            // echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                        if(count($result['test_questions'][$ii]['question_sub_questions'])>0){
                            for($iisub=0;$iisub< count($result['test_questions'][$ii]['question_sub_questions']) ;$iisub++) {
                                $stmtosub = "SELECT tqcw.*  FROM `test_questions_complete_words` tqcw ";
                                $stmtosub .= " WHERE tqcw.`question_id` ='{$result['test_questions'][$ii]['question_sub_questions'][$iisub]['id']}' ";
                                $result['test_questions'][$ii]['question_sub_questions'][$iisub]['test_questions_complete_words'] = $this -> mDb -> getAll($stmtosub);
                            }
                        }
                    }
                    
                     if($result['test_questions'][$ii]['type']  == 'complete_it_writing_manual_correct' ){
                        $stmt = "SELECT pl.* ,qattachfile.`file`,qattachfile.`attachment_type`  FROM `test_questions` pl";
                        $stmt .= " LEFT JOIN `test_question_attachments` qattachfile ON  ( qattachfile.`question_id` = pl.`id` AND  qattachfile.`option_id` IS NULL  AND related_to = 'question')";
                        $stmt .= " WHERE pl.`test_id`IN {$tempids} AND pl.`parent_id` = '{$result['test_questions'][$ii]['id']}' AND pl.`is_deleted` = '0'";
                            // echo $stmt;die();
                        $result['test_questions'][$ii]['question_sub_questions'] = $this -> mDb -> getAll($stmt);

                    }

                if($result['test_questions'][$ii]['type'] == 'match_it' ){
                                $stmt = "SELECT mq.*  FROM `test_questions_match_items` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                //                    echo $stmt;die();
                $result['test_questions'][$ii]['match_questions_items'] = $this -> mDb -> getAll($stmt);

                            }

                            if($result['test_questions'][$ii]['type'] == 'sort_it' ){
                                $stmt = "SELECT mq.*  FROM `test_questions_sort_words` mq";
                                $stmt .= " WHERE mq.`question_id` = '{$result['test_questions'][$ii]['id']}' ";
                //                    echo $stmt;die();
                $result['test_questions'][$ii]['sort_questions_words'] = $this -> mDb -> getAll($stmt);

                            }



            if($result['test_questions'][$ii]['type'] != 'head_question' ){
                $qindex++;
                $result['test_questions'][$ii]['index']=$qindex;
            }else{
                $result['test_questions'][$ii]['index']=0;
            }

            }

        }
  
  

    return  $result;
}


function deleteQuestion($ids) {

    $tempids='('.implode(',',$ids).')';

    $sql = "SELECT `test_id` FROM `test_questions`";
    $sql .= " WHERE `id` IN ".$tempids;
    $test_id = $this -> mDb -> getOne($sql);


    $sqllo = "DELETE FROM `test_question_options` ";
    $sqllo.= " WHERE `test_question_id` IN ".$tempids;
    $this-> mDb-> query($sqllo);
    
    $sql = "DELETE  from `test_questions`" ;
    $sql .=" WHERE  `parent_id`  IN ".$tempids;
    $this->mDb->query($sql);

    $sqll = "DELETE FROM `test_questions` ";
    $sqll.= " WHERE `id` IN ".$tempids;

    // $sqll = "UPDATE `test_questions` SET ";
    // $sqll .=" `is_deleted`='1' ";
    // $sqll .= " WHERE `id` IN ".$tempids;
$res=$this-> mDb-> query($sqll);

    $this->updateDegreeOfTest($test_id);
    return  $res;
}


    function generateTestRequestPdf($data)
    {
        $id = $data['id'];
        $user_id = $data['user_id'];

        if (($id && $id > 0) && ($user_id && $user_id >0)) {

            $testData=$this->getTestDetailsInfo($id);


            // $defaultConfig = (new Mpdf\Config\ConfigVariables())->getDefaults();
            // $fontDirs = $defaultConfig['fontDir'];
            // $defaultFontConfig = (new Mpdf\Config\FontVariables())->getDefaults();
            // $fontData = $defaultFontConfig['fontdata'];
            // $mpdf = new \Mpdf\Mpdf([
            //     'fontDir' => array_merge($fontDirs, [
            //         __DIR__ . './font',
            //     ]),
            //     'fontdata' => $fontData + [
            //             'Cairo' => [
            //                 'R' => 'Cairo-VariableFont_wght.ttf',
            //                 'I' => 'Cairo-VariableFont_wght.ttf',
            //             ]
            //         ],
            //     'default_font' => 'Cairo'
            // ]);


        $mpdf = new \Mpdf\Mpdf(['autoArabic' => true,'autoScriptToLang' => true]);
            ob_start();

//        include "./RentRequest.php";
            include "./exam_sheet/exam.php";
            $html = ob_get_contents();

//        $mpdf->SetJS('<script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>') ;
//        $mpdf->SetJS('<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3.0.1/es5/tex-mml-chtml.js"></script>') ;
            $mpdf->SetJS("window.alert('Please login first to access this page.')");
//        sleep(3);
            ob_end_clean();

//          $mpdf->output("../uploads/RentesPDF/RentRequest.pdf", \Mpdf\Output\Destination::FILE);
//        return true;

            $mpdf->WriteHtml($html);
            return $mpdf->Output('filename.pdf', 'D');
        }
    }

    function generateTestRequestPdfold(){

        // $options = new Options();
        // $options->set('defaultFont', 'Cairo');
        // $dompdf = new Dompdf($options);
        // $html = file_get_contents("./exam_sheet/exam.html");
        // $dompdf->loadHtml($html);


// // (Optional) Setup the paper size and orientation
//         $dompdf->setPaper('A4', 'landscape');

// // Render the HTML as PDF
//         $dompdf->render();

// // Output the generated PDF to Browser
//        return $dompdf->stream();


    die();

        // $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

        // // set document information
        // $pdf->SetCreator(PDF_CREATOR);
        // $pdf->SetAuthor('Your Blog Coach');
        // $pdf->SetTitle('Heading');

        // // set default header data
        // $pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 006', PDF_HEADER_STRING);
        // $pdf->addJavascriptObject("window.alert('Please login first to access this page.')",true);
        // // set header and footer fonts
        // $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        // $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

        // set default monospaced font
//        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

        // set margins
        // $pdf->SetMargins(20, 20, 20);
        // $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        // $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

        // // set auto page breaks
        // $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

        // // set image scale factor
        // $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

        // add a page
//         $pdf->AddPage();

// //        include "./exam_sheet/exam.html";
// //        $html = ob_get_contents();
//         $html = '<body><h1>emad</h1></body>';

//         $pdf->writeHTML($html, true, false, true, false, '');

        // add a page
//        $pdf->AddPage();
//
//        $html .= '<h4>Second page</h4>';
//
//        $pdf->writeHTML($html, true, false, true, false, '');



        // // reset pointer to the last page
        // $pdf->lastPage();
        // //Close and output PDF document
        // $pdf->Output('example.pdf', 'D');

        return true;

//        $html2pdf = new Html2Pdf();
//        include "./exam_sheet/exam.html";
//        $html = ob_get_contents();
//
//        $html2pdf->writeHTML($html);
//        return  $html2pdf->output('myPdf.pdf', 'D');
//

        
        // $defaultConfig = (new Mpdf\Config\ConfigVariables())->getDefaults();
        // $fontDirs = $defaultConfig['fontDir'];
        // $defaultFontConfig = (new Mpdf\Config\FontVariables())->getDefaults();
        // $fontData = $defaultFontConfig['fontdata'];
        // $mpdf = new \Mpdf\Mpdf([
        //     'fontDir' => array_merge($fontDirs, [
        //         __DIR__ . './font',
        //     ]),
        //     'fontdata' => $fontData + [
        //             'Cairo' => [
        //                 'R' => 'Cairo-VariableFont_wght.ttf',
        //                 'I' => 'Cairo-VariableFont_wght.ttf',
        //             ]
        //         ],
        //     'default_font' => 'Cairo'
        // ]);


//        $mpdf = new \Mpdf\Mpdf(['autoArabic' => true,'autoScriptToLang' => true]);
        ob_start();

//        include "./RentRequest.php";
        include "./exam_sheet/exam.html";
        $html = ob_get_contents();

//        $mpdf->SetJS('<script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>') ;
//        $mpdf->SetJS('<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3.0.1/es5/tex-mml-chtml.js"></script>') ;
//        $mpdf->SetJS('<script type="text/javascript">window.alert("Please login first to access this page."); </script>') ;
//        sleep(3);
        ob_end_clean();

//          $mpdf->output("../uploads/RentesPDF/RentRequest.pdf", \Mpdf\Output\Destination::FILE);
//        return true;

        $mpdf->WriteHtml($html);
        return   $mpdf->Output('filename.pdf', 'D');
    }




function deleteSupQuestionByParent($ids) {

    $tempids='('.implode(',',$ids).')';



    $sql = "SELECT `test_id` FROM `test_questions`";
    $sql .= " WHERE `id` IN ".$tempids;
    $test_id = $this -> mDb -> getOne($sql);


    $sql = "SELECT `id` FROM `test_questions`";
    $sql .= " WHERE `parent_id` IN ".$tempids;
    $qids = $this -> mDb -> getAll($sql);

    if(count($qids)>0){
        for ($i=0;$i<count($qids);$i++){
            $sqll = "DELETE FROM `test_question_options` ";
            $sqll.= " WHERE `test_question_id` = '{$qids[$i]['id']}'";
            $this-> mDb-> query($sqll);
        }
    }


    $sqll = "DELETE FROM `test_questions` ";
    $sqll.= " WHERE `parent_id` IN ".$tempids;

   
$res=$this-> mDb-> query($sqll);

    $this->updateDegreeOfTest($test_id);
   


    // $sqll = "UPDATE `test_questions` SET ";
    // $sqll .=" `is_deleted`='1' ";
    // $sqll .= " WHERE `parent_id` IN ".$tempids;
    // $this-> mDb-> query($sqll);

    return  $res;
}


function deleteAttachment($request) {

    $sqll = "DELETE FROM `test_question_attachments` ";
    $sqll.= " WHERE `file` = '{$request['file']}' AND `related_to` = '{$request['related_to']}'";
    $res=$this-> mDb-> query($sqll);

    if($res){
        $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'questions_attachments/' . $request['file'];

        if (file_exists($old_img)) {
            // @unlink($old_img);
        }
    }

	return  $res;
}
function deleteQuestionOption($ids) {

    $tempids='('.implode(',',$ids).')';
    $sqll = "DELETE FROM `test_question_options` ";
    $sqll.= " WHERE `id` IN ".$tempids;
	return  $this-> mDb-> query($sqll);
}
function deleteMatchQuestionsItem($ids) {

    $tempids='('.implode(',',$ids).')';
    $sqll = "DELETE FROM `test_questions_match_items` ";
    $sqll.= " WHERE `id` IN ".$tempids;
	return  $this-> mDb-> query($sqll);
}
function removeMatchQuestionsImage($ids,$image_type) {

    $tempids='('.implode(',',$ids).')';
	if($image_type == 'image1'){
	    	$sqll = "UPDATE `test_questions_match_items` SET ";
            $sqll .=" `image1`='' ";
            $sqll .= " WHERE `id` IN ".$tempids;
           return $this-> mDb-> query($sqll);
	}else{
	    	$sqll = "UPDATE `test_questions_match_items` SET ";
            $sqll .=" `image2`='' ";
            $sqll .= " WHERE `id` IN ".$tempids;
           return $this-> mDb-> query($sqll);
	}
}
function deleteSortQuestionsWord($ids) {

    $tempids='('.implode(',',$ids).')';
    $sqll = "DELETE FROM `test_questions_sort_words` ";
    $sqll.= " WHERE `id` IN ".$tempids;
	return  $this-> mDb-> query($sqll);
}
function deleteCompleteQuestionsWord($ids) {

    $tempids='('.implode(',',$ids).')';
    $sqll = "DELETE FROM `test_questions_complete_words` ";
    $sqll.= " WHERE `id` IN ".$tempids;
	return  $this-> mDb-> query($sqll);
}
function addQuestionAttachments($question_id,$attachment,$attachment_type,$related_to,$option_id='') {

        $stmtoatt = "INSERT INTO `test_question_attachments` SET ";
        $stmtoatt .= " `question_id` = '{$question_id}', ";
        // $stmtoatt .= $option_id?" `option_id` = '{$option_id}', ":"";
        $stmtoatt .= " `file` = '{$attachment}', ";
        $stmtoatt .= " `attachment_type` = '{$attachment_type}', ";
        $stmtoatt .= " `related_to` = '{$related_to}' ";
    return  $this -> mDb -> queryreturnlastid($stmtoatt);
}


}?>