<?php

$videoConverterObj = new videoConverter();
// require_once('/home/onlineapp/public_html/develop.testat-app.com/vendor/autoload.php');

use FFMpeg\Format\Video\X264;
use FFMpeg\FFMpeg;
class videoConverter
{

    var $mDb;
    var $mConfig;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }
    
function getVideoDetails($videoId) {
    $sql = "SELECT id, course_id, file, file_hls FROM videos_courses WHERE id = '{$videoId}'";
    return $this->mDb->getRow($sql);
}  

function updateVideoHlsData($videoId, $fileHls, $hlsTime) {
    
    // echo $videoId;
    // echo $fileHls;
    // echo $hlsTime;
    $sql = "UPDATE videos_courses 
            SET file_hls = '{$fileHls}', hls_time = '{$hlsTime}' 
            WHERE id = '{$videoId}'";
            // echo $sql;
    $this->mDb->query($sql);
}

function calculateHlsDuration($m3u8Path) {
    $totalDuration = 0;
    if (file_exists($m3u8Path)) {
        $file = fopen($m3u8Path, 'r');
        if ($file) {
            while (($line = fgets($file)) !== false) {
                $line = trim($line);
                if (str_starts_with($line, '#EXTINF:')) {
                    // Extract duration from the line
                    $duration = floatval(str_replace('#EXTINF:', '', $line));
                    $totalDuration += $duration;
    
                }
            }
            fclose($file);
        }
    }

    return $this->formatDuration($totalDuration);
}

function formatDuration($durationInSeconds) {
    $hours = floor($durationInSeconds / 3600);
    $minutes = floor(($durationInSeconds % 3600) / 60);
    $seconds = floor($durationInSeconds % 60);

    return sprintf("%02d:%02d:%02d", $hours, $minutes, $seconds);
}
function deleteHLSFiles($hlsFolder, $hlsFile) {
    if (is_dir($hlsFolder)) {
        $hlsFilePath = $hlsFolder . '/' . $hlsFile;
//   print_r($hlsFilePath);die();

        if (file_exists($hlsFilePath)) {
            unlink($hlsFilePath);
        }

        $segmentFiles = glob($hlsFolder . '/' . pathinfo($hlsFile, PATHINFO_FILENAME) . '_*.ts');
         
        foreach ($segmentFiles as $segment) {
            unlink($segment);
        }
        // die();
    }
}

    
 public function getVideosNotConverted() {
        $sql = "SELECT id, file,course_id
                    FROM videos_courses 
                    WHERE file IS NOT NULL 
                      AND file != '' 
                      AND (file_hls IS NULL OR file_hls = '') 
                      AND is_deleted = '0'";
       return $this->mDb->getAll($sql);
    }

public function getVideosWithMismatchedTime() {
        $sql = "SELECT id, file ,course_id
                FROM videos_courses 
                WHERE  file IS NOT NULL 
                      AND file != ''  AND (file_hls IS NULL OR file_hls = '') 
                AND time != hls_time AND is_deleted = '0' ";
        return  $this->mDb->getAll($sql);
    } 
    
function updateHlsTime($video_id, $duration) {
    $sql = "UPDATE videos_courses SET hls_time = '{$duration}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}    

function updateHlsFileName($video_id, $hls_name) {
    $sql = "UPDATE videos_courses SET file_hls = '{$hls_name}' WHERE id = '{$video_id}'";
    $this->mDb->query($sql);
}
function convertToHLSWithLibrary($inputFile, $hlsFolder) {
    try {
        //  echo"nadde";
        // print_r($inputFile);die();
        $ffmpeg = FFMpeg::create([
            // 'ffmpeg.binaries'  => '/usr/bin/ffmpeg',
            // 'ffprobe.binaries' => '/usr/bin/ffprobe',
            'timeout'         => 3600,
            'ffmpeg.threads'  => 2,
            'temporary_directory' => '/tmp'
        ]);

        if (!empty($hlsFolder) && !is_dir($hlsFolder)) {
            mkdir($hlsFolder, 0777, true);
        }

        // Validate video using FFprobe
        $ffprobe = $ffmpeg->getFFProbe();
       
        $videoStream = $ffprobe
            ->streams($inputFile)
            ->videos()
            ->first();

        if (!$videoStream) {
            throw new Exception("No video stream found");
        }

        $basename = basename($inputFile, '.' . pathinfo($inputFile, PATHINFO_EXTENSION));
        $hlsPath = $hlsFolder . "/" . $basename . '.m3u8';
        $segmentPattern = $hlsFolder . "/" . $basename . "_%03d.ts";

        // Open and process video
        $video = $ffmpeg->open($inputFile);

        // Configure format
        $format = new X264('aac', 'libx264');
        
        // Set video conversion parameters
        $format->setAudioCodec('aac')
               ->setVideoCodec('libx264')
               ->setKiloBitrate(2000) // 2 Mbps
               ->setAudioChannels(2)
               ->setAudioKiloBitrate(128); // 128 kbps audio

        // Set additional parameters for HLS
        $format->setAdditionalParameters([
            '-hls_time', '10',
            '-hls_list_size', '0',
            '-hls_segment_filename', $segmentPattern,
            '-preset', 'ultrafast',
            '-profile:v', 'baseline',
            '-level', '3.0',
            '-f', 'hls',
            '-hls_playlist_type', 'vod',
            '-max_muxing_queue_size', '2048',
            '-movflags', '+faststart'
        ]);

        // Add video filters
        $video->filters()
             ->resize(new \FFMpeg\Coordinate\Dimension(1280, 720))
             ->synchronize();

        // Add progress monitoring
        $format->on('progress', function($video, $format, $percentage) {
            error_log("Conversion progress: $percentage%");
        });

        // Save the video
        $video->save($format, $hlsPath);

        // Verify the conversion
        if (!file_exists($hlsPath)) {
            throw new Exception("HLS conversion failed - output file not created");
        }

        return $hlsPath;

    } catch (Exception $e) {
        echo('FFmpeg HLS conversion error: ' . $e->getMessage());
        
        // Cleanup any partial files
        // if (isset($basename) && isset($hlsFolder)) {
        //     $files = glob("$hlsFolder/$basename*.*");
        //     foreach ($files as $file) {
        //         if (file_exists($file)) {
        //             unlink($file);
        //         }
        //     }
        // }
        
        return false;
    }
}


function convertVideo($inputFile, $hlsFolder) {
    try {
      

        if (!file_exists($inputFile)) {
            throw new Exception("Input file does not exist");
        }

        // Check disk space
        $fileSize = filesize($inputFile);
        $diskSpace = disk_free_space($hlsFolder);
    //   print_r($diskSpace);die();
        if ($diskSpace < ($fileSize * 3)) {
            throw new Exception("Insufficient disk space");
        }

        // Perform conversion
        $result = $this->convertToHLSWithLibrary($inputFile, $hlsFolder);
        
        if (!$result) {
            throw new Exception("Conversion failed");
        }
        
        return $result;
        
    } catch (Exception $e) {
        error_log('Conversion failed: ' . $e->getMessage());
        return false;
    }
}


function getVideoDuration($videoPath) {
    $ffmpeg = FFMpeg::create();
    $video = $ffmpeg->open($videoPath);

    $durationInSeconds = $video->getFormat()->get('duration');

    $hours = floor($durationInSeconds / 3600);
    $minutes = floor(($durationInSeconds % 3600) / 60);
    $seconds = floor($durationInSeconds % 60);

    $formattedDuration = sprintf("%02d:%02d:%02d", $hours, $minutes, $seconds);

    return $formattedDuration; 
} 
    
    
    
    
    
    
    
    
    
}