<?php

$videoObj = new Videos();

class Videos
{
    var $mDb;
    var $mConfig;
    var $lang;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
    }

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }

    function getSomeVideoComments($aStart, $aLimit, $sort, $type, $searchTitle, $searchCourseName, $searchVideoName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT p.id, p.status, p.date_added, p.comment, u.full_name AS 'user_full_name',vc.title video_title  FROM `videos_comments` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.id > 0 ";
        $sql .= $searchTitle ? ' AND p.comment like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchVideoName ? ' AND vc.title like "%' . $searchVideoName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester!='both' && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND p.status = "' . $searchStatus . '"' : '';
        $sql .= $sort === 'comment' ? " ORDER BY p.{$sort} {$type}" : " ORDER BY p.`id` DESC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getSearchVideoCommentsCount($sort, $type, $searchTitle, $searchCourseName, $searchVideoName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT COUNT(p.`id`) as 'result_count' FROM `videos_comments` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.`id` > 0  ";
        $sql .= $searchTitle ? ' AND p.`comment` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchVideoName ? ' AND vc.title like "%' . $searchVideoName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester!='both' && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND p.status = "' . $searchStatus . '"' : '';
        $sql .= " ORDER BY p.{$sort} {$type}";
        // 	echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function getVideoCommentsCount($searchTitle, $searchCourseName, $searchVideoName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject, $searchStatus)
    {
        $sql = "SELECT COUNT(p.`id`) as 'count' FROM `videos_comments` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_id ";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.`id` > 0  ";
        $sql .= $searchTitle ? ' AND p.`comment` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchVideoName ? ' AND vc.title like "%' . $searchVideoName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester!='both' && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= $searchStatus != '' ? ' AND p.status = "' . $searchStatus . '"' : '';
        // echo $sql;
        return $this->mDb->getOne($sql);
    }

    function getOneVideoComments($id)
    {
        $result = array();
        $sql = "SELECT * FROM `videos_comments`";
        $sql .= " WHERE `id` = '{$id}'";
        return $this->mDb->getRow($sql);
    }

    function activateCommentsInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "UPDATE `videos_comments` SET ";
        $sql .= " `status`='0' ";
        $sql .= " WHERE `id` IN " . $tempids;

        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }


    function updateCommentById($temp)
    {
        $sql = "UPDATE `videos_comments` SET ";
        $sql .= " `status`='{$temp['status']}' ,";
        $sql .= " `comment`='{$temp['comment']}' ";
        $sql .= " WHERE `id`='{$temp['id']}' ";
        // echo $sql;
        return $this->mDb->query($sql);
    }

    function deleteCommentsInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "DELETE FROM `videos_comments`";
        $sql .= " WHERE `id` IN " . $tempids;
        // echo $sql;
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    /*videos_inquiries*/
    function getSomeVideoInquiries($aStart, $aLimit, $sort, $type, $searchTitle, $searchCourseName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject)
    {
        $sql = "SELECT p.video_id,vc.title,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`= `p`.`video_id`) unRead ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.id > 0 ";
        $sql .= $searchTitle ? ' AND vc.title like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= " GROUP BY `p`.`video_id`";
        $sql .= $sort === 'title' ? " ORDER BY vc.{$sort} {$type} " : " ORDER BY unRead DESC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getSearchVideoInquiriesCount($sort, $type, $searchTitle, $searchCourseName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject)
    {
        $sql = "SELECT DISTINCT (p.`id`) as 'result_count' FROM `videos_inquiries` p";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.`id` > 0  ";
        $sql .= $searchTitle ? ' AND vc.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= " GROUP BY `p`.`video_id`";
        $sql .= $sort === 'title' ? " ORDER BY vc.{$sort} {$type}" : " ORDER BY p.`id` DESC";
        //echo $sql;
        $res = $this->mDb->getAll($sql);
        return $res ? count($res) : 0;
    }

    function getVideoInquiriesCount($searchTitle, $searchCourseName, $searchCountry, $searchStage, $searchGrade, $searchSemester, $searchSubject)
    {
        $sql = "SELECT DISTINCT(p.`id`) as 'count' FROM `videos_inquiries` p";
        $sql .= " LEFT JOIN `videos_courses` vc ON vc.id = p.video_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON (cl.course_id = vc.course_id AND cl.lang_code='{$this->lang}')";
        $sql .= " LEFT JOIN `courses` c ON  c.id = vc.course_id ";
        $sql .= " WHERE p.`id` > 0  ";
        $sql .= $searchTitle ? ' AND vc.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchCourseName ? ' AND cl.name like "%' . $searchCourseName . '%"' : '';
        $sql .= $searchCountry ? ' AND c.country_id ="' . $searchCountry . '"' : '';
        $sql .= $searchStage ? ' AND c.stage_id ="' . $searchStage . '"' : '';
        $sql .= $searchGrade ? ' AND c.grade_id = "' . $searchGrade . '"' : '';
        $sql .= $searchSemester && $searchGrade ? ' AND c.semester="' . $searchSemester . '"' : '';
        $sql .= $searchSubject ? ' AND c.subject_id = "' . $searchSubject . '"' : '';
        $sql .= " GROUP BY `p`.`video_id`";
        //   echo $sql;
        $res = $this->mDb->getAll($sql);
        return $res ? count($res) : 0;
    }

    function getOneVideoInquiries($id)
    {
        $result = array();
        $sql = "SELECT * FROM `videos_inquiries`";
        $sql .= " WHERE `id` = '{$id}'";
        return $this->mDb->getRow($sql);
    }

    function updateInquiriesById($temp)
    {
        $sql = "UPDATE `videos_inquiries` SET ";
        $sql .= " `status`='{$temp['status']}' ,";
        $sql .= " `comment`='{$temp['comment']}' ";
        $sql .= " WHERE `id`='{$temp['id']}' ";
        // echo $sql;
        return $this->mDb->query($sql);
    }
    
    function getVideoInfoById($temp)
    {
        $sql = "SELECT * FROM `videos_courses`";
        $sql.= " WHERE `id` = '{$temp['video_id']}'";
    //   echo $sql;
        return $this->mDb->getRow($sql); 
    }

    function deleteInquiriesInVideo($ids)
    {
        $tempids = '(' . implode(',', $ids) . ')';
        $sql = "DELETE FROM `videos_inquiries`";
        $sql .= " WHERE `id` IN " . $tempids;
        // echo $sql;
        if ($this->mDb->query($sql)) {
            return true;
        } else {
            return false;
        }
    }

    function getAllInquiriesInVideo($data)
    {
        $sql = "SELECT p.video_id,u.full_name AS 'user_full_name',p.user_from, max(p.`date_added`) date_added,max(p.`content`) content,";
        $sql .= "(SELECT count(vi.id) FROM `videos_inquiries` vi WHERE vi.`user_to` ='0' AND vi.`read_to`='0' AND  `vi`.`video_id`='{$data['video_id']}' AND `vi`.`user_from` = `p`.`user_from`) unRead ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " RIGHT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}'";
        $sql .= " GROUP BY `p`.`user_from` ";
        $sql .= " ORDER BY unRead DESC";
        // echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getAllInquiriesInVideoChat($data)
    {
        $sql = "SELECT p.id,p.video_id,u.full_name AS 'user_full_name',p.user_from,p.user_to,p.date_added,p.content, u.user_level";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}' AND (`p`.`user_from`='{$data['user_from']}' ||  `p`.`user_to`='{$data['user_from']}')";
        $sql .= " ORDER BY date_added ASC";
        //echo $sql;
        return $this->mDb->getAll($sql);
    }

    function readInquiriesInVideoChat($data)
    {
        $sql = "UPDATE `videos_inquiries` SET ";
        $sql .= " `read_to`='1' ";
        $sql .= " WHERE video_id='{$data['video_id']}' AND `user_from`='{$data['user_from']}' AND `user_to`='{$data['user_to']}' ";
        // echo $sql;
        return $this->mDb->query($sql);
    }

    function addInquiriesToVideoById($items)
    {
        $sql = "INSERT INTO `videos_inquiries` SET ";
        $sql .= "`video_id`='{$items['id']}',`user_to`='{$items['user_id']}',";
        $sql .= " `user_from`='{$items['user_from']}',`read_from`='{$items['read_from']}',`content`='{$items['content']}'";
        //   echo $sql;
        return $this->mDb->queryReturnLastId($sql);
    }

    function getInquirieVedioById($id)
    {
        $sql = "SELECT * FROM `videos_inquiries` ";
        $sql .= " WHERE `id` = '{$id}'";
        // echo $sql;
        return $this->mDb->getRow($sql);

    }
     function getMaxContentInquirieVedioById($data)
    {
        $sql = "SELECT max(p.`content`) content ";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['id']}' AND p.user_from='{$data['user_id']}'";
        $sql .= " GROUP BY `p`.`user_from` ";
    //   echo $sql;
        return $this->mDb->getOne($sql);

    }
}