<?php

///////////////////////////////////////////////////////////////////////////////
/**
 * Filename: upload-class.php
 * Purpose: Upload FIles
 * Author: TRAIDNT
 * Developer : Ahmed Elsayed
 * Date: 10/11/2009
 */
///////////////////////////////////////////////////////////////////////////////
// $upload = new Upload();

class Upload {

    /**
     * array content allow ext list
     * @protected   array
     */
    protected $_allowext;

    /**
     *  to print logo to images if TRUE
     * @protected   bool
     */
    protected $_logoimages;

    /**
     * create thmubs images if true
     * @protected   bool
     */
    protected $_thumbsimages;

    /**
     * thumbs images width
     * @protected   int
     */
    protected $_th_width;

    /**
     * thumbs images hight
     * @protected   int
     */
    protected $_th_hight;

    /**
     * filename prefix
     * @protected   str
     */
    protected $_nameprefix;

    /**
     * max upload file
     * @protected   int
     */
    protected $_maxsize;

    /**
     * list error's
     * @protected   array
     */
    protected $_error;

    /**
     * list disallow mime type
     * @protected   array
     */
    protected $_disallow_mime = array("text/html",
        "text/plain",
        "magnus-internal/shellcgi",
        "application/x-php",
        "text/php",
        "application/x-httpd-php",
        "application/php",
        "magnus-internal/shellcgi",
        "text/x-perl",
        "application/x-perl",
        "application/x-exe",
        "application/exe",
        "application/x-java",
        "application/java-byte-code",
        "application/x-java-class",
        "application/x-java-vm",
        "application/x-java-bean",
        "application/x-jinit-bean",
        "application/x-jinit-applet",
        "magnus-internal/shellcgi",
        "image/svg",
        "image/svg-xml",
        "image/svg+xml",
        "text/xml-svg",
        "image/vnd.adobe.svg+xml",
        "image/svg-xml",
        "text/xml",
    );

    /**
     * file array info include (name,path,type,ext,etc)
     * @protected   array
     */
    protected $_fileinfo;

    protected $_thumbsConfig = array();

    /**
     * site logo path using for print logo
     * @protected   str
     */
    protected $_logopath;

    /**
     * uploading folder
     * @private str
     */
    private $_uploadfolder;

    /**
     * Constructor
     * @param   array   list allow ext
     * @param   BOLL    TRUE to print logo OR FALSE to cancel print
     * @param   int     images thumbs width
     * @param   int     images thumbs hight
     * @param   int     max size to upload
     * @param   str     uploading folder #note : Just add slash / at the end of folder name
     * @param   str     site logo path
     * @param   array   list disallow mime typeprotection
     * @param   str     filename prefix
     * @return  void
     */
    public function __construct($allowext, $thumbsConfig, $maxsize, $uploadfolder, $thumbsimages) {
        $this->_allowext = $allowext;
        $this->_thumbsConfig = $thumbsConfig;
        $this->_maxsize = $maxsize;
        $this->_error = array();
        $this->_fileinfo = array();
        $this->_uploadfolder = $uploadfolder;
//        $this->_logopath = $_SERVER['DOCUMENT_ROOT'] . "/" ."link/api/uploads/logo.png";
        $this->_thumbsimages = $thumbsimages;
    }

    // public static function thumbsUpload($allowext, $thumbsConfig, $maxsize, $uploadfolder, $thumbsimages) {
    //     $instance = new self();
    //     $instance->_allowext = $allowext;
    //     $instance->_thumbsConfig = $thumbsConfig;
    //     $instance->_maxsize = $maxsize;
    //     $instance->_error = array();
    //     $instance->_fileinfo = array();
    //     $instance->_uploadfolder = $uploadfolder;
    //     $instance->_thumbsimages = $thumbsimages;
    //     return $instance;
    // }

    /**
     * Upload File
     * @param   array   file info array #note : this array content data from $_FILES array
     *                  just have this key [type,name,size,tmp]
     * @param   int     max size
     * @return  full file info array in success OR FALSE in failure
     */
  public function Upload_File($filearray, $maxsize = NULL)
{
    global $Lang;
    // Check the right data
    if (!is_array($filearray) || !isset($filearray["type"], $filearray["name"], $filearray["tmp"], $filearray["size"])) {
        return FALSE;
    }

    // Get file extension
    $filearray["ext"] = $this->GetExt($filearray["name"]);
    $filearray["uniqname"] = $this->uniqname();
    $filearray["newname"] = $this->_nameprefix . basename(str_replace(" ", "_", $filearray["name"]), "." . $filearray["ext"]) . '(' . $filearray["uniqname"] . ').' . $filearray["ext"];
    $filearray["place"] =  $this->_uploadfolder . "/";
    $filearray["nplace"] =  $this->_uploadfolder . "/" . $filearray["newname"];

    $filearray["keywords"] = $this->GetFileKeywords($filearray["name"]);

    // Check if this file is an image
    if ($this->is_img($filearray["ext"]) && $this->_thumbsimages) {
        $filearray["thplace"] =  $this->_uploadfolder . "/thumbs/" . $filearray["newname"];
    }

    $this->_fileinfo = $filearray;

    
    if (!$this->protection($this->_fileinfo['type'], $this->_fileinfo["name"], $filearray["tmp"])) {
        $isProtected = $this->protection($this->_fileinfo['type'], $this->_fileinfo["name"], $filearray["tmp"]);
        $this->return_error($Lang['L_errorNotAllowFile']);
        return FALSE;
    }

    if (!$this->CheckSize($this->_fileinfo["size"], $maxsize)) {
        die();
        $this->return_error($Lang['L_errorSizeFile'] . $maxsize . ' كيلو بايت');
        return FALSE;
    }

    // Move uploaded file to the upload folder
    if ($this->hasErrors()) {
        return FALSE;
    }
    try {
        $up = $this->move_uploaded($this->_fileinfo["tmp"], $this->_fileinfo["place"], $this->_fileinfo["newname"]);
// echo "up===";  print_r($up) ;die();
    } catch (PDOException $e) {
        echo "Error: " . $e->getMessage();die();
        return FALSE;
    }

// echo $up; die();
    if ($up) {
        // Handle image thumbnails
        if ($this->_thumbsimages) {
            $thumbs = $this->createthumb($this->_fileinfo["place"] . $this->_fileinfo["newname"], $this->_fileinfo["ext"], $this->_fileinfo["thplace"], $this->_th_width, $this->_th_hight);
            if (!$thumbs) {
                @unlink($this->_fileinfo["place"] . $this->_fileinfo["newname"]);
                @unlink($this->_fileinfo["thplace"]);
                $this->return_error($Lang['L_errorThumb']);
                return FALSE;
            }
        }

        // Print logo if allowed
        if ($this->_logoimages && is_file($this->_logopath)) {
            $this->printlogo($this->_fileinfo["place"] . $this->_fileinfo["newname"], $this->_fileinfo["ext"], $this->_logopath);
        }

        return $this->_fileinfo;
    } else {
        $this->return_error($Lang['L_error_upload']);
        return FALSE;
    }
}


    /**
     * GET file ext
     * @param   str     file name
     * @return  file ext in success Or False in failure
     */
    public function GetExt($filename) {

        // if file name is not null
        if (!is_null($filename)) {

            // make the file name lower case and crop the ext
            $fileext = strtolower(strrchr(strtolower($filename), '.'));
            // replace the dot (.) with blank
            $fileext = str_replace(".", "", $fileext);
            // return the file ext
            return($fileext);
        } else {
            // return false if file name is null
            return(FALSE);
        }
    }

    /**
     * check if file ext allow in allow ext array or not
     * @param   str     file name
     * @return  BOLL    TRUE if allowed Or FALSE
     */
    public function CheckExt($ext) {

        // check if ext is nul Or allow ext array is not array
        if (!is_null($ext) OR !is_array($this->_allowext)) {
            // check if ext in array of allow ext
            if (in_array($ext, $this->_allowext)) {
                // return true it's mean it is allow ext
                return(TRUE);
            } else {
                // return false it's mean it is disallow ext
                return(FALSE);
            }
        } else {
            // return false if ext param is null or allowext it not array
            return(FALSE);
        }
    }

    /**
     * check if file size large than max upload size or not
     * @param   int     file size
     * @param   int     max file size
     * @return  BOLL    TRUE Or FALSE
     */
    public function CheckSize($filesieze, $maxsize) {

        // if file size is not null and numeric
        if (is_numeric($filesieze) OR !is_null($filesieze) OR !is_null($this->_maxsize)) {
            if (is_null($maxsize)) {
                $max = $this->_maxsize;
            } else {
                $max = $maxsize;
            }

            //check if file size large than the max upload size
            if (round($filesieze) < $max) {
                return(TRUE);
            } else {
                return(FALSE);
            }
        } else {
            // if file size is  null and  not numeric
            return(FALSE);
        }
    }

    /**
     * generate new key
     * @param   void
     * @return  str     key
     */
    public function uniqname() {
        return(substr(md5(uniqid(rand())), 0, 10));
    }

    /**
     * chech file type
     * @param   str     file ext
     * @return  boll    TRUE mean is img
     */
    public function is_img($ext) {
        // list of  images ext
        $picarray = array("jpg", "gif", "png", "jpeg", "bmp", "jpeg");

        // if param ext is not null
        if (!is_null($ext)) {

            // if param ext in images ext array
            if (in_array($ext, $picarray)) {
                // return true to mean it's images
                return(TRUE);
            } else {
                // return false to mean it's not image
                return(FALSE);
            }
        } else {
            // if param ext is  null
            return(FALSE);
        }
    }

    /**
     * generat keywords from filename
     * @param   str     file name
     * @return  array   false mean file name is null
     */
    private function GetFileKeywords($filename) {
        if (!is_null($filename)) {
            $str = trim($filename);
            $str = preg_replace("#[&].{2,7}[;]#sim", " ", $str);
            $str = preg_replace("#[()A°^!\"A§\$%&/{(\[)\]=}?A´`,;.:\-_\#'~+*]#", " ", $str);
            $str = preg_replace("#\s+#sim", " ", $str);
            $arraw = explode(" ", $str);

            foreach ($arraw as $v) {
                $v = trim($v);
                if (strlen($v) < 3 || in_array($v, $this->_allowext))
                    continue;

                $arr[] = $v;
            }

            $final = @implode(",", $arr);

            return($final);
        }
        else {
            return(false);
        }
    }

    /**
     * get full path
     * @param   void
     * @return  str     full path
     */ 
    private function CurrentFullPath() {
        $root     = $_SERVER['DOCUMENT_ROOT']; 
        $self     = $_SERVER['PHP_SELF']; 
        $self_arr = explode('/', $self);
        $self     = '/'.$self_arr[1];
        return $root . $self;//mb_substr($self, 0, -mb_strlen(strrchr($self, "/")));
    }

    /**
     * move uploaded file
     * @param   str     file tmp
     * @param   str     new file place
     * @param   str     new file name
     * @return  boll    TRUE it's success moved
     */
    private function move_uploaded($tmp, $path, $name) {

            // echo $tmp."<br>";
            // echo $name;
            // die();
            $path = $_SERVER['DOCUMENT_ROOT'] . "/" . $path;
            // echo $path."<br>";die();
        // check if all param is not null
        if (!is_null($tmp) OR !is_null($path) OR !is_null($name)) {
            // check if  is writeable dir or not
            if (is_dir($path) AND is_writeable($path)) {

                // move file to file place
                $movefile = @move_uploaded_file($tmp, $path . $name);

                // if success move
                if ($movefile) {
                    // echo 'TRUE';die();
                    return(TRUE);
                } else {
                    echo 'if php can\'t move file';die();
                    return(FALSE);
                }
            } else {
                echo  'if uploaded dir is not   writeable';die();
                return(FALSE);
            }
        } else {
            echo 'if  param is null';die();
            return(FALSE);
        }
    }
//     private function move_uploaded($tmp, $path, $name) {
        
//         // echo "tmp : " . !is_null($tmp);
//         // echo "path : " . !is_null($path);
//         // echo "name : " . !is_null($name);
//         // echo "================";
//         // echo is_null($tmp);
//         // die();
//     // تحقق من أن جميع المعاملات ليست null
//     if (!is_null($tmp) && !is_null($path) && !is_null($name)) {
//         // تحقق من أن المجلد قابل للكتابة
//         if (is_dir($path) && is_writable($path)) {
//             // فتح الملف المؤقت للقراءة
//             $input = fopen($tmp, 'rb');
//             // echo $input;die();
//             if (!$input) {
//                 // echo 'فشل فتح الملف المؤقت';die();
//                 return FALSE; 
//             }

//             // فتح الملف في المسار النهائي للكتابة
//             $output = fopen($path . $name, 'wb');
//             if (!$output) {
//                 fclose($input);
//                 // echo 'فشل فتح الملف النهائي للكتابة';die();
//                 return FALSE; 
//             }

//             // قراءة الملف على أجزاء صغيرة وكتابتها إلى الوجهة
//             while (!feof($input)) {
//                 $buffer = fread($input, 8192); // قراءة 8 كيلو بايت في كل مرة
//                 fwrite($output, $buffer);      // كتابة البيانات إلى الملف النهائي
//             }

//             // إغلاق الملفات
//             fclose($input);
//             fclose($output);

//             // التحقق من أن الملف تم نقله بنجاح
//             if (file_exists($path . $name)) {
//                 // echo 'تم النقل بنجاح';die();
//                 return TRUE; 
//             } else {
//                 // echo 'فشل النقل';die();
//                 return FALSE; 
//             }
//         } else {

//             // echo  'إذا كان المجلد غير قابل للكتابة';die();
//             return FALSE;
//         }
//     } else {

//         // echo  'إذا كان أحد المعاملات null';die();
//         return FALSE;
//     }
// }


    /**
     * check the weather ot ext dir
     * @param   str     file ext
     * @return  boll    TRUE OR FALSE
     */
    private function ExtDir($ext) { 
        // if param ext is not null
        if (!is_null($ext)) {
            echo $this->_uploadfolder; 
            // if upload folder is not exist create it
            if (!is_dir($this->_uploadfolder)) { 
                $mkdir = @mkdir($this->_uploadfolder, 0777);
                if (!$mkdir) { echo '5';
                    // return false if php can't create upload folder
                    return(FALSE);
                }
            } else { 
                // if ext folder is not exist
                if (!is_dir($this->_uploadfolder)) {

                    // create ext folder
                    $mkdir = @mkdir($this->_uploadfolder, 0777);
                    // create the thumbs folder
                    $mkdir2 = @mkdir($this->_uploadfolder . "/thumbs", 0777);

                    // if php create folder
                    if ($mkdir AND $mkdir2) {
                        return(TRUE);
                    }
                    // if php can't create folder
                    else {
                        return(FALSE);
                    }
                } else {
                    // if ext folder is exist
                    return(TRUE);
                }
            }
        } else {
            // if param ext is null
            return(FALSE);
        }
    }

    /**
     * print site logo to images
     * @param   str     file name with full path
     * @param   str     file ext
     * @param   str     logo path
     * @return  boll    TRUE OR FALSE
     */
    public function printlogo($name, $ext, $logo) {

        if (!is_null($name) AND !is_null($ext) AND !is_null($logo) AND function_exists('gd_info')) {

            if (preg_match("/jpg|jpeg/", $ext)) {
                $src_img = imagecreatefromjpeg($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }
            if (preg_match("/png/", $ext)) {
                $src_img = imagecreatefrompng($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }

            if (preg_match("/gif/", $ext)) {
                $src_img = imagecreatefromgif($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }

            $src_logo = imagecreatefrompng($logo);

            $bwidth = imageSX($src_img);
            $bheight = imageSY($src_img);
            $lwidth = imageSX($src_logo);
            $lheight = imageSY($src_logo);


            if ($bwidth > 160 && $bheight > 130) {

                $src_x = $bwidth - ($lwidth +10);
                $src_y = $bheight - ($lheight +10);
                ImageAlphaBlending($src_img, true);
                ImageCopy($src_img, $src_logo, $src_x, $src_y, 0, 0, $lwidth, $lheight);

                if (preg_match("/jpg|jpeg/", $ext)) {
                    imagejpeg($src_img, $name);
                }
                if (preg_match("/png/", $ext)) {
                    imagepng($src_img, $name);
                }
                if (preg_match("/gif/", $ext)) {
                    imagegif($src_img, $name);
                }
            } else {
                return(FALSE);
            }
        } else {
            return(FALSE);
        }
    }

    /**
     * create images thumbs
     * @param   str     file name with full path
     * @param   str     file ext
     * @param   str     thumbs file name
     * @param   int     thumbs width
     * @param   int     thumbs haight
     * @return  boll    TRUE OR FALSE
     */
    public function createthumb($name, $ext, $filename, $new_w, $new_h) {

        if (!is_null($name) AND !is_null($ext) AND !is_null($filename) AND !is_null($new_w)
                AND !is_null($new_h) AND function_exists('gd_info')) {

            if (preg_match("/jpg|jpeg/", $ext)) {
                $src_img = @imagecreatefromjpeg($name);

                if (!$src_img) {
                    return(FALSE);
                }

            }
            if (preg_match("/png/", $ext)) {
                $src_img = imagecreatefrompng($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }
            if (preg_match("/gif/", $ext)) {
                $src_img = imagecreatefromgif($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }
            if (preg_match("image/webp", $ext)) {
                $src_img = @imagecreatefromwebp($name);

                if (!$src_img) {
                    return(FALSE);
                }
            }

            $old_x = imageSX($src_img);
            $old_y = imageSY($src_img);


            $thumb_w = $new_w;
            $thumb_h = $new_h;

            $dst_img = ImageCreateTrueColor($thumb_w, $thumb_h);
            imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $thumb_w, $thumb_h, $old_x, $old_y);

            if (preg_match("/jpg|jpeg/", $ext)) {
                imagejpeg($dst_img, $filename);
            }

            if (preg_match("/png/", $ext)) {
                imagepng($dst_img, $filename);
            }

            if (preg_match("/gif/", $ext)) {
                imagegif($dst_img, $filename);
            }
             if (preg_match("image/webp", $ext)) {
                imagejpeg($dst_img, $filename);
            }

            imagedestroy($dst_img);
            imagedestroy($src_img);

            return(TRUE);
        } else {
            return(FALSE);
        }
    }

    /**
     * get the mime type by ext
     * @param   str     file name with full path
     * @return  str     MIME type
     */
    public function Get_File_MimeType($filename, $tmp = '') {


        if (!is_null($filename)) {

            if (function_exists('finfo_open')& 1!=1) {
                $finfo = finfo_open(FILEINFO_MIME);
                $mimetype = finfo_file($finfo, $filename);
                finfo_close($finfo);
                return $mimetype;
            } else {

                $mime_types = array(
                    'txt' => 'text/plain',
                    'htm' => 'text/html',
                    'html' => 'text/html',
                    'php' => 'text/html',
                    'css' => 'text/css',
                    'js' => 'application/javascript',
                    'json' => 'application/json',
                    'xml' => 'application/xml',
                    'swf' => 'application/x-shockwave-flash',
                    'flv' => 'video/x-flv',
                    // images
                    'webp' => 'image/webp',
                    'png' => 'image/png',
                    'jpe' => 'image/jpeg',
                    'jpeg' => 'image/jpeg',
                    'jpg' => 'image/jpeg',
                    'gif' => 'image/gif',
                    'bmp' => 'image/bmp',
                    'ico' => 'image/vnd.microsoft.icon',
                    'tiff' => 'image/tiff',
                    'tif' => 'image/tiff',
                    'svg' => 'image/svg+xml',
                    'svgz' => 'image/svg+xml',
                    // archives
                    'zip' => 'application/zip',
                    'rar' => 'application/x-rar-compressed',
                    'exe' => 'application/x-msdownload',
                    'msi' => 'application/x-msdownload',
                    'cab' => 'application/vnd.ms-cab-compressed',
                    // audio/video
                    'mp3' => 'audio/mpeg',
                    'qt' => 'video/quicktime',
                    'mov' => 'video/quicktime',
                    'wmv' => 'video/x-ms-wmv',
                    'avi' => 'video/x-msvideo',
                    'wav' => 'audio/x-wav',
                    'ram' => 'audio/x-pn-realaudio',
                    '3gp' => 'video/3gpp',
                    'ra' => 'audio/vnd.rn-realaudio',
                    'ram' => 'audio/vnd.rn-realaudio',
                    'rm' => 'application/vnd.rn-realmedia',
                    'rpm' => 'audio/x-pn-realaudio-plugin',
                    // adobe
                    'pdf' => 'application/pdf',
                    'psd' => 'image/vnd.adobe.photoshop',
                    'ai' => 'application/postscript',
                    'eps' => 'application/postscript',
                    'ps' => 'application/postscript',
                    // ms office
                    'doc' => 'application/msword',
                    'rtf' => 'application/rtf',
                    'xls' => 'application/vnd.ms-excel',
                    'ppt' => 'application/vnd.ms-powerpoint',
                    // open office
                    'odt' => 'application/vnd.oasis.opendocument.text',
                    'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
                    'docx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
                );

                $ext = $this->GetExt($filename);
                if (array_key_exists($ext, $mime_types)) {

                    return $mime_types[$ext];
                } elseif (function_exists('mime_content_type')) {
                    return(mime_content_type($tmp));
                } else {
                    return 'application/octet-stream';
                }
            }
        } else {
            return(FALSE);
        }
    }

    /**
     * fix Ie MIME
     * @param   str     file mime type
     * @return  str
     */
    private function fixIeMIME($mime) {
        switch ($mime) {
            case"application/x-zip-compressed":
                return("application/zip");
                break;
            case"image/x-png":
                return("image/xpng");
                break;
            case"image/pjpeg":
                return("image/jpeg");
                break;
            case"audio/x-mpeg":
            case"audio/mp3":
            case"audio/x-mp3":
            case"audio/mpeg3":
            case"audio/x-mpeg3":
            case"audio/mpg":
            case"audio/x-mpg":
            case"audio/x-mpegaudio":
                return("audio/mpeg");
                break;
            default:
                return($mime);
                break;
        }
    }

    /**
     * chech file protection
     * @param   str     file mime
     * @param   str     file name
     * @return  boll    TRUE mean is positive file
     */
    public function protection($file_mimetype, $file_name, $tmp = '')
    {
        //fie IE mime type
        $file_mimetype = $this->fixIeMIME($file_mimetype);


        if (!is_null($file_mimetype) and !is_null($file_name)) {
            $realmime = $this->Get_File_MimeType($file_name, $tmp);


            // if (($realmime != $file_mimetype) and ($file_mimetype != 'application/octet-stream')) {
            //     return (TRUE);
            // } else {
            if (is_array($this->_disallow_mime)) {

                if (in_array($file_mimetype, $this->_disallow_mime)) {
                    return (FALSE);
                } else {
                    return (TRUE);
                }
            } else {
                return (TRUE);
            }
            // }
        } else {
            return (FALSE);
        }
    }

    /**
     * set new error
     * @param   str     error
     */
    private function return_error($message) {
        return $this->error[] = $message;
    }

    public function showErrors() {
        if ($this->hasErrors()) { 
            reset($this->error);

            return($this->error);

            $this->resetErrors();
        }
    }

    public function hasErrors() {
        if (count($this->error) > 0) {
            return true;
        } else {
            return false;
        }
    }

    private function resetErrors() {
        if ($this->hasErrors()) {
            unset($this->error);
            $this->error = array();
        }
    }

    public function __destruct() {
        $this->_allowext = NULL;
        $this->_logoimages = FALSE;
        $this->_th_width = NULL;
        $this->_th_hight = NULL;
        $this->_nameprefix = NULL;
        $this->_maxsize = NULL;
        $this->_error = NULL;
        $this->_fileinfo = NULL;
        $this->_disallow_mime = NULL;
        $this->_logopath = NULL;
        $this->_uploadfolder = NULL;
    }

}

?>