<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');



require '../vendor/autoload.php'; // تحميل مكتبة PhpSpreadsheet
require_once('init.php');

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Style\Alignment;


if ($_GET['action'] == 'exportVisitorsDataInExcelSheet') {
        // echo "TEST";die();
        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            try {

                $data = $userAdmObj->getAllVisitorData();
                // print_r($data);die();
                // إنشاء ملف Excel جديد
                $spreadsheet = new Spreadsheet();
                $sheet = $spreadsheet->getActiveSheet();
            
                // جعل الورقة من اليمين إلى اليسار (RTL)
                $sheet->setRightToLeft(true);
            
                // كتابة عناوين الأعمدة باللغة العربية
                $sheet->setCellValue('A1', 'الاسم');
                $sheet->setCellValue('B1', 'الصف');
                $sheet->setCellValue('C1', 'الموبايل');
                $sheet->setCellValue('D1', 'تاريخ الأجابة');
            
                // ضبط محاذاة العناوين إلى اليمين
                $sheet->getStyle('A1:D1')->getAlignment()->setHorizontal(Alignment::HORIZONTAL_RIGHT);
            
                // كتابة البيانات إلى الملف
                $row = 2; // نبدأ من الصف الثاني لأن الصف الأول للعناوين
                foreach ($data as $item) {
                    $sheet->setCellValue('A' . $row, $item['full_name']);
                    $sheet->setCellValue('B' . $row, $item['grade_name']);
                    $sheet->setCellValue('C' . $row, $item['mobile']);
                    $sheet->setCellValue('D' . $row, $item['date_added']);
                    $row++;
                }
            
                // تحديد رؤوس HTTP لإرسال الملف كتنزيل
                header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
                header('Content-Disposition: attachment;filename="بيانات الزوار.xlsx"');
                header('Cache-Control: max-age=0');
            
                // إنشاء كاتب الملف وتصديره
                $writer = new Xlsx($spreadsheet);
                $writer->save('php://output');
                exit;
            
            } catch (PDOException $e) {
                echo 'Database error: ' . $e->getMessage();
            }

            
        }else {
                echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
            }
}
