<?php

/* * *************************************************************************
 *
 *   PROJECT: BigWish App
 *   powerd by IT PLUS Team
 *   Copyright 2017 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

$token  = apache_request_headers()["Authorization"];
$verify = $hs256Obj->verifyJWT('sha256', $token);

if (isset($token) && isset($verify) && $verify) {

    if ($_GET['action'] == 'getSomeGroups') {


        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : '';
        $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
        $orderData = $GroupsAdminObj->getSomeGroups($start, $aItemsPerPage, $sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo,$searchTeacherId);

        $Data = $orderData ? $orderData : '';
    }

    if ($_GET['action'] == 'getSearchGroupsCount') {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : '';
        $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
        $orderSearchData = $GroupsAdminObj->getSearchGroupsCount($sort, $type, $searchId, $searchName, $searchDateFrom, $searchDateTo,$searchTeacherId);

        $Data = $orderSearchData ? $orderSearchData : '';
    }

    if ($_GET['action'] == 'getGroupsCount') {

        $orderData = $GroupsAdminObj->getGroupsCount();
        $Data      = $orderData ? $orderData : '';
    }

} else {
    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
}


if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);

    if (isset($token) && isset($verify) && $verify) {

        if ($_GET['action'] == 'getOneGroup') {

            $oneOrderData = $GroupsAdminObj->getOneGroup($Req);
            $Data        = $oneOrderData ? $oneOrderData : '';
        }

        if ($_GET['action'] == 'deleteOrder') {

            $orderData = $GroupsAdminObj->deleteOrder($Req);
            $Data     = $orderData ? $orderData : '';
        }

        if ($_GET['action'] == 'changeOrderStatus') {

            $orderData = $GroupsAdminObj->changeOrderStatus($Req);
            $Data     = $orderData ? $orderData : '';
        }


    } 
    else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

echo json_encode($Data);
