<?php

/* * *************************************************************************
 *
 *   PROJECT: testat App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With'); 

require_once('classes/plusMailer.php');
require_once('classes/upload-class.php');
require_once('../includes/config.inc.php');
require_once('classes/iplus.php'); 
require_once('classes/class.organizeCourseVideos.php');
require_once('/home/onlineapp/public_html/develop.testat-app.com/vendor/autoload.php');

use FFMpeg\FFMpeg;
use FFMpeg\Format\Video\X264;


if ($_GET['action'] == 'organizeCourseVideos') {

   
 $Data =$organizeCourseVideosObj->copyCourseFiles();
    echo json_encode($Data);
    die();
}

if (isset($_GET['action']) && $_GET['action'] == 'convertCourseVideos') {
    // Get all courses
    $courses = $organizeCourseVideosObj->getAllCourses();
    $courseIds = $organizeCourseVideosObj->extractIds($courses); 
    

    foreach ($courseIds as $courseId) {
        
        $courseFolder = $_SERVER['DOCUMENT_ROOT'] . "/uploads/organized_course_videos/$courseId";

        if (!is_dir($courseFolder)) {
            mkdir($courseFolder, 0755, true);
        }

        
        $videoFiles = glob($courseFolder . '/*.{mp4,mov,wmv,flv}', GLOB_BRACE);
        
        if (empty($videoFiles)) {
            echo "No video files found for course ID: $courseId\n";
            continue;
        }

        
        $hlsFolder = $courseFolder . '/hls';
     
        if (!is_dir($hlsFolder)) {
            mkdir($hlsFolder, 0755, true);
        }

        foreach ($videoFiles as $videoFile) {
            $fileName = basename($videoFile);
            $hlsFilePath = $hlsFolder . '/' . pathinfo($fileName, PATHINFO_FILENAME) . '.m3u8';

            if (file_exists($hlsFilePath)) {
                echo "Skipping already converted file: $videoFile\n";
                continue;
            }

            $result = convertToHLSWithLibrary($videoFile, $hlsFolder);
            if ($result === false) {
                error_log("Failed to convert: $videoFile");
                echo "Failed to convert: $videoFile\n";
            } else {
                echo "Successfully converted: $videoFile to $result\n";
                $organizeCourseVideosObj->updateHlsFile($courseId, $fileName, $result);
            }
        }
    }

    // Return final JSON response after processing all courses
    $data = ['status' => 'success', 'message' => 'Conversion completed for all courses'];
    echo json_encode($data);
    die();
}


function convertToHLSWithLibrary($inputFile, $hlsFolder) {
    try {
        $ffmpeg = FFMpeg::create(); 
        
        if (!empty($hlsFolder) && !is_dir($hlsFolder)) {
        mkdir($hlsFolder, 0777, true);
    }
        $video = $ffmpeg->open($inputFile);
        $basename = basename($inputFile, '.' . pathinfo($inputFile, PATHINFO_EXTENSION)); 
      
        $hlsPath = $hlsFolder ."/". $basename . '.m3u8';
    // print_r($video);die();

        $command = "ffmpeg -i {$inputFile} -c:v libx264 -c:a aac -f hls {$hlsPath}";
        error_log("Executing command: $command");

            // print_r($basename);die();
        $video->save(new X264('aac', 'libx264'), $hlsPath);

        return $basename . '.m3u8'; 
    } catch (Exception $e) {
      
        error_log('FFmpeg HLS conversion error: ' . $e->getMessage());
        return false; 
    }
}
