<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';
global $hs256Obj;
global $PreparationNotebookAdmObj;
// Start Functionality
$postdata = file_get_contents("php://input");

if ($_GET['action'] == 'getSomePreparationNotebook') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $pagesData = $PreparationNotebookAdmObj->getSomePreparationNotebook($start, $aItemsPerPage, $sort, $type, $searchTitle);
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}

if ($_GET['action'] == 'getSearchPreparationNotebookCount') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $pagesSearchData = $PreparationNotebookAdmObj->getSearchPreparationNotebookCount($sort, $type, $searchTitle);
        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}

if ($_GET['action'] == 'getPreparationNotebookCount') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
        $pagesData = $PreparationNotebookAdmObj->getPreparationNotebookCount();
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}

if ($_GET['action'] == 'addEditPreparationNotebook') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
     
     /* echo '<pre>';
        print_r($_REQUEST);
        echo '</pre>';
        print_r($_FILES);*/

        $temp = array();
        $allow_ext = array("jpg", "webp", "gif", "png", "jpeg", "bmp", "pdf", "doc", "docm", "docx", "dot", "dotx");
        $maxsize = 1024 * 1024 * 10; //kb
        // $uploadFolder = 'wethaq/api/uploads/banks';
        $uploadFolder = $Config['uploads_path'] . 'preparation_notebook';

        $thumbsConfig = array(
            array(
                'width' => '100',
                'hight' => '100'
            )
        );

        if (strpos($_FILES["file"]['type'], 'image') !== false) {
            $thum = true;
        } else {
            $thum = false;
        }

        $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);
        $uploadDoc = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);

        if ((isset($_FILES['file']['name']) && $_FILES['file']['name'] != '') || (isset($_FILES['doc']['name']) && $_FILES['doc']['name'] != '')) {
            //get file name
            $file['name'] = addslashes($_FILES["file"]["name"]);
            $doc['name'] = addslashes($_FILES["doc"]["name"]);
            // get file type
            $file['type'] = $_FILES["file"]['type'];
            $doc['type'] = $_FILES["doc"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["file"]['size'] / 1024;
            $doc['size'] = $_FILES["doc"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["file"]['tmp_name'];
            $doc['tmp'] = $_FILES["doc"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
            $doc['ext'] = $uploadDoc->GetExt($_FILES["doc"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);

                //if uploagetStageByParentIDding successfully
                if ($upfile) {
                    $temp['file'] = $upfile['newname'];
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
            if ($doc['name'] != '') {
                // Start Uploading File
                $updoc = $uploadDoc->Upload_File($doc, $maxsize);

                //if uploagetStageByParentIDding successfully
                if ($updoc) {
                    $temp['doc'] = $updoc['newname'];
                } else {
                    $errorDoc = true;
                    $showErrorDoc[] = $uploadDoc->showErrors();
                    $top_msgDoc['error'][] = $showErrorDoc[0][0];
                }
            }
        } else {
            $temp = null;
        }
       
        $pageData = $PreparationNotebookAdmObj->addEditPreparationNotebook($_REQUEST, $temp);
        $Data = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}


if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);


    if ($_GET['action'] == 'getOnePreparationNotebook') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $onepageData = $PreparationNotebookAdmObj->getOnePreparationNotebook($Req);
            $Data = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'deletePreparationNotebook') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $PreparationNotebookAdmObj->deletePreparationNotebook($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
}