<?php

/* * *************************************************************************
 *
 *   PROJECT: Testat App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

$token  = apache_request_headers()["Authorization"];
$verify = $hs256Obj->verifyJWT('sha256', $token);

if (isset($token) && isset($verify) && $verify) {

    if ($_GET['action'] == 'getSomePrintableData') {

        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';


        $categoryData = $PrintableDataObj->getSomePrintableData($start, $aItemsPerPage, $sort, $type, $searchName,$searchCountry,$searchStage);

        $Data = $categoryData ? $categoryData : '';
    }

    if ($_GET['action'] == 'getSearchPrintableDataCount') {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $categorySearchData = $PrintableDataObj->getSearchPrintableDataCount($sort, $type, $searchName,$searchCountry,$searchStage);

        $Data = $categorySearchData ? $categorySearchData : '';
    }

    if ($_GET['action'] == 'getPrintableDataCount') {

        $categoryData = $PrintableDataObj->getPrintableDataCount();
        $Data      = $categoryData ? $categoryData : '';
    }

    if ($_GET['action'] == 'addEditPrintableData') {

        $operation = $_REQUEST['operation'];
        $data_id = '';

        $temp = array();

       
    

        if ($operation === 'edit') {
            $data_id = $_REQUEST['printable_data_id'];
        }
// print_r($_REQUEST);
        $categoryData = $PrintableDataObj->addEditPrintableData($_REQUEST, $data_id);
        $Data = $categoryData?$categoryData:''; 
    }


    if ($_GET['action'] == 'getAllCountries') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
        $dData = $PrintableDataObj->getAllCountries($rools);
        $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
            echo json_encode($Data);
        }
    }

    if ($_GET['action'] == 'getStagesWithCountryId') {
        $country_id = $_GET['country_id'] ? $_GET['country_id'] :'';
        $dData = $PrintableDataObj->getStagesWithCountryId($country_id);
        $Data = $dData ? $dData : '';
    }
 if ($_GET['action'] == 'getGradesWithStageId') {
        $stage_id = $_GET['stage_id'] ? $_GET['stage_id'] :'';
        $dData = $PrintableDataObj->getGradesWithStageId($stage_id);
        $Data = $dData ? $dData : '';
    }

} else {
    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
}


if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);

    if (isset($token) && isset($verify) && $verify) {

        if ($_GET['action'] == 'getOnePrintableData') {

            $oneData = $PrintableDataObj->getOnePrintableData($Req);
            $Data        = $oneData ? $oneData : '';
        }


        if ($_GET['action'] == 'deletePrintableData') {

            $categoryData = $PrintableDataObj->deletePrintableData($Req);
            $Data     = $categoryData ? $categoryData : '';
        }


    } 
    else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

echo json_encode($Data);
