<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

$token  = apache_request_headers()["Authorization"];
$verify = $hs256Obj->verifyJWT('sha256', $token);

if (isset($token) && isset($verify) && $verify) {

    if ($_GET['action'] == 'getSomeSubjects') {
        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $searchSemester = $_GET['searchSemester'] ? $_GET['searchSemester'] : '';
        $searchSpecialize = $_GET['searchSpecialize'] ? $_GET['searchSpecialize'] : '';
        $langData = $subjectObj->getSomeSubjects($start, $aItemsPerPage, $sort, $type, $searchName,$searchCountry,$searchStage,$searchGrade,$searchSemester,$searchSpecialize);
        $Data = $langData ? $langData : '';
    }

    if ($_GET['action'] == 'getSearchSubjectsCount') {
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $searchSemester = $_GET['searchSemester'] ? $_GET['searchSemester'] : '';
        $searchSpecialize = $_GET['searchSpecialize'] ? $_GET['searchSpecialize'] : '';
        $langSearchData = $subjectObj->getSearchSubjectsCount($sort, $type, $searchName,$searchCountry,$searchStage,$searchGrade,$searchSemester,$searchSpecialize);
//       echo $langSearchData;die();
        $Data = $langSearchData >0 ? $langSearchData : '0';

    }

    if ($_GET['action'] == 'getAllCountries') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
            $dData = $gradesObj->getAllCountries($rools);
            $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
            echo json_encode($Data);
        }
    }

    if ($_GET['action'] == 'getStagesWithCountryId') {
        $country_id = $_GET['country_id'] ? $_GET['country_id'] : '';
        $dData = $gradesObj->getStagesWithCountryId($country_id);
        $Data = $dData ? $dData : '';
    } if ($_GET['action'] == 'getGradesWithStageID') {
        $stage_id = $_GET['stage_id'] ? $_GET['stage_id'] : '';
        $dData = $gradesObj->getGradesWithStageID($stage_id);
        $Data = $dData ? $dData : '';
    }


    if ($_GET['action'] == 'getSubjectsWithGradeID') {
        $grade_id = $_GET['grade_id'] ? $_GET['grade_id'] : '';
        $semester = $_GET['semester'] && $_GET['semester'] !='both' ? $_GET['semester'] : 'both';
        $dData = $gradesObj->getSubjectsWithGradeID($grade_id,$semester);
        $Data = $dData ? $dData : '';
    }


    if ($_GET['action'] == 'getSubjectsCount') {

        $langData = $subjectObj->getSubjectsCount();
        $Data = $langData ? $langData : '';
    }

    if ($_GET['action'] == 'getAllSubjects') {

        $langData = $subjectObj->getAllSubjects();
        $Data = $langData ? $langData : '';

    }

    if($_GET['action'] == 'deleteBranch'){
        $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

// echo (isset($token) && isset($verify) && $verify) ;die();
                if (isset($token) && isset($verify) && $verify) {
                    $langData = $subjectObj->deleteBranch($Req);
                    $Data = $langData ? $langData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }
    }
    if ($_GET['action'] == 'addEditSubject') {
        header('Content-Type: application/json; charset=utf-8');
        
        try {
            // تعيين حدود PHP لتحميل الملفات
            ini_set('memory_limit', '1G');
            ini_set('max_execution_time', 300);
            ini_set('post_max_size', '1G');
            ini_set('upload_max_filesize', '1G');

            if(isset($_REQUEST['branches'])){
                $_REQUEST['allBranches'] = json_decode($_REQUEST['branches']);
            }
       
            $_REQUEST['fields'] = json_decode($_REQUEST['fields']);
            $operation = $_REQUEST['operation'];
            $lang_id = '';
            $tempSubject = null;
            $tempBranches = [];
            
            // تكوين الرفع
            $allow_ext = ["jpg", "webp", "gif", "png", "jpeg", "bmp"];
            $maxsize = 50 * 1024 * 1024; // 50MB
            
            // تحديد مسار التحميل
            $uploadFolder =  $_SERVER['DOCUMENT_ROOT']. '/uploads/subjects/';
            // التأكد من وجود المجلد
            if (!file_exists($uploadFolder)) {
                if (!mkdir($uploadFolder, 0755, true)) {
                    throw new Exception('فشل في إنشاء مجلد التحميل: ' . $uploadFolder);
                }
            }

            if (!is_writable($uploadFolder)) {
                throw new Exception('المجلد غير قابل للكتابة: ' . $uploadFolder);
            }

            // تكوين الصور المصغرة
            $thumbsConfig = [
                'small' => ['width' => 100, 'height' => 100]
            ];
            // تهيئة فئة التحميل
            $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, true);

            // معالجة الملف الرئيسي
            if (isset($_FILES['file']) && !empty($_FILES['file']['name'])) {
                if ($_FILES['file']['error'] !== UPLOAD_ERR_OK) {
                    throw new Exception('خطأ في رفع الملف: ' . $_FILES['file']['error']);
                }

                $file = [
                    'name' => $_FILES['file']['name'],
                    'type' => $_FILES['file']['type'],
                    'size' => $_FILES['file']['size'],
                    'tmp' => $_FILES['file']['tmp_name'],
                    'error' => $_FILES['file']['error']
                ];

                // التحقق من حجم الملف
                if ($file['size'] > $maxsize) {
                    throw new Exception("حجم الملف {$file['name']} يتجاوز الحد الأقصى المسموح به (5MB)");
                }

                // التحقق من امتداد الملف
                $file['ext'] = strtolower($upload->GetExt($file['name']));
                if (!in_array($file['ext'], $allow_ext)) {
                    throw new Exception("نوع الملف {$file['name']} غير مسموح به");
                }

                // رفع الملف
                $upfile = $upload->Upload_File($file, $maxsize);
                if (!$upfile) {
                    $showError = $upload->showErrors();
                    throw new Exception($showError[0][0]);
                }

                $tempSubject = [
                    'file' => $upfile['newname'],
                    'original_name' => $file['name'],
                    'size' => $file['size'],
                    'type' => $file['type']
                ];

                // التحقق من وجود الملف بعد الرفع
                if (!file_exists($uploadFolder . $upfile['newname'])) {
                    throw new Exception('فشل في رفع الملف: ' . $file['name']);
                }
            }

            // معالجة ملفات الفروع
            if (isset($_REQUEST['allBranches']) && is_array($_REQUEST['allBranches'])) {
                foreach ($_REQUEST['allBranches'] as $branch) {
                    $fileKey = 'fileBranches' . $branch->img;
                    
                    if (isset($_FILES[$fileKey]) && !empty($_FILES[$fileKey]['name'])) {
                        if ($_FILES[$fileKey]['error'] !== UPLOAD_ERR_OK) {
                            throw new Exception('خطأ في رفع ملف الفرع: ' . $_FILES[$fileKey]['error']);
                        }

                        $file = [
                            'name' => $_FILES[$fileKey]['name'],
                            'type' => $_FILES[$fileKey]['type'],
                            'size' => $_FILES[$fileKey]['size'],
                            'tmp' => $_FILES[$fileKey]['tmp_name'],
                            'error' => $_FILES[$fileKey]['error']
                        ];

                        // التحقق من حجم الملف
                        if ($file['size'] > $maxsize) {
                            throw new Exception("حجم الملف {$file['name']} يتجاوز الحد الأقصى المسموح به (5MB)");
                        }

                        // التحقق من امتداد الملف
                        $file['ext'] = strtolower($upload->GetExt($file['name']));
                        if (!in_array($file['ext'], $allow_ext)) {
                            throw new Exception("نوع الملف {$file['name']} غير مسموح به");
                        }

                        // رفع الملف
                        $upfile = $upload->Upload_File($file, $maxsize);
                        if (!$upfile) {
                            $showError = $upload->showErrors();
                            throw new Exception($showError[0][0]);
                        }

                        $tempBranches[$branch->img] = [
                            'file' => $upfile['newname'],
                            'original_name' => $file['name'],
                            'size' => $file['size'],
                            'type' => $file['type']
                        ];

                        // التحقق من وجود الملف بعد الرفع
                        if (!file_exists($uploadFolder . $upfile['newname'])) {
                            throw new Exception('فشل في رفع ملف الفرع: ' . $file['name']);
                        }
                    } else {
                        $tempBranches[$branch->img] = [];
                    }
                }
            }

            // تحديد معرف المادة في حالة التعديل
            if ($operation === 'edit') {
                $lang_id = $_REQUEST['subject_id'];
            }

            // حفظ البيانات
            $subjectFile = isset($tempSubject['file']) ? $tempSubject['file'] : null;
            $langData = $subjectObj->addEditSubject($_REQUEST, $subjectFile, $lang_id, $tempBranches);
            
            // تحضير الاستجابة
            $Data = [
                'status' => true,
                'msg' => $operation === 'edit' ? 'تم تحديث المادة بنجاح' : 'تم إضافة المادة بنجاح',
                'data' => $langData,
                'files' => [
                    'main' => $tempSubject,
                    'branches' => $tempBranches
                ]
            ];

        } catch (Exception $e) {
            $Data = [
                'status' => false,
                'msg' => $e->getMessage()
            ];
        }
    }
    if ($_GET['action'] == 'getAllParentFieldsOfStudy') {

        $langData = $subjectObj->getAllParentFieldsOfStudy($_GET['grade_id']);
        $Data = $langData ? $langData : '';

    }
    
    if ($_GET['action'] == 'getAllChildBytFieldsOfStudyId') {

        $langData = $subjectObj->getAllChildBytFieldsOfStudyId($_GET['parent_id']);
        $Data = $langData ? $langData : '';

    }
    
    if($_GET['action'] == 'getBranchesBySubjectId'){
        
        $langData = $subjectObj->getBranchesBySubjectId($_GET['subject_id']);
        $Data = $langData ? $langData : '';
    }
    
}else {
    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
}


    if (isset($postdata) && !empty($postdata)) {

        $Req = json_decode($postdata, true);
        if (isset($token) && isset($verify) && $verify) {
            if ($_GET['action'] == 'getOneSubject') {

                $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

                if (isset($token) && isset($verify) && $verify) {

                    $onelangData = $subjectObj->getOneSubject($Req);
                    $Data = $onelangData ? $onelangData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }

            }

            if ($_GET['action'] == 'deleteSubject') {

                $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

                if (isset($token) && isset($verify) && $verify) {

                    $langData = $subjectObj->deleteSubject($Req);
                    $Data = $langData ? $langData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }

            }

        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    echo json_encode($Data);
