<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

$postdata = file_get_contents("php://input");

if ($_GET['action'] == 'getSomeTests') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    
    if (isset($token) && isset($verify) && $verify) {
        
        $_GET['user_id'] = $_GET['user_id']?:$ADMIN['id'];

        $rools = $userAdmObj->getAdminRolesControls($_GET['user_id']);
// print_r($_GET);die();
        if (($rools == 'all' || (is_array($rools) && count($rools) > 0)) && $rools != 'noRole')
         {
            $dateTime = date('Y-m-d H:i:s');
            $start = $_GET['start'] ? $_GET['start'] : 0;
            $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;
            if ($_GET['sort'] == 'title') {
                $_GET['sort'] = 'name';
            }

            $sort = $_GET['sort'] ? $_GET['sort'] : 'id';

            $type = $_GET['type'] ? $_GET['type'] : 'DESC';
            $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
            $searchQuestion = $_GET['searchQuestion'] ? $_GET['searchQuestion'] : '';
            $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
            $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
            $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';

            $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
            $searchTestSemester = $_GET['searchTestSemester'] ? $_GET['searchTestSemester'] : '';
            $searchUnit = $_GET['searchUnit'] ? $_GET['searchUnit'] : '';
            $searchLesson = $_GET['searchLesson'] ? $_GET['searchLesson'] : '';
            $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
            $searchSource = $_GET['searchSource'] ? $_GET['searchSource'] : '';
            $searchStatus = $_GET['searchStatus'] != '' ? $_GET['searchStatus'] : '';
            $searchPaid = $_GET['searchPaid'] != '' ? $_GET['searchPaid'] : '';
            $searchTestType = $_GET['searchTestType'] ? $_GET['searchTestType'] : '';
            $searchAddedBy = $_GET['searchAddedBy'] ? $_GET['searchAddedBy'] : '';
            $searchJob = $_GET['searchJob'] ? $_GET['searchJob'] : '';


            $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
            $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : $dateTime;


            $pagesData = $TestsObj->getSomeTests($start, $aItemsPerPage, $sort, $type, $searchTitle, $searchQuestion, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester, $rools, $searchUnit, $searchLesson, $searchTeacherId, $searchDateFrom, $searchDateTo, $searchSource, $searchStatus, $searchTestType, $searchAddedBy, $searchJob, $searchPaid);
            $Data = $pagesData ? $pagesData : '';
            echo json_encode($Data);
        } elseif ($rools == 'noRole') {
            $Data = ''; 
            echo json_encode($Data);
        }
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getSearchTestsCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        if ($_GET['sort'] == 'title') {
            $_GET['sort'] = 'name';
        }
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';

        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $dateTime = date('Y-m-d H:i:s');
        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $searchQuestion = $_GET['searchQuestion'] ? $_GET['searchQuestion'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';

        $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
        $searchTestSemester = $_GET['searchTestSemester'] ? $_GET['searchTestSemester'] : '';
        $searchUnit = $_GET['searchUnit'] ? $_GET['searchUnit'] : '';
        $searchLesson = $_GET['searchLesson'] ? $_GET['searchLesson'] : '';
        $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : $dateTime;
        $searchSource = $_GET['searchSource'] ? $_GET['searchSource'] : '';

        $searchStatus = $_GET['searchStatus'] != '' ? $_GET['searchStatus'] : '';
        $searchPaid = $_GET['searchPaid'] != '' ? $_GET['searchPaid'] : '';
        $searchTestType = $_GET['searchTestType'] ? $_GET['searchTestType'] : '';
        $searchAddedBy = $_GET['searchAddedBy'] ? $_GET['searchAddedBy'] : '';
        $searchJob = $_GET['searchJob'] ? $_GET['searchJob'] : '';
        $pagesSearchData = $TestsObj->getSearchTestsCount($sort, $type, $searchTitle, $searchQuestion, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester, $searchUnit, $searchLesson, $searchTeacherId, $searchDateFrom, $searchDateTo, $searchSource, $searchStatus, $searchTestType, $searchAddedBy,$searchJob, $searchPaid);

        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getTestsCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $searchQuestion = $_GET['searchQuestion'] ? $_GET['searchQuestion'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';

        $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
        $searchTestSemester = $_GET['searchTestSemester'] ? $_GET['searchTestSemester'] : '';
        $searchUnit = $_GET['searchUnit'] ? $_GET['searchUnit'] : '';
        $searchLesson = $_GET['searchLesson'] ? $_GET['searchLesson'] : '';
        $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : $dateTime;
        $searchSource = $_GET['searchSource'] ? $_GET['searchSource'] : '';

        $searchStatus = $_GET['searchStatus'] != '' ? $_GET['searchStatus'] : '';
        $searchPaid = $_GET['searchPaid'] != '' ? $_GET['searchPaid'] : '';
        $searchTestType = $_GET['searchTestType'] ? $_GET['searchTestType'] : '';
        $searchAddedBy = $_GET['searchAddedBy'] ? $_GET['searchAddedBy'] : '';
        $searchJob = $_GET['searchJob'] ? $_GET['searchJob'] : '';
        $pagesData = $TestsObj->getTestsCount($searchTitle, $searchQuestion, $searchCountry, $searchStage, $searchGrade, $searchSubject, $searchTestSemester, $searchUnit, $searchLesson, $searchTeacherId, $searchDateFrom, $searchDateTo, $searchSource, $searchStatus, $searchTestType, $searchAddedBy,$searchJob, $searchPaid);
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}


if ($_GET['action'] == 'movequestionsoptionnotetosquestion') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $pagesData = $TestsObj->movequestionsoptionnotetosquestion();
        $Data = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}



if ($_GET['action'] == 'generateTestRequestPdf' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $pageData = $TestsObj->generateTestRequestPdf($_REQUEST);
        $Data = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'addEditTest' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
        $Req = json_decode($postdata, TRUE);
        $pageData = $TestsObj->addEditTest($Req); 
        $Data = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'addEditQuestion' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    $Req = json_decode($postdata, TRUE);
    if (isset($token) && isset($verify) && $verify) {
        $pageData = $TestsObj->addEditQuestion($Req);
        $Data = $pageData ? $pageData : ''; 
        echo json_encode($pageData);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'deleteAttachment' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $pageData = $TestsObj->deleteAttachment($_REQUEST);
        $Data = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'uploadAttachment') {

    $operation = $_REQUEST['operation'];
    $lang_id = '';
    $temp = array();

    $allow_ext = array("mp3", "webp", "mp4", "mov", "wmv", "flv", "jpg", "gif", "png", "jpeg", "bmp", "pdf");
    //
//    print_r($_FILES);
//    die();

    $maxsize = 1024 * 1024 * 5; //5G    
    
    // echo $Config['uploads_path'];die();
    $uploadFolder = $_SERVER['DOCUMENT_ROOT'] . "/" . $Config['uploads_path'] . 'questions_attachments';
    // echo $uploadFolder;die();

    $thumbsConfig = array(
        array(
            'width' => '100',
            'hight' => '100'
        )
    );

    if (strpos($_FILES["file"]['type'], 'image') !== false) {
        $thum = true;
    } else {
        $thum = false;
    }


    $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);
    // echo $_FILES['file']['name'];die();
    if (isset($_FILES['file']['name']) and $_FILES['file']['name'] != '') {

        //get file name
        $file['name'] = addslashes($_FILES["file"]["name"]);
        // get file type
        $file['type'] = $_FILES["file"]['type'];
        // get filesize in KB
        $file['size'] = $_FILES["file"]['size'] / 1024;
        // get file tmp path
        $file['tmp'] = $_FILES["file"]['tmp_name'];
        //get file ext [to get max uploades size]
        $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
        //check if guest have selected file or not
        if ($file['name'] != '') {
            // Start Uploading File
            // print_r($file); die();
            $upfile = $upload->Upload_File($file, $maxsize);
            // echo "upfile : ";
            // print_r($upfile);die();
            //if uploading successfully
            if ($upfile) {

                $temp['file'] = $upfile['newname'];
                $temp['name'] = $upfile['original_name'];
                $temp['type'] = $upfile['type'];
                $temp['ext'] = $upfile['ext'];
                $temp['size'] = $upfile['size'];
            } else {
                $error = true;
                $showError[] = $upload->showErrors();
                $top_msg['error'][] = $showError[0][0];
                echo json_encode($top_msg);
                exit;
            }
        }
    } else {
        $temp = null;
    }
    //         print_r($_REQUEST); die();
    
    $temp['status'] = true;
    $temp['progress'] = 100;
    $temp['msg'] = 'تم تحميل الملف بنجاح';

    $Data = $temp ? $temp : '';
   echo json_encode($Data);
    exit;
}




if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);



    if ($_GET['action'] == 'getOneTest') {
        // echo 'test';die();
        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            $onepageData = $TestsObj->getOneTest($Req);
            $Data = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    if ($_GET['action'] == 'getTestDetailsInfo') {
        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            $onepageData = $TestsObj->getTestDetailsInfo($Req);
            $Data = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    if ($_GET['action'] == 'deleteTest') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteTest($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'getQuestionsWithTestID') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->getQuestionsWithTestID($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'deleteQuestion') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteQuestion($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteSupQuestionByParent') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteSupQuestionByParent($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteQuestionOption') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteQuestionOption($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteMatchQuestionsItem') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteMatchQuestionsItem($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'removeMatchQuestionsImage') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $image_type = $_GET['image_type'] ? $_GET['image_type'] : '';
            $pageData = $TestsObj->removeMatchQuestionsImage($Req, $image_type);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'deleteSortQuestionsWord') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteSortQuestionsWord($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'deleteCompleteQuestionsWord') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsObj->deleteCompleteQuestionsWord($Req);
            $Data = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }




}