<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

if ($_GET['action'] == 'getSomeTests') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);

        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
              $dateTime = date('Y-m-d H:i:s');
            $start         = $_GET['start'] ? $_GET['start'] : 0;
            $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;
            $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
            $type = $_GET['type'] ? $_GET['type'] : 'DESC';
            $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
            $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
            $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
            $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';

            $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
            $searchUnit = $_GET['searchUnit'] ? $_GET['searchUnit'] : '';
            $searchLesson = $_GET['searchLesson'] ? $_GET['searchLesson'] : '';
            $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
             $searchSource = $_GET['searchSource'] ? $_GET['searchSource'] : '';
            $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
            $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] :   $dateTime ;

            $pagesData = $TestsPrintableObj->getSomeTests($start, $aItemsPerPage, $sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$rools,$searchUnit,$searchLesson,$searchTeacherId,$searchDateFrom, $searchDateTo,$searchSource);
            $Data = $pagesData ? $pagesData : '';
            echo json_encode($Data);
        }
        elseif($rools == 'noRole'){
            $Data = '';
            echo json_encode($Data);
        }
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getSearchTestsCount') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
$dateTime = date('Y-m-d H:i:s');
        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';

        $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
        $searchUnit = $_GET['searchUnit'] ? $_GET['searchUnit'] : '';
        $searchLesson = $_GET['searchLesson'] ? $_GET['searchLesson'] : '';
        $searchTeacherId = $_GET['searchTeacherId'] ? $_GET['searchTeacherId'] : '';
          $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] :   $dateTime ;
         $searchSource = $_GET['searchSource'] ? $_GET['searchSource'] : '';
        $pagesSearchData = $TestsPrintableObj->getSearchTestsCount($sort, $type, $searchTitle,$searchCountry,$searchStage,$searchGrade,$searchSubject,$searchUnit,$searchLesson,$searchTeacherId,$searchDateFrom, $searchDateTo,$searchSource);

        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getTestsCount') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $pagesData = $TestsPrintableObj->getTestsCount();
        $Data      = $pagesData ? $pagesData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'generateTestRequestPdf'&& $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $pageData = $TestsPrintableObj->generateTestRequestPdf($_REQUEST);
        $Data     = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'addEditTest' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        
        
        $temp = array();
        $allow_ext = array("jpg","webp", "gif", "png", "jpeg", "bmp","pptx","ppt","pdf","doc","docx");
        $maxsize = 1024 * 1024 * 5; //kb
        // $uploadFolder = 'wethaq/api/uploads/banks';
        $uploadFolder = $Config['uploads_path'] . 'tests_printable';

         $thumbsConfig = array(
        array(
            'width' => '100',
            'hight' => '100'
        )
    );
    
    if(strpos($_FILES["file"]['type'], 'image') !== false){
        $thum = true;
    } else{
        $thum = false;
    }

        $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);

        if (isset($_FILES['file']['name']) AND $_FILES['file']['name'] != '') {

            //get file name
            $file['name'] = addslashes($_FILES["file"]["name"]);
            // get file type
            $file['type'] = $_FILES["file"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["file"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["file"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);

                //if uploagetStageByParentIDding successfully
                if ($upfile) {
                    $temp['file'] = $upfile['newname'];
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
        }
        else
        {
         $temp['file'] = null;
        }

         $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);

        if (isset($_FILES['answer']['name']) AND $_FILES['answer']['name'] != '') {

            //get file name
            $file['name'] = addslashes($_FILES["answer"]["name"]);
            // get file type
            $file['type'] = $_FILES["answer"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["answer"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["answer"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["answer"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);

                //if uploagetStageByParentIDding successfully
                if ($upfile) {
                    $temp['answer'] = $upfile['newname'];
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
        }
        else
        {
            $temp['answer'] = null;
        }

        
        $pageData = $TestsPrintableObj->addEditTest($_REQUEST,$temp['file'], $temp['answer']);
        $Data     = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}if ($_GET['action'] == 'addEditQuestion' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        
        
        
        $pageData = $TestsPrintableObj->addEditQuestion($_REQUEST);
        $Data     = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'deleteAttachment' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $token  = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $pageData = $TestsPrintableObj->deleteAttachment($_REQUEST);
        $Data     = $pageData ? $pageData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'uploadAttachment') {

    $operation = $_REQUEST['operation'];
    $lang_id = '';
    $temp = array();

    $allow_ext = array("mp3","mp4","mov","wmv","flv","jpg", "gif", "png", "jpeg", "bmp");
//
//    print_r($_FILES);
//    die();

    $maxsize = 1024 * 500; //kb
    // $uploadFolder = '_wethaq/api/uploads/languages';
    $uploadFolder = $Config['uploads_path'] . 'questions_attachments';

    $thumbsConfig = array(
        array(
            'name' => 'medium',
            'width' => '240',
            'hight' => '250'
        ),
        array(
            'name' => 'small',
            'width' => '80',
            'hight' => '80'
        ),
    );

    $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);

    if (isset($_FILES['file']['name']) AND $_FILES['file']['name'] != '') {

        //get file name
        $file['name'] = addslashes($_FILES["file"]["name"]);
        // get file type
        $file['type'] = $_FILES["file"]['type'];
        // get filesize in KB
        $file['size'] = $_FILES["file"]['size'] / 1024;
        // get file tmp path
        $file['tmp'] = $_FILES["file"]['tmp_name'];
        //get file ext [to get max uploades size]
        $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
        //check if guest have selected file or not
        if ($file['name'] != '') {
            // Start Uploading File
            $upfile = $upload->Upload_File($file, $maxsize);

            //if uploading successfully
            if ($upfile) {

                $temp['file'] = $upfile['newname'];
                $temp['name'] = $upfile['name'];
                $temp['type'] = $upfile['type'];
                $temp['ext'] = $upfile['ext'];
                $temp['size'] = $upfile['size'];
            } else {
                $error = true;
                $showError[] = $upload->showErrors();
                $top_msg['error'][] = $showError[0][0];
            }
        }
    } else {
        $temp = null;
    }
//         print_r($_REQUEST); die();

    $Data = $temp['file'] ? $temp : '';
    echo json_encode($Data);
}




if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);



    if ($_GET['action'] == 'getOneTest') {
        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            $onepageData = $TestsPrintableObj->getOneTest($Req);
            $Data        = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    if ($_GET['action'] == 'getTestDetailsInfo') {
        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            $onepageData = $TestsPrintableObj->getTestDetailsInfo($Req);
            $Data        = $onepageData ? $onepageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    if ($_GET['action'] == 'deleteTest') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteTest($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    
    
    if ($_GET['action'] == 'getQuestionsWithTestID') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->getQuestionsWithTestID($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    
    if ($_GET['action'] == 'deleteQuestion') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteQuestion($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteSupQuestionByParent') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteSupQuestionByParent($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    } if ($_GET['action'] == 'deleteQuestionOption') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteQuestionOption($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    } if ($_GET['action'] == 'deleteMatchQuestionsItem') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteMatchQuestionsItem($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }if ($_GET['action'] == 'deleteSortQuestionsWord') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteSortQuestionsWord($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


if ($_GET['action'] == 'deleteCompleteQuestionsWord') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $pageData = $TestsPrintableObj->deleteCompleteQuestionsWord($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

}

if ($_GET['action'] == 'toggleActivationTests') {

        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            
            if($Req['status'] == 'activate'){
                $Req['status'] = '1';
            }elseif($Req['status'] == 'unactivate'){
                $Req['status'] = '0';
            }
            
            $pageData = $TestsPrintableObj->toggleActivationTests($Req);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }