<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

//searchCountry,searchStage,searchGrade,searchSemester
$token  = apache_request_headers()["Authorization"];
$verify = $hs256Obj->verifyJWT('sha256', $token);

if (isset($token) && isset($verify) && $verify) {

    if ($_GET['action'] == 'getSomeUnits') {
        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchMode = $_GET['searchMode'] ? $_GET['searchMode'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $searchSemester = $_GET['searchSemester'] ? $_GET['searchSemester'] : '';
        $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
        $langData = $unitsObj->getSomeUnits($start, $aItemsPerPage, $sort, $type, $searchName,$searchMode,$searchCountry,$searchStage,$searchGrade,$searchSemester,$searchSubject);
        $Data = $langData ? $langData : '';
    }

    if ($_GET['action'] == 'getSearchUnitsCount') {
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchMode = $_GET['searchMode'] ? $_GET['searchMode'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $searchSemester = $_GET['searchSemester'] ? $_GET['searchSemester'] : '';
        $searchSubject = $_GET['searchSubject'] ? $_GET['searchSubject'] : '';
        $langSearchData = $unitsObj->getSearchUnitsCount($sort, $type, $searchName,$searchMode,$searchCountry,$searchStage,$searchGrade,$searchSemester,$searchSubject);
//       echo $langSearchData;die();
        $Data = $langSearchData >0 ? $langSearchData : '0';

    }

    if ($_GET['action'] == 'getAllCountries') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        // echo $rools;die();
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole'){
            $dData = $gradesObj->getAllCountries($rools);
            $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
        }
    }

    if ($_GET['action'] == 'getStagesWithCountryId') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
        $country_id = $_GET['country_id'] ? $_GET['country_id'] : '';
        $dData = $gradesObj->getStagesWithCountryId($country_id,$rools);
        $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
        }
    } 
    if ($_GET['action'] == 'getGradesWithStageID') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
        $stage_id = $_GET['stage_id'] ? $_GET['stage_id'] : '';
        $dData = $gradesObj->getGradesWithStageID($stage_id,$rools);
        $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
        }
    }



    if ($_GET['action'] == 'getSubjectsWithGradeID') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
        $grade_id = $_GET['grade_id'] ? $_GET['grade_id'] : '';
        $semester = $_GET['semester'] && $_GET['semester'] !='both' ? $_GET['semester'] : '';
        $specialize_id = $_GET['specialize_id'] ? $_GET['specialize_id'] : '';
        $dData = $gradesObj->getSubjectsWithGradeID($grade_id,$semester,$specialize_id,$rools);
        $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
        }
    }
    
    if ($_GET['action'] == 'getSubjectsWithGradeIDForCosts') {
        $rools=$userAdmObj->getAdminRolesControls($_GET['user_id']);
        if(($rools == 'all' || count($rools) > 0) && $rools != 'noRole' ){
        $grade_id = $_GET['grade_id'] ? $_GET['grade_id'] : '';
        $semester = $_GET['semester'] && $_GET['semester'] !='both' ? $_GET['semester'] : '';
        $specialize_id = $_GET['specialize_id'] ? $_GET['specialize_id'] : '';
        $dData = $gradesObj->getSubjectsWithGradeIDForCosts($grade_id,$semester,$specialize_id,$rools);
        $Data = $dData ? $dData : '';
        }
        elseif($rools == 'noRole'){
            $Data = '';
        }
    }

    if ($_GET['action'] == 'getUnitsWithSubjectID') {
        $subject_id = $_GET['subject_id'] ? $_GET['subject_id'] : '';
        $dData = $gradesObj->getUnitsWithSubjectID($subject_id);
        $Data = $dData ? $dData : '';
    }

    if ($_GET['action'] == 'getUnitsWithSubjectIDInSemester') {
        $subject_id = $_GET['subject_id'] ? $_GET['subject_id'] : '';
        $semester = $_GET['semester'] && $_GET['semester'] != 'both' ? $_GET['semester'] : '';
        $dData = $gradesObj->getUnitsWithSubjectIDInSemester($subject_id, $semester);
        $Data = $dData ? $dData : '';
    }
    
      if ($_GET['action'] == 'getUnitsWithSubjectIDWithExplanationsInSemester') {
        $subject_id = $_GET['subject_id'] ? $_GET['subject_id'] : '';
        $semester = $_GET['semester'] && $_GET['semester'] != 'both' ? $_GET['semester'] : '';
        $dData = $gradesObj->getUnitsWithSubjectIDWithExplanationsInSemester($subject_id, $semester);
        $Data = $dData ? $dData : '';
    }
    
        if ($_GET['action'] == 'getBanksWithSubjectID') {
        $subject_id = $_GET['subject_id'] ? $_GET['subject_id'] : '';
        $dData = $gradesObj->getBanksWithSubjectID($subject_id);
        $Data = $dData ? $dData : '';
    }

    if ($_GET['action'] == 'getLessonsWithUnitID') {
        $unit_id = $_GET['unit_id'] ? $_GET['unit_id'] : '';

        $dData = $gradesObj->getLessonsWithUnitID($unit_id);
        $Data = $dData ? $dData : '';
    }


    if($_GET['action'] == 'getUnitsWithBranchID'){
        
        $dData = $unitsObj->getUnitsWithBranchID($_GET['branch_id'], $_GET['subject_id']);
        $Data = $dData ? $dData : '';            
    }

    if ($_GET['action'] == 'getUnitsCount') {
 $searchMode = $_GET['searchMode'] ? $_GET['searchMode'] : '';
        $langData = $unitsObj->getUnitsCount($searchMode);
        $Data = $langData ? $langData : '';
    }

    if ($_GET['action'] == 'getAllSubjects') {

        $langData = $unitsObj->getAllSubjects();
        $Data = $langData ? $langData : '';

    } 
}else {
    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
}


    if (isset($postdata) && !empty($postdata)) {

        $Req = json_decode($postdata, true);
        if (isset($token) && isset($verify) && $verify) {
            if ($_GET['action'] == 'getOneUnit') {

                $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

                if (isset($token) && isset($verify) && $verify) {

                    $onelangData = $unitsObj->getOneUnit($Req);
                    $Data = $onelangData ? $onelangData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }

            }

            if ($_GET['action'] == 'deleteUnit') {

                $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

                if (isset($token) && isset($verify) && $verify) {

                    $langData = $unitsObj->deleteUnit($Req);
                    $Data = $langData ? $langData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }

            }


            

            if ($_GET['action'] == 'deleteOneLesson') {

                $token = apache_request_headers()["Authorization"];
                $verify = $hs256Obj->verifyJWT('sha256', $token);

                if (isset($token) && isset($verify) && $verify) {

                    $langData = $unitsObj->deleteOneLesson($Req);
                    $Data = $langData ? $langData : '';

                } else {
                    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
                }

            }
            
            if ($_GET['action'] == 'addEditUnit') {
                        $operation = $Req['operation'];
                        $lang_id = '';
                        if ($operation === 'edit') {
                            $lang_id = $Req['unit_id'];
                        }

                        $langData = $unitsObj->addEditUnit($Req, $lang_id);
                        $Data = $langData ? $langData : '';
                    }
            

        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }
    
     if ($_GET['action'] == 'getAllDataTestInMonths') {
        $token  = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            $Req['type']='test';
            $onepageData = $TestsObj->getAllDataTestInMonths($Req);
            $Data        = $onepageData ? $onepageData : ''; 
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    echo json_encode($Data);

