<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


require_once('init.php');
// require_once('/home/onlineapp/public_html/develop.testat-app.com/vendor/autoload.php');

// use FFMpeg\Format\Video\X264;
// use FFMpeg\FFMpeg;




if ($_GET['action'] == 'reconvertToHLS') {
    $videoId = $_REQUEST['video_id'];
    $Data = [];

    if (!empty($videoId)) {

        $videoData =$videoConverterObj-> getVideoDetails($videoId);
        
       
        if ($videoData) {
            $file = $videoData['file'];
            $courseId = $videoData['course_id'];
            $currentHlsFile = $videoData['file_hls'];

            $hlsFolder = "/home/onlineapp/public_html/api/uploads/course_videos_and_attachments/{$courseId}/hls";
            $filePath = "/home/onlineapp/public_html/api/uploads/course_videos_and_attachments/{$courseId}/{$file}";
            
            if (file_exists($filePath)) {
               $how=$videoConverterObj->deleteHLSFiles($hlsFolder, $currentHlsFile);
        //   die();
                $hlsFile = $videoConverterObj->convertVideo($filePath, $hlsFolder);
               
                
                if ($hlsFile) {
                     $basename = basename($hlsFile);
             
                     $duration = $videoConverterObj->calculateHlsDuration($hlsFile);
                     
                    $videoConverterObj->updateVideoHlsData($videoId, $basename, $duration);

                    $Data['status'] = true;
                    $Data['msg'] = 'HLS reconversion completed successfully.';
                    $Data['new_hls_file'] = $basename;
                } else {
                    $Data['status'] = false;
                    $Data['msg'] = 'HLS reconversion failed. Check logs for details.';
                }
            } else {
                $Data['status'] = false;
                $Data['msg'] = 'Original file not found.';
                $Data['file_path'] = $filePath;
            }
        } else {
            $Data['status'] = false;
            $Data['msg'] = 'Video not found in the database.';
        }
    } else {
        $Data['status'] = false;
        $Data['msg'] = 'No video ID provided.';
    }
}


if ($_GET['action'] == 'uploadAttachment' && $_SERVER['REQUEST_METHOD'] == 'POST') {
    header('Content-Type: application/json; charset=utf-8');

    ini_set('memory_limit', '2G');
    ini_set('max_execution_time', 7200);
    ini_set('post_max_size', '5G');
    ini_set('upload_max_filesize', '5G');

    $uploadBasePath = $_SERVER['DOCUMENT_ROOT'] . "/" . $Config['uploads_path'];
    $uploadFolderName = $_GET['uploadFolderName'];
    $uploadLink = $uploadBasePath . $uploadFolderName;

    $course_id = isset($_GET['course_id']) ? filter_var($_GET['course_id'], FILTER_SANITIZE_NUMBER_INT) : null;
    if ($uploadFolderName === 'course_videos_and_attachments' && $course_id) {
        $uploadLink .= '/' . $course_id;

        if (!is_dir($uploadLink)) {
            mkdir($uploadLink, 0777, true);
        }
    }

    $allowed_ext = [
        "mp4", "mov", "wmv", "flv", "webm", "avi", "mkv", "mp3", "wav", "ogg", "m4a", "jpg", "gif", "png", "jpeg", "bmp", "webp",
        "pdf", "doc", "docm", "docx", "dot", "dotx", "ppt", "pptx", "xls", "xlsx"
    ];
    $maxsize = 5 * 1024 * 1024 * 1024; // 5GB
    $thumbsConfig = [
        'small' => ['width' => 150, 'height' => 150],
        'medium' => ['width' => 300, 'height' => 300]
    ];
    $Data = [
        'status' => false,
        'msg' => '',
        'progress' => 0
    ];

    $upload = new Upload($allowed_ext, $thumbsConfig, $maxsize, $uploadLink, true);

    try {
        if (!isset($_FILES['file']) || empty($_FILES['file']['name'])) {
            throw new Exception('لم يتم تحميل أي ملف');
        }

        $file = [
            'name' => basename(strip_tags($_FILES["file"]["name"])),
            'type' => $_FILES["file"]['type'],
            'size' => $_FILES["file"]['size'],
            'tmp' => $_FILES["file"]['tmp_name'],
            'error' => $_FILES["file"]['error']
        ];

        if ($file['size'] > $maxsize) {
            throw new Exception('حجم الملف يتجاوز الحد الأقصى المسموح به (5GB)');
        }

        $file['ext'] = strtolower($upload->GetExt($file['name']));
        if (!in_array($file['ext'], $allowed_ext)) {
            throw new Exception('نوع الملف غير مسموح به');
        }

        $chunk_number = isset($_POST['chunk_number']) ? (int) $_POST['chunk_number'] : 0;
        $total_chunks = isset($_POST['total_chunks']) ? (int) $_POST['total_chunks'] : 1;

        if ($total_chunks > 1) {
            $chunk_dir = $uploadLink . '/chunks_' . md5($file['name']);
            if (!is_dir($chunk_dir)) {
                mkdir($chunk_dir, 0755, true);
            }

            $chunk_file = $chunk_dir . '/chunk_' . $chunk_number;
            if (!move_uploaded_file($file['tmp'], $chunk_file)) {
                throw new Exception('فشل في حفظ جزء الملف');
            }

            $Data['progress'] = round(($chunk_number + 1) / $total_chunks * 100);
            if ($chunk_number < $total_chunks - 1) {
                $Data['status'] = true;
                $Data['msg'] = 'تم تحميل الجزء بنجاح';
                echo json_encode($Data);
                exit;
            }

            $final_path = $uploadLink . '/' . $file['name'];
            $combined = fopen($final_path, 'wb');
            for ($i = 0; $i < $total_chunks; $i++) {
                $chunk_data = file_get_contents($chunk_dir . '/chunk_' . $i);
                fwrite($combined, $chunk_data);
                unlink($chunk_dir . '/chunk_' . $i);
            }
            fclose($combined);
            rmdir($chunk_dir);

            $file['tmp'] = $final_path;
        }

        $upfile = $upload->Upload_File($file, $maxsize);

        if ($upfile) {
            if (in_array($upfile['ext'], ['jpg', 'jpeg', 'png', 'gif', 'webp'])) {
                $Data['thumbnails'] = [
                    'small' => 'thumbs/' . $upfile['newname'],
                    'medium' => 'thumbs/' . $upfile['newname']
                ];
            }

            if (isset($_GET['convertToHLS']) && $_GET['convertToHLS'] === 'true') {
                if (in_array($file['ext'], ['mp4', 'mov', 'wmv', 'flv', 'webm'])) {
                    $videoDuration = $videoConverterObj->getVideoDuration($uploadLink . '/' . $upfile['newname']);
                    $Data['time'] = $videoDuration ?: 'Could not retrieve duration.';

                    $hlsFolder = $uploadLink . '/hls';
                    if (!is_dir($hlsFolder)) {
                        mkdir($hlsFolder, 0777, true);
                    }

                    $hlsFile = $videoConverterObj->convertVideo($uploadLink . '/' . $upfile['newname'], $hlsFolder, $upfile['newname']);
                    $Data['file_hls'] = basename($hlsFile) ?: null;
                    // $Data['hls'] = $hlsFile ?: null;
                    $Data['hls_msg'] = $hlsFile ? 'HLS conversion completed successfully.' : 'HLS conversion failed.';
                }
            }

            $Data['status'] = true;
            $Data['file'] = $upfile['newname'];
            $Data['ext'] = $upfile['ext'];
            $Data['size'] = $upfile['size'];
            $Data['type'] = $upfile['type'];
            $Data['msg'] = 'تم تحميل الملف بنجاح';
        } else {
            throw new Exception('فشل تحميل الملف: ' . implode(', ', $upload->showErrors()));
        }
    } catch (Exception $e) {
        $Data['msg'] = $e->getMessage();
    }

}



if ($_GET['action'] == 'deleteAttachment' && $_SERVER['REQUEST_METHOD'] == 'POST') {
    $is_deleted = false;
        $old_file = $_SERVER['DOCUMENT_ROOT'] . "/" . $Config['uploads_path'];
        if($Req['uploadFolderName']) $old_file .=  $Req['uploadFolderName'] . '/';
        $old_file .= $Req['file'];
    // print_r($old_file);die();
        
        if (file_exists($old_file)) {
            $is_deleted = @unlink($old_file);  
        }
        $Data = $is_deleted;

    }

    echo json_encode($Data);
    exit;
