<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/
 *
 * ************************************************************************* */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once('init.php');

// Start Functionality  
$postdata = file_get_contents("php://input");

// Authorizaiton

if ($_GET['action'] == 'getAllSubjectsSubscriptionCosts') {
        // echo "TEST";die();
        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            
            if($_GET['user_type'] == 'student'){
                $subjects = $userAdmObj->getAllSubjectsSubscriptionCosts($_GET);
            }else if($_GET['user_type'] == 'teacher'){
                $subjects = $userAdmObj->getAllSubjectsSubscriptionCostsByTeacherId($_GET);
            }
            $Data = $subjects ? $subjects : '';
            echo json_encode($Data);
            
        }else {
                echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
            }
    }
    
if ($_GET['action'] == 'getSomeUsers') {

    $token = apache_request_headers()["Authorization"];

    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $dateTime = date('Y-m-d H:i:s');
        $start = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchEmail = $_GET['searchEmail'] ? $_GET['searchEmail'] : '';
        $userType = $_GET['userType'] ? $_GET['userType'] : '';

        $searchUserPhone = $_GET['searchUserPhone'] ? $_GET['searchUserPhone'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : $dateTime;
        $searchUserStatus = $_GET['searchUserStatus'] != '' ? $_GET['searchUserStatus'] : '';
        $searchUserType = $_GET['searchUserType'] ? $_GET['searchUserType'] : '';
        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $is_deleted = $_GET['accountStatus'] == 'deleted' ? '1' : '';
        $is_not_deleted = $_GET['accountStatus'] == 'not_deleted' ? '0' : '';
        $searchAccountType = $_GET['searchAccountType'] ? $_GET['searchAccountType'] : '';

        $usersData = $userAdmObj->getSomeUsers($userType, $start, $aItemsPerPage, $sort, $type, $searchName, $searchEmail, $searchUserPhone, $searchDateFrom, $searchDateTo, $searchUserStatus, $searchUserType, $searchId, $searchCountry, $searchStage, $searchGrade, $searchAccountType, $is_deleted, $is_not_deleted);

        $Data = $usersData ? $usersData : '';
        echo json_encode($Data);

    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'chickEmail') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    $req = $_GET['email'];
    if (isset($token) && isset($verify) && $verify) {


        $userLevelData = $userAdmObj->chickEmail($req);
        $Data = $userLevelData ? $userLevelData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}


if ($_GET['action'] == 'chickMobile') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    $req = $_GET['mobile'];
    if (isset($token) && isset($verify) && $verify) {


        $userLevelData = $userAdmObj->chickMobile($req);
        $Data = $userLevelData ? $userLevelData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getSearchUsersCount') {
    $dateTime = date('Y-m-d H:i:s');
    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchEmail = $_GET['searchEmail'] ? $_GET['searchEmail'] : '';
        $userType = $_GET['userType'] ? $_GET['userType'] : '';
        $searchUserPhone = $_GET['searchUserPhone'] ? $_GET['searchUserPhone'] : '';
        $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
        $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] : $dateTime;
        $searchUserStatus = $_GET['searchUserStatus'] != '' ? $_GET['searchUserStatus'] : '';
        $searchUserType = $_GET['searchUserType'] ? $_GET['searchUserType'] : '';
        $searchId = $_GET['searchId'] ? $_GET['searchId'] : '';
        $searchCountry = $_GET['searchCountry'] ? $_GET['searchCountry'] : '';
        $searchStage = $_GET['searchStage'] ? $_GET['searchStage'] : '';
        $searchGrade = $_GET['searchGrade'] ? $_GET['searchGrade'] : '';
        $searchAccountType = $_GET['searchAccountType'] ? $_GET['searchAccountType'] : '';
        $is_deleted = $_GET['accountStatus'] == 'deleted' ? '1' : '';
        $is_not_deleted = $_GET['accountStatus'] == 'not_deleted' ? '0' : '';
        $usersSearchData = $userAdmObj->getSearchUsersCount($userType, $sort, $type, $searchName, $searchEmail, $searchUserPhone, $searchDateFrom, $searchDateTo, $searchUserStatus, $searchUserType, $searchId, $searchCountry, $searchStage, $searchGrade, $searchAccountType, $is_deleted, $is_not_deleted);

        $Data =
            $usersSearchData ? $usersSearchData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getUsersCount') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $userType = $_GET['userType'] ? $_GET['userType'] : '';
        $usersData = $userAdmObj->getUsersCount($userType);
        $Data = $usersData ? $usersData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}

if ($_GET['action'] == 'getUsersLevels') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $usersLevelsData = $userAdmObj->getUsersLevels();
        $Data = $usersLevelsData ? $usersLevelsData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'getAllRegisterUsers') {
    // echo "TEST";die();
    $userData = $userAdmObj->getAllRegisterUsers();
    $Data = $userData ? $userData : '';
    echo json_encode($Data);
}
if ($_GET['action'] == 'getUserDetailsInfo') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $id = $_GET['id'] ? $_GET['id'] : '';
        $userData = $userAdmObj->getUserDetailsInfo($id);
        $Data = $userData ? $userData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}


if ($_GET['action'] == 'addEditUser') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $_REQUEST += $Req;
        
        $operation = $_REQUEST['operation'];
        $user_id = '';
        // $temp = array();
        // $allow_ext = array("jpg", "webp", "gif", "png", "jpeg", "bmp");
        // $maxsize = 1024 * 1024 * 5; //kb
        // // $uploadFolder = 'link/api/uploads/users';
        // $uploadFolder = $Config['uploads_path'] . 'users';

        // $thumbsConfig = array(
        //     array(
        //         'width' => '100',
        //         'hight' => '100'
        //     )
        // );

        // if (strpos($_FILES["file"]['type'], 'image') !== false) {
        //     $thum = true;
        // } else {
        //     $thum = false;
        // }

        // $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);

        // if (isset($_FILES['file']['name']) and $_FILES['file']['name'] != '') {

        //     //get file name
        //     $file['name'] = addslashes($_FILES["file"]["name"]);
        //     // get file type
        //     $file['type'] = $_FILES["file"]['type'];
        //     // get filesize in KB
        //     $file['size'] = $_FILES["file"]['size'] / 1024;
        //     // get file tmp path
        //     $file['tmp'] = $_FILES["file"]['tmp_name'];
        //     //get file ext [to get max uploades size]
        //     $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
        //     //check if guest have selected file or not
        //     if ($file['name'] != '') {
        //         // Start Uploading File
        //         $upfile = $upload->Upload_File($file, $maxsize);

        //         //if uploading successfully
        //         if ($upfile) {
        //             $temp['file'] = $upfile['newname'];
        //         } else {
        //             $error = true;
        //             $showError[] = $upload->showErrors();
        //             $top_msg['error'][] = $showError[0][0];
        //         }
        //     }
        // } else {
        //     $temp['file'] = null;
        // }
        
        if ($operation === 'edit') {
            $user_id = $_REQUEST['user_id'];
        }


        $temp['file'] = $Req['file'];
        $usersData = $userAdmObj->addEditUser($_REQUEST, $temp['file'], $user_id);
        $Data = $usersData ? $usersData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getAllSchoolYears') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $id = $_GET['country_id'] ? $_GET['country_id'] : '';
        $data = $userAdmObj->getAllSchoolYears($id);
        $Data = $data ? $data : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
if ($_GET['action'] == 'getSubscriptionCosts') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {
        $country_id = $_GET['country_id'] ? $_GET['country_id'] : '';
        $subscription_type = $_GET['subscription_type'] ? $_GET['subscription_type'] : '';
        $data = $userAdmObj->getSubscriptionCosts($subscription_type, $country_id);
        $Data = $data ? $data : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

if ($_GET['action'] == 'getSearchUsersByType') {


    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);

    if (isset($token) && isset($verify) && $verify) {

        $query = $_GET['query'] ? $_GET['query'] : '';
        $user_type = $_GET['user_type'] ? $_GET['user_type'] : 'parent';
        $oneUsersData = $userAdmObj->getSearchUsersByType($query, $user_type);
        $Data = $oneUsersData ? $oneUsersData : '';
        echo json_encode($Data);
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}
 
if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, TRUE);

    if ($_GET['action'] == 'signIn') {
        // print_r($Req);die();
        
        $email      = $Req['email'];
        $password   = $Req['password'];
        $signInData = $userAdmObj->signIn($email, $password);
        
        if($signInData){
            
            if($signInData['is_deleted'] == '0'){
                 // JWT Header
                $header = [
                    "alg" => "HS256",
                    "typ" => "JWT"
                ];
                // JWT Payload data
                $payload = [
                    "user_id" => $signInData['id']
                ];
                $token = $hs256Obj->generateJWT('sha256', $header, $payload);
                $userAdmObj->insertAuthCode($signInData['id'], $token);
                $returnedData = ['token' => $token, 'userData' => $signInData];
                $Data = $returnedData ? $returnedData : '';
            }else if ($signInData['is_deleted'] == '1') {

                $Data['message'] = "تم أيقاف هذا الحساب أو انه لم يفعل حتى الان";
        
                $Data['is_disabled'] = true;
        
                $Data['success'] = false;

    }
        }else{
             $Data['success'] = false;
        
            $Data['message'] = $Lang['L_PleaseCheckCredentialData'];
        }
       
        echo json_encode($Data);

    }

    if ($_GET['action'] == 'getUserLevel') {

        $token = apache_request_headers()["Authorization"];

        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $userLevelData = $userAdmObj->getUserLevel($Req);
            $Data = $userLevelData ? $userLevelData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'getOneUser') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $userType = $_GET['userType'] ? $_GET['userType'] : '';

            $oneUsersData = $userAdmObj->getOneUser($userType, $Req);
            $Data = $oneUsersData ? $oneUsersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    if ($_GET['action'] == 'addingDriverToOrder') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $driverData = $userAdmObj->addingDriverToOrder($Req);
            $Data = $driverData ? $driverData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    
    if ($_GET['action'] == 'addSubscription') { 
        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);
        if (isset($token) && isset($verify) && $verify) {
            
            $data['admin_id'] = $ADMIN['id'];
             if($Req['subscription_type'] != 'subjects'){
                 
                 $Req['subjects'] = $userAdmObj->getAllUserSubjects($Req['user_id'], $Req['subscription_type'], $Req['cost_type']);
                //  print_r($Req['subjects']);die();
             }else{
                 $Req['subjects'] = $userAdmObj->convert_object_to_array(json_decode($Req['subjects']));
             }
             $date = date('Y-m-d');
             $current_shoolYear = $userAdmObj->getSchoolYearBuCountryId($Req['country_id']);
            
            //  print_r($Req['subjects']);die();
            
            foreach($Req['subjects'] as $item){
                if($Req['subscription_type'] != 'subjects'){
                    $item['subscription_type'] = $Req['subscription_type'];
                }
                if ($item['subscription_type'] == 'year' && $date < $current_shoolYear['first_semester_end']) {
                    // $item['subscription_type_customized'] = 'year';
                    $item['start_date'] = $current_shoolYear['first_semester_start'];
                    $item['end_date'] = $current_shoolYear['second_semester_end'];
                    $item['end_date'] = $current_shoolYear['second_semester_end'];
                    $item['subscription_type'] = 'year';
                    $cost_type = 'year';
                } else {
                    if ($item['subscription_type'] == 'first_semester' && $date < $current_shoolYear['first_semester_end']) {
                        // $item['subscription_type_customized'] = 'first_semester';
                        $item['subscription_type'] = 'first_semester';
                        $item['start_date'] = $current_shoolYear['first_semester_start'];
                        $item['end_date'] = $current_shoolYear['first_semester_end'];
                        $cost_type = 'semester';
                    } else if ($item['subscription_type'] == 'second_semester' && $date < $current_shoolYear['second_semester_end']) { // && $date > $current_shoolYear['first_semester_end']
                        // $item['subscription_type_customized'] = 'second_semester';
                        $item['subscription_type'] = 'second_semester';
                        $item['start_date'] = $current_shoolYear['second_semester_start'];
                        $item['end_date'] = $current_shoolYear['second_semester_end'];
                        $cost_type = 'semester';
                    }
                }
    
                if($Req['subscription_type'] == "subjects"){
                    $item['subscription_type'] = 'subjects';
                }
                 $data['user_id'] = $Req['user_id'];
                 $data['subject_id'] = $item['id'];
                 $data['start_date'] = $item['start_date'];
                 $data['end_date'] = $item['end_date'];
                 $data['subscription_type'] = $item['subscription_type'];
                 $data['year_title'] = $Req['year_title'];
                 $data['cost'] = $item['cost'];
                    $addopoData = $userAdmObj->addSubscription($data);
            }
                //  print_r($data);die();
            $Data = $addopoData ? $addopoData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }
    }

    if ($_GET['action'] == 'deleteUser') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $userType = $_GET['userType'] ? $_GET['userType'] : '';

            $usersData = $userAdmObj->deleteUser($userType, $Req);
            $Data = $usersData ? $usersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'removeSubscription') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $usersData = $userAdmObj->removeSubscription($Req);
            $Data = $usersData ? $usersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteStudentsParents') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $usersData = $userAdmObj->deleteStudentsParents($Req);
            $Data = $usersData ? $usersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'removeTeacher') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $usersData = $userAdmObj->removeTeacher($Req);
            $Data = $usersData ? $usersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteAdminRole') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $usersData = $userAdmObj->deleteAdminRole($Req);
            $Data = $usersData ? $usersData : '';
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }
    if ($_GET['action'] == 'deleteOneUserCar') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {

            $userDeleteCarData = $userAdmObj->deleteOneUserCar($Req['user_id'], $Req['car_id']);

            $Data = $userDeleteCarData ? $userDeleteCarData : "no car deleted";

            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }

    if ($_GET['action'] == 'deleteTeacherFile') {

        $token = apache_request_headers()["Authorization"];
        $verify = $hs256Obj->verifyJWT('sha256', $token);

        if (isset($token) && isset($verify) && $verify) {
            $dle = $userAdmObj->deleteTeacherFile($Req);
            if ($dle) {
                $data = array(
                    'id' => $_REQUEST['id']
                );
                $Data['status'] = true;
                $Data['dataTeacher'] = $userAdmObj->getTeacherDataByIdTeacher($data);
            } else {
                $Data['status'] = false;
            }
            echo json_encode($Data);
        } else {
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        }

    }


    ///////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////// APP ////////////////////////////////////////////

    if ($_GET['action'] == 'forgetPassword') {

        $email = $Req['email'];
        $userForgetPassData = $userAdmObj->userForgetPassword($email);

        if ($userForgetPassData['error'] === 'email_mobile_already_exists') {
            // generate new user password
            // Send new password to user by this email

            $infoUser = $userAdmObj->getUserInfoByEmail($email);

            $new_pass = newPassword();

            $ch = $userAdmObj->changePassword($infoUser['id'], md5($new_pass));


            if ($ch) {

                $subject = 'Your password has been changed based on your request - IPlus';

                $msg = "<div style='direction:ltr;line-height:1.5;'> Welcome";
                $msg .= "<span style='color:green;display:block'>" . $infoUser['full_name'] . "</span>";
                $msg .= "Your password has been changed based on your request, and your new password is ";
                $msg .= "<span style='color:green;display:block'>" . $new_pass . "</span></div>";
                $site_email = $Config['site_email'];

                $send = $mailer->sendEmail($infoUser['email'], $subject, $msg, 'IPlus' . '<' . $site_email . '>', $site_email);

                if ($send) {
                    $Data['success'] = 'successSendPassByEmail';
                } else {
                    $Data['error'] = 'problemToSendPassword';
                }

            } else {
                $Data['error'] = 'problemWhenChangePassword';
            }

            echo json_encode($Data);
        } else {
            $Data = $userForgetPassData ? $userForgetPassData : '';
            echo json_encode($Data);
        }
    }
}

if ($_GET['action'] == 'addEditProfileTeacher') {

    $token = apache_request_headers()["Authorization"];
    $verify = $hs256Obj->verifyJWT('sha256', $token);
    if (isset($token) && isset($verify) && $verify) {
        if ($_REQUEST):
            $error = false;
            $_REQUEST['newFileUpload'] = '';
            if (isset($_FILES['fileUpload']['name']) && $_FILES['fileUpload']['name'] != '' && $_REQUEST['upload_type'] == "file"):
                //upload video to description status
                $allow_ext = array("mp3", "webp", "mp4", "mov", "wmv", "flv");
                $maxsize = 30000000; //30 Mbps
                $uploadFolder = $Config['uploads_path'] . 'teachers_videos';
                $thum = false;
                $thumbsConfig = array(
                    array(
                        'width' => '100',
                        'hight' => '100'
                    )
                );
                $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, $thum);
                //get file name
                $file['name'] = addslashes($_FILES["fileUpload"]["name"]);
                // get file type
                $file['type'] = $_FILES["fileUpload"]['type'];
                // get filesize in KB
                $file['size'] = $_FILES["fileUpload"]['size'] / 1024;
                // get file tmp path
                $file['tmp'] = $_FILES["fileUpload"]['tmp_name'];
                //get file ext [to get max uploades size]
                $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
                //check if guest have selected file or not

                if ($file['name'] != '') {

                    // Start Uploading File
                    $upfile = $upload->Upload_File($file, $maxsize);

                    //if uploading successfully
                    if ($upfile) {
                        $_REQUEST['file'] = $upfile['newname'];
                        $_REQUEST['newFileUpload'] = $upfile['newname'];
                    } else {
                        $error = true;
                        $showError[] = $upload->showErrors();
                        $Data['msg'] = $showError[0][0];
                    }

                }

            endif;
            /*   echo '<pre>';
               print_r($_REQUEST);
               echo '</pre>';*/
            if (!$error):
                $usersData = $userAdmObj->updateTeacherData($_REQUEST);
                if ($usersData) {
                    $data = array(
                        'id' => $_REQUEST['id']
                    );
                    $Data['dataTeacher'] = $userAdmObj->getTeacherDataByIdTeacher($data);
                    $Data['status'] = true;
                    $Data['type'] = 'insert';
                    $Data['msg'] = $_REQUEST['operation'] == "add" ? "تم حفظ البيانات بنجاح" : "تم تعديل البيانات بنجاح";
                } else {
                    $Data['status'] = false;
                    $Data['type'] = 'insert';
                    $Data['msg'] = $_REQUEST['operation'] == "add" ? "حدثت مشكله اثناء حفظ البيانات , يرجى المحاوله مره اخرى" : "حدثت مشكله اثناء تعديل البيانات , يرجى المحاوله مره اخرى";
                }
            else:
                $Data['status'] = false;
                $Data['type'] = 'upload';

                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $Config['uploads_path'] . 'teachers_videos/' . $Req['newFileUpload'];
                if (file_exists($old_img)) :
                    @unlink($old_img);
                endif;
            endif;
            echo json_encode($Data);
        else:
            echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
        endif;
    } else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }
}