<?php

require_once('./classes/class.question_paragraph.php');
require_once('./classes/class.complete_it_writing_auto_correct.php');
require_once('./classes/class.complete_it_sub.php');
require_once('./classes/class.choose_check.php');
require_once('./classes/class.sort_it.php');
require_once('./classes/class.match_it.php');
require_once('./classes/class.general_question.php');

class QuestionFactory 
{
    
    public function store($test_id,$question){
            switch($question['type']){
                case "paragraphs" : 
                    return new QuestionParagraph($test_id,$question);
                case "complete_it_writing_auto_correct" :
                case "complete_it_writing_manual_correct" :
                case "complete_it" :
                    return new CompleteItWritingAutoCorrect($test_id,$question);
                case "complete_it_sub" :
                    return new CompleteItSub($test_id,$question);
                case "choose" :
                case "check" :
                    return new ChooseCheck($test_id,$question);
                case "sort_it" :
                    return new SortIt($test_id,$question);
                case "match_it" :
                    return new MatchIt($test_id,$question);
                case 'head_question' :
                case 'break' :
                case 'article' :
                    return new GeneralQuestion($test_id, $question);
                default:
                    echo "++++++  " . $question['type']."  +++++++";
                    print_r($question);die();
            }
    }
}


?>