<?php

$commonObj = new Common();

class Common
{

    public $mDb;
    public $mConfig;
    public $mMailer;
    public $dateTime;

    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mMailer = new Mailer();

        $this->dateTime = date('Y-m-d H:i:s');
    }

    function convert_object_to_array($data)
    {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }


    function getSubjectsByStage_id($stage_id, $itemsPerPage)
    {
        $sql = "SELECT f.name , f.img, f.id , f.subject_direction ,  f.description_" . LANGUAGE . " as description  FROM `subjects` f ";
        $sql .= "where f.`status` ='1' AND f.is_deleted !='1' AND  f.`stage_id` ='{$stage_id}' AND  f.show_in_home ='1' ";
        $sql .= " group by f.name order by f.`sort` asc ";
        $sql .= $itemsPerPage > 0 ? " Limit {$itemsPerPage} " : " ";
        // p($sql);
        return $this->mDb->getAll($sql);
    }


    function getAllStageWithSubjects($country_id)
    {
        $res = $this->getAllStages($country_id, 1);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['subjcets'] = $this->getSubjectsByStage_id($res[$i]['id'], 6);
        }
        return $res;
    }


    function getAllContactInfo($position)
    {
        $sql = "SELECT   f.phone , f.whatsapp , f.email , f.img , fl.title  , fl.address  FROM `contact_information` f ";
        $sql .= "LEFT JOIN `contact_information_langs` fl ON ( f.`id` = fl.`contact_information_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`position` ='{$position}'  AND f.`status` ='1'    ";
        // echo   $sql;
        return $this->mDb->getAll($sql);
    }


    function getStageDetailsWithSubjects($stage_id)
    {

        global $USER_DATA;
        $sql = "SELECT f.id , fl.`name` ,f.img , fl.description   FROM `stages` f ";
        $sql .= "LEFT JOIN `stages_langs` fl ON ( f.`id` = fl.`stage_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`id` ='{$stage_id}'  AND f.`status` ='1'  AND   f.is_deleted !='1' ";

        // for Testers
        $sql .= "  AND  ( (f.just_for_tester ='0') ||  (f.just_for_tester ='1' and  f.tester_ids LIKE '%," . $USER_DATA['id'] . ",%'   ) )    ";

        // echo   $sql;
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['subjcets'] = $this->getSubjectsByStage_id($stage_id, 20);
            return $res;
        }
    }

    function getAllAdvantages()
    {
        $sql = "SELECT a.id ,a.img , al.`title`  , al.`description`  , al.`meta_description`  , al.`meta_title`   , al.`meta_keywords`  , al.alt_image  FROM `advantages` a ";
        $sql .= "LEFT JOIN `advantages_langs` al ON ( a.`id` = al.`advantage_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where a.`status` ='1'  order by a.`sort` asc ";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    function getAdvantagesDetails($id)
    {

        $sql = "SELECT a.id,a.video,a.img , al.`title` , al.`description`  , al.`meta_description`  , al.`meta_title`   , al.`meta_keywords`  , al.alt_image FROM `advantages` a ";
        $sql .= "LEFT JOIN `advantages_langs` al ON ( a.`id` = al.`advantage_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where a.`status` ='1' and a.id='{$id}' ";
        // echo $sql;die();
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['items'] = $this->getAllAdvantagesItem($res['id']);
            return $res;
        }
    }

    function getAllAdvantagesItem($advantage_id)
    {
        $sql = "SELECT ai.item FROM `advantage_items` ai ";
        $sql .= "where ai.advantage_id = '{$advantage_id}' AND ai.`lang_code`='" . LANGUAGE . "' order by ai.`id` asc ";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    function getAllExplanations()
    {
        $sql = "SELECT e.id ,e.video,  e.img ,el.title  FROM `explanations` e ";
        $sql .= "LEFT JOIN `explanations_langs` el ON ( e.`id` = el.`explanation_id`  AND el.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where e.`status` ='1'  ";
        return $this->mDb->getAll($sql);
    }


    function getAllSliders($temp,$test) //
    {
        $sql = "SELECT s.id,s.url,sl.img, sl.file_type  ,s.type , s.title, s.place_banner   ";
        if ($temp['type'] == "guest_banners")
            $sql .= ",s.place_banner, t.name as test_name ";
            $sql .= ",COALESCE(gl.name, '') as grade_name,COALESCE(stgl.name, '') as stage_name, COALESCE(un.name, '')as unit_name, COALESCE(sub.name, '') as subject_name, COALESCE(fosl.name, '') as field_study_name ";
        $sql .= " FROM `sliders` s ";
        if ($temp['type'] == "guest_banners")
            $sql .= " LEFT JOIN tests t ON s.stage_id = t.stage_id AND s.country_id = t.country_id ";
            $sql .= " LEFT JOIN grades_langs gl ON gl.grade_id = t.grade_id AND gl.lang_code = '". LANGUAGE."'";
            $sql .= " LEFT JOIN stages_langs stgl ON stgl.stage_id = t.stage_id AND stgl.lang_code = '". LANGUAGE."'";
            $sql .= " LEFT JOIN units un ON un.id = t.unit_id ";
            $sql .= " LEFT JOIN subjects sub ON sub.id = t.subject_id ";
            $sql .= " LEFT JOIN fields_of_study_subjects foss ON foss.subject_id = sub.id ";
            $sql .= " LEFT JOIN fields_of_study_langs fosl ON fosl.fields_of_study_id = foss.field_of_study_id AND fosl.lang_code = '". LANGUAGE."'";
            $sql .= "LEFT JOIN `sliders_langs` sl ON ( s.`id` = sl.`slider_id`  AND sl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where s.`status` ='1' AND s.type ='{$temp['type']}' ";
         if ($temp['type'] == "guest_banners")
                $sql .= " AND t.id = '{$test}'";
        $sql .= " order by s.`sort`";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        
        if(!$res){
           return $this->getTestData($test);
        }else{
            return $res;
        }
    }
    
    
    function getTestData($test){
        $sql  = "SELECT t.name as test_name ";
        $sql .= ",COALESCE(gl.name, '') as grade_name,COALESCE(sl.name, '') as stage_name, COALESCE(un.name, '')as unit_name, COALESCE(sub.name, '') as subject_name, COALESCE(fosl.name, '') as field_study_name ";
        $sql .= "FROM `tests` t";
        $sql .= " LEFT JOIN grades_langs gl ON gl.grade_id = t.grade_id AND gl.lang_code = '". LANGUAGE."'";
        $sql .= " LEFT JOIN stages_langs sl ON sl.stage_id = t.stage_id AND sl.lang_code = '". LANGUAGE."'";
        $sql .= " LEFT JOIN units un ON un.id = t.unit_id ";
        $sql .= " LEFT JOIN subjects sub ON sub.id = t.subject_id ";
         $sql .= " LEFT JOIN fields_of_study_subjects foss ON foss.subject_id = sub.id ";
        $sql .= " LEFT JOIN fields_of_study_langs fosl ON fosl.fields_of_study_id = foss.field_of_study_id AND fosl.lang_code = '". LANGUAGE."'";
        $sql .= " WHERE t.id = '{$test}' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }
    
    
    
    function getAllFrequentlQuestions()
    {
        $sql = "SELECT f.id,fl.`title`,fl.`description`  FROM `frequently_questions` f ";
        $sql .= "LEFT JOIN `frequently_questions_langs` fl ON ( f.`id` = fl.`question_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where f.`status` ='1'  order by f.`sort`";
        return $this->mDb->getAll($sql);
    }

    function getAllCountries()
    {
        $sql = "SELECT c.id , c.img , c.country_code , c.valid_count_of_mobile_number	 ,cl.name  FROM `countries` c ";
        $sql .= "LEFT JOIN `countries_langs` cl ON ( c.`id` = cl.`country_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where c.`status` ='1'  order by c.`id`";
        return $this->mDb->getAll($sql);
    }

    function getValid_count_of_mobile_number($country_code)
    {
        $sql = "SELECT   c.valid_count_of_mobile_number FROM `countries` c ";
        $sql .= "where c.`status` ='1' AND c.country_code='{$country_code}'  ";
        return $this->mDb->getOne($sql);
    }

    function getAllStages($country_id, $show_in_home)
    {
        global $USER_DATA;
        $sql = "SELECT f.id , fl.`name` , f.img   FROM `stages` f ";
        $sql .= "LEFT JOIN `stages_langs` fl ON ( f.`id` = fl.`stage_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where f.`status` ='1'  AND f.`country_id` ='{$country_id}'  AND  f.is_deleted !='1' ";
        $sql .= $show_in_home ? " AND  f.show_in_home ='1' " : " ";
        // for Testers
        $sql .= "  AND  ( (f.just_for_tester ='0') ||  (f.just_for_tester ='1' and  f.tester_ids LIKE '%," . $USER_DATA['id'] . ",%'   ) )    ";

        //  p($sql);
        return $this->mDb->getAll($sql);
    }

    function getAllGrades($stage_id, $type, $parent_id = '0')
    {
        $sql = "SELECT f.id , fl.`name` , f.`stage_id`  FROM `grades` f ";
        $sql .= "LEFT JOIN `grades_langs` fl ON ( f.`id` = fl.`grade_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where f.`status` ='1'  AND f.`parent_id` ='{$parent_id}' AND f.`stage_id` ='{$stage_id}' AND  f.is_deleted !='1' AND type = '{$type}'   ";
        // $sql .= $stage_id ? "AND f.`stage_id` ='{$stage_id}'":"";
        // echo $sql;die();
        $sql .= "  order by f.`sort` asc ";
        return $this->mDb->getAll($sql);
    }

    function getAllGradesWithSpecialize($stage_id)
    {
        $res = $this->getAllGrades($stage_id, 'grade', '0');
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['specializes'] = $this->getAllGrades($stage_id, 'specialize', $res[$i]['id']);
        }
        return $res;
    }


    function getSettingByName($name)
    {
        $sql = " SELECT  value  FROM `settings` where name ='{$name}'  ";
        $res = $this->mDb->getOne($sql);
    }

    function getAllSettings()
    {
        $sql = " SELECT name,value ";
        $sql .= " FROM `settings` ";
        // $sql .= " WHERE    `name`='site_name' OR  `name`='site_keywords' OR `name`='phone'  OR `name`='site_email' OR `name`='address' OR `name`='address_en' OR `name`='facebook' OR `name`='twitter' OR `name`='google_plus' OR `name`='whatsapp'  OR `name`='site_desc'   OR `name`='site_desc_en' OR `name`='linkedin' OR `name`='trial_period_student' OR `name`='trial_period_parent' OR `name`='trial_period_teacher' OR `name`='app_android_version' OR `name`='app_IOS_version' OR name='hide_show_subsecription' OR name='hide_subsecription' OR name='show_all_languages' OR name='force_update' OR name='api_secrit_key_on' OR name='huawei_url' OR `name`='address_en' OR `name`='facebook' OR `name`='twitter' OR `name`='google_plus' OR `name`='whatsapp'  OR `name`='site_desc'   OR `name`='site_desc_en' OR `name`='linkedin' OR `name`='trial_period_student' OR `name`='trial_period_parent' OR `name`='trial_period_teacher' OR `name`='app_android_version' OR `name`='app_IOS_version' OR name='hide_show_subsecription' OR name='hide_subsecription' OR name='show_all_languages' OR name='force_update' OR name='api_secrit_key_on' OR name='huawei_url' OR `name`='address_en' OR `name`='facebook' OR `name`='twitter' OR `name`='google_plus' OR `name`='whatsapp'  OR `name`='site_desc'   OR `name`='site_desc_en' OR `name`='linkedin' OR `name`='trial_period_student' OR `name`='trial_period_parent' OR `name`='trial_period_teacher' OR `name`='app_android_version' OR `name`='app_IOS_version' OR name='hide_show_subsecription' OR name='hide_subsecription' OR name='show_all_languages' OR name='force_update' OR name='api_secrit_key_on' OR name='huawei_url'   OR name='appstore_url'   OR name='googleplay_url'  ";

        // p($sql);
        $res = $this->mDb->getAll($sql);
        foreach ($res as $k => $v) {
            $temp[$v['name']] = $v['value'];
        }

        return $temp;
    }

    function getSchoolYearBuCountryId($country_id)
    {
        $date = date('Y-m-d');

        $sql = "SELECT `id`, `added_by`, `status`, `title`, `country_id`, `first_semester_start`, `first_semester_end`, `second_semester_start`, `second_semester_end`, `date_added` FROM `school_years`";
        $sql .= " WHERE status ='1' AND `country_id` = '{$country_id}' and  second_semester_end > '{$date}'  order by second_semester_end asc ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        if (count($res)) {
            return $res[0];
        }
    }

    function insertToFawryTransactionPaymentLog($temp)
    {
        $subjects = $this->convert_object_to_array(json_decode($temp['subscription']));
       
        $sql = "INSERT INTO `fawry_payment_transactions` SET ";
        foreach ($this->mDb->getCols('fawry_payment_transactions', $temp) as $k => $v) {
            $sql .= ($k == 'cat_name') ? ' ' : "{$k}='{$v}',";
        }
        $sql .= "date_added='{$this->dateTime}'";
        //  echo $sql;die();
        $id = $this->mDb->queryReturnLastId($sql);
        $cost_type = strtolower($temp['payment_status']);
        
        if($id){
            foreach($subjects['subjects'] as $key => $subject){
                $sqll = "INSERT INTO `users_subjects_subscriptions` SET ";
                $sqll .= " `user_id` = '{$temp['user_id']}' ";
                $sqll .= ", `subject_id` = '{$subject['subject_id']}' ";
                $sqll .= ", `start_date` = '{$subject['start_date']}' ";
                $sqll .= ", `end_date` = '{$subject['end_date']}' ";
                $sqll .= ", `subscription_type` = '{$subject['subscription_type']}' ";
                $sqll .= ", `year_title` = '{$subject['year_title']}' ";
                $sqll .= ", `cost` = '{$subject['cost']}' ";
                $sqll .= ", `status` = '0' ";
                $sqll .= ", `cost_type` = '{$cost_type}' ";
                $sqll .= ", `set_from` = '{$subject['set_from']}' ";
                $sqll .= ", `fawry_payment_transaction_id` = '{$id}'";
                // echo 
                $res = $this->mDb->query($sqll);
            }
        }
        if($res && $id){
            return $id;
        }else{
            return false;
        }
    }
    
    function insertTransactionPaymentForCourse($transactionData, $payment_gateway){
        $temp = $this->convert_object_to_array(json_decode($transactionData['subscription']));
        $table = $payment_gateway."_transactions";
        $sql = "INSERT INTO " . $table . " SET ";
        foreach ($this->mDb->getCols($table, $transactionData) as $k => $v) {
            $sql .= ($k == 'cat_name') ? ' ' : "{$k}='{$v}',";
        }
        $sql .= "date_added='{$this->dateTime}'";
        //  echo $sql;die();
        $trans_id = $this->mDb->queryReturnLastId($sql);
        
        if(!$trans_id){
            return false;
        }
        
        $transaction_id = $payment_gateway == 'vodafone_cash' ? $payment_gateway . "_payment" : $payment_gateway;
        $transaction_table = $transaction_id . "_transaction_id";
        $sql = "INSERT INTO course_subscriptions SET ";
        $sql .= "  user_id = '{$temp['user_id']}' ";
        $sql .= " , course_id = '{$temp['course_id']}' ";
        $sql .= " , course_cost = '{$temp['course_cost']}' ";
        $sql .= " , status = '0' ";
        $sql .= " , " . $transaction_table . " = '{$trans_id}' ";
        // echo $sql;die();
        $course_sub_id = $this->mDb->query($sql);
        if(!$course_sub_id){
            $sql = "DELETE " . $table . " WHERE id = '{$trans_id}' ";
            $this->mDb->qury($sql);
            return false;  
        }   
    if($trans_id && $course_sub_id){
        return true;
    }else{
        return false;
    }
    }

private function insertTeacherCredits($teacher_id, $student_id, $course_id, $type, $amount) {
    $sql = "INSERT INTO `teacher_credits` SET ";
    $sql .= "`teacher_id` = '{$teacher_id}', ";
    if ($student_id) {
        $sql .= "`student_id` = '{$student_id}', ";
    }
    $sql .= "`course_id` = '{$course_id}', ";
    $sql .= "`type` = '{$type}', ";
    $sql .= "`status` = '1', ";
    $sql .= "`teacher_amount` = '{$amount}'";
    
    $res = $this->mDb->query($sql);
    if(!$res){
        throw new Exception("Failed to insert into teacher_credits");
    }
}

private function rollbackInsertedData($transactionTable, $trans_id, $subscriptionTable, $course_sub_id) {
    if ($trans_id) {
        $this->mDb->query("DELETE FROM `{$transactionTable}` WHERE id = '{$trans_id}'");
    }
    if ($course_sub_id) {
        $this->mDb->query("DELETE FROM `{$subscriptionTable}` WHERE id = '{$course_sub_id}'");
    }
}

    
    
    
    
    
    function insertToVodafoneCashTransactionPaymentLog($temp)
    {
        
        $subjects = $this->convert_object_to_array(json_decode($temp['subscription']));
        $sql = "INSERT INTO `vodafone_cash_transactions` SET ";
        foreach ($this->mDb->getCols('vodafone_cash_transactions', $temp) as $k => $v) {
            $sql .= ($k == 'cat_name') ? ' ' : "{$k}='{$v}',";
        }
        $sql .= "date_added='{$this->dateTime}'";
        //  echo $sql;die();
        $id = $this->mDb->queryReturnLastId($sql);
        $cost_type = strtolower($temp['payment_status']);
        if($id){
            foreach($subjects['subjects'] as $key => $subject){
                $sqll = "INSERT INTO `users_subjects_subscriptions` SET ";
                $sqll .= " `user_id` = '{$temp['user_id']}' ";
                $sqll .= ", `subject_id` = '{$subject['subject_id']}' ";
                $sqll .= ", `start_date` = '{$subject['start_date']}' ";
                $sqll .= ", `end_date` = '{$subject['end_date']}' ";
                $sqll .= ", `subscription_type` = '{$subject['subscription_type']}' ";
                $sqll .= ", `year_title` = '{$subject['year_title']}' ";
                $sqll .= ", `cost` = '{$subject['cost']}' ";
                $sqll .= ", `status` = '0' ";
                $sqll .= ", `cost_type` = '{$cost_type}' ";
                $sqll .= ", `set_from` = '{$subject['set_from']}' ";
                $sqll .= ", `vodafone_cash_payment_transaction_id` = '{$id}'";
                
                $res = $this->mDb->query($sqll);
            }
        }
        if($res && $id){
            return $id;
        }else{
            return false;
        }
    }

    function insertToPaymobTransactionPaymentLog($temp)
    {
        // print_r($temp);dei();
        $subjects = $this->convert_object_to_array(json_decode($temp['subscription']));
        $sql = "INSERT INTO `paymob_payment_transactions` SET ";
        foreach ($this->mDb->getCols('paymob_payment_transactions', $temp) as $k => $v) {
            $sql .= ($k == 'cat_name') ? ' ' : "{$k}='{$v}',";
        }
        $sql .= "date_added='{$this->dateTime}'";
         $id = $this->mDb->queryReturnLastId($sql);
        $cost_type = strtolower($temp['payment_status']);
        if($id){
            foreach($subjects['subjects'] as $key => $subject){
                $sqll = "INSERT INTO `users_subjects_subscriptions` SET ";
                $sqll .= " `user_id` = '{$temp['user_id']}' ";
                $sqll .= ", `subject_id` = '{$subject['subject_id']}' ";
                $sqll .= ", `start_date` = '{$subject['start_date']}' ";
                $sqll .= ", `end_date` = '{$subject['end_date']}' ";
                $sqll .= ", `subscription_type` = '{$subject['subscription_type']}' ";
                $sqll .= ", `year_title` = '{$subject['year_title']}' ";
                $sqll .= ", `cost` = '{$subject['cost']}' ";
                $sqll .= ", `status` = '0' ";
                $sqll .= ", `cost_type` = '{$cost_type}' ";
                $sqll .= ", `set_from` = '{$subject['set_from']}' ";
                $sqll .= ", `paymob_payment_transaction_id` = '{$id}'";
                
                $res = $this->mDb->query($sqll);
            }
        }
        if($res && $id){
            return $id;
        }else{
            return false;
        }
    }


    function getTeacherGuides($temp)
    {
        $sql = "SELECT f.id  ,f.img ,f.file , fl.description  , fl.`title`  FROM `teacher_guide` f ";
        $sql .= "LEFT JOIN `teacher_guide_langs` fl ON ( f.`id` = fl.`teacher_guide_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`subject_id` ='{$temp['subject_id']}' AND  (f.`semester` ='{$temp['semester']}' ||  f.`semester` ='both' )  AND f.`status` ='1'  AND   f.is_deleted !='1' ";
        // echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getDetailsTeacherGuidesById($temp)
    {
        $sql = "SELECT f.id  ,f.img ,f.file , fl.description  , fl.`title`  FROM `teacher_guide` f ";
        $sql .= "LEFT JOIN `teacher_guide_langs` fl ON ( f.`id` = fl.`teacher_guide_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`id` ='{$temp['id']}' ";
        //echo $sql;
        return $this->mDb->getRow($sql);
    }


    function getPreparationNotebook($temp)
    {
        $sql = "SELECT f.id  ,f.img ,f.file , fl.description  , fl.`title`  FROM `preparation_notebook` f ";
        $sql .= "LEFT JOIN `preparation_notebook_langs` fl ON ( f.`id` = fl.`preparation_notebook_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`subject_id` ='{$temp['subject_id']}' AND  (f.`semester` ='{$temp['semester']}' ||  f.`semester` ='both' )  AND f.`status` ='1'  AND   f.is_deleted !='1' ";

        //echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getDetailsPreparationNotebookById($temp)
    {
        $sql = "SELECT f.id  ,f.img ,f.file , fl.description  , fl.`title`  FROM `preparation_notebook` f ";
        $sql .= "LEFT JOIN `preparation_notebook_langs` fl ON ( f.`id` = fl.`preparation_notebook_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
        $sql .= "where  f.`id` ='{$temp['id']}' ";
        return $this->mDb->getRow($sql);
    }

    function getAllCoursesBySubjectId($temp)
    {
        $sql = "SELECT  
            u.full_name as teacher_name,
            f.id,
            f.img,
            fl.description,
            fl.`name`,
            f.paid,
            f.amount,
            f.status,
            cf.id as favorit,
            vc.status as video_Status,
            TIME_FORMAT(SEC_TO_TIME(SUM(TIME_TO_SEC(STR_TO_DATE(vc.time, '%H:%i:%s')))), '%H:%i:%s') AS time,
            COUNT(vc.id) AS count_of_videos,
            CASE WHEN cf.id IS NOT NULL THEN 1 ELSE 0 END AS is_favorite
        FROM
            `courses` f
        LEFT JOIN
            `courses_langs` fl ON (f.`id` = fl.`course_id` AND fl.`lang_code` = :language)
        LEFT JOIN
            `users` u ON (u.`id` = f.`added_by`)
        LEFT JOIN
            `videos_courses` vc ON (vc.`course_id` = f.`id` AND vc.is_deleted != '1')
        LEFT JOIN
            `courses_favorites` cf ON (cf.`course_id` = f.`id` AND cf.user_id = '{$temp['user_id']}')
        WHERE f.set_from = 'teacher' AND f.`is_deleted` = '0' AND f.status = '1' ";


        // Conditional parts of the query
        if (!empty($temp['subject_id'])) {
            $sql .= " AND f.`subject_id` = :subject_id";
        }


        $sql .= " GROUP BY f.id";
        //   echo $sql;die();
        // Preparing the statement
        $stmt = $this->mDb->prepare($sql);
        $languageValue = LANGUAGE; // Adjust this line if LANGUAGE is already a variable
        $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);


        $subject_id = $temp['subject_id']; // Adjust this line if $temp['id'] is already a variable
        $stmt->bindParam(':subject_id', $subject_id, PDO::PARAM_INT);
        $stmt->bindParam(':subject_id', $subject_id, PDO::PARAM_INT);

        // Execute the query with the parameters
        $stmt->execute($params);

        // Fetching all courses
        $courses = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $data = [] ;
       
            foreach($courses as $course){
                // if($course['count_of_videos'] > 0)
                //     $data[] = $course;
                $sql = "SELECT status FROM `videos_courses` WHERE course_id = '{$course['id']}'";
                $vds = $this->mDb->getAll($sql);{
                    if(count($vds) > 0){
                        foreach($vds as $vd){
                          if($vd['status'] == '1'){
                              $data[] = $course;
                              break;
                          }  
                        }
                        
                    }
                }
            }
        return $data;

    }


    function getAllCoursesForTeacher($temp)
    {

        $sql = "SELECT  
            u.full_name as teacher_name,
            f.id,
            f.img,
            f.`group`,
            fl.description,
            fl.`name`,
            f.paid,
            f.grade_id,
            f.stage_id ,
            f.semester,
            f.amount,
             f.subject_id,
            cf.id as favorit,
            f.status,
             COALESCE(vc_videos.total_video_time, 0) AS time, 
            COALESCE(vc_videos.count_of_videos, 0) AS count_of_videos,
            CASE WHEN cf.id IS NOT NULL THEN 1 ELSE 0 END AS is_favorite
        FROM
            `courses` f
        LEFT JOIN
            `courses_langs` fl ON (f.`id` = fl.`course_id` AND fl.`lang_code` = ?)
        LEFT JOIN
            `users` u ON (u.`id` = f.`added_by`)
        LEFT JOIN (
            SELECT 
                vc.`course_id`, 
                 TIME_FORMAT(SEC_TO_TIME(SUM(TIME_TO_SEC(STR_TO_DATE(vc.time, '%H:%i:%s')))), '%H:%i:%s') AS total_video_time,

                COUNT(vc.id) AS count_of_videos 
            FROM 
                `videos_courses` vc 
            WHERE 
                vc.`is_deleted` != '1'
            GROUP BY 
                vc.`course_id`
        ) AS vc_videos ON vc_videos.`course_id` = f.`id`
        LEFT JOIN
            `courses_favorites` cf ON (cf.`course_id` = f.`id` AND cf.user_id = f.added_by)
        WHERE f.set_from = 'teacher' AND f.`is_deleted` = '0' ";


        // Conditional parts of the query
        if (!empty($temp['subject_id'])) {
            $sql .= " AND f.`subject_id` = ?";
        }
        if (!empty($temp['user_id'])) {
            $sql .= " AND f.`added_by` = ?";
        }

        $sql .= " GROUP BY f.id ORDER BY f.id DESC";
// echo $sql;die();
        // Preparing the statement
        $stmt = $this->mDb->prepare($sql);

        // Binding parameters
        $params = [LANGUAGE]; // Start with LANGUAGE as the first parameter
        if (!empty($temp['subject_id'])) {
            $params[] = $temp['subject_id'];
        }
        if (!empty($temp['user_id'])) {
            $params[] = $temp['user_id'];
        }

        // Execute the query with the parameters
        $stmt->execute($params);
//        echo $stmt->debugDumpParams();
        // Fetching all courses
        $courses = $stmt->fetchAll(PDO::FETCH_ASSOC);

        return $courses;

    }

    function getDetailsCoursesInfo($temp)
    {
// print_r($temp);die();
        $sql = "SELECT 
            c.set_from,
            c.id AS course_id, 
            c.subject_id , 
            cl.name AS course_name, 
            cl.description AS course_desc, 
            c.paid AS course_paid, 
            c.amount AS course_amount, 
            c.img AS course_img, 
            cf.id AS favorit, 
            CASE WHEN cf.id IS NOT NULL THEN 1 ELSE 0 END AS is_favorite, 
            s.subject_direction, 
            COALESCE(vc_videos.total_video_time, 0) AS total_video_time, 
            COALESCE(vc_videos.count_of_videos, 0) AS count_of_videos 
        FROM 
            `courses` c 
        LEFT JOIN 
            `courses_langs` cl ON cl.`course_id` = c.`id` AND cl.`lang_code` = :language 
        LEFT JOIN 
            `subjects` s ON s.`id` = c.`subject_id` 
        LEFT JOIN 
            `courses_favorites` cf ON cf.`course_id` = c.`id` AND cf.user_id = c.added_by 
        LEFT JOIN (
            SELECT 
                vc.`course_id`, 
                 TIME_FORMAT(SEC_TO_TIME(SUM(TIME_TO_SEC(STR_TO_DATE(vc.time, '%H:%i:%s')))), '%H:%i:%s') AS total_video_time,

                COUNT(vc.id) AS count_of_videos 
            FROM 
                `videos_courses` vc 
            WHERE 
                vc.`is_deleted` != '1'
            GROUP BY 
                vc.`course_id`
        ) AS vc_videos ON vc_videos.`course_id` = c.`id` 
        WHERE 
            c.`subject_id` = :subject_id AND c.`is_deleted` = '0' AND c.`set_from` = :set_from ";
    if($temp['subject_branch_id']){
        $sql .= " AND subject_branch_id = '{$temp['subject_branch_id']}' ";
    }
    $sql .="
        GROUP BY 
            c.id, cl.name, cl.description, c.paid, c.amount, c.img, cf.id, s.subject_direction";

        $stmt = $this->mDb->prepare($sql);
// echo $sql;die();
        // Ensure LANGUAGE is stored in a variable if it's not already
        $languageValue = LANGUAGE; // Adjust this line if LANGUAGE is already a variable
        $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);
        $admin_area = "admin-area";
         $stmt->bindParam(':set_from', $admin_area);

        // Ensure $temp['id'] is stored in a variable if it's not already
        $subject_id = $temp['id']; // Adjust this line if $temp['id'] is already a variable
        $stmt->bindParam(':subject_id', $subject_id, PDO::PARAM_INT);
    // echo $stmt->execute();die();
        $stmt->execute();
        $courses = $stmt->fetch(PDO::FETCH_ASSOC);
        $courses['course_desc'] = strip_tags($courses['course_desc']);
// print_r($courses);die();
        return $courses;
    }

    function getDetailsCoursesInfoByCourseId($temp)
    {
       
        // print_r($temp);die();
        $sql = "SELECT 
            c.id AS course_id, 
            c.subject_id , 
            c.status, 
            c.stage_id,
            c.grade_id,
            c.group,
            c.semester,
            cl.name AS course_name, 
            cl.description AS course_desc, 
            c.paid AS course_paid, 
            c.amount AS course_amount, 
            c.img AS course_img, 
            cf.id AS favorit, 
            CASE WHEN cf.id IS NOT NULL THEN 1 ELSE 0 END AS is_favorite, 
            s.subject_direction, 
            COALESCE(vc_videos.total_video_time, 0) AS total_video_time, 
            COALESCE(vc_videos.count_of_videos, 0) AS count_of_videos 
        FROM 
            `courses` c 
        LEFT JOIN 
            `courses_langs` cl ON cl.`course_id` = c.`id` AND cl.`lang_code` = :language 
        LEFT JOIN 
            `subjects` s ON s.`id` = c.`subject_id` 
        LEFT JOIN 
            `courses_favorites` cf ON cf.`course_id` = c.`id` AND cf.user_id = c.added_by 
        LEFT JOIN (
            SELECT 
                vc.`course_id`, 
                 TIME_FORMAT(SEC_TO_TIME(SUM(TIME_TO_SEC(STR_TO_DATE(vc.time, '%H:%i:%s')))), '%H:%i:%s') AS total_video_time,

                COUNT(vc.id) AS count_of_videos 
            FROM 
                `videos_courses` vc 
                LEFT JOIN `units` u ON u.id = vc.unit_id_explain
                LEFT JOIN `unit_lessons` ul ON ul.id = vc.lesson_id_explain
            WHERE 
                vc.`is_deleted` != '1' AND u.`is_deleted` != '1' AND ul.`is_deleted` != '1' ";
                
        // $sql .= $temp['user_type'] == 'student' ? "AND vc.status = '1'":"";
        
        $sql .= "
            GROUP BY 
                vc.`course_id`
        ) AS vc_videos ON vc_videos.`course_id` = c.`id` 
        WHERE 
            c.`id` = :courseId AND c.`is_deleted` = '0'  AND c.`set_from` = 'teacher'
        GROUP BY 
            c.id, cl.name, cl.description, c.paid, c.amount, c.img, cf.id, s.subject_direction";
// echo $sql;die();


        $stmt = $this->mDb->prepare($sql);
        // Ensure LANGUAGE is stored in a variable if it's not already
        $languageValue = LANGUAGE; // Adjust this line if LANGUAGE is already a variable
        $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);

        // Ensure $temp['id'] is stored in a variable if it's not already
        $courseIdValue = $temp['id']; // Adjust this line if $temp['id'] is already a variable
        $stmt->bindParam(':courseId', $courseIdValue, PDO::PARAM_INT);

        $stmt->execute();
//        $stmt->debugDumpParams();
        $courses = $stmt->fetch(PDO::FETCH_ASSOC);
        /*        if (!empty($courses)):
                    $data = array("user_id" => $temp['user_id'], "course_id" => $temp['id']);
                    $idCourseSubscription = $this->checkUserSubscriptionToCourse($data);
                    $courses['status_user_subscription_in_course'] = $idCourseSubscription ? true : false;
                endif;*/
                
        return $courses;
    }

    function getDetailsCoursesBySubjectId($temp)
    {
        
        // print_r($temp);die();
        $sql = "SELECT vc.course_id, vc.id,vc.sort, vc.title,vc.time,vc.paid, vc.status FROM `videos_courses` vc "; ///,(SELECT `t`.`paid` FROM `tests`  t WHERE `t`.`id` =`vc`.`exercise_id` ) exercise_paid_status
        $sql .= "where  vc.`unit_id_explain` ='{$temp['id']}' AND  vc.`is_deleted` = '0'  AND vc.`lesson_id_explain` = '{$temp['lesson_id_explain']}'";
        // $sql .= $temp['user_type'] == 'student' ? " AND vc.`status` = '1'":"";
        $sql .= " ORDER BY `vc`.`sort` ASC";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $hours = 0;
        for ($i = 0; $i < count($res); $i++) {
            $obj = array(
                'id' => $res[$i]['id'],
                'course_id' => $temp['course_id'],
                'user_id' => $temp['user_id']
            );
            
            $duration = explode(":", $res[$i]['time']);
            $total_time = ($duration[0] * 60 * 60) + ($duration[1] * 60) + $duration[2];
            $dta = $this->checkVideoViewRate($obj);
           $res[$i]['videoViewRate'] = empty($dta) || !$total_time ? "0" : ($total_time > 0 ? round(($dta['percentage'] / $total_time) * 100) : "0");
            $hours += $total_time / 60;
            $res[$i]['hours'] = sprintf("%.2f", $hours);
            
            // if($temp['user_type'] == 'student' && $res[$i]['status'] == '0'){
                
            // }
        }
        // print_r($res);
        // die();
        return $res;
    }
    
    
    function getDetailsCoursesBySubjectIdForTestatCourses($temp)
    {
        
        // print_r($temp);die();
        $sql = "SELECT vc.course_id, vc.id,vc.sort, vc.title,vc.time,vc.paid, vc.status, vc.`lesson_id_explain` FROM `videos_courses` vc "; ///,(SELECT `t`.`paid` FROM `tests`  t WHERE `t`.`id` =`vc`.`exercise_id` ) exercise_paid_status
        $sql .= "where  vc.`unit_id_explain` ='{$temp['id']}' AND  vc.`is_deleted` = '0'  AND vc.`lesson_id_explain` = '{$temp['lesson_id_explain']}'";
        $sql .= " AND vc.set_from = 'admin-area' ";
        $sql .= " ORDER BY  `vc`.`sort` ASC";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $hours = 0;
        for ($i = 0; $i < count($res); $i++) {
            $obj = array(
                'id' => $res[$i]['id'],
                'course_id' => $temp['course_id'],
                'user_id' => $temp['user_id']
            );
            
            $duration = explode(":", $res[$i]['time']);
            $total_time = ($duration[0] * 60 * 60) + ($duration[1] * 60) + $duration[2];
            $dta = $this->checkVideoViewRate($obj);
           $res[$i]['videoViewRate'] = empty($dta) || !$total_time ? "0" : ($total_time > 0 ? round(($dta['percentage'] / $total_time) * 100) : "0");
            $hours += $total_time / 60;
            $res[$i]['hours'] = sprintf("%.2f", $hours);
            
            // if($temp['user_type'] == 'student' && $res[$i]['status'] == '0'){
                
            // }
        }
        // print_r($res);
        // die();
        return $res;
    }

    function countVideosToCoursesBySubjectId($temp)
    {
        // print_r($temp);die();
        
        $sql = "SELECT count(vc.id) FROM `videos_courses` vc ";
        $sql .= "where  vc.`unit_id_explain` ='{$temp['id']}' AND vc.`is_deleted` != '1'";//AND course_id = '{$temp['course_id']}'
        // $sql .= $temp['user_type'] == 'student' ? "AND vc.`status` = '1'":"";
        $sql .= $temp['lesson_id_explain'] > 0 ? "AND vc.`lesson_id_explain` = '{$temp['lesson_id_explain']}' " : "";
        // if($temp['lesson_id_explain'] > 0){
        //         echo $sql;die();
            
        // }
        return $this->mDb->getOne($sql);
    }
    
    function countVideosToCoursesBySubjectIdForTestatCourses($temp)
    {
        // print_r($temp);die();
        
        $sql = "SELECT count(vc.id) FROM `videos_courses` vc ";
        $sql .= "where  vc.`unit_id_explain` ='{$temp['id']}' AND vc.`is_deleted` != '1' AND set_from = 'admin-area'";
        $sql .= $temp['lesson_id_explain'] > 0 ? "AND vc.`lesson_id_explain` = '{$temp['lesson_id_explain']}' " : "";
        //echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    

    public function getAllUnitsBySubjectId($temp)
    {
        // print_r($temp);die();
        $sql  = "SELECT f.id  ,f.name   FROM `units` f ";
        // $sql .= " LEFT JOIN `courses` c ON c.subject_id = f.subject_id ";
        $sql .= "where  f.`subject_id` ='{$temp['id']}' AND f.`mode`='explanations' AND f.`is_deleted` = '0'  ";//AND c.id = '{$temp['course_id']}'
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }
    
    public function getAllUnitsBySubjectIdForTestatCourses($temp)
    {
        // print_r($temp);die();
        $sql  = "SELECT f.id  ,f.name   FROM `units` f ";
        $sql .= "where  f.`subject_id` ='{$temp['id']}' AND f.`mode`='explanations' AND f.`is_deleted` = '0'  ORDER BY f.sort";//AND f.course_id = '{$temp['course_id']}'
        // echo $sql;die();
        $units = $this->mDb->getAll($sql);
        // echo count($units);die();
        return $units;
    }

    public function getAllUnitsByCourseId($temp)
    {
        $sql = "SELECT f.id  ,f.name   FROM `units` f ";
        $sql .= "where  f.`course_id` ='{$temp['id']}' AND f.`mode`='explanations' AND f.`is_deleted` = '0' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    // public function getAllLessonInUnitsById($temp)
    // {
    //     $sql = "SELECT COUNT(vc.id) AS videos_count, f.id  ,f.name   FROM `unit_lessons` f ";
    //     $sql .= " LEFT JOIN `videos_courses` vc ON vc.lesson_id_explain = f.id ";
    //     $sql .= " where  f.`unit_id` ='{$temp['id']}' AND is_deleted != '1' HAVING videos_count > 0 ";
    //     // return $sql;
    //     return $this->mDb->getAll($sql);
    // }
    
    public function getAllLessonInUnitsById($temp)
    {
        $sql = "SELECT f.id  ,f.name   FROM `unit_lessons` f ";
        $sql .= "where  f.`unit_id` ='{$temp['id']}' AND is_deleted != '1'";
        // return $sql;
        return $this->mDb->getAll($sql);
    }

    public function getNameExercise($id)
    {
        $sql = "select vt.test_type, vt.unit_id, vt.lesson_id, vt.exercise_id as unit_exercise_id, t.name as exercise_name from `videos_tests` vt LEFT JOIN `tests` t ON vt.`exercise_id` = t.`id`";
        $sql .= " where vt.`video_id` = '{$id}'";
            // echo($sql);die();
        return $this->mDb->getAll($sql);
    }

    function getDetailsvideoById($data)
    {
        $sql  = "SELECT vc.*, cl.name AS course_name, s.name AS subject_name, c.amount FROM `videos_courses` vc ";
        $sql .= " LEFT JOIN `courses` c ON c.id = vc.course_id ";
        $sql .= " LEFT JOIN `courses_langs` cl ON cl.course_id = vc.course_id ";
        $sql .= " LEFT JOIN `subjects` s ON s.id = c.subject_id ";
        $sql .= " WHERE vc.`id` = '{$data['id']}'";
        // echo $sql; die();
        $result = $this->mDb->getRow($sql);
        // print_r($result);die();
        $result['no_show'] = false;
        
        // $sql = "SELECT id FROM `course_subscriptions` WHERE `course_id` = '{$result['course_id']}' AND `user_id` = '{$data['user_id']}'";
        // $subs_id = $this->mDb->getOne($sql);
        
        // if(!$subs_id && $result['paid']){
        //     $result['show_status'] = true;
        // }
        
        if (!empty($result)){
            $result['unit_name'] = $this->getNameItem('name', 'units', 'id', $result['unit_id_explain']);
            $result['lesson_name'] = $this->getNameItem('name', 'unit_lessons', 'id', $result['lesson_id_explain']);
            $result['exercises'] = $this->getNameExercise($result['id']);

            $obj = array(
                'id' => $result['id'],
                'course_id' => $result['course_id'],
                'user_id' => $data['user_id']
            );

            $duration = explode(":", $result['time']);
            $total_time = ($duration[0] * 60 * 60) + ($duration[1] * 60) + $duration[2];

            $dta = $this->checkVideoViewRate($obj);
            // echo $total_time;die();
            $result['videoViewRate'] = empty($dta) || !$total_time ? "0" : round(($dta['percentage'] / $total_time) * 100);
            $result['allAttachvideosInCourses'] = $this->allAttachvideosInCourses($result['id']);
            $result['allComments'] = $this->getAllCommentsInVideoById($data);
            // $result['allInquiries'] = [];
        }

        $_obj['course_id'] = $result['course_id'];

        $sql = "SELECT  ";
        $sql .= " (SELECT s.id FROM `subjects` as s  WHERE c.subject_id = s.id) AS subject_id ";
        $sql .= " FROM courses c  ";
        $sql .= " where c.id = '{$_obj['course_id']}'";
        // echo $sql;die();
        $res = $this->mDb->getOne($sql);
        $result['subject_id'] = $res;

        return $result;
    }

    function getNextAndPreviuos($data, $user_type='student')
    {
        $sql = "SELECT `id` FROM `videos_courses` ";
        $sql .= "WHERE course_id = '{$data['course_id']}' AND is_deleted != '1' AND set_from = 'admin-area' ";
        $sql .= $user_type == "student" ? "AND `status` = '1' " : "";
        $sql .= "ORDER BY unit_id_explain ASC, lesson_id_explain ASC, sort ASC";
        
        // Execute the query and get all matching video IDs
        $res = $this->mDb->getAll($sql);
        $arr = array_column($res, "id");
        
        // Find the index of the current video ID in the list
        $currentId = array_search($data['id'], $arr);
        
        // Initialize result array with null values
        $result = ['next' => null, 'previous' => null];
        
        // Check if a next video exists
        if (isset($arr[$currentId + 1])) {
            $nextId = $arr[$currentId + 1];
            $result['next'] = $this->mDb->getRow("SELECT id, paid FROM `videos_courses` WHERE id = '{$nextId}'");
        }
        
        // Check if a previous video exists
        if (isset($arr[$currentId - 1])) {
            $prevId = $arr[$currentId - 1];
            $result['previous'] = $this->mDb->getRow("SELECT id, paid FROM `videos_courses` WHERE id = '{$prevId}'");
        }
        
        // Output the result for debugging
        // print_r($result);
        // die();

        
        return $result;
        
        // print_r($result);die();
        // $sql = "SELECT `id`, `paid` FROM `videos_courses` ";
        // $sql .= "WHERE (sort > '{$data['sort']}' OR (`sort` = '{$data['sort']}' AND `id` > '{$data['id']}')) AND `course_id` = '{$data['course_id']}' AND `is_deleted` != '1' ";
        // $sql .= " AND (unit_id_explain = '{$data['unit_id_explain']}' OR unit_id_explain > '{$data['unit_id_explain']}') AND (lesson_id_explain = '{$data['lesson_id_explain']}' OR lesson_id_explain > '{$data['lesson_id_explain']}')";
        // $sql .= $user_type == "student" ? "  AND `status` = '1' " :"";
        // $sql .= " ORDER BY  unit_id_explain ASC, lesson_id_explain ASC, sort ASC LIMIT 1";
        // // echo $sql;die();
        // $result['next'] = $this->mDb->getRow($sql);

        // $sql = "SELECT `id`, `paid` FROM `videos_courses` ";
        // $sql .= "WHERE (sort < '{$data['sort']}' OR (`sort` = '{$data['sort']}' AND `id` < '{$data['id']}'))  AND `course_id` = '{$data['course_id']}'AND `is_deleted` != '1' ";
        // $sql .= " AND (unit_id_explain = '{$data['unit_id_explain']}' OR unit_id_explain < '{$data['unit_id_explain']}') AND (lesson_id_explain = '{$data['lesson_id_explain']}' OR lesson_id_explain < '{$data['lesson_id_explain']}')";
        // $sql .= $user_type == "student" ? "  AND `status` = '1' " :"";
        // $sql .= " ORDER BY  unit_id_explain DESC, lesson_id_explain DESC, sort DESC LIMIT 1";
        // // echo $sql;die();
        // $result['previous'] = $this->mDb->getRow($sql);

        // return $result;

    }

    function allAttachvideosInCourses($id)
    {

        $sql = "SELECT * FROM `videos_attachments_courses`";
        $sql .= " WHERE `video_id` = '{$id}'";
        return $this->mDb->getAll($sql);
    }

    function getNameItem($column_name, $table, $column_case_name, $column_case)
    {
        $sql = "SELECT `{$column_name}` FROM `{$table}` ";
        $sql .= " WHERE `{$column_case_name}` = '{$column_case}'";
        return $this->mDb->getOne($sql);

    }

    function updateViewVideoById($items)
    {
        $sql = "UPDATE  `videos_courses` SET `views`=1+views";
        $sql .= " WHERE   `id`='{$items['id']}'  AND `status` = '1'";
        return $this->mDb->query($sql);
    }

    function addCommentsTovideoById($items)
    {
        $sql = "INSERT INTO `videos_comments` SET ";
        $sql .= "`video_id`='{$items['video_id']}' ,`comment`='{$items['comment']}',`user_id`='{$items['user_id']}',";
        $sql .= $items['parent'] != 0 ? " parent = '{$items['parent']}', " : "`parent` = '0',";
        $sql .= " `status`='{$this->mConfig['comments_status']}' ,date_added='{$this->dateTime}'";
        //   echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }

    function replyCommentById($items)
    {
        $sql = "INSERT INTO `videos_comments` SET ";
        $sql .= "`video_id`='{$items['id']}' ,`comment`='{$items['comment']}',`user_id`='{$items['user_id']}', `parent`='{$items['parent']}',";
        $sql .= " `status`='{$this->mConfig['comments_status']}' ,";
        $sql .= " `parent`='{$items['comment_id']}' ,date_added='{$this->dateTime}'";
        //   echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }

    function getCommentVedioById($id)
    {
        $sql = "SELECT vc.*, u.full_name as username, u.img as avatar FROM `videos_comments` vc ";
        $sql .= "LEFT JOIN `users` u ON u.id = vc.user_id";
        $sql .= " WHERE vc.`id` = '{$id}'";
        return $this->mDb->getRow($sql);

    }

    function deleteCommentById($data)
    {
        $sql = "DELETE FROM `videos_comments` ";
        $sql .= " WHERE `id` = '{$data['id']}'";
        return $this->mDb->query($sql);

    }

    function getAllCommentsInVideoById($data)
    {
        $sql = "SELECT vc.* , u.img as avatar, u.full_name as username  FROM `videos_comments` vc ";
        $sql .= " LEFT JOIN `users` u ON vc.user_id = u.id";
        $sql .= " WHERE (((vc.`video_id` = '{$data['id']}' AND vc.`status`='0')||(vc.`video_id` = '{$data['id']}' AND vc.`user_id`='{$data['user_id']}' AND (vc.`status`='0' ||  vc.`status`='1')) ) AND vc.`parent`='0')";
        $sql .= " ORDER BY vc.`status` DESC ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['statusName'] = $res[$i]['status'] > 0 ? "pending" : "published";
            $res[$i]['allReply'] = $this->getAllReplyCommentsInVideoById($res[$i]);
        }
        return $res;
    }

    function getAllReplyCommentsInVideoById($data)
    {
        $sql = "SELECT vc.*, u.img as avatar, u.full_name as username FROM `videos_comments` vc LEFT JOIN `users` u ON u.id = vc.user_id";
        $sql .= " WHERE ((vc.`parent` = '{$data['id']}' AND vc.`status`='0')||(vc.`parent` = '{$data['id']}' AND vc.`user_id`='{$data['user_id']}' AND (vc.`status`='0' ||  vc.`status`='1')))";
        $sql .= " ORDER BY vc.`status` DESC ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['statusName'] = $res[$i]['status'] > 0 ? "pending" : "published";
        }
        return $res;
    }

    function addInquiriesToVideoById($items)
    {
        $sql = "INSERT INTO `videos_inquiries` SET ";
        $sql .= "`video_id`='{$items['id']}',`user_from`='{$items['user_id']}',";
        $sql .= " `user_to`='{$items['user_to']}',`read_from`='{$items['read_from']}',`content`='{$items['content']}'";
        $id = $this->mDb->queryReturnLastId($sql);
        if ($id) {
            $this->SendEmailToTheAdministrationForAddedInquiryAtThisStage($items);
        }
        return $id;
    }

    function SendEmailToTheAdministrationForAddedInquiryAtThisStage($Req)
    {

        $getStage = $this->getDetailsvideoById($Req);
        if ($getStage) {
            $_obj['id'] = $getStage['course_id'];
            $getDataCourses = $this->getCourseInfoById($_obj);
            if ($getDataCourses) {
                $_dataStage = array(
                    'country_id' => $getDataCourses['country_id'],
                    'stage_id' => $getDataCourses['stage_id']
                );
                $getAllEmailsByData = $this->getAllEmailsByStageId($_dataStage);
                if ($getAllEmailsByData) {
                    for ($i = 0; $i < count($getAllEmailsByData); $i++) {
                        $to = $getAllEmailsByData[$i]['user_email'];
                        $from = "noreply@testat-app.com";
                        $subject = "Respond to members' inquiries";
                        $headers = "From: Testat <$from>\r\n";
                        $headers .= "Reply-To:<$to>\r\n";
                        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
                        $username = $this->getNameItem('full_name', 'users', 'id', $Req["user_id"]);


                        $message = <<<EOT
        <div style="margin: auto;
    width: 500px;
    text-align: end;
    line-height: 1.7;
    font-size: 20px;">
 <h4 style="padding:10px">Dear, {$getAllEmailsByData[$i]["user_name"]} </h4>
    <p style="padding:10px">The member <span style="color:gray">{$username}</span>  added an inquiry to the video title <br/> - <span style="color:gray">{$getStage["title"]}</span> - <br/>
   which you can respond to by clicking on the link <a href="https://admin-area.testat-app.com/video_inquiries/all-video-inquiries?From={$Req["id"]}&To={$Req["user_id"]}&Use={$username}&Ti={$getStage["title"]}" target="blank" style="padding:10px"> Go now link </a>
</p> </div>
EOT;

                        mail($to, $subject, $message, $headers);

                    }
                }
            }
        }


    }

    function getAllEmailsByStageId($data)
    {
        $sql = "SELECT user_name,user_email FROM `admins_email` ";
        $sql .= " WHERE `country_id` = '{$data['country_id']}' AND `stage_id`='{$data['stage_id']}'";
        // echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getInquirieVedioById($id)
    {
        $sql = "SELECT * FROM `videos_inquiries` ";
        $sql .= " WHERE `id` = '{$id}'";
        return $this->mDb->getRow($sql);

    }

    function getAllInquiriesInVideoChat($data)
    {
        $sql = "SELECT p.id,p.video_id,u.full_name AS 'user_full_name',p.user_from,p.user_to,p.date_added,p.content";
        $sql .= " FROM `videos_inquiries` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}' AND (`p`.`user_from`='{$data['user_from']}' ||  `p`.`user_to`='{$data['user_from']}')";
        $sql .= " ORDER BY date_added ASC";
        //echo $sql;
        return $this->mDb->getAll($sql);
    }

    function getCourseInfoById($data)
    {
        $sql = "SELECT c.*,fl.description,fl.`name` FROM `courses` c  ";
        $sql .= "LEFT JOIN `courses_langs` fl ON (c.`id` = fl.`course_id` AND fl.`lang_code` ='" . LANGUAGE . "')";
        $sql .= " WHERE c.`id` > 0 AND c.id='{$data['id']}'";
//        echo $sql;
        return $this->mDb->getRow($sql);
    }

    function checkUserTakeCourse($data)
    {
        $sql = "SELECT `id` FROM `course_subscriptions`  ";
        $sql .= " WHERE `id` > 0 AND `user_id`='{$data['user_id']}' AND`course_id`='{$data['id']}' AND status = '1' ";
        //   echo $sql;die();
        return $this->mDb->getRow($sql);
    }

    function addCourseSubscriptions($items)
    {
        $sql = "INSERT INTO `course_subscriptions` SET ";
        $sql .= "`user_id`='{$items['user_id']}' ,`course_id`='{$items['id']}',";
        $sql .= " `course_cost`='{$items['cost']}'";
        //   echo $sql;
        return $this->mDb->queryReturnLastId($sql);
    }

    function checkVideoViewRate($data)
    {
        $sql = "SELECT * FROM `views_ratio`  ";
        $sql .= " WHERE `id` > 0 AND `video_id`='{$data['id']}' AND `course_id`='{$data['course_id']}' AND `user_id` = '{$data['user_id']}'";
        //   echo $sql;die();
        // echo $sql ."<br>";
        return $this->mDb->getRow($sql);
    }

    function addVideoViewRate($data)
    {
        $sql = "INSERT INTO `views_ratio` SET ";
        $sql .= " `video_id`='{$data['id']}' , `course_id`='{$data['course_id']}' , `user_id` = '{$data['user_id']}',`percentage`='{$data['percentage']}'";
        //   echo $sql;
        return $this->mDb->query($sql);
    }

    function updateVideoViewRate($data)
    {
        $sql = "UPDATE `views_ratio` SET ";
        $sql .= " `video_id`='{$data['video_id']}' , `course_id`='{$data['course_id']}' , `user_id` = '{$data['user_id']}',`percentage`='{$data['percentage']}'";
        $sql .= " WHERE `id` ='{$data['id']}'";
        //   echo $sql;
        return $this->mDb->query($sql);
    }

    function getOneVideoComments($id)
    {
        $sql = "SELECT * FROM `videos_comments`";
        $sql .= " WHERE `id` = '{$id}'";
        // echo $sql;
        return $this->mDb->getRow($sql);
    }


    function addEditCourse($request, $course_id)
    {
        $img = $request['img'];
        // $dataLangObj = json_decode($request['LangObj']);
        // $newDataLangObj = $this->convert_object_to_array($dataLangObj);
        // print_r($newDataLangObj);die();

        // unset($request['countryLangObj']);
        unset($request['action']);
        // echo $request['operation'];die();
        $res = false;
        if ($request['operation'] === 'add') {

            // Add
            unset($request['operation']);
            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `courses` SET ";
            $sql .= " `country_id` = '{$request['country_id']}',";
            $sql .= " `stage_id` = '{$request['stage_id']}',";
            $sql .= " `grade_id` = '{$request['grade_id']}',";
            $sql .= " `subject_id` = '{$request['subject_id']}',";
            $sql .= " `semester` = '{$request['semester']}',";
            $sql .= " `added_by` = '{$request['added_by']}',";
            $sql .= " `sort` = '{$request['sort']}',";
            $sql .= " `amount` = '{$request['amount']}',";
            $sql .= " `group` = '{$request['group']}',";
            $sql .= " `set_from` = 'teacher',";
            $sql .= $request['status'] === true ? " `status` = '1'," : " `status` = '0',";
            $sql .= $request['paid'] === true ? " `paid` = '1'," : " `paid` = '0',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= " `img` = '{$img}'";
            // echo $sql; die();
            $last_id = $this->mDb->queryReturnLastId($sql);


            $stmt = "INSERT INTO `courses_langs`(`course_id`, `lang_code`, `name`, `description`) ";
            $stmt .= " VALUES ('{$last_id}', 'ar', '{$request['name']}', '{$request['description']}')";
            // echo $stmt;die();
            $res = $this->mDb->query($stmt);
            if ($res && $last_id):
                $_data = array("id" => $last_id);
                return $this->getCourseInfoById($_data);
            else:
                return false;
            endif;
        } else {
            /*echo "<pre>";
            print_r($request);
            echo "</pre>";*/
            // Edit
            // echo $img;die();
            $check_query = "SELECT `id` FROM `courses` WHERE `id` = '{$course_id}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {

                return 403;
            } else {

                $sql = "UPDATE `courses` SET ";
                $sql .= " `country_id` = '{$request['country_id']}',";
                $sql .= " `stage_id` = '{$request['stage_id']}',";
                $sql .= " `grade_id` = '{$request['grade_id']}',";
                $sql .= " `subject_id` = '{$request['subject_id']}',";
                $sql .= " `semester` = '{$request['semester']}',";
                $sql .= " `added_by` = '{$request['added_by']}', ";
                $sql .= " `group` = '{$request['group']}', ";
                $sql .= " `sort` = '{$request['sort']}', ";
                $sql .= " `amount` = '{$request['amount']}', ";
                $sql .= " `set_from` = '{$request['set_from']}', ";
                $sql .= $request['paid'] === true ? " `paid` = '1' ," : " `paid` = '0' ,";
                $sql .= $request['status'] === true ? " `status` = '1'" : " `status` = '0'";


                if ($request['old_img'] != '' || $request['old_img'] != null) {

                    // Delete old image from the server
                    /*$img_query = "SELECT `img` FROM `courses` WHERE `id` = '{$course_id}'";
                    $img_result = $this->mDb->getOne($img_query);*/

                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'courses/' . $request['old_img'];

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                }
                $sql .= ",`img`='{$request['img']}' ";

                $sql .= " WHERE `id` = '{$course_id}'";

//                  echo $sql;

                $res = $this->mDb->query($sql);

                $stmt = "UPDATE `courses_langs` SET";
                $stmt .= " `name`='{$request['name']}' , ";
                $stmt .= " `description`='{$request['description']}' ";

                $stmt .= " WHERE `lang_code`='ar' AND `course_id` = '{$course_id}'";

                $resStmt = $this->mDb->query($stmt);
                if ($res && $resStmt):
                    $_data = array("id" => $course_id);
                    return $this->getCourseInfoById($_data);
                else:
                    return false;
                endif;
            }

        }
    }


    function addEditVideoOfCourseByTeacher($data)
    {
        
        $res = false;
        
        $dateTime = date('Y-m-d H:i:s');
        

        if ($data['id'] == '' && $data['operation'] === 'add') {
            $sql = "INSERT INTO `videos_courses` SET ";
            $sql .= " `course_id` = '{$data['course_id']}',";
            $sql .= " `title` = '{$data['title']}',";
            $sql .= " `desc` = '{$data['desc']}',";
            $sql .= " `file_hls` = '{$data['file_hls']}',";
            $sql .= $data['unit_id_explain'] > 0 ? " `unit_id_explain` = '{$data['unit_id_explain']}'," : "";
            $sql .= $data['lesson_id_explain'] > 0 ? " `lesson_id_explain` = '{$data['lesson_id_explain']}'," : "";
            $sql .= " `added_by` = '{$data['added_by']}',";
            $sql .= " `group` = '{$data['group']}',";
            $sql .= " `sort` = '{$data['sort']}',";
            $sql .= " `set_from` = 'teacher',";
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
            // $sql .= $data['status'] == 'true' ? " `status` = '1'," : " `status` = '0',";
            $sql .= " `status` = '0',";
            $sql .= $data['paid'] == 'true' ? " `paid` = '1'," : " `paid` = '0',";
            $sql .= " `file` = '{$data['file']}',";
            $sql .= " `url_video_youtube` = '{$data['url_video_youtube']}',";
            $sql .= " `time` = '{$data['time']}'";
//   echo $sql;die();
            $last_id = $this->mDb->queryReturnLastId($sql);

            if ($last_id) {
                foreach ($data['doc'] as $key => $value) {
                    $stmt = "INSERT INTO `videos_attachments_courses`(`video_id`, `attach_file`,`file_size`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['file']}','{$value['size']}' )";
                    // echo $stmt;die();
                    $this->mDb->query($stmt);
                }

                foreach ($data['video_tests'] as $key => $value) {
                    $_unit_id = $value['unit_id'] > 0 ? $value['unit_id'] : 0;
                    $_lesson_id = $value['lesson_id'] > 0 ? $value['lesson_id'] : 0;
                    $stmt = "INSERT INTO `videos_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                    $stmt .= " VALUES ('{$last_id}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                    $this->mDb->query($stmt);
                }
            }

            if ($last_id):
                $_data = array("id" => $last_id);
                return $this->getVideoInfoById($_data);
            else:
                return false;
            endif;

        } else {

            // Edit

            $check_query = "SELECT `id` FROM `videos_courses` WHERE `id` = '{$data['id']}'";
            $check_result = $this->mDb->getOne($check_query);

            if ($check_result === false) {

                return 403;
            } else {
                $data['unit_id_explain'] = $data['unit_id_explain'] > 0 ? $data['unit_id_explain'] : 0;
                $data['lesson_id_explain'] = $data['lesson_id_explain'] > 0 ? $data['lesson_id_explain'] : 0;

                $sql  = "UPDATE `videos_courses` SET ";
                $sql .= " `course_id` = '{$data['course_id']}',";
                $sql .= " `title` = '{$data['title']}',";
                $sql .= " `desc` = '{$data['desc']}',";
                $sql .= " `file_hls` = '{$data['file_hls']}',";
                $sql .= " `group` = '{$data['group']}',";
                $sql .= " `unit_id_explain` = '{$data['unit_id_explain']}',";
                $sql .= " `lesson_id_explain` = '{$data['lesson_id_explain']}',";
                $sql .= " `added_by` = '{$data['added_by']}',";
                $sql .= " `sort` = '{$data['sort']}',";
                $sql .= " `set_from` = '{$data['set_from']}',";
                $sql .= $data['img_video'] != "" ? "`img` = '{$data['img_video']}'," : "";
                $sql .= $data['status'] == 'true' ? " `status` = '1'," : " `status` = '0',";
                $sql .= $data['paid'] == 'true' ? " `paid` = '1'," : " `paid` = '0',";
                $sql .= $data['file'] ? " `file` = '{$data['file']}',`time` = '{$data['time']}',`url_video_youtube`=NULL, " : "";
                $sql .= $data['url_video_youtube'] ? " `url_video_youtube` = '{$data['url_video_youtube']}',`time` = '{$data['time']}',`file` = NULL, " : "";
                $sql .= " `date_added` = '{$dateTime}'";
                $sql .= " WHERE `id` = '{$data['id']}'";
                //  echo $sql; die();
                $res = $this->mDb->query($sql);
                if ($res) {

                    if ($data['img_video'] != '' || $data['img_video'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['img_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                    if ($data['file'] != '' || $data['file'] != null) {
                        // Delete old image from the server
                        // $img_query = "SELECT `img_vedio` FROM `vedio_courses` WHERE `id` = '{$data['id']}'";
                        // $img_result = $this->mDb->getOne($img_query);
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path_course_videos_and_attachments'] . 'course_videos_and_attachments/' . $data['file_old'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                        }
                    }
                    
                    $stmtd1 = "DELETE FROM `videos_attachments_courses` WHERE `video_id` = '{$data['id']}'";
                    $this->mDb->query($stmtd1);
                    foreach ($data['doc'] as $key => $value) {
                        $stmt = "INSERT INTO `videos_attachments_courses`(`video_id`, `attach_file`,`file_size`) ";
                        $stmt .= " VALUES ('{$data['id']}', '{$value['file']}','{$value['size']}')";
                        $this->mDb->query($stmt);
                    }

                    $stmtd2 = "DELETE FROM `videos_tests` WHERE `video_id` = '{$data['id']}'";
                    $this->mDb->query($stmtd2);
                    
                    foreach ($data['video_tests'] as $key => $value) {
                        $_unit_id = $value['unit_id'] > 0 ? $value['unit_id'] : 0;
                        $_lesson_id = $value['lesson_id'] > 0 ? $value['lesson_id'] : 0;
                        $stmt = "INSERT INTO `videos_tests`(`video_id`, `test_type`,`unit_id`,`lesson_id`,`exercise_id`) ";
                        $stmt .= " VALUES ('{$data['id']}', '{$value['test_type']}','{$_unit_id}','{$_lesson_id}','{$value['unit_exercise_id']}' )";
                        //   echo $stmt;
                        $this->mDb->query($stmt);
                    }
                }

                if ($res):
                    $_data = array("id" => $data['id']);
                    return $this->getVideoInfoById($_data);
                else:
                    return false;
                endif;
            }
        }
    }

    function getAllCourseUnits($temp)
    {
        $sql = "SELECT id, name FROM `units` ul";
        $sql .= " where `course_id` ='{$temp['course_id']}' AND is_deleted != '1'";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    function getAllCourseUnitLessons($temp)
    {
        $sql = "SELECT ul.id, ul.name FROM `unit_lessons` ul";
        $sql .= " where  ul.`unit_id` ='{$temp['unit_id']}' AND ul.is_deleted != '1'";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function addUnitAndSubjectToCourses($temp)
    {
        $sql = "INSERT INTO `unit_lessons` SET ";
        $sql .= "`unit_id`='{$temp['unit_id']}' ,`name`='{$temp['name']}',`course_id`='{$temp['course_id']}'";
        //   echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }

    function addUnit($request)
    {
        $sql = "INSERT INTO `units` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',";
        $sql .= $request['country_id'] ? " `country_id` = '{$request['country_id']}'," : "";
        $sql .= $request['stage_id'] ? " `stage_id` = '{$request['stage_id']}'," : "";
        $sql .= $request['grade_id'] ? " `grade_id` = '{$request['grade_id']}'," : "";
        $sql .= $request['subject_id'] ? " `subject_id` = '{$request['subject_id']}'," : "";
        $sql .= $request['semester'] ? " `semester` = '{$request['semester']}'," : "";
        $sql .= " `name` = '{$request['name']}',";
        $sql .= $request['sort'] ? " `sort` = '{$request['sort']}'," : " `sort` = '0',";
        $sql .= " `mode` = 'explanations',";
        $sql .= " `course_id` = '{$request['course_id']}',";
        $sql .= $request['status'] === 'true' ? " `status` = '1'," : "";
        $sql .= " `date_added` = '{$this->dateTime}'";
        // echo $sql; die();
        $this->mDb->query($sql);
        $last_grade_id = $this->mDb->getLastInsertId();
        return $last_grade_id;
    }
    
    function editUnit($request)
    {
        $sql = "UPDATE `units` SET ";
        // $sql .= " `added_by` = '{$request['added_by']}',";
        // $sql .= $request['country_id'] ? " `country_id` = '{$request['country_id']}'," : "";
        // $sql .= $request['stage_id'] ? " `stage_id` = '{$request['stage_id']}'," : "";
        // $sql .= $request['grade_id'] ? " `grade_id` = '{$request['grade_id']}'," : "";
        // $sql .= $request['subject_id'] ? " `subject_id` = '{$request['subject_id']}'," : "";
        // $sql .= $request['semester'] ? " `semester` = '{$request['semester']}'," : "";
        $sql .= " `name` = '{$request['name']}' ";
        // $sql .= $request['sort'] ? " `sort` = '{$request['sort']}'," : " `sort` = '0',";
        // $sql .= " `mode` = 'explanations',";
        // $sql .= " `course_id` = '{$request['course_id']}',";
        // $sql .= $request['status'] === 'true' ? " `status` = '1'," : "";
        // $sql .= " `date_added` = '{$this->dateTime}'";
        $sql .= " WHERE `id` = '{$request['unit_id']}' AND `added_by` = '{$request['added_by']}'";
        // echo $sql; die();
        return $this->mDb->query($sql);
        // $last_grade_id = $this->mDb->getLastInsertId();
        // return $last_grade_id;
    }

    function addLesson($temp)
    {
        $stmt = "INSERT INTO `unit_lessons`(`unit_id`, `name`) ";
        $stmt .= " VALUES ('{$temp['unit_id']}', '{$temp['name']}')";
        $res = $this->mDb->query($stmt);
        return $res ? $this->mDb->getLastInsertId() : false;
    }
    
    function editLesson($temp)
    {
        $sql = "SELECT id from `units` WHERE id = '{$temp['unit_id']}' AND added_by = '{$temp['added_by']}'";
        $unit = $this->mDb->getRow($sql);
        // echo $unit['id'];die();
        if(!$unit['id']){
            return false;
        }
        $stmt = "UPDATE `unit_lessons` SET ";
        $stmt .= " `unit_id` = '{$temp['unit_id']}', `name` = '{$temp['name']}' WHERE `id` = '{$temp['lesson_id']}' ";
        return $this->mDb->query($stmt);
        // return $res ? $this->mDb->getLastInsertId() : false;
    }

    function deleteUnit($temp){
         $sql = "SELECT id from `units` WHERE id = '{$temp['unit_id']}' AND added_by = '{$temp['added_by']}'";
        $unit = $this->mDb->getRow($sql);
        if(!$unit['id']){
            return false;
        }
        
        $sql = "UPDATE `units` SET `is_deleted` = '1' WHERE `id` = '{$temp['unit_id']}' AND `added_by` = '{$temp['added_by']}'";
        // echo $sql;die();
        $res = $this->mDb->query($sql);
        
        if($res){
            $sqll = "UPDATE `videos_courses` SET `is_deleted` = '1' WHERE `unit_id_explain` = '{$temp['unit_id']}'";
            $ress = $this->mDb->query($sqll);
            
           if($ress){
                $sqlll = "UPDATE `unit_lessons` SET `is_deleted` = '1' WHERE `unit_id` = '{$temp['unit_id']}'";
                // echo $sql;die();
                return $this->mDb->query($sqlll);
           }
        }
        
        return false;
    }
    
    function deleteLesson($temp){
         $sql = "SELECT id from `units` WHERE id = '{$temp['unit_id']}' AND added_by = '{$temp['added_by']}'";
        $unit = $this->mDb->getRow($sql);
        if(!$unit['id']){
            return false;
        }
        
        $sql = "DELETE FROM `unit_lessons` WHERE `id` = '{$temp['lesson_id']}'";
        $res = $this->mDb->query($sql);
        
         if($res){
            $sqll = "UPDATE `videos_courses` SET `is_deleted` = '1' WHERE `lesson_id_explain` = '{$temp['lesson_id']}'";
            return $this->mDb->query($sqll);
         }
    }
    
    
    function addRemoveFavoriteCourse($temp)
    {

        $sql = "SELECT id from `courses_favorites` where `course_id` = '{$temp['course_id']}' AND `user_id` = '{$temp['user_id']}'";
        $row = $this->mDb->getRow($sql);
        if ($row['id']) {
            $sql = "DELETE FROM courses_favorites WHERE `id` = '{$row['id']}'";
            $key = "remove_favorite";
        } else {
            $sql = "INSERT INTO courses_favorites (`course_id`, `user_id`) VALUES ('{$temp['course_id']}', '{$temp['user_id']}')";
            $key = "add_favorite";


        }
        // echo $sql;die();

        $res['data'] = $this->mDb->query($sql);
        $res['key'] = $key;
        return $res;

    }

    function getMyFavoriteCourses($id)
    {

//         $sql = "SELECT
//         f.*
//     FROM
//         `courses` f
//     LEFT JOIN
//         `courses_langs` fl ON (f.`id` = fl.`course_id` AND fl.`lang_code`='" . LANGUAGE . "')
//     LEFT JOIN
//         `users` u ON (u.`id` = f.`added_by`)
//     LEFT JOIN 
//         `courses_favorites` cf ON (cf.course_id = f.id)
//     WHERE
//         cf.user_id = '{$id}' AND f.`is_deleted` = '0' 
//     GROUP BY
//         f.id";
// // echo $sql;die();
//     $courses = $this->mDb->getAll($sql);

//     return $courses;AND cf.user_id = f.added_by

        $sql = "SELECT  
            u.full_name as teacher_name,
            f.id,
            f.img,
            fl.description,
            fl.`name`,
            f.paid,
            f.amount,
            f.status,
            cf.id as favorit,
            TIME_FORMAT(SEC_TO_TIME(SUM(TIME_TO_SEC(STR_TO_DATE(vc.time, '%H:%i:%s')))), '%H:%i:%s') AS time,
            COUNT(vc.id) AS count_of_videos,
            CASE WHEN cf.id IS NOT NULL THEN 1 ELSE 0 END AS is_favorite
        FROM
            `courses` f
        LEFT JOIN
            `courses_langs` fl ON (f.`id` = fl.`course_id` AND fl.`lang_code` = :language)
        LEFT JOIN
            `users` u ON (u.`id` = f.`added_by`)
        LEFT JOIN
            `videos_courses` vc ON (vc.`course_id` = f.`id` AND vc.is_deleted != '1')
        LEFT JOIN
            `courses_favorites` cf ON (cf.`course_id` = f.`id` )
        WHERE f.`is_deleted` = '0' ";


        if (!empty($id)) {
            $sql .= " AND cf.`user_id` = :user_id";
        }

        $sql .= " GROUP BY f.id ORDER BY f.id DESC";

        // echo $sql; die();

        // Preparing the statement
        $stmt = $this->mDb->prepare($sql);


        // Binding the language code to the placeholder
        $stmt->bindValue(':language', LANGUAGE, PDO::PARAM_STR);

        if (!empty($id)) {
            $stmt->bindValue(':user_id', $id, PDO::PARAM_INT);
        }

        // Execute the query with the parameters
        $stmt->execute($params);

        // Fetching all courses
        $courses = $stmt->fetchAll(PDO::FETCH_ASSOC);

        return $courses;

    }

    function deleteCoursesBIdy($data)
    {

        $sql = "UPDATE `courses` SET";
        $sql .= " `is_deleted`='1'  ";
        $sql .= " WHERE `id`= :value1 ";
        // Prepare the statement
        $stmt = $this->mDb->prepare($sql);
        $stmt->bindValue(':value1', $data['id']);
        // Execute the query
        $result = $stmt->execute();
        // Check for success
        if ($result)
            return true;
        else
            return false;

    }

    function getVideoInfoById($data)
    {
        $sql = "SELECT * FROM `videos_courses`  ";
        $sql .= " WHERE `id` > 0 AND id='{$data['id']}'";
        //   echo $sql;
        return $this->mDb->getRow($sql);
    }

    function deleteVideoBIdy($data)
    {

        $sql = "UPDATE `videos_courses` SET";
        $sql .= " `is_deleted`='1'  ";
        $sql .= " WHERE `id`= :value1 ";
        // Prepare the statement
        $stmt = $this->mDb->prepare($sql);
        $stmt->bindValue(':value1', $data['id']);
        // Execute the query
        $result = $stmt->execute();
        // Check for success
        if ($result)
            return true;
        else
            return false;

    }

    function checkUserSubscriptionToCourse($data = array())
    {

        $sql = "SELECT * FROM `course_subscriptions` ";
        $sql .= " WHERE ";
        $sql .= " `user_id` = :value1 ";
        $sql .= " AND `course_id` = :value2  ";
        $sql .= " LIMIT 1";
        // Prepare the statement
        $stmt = $this->mDb->prepare($sql);
        // Binding the language code to the placeholder
        $stmt->bindValue(':value1', $data['user_id']);
        $stmt->bindValue(':value2', $data['course_id']);
        // Execute the query
        $stmt->execute();
        // Fetch the result
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    function AddSubscriptionToCourses($data = array())
    {
        $sql = "INSERT INTO `course_subscriptions` SET ";
        $sql .= " `user_id` = :value1,";
        $sql .= " `course_id` = :value2,";
        $sql .= "`course_cost` = :value3";
        // Prepare the statement
        $stmt = $this->mDb->prepare($sql);
        $stmt->bindValue(":value1", $data['user_id']);
        $stmt->bindValue(":value2", $data['course_id']);
        $stmt->bindValue(":value3", $data['course_cost']);
        // Execute the query
        $result = $stmt->execute();
        // Check for success
//        echo $stmt->debugDumpParams();
        if ($result)
            return $this->mDb->queryReturnLastId($sql);
        else
            return false;
    }
    
    
    function checkTeacherUnitRelated($teacher_id, $unit_id=null, $lesson_id=null){
        $sql  = "SELECT u.`id` FROM `units` u ";
        $sql .= "LEFT JOIN `unit_lessons` ul ON u.id = ul.unit_id ";
        $sql .= "WHERE u.`added_by` = :teacher_id";
        $sql .= $unit_id ? " AND u.`id` = :unit_id ":"";
        $sql .= $lesson_id ? " AND ul.`id` = :lesson_id ":"";
        // echo $sql . "---" . $teacher_id;die();
        $stmt= $this->mDb->connect()->prepare($sql);
        
        $stmt->bindParam(":teacher_id", $teacher_id);
        
        if($unit_id)
            $stmt->bindParam(":unit_id", $unit_id);
        if($lesson_id)
            $stmt->bindParam(":lesson_id", $lesson_id);
            
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    

    public function getAdminEmails($stage_id){
        $sql = "SELECT user_email FROM `admins_email` WHERE stage_id = '{$stage_id}'";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }
    
    
    public function getCourseStagId($course_id){
        $sql = "SELECT stage_id FROM `courses` WHERE id = '{$course_id}'";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    
    
    
    public function getVideoStagId($video_id){
        $sql  = "SELECT c.stage_id FROM `videos_courses` vc ";
        $sql .= " LEFT JOIN `courses` c ON c.id = vc.course_id ";
        $sql .= " WHERE vc.id = '{$video_id}'";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    
    
    public function getVideoData($video_id){
        $sql  = "SELECT vc.title, vc.course_id, c.name FROM `videos_courses` vc ";
        $sql .= " LEFT JOIN `courses_langs` c ON c.course_id = vc.course_id AND lang_code = 'ar' ";
        $sql .= " WHERE vc.id = '{$video_id}'";
        // echo $sql;die();
        return $this->mDb->getRow($sql);
    }
}
