<?php

$finalReviewNotesObj = new FinalReviewNotes();

class FinalReviewNotes
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();
    $this->dateTime = date('Y-m-d H:i:s');
  }
  
  
  function getAllCategories($temp)
  {
    $sql  = "SELECT * FROM `categories` ";
    $sql .= " WHERE stage_id = '{$temp['stage_id']}' AND grade_id = '{$temp['grade_id']}' AND type = 'videos'";
    
    $categories = $this->mDb->getAll($sql);
    foreach($categories as &$category){
        $category['videos'][] = $this->getAllVideosByCategoryId($category['id']);
    }
    
    
    return $categories;
  }
  
  public function getAllVideosByCategoryId($id){
     $sql = "SELECT * FROM `final_review_notes` WHERE category_id = '{$id}'";
    //  echo $sql;die();
    $videos =  $this->mDb->getAll($sql);
    
    foreach($videos as &$video){
        $video['comments'][] = $this->getAllVideoCommentsByVideoId($video['id']);
        $video['inquiries'][] = $this->getAllVideoInquiriesByVideoId($video['id']);
    }
    
    return $videos;
  }
  
  public function getAllVideoCommentsByVideoId($id){
     $sql = "SELECT * FROM `final_review_notes_comments` WHERE video_id = '{$id}'";
    return $this->mDb->getAll($sql);
  }
  
  public function getAllVideoInquiriesByVideoId($id){
     $sql = "SELECT * FROM `final_review_notes_inquiries` WHERE video_id = '{$id}'";
    return $this->mDb->getAll($sql);
  }


function getAllFinalReviewNotesBySubjectId($temp)
{
    $sql = "SELECT  
        frn.*,
        c.id AS category_id,
        cl.description  as category_desc,
        cl.`title` as category_name
    FROM
        `final_review_notes` frn
    LEFT JOIN
        `categories` c ON frn.category_id = c.id
    LEFT JOIN
        `categories_langs` cl ON (c.`id` = cl.`category_id` AND cl.`lang_code` = :language)
    WHERE frn.id > 0";

    if (!empty($temp['subject_id'])) {
        $sql .= " AND frn.`subject_id` = :subject_id";
    }
    
    if (!empty($temp['subject_branch_id'])) {
        $sql .= " AND frn.`branch_id` = :branch_id";
    }
    
    // $sql .= " GROUP BY frn.category_id";

    $stmt = $this->mDb->prepare($sql);
    $languageValue = LANGUAGE;
    $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);

    if (!empty($temp['subject_id'])) {
        $subject_id = $temp['subject_id'];
        $stmt->bindParam(':subject_id', $subject_id, PDO::PARAM_INT);
    }
    
    if (!empty($temp['subject_branch_id'])) {
        $branch_id = $temp['subject_branch_id'];
        $stmt->bindParam(':branch_id', $branch_id, PDO::PARAM_INT);
    }

    $stmt->execute();

    $categories = $stmt->fetchAll(PDO::FETCH_ASSOC);
    // return $categories;
    $data = [];
    foreach ($categories as &$category) {
        $category_id = $category['category_id'] ?? 'no_category';
         $data[$category_id]['id'] = $category['category_id'];
         $data[$category_id]['name'] = $category['category_name'];
         $data[$category_id]['description'] = $category['category_desc'];
        
        // if (!isset($data[$category_id])) {
        //     $data[$category_id]['category_notes'][] = [];
        // }
        $data[$category_id]['category_notes'][] = $category;
    }
 
    return array_values($data);
}




 function getDetailsCategoriesInfo($temp)
    {
// print_r($temp);die();
        $sql = "SELECT 
            c.id AS category_id, 
            c.subject_id , 
            cl.title AS category_title, 
            cl.description AS category_desc, 
            s.subject_direction, 
            frn.file
        FROM 
            `categories` c 
        LEFT JOIN 
            `categories_langs` cl ON cl.`category_id` = c.`id` AND cl.`lang_code` = :language 
        LEFT JOIN 
            `subjects` s ON s.`id` = c.`subject_id` 
        LEFT JOIN 
            `final_review_notes` frn ON frn.category_id = c.id
        WHERE 
            c.`subject_id` = :subject_id
        GROUP BY 
            c.id, cl.title, cl.description, s.subject_direction";

// echo $sql;die();
        $stmt = $this->mDb->prepare($sql);
        // Ensure LANGUAGE is stored in a variable if it's not already
        $languageValue = LANGUAGE; // Adjust this line if LANGUAGE is already a variable
        $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);

        // Ensure $temp['id'] is stored in a variable if it's not already
        $subject_id = $temp['id']; // Adjust this line if $temp['id'] is already a variable
        $stmt->bindParam(':subject_id', $subject_id, PDO::PARAM_INT);

        $stmt->execute();
        $courses = $stmt->fetchAll(PDO::FETCH_ASSOC);
        // print_r($courses);die();
        return $courses;
    }
    
    public function getAllUnitsBySubjectId($temp)
    {
        $sql = "SELECT f.id  ,f.name   FROM `units` f ";
        $sql .= "where  f.`subject_id` ='{$temp['id']}' AND f.`mode`='explanations' AND f.`is_deleted` = '0' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }
    
    function countVideosToCoursesBySubjectId($temp)
    {
        // print_r($temp);die();
        $sql = "SELECT count(frv.id) FROM `final_review_notes` frv ";
        $sql .= "where  frv.`category_id` = '{$temp['course_id']}' AND frv.`is_deleted` != '1'";
        echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    
    
    function getDetailsgetDetailsFinalReviewVideosInfoBySubjectId($catgory_id)
    {
        // print_r($temp);die();
        $sql = "SELECT fvr.id,fvr.sort, fvr.title,fvr.time FROM `final_review_notes` fvr "; ///,(SELECT `t`.`paid` FROM `tests`  t WHERE `t`.`id` =`vc`.`exercise_id` ) exercise_paid_status
        $sql .= "where  fvr.`category_id` ='{$catgory_id}' AND fvr.`is_deleted` = '0' ";
        $sql .= " ORDER BY `fvr`.`sort` ASC";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $hours = 0;
        for ($i = 0; $i < count($res); $i++) {
            $obj = array(
                'id' => $res[$i]['id'],
                'category_id' => $temp['category_id'],
                'user_id' => $temp['user_id']
            );
            
            $duration = explode(":", $res[$i]['time']);
            $total_time = ($duration[0] * 60 * 60) + ($duration[1] * 60) + $duration[2];
            $dta = $this->checkVideoViewRate($obj);
            // print_r($dta);
            // echo "<br>";
            $res[$i]['videoViewRate'] = empty($dta) ? "0" : ($total_time > 0 ? round(($dta['percentage'] / $total_time) * 100) : "0");
            // $res[$i]['videoViewRate'] = empty($dta) ? "0" : round(($dta['percentage'] / $total_time) * 100);
            $hours += $total_time / 60;
            $res[$i]['hours'] = sprintf("%.2f", $hours);
        }
        // print_r($res);
        // die();
        
        return $res;
    }
    
    function getDetailsFinalReviewNotesByCategoryId($temp)
    {
        // print_r($temp);die();
        $sql = "SELECT 
            c.id AS category_id, 
            c.subject_id , 
            c.status, 
            cl.title AS category_name, 
            cl.description AS category_desc,
            s.subject_direction, 
            frn.file
        FROM 
            `categories` c 
        LEFT JOIN 
            `categories_langs` cl ON cl.`category_id` = c.`id` AND cl.`lang_code` = :language 
        LEFT JOIN 
            `subjects` s ON s.`id` = c.`subject_id`  
        LEFT JOIN 
            `final_review_notes` frn ON (frn.category_id = c.id)
        WHERE 
            c.`id` = :categoryId 
        GROUP BY 
            c.id, cl.title, cl.description, s.subject_direction";
// echo $sql;die();


        $stmt = $this->mDb->prepare($sql);
        // Ensure LANGUAGE is stored in a variable if it's not already
        $languageValue = LANGUAGE; // Adjust this line if LANGUAGE is already a variable
        $stmt->bindParam(':language', $languageValue, PDO::PARAM_STR);

        // Ensure $temp['id'] is stored in a variable if it's not already
        $courseIdValue = $temp['id']; // Adjust this line if $temp['id'] is already a variable
        $stmt->bindParam(':categoryId', $courseIdValue, PDO::PARAM_INT);

        $stmt->execute();
//        $stmt->debugDumpParams();
        $courses = $stmt->fetch(PDO::FETCH_ASSOC);
        /*        if (!empty($courses)):
                    $data = array("user_id" => $temp['user_id'], "course_id" => $temp['id']);
                    $idCourseSubscription = $this->checkUserSubscriptionToCourse($data);
                    $courses['status_user_subscription_in_course'] = $idCourseSubscription ? true : false;
                endif;*/
                
        return $courses;
    }
    
    
    public function getNameExercise($id)
    {
        $sql = "select vt.test_type, vt.unit_id, vt.lesson_id, vt.exercise_id as unit_exercise_id, t.name as exercise_name from `final_review_notes_tests` vt LEFT JOIN `tests` t ON vt.`exercise_id` = t.`id`";
        $sql .= " where vt.`video_id` = '{$id}'";
            // echo($sql);die();
        return $this->mDb->getAll($sql);
    }
    
    function allAttachvideosInCourses($id)
    {

        $sql = "SELECT * FROM `videos_attachments_final_review`";
        $sql .= " WHERE `video_id` = '{$id}'";
        return $this->mDb->getAll($sql);
    }
    
    function getAllCommentsInVideoById($data)
    {
        $sql = "SELECT vc.* , u.img as avatar, u.full_name as username  FROM `final_review_notes_comments` vc ";
        $sql .= " LEFT JOIN `users` u ON vc.user_id = u.id";
        $sql .= " WHERE (((vc.`video_id` = '{$data['id']}' AND vc.`status`='0')||(vc.`video_id` = '{$data['id']}' AND vc.`user_id`='{$data['user_id']}' AND (vc.`status`='0' ||  vc.`status`='1')) ) AND vc.`parent`='0')";
        $sql .= " ORDER BY vc.`status` DESC ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['statusName'] = $res[$i]['status'] > 0 ? "pending" : "published";
            $res[$i]['allReply'] = $this->getAllReplyCommentsInVideoById($res[$i]);
        }
        return $res;
    }
    
     function getAllReplyCommentsInVideoById($data)
    {
        $sql = "SELECT vc.*, u.img as avatar, u.full_name as username FROM `final_review_notes_comments` vc LEFT JOIN `users` u ON u.id = vc.user_id";
        $sql .= " WHERE ((vc.`parent` = '{$data['id']}' AND vc.`status`='0')||(vc.`parent` = '{$data['id']}' AND vc.`user_id`='{$data['user_id']}' AND (vc.`status`='0' ||  vc.`status`='1')))";
        $sql .= " ORDER BY vc.`status` DESC ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['statusName'] = $res[$i]['status'] > 0 ? "pending" : "published";
        }
        return $res;
    }
    
    function getDetailsvideoById($data)
    {
        $sql = "SELECT * FROM `final_review_notes`";
        $sql .= " WHERE `id` = '{$data['id']}'";
        $result = $this->mDb->getRow($sql);
        if (!empty($result)):
            // $result['unit_name'] = $this->getNameItem('name', 'units', 'id', $result['unit_id_explain']);
            // $result['lesson_name'] = $this->getNameItem('name', 'unit_lessons', 'id', $result['lesson_id_explain']);
            $result['exercises'] = $this->getNameExercise($result['id']);

            $obj = array(
                'id' => $result['id'],
                'category_id' => $result['category_id'],
                'user_id' => $data['user_id']
            );

            $duration = explode(":", $result['time']);
            $total_time = ($duration[0] * 60 * 60) + ($duration[1] * 60) + $duration[2];

            $dta = $this->checkVideoViewRate($obj);

            $result['videoViewRate'] = empty($dta) ? "0" : round(($dta['percentage'] / $total_time) * 100);
            $result['allAttachvideosInCourses'] = $this->allAttachvideosInCourses($result['id']);
            $result['allComments'] = $this->getAllCommentsInVideoById($data);
            // $result['allInquiries'] = [];
        endif;

        $_obj['category_id'] = $result['category_id'];

        $sql = "SELECT  ";
        $sql .= " (SELECT s.id FROM `subjects` as s  WHERE c.subject_id = s.id) AS subject_id ";
        $sql .= " FROM categories c  ";
        $sql .= " where c.id = '{$_obj['category_id']}'";

        $res = $this->mDb->getOne($sql);
        $result['subject_id'] = $res;

        return $result;
    }
    
    
    function checkVideoViewRate($data)
    {
        $sql = "SELECT * FROM `final_review_notes_views_ratio`  ";
        $sql .= " WHERE `id` > 0 AND `video_id`='{$data['id']}' AND `category_id`='{$data['category_id']}' AND `user_id` = '{$data['user_id']}'";
        //   echo $sql;die();
        // echo $sql ."<br>";
        return $this->mDb->getRow($sql);
    }
    
    function addVideoViewRate($data)
    {
        $sql = "INSERT INTO `final_review_notes_views_ratio` SET ";
        $sql .= " `video_id`='{$data['id']}' , `category_id`='{$data['category_id']}' , `user_id` = '{$data['user_id']}',`percentage`='{$data['percentage']}'";
        //   echo $sql;
        return $this->mDb->query($sql);
    }
    
    function updateVideoViewRate($data)
    {
        $sql = "UPDATE `final_review_notes_views_ratio` SET ";
        $sql .= " `video_id`='{$data['video_id']}' , `category_id`='{$data['category_id']}' , `user_id` = '{$data['user_id']}',`percentage`='{$data['percentage']}'";
        $sql .= " WHERE `id` ='{$data['id']}'";
        //   echo $sql;
        return $this->mDb->query($sql);
    }
    
    function updateViewNoteById($items)
    {
        $sql = "UPDATE  `final_review_notes` SET `views`=1+views";
        $sql .= " WHERE   `id`='{$items['id']}' ";
        return $this->mDb->query($sql);
    }

    function addCommentsTovideoById($items)
    {
        $sql = "INSERT INTO `final_review_notes_comments` SET ";
        $sql .= "`video_id`='{$items['video_id']}' ,`comment`='{$items['comment']}',`user_id`='{$items['user_id']}',";
        $sql .= $items['parent'] != 0 ? " parent = '{$items['parent']}', " : "`parent` = '0',";
        $sql .= " `status`='{$this->mConfig['comments_status']}' ,date_added='{$this->dateTime}'";
        //   echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }
    
    function getOneVideoComments($id)
    {
        $sql = "SELECT * FROM `final_review_notes_comments`";
        $sql .= " WHERE `id` = '{$id}'";
        // echo $sql;
        return $this->mDb->getRow($sql);
    }
    function getCommentVedioById($id)
    {
        $sql = "SELECT vc.*, u.full_name as username, u.img as avatar FROM `final_review_notes_comments` vc ";
        $sql .= "LEFT JOIN `users` u ON u.id = vc.user_id";
        $sql .= " WHERE vc.`id` = '{$id}'";
        return $this->mDb->getRow($sql);

    }
    
    function deleteCommentById($data)
    {
        $sql = "DELETE FROM `final_review_notes_comments` ";
        $sql .= " WHERE `id` = '{$data['id']}'";
        return $this->mDb->query($sql);

    }
    
    function addInquiriesToVideoById($items)
    {
        $sql = "INSERT INTO `final_review_notes_inquiries` SET ";
        $sql .= "`video_id`='{$items['id']}',`user_from`='{$items['user_id']}',";
        $sql .= " `user_to`='{$items['user_to']}',`read_from`='{$items['read_from']}',`content`='{$items['content']}'";
        $id = $this->mDb->queryReturnLastId($sql);
        if ($id) {
            $this->SendEmailToTheAdministrationForAddedInquiryAtThisStage($items);
        }
        return $id;
    }
    
    function getCategoryInfoById($data)
    {
        $sql = "SELECT c.*,fl.description,fl.`name` FROM `categories` c  ";
        $sql .= "LEFT JOIN `categories_langs` fl ON (c.`id` = fl.`categories_id` AND fl.`lang_code` ='" . LANGUAGE . "')";
        $sql .= " WHERE c.`id` > 0 AND c.id='{$data['id']}'";
//        echo $sql;
        return $this->mDb->getRow($sql);
    }
    
    
    function getAllEmailsByStageId($data)
    {
        $sql = "SELECT user_name,user_email FROM `admins_email` ";
        $sql .= " WHERE `country_id` = '{$data['country_id']}' AND `stage_id`='{$data['stage_id']}'";
        // echo $sql;
        return $this->mDb->getAll($sql);
    }
    
    function getNameItem($column_name, $table, $column_case_name, $column_case)
    {
        $sql = "SELECT `{$column_name}` FROM `{$table}` ";
        $sql .= " WHERE `{$column_case_name}` = '{$column_case}'";
        return $this->mDb->getOne($sql);

    }
    
    
    function SendEmailToTheAdministrationForAddedInquiryAtThisStage($Req)
    {

        $getStage = $this->getDetailsvideoById($Req);
        if ($getStage) {
            $_obj['id'] = $getStage['course_id'];
            $getDataCourses = $this->getCategoryInfoById($_obj);
            if ($getDataCourses) {
                $_dataStage = array(
                    'country_id' => $getDataCourses['country_id'],
                    'stage_id' => $getDataCourses['stage_id']
                );
                $getAllEmailsByData = $this->getAllEmailsByStageId($_dataStage);
                if ($getAllEmailsByData) {
                    for ($i = 0; $i < count($getAllEmailsByData); $i++) {
                        $to = $getAllEmailsByData[$i]['user_email'];
                        $from = "noreply@testat-app.com";
                        $subject = "Respond to members' inquiries";
                        $headers = "From: Testat <$from>\r\n";
                        $headers .= "Reply-To:<$to>\r\n";
                        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
                        $username = $this->getNameItem('full_name', 'users', 'id', $Req["user_id"]);


                        $message = <<<EOT
        <div style="margin: auto;
    width: 500px;
    text-align: end;
    line-height: 1.7;
    font-size: 20px;">
 <h4 style="padding:10px">Dear, {$getAllEmailsByData[$i]["user_name"]} </h4>
    <p style="padding:10px">The member <span style="color:gray">{$username}</span>  added an inquiry to the video title <br/> - <span style="color:gray">{$getStage["title"]}</span> - <br/>
   which you can respond to by clicking on the link <a href="https://admin-area.testat-app.com/video_inquiries/all-video-inquiries?From={$Req["id"]}&To={$Req["user_id"]}&Use={$username}&Ti={$getStage["title"]}" target="blank" style="padding:10px"> Go now link </a>
</p> </div>
EOT;

                        mail($to, $subject, $message, $headers);

                    }
                }
            }
        }


    }
    
    
    function getInquirieVedioById($id)
    {
        $sql = "SELECT * FROM `final_review_notes_inquiries` ";
        $sql .= " WHERE `id` = '{$id}'";
        return $this->mDb->getRow($sql);

    }
    
    
    function getAllInquiriesInVideoChat($data)
    {
        $sql = "SELECT p.id,p.video_id,u.full_name AS 'user_full_name',p.user_from,p.user_to,p.date_added,p.content";
        $sql .= " FROM `final_review_notes_inquiries` p";
        $sql .= " LEFT JOIN `users` u ON u.id = p.user_from ";
        $sql .= " WHERE `p`.`id` > 0 AND p.video_id='{$data['video_id']}' AND (`p`.`user_from`='{$data['user_from']}' ||  `p`.`user_to`='{$data['user_from']}')";
        $sql .= " ORDER BY date_added ASC";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }
    
    // function replyCommentById($items)
    // {
    //     $sql = "INSERT INTO `videos_comments` SET ";
    //     $sql .= "`video_id`='{$items['id']}' ,`comment`='{$items['comment']}',`user_id`='{$items['user_id']}', `parent`='{$items['parent']}',";
    //     $sql .= " `status`='{$this->mConfig['comments_status']}' ,";
    //     $sql .= " `parent`='{$items['comment_id']}' ,date_added='{$this->dateTime}'";
    //     //   echo $sql;die();
    //     return $this->mDb->queryReturnLastId($sql);
    // }

    

    
    
    

    
}  
?>