<?php

$groupObj = new Group();

class Group
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $subjectObj;
  public $testObj;
  public $meetObj;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();
    $this->subjectObj = new Subject();
    $this->testObj = new Test();
    $this->meetObj = new Meet();
    $this->dateTime = date('Y-m-d H:i:s');
  }

  ////////////////////////////////////////////`tests`////////////////////////////////////////////



  function getGroupDetails($group_id)
  {
    global $USER_DATA;
    $sql = "SELECT f.name , f.id , f.date_added , f.description  ,f.image ,f.teacher_id  FROM `groups` f ";
    $sql .= "where f.is_deleted !='1' AND  f.`id` ='{$group_id}'   ";
    $res = $this->mDb->getRow($sql);
    if ($res) {
      $res['member_count'] = $this->getMemberCountOfGroup($group_id);
      $res['post_count'] = $this->getPostCountOfGroup($group_id);

      $six_member['start'] = '0';
      $six_member['itemsPerPage'] = '6';
      $six_member['group_id'] = $group_id;
      $res['six_members_of_group'] = $this->getGroupMembersByParams($six_member);
      if ($USER_DATA['user_type'] == 'teacher') {
        $res['join_requests_pending_count'] = $this->getCountOfAllJoinRequests($group_id, 'pending');
      }
      $related_to_group_data = $this->getRelatedToGroup($res, $USER_DATA);
      $res['related_to_group'] = $related_to_group_data['related_to_group'];
      $res['request_id'] = $related_to_group_data['request_id'];
      $res['owner_group_data'] = $this->getSomeInfoAboutOwnerOfGroup($res['teacher_id']);
      $res['description'] = retNewLine($res['description']);
    }

    return $res;
  }

  function getRelatedToGroup($group_data, $user_data)
  {
    //  p(  $group_data['teacher_id']);
    if ($user_data['user_type'] == 'teacher') {
      if ($user_data['id'] == $group_data['teacher_id']) {
        $res['related_to_group'] = 'owner';
      }
    } else if ($user_data['user_type'] == 'student') {
      if ($this->checkIfMemberInGroup($group_data['id'], $user_data['id'])) {
        $res['related_to_group'] = 'member';
      } else {
        $request_id = $this->checkjoinRequest($group_data['id'], $user_data['id']);
        $res['related_to_group'] =  $request_id  > 0 ?  'request_join_has_send' : 'visitor';
        $res['request_id'] =  $request_id > 0 ?  $request_id : '';
      }
    }
    return $res;
  }

  function getSomeInfoAboutOwnerOfGroup($id)
  {
    $sql = "SELECT u.`id`,  u.`full_name` , u.`mobile`,  u.`country_code`, u.`img`  FROM `users` u  ";
    $sql .= " WHERE u.`id` = '{$id}' AND u.is_deleted !='1' ";
    // echo $sql;die();
    $result = $this->mDb->getRow($sql);
    return $result;
  }

  function getGroupsByParams($temp, $searchType)
  {
    global $USER_DATA;

    $sql = "SELECT f.name , f.id , f.date_added , f.description ,f.image ,f.teacher_id    FROM `groups` f ";
    $sql .= $temp['student_id'] ?  " LEFT JOIN `group_members` gm ON (gm.group_id = f.id) " : '';
    $sql .= "where f.is_deleted !='1'  ";

    if ($searchType == 'all') {
      $sql .= $temp['searchKey'] ? ' AND (f.name like "%' . $temp['searchKey'] . '%"  || f.id = "' . $temp['searchKey'] . '"  ) ' : '';
    } else if ($searchType == 'id') {
      $sql .= $temp['searchKey'] ? ' AND (f.id = "' . $temp['searchKey'] . '"  ) ' : '';
    }
    $sql .=  $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
    $sql .=  $temp['student_id'] ? " AND gm.`student_id` ='{$temp['student_id']}'   " : ' ';
    $sql .= " group by f.id  order by f.`id` desc  ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
            ';

    //echo $sql;
    $res = $this->mDb->getAll($sql);
    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['owner_group_data'] = $this->getSomeInfoAboutOwnerOfGroup($res[$i]['teacher_id']);

      $res[$i]['member_count'] = $this->getMemberCountOfGroup($res[$i]['id']);
      $res[$i]['post_count'] = $this->getPostCountOfGroup($res[$i]['id']);


      if ($USER_DATA['user_type'] == 'teacher') {
        $res[$i]['join_requests_pending_count'] = $this->getCountOfAllJoinRequests($res[$i]['id'], 'pending');
      } else if ($USER_DATA['user_type'] == 'student') {
        $related_to_group_data = $this->getRelatedToGroup($res[$i], $USER_DATA);
        $res[$i]['related_to_group'] = $related_to_group_data['related_to_group'];
        $res[$i]['request_id'] = $related_to_group_data['request_id'];
      }
      $res[$i]['description'] = retNewLine($res[$i]['description']);
    }
    return $res;
  }

  function  getCountGroupsByParams($temp)
  {
    $sql = "SELECT  COUNT( DISTINCT f.id) FROM `groups` f ";
    $sql .= $temp['student_id'] ?  " LEFT JOIN `group_members` gm ON (gm.group_id = f.id) " : '';
    $sql .= "where f.is_deleted !='1'  ";
    $sql .= $temp['searchKey'] ? ' AND (f.name like "%' . $temp['searchKey'] . '%"  || f.id = "' . $temp['searchKey'] . '"  ) ' : '';
    $sql .=  $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
    $sql .=  $temp['student_id'] ? " AND gm.`student_id` ='{$temp['student_id']}'   " : ' ';
    // echo $sql;
    // $sql .= " group by f.id ";
    return $this->mDb->getOne($sql);
  }

  function  getAllCountGroups($temp)
  {
    $sql = "SELECT  COUNT( DISTINCT f.id) FROM `groups` f ";
    $sql .= $temp['student_id'] ?  " LEFT JOIN `group_members` gm ON (gm.group_id = f.id) " : '';
    $sql .= "where f.is_deleted !='1'  ";
    $sql .=  $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
    $sql .=  $temp['student_id'] ? " AND gm.`student_id` ='{$temp['student_id']}'   " : ' ';
    return $this->mDb->getOne($sql);
  }


  function getPostCountOfGroup($group_id)
  {
    $sql = "SELECT count(`id`) from  `group_posts`  where `group_id`='{$group_id}' AND is_deleted !='1'  ";
    return $this->mDb->getOne($sql);
  }

  function getMemberCountOfGroup($group_id)
  {
    $sql = "SELECT count(`id`) from  `group_members`  where `group_id`='{$group_id}'  ";
    return $this->mDb->getOne($sql);
  }
  function getCountOfAllJoinRequests($group_id, $status)
  {
    $sql = "SELECT count(`id`) from  `group_join_requests`  where `group_id`='{$group_id}' AND `status` ='{$status}'  ";
    return $this->mDb->getOne($sql);
  }

  function addGroup($temp)
  {
    global $USER_DATA;

    $temp['name'] = str_replace("'", "\'", $temp['name']);
    $temp['description'] = str_replace("'", "\'", $temp['description']);

    $sql = "INSERT INTO `groups` SET ";
    $sql .= " `teacher_id` = '" . $USER_DATA['id'] . "' , ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `name` = '{$temp['name']}', ";
    $sql .= " `image` = '{$temp['image']}', ";
    $sql .= " `description` = '{$temp['description']}', ";
    $sql .= " `date_added` = '{$this->dateTime}'";
    //p($sql);
    $group_id = $this->mDb->queryReturnLastId($sql);

    if ($group_id) {
      // return $this->getGroupDetails($group_id);
    }
    return $group_id;
  }

  function editGroup($temp)
  {
    global $USER_DATA;
    $temp['name'] = str_replace("'", "\'", $temp['name']);
    $temp['description'] = str_replace("'", "\'", $temp['description']);

    $sql = "UPDATE `groups` SET ";
    $sql .= " `name` = '{$temp['name']}', ";
    $sql .= " `image` = '{$temp['image']}', ";
    $sql .= " `description` = '{$temp['description']}', ";
    $sql .= " `date_edited` = '{$this->dateTime}'   ";
    $sql .= " Where `teacher_id` = '" . $USER_DATA['id'] . "' AND id ='{$temp['group_id']}' ";
    //  p($sql);
    return $this->mDb->query($sql);
  }








  function deleteGroup($group_id)
  {
    global $USER_DATA;
    $sql = "UPDATE `groups` SET is_deleted = '1'  ";
    $sql .= " Where `teacher_id` = '" . $USER_DATA['id'] . "' AND id ='{$group_id}' ";
    //  p($sql);
    return $this->mDb->query($sql);
  }

  function joinRequest($group_id)
  {
    global $USER_DATA;
    $sql = "INSERT INTO `group_join_requests` SET ";
    $sql .= " `student_id` = '" . $USER_DATA['id'] . "' , ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `group_id` = '{$group_id}', ";
    $sql .= " `date_added` = '{$this->dateTime}'";
    return $this->mDb->queryReturnLastId($sql);
  }


  function checkIfMemberInGroup($group_id, $student_id)
  {
    $sql = "SELECT  id  from  `group_members` where `group_id`='{$group_id}' AND  `student_id` = '{$student_id}'   ";
    return $this->mDb->getOne($sql);
  }

  function getMemberIdsInGroup($group_id)
  {
    $sql = "SELECT  student_id  from  `group_members` where `group_id`='{$group_id}' ";
    return $this->mDb->getAll($sql);
  }



  function checkjoinRequest($group_id, $student_id)
  {
    $sql = "SELECT  id  from  `group_join_requests` where `group_id`='{$group_id}' AND  `student_id` = '{$student_id}'   AND status = 'pending'  ";
    return $this->mDb->getOne($sql);
  }

  function checkjoinRequest2($group_id, $request_id)
  {
    $sql = "SELECT  * from  `group_join_requests` where `group_id`='{$group_id}' AND `id`='{$request_id}'  AND status = 'pending'  ";
    return $this->mDb->getRow($sql);
  }






  function getGroupMembersByParams($temp)
  {
    //   print_r($temp);die();
    $temp['sort_by'] =  $temp['sort_by'] ?  $temp['sort_by'] : 'id';
    $temp['sort_type'] =  $temp['sort_type'] ?  $temp['sort_type'] : 'desc';

    $sql =  '';
    if ($temp['teacher_id']) {
      if ($temp['report'] == '1') {
        $sql .= "SELECT sum(t.type ='unit_test' ) + sum(t.type ='general_test' )    as test_count 
        , IFNULL( SUM(CASE WHEN (t.type = 'unit_test' || t.type = 'general_test') THEN sta.exam_degree_percentage ELSE 0 END )/(sum(t.type ='unit_test' ) + sum(t.type ='general_test' ) ) , 0) as total_degree_percentage  , ";
      } else {
        $sql .= "SELECT count(sta.id) as test_count , IFNULL( SUM(sta.exam_degree_percentage  ) /  count(sta.id) , 0) as total_degree_percentage ,";
      }
      $sql .= " u.img, u.full_name, u.mobile   , u.country_code ,gm.student_id  ,gm.date_added ,g.name as group_name ";
    } else {
      $sql .= " SELECT u.img, u.full_name, gm.student_id  ,gm.date_added ,g.name as group_name";
    }
    $sql .= "  FROM `group_members` gm  ";
    $sql .= " LEFT JOIN `groups` g ON ( g.id = gm.group_id ) ";
    $sql .= " LEFT JOIN `users` u ON (u.id = gm.student_id) ";
    $sql .= " LEFT JOIN `student_tests_answers` sta ON (u.id = sta.user_id AND 	sta.corrected = '1' )  ";
    $sql .= $temp['teacher_id'] && ($temp['sort_by'] == 'test_count' ||  $temp['sort_by'] == 'total_degree_percentage') ? " LEFT JOIN `tests_shares` ts ON (ts.id = sta.share_id)  " : " ";
    $sql .= $temp['teacher_id'] ? " LEFT JOIN `tests` t ON (t.id = sta.test_id  ) " : " ";


    $sql .= "where  g.is_deleted !='1' AND u.is_deleted != '1' AND gm.`group_id` in ({$temp['group_id']}) ";
    $sql .= $temp['teacher_id'] ? " AND g.teacher_id = '{$temp['teacher_id']}' ": "";
    $sql .= $temp['searchKey'] ? ' AND (u.full_name like "%' . $temp['searchKey'] . '%"  || u.id = "' . $temp['searchKey'] . '"   ) ' : '';
    $sql .= $temp['specialize_id'] ? ' AND ( u.specialize_id = "' . $temp['specialize_id'] . '"   ) ' : '';
    $sql .= $temp['grade_id'] ? ' AND (  u.grade_id = "' . $temp['grade_id'] . '"   ) ' : '';
    $sql .= $temp['teacher_id'] && ($temp['sort_by'] == 'test_count' ||  $temp['sort_by'] == 'total_degree_percentage') ? ' AND (  ts.teacher_id = "' . $temp['teacher_id'] . '"    ) ' : '';

    $sql .= " group by gm.student_id  ";
    if ($temp['sort_by'] == 'id') {
      $sql .=    " order by u.`id` {$temp['sort_type']} ";
    } else if ($temp['sort_by'] == 'user_name') {
      $sql .=    " order by u.`full_name` {$temp['sort_type']} ";
    } else if ($temp['sort_by'] == 'total_degree_percentage') {
      $sql .=    " order by total_degree_percentage {$temp['sort_type']} ";
    } else if ($temp['sort_by'] == 'test_count') {
      $sql .=    " order by test_count {$temp['sort_type']} ";
    }
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    // echo $sql;die();
    $res = $this->mDb->getAll($sql);
    return $res;
  }
  function getCountGroupMembersByParams($temp)
  {
    $sql = "SELECT   COUNT( DISTINCT gm.student_id) FROM `group_members` gm ";
    $sql .= " LEFT JOIN `groups` g ON ( g.id = gm.group_id ) ";
    $sql .= " LEFT JOIN `users` u ON (u.id = gm.student_id) ";
    $sql .= "where  g.is_deleted !='1' AND u.is_deleted != '1' AND gm.`group_id` in ({$temp['group_id']}) ";
    $sql .= $temp['searchKey'] ? ' AND (u.full_name like "%' . $temp['searchKey'] . '%"  || u.id = "' . $temp['searchKey'] . '"   ) ' : '';
    $sql .= $temp['specialize_id'] ? ' AND ( u.specialize_id = "' . $temp['specialize_id'] . '"   ) ' : '';
    $sql .= $temp['grade_id'] ? ' AND (  u.grade_id = "' . $temp['grade_id'] . '"   ) ' : '';

    // echo $sql; die();
    return $this->mDb->getOne($sql);
  }





  // function getGroupMembersByParams($temp)
  // {
  //   $sql = "SELECT   u.img, u.full_name, u.mobile   , u.country_code ,gm.student_id  ,gm.date_added ,g.name as group_name  FROM `group_members` gm ";
  //   $sql .= " LEFT JOIN `groups` g ON ( g.id = gm.group_id ) ";
  //   $sql .= " LEFT JOIN `users` u ON (u.id = gm.student_id) ";
  //   $sql .= "where  g.is_deleted !='1' AND u.is_deleted != '1' AND gm.`group_id` in ({$temp['group_id']}) ";
  //   $sql .= $temp['searchKey'] ? ' AND (u.full_name like "%' . $temp['searchKey'] . '%"  || u.id = "' . $temp['searchKey'] . '"  ) ' : '';
  //   $sql .= "  order by gm.`id` DESC ";
  //   $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
  //         LIMIT 0 , 10  ';
  //   //  p($sql);

  //   return $this->mDb->getAll($sql);
  // }




  function getJoinRequestsByParams($temp)
  {
    global $USER_DATA;
    $sql = "SELECT  u.img, u.full_name , u.mobile , u.country_code , gjr.student_id,  gjr.status  , gjr.id as request_id ,gjr.group_id , gjr.date_added   FROM `group_join_requests` gjr ";
    $sql .= " LEFT JOIN `groups` g ON ( g.id = gjr.group_id ) ";
    $sql .= " LEFT JOIN `users` u ON (u.id = gjr.student_id) ";
    $sql .= "where gjr.status ='pending' AND g.is_deleted !='1' AND  g.`teacher_id` = '" . $USER_DATA['id'] . "' AND  gjr.`group_id`='{$temp['group_id']}'  ";
    $sql .= $temp['searchKey'] ? ' AND (u.full_name like "%' . $temp['searchKey'] . '%"  || u.id = "' . $temp['searchKey'] . '"  ) ' : '';
    $sql .= "  order by gjr.`id` DESC ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
          LIMIT 0 , 10  ';
    // p($sql);

    return $this->mDb->getAll($sql);
  }

  function deleteJoinRequest($request_id)
  {
    global $USER_DATA;
    $sql = "DELETE  FROM `group_join_requests` ";
    $sql .= " Where `id` = '{$request_id}' AND student_id = '" . $USER_DATA['id'] . "' ";
    // p($sql);
    return $this->mDb->query($sql);
  }


  function changeStatusOfJoin_request($request_id, $status)
  {
    $sql = "UPDATE `group_join_requests` SET `status` = '{$status}'  ";
    $sql .= " Where id ='{$request_id}' ";
    // p($sql);
    return $this->mDb->query($sql);
  }
  function deleteJoin_requests($student_id, $group_id)
  {
    $sql = "DELETE  FROM `group_join_requests` ";
    $sql .= " Where `group_id` = '{$group_id}' AND student_id = '{$student_id}' ";
    // p($sql);
    return $this->mDb->query($sql);
  }


  function  addMemberToGroup($temp)
  {
    $sql = "INSERT INTO `group_members` SET ";
    $sql .= " `student_id` = '{$temp['student_id']}' , ";
    $sql .= " `group_id` = '{$temp['group_id']}', ";
    $sql .= " `date_added` = '{$this->dateTime}'";
    return $this->mDb->queryReturnLastId($sql);
  }

  function acceptJoinRequest($temp)
  {
    $res = $this->addMemberToGroup($temp);
    if ($res) {
      $this->changeStatusOfJoin_request($temp['request_id'], 'accepted');
    }
    return $res;
  }
  function deleteMemberFromGroup($group_id, $student_id)
  {
    $sql = "DELETE  FROM `group_members` ";
    $sql .= " Where `group_id` = '{$group_id}' AND student_id = '{$student_id}' ";
    // p($sql);
    return $this->mDb->query($sql);
  }





  // // // // // // // // // // // // // // // posts  // // // // // // // // // // // // // //



  function getPostsByParams($temp)
  {
    $sql = "SELECT gp.content , gp.id , gp.id as post_id , gp.date_added , gp.date_edited , gp.post_type  , gp.can_download_attachements FROM `group_posts` gp ";

    $sql .= "where gp.is_deleted !='1' AND gp.group_id ='{$temp['group_id']}'  ";
    $sql .= $temp['searchKey'] ? ' AND (gp.content like "%' . $temp['searchKey'] . '%" ) ' : '';
    $sql .= "  order by gp.`id` desc ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
          LIMIT 0 , 10  ';

    //echo $sql;
    $res = $this->mDb->getAll($sql);
    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['attachments'] = $this->getPostAttachments($res[$i]['id']);

      $res[$i]['can_download_attachements'] =   $res[$i]['can_download_attachements']  == '1' ?  true : false;


      $res[$i]['content'] = retNewLine($res[$i]['content']);
      if ($res[$i]['post_type'] == 'test_shared') {
        $res[$i]['share_id'] =      $this->testObj->getShare_idByPost_id($res[$i]['id']);
        $res[$i]['shared_test_details'] =      $this->testObj->getSharedTestDetails($res[$i]['share_id']);
      }
      if ($res[$i]['post_type'] == 'meet_shared') {
        $res[$i]['share_id'] =      $this->meetObj->getShare_idByPost_id($res[$i]['id']);
        $res[$i]['shared_test_details'] =     $this->meetObj->getSharedMeetDetails($res[$i]['share_id']);
      }
    }
    return $res;
  }
 
  function getPostDetails($post_id)
  {

    $sql = "SELECT gp.content , gp.id , gp.id as post_id , gp.date_added , gp.date_edited ,gp.post_type , gp.can_download_attachements   FROM `group_posts`  gp ";
    $sql .= "where gp.is_deleted !='1' AND  gp.`id` ='{$post_id}'   ";
    $res = $this->mDb->getRow($sql);
    if ($res) {
      $res['attachments'] = $this->getPostAttachments($post_id);
      $res['can_download_attachements'] =   $res['can_download_attachements']  == '1' ?  true : false;
      $res['content'] = retNewLine($res['content']);
      if ($res['post_type'] == 'test_shared') {
        $res['share_id'] = $this->testObj->getShare_idByPost_id($res['id']);
        $res['shared_test_details'] = $this->testObj->getSharedTestDetails($res['share_id']);
      }
      if ($res['post_type'] == 'meet_shared') {
        $res['share_id'] =      $this->meetObj->getShare_idByPost_id($res['id']);
        $res['shared_test_details'] =     $this->meetObj->getSharedMeetDetails($res['share_id']);
      }
    }
    return $res;
  }
  function getGroup_idByPost_id($post_id)
  {
    $sql = "SELECT gp.group_id FROM `group_posts`  gp ";
    $sql .= "where gp.is_deleted !='1' AND  gp.`id` ='{$post_id}'   ";
    return $this->mDb->getOne($sql);
  }

  function addPost($temp)
  {

    if (isset($temp['can_download_attachements'])) {
      $temp['can_download_attachements'] = $temp['can_download_attachements'] ? "1" : "0";
    } else {
      $temp['can_download_attachements'] = '1';
    }
    $temp['content'] = str_replace("'", "\'", $temp['content']);
    $sql = "INSERT INTO `group_posts` SET ";
    // $sql .= " `teacher_id` = '" . $USER_DATA['id'] . "' , ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `group_id` = '{$temp['group_id']}', ";
    $sql .= " `content` = '{$temp['content']}', ";
    $sql .= " `post_type` = '{$temp['post_type']}', ";
    $sql .= " `can_download_attachements` = '{$temp['can_download_attachements']}', ";
    $sql .= " `date_added` = '{$this->dateTime}'";
    //  p($sql);
    $post_id = $this->mDb->queryReturnLastId($sql);
    if ($post_id) {
      $this->addPostAttachments($temp['attachments'], $post_id);
    }
    return $post_id;
  }

  function editPost($temp)
  {
    $temp['content'] = str_replace("'", "\'", $temp['content']);

    if (isset($temp['can_download_attachements'])) {
      $temp['can_download_attachements'] = $temp['can_download_attachements'] ? "1" : "0";
    } else {
      $temp['can_download_attachements'] = '1';
    }
    $sql = "UPDATE `group_posts` SET ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `content` = '{$temp['content']}', ";
    $sql .= " `can_download_attachements` = '{$temp['can_download_attachements']}', ";
    $sql .= " `date_edited` = '{$this->dateTime}'  where id ='{$temp['post_id']}'   ";
    // p($sql);
    $res = $this->mDb->query($sql);
    if ($res) {
      $this->deletePostAttachments($temp['post_id']);
      $this->addPostAttachments($temp['attachments'], $temp['post_id']);
    }
    return $this->getPostDetails($temp['post_id']);
  }



  function addPostAttachments($attachments, $post_id)
  {
    if (count($attachments)) {
      for ($i = 0; $i < count($attachments); $i++) {
        # code...
        $attachments[$i]['file'] = str_replace("'", "\'", $attachments[$i]['file']);

        $sql = "INSERT INTO `group_post_attachments` SET ";
        $sql .= " `post_id` = '{$post_id}', ";
        $sql .= " `file` = '{$attachments[$i]['file']}', ";
        $sql .= " `attachment_type` = '{$attachments[$i]['attachment_type']}' ";
        // echo $sql;
        // die();
        $this->mDb->query($sql);
      }
    }
  }

  function getPostAttachments($post_id)
  {
    $sql = "SELECT `file`,`attachment_type` , `id` FROM `group_post_attachments` ";
    $sql .= " WHERE  `post_id` = '{$post_id}'   ";
    $res = $this->mDb->getAll($sql);
    $res =   getFileSizeArr($res, 'posts');
    return $res;
  }

  function deletePostAttachments($post_id)
  {
    $sql = "DELETE  FROM `group_post_attachments` ";
    $sql .= " Where `post_id` = '{$post_id}' ";
    return $this->mDb->query($sql);
  }


  function deletePost($post_id)
  {
    $sql = "UPDATE `group_posts` SET is_deleted = '1'  ";
    $sql .= " Where id ='{$post_id}' ";
    // p($sql);
    return $this->mDb->query($sql);
  }

  function getGroup_ids($teacher_id)
  {
    $sql = "SELECT f.id  FROM `groups` f ";
    $sql .= "  where f.is_deleted= '0' AND f.`teacher_id` ='{$teacher_id}' ";
    return $this->mDb->getAll($sql);
  }
  function getGroupOwner($id)
  {
    $sql = "SELECT f.teacher_id  FROM `groups` f ";
    $sql .= "  where f.is_deleted= '0' AND f.`id` ='{$id}' ";
    return $this->mDb->getOne($sql);
  }

  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////


  function checkTeacherRlatedToGroup_id($group_id, $teacher_id)
  {
    $sql = "SELECT  `id` from  `groups`  ";
    $sql .= " where  `id`= '{$group_id}' AND teacher_id = '{$teacher_id}'  ";
    // echo $sql;
    return $this->mDb->getOne($sql);
  }

  function checkStudentRlatedToGroup_id($group_id, $student_id)
  {
    $sql = "SELECT  g.`id` from  `groups` g  ";
    $sql .= " LEFT JOIN `group_members` gm ON (gm.group_id = g.id) ";
    $sql .= " where g.`id` in ($group_id) AND gm.student_id = '{$student_id}'    ";
    // echo $sql;die();
    return $this->mDb->getOne($sql);
  }
}
