<?php

$subjectObj = new Subject();

class Subject
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }

  function getSubjectsToSignInOrEdit($grade_id, $field_of_study_id=null)
  {
      
      $stmt = "SELECT id FROM `fields_of_study` WHERE id != :field_of_study_id";
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':field_of_study_id', $field_of_study_id);
        $query->execute();
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

    $ids = "(" . implode(",", $dat) . ")";
    
    $sql = "SELECT f.name , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color ,f.`stage_id` ,f.`grade_id`, sl.name  as  stage_name ,gl.name  as grade_name , f.semester ";
    $sql .= $field_of_study_id && $field_of_study_id != "undefined" ? ", foss.field_of_study_id, fosl.name as field_of_study_name " :"";
    $sql .= " FROM `subjects` f ";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( f.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    // $sql .= " LEFT JOIN `grades_langs` spl ON  ( f.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( f.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    if($field_of_study_id && $field_of_study_id != "undefined"){
        $sql .= " LEFT JOIN `fields_of_study_subjects` foss  ON  ( f.`id` = foss.`subject_id` ) ";
        $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( fosl.`fields_of_study_id` = foss.`field_of_study_id` AND fosl.`lang_code` = '" . LANGUAGE . "' ) ";
    }
    $sql .= " where f.`status` ='1' AND f.is_deleted !='1' AND f.`grade_id` in ({$grade_id}) ";
    // $sql .=  !$specialize_id  ? "  AND  f.`grade_id` in ({$grade_id}) "  : ' ';
    // $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $field_of_study_id && $field_of_study_id != "undefined" ?  " AND foss.field_of_study_id = '{$field_of_study_id}'" :  " ";

    $sql .= " group by f.id   order by f.`sort` asc ";
// echo $sql;die();
     $data =  $this->mDb->getAll($sql);
  
    
    return $this->getBranchesAndFieldsForEachSubject($data);
  }


  function getSubjects($grade_id, $specialize_id, $semester)
  {
    
    global  $USER_DATA;
    
        $stmt = "SELECT id FROM `fields_of_study` WHERE id != :user_field_of_study_id";
        
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':user_field_of_study_id', $USER_DATA['field_of_study_id']);
        $query->execute();
        
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

   
    
    $ids = "(" . implode(",", $dat) . ")";
    $sql  = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`, f.dont_show_branches_in_general_tests ";
    $sql .= ", (SELECT COUNT(id) FROM `final_review_notes` WHERE subject_id = f.id AND status = '1' ) as final_notes_count";
    $sql .= ", (SELECT COUNT(id) FROM `final_review_videos` WHERE subject_id = f.id AND `status` ='1'  ) as final_views_count ";
    $sql .= ", (SELECT COUNT(id) FROM `examine_questions` WHERE subject_id = f.id AND `status` ='1') as final_examin_count ";
    $sql .= ", (SELECT COUNT(id) FROM `important_article_questions` WHERE subject_id = f.id AND `status` ='1') as final_article_count ";
    $sql .= "  FROM `subjects` f ";
    $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON (foss.subject_id = f.id) ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  "  AND  f.`grade_id` in ({$grade_id}) ";
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
     $sql .=  $USER_DATA['field_of_study_id'] ?  " AND (f.`grade_id` in ({$grade_id}) AND (foss.field_of_study_id = '{$USER_DATA['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    $sql .= " group by f.id   order by f.`sort` asc ";
    // echo $sql;die();
    $data =  $this->mDb->getAll($sql);
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  function getSubjectsForFinalReview($grade_id, $specialize_id, $semester)
  {
      
    // echo $grade_id;die();
    global  $USER_DATA;
    // Prepare the SQL statement
        $stmt = "SELECT id FROM `fields_of_study` WHERE id != :user_field_of_study_id";
        // Bind parameters and execute the statement
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':user_field_of_study_id', $USER_DATA['field_of_study_id']);
        $query->execute();
        // Fetch the results into an array
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

   
    
    $ids = "(" . implode(",", $dat) . ")";
    // echo $dd;die();
    
    $sql  = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`, f.dont_show_branches_in_general_tests ";
    $sql .= ",(COUNT(frn.id) + COUNT(imq.id) + COUNT(eq.id) + COUNT(frv.id)) as total_count ";
    $sql .= "  FROM `subjects` f ";
    $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON (foss.subject_id = f.id) ";
    $sql .= " LEFT JOIN `final_review_notes` frn ON (frn.subject_id = f.id) ";
    $sql .= " LEFT JOIN `final_review_videos` frv ON (frv.subject_id = f.id) ";
    $sql .= " LEFT JOIN `examine_questions` eq ON (eq.subject_id = f.id AND eq.`parent_id` = '0') ";
    $sql .= " LEFT JOIN `important_article_questions` imq ON (imq.subject_id = f.id) ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  "  AND  f.`grade_id` in ({$grade_id}) ";
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $USER_DATA['field_of_study_id'] ?  " AND (f.`grade_id` in ({$grade_id}) AND (foss.field_of_study_id = '{$USER_DATA['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    $sql .= " group by f.id HAVING total_count > 0  order by f.`sort` asc ";
    $data =  $this->mDb->getAll($sql);
    // echo $sql;die();
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  
  function getSubjectsForQuestionBank($grade_id, $specialize_id, $semester)
  {
      
    // echo $grade_id;die();
    global  $USER_DATA;
    // Prepare the SQL statement
        $stmt = "SELECT id FROM `fields_of_study` WHERE id != :user_field_of_study_id";
        // Bind parameters and execute the statement
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':user_field_of_study_id', $USER_DATA['field_of_study_id']);
        $query->execute();
        // Fetch the results into an array
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

   
    
    $ids = "(" . implode(",", $dat) . ")";
    // echo $dd;die();
    
    $sql  = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`, f.dont_show_branches_in_general_tests ";
    $sql .= ", (SELECT COUNT(qb.id) FROM questions_bank qb WHERE qb.subject_id = f.subject_id AND qb.status = '1' AND ( qb.semester = 'first' || qb.semester = 'both' )) AS total_count ";
    $sql .= "  FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  "  AND  f.`grade_id` in ({$grade_id}) ";
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $USER_DATA['field_of_study_id'] ?  " AND (f.`grade_id` in ({$grade_id}) AND (foss.field_of_study_id = '{$USER_DATA['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    $sql .= " group by f.id HAVING total_count > 0  order by f.`sort` asc ";
    $data =  $this->mDb->getAll($sql);
    // echo $sql;die();
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  
  
   function getSubjectsForBubbleSheet($grade_id, $specialize_id, $semester, $type)
  {
      
    // echo $grade_id;die();
    global  $USER_DATA;
    // Prepare the SQL statement
        $stmt = "SELECT id FROM `fields_of_study` WHERE id != :user_field_of_study_id";
        // Bind parameters and execute the statement
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':user_field_of_study_id', $USER_DATA['field_of_study_id']);
        $query->execute();
        // Fetch the results into an array
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

   
    
    $ids = "(" . implode(",", $dat) . ")";
    // echo $dd;die();
    
    $sql  = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`, f.dont_show_branches_in_general_tests ";
    $sql .= ", (SELECT COUNT(t.id) FROM tests t WHERE `print_type` LIKE '%bubble_sheet%' AND t.subject_id = f.subject_id AND t.status = '1' AND ( t.semester = 'first' || t.semester = 'both' ) AND t.`type` = '{$type}') AS total_count ";
    $sql .= "  FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  "  AND  f.`grade_id` in ({$grade_id}) ";
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $USER_DATA['field_of_study_id'] ?  " AND (f.`grade_id` in ({$grade_id}) AND (foss.field_of_study_id = '{$USER_DATA['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    $sql .= " group by f.id HAVING total_count > 0  order by f.`sort` asc ";
    $data =  $this->mDb->getAll($sql);
    // echo $sql;die();
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  
    function getIdsSubjects($grade_id, $specialize_id, $semester)
  {
    
    // echo $grade_id;die();
    global  $USER_DATA;
    // Prepare the SQL statement
        $stmt = "SELECT id FROM `fields_of_study` WHERE id != :user_field_of_study_id";
        // Bind parameters and execute the statement
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':user_field_of_study_id', $USER_DATA['field_of_study_id']);
        $query->execute();
        // Fetch the results into an array
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

   
    
    $ids = "(" . implode(",", $dat) . ")";
    // echo $dd;die();
    
    $sql  = "SELECT f.id FROM `subjects` f ";
    $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON (foss.subject_id = f.id) ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  "  AND  f.`grade_id` in ({$grade_id}) ";
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
    // $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $USER_DATA['field_of_study_id'] ?  " AND (f.`grade_id` in ({$grade_id}) AND (foss.field_of_study_id = '{$USER_DATA['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    $sql .= " group by f.id   order by f.`sort` asc ";
    // echo $sql;die();
    $data =  $this->mDb->getAll($sql);
    
    // $ids = array_map(function($item) {
    //     return $item['id'];
    // }, $data);
    
    return $data;
    // return '(' . implode(',', $ids) . ')';
  }
  
  
  function getIdsTeacherSubjects($grade_id, $specialize_id, $semester)
  {
    
    // echo $grade_id;die();
    global  $USER_DATA;
    
    $sql  = "SELECT f.subject_id FROM `teacher_subjects` f WHERE `user_id` = '{$USER_DATA['id']}'";
    $ids =  $this->mDb->getAll($sql);
    
    // $ids = array_map(function($item) {
    //     return $item['id'];
    // }, $data);
    
    return $ids;
    // return '(' . implode(',', $ids) . ')';
  }
  
  
  function getSubjectsForCourses($grade_id, $specialize_id, $semester, $set_from=null)
  {
    //   echo $grade_id;die();
    global  $USER_DATA;
    $sql = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`, u.user_type  FROM `courses` c ";
    $sql .= "LEFT JOIN `subjects` f ON  f.id = c.subject_id ";
    $sql .= "LEFT JOIN `users` u ON  u.id = c.added_by ";
    $sql .= " LEFT JOIN `videos_courses` vc ON  vc.course_id = c.id";
    $sql .= " where f.`status` ='1' AND f.is_deleted !='1'  AND c.is_deleted !='1' AND vc.status = '1'  AND vc.is_deleted != '1' ";
    $sql .= $set_from ? " AND c.set_from = '{$set_from}' ":"";
    $sql .=  !$specialize_id  ? "  AND  f.`grade_id` in ({$grade_id}) "  : ' ';
    $sql .= $semester ? "  AND ( c.`semester` = '{$semester}' ||  c.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .= " group by f.id ";
    $sql .= " HAVING COUNT(vc.id) > 0 ";
    $sql .= "order by f.`sort` asc ";
    // echo $sql;die();
    $data = $this->mDb->getAll($sql);
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  function checkShowForCourses($grade_id, $specialize_id, $semester)
  {
    //   echo $grade_id;die();
    global  $USER_DATA;
    $sql = "SELECT c.id, u.user_type, c.set_from  FROM `courses` c ";
    $sql .= "LEFT JOIN `subjects` f ON  f.id = c.subject_id ";
    $sql .= "LEFT JOIN `users` u ON  u.id = c.added_by ";
    $sql .= " LEFT JOIN `videos_courses` vc ON  vc.course_id = c.id";
    $sql .= " where f.`status` ='1' AND f.is_deleted !='1'  AND c.is_deleted !='1' AND vc.status = '1'  ";
    $sql .=  !$specialize_id  ? "  AND  f.`grade_id` in ({$grade_id}) "  : ' ';
    $sql .= $semester ? "  AND ( c.`semester` = '{$semester}' ||  c.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .= " group by c.id   ";
    $sql .= " HAVING COUNT(vc.id) > 0 ";
    $sql .= "order by f.`sort` asc ";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }
  


  function getGridIdAndSpecializeIdBySubjectId($subject_id)
  {
    $sql = "SELECT f.specialize_id , f.grade_id ,f.semester    FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1' AND id ='{$subject_id}'  ";
    // echo $sql;die();
    return $this->mDb->getRow($sql);
  }


  function getTeacher_stages($teacher_id)
  {
    $sql = "SELECT  ts.stage_id ,sl.name  as  stage_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `stages` s  ON  ( s.`id` = ts.`stage_id` )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE  ts.user_id = '{$teacher_id}' AND s.is_deleted != '1'   group by  ts.stage_id ORDER BY ts.stage_id";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }
  
  
//   function getTeacher_grades($teacher_id, $stage_id)
//   {
//     $sql = "SELECT  ts.specialize_id , ts.grade_id ,gl.name  as  grade_name FROM `teacher_subjects` ts ";
//     $sql .= " LEFT JOIN `grades` g  ON  ( g.`id` = ts.`grade_id` )";
//     $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
//     $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.stage_id = '{$stage_id}' AND g.is_deleted != '1'   group by  ts.grade_id  order by g.sort asc  ";
//     // echo $sql;die();
//     return $this->mDb->getAll($sql);
//   }
  
  
  function getTeacher_grades($teacher_id, $stage_id)
  {
    $sql = "SELECT  COUNT(foss.id) as fields_count, ts.field_of_study_id , ts.grade_id ,gl.name  as  grade_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `grades` g  ON  (g.`id` = ts.`grade_id`)";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON foss.subject_id = ts.subject_id ";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.stage_id = '{$stage_id}' AND g.is_deleted != '1'   group by  ts.grade_id  order by g.sort asc  ";
    // if($stage_id == '3'){
    //     echo $sql;die();
    // }
    return $this->mDb->getAll($sql);
  }
  
  
  function getTeacher_specializes($teacher_id,  $grade_id)
  {
    $sql = "SELECT  ts.specialize_id ,spl.name  as specialize_name  FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `grades` g  ON  ( g.`id` = ts.`specialize_id` )";
    $sql .= " LEFT JOIN `grades_langs` spl  ON  ( ts.`specialize_id` = spl.`grade_id`  AND spl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.grade_id = '{$grade_id}' AND g.is_deleted != '1'   group by  ts.specialize_id  order by g.sort asc  ";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }
  
  function getTeacher_fields($teacher_id,  $grade_id)
  {
    $sql = "SELECT  ts.field_of_study_id ,fosl.name  as field_study_name  FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.grade_id = '{$grade_id}'  group by  ts.`field_of_study_id` ";
    // if($grade_id == '15'){
    //     echo $sql;die();
    // }
    return $this->mDb->getAll($sql);
  }


  function getTeacher_subjects($teacher_id, $grade_id, $field_of_study_id, $semester)
  {
    $sql = "SELECT s.id, s.name,s.country_id,s.stage_id,s.specialize_id,s.semester,s.separate_subject,s.img,
    s.cover_color,s.subject_direction,s.show_in_home,s.description_en,s.status,s.sort,
    s.dont_show_branches_in_general_tests,s.added_by,s.is_deleted,s.date_added, ts.field_of_study_id, fosl.name as field_of_study_name";
    // $sql .= ", COUNT(frn.id) AS final_notes_count,COUNT(imq.id) AS final_article_count,COUNT(eq.id) AS final_examin_count,COUNT(frv.id) AS final_views_count ";
    $sql .= ",(SELECT COUNT(frn.id) FROM final_review_notes frn WHERE frn.subject_id = ts.subject_id AND status = '1'  AND ( frn.semester = '{$semester}' || frn.semester = 'both' )) AS final_notes_count ";
    $sql .= ",(SELECT COUNT(imq.id) FROM important_article_questions imq WHERE imq.subject_id = ts.subject_id AND status = '1'  AND ( imq.semester = '{$semester}' || imq.semester = 'both' )) AS final_article_count ";
    $sql .= ",(SELECT COUNT(eq.id) FROM examine_questions eq WHERE eq.subject_id = ts.subject_id AND status = '1'  AND ( eq.semester = '{$semester}' || eq.semester = 'both' )) AS final_examin_count ";
    $sql .= ",(SELECT COUNT(frv.id) FROM final_review_videos frv WHERE frv.subject_id = ts.subject_id AND status = '1' ) AS final_views_count ";
    $sql .= ",(SELECT COUNT(qb.id) FROM questions_bank qb WHERE qb.subject_id = ts.subject_id AND status = '1'  AND ( qb.semester = '{$semester}' || qb.semester = 'both' )) AS question_bank_count ";
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%bubble_sheet%' AND `type` = 'unit_test'  AND ( `semester` = '{$semester}' || `semester` = 'both' )) as bubble_sheet_count_for_unit_test ";
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%bubble_sheet%' AND `type` = 'general_test'   AND ( `semester` = '{$semester}' || `semester` = 'both' )) as bubble_sheet_count_for_general_test ";
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%bubble_sheet%' AND `type` = 'unit_exercise'   AND ( `semester` = '{$semester}' || `semester` = 'both' )) as bubble_sheet_count_for_unit_exercise ";
    
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%pdf%' AND `type` = 'unit_test'  AND ( `semester` = '{$semester}' || `semester` = 'both' )) as pdf_count_for_unit_test ";
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%pdf%' AND `type` = 'general_test'   AND ( `semester` = '{$semester}' || `semester` = 'both' )) as pdf_count_for_general_test ";
    $sql .= ", (SELECT COUNT(id) FROM `tests` WHERE subject_id = ts.subject_id AND `status` ='1'  AND  is_deleted !='1' AND `print_type` LIKE '%pdf%' AND `type` = 'unit_exercise'   AND ( `semester` = '{$semester}' || `semester` = 'both' )) as pdf_count_for_unit_exercise ";
    $sql .= ", ts.subject_id  ,ts.specialize_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name FROM `teacher_subjects` ts "; // ,spl.name  as specialize_name
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = ts.`subject_id` )";
    // $sql .= " LEFT JOIN `final_review_notes` frn ON (frn.subject_id = ts.subject_id) ";
    // $sql .= " LEFT JOIN `final_review_videos` frv ON (frv.subject_id = ts.subject_id) ";
    // $sql .= " LEFT JOIN `examine_questions` eq ON (eq.subject_id = ts.subject_id) ";
    // $sql .= " LEFT JOIN `important_article_questions` imq ON (imq.subject_id = ts.subject_id) ";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `fields_of_study_subjects` foss  ON  ( ts.`subject_id` = foss.`subject_id`)";
    $sql .= " LEFT JOIN `fields_of_study` fos  ON  ( foss.`field_of_study_id` = fos.`id`)";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'   AND  s.is_deleted !='1' AND  s.status = '1'  ";
    $sql .= $semester ? "  AND ( s.`semester` = '{$semester}'  || s.semester='both') "  : ' ';
    $sql .= !$field_of_study_id  && $grade_id ? " AND   ts.grade_id in ({$grade_id})    " :   " ";
    // $sql .=  $specialize_id  && $grade_id  ?  " AND ( (ts.`grade_id` in ({$grade_id}) AND (ts.`specialize_id` is null ||  ts.`specialize_id` ='' ) ) || ts.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .=  $field_of_study_id  && $grade_id  ?  " AND  ts.`grade_id` in ({$grade_id}) AND ts.`field_of_study_id` = '{$field_of_study_id}' " :  " ";
    $sql.=" GROUP BY s.id ORDER BY s.sort ASC";
    
//   if($grade_id == '10'){
        // echo $sql;die();
//   }
    $data =  $this->mDb->getAll($sql);
    return $this->getBranchesAndFieldsForEachSubject($data);
  }
  
  
  function getTeacher_subjects_for_final_review($teacher_id, $grade_id, $specialize_id, $semester)
  {

    $sql = "SELECT s.id, s.name,s.country_id,s.stage_id,s.specialize_id,s.semester,s.separate_subject,s.img,
    s.cover_color,s.subject_direction,s.show_in_home,s.description_en,s.status,s.sort,
    s.dont_show_branches_in_general_tests,s.added_by,s.is_deleted,s.date_added, ts.field_of_study_id, fosl.name as field_of_study_name";
    // $sql .= ", (COUNT(frn.id) + COUNT(imq.id) + COUNT(eq.id) + COUNT(frv.id)) as total_count ";
    $sql .= ",(SELECT COUNT(frn.id) FROM final_review_notes frn WHERE frn.subject_id = ts.subject_id AND frn.status = '1' AND ( frn.semester = '{$semester}' || frn.semester = 'both' )) ";
    $sql .= "+(SELECT COUNT(imq.id) FROM important_article_questions imq WHERE imq.subject_id = ts.subject_id AND imq.status = '1' AND ( imq.semester = '{$semester}' || imq.semester = 'both' ))";
    $sql .= "+(SELECT COUNT(eq.id) FROM examine_questions eq WHERE eq.subject_id = ts.subject_id AND eq.status = '1' AND ( eq.semester = '{$semester}' || eq.semester = 'both' ))";
    $sql .= "+(SELECT COUNT(frv.id) FROM final_review_videos frv WHERE frv.subject_id = ts.subject_id AND frv.status = '1' ) AS total_count ";
    $sql .= ", ts.subject_id  ,ts.specialize_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = ts.`subject_id` )";
    // $sql .= " LEFT JOIN `final_review_notes` frn ON (frn.subject_id = s.id) ";
    // $sql .= " LEFT JOIN `final_review_videos` frv ON (frv.subject_id = s.id) ";
    // $sql .= " LEFT JOIN `examine_questions` eq ON (eq.subject_id = s.id AND eq.parent_id = '0' AND ( eq.`semester` = '{$semester}'  || eq.semester='both')) ";
    // $sql .= " LEFT JOIN `important_article_questions` imq ON (imq.subject_id = s.id AND ( imq.`semester` = '{$semester}'  || imq.semester='both')) ";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `fields_of_study` fos  ON  ( ts.`field_of_study_id` = fos.`id`)";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    // $sql .= " LEFT JOIN `subjects_branches` sb ON sb.subject_id = s.id ";
    // $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON ( sbl.subject_branch_id = sb.id AND sbl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'   AND  s.is_deleted !='1' AND  s.status = '1'  ";
    // $sql .= " AND frn.is_deleted != '1' AND frv.is_deleted != '1' AND imq.is_deleted != '1' AND eq.is_deleted != '1'";
    $sql .= $semester ? "  AND ( s.`semester` = '{$semester}'  || s.semester='both') "  : ' ';
    // $sql .= $semester ? "  AND ( imq.`semester` = '{$semester}'  || imq.semester='both') "  : ' ';
    // $sql .= $semester ? "  AND ( eq.`semester` = '{$semester}'  || eq.semester='both') "  : ' ';
    $sql .= !$specialize_id  && $grade_id ? " AND   ts.grade_id in ({$grade_id})    " :   " ";
    $sql .=  $specialize_id  && $grade_id  ?  " AND ( (ts.`grade_id` in ({$grade_id}) AND (ts.`specialize_id` is null ||  ts.`specialize_id` ='' ) ) || ts.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql.=" GROUP BY s.id HAVING total_count > 0 ORDER BY s.sort ASC";
    // if($grade_id == '1'){
    //     echo $sql;die();
    // }
    $data =  $this->mDb->getAll($sql);
    
    // foreach($data as &$item){
    //     $sql = "SELECT COUNT(id) FROM `final_review_notes` WHERE subject_id = '{$item['subject_id']}' ";
    //     $item['final_notes_count'] = $this->mDb->getOne($sql);
        
    //     $sql = "SELECT COUNT(id) FROM `final_review_videos` WHERE subject_id = '{$item['subject_id']}'";
    //     $item['final_videos_count'] = $this->mDb->getOne($sql);
        
    //     $sql = "SELECT COUNT(id) FROM `examine_questions` WHERE subject_id = '{$item['subject_id']}'";
    //     $item['final_examine_count'] = $this->mDb->getOne($sql);
        
    //     $sql = "SELECT COUNT(id) FROM `important_article_questions` WHERE subject_id = '{$item['subject_id']}'";
    //     $item['final_article_count'] = $this->mDb->getOne($sql);
    // }
    return $this->getBranchesAndFieldsForEachSubjectForFinalReview($data);
  }
  
  function getTeacher_subjects_for_question_bank($teacher_id, $grade_id, $field_of_study_id, $semester)
  {

    $sql = "SELECT s.id, s.name,s.country_id,s.stage_id,s.specialize_id,s.semester,s.separate_subject,s.img,
    s.cover_color,s.subject_direction,s.show_in_home,s.description_en,s.status,s.sort,
    s.dont_show_branches_in_general_tests,s.added_by,s.is_deleted,s.date_added, ts.field_of_study_id, fosl.name as field_of_study_name";
    $sql .= ", (SELECT COUNT(qb.id) FROM questions_bank qb WHERE qb.subject_id = ts.subject_id AND qb.status = '1' AND ( qb.semester = '{$semester}' || qb.semester = 'both' )) AS total_count ";
    $sql .= ", ts.subject_id  ,ts.specialize_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = ts.`subject_id` )";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `fields_of_study` fos  ON  ( ts.`field_of_study_id` = fos.`id`)";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'   AND  s.is_deleted !='1' AND  s.status = '1'  ";
    $sql .= $semester ? "  AND ( s.`semester` = '{$semester}'  || s.semester='both') "  : ' ';
    $sql .= $grade_id ? " AND   ts.grade_id in ({$grade_id})    " :   " ";
    $sql .= $field_of_study_id ?  " AND ts.`field_of_study_id` in ({$field_of_study_id}) " :  " ";
    $sql.=" GROUP BY s.id HAVING total_count > 0 ORDER BY s.sort ASC";
    // if($grade_id == '17'){
    //     echo $sql;die();
    // }
    $data =  $this->mDb->getAll($sql);
    return $this->getBranchesAndFieldsForEachSubjectForQuestionBank($data);
  }
  
  function getTeacher_subjects_for_tests($teacher_id, $grade_id, $field_of_study_id, $semester, $type, $print_type)
  {

    $sql = "SELECT s.id, s.name,s.country_id,s.stage_id,s.specialize_id,s.semester,s.separate_subject,s.img,
    s.cover_color,s.subject_direction,s.show_in_home,s.description_en,s.status,s.sort,
    s.dont_show_branches_in_general_tests,s.added_by,s.is_deleted,s.date_added, ts.field_of_study_id, fosl.name as field_of_study_name";
    $sql .= ", (SELECT COUNT(t.id) FROM tests t WHERE `print_type` LIKE '%{$print_type}%' AND t.subject_id = ts.subject_id AND t.status = '1' AND t.is_deleted != '1' AND ( t.semester = '{$semester}' || t.semester = 'both' ) AND type = '{$type}') AS total_count ";
    $sql .= ", ts.subject_id  ,ts.specialize_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = ts.`subject_id` )";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `fields_of_study` fos  ON  ( ts.`field_of_study_id` = fos.`id`)";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'   AND  s.is_deleted !='1' AND  s.status = '1'  ";
    $sql .= $semester ? "  AND ( s.`semester` = '{$semester}'  || s.semester='both') "  : ' ';
    $sql .= $grade_id ? " AND   ts.grade_id in ({$grade_id})    " :   " ";
    $sql .= $field_of_study_id  ?  " AND ts.`field_of_study_id` in ({$field_of_study_id}) " :  " ";
    $sql.=" GROUP BY s.id HAVING total_count > 0 ORDER BY s.sort ASC";
    // if($grade_id == '10'){
    //     echo $sql;die();
    // }
    $data =  $this->mDb->getAll($sql);
    return $this->getBranchesAndFieldsForEachSubjectForFinalReview($data);
  }
  
  
  function getTeacher_subjectsForCourses($teacher_id, $grade_id, $specialize_id, $semester, $set_from=null)
  {
    
    // print_r($semester);die();
    $sql  = "SELECT s.* , ts.subject_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name, fosl.name as faild_of_study_name, ts.field_of_study_id as faild_of_study_id, u.user_type  FROM `courses` c ";
    $sql .= "LEFT JOIN `courses_langs` cl ON ( c.id = cl.course_id AND cl.lang_code = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = c.`subject_id` )";
    $sql .= " LEFT JOIN `users` u  ON  ( u.`id` = c.`added_by` )";
    $sql .= " LEFT JOIN `teacher_subjects` ts  ON  ( s.`id` = ts.`subject_id` )";
    $sql .= " LEFT JOIN `fields_of_study` fos  ON  ( ts.`field_of_study_id` = fos.`id`)";
    $sql .= " LEFT JOIN `fields_of_study_langs` fosl  ON  ( ts.`field_of_study_id` = fosl.`fields_of_study_id`  AND fosl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `videos_courses` vc ON  vc.course_id = c.id ";
    $sql .= " WHERE   ts.user_id = '{$teacher_id}' AND  s.is_deleted !='1' AND  c.is_deleted !='1' AND vc.status = '1' ";
    $sql .= $set_from ? " AND c.set_from = '{$set_from}' ":"";
    $sql .= $semester ? "  AND (s.`semester` = '{$semester}' || s.`semester` = 'both')"  : ' ';
    $sql .= !$specialize_id  && $grade_id ? " AND   c.grade_id in ({$grade_id})    " :   " ";
    $sql .=  $specialize_id  && $grade_id  ?  " AND ( (ts.`grade_id` in ({$grade_id}) AND (ts.`specialize_id` is null ||  ts.`specialize_id` ='' ) ) || ts.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .= "GROUP BY s.id ";
    $sql .= " HAVING COUNT(vc.id) > 0 ";
    $sql .="ORDER BY s.sort ASC";
    echo $sql; 
    die();
     $data =  $this->mDb->getAll($sql);
    
     return $this->getBranchesAndFieldsForEachSubject($data);
  }


  function getUnitOfSubject($subject_id, $semester, $subject_branch_id = null)
  {
    $sql = "SELECT f.name , f.id , f.semester   FROM `units` f ";
    $sql .= "where f.`status` ='1' AND f.mode='test' AND f.`subject_id` ='{$subject_id}'  AND  f.is_deleted !='1' ";
    $sql .= $semester  ? "  AND ( f.`semester` = '{$semester}' || f.`semester` ='both' ) "  : ' ';
    $sql .= $subject_branch_id ? "AND f.subject_branch_id = '{$subject_branch_id}' ": " AND f.subject_branch_id IS NULL";
    $sql .= "  order by f.`sort` asc ";
    // echo $sql ;die();
    return $this->mDb->getAll($sql);
  }

  function getUnitLesson($unit_id)
  {
    $sql = "SELECT f.name , f.id   FROM `unit_lessons` f ";
    $sql .= "where   f.`unit_id` ='{$unit_id}' AND  f.is_deleted !='1'  ";
    $sql .= "  order by f.`id` asc ";
    return $this->mDb->getAll($sql);
  }


  function getSubjectData($subject_id, $subject_branch_id = null)
  {
    $sql = "SELECT * FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.`id` ='{$subject_id}'  AND  f.is_deleted !='1'  ";
    // $sql .= $subject_branch_id ? " AND `subject_branch_id` = '{$subject_branch_id}' " : " ";
    // echo $sql;die();
    $item = $this->mDb->getRow($sql);
    
    $sql  = "SELECT sb.id, sbl.name, sb.image FROM `subjects_branches` sb ";
    $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
    $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ORDER BY sb.sort ASC";
        
    // echo $sql;die();
    $item['branches'] = $this->mDb->getAll($sql);
    
    return $item;
  }
  
  
  function getSubjectDataForFinalReview($subject_id, $subject_branch_id = null)
  {
    $sql = "SELECT * FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.`id` ='{$subject_id}'  AND  f.is_deleted !='1'  ";
    // $sql .= $subject_branch_id ? " AND `subject_branch_id` = '{$subject_branch_id}' " : " ";
    // echo $sql;die();
    $item = $this->mDb->getRow($sql);
    
    $sql = "SELECT sb.id, sbl.name, sb.image ";
        $sql .= ", (COUNT(frn.id) + COUNT(imq.id) + COUNT(eq.id) + COUNT(frv.id)) as total_count ";
        $sql .= " FROM `subjects_branches` sb ";
        $sql .= " LEFT JOIN `final_review_notes` frn ON (frn.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `final_review_videos` frv ON (frv.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `examine_questions` eq ON (eq.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `important_article_questions` imq ON (imq.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ";
        $sql .= " HAVING total_count > 0 ORDER BY sb.sort ASC ";
        
    // echo $sql;die();
    $item['branches'] = $this->mDb->getAll($sql);
    
    return $item;
  }
  
  function getSubjectDataForQuestionBank($subject_id, $subject_branch_id = null)
  {
    $sql = "SELECT * FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.`id` ='{$subject_id}'  AND  f.is_deleted !='1'  ";
    // $sql .= $subject_branch_id ? " AND `subject_branch_id` = '{$subject_branch_id}' " : " ";
    // echo $sql;die();
    $item = $this->mDb->getRow($sql);
    
    $sql = "SELECT sb.id, sbl.name, sb.image ";
        $sql .= ", COUNT(qb.id) as total_count ";
        $sql .= " FROM `subjects_branches` sb ";
        $sql .= " LEFT JOIN `questions_bank` qb ON (qb.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ";
        $sql .= " HAVING total_count > 0 ORDER BY sb.sort ASC ";
        
    // echo $sql;die();
    $item['branches'] = $this->mDb->getAll($sql);
    
    return $item;
  }
  

  function getUnitData($unit_id)
  {
    $sql = "SELECT * FROM `units` f ";
    $sql .= "where f.`status` ='1' AND f.mode='test' AND f.`id` ='{$unit_id}'  AND  f.is_deleted !='1'  ";
    // echo $sql;
    return $this->mDb->getRow($sql);
  }


  function getLessonData($lesson_id)
  {
    $sql = "SELECT * FROM `unit_lessons` f ";
    $sql .= "where  f.`id` ='{$lesson_id}' AND  f.is_deleted !='1'  ";
    return $this->mDb->getRow($sql);
  }

  function checkCatbyParams($subject_id, $type)
  {
    $sql = "SELECT f.id FROM `categories` f ";
    $sql .= "where f.`status` ='1' AND f.`subject_id` ='{$subject_id}' AND f.`type` ='{$type}'     ";
    // p($sql);
    return $this->mDb->getOne($sql);
  }



  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////

  function checkTeacherRelatedToSubject($teacher_id, $subject_id)
  {
    $sql = "SELECT  ts.id   FROM `teacher_subjects` ts ";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'  AND ts.`subject_id` ='{$subject_id}' ";
    //  echo $sql;die();
    return $this->mDb->getOne($sql);
  }


  function checkStudentRelatedToSubject($grade_id, $subject_id)
  {
    $sql = "SELECT  s.id   FROM `subjects` s ";
    $sql .= "WHERE   s.grade_id = '{$grade_id}'  AND s.`id` ='{$subject_id}' ";
//      echo $sql;die();
    return $this->mDb->getOne($sql);
  }
  
  
  function getBranchesAndFieldsForEachSubject($data){
      foreach($data as &$item){
        $sql = "SELECT sb.id, sbl.name, sb.image FROM `subjects_branches` sb ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ";
        $sql .= " ORDER BY sb.sort ASC ";
        
        // echo $sql;die();
        $item['branches'] = $this->mDb->getAll($sql);
        
        $sql = "SELECT fos.id, fosl.name FROM `fields_of_study` fos ";
        $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON foss.field_of_study_id = fos.id ";
        $sql .= " LEFT JOIN `fields_of_study_langs` fosl ON (fos.id = fosl.fields_of_study_id AND fosl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE foss.subject_id = '{$item['id']}'";
        
        // echo $sql;die();
        $item['fields'] = $this->mDb->getAll($sql);
    }
    
    return $data;
  }
  
  
  
  function getBranchesAndFieldsForEachSubjectForFinalReview($data){
      foreach($data as &$item){
        $sql = "SELECT sb.id, sbl.name, sb.image ";
        // $sql .= ", (COUNT(frn.id) + COUNT(imq.id) + COUNT(eq.id) + COUNT(frv.id)) as total_count ";
        $sql .= ", (SELECT COUNT(frn.id) FROM `final_review_notes` frn WHERE frn.branch_id = sb.id ) ";
        $sql .= "+ (SELECT COUNT(frv.id) FROM `final_review_videos` frv WHERE frv.branch_id = sb.id ) ";
        $sql .= "+ (SELECT COUNT(eq.id) FROM `examine_questions` eq WHERE eq.branch_id = sb.id )  ";
        $sql .= "+ (SELECT COUNT(imq.id) FROM `important_article_questions` imq WHERE imq.branch_id = sb.id ) as total_count ";
        $sql .= " FROM `subjects_branches` sb ";
        // $sql .= " LEFT JOIN `final_review_notes` frn ON (frn.branch_id = sb.id) ";
        // $sql .= " LEFT JOIN `final_review_videos` frv ON (frv.branch_id = sb.id) ";
        // $sql .= " LEFT JOIN `examine_questions` eq ON (eq.branch_id = sb.id) ";
        // $sql .= " LEFT JOIN `important_article_questions` imq ON (imq.branch_id = sb.id) ";
        $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ";
        $sql .= " HAVING total_count > 0 ORDER BY sb.sort ASC ";
        
        // echo $sql;die();
        
        // if($item['id'] == '417'){
        //     echo $sql;die();
        // }
        
        $item['branches'] = $this->mDb->getAll($sql);
        
        $sql = "SELECT fos.id, fosl.name FROM `fields_of_study` fos ";
        $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON foss.field_of_study_id = fos.id ";
        $sql .= " LEFT JOIN `fields_of_study_langs` fosl ON (fos.id = fosl.fields_of_study_id AND fosl.lang_code = '" . LANGUAGE . "')";
        $sql .= " WHERE foss.subject_id = '{$item['id']}'";
        
        // echo $sql;die();
        $item['fields'] = $this->mDb->getAll($sql);
        
        
        
    }
    
    return $data;
  }


  function getBranchesAndFieldsForEachSubjectForQuestionBank($data){
    foreach($data as &$item){
      $sql = "SELECT sb.id, sbl.name, sb.image ";
      // $sql .= ", (COUNT(frn.id) + COUNT(imq.id) + COUNT(eq.id) + COUNT(frv.id)) as total_count ";
      $sql .= ",(SELECT COUNT(qb.id) FROM `questions_bank` qb WHERE qb.branch_id = sb.id ) as total_count ";
      $sql .= " FROM `subjects_branches` sb ";
      $sql .= " LEFT JOIN `subjects_branches_langs` sbl ON (sb.id = sbl.subject_branch_id AND sbl.lang_code = '" . LANGUAGE . "')";
      $sql .= " WHERE sb.subject_id = '{$item['id']}' AND sb.is_deleted != '1' ";
      $sql .= " HAVING total_count > 0 ORDER BY sb.sort ASC ";
      
      // echo $sql;die();
      
    //   if($item['id'] == '417'){
    //       echo $sql;die();
    //   }
      
      $item['branches'] = $this->mDb->getAll($sql);
      
      $sql = "SELECT fos.id, fosl.name FROM `fields_of_study` fos ";
      $sql .= " LEFT JOIN `fields_of_study_subjects` foss ON foss.field_of_study_id = fos.id ";
      $sql .= " LEFT JOIN `fields_of_study_langs` fosl ON (fos.id = fosl.fields_of_study_id AND fosl.lang_code = '" . LANGUAGE . "')";
      $sql .= " WHERE foss.subject_id = '{$item['id']}'";
      
      // echo $sql;die();
      $item['fields'] = $this->mDb->getAll($sql);
      
      
      
  }
  
  return $data;
}


}
