<?php

$subscriptionObj = new Subscription();

class Subscription
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }

  function getSubscriptionCostContent()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title    FROM `subscription_cost_content`   ";
    $sql .= "where   `status` ='1' order by sort asc  ";
    //  echo  $sql;
    return $this->mDb->getAll($sql);
  }

  function getSubscriptionCostSteps()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title , description_" . LANGUAGE . " as description    FROM `subscription_cost_steps`   ";
    $sql .= "where `status` ='1' order by sort asc  ";
    // echo  $sql;
    return $this->mDb->getAll($sql);
  }


  function getSubscriptionVideos()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title ,   video FROM `subscription_cost_videos`   ";
    $sql .= "where `status` ='1' order by sort asc  ";
    // echo  $sql;
    return $this->mDb->getAll($sql);
  }





  function getAllSubscriptionCosts($temp)
  {
    //   print_r($temp);die();
    $sql = "SELECT c.id ,  c.trial_period ,c.subscription_type , c.category, c.cost , c.cost_year , c.cost_semester  ,cl.title  ,cl.description , cuntl.`currency_name`  FROM `subscription_costs` c ";
    $sql .= "LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= "where c.`status` ='1' AND c.`category` in ({$temp['category']}) ";

    $sql .= $temp['stage_id'] && $temp['user_type'] == 'student' ? "AND c.`stage_id` ='{$temp['stage_id']}' " : " ";

    $sql .= $temp['grade_id'] && $temp['user_type'] == 'student' ? "AND c.`grade_id` ='{$temp['grade_id']}' " : " ";

    $sql .= $temp['user_type'] ? "AND c.`user_type` ='{$temp['user_type']}' " : " ";
    $sql .= $temp['subscription_type'] ? "AND c.`subscription_type` ='{$temp['subscription_type']}' " : " ";
    $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    // echo $sql ;die();
    return $temp['itemsPerPage'] == '1' ? $this->mDb->getRow($sql) : $this->mDb->getAll($sql);
  }
  
  
   function getAllSubjectSubscriptionCosts($temp)
  {
    $sql = "SELECT c.id ,  c.trial_period ,c.subscription_type , c.category, c.cost , c.cost_year , c.cost_semester  ,cl.title  ,cl.description , cuntl.`currency_name`  FROM `subscription_costs` c ";
    $sql .= "LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= "where c.`status` ='1' AND c.`category` in ({$temp['category']}) ";

    $sql .= $temp['stage_id'] && $temp['user_type'] == 'student' ? "AND c.`stage_id` ='{$temp['stage_id']}' " : " ";

    $sql .= $temp['grade_id'] && $temp['user_type'] == 'student' ? "AND c.`grade_id` ='{$temp['grade_id']}' " : " ";

    $sql .= $temp['user_type'] ? "AND c.`user_type` ='{$temp['user_type']}' " : " ";
    $sql .= $temp['subscription_type'] ? "AND c.`subscription_type` ='{$temp['subscription_type']}' " : " ";
    $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    // echo $sql ;die();
    return $temp['itemsPerPage'] == '1' ? $this->mDb->getRow($sql) : $this->mDb->getAll($sql);
  }
  
  

  function getSubscriptionDetails($id)
  {
    $sql = "SELECT  c.* ,cl.title  ,cl.description , cuntl.`currency_name`  FROM `subscription_costs` c ";
    $sql .= "LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= "where c.id = {$id} AND c.`status` ='1'  ";
    //  echo  $sql;
    return $this->mDb->getRow($sql);
  }
  
  
  
  function getSubscription($id)
  {
    $sql = "SELECT  c.*   FROM `subscription_costs` c ";
    $sql .= "where c.id = {$id} AND c.`status` ='1'  ";
    //  echo  $sql;
    return $this->mDb->getRow($sql);
  }
  
  
  function getSubjectSubscription($subject_id)
  {
    $sql = "SELECT  c.*   FROM `subjects_costs` c ";
    $sql .= "where c.subject_id = '{$subject_id}' AND c.`status` ='1'  ";
    //  echo  $sql;die();
    return $this->mDb->getRow($sql);
  }
  
  
  function getSubjectSubscriptionBySubjectId($subject_id)
  {
    $sql = "SELECT  c.*   FROM `subjects_costs` c ";
    $sql .= "where c.subject_id = '{$subject_id}' ";
    //  echo  $sql;die();
    return $this->mDb->getRow($sql);
  }




  function addUserSubscription($temp)
  {
    //   print_r($temp);die();
    $temp['days']  =  $temp['days'] > 0 ?  $temp['days'] :  0;

    $sql = "INSERT INTO `user_subscription` SET ";
    $sql .= "  `user_id` = '{$temp['user_id']}' ";
    $sql .= " , `start_date` = '{$temp['start_date']}' ";
    $sql .= " , `end_date` = '{$temp['end_date']}' ";
    $sql .= " , `subscription_type` = '{$temp['subscription_type']}' ";
    $sql .= " , `year_title` = '{$temp['year_title']}' ";
    $sql .= $temp['cost'] ? " , `cost` = '{$temp['cost']}' " : " ";
    $sql .= $temp['cost_type'] ? " , `cost_type` = '{$temp['cost_type']}' " : " ";
    $sql .= $temp['fawry_payment_transaction_id'] ? " , `fawry_payment_transaction_id` = '{$temp['fawry_payment_transaction_id']}' " : " ";
    $sql .= " , `date_added` = '{$this->dateTime}' ";
    // echo $sql; die();
     return $this->mDb->queryReturnLastId($sql);
      
    //   return $this->mDb->getLas
  }
  
  
  function addUserSubjectsSubscription($temp)
  {
    //   print_r($temp);die();
    $temp['days']  =  $temp['days'] > 0 ?  $temp['days'] :  0;

    $sql = "INSERT INTO `users_subjects_subscriptions` SET ";
    $sql .= "  `user_id` = '{$temp['user_id']}' ";
    $sql .= " , `subject_id` = '{$temp['subject_id']}' ";
    $sql .= " , `user_subscription_id` = '{$temp['user_subscription_id']}' ";
    $sql .= " , `date_added` = '{$this->dateTime}' ";
    // echo $sql; die();
    return  $this->mDb->query($sql);
  }




  function getMySubscriptionLog($temp)
  {
      /* remove this  to return all previous subscriptions
    $sql = "SELECT us.* , fpt.responce FROM `user_subscription` us ";
    $sql .= "LEFT JOIN `fawry_payment_transactions` fpt ON ( fpt.`id` = us.`fawry_payment_transaction_id` )";
    $sql .= "where us.`user_id` ='{$temp['user_id']}'  and fpt.payment_transaction_type = 'subscription' order by us.id desc   ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';*/
    
    $sql = "SELECT us.* FROM `user_subscription` us ";
    $sql .= "where us.`user_id` ='{$temp['user_id']}' order by us.id desc   ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    // echo $sql;die();
    $res = $this->mDb->getAll($sql);

    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['responce'] =  json_decode($res[$i]['responce']);
      $res[$i]['currency_name'] = $this->getCurrancyByCountryId();
    }
    return $res;
  }

  function  getCurrancyByCountryId()
  {global $USER_DATA;
    $sql  = "SELECT  currency_name FROM `countries_langs` where country_id = " . $USER_DATA['country_id'] . " ";
    return $this->mDb->getOne($sql);
  }
  
  
  
  public function getAllSubjectsSubscriptionCosts($arg){
      
       $stmt = "SELECT id FROM `fields_of_study` WHERE id != :field_of_study_id";
        // Bind parameters and execute the statement
        $query = $this->mDb->prepare($stmt);
        $query->bindParam(':field_of_study_id', $arg['field_of_study_id']);
        $query->execute();
        // Fetch the results into an array
        $dat = $query->fetchAll(PDO::FETCH_COLUMN);

    $ids = "(" . implode(",", $dat) . ")";
    
      $sql  = "SELECT s.id as subject_id, s.img, sc.id as subject_cost_id, sc.".$arg['user']."_cost_semester as cost_semester,  sc.".$arg['user']."_cost_year as cost_year, s.name as subject_name, sl.name, gl.name FROM `subjects` s ";
      $sql .= " LEFT JOIN `subjects_costs` sc ON s.id = sc.subject_id ";
      $sql .= " LEFT JOIN `grades_langs` gl ON (s.grade_id = gl.grade_id AND gl.lang_code = '" . LANGUAGE . "')";
      $sql .=  $arg['field_of_study_id'] ? "LEFT JOIN `fields_of_study_subjects` foss ON foss.subject_id = s.id ":"";
      $sql .= " LEFT JOIN `stages_langs` sl ON (sl.stage_id = s.stage_id AND sl.lang_code = '" . LANGUAGE . "')";
      $sql .= " WHERE (sc.status = '1' OR sc.status IS NULL) AND s.status = '1' AND s.grade_id = '{$arg['grade_id']}' AND s.is_deleted != '1'";
      $sql .= " AND s.id NOT IN (
                SELECT uss.subject_id 
                FROM `users_subjects_subscriptions` uss 
                WHERE 
                    uss.user_id = '{$arg['user_id']}' 
                    AND '{$this->dateTime}' < uss.end_date
                    AND uss.`status` != '0' AND uss.cost_type = 'paid'
            )";
    $sql .=  $arg['field_of_study_id'] ?  " AND (s.`grade_id` in ({$arg['grade_id']}) AND (foss.field_of_study_id = '{$arg['field_of_study_id']}' OR (foss.field_of_study_id NOT IN {$ids} OR foss.field_of_study_id IS NULL))) " :  " ";
    //   echo $sql;die();
    
    return $this->mDb->getAll($sql);
      
  }
  
  
  public function getAllSubjectsSubscriptionCostsByTeacherId($arg){
      
      $sql  = "SELECT s.id as subject_id, s.grade_id, s.img, sc.id as subject_cost_id, sc.".$arg['user']."_cost_semester as cost_semester,  sc.".$arg['user']."_cost_year as cost_year, s.name as subject_name, sl.name AS stage_name, gl.name AS grade_name FROM `subjects` s ";
      $sql .= " LEFT JOIN `subjects_costs` sc ON s.id = sc.subject_id ";
      $sql .= " LEFT JOIN `teacher_subjects` ts ON s.id = ts.subject_id ";
      $sql .= " LEFT JOIN `grades_langs` gl ON (s.grade_id = gl.grade_id AND gl.lang_code = '" . LANGUAGE . "')";
      $sql .= " LEFT JOIN `stages_langs` sl ON (sl.stage_id = s.stage_id AND sl.lang_code = '" . LANGUAGE . "')";
      $sql .= " WHERE (sc.status = '1' || sc.status IS NULL) AND s.status = '1' AND ts.user_id = '{$arg['teacher_id']}' AND s.`is_deleted` != '1'";
      $sql .= " AND s.id NOT IN (
                SELECT uss.subject_id 
                FROM `users_subjects_subscriptions` uss 
                WHERE 
                    uss.user_id = '{$arg['teacher_id']}' 
                    AND '{$this->dateTime}' < uss.end_date 
                    AND uss.status = '1' AND uss.cost_type = 'paid'
            ) ORDER BY s.grade_id ASC";
        //   echo $sql;die();
      $data = $this->mDb->getAll($sql);
    //   $result =[];
    //   foreach($data as $item){
    //       $result[$item['grade_id']]['name'] = $item['grade_name'];
    //       $result[$item['grade_id']]['subjects'][] = $item;
    //   }
      
      return $data; //array_values($result);
  }
  
  public function checkDiscountCode($code){
      $today = $this->dateTime = date('Y-m-d');
      $sql = "SELECT * FROM `discount_codes` ";
      $sql .= " WHERE `code` = '{$code}' AND `start_date` < '{$today}' AND `end_date` >= '{$today}' AND `status` = '1'";
    //   echo $sql;die();
      $code = $this->mDb->getRow($sql);
      return $code;
  }
  
  function addUserCourseSubscription($temp)
  {
      //   echo "Hi From Class";die();
    $temp['days']  =  $temp['days'] > 0 ?  $temp['days'] :  0;

    // $sqll = "SELECT value `settings` WHERE `name` = 'Management_ratio_in_paid_courses' AND `autoload` = '1' ";
    $sql = "INSERT INTO `course_subscriptions` SET ";
    $sql .= "  `user_id` = '{$temp['user_id']}' ";
    $sql .= " , `course_id` = '{$temp['course_id']}' ";
    $sql .= " , `course_cost` = '{$temp['course_cost']}' ";
    $sql .= " , `status` = '0' ";
    // echo $sql;die();
    $id = $this->mDb->query($sql);
    
    // echo $id;die();
    
    // if($id){
    //     foreach($temp['subjects'] as $subject_id){
    //         $sqll = "INSERT INTO `users_subjects_subscriptions` SET ";
    //         $sqll .= " `user_id` = '{$temp['user_id']}' ";
    //         $sqll .= ", `subject_id` = '{$subject_id}' ";
    //         $sqll .= ", `user_subscription_id` = '{$id}' ";
            
    //         $res = $this->mDb->query($sqll);
    //     }
    // }
    if($id){
        $sqll = "SELECT * FROM `courses` WHERE `id` = '{$temp['course_id']}' ";
        $course = $this->mDb->getRow($sqll);
        
        $sqlll = "SELECT value FROM `settings` WHERE `name` = 'Management_ratio_in_paid_courses' ";
        $admin_rate = $this->mDb->getOne($sqlll);
         $administration_amount = 0 - ($admin_rate * $temp['course_cost']);
        $teacher_amount = $temp['course_cost'];
        
        $sqllll  = "INSERT INTO `teacher_credits` SET ";
        $sqllll .= " `teacher_id` = '{$course['added_by']}' ";
        $sqllll .= " `student_id` = '{$temp['user_id']}' ";
        $sqllll .= " ,`course_id` = '{$course['id']}' ";
        $sqllll .= " ,`type` = 'student_subscription' ";
        $sqllll .= " ,`status` = '1' ";
        $sqllll .= " ,`teacher_amount` = '{$teacher_amount}' ";
         $res = $this->mDb->query($sqllll);
         
         
        $sqlllll  = "INSERT INTO `teacher_credits` SET ";
        $sqlllll .= " `teacher_id` = '{$course['added_by']}' ";
        $sqlllll .= " ,`course_id` = '{$course['id']}' ";
        $sqlllll .= " ,`type` = 'administration_amount' ";
        $sqlllll .= " ,`status` = '1' ";
        $sqlllll .= " ,`teacher_amount` = '{$administration_amount}' ";
         $res = $this->mDb->query($sqlllll);
    }
    if($id && $res){
        return true;
    }else{
        return false;
    }
  }
  
  public function incrementDiscountCodeUsageTime($id, $times){
      $sql= "UPDATE `discount_codes` SET `usage_times` = '{$times}' WHERE `id` = '{$id}' ";
    //   echo $sql;die();
      return $this->mDb->query($sql);
  }
  
}
