<?php

$teacherCreditsObj = new TeacherCredit();

class TeacherCredit
{

    public $mConfig;
    public $mMailer;
    public $notifyObj;
    public $dateTime;
    
    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mMailer = new Mailer();
        $this->subjectObj = new Subject();
        $this->notifyObj = new notifications();
        $this->dateTime = date('Y-m-d H:i:s');
        $this->questionFactory = new QuestionFactory;
        
    }
    
    function checkAvailableRequestAmount($temp){
        $sql = "SELECT SUM(teacher_amount) FROM `teacher_credits` WHERE `teacher_id` = '{$temp['teacher_id']}'";
        // echo $sql;die();
        $ch = $this -> mDb -> getOne($sql);
        
        return $ch >= $temp['teacher_amount'];
    }
    
    public function teacher_credits_transactions($temp) {
    $sql = "SELECT tc.teacher_amount, tc.teacher_id, tc.course_id, tc.type, tc.status, tc.added_date";
    $sql .= " ,u.full_name as student_name ,su.name as subject_name FROM `teacher_credits` tc";
    $sql .= " LEFT JOIN `users` u ON tc.student_id = u.id";
    $sql .= " LEFT JOIN `courses` c ON tc.course_id = c.id";
    $sql .= " LEFT JOIN `subjects` su ON c.subject_id = su.id";
    $sql .= " WHERE tc.teacher_id = '{$temp['teacher_id']}' AND tc.`status` = '1' ORDER BY tc.id DESC";
    // echo $sql;die();
    $res = $this->mDb->getAll($sql);
    // print_r($res);die();
    $total = 0;
    foreach ($res as &$item) {
        $total += $item['teacher_amount'];
        $item['teacher_amount'] = abs($item['teacher_amount']);
    }

    $sql = " SELECT SUM(tc.teacher_amount) as suspended_balance FROM `teacher_credits` tc";
    $sql .= " WHERE tc.teacher_id = '{$temp['teacher_id']}' AND tc.`status` = '0' AND tc.`type` = 'withdraw'";
    // echo $sql;die();
    $suspended_balance = $this->mDb->getOne($sql);
    
    return ['transactions' => $res, 'total' => $total + $suspended_balance, 'suspended_balance' => abs($suspended_balance)];
}


    
    public function checkTeacherBalance($teacher_id){
        
        $sql = "SELECT teacher_amount FROM `teacher_credits` WHERE `teacher_id` = '{$teacher_id}' AND `status` = '1'";
        return $this->mDb->getOne($sql);
    }
    public function balanceWithdrawalRequest($temp){
        $teacher_balance = $this->checkTeacherBalance($temp['teacher_id']);
        
        if($teacher_balance <= 0){
            return -1;
        }
        
        $teacher_amount = abs($temp['teacher_amount']);
        $sql  = "INSERT INTO `teacher_credits` SET ";
        $sql .= " `course_id` = '0' ";
        $sql .= " ,`teacher_id` = '{$temp['teacher_id']}' ";
        $sql .= " ,`type` = 'withdraw' ";
        $sql .= " ,`payment_method` = '{$temp['payment_method']}' ";
        $sql .= ($temp['payment_method'] == 'vodafone_cash' || 
                $temp['payment_method'] == 'instapay' || $temp['payment_method'] == 'etisalat_cash') && $temp['mobile_number'] ? " ,`mobile_number` = '{$temp['mobile_number']}' ":"";
        $sql .= $temp['payment_method'] == 'bank_account' && $temp['bank_account_number'] ? " ,`bank_account_number` = '{$temp['bank_account_number']}' ":"";
        $sql .= $temp['payment_method'] == 'bank_account' && $temp['bank_account_name'] ? " ,`bank_account_name` = '{$temp['bank_account_name']}' ":"";
        $sql .= $temp['payment_method'] == 'bank_account' && $temp['bank_name'] ? " ,`bank_name` = '{$temp['bank_name']}' ":"";
        $sql .= " ,`teacher_amount` = '-{$teacher_amount}' ";
        $sql .= " ,`status` = '0' ";
        // echo $sql;die();
        $res = $this->mDb->query($sql);
        if($res){
            return true;
        }else{
            return false;
        }
    }
    
}