<?php

$videosCoursesObj = new VideosCourses();

class VideosCourses {

    
    public $mDb;
    public $mConfig;
    public $dateTime;
 
    function __construct() {
       
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');

    }
        function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
    function getAllVideosCourses($limit, $offset) {
    try {
        $query = "SELECT id, file FROM videos_courses WHERE hls_file IS NULL AND (file IS NOT NULL AND file != '')  LIMIT :limit OFFSET :offset";
        $stmt = $this->mDb->connect()->prepare($query);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->bindParam(':offset', $offset, PDO::PARAM_INT);
        
        if ($stmt->execute()) {
            return $stmt->fetchAll(PDO::FETCH_ASSOC);
        } else {
            return false;
        }
    } catch (PDOException $e) {
        // Handle potential exceptions
        return "Error: " . $e->getMessage();
    }
}

function getVideosCoursesCount() {
    try {
        $query = "SELECT COUNT(*) AS total FROM videos_courses WHERE hls_file IS NULL AND (file IS NOT NULL AND file != '')";
        $stmt = $this->mDb->connect()->prepare($query);
        
        if ($stmt->execute()) {
            $result = $stmt->fetch(PDO::FETCH_ASSOC);
            return $result['total']; // Return the count
        } else {
            return false;
        }
    } catch (PDOException $e) {
        // Handle potential exceptions
        return "Error: " . $e->getMessage();
    }
}



    function updateHLSFile($fileId, $hlsFilename) {
    $query = "UPDATE videos_courses SET hls_file = :hlsFilename WHERE id = :fileId AND hls_file IS NULL";
    
    $stmt = $this->mDb->connect()->prepare($query);
    $stmt->bindParam(':hlsFilename', $hlsFilename);
    $stmt->bindParam(':fileId', $fileId);
    // print_r($stmt);die();
    return $stmt->execute();
    }
}