<?php

// Base middleware class
class MiddlewareBase
{
    protected $dateTime;
    protected $userData;
    protected $config;
    protected $db;
    protected $lang;
    protected $testId;
    protected $testObj;

    public function __construct($userData, $config, $db, $lang, $testId, $testObj)
    {
        $this->userData = $userData;
        $this->config = $config;
        $this->db = $db;
        $this->lang = $lang;
        $this->testId = $testId;
        $this->testObj = $testObj;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    public function getTestObj()
    {
        return $this->testObj;
    }

    public function getTestId()
    {
        return $this->testId;
    }

    public function getUserData()
    {
        return $this->userData;
    }

    public function getLang()
    {
        return $this->lang;
    }
    
    protected function returnErrorResponse(array $ret, int $code = 404): array
    {
        return [
            'http_response_code_status' => $code,
            'ret' => array_merge($ret, ['code' => $code]),
            'next' => false,
        ];
    }
}?>