<?php

require_once './middleWares/Interfaces/UserRelationCheckerInterface.php';
require_once './middleWares/classes/middleWareBase.php';

// Concrete class for student relation check
class StudentRelationChecker implements UserRelationCheckerInterface
{
    protected $testsMiddleware;

    public function __construct(MiddlewareBase $testsMiddleware)
    {
        $this->testsMiddleware = $testsMiddleware;
    }

    public function isRelatedToTest(): bool
    {
        $testObj = $this->testsMiddleware->getTestObj();
        $testId = $this->testsMiddleware->getTestId();
        $userData = $this->testsMiddleware->getUserData();

        $availableToVisitor = $testObj->getAvailableToVisitorOfTest($testId);
        if (!$availableToVisitor['available_to_visitor']) {
            return (bool) $testObj->checkStudentRlatedToTest_id($testId, $userData['grade_id']);
        }
        return true;
    }

    public function getErrorResponse(): array
    {
        $lang = $this->testsMiddleware->getLang();
        return [
            'message' => $lang['L_not_related'],
            'on' => 'test_id',
        ];
    }
}?>