<?php

require_once './middleWares/Interfaces/UserRelationCheckerInterface.php';
require_once './middleWares/classes/middleWareBase.php';
require_once './middleWares/classes/studentTestsAnswerMiddleWareBase.php';

// Concrete class for teacher relation check
class TeacherRelationChecker implements UserRelationCheckerInterface
{
    protected $testsMiddleware;

    public function __construct(MiddlewareBase $testsMiddleware)
    {
        $this->testsMiddleware = $testsMiddleware;
    }

    public function isRelatedToTest(): bool
    {
        $testObj = $this->testsMiddleware->getTestObj();
        $testId = $this->testsMiddleware->getTestId();
        $userId = $this->testsMiddleware->getUserData()['id'];

        return (bool) $testObj->checkTeacherRlatedToTest_id($testId, $userId);
    }

    public function getErrorResponse(): array
    {
        $lang = $this->testsMiddleware->getLang();
        return [
            'message' => $lang['L_not_related'],
            'on' => 'test_id',
        ];
    }
}?>