<?php

/* * *************************************************************************
 *
 *   PROJECT: Big Wish App
 *   powerd by IT PLUS Team
 *   Copyright 2017 IT Plus Inc
 *   http://it-plus.co/
 *
 * ************************************************************************* */


require_once('init.php');


if ($_GET['action'] == 'getAllCategories' && $_SERVER['REQUEST_METHOD'] === 'GET') {


    $_GET['start'] = $_GET['start'] ? $_GET['start'] : '0';
    $_GET['itemsPerPage'] = $_GET['itemsPerPage'] ? $_GET['itemsPerPage'] : '10';
    $article_data = $articleObj->getAllCategories($_GET);
    if (count($article_data)) {
        $Data['data'] = $article_data;
        $Data['success'] = true;
    } else {
        $Data['message'] = $Lang['L_noContent'];;
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'getCategoryDetails' && $_SERVER['REQUEST_METHOD'] === 'GET') {
    if (!$_GET['category_title']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {

        $article_data = $articleObj->getCategoryDetails($_GET['category_title']);
        if ($article_data) {
            $Data['data'] = $article_data;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_noContent'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'getAllArticles'  && $_SERVER['REQUEST_METHOD'] === 'GET') {


    $_GET['start'] =  $_GET['start'] ?  $_GET['start'] : '0';
    $_GET['itemsPerPage']  =  $_GET['itemsPerPage'] ?  $_GET['itemsPerPage'] : '10';

    $article_data = $articleObj->getAllArticles($_GET);
    if (count($article_data)) {
        $Data['data'] = $article_data;
        $Data['success'] = true;
    } else {
        $Data['message'] = $Lang['L_noContent'];;
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'getArticleDetails'  && $_SERVER['REQUEST_METHOD'] === 'GET') {
    if (!$_GET['slug']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {
        $articleObj->addViewToArticle($_GET['slug']);
        $article_data = $articleObj->getArticleDetails($_GET['slug']);
        if ($article_data) {
            $Data['data'] = $article_data;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_noContent'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'getAllCommentsOnArticle'  && $_SERVER['REQUEST_METHOD'] === 'GET') {


    if (!$_GET['article_id']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {

        $_GET['start'] =  $_GET['start'] ?  $_GET['start'] : '0';
        $_GET['itemsPerPage']  =  $_GET['itemsPerPage'] ?  $_GET['itemsPerPage'] : '10';
        $_GET['type'] = 'comment';
        $article_data = $articleObj->getAllCommnetsOrRepliesArticle($_GET);
        if (count($article_data)) {
            $Data['data'] = $article_data;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_noContent'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'getAllRepliesOnComment'  && $_SERVER['REQUEST_METHOD'] === 'GET') {

    if (!$_GET['comment_id']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {
        $_GET['start'] =  $_GET['start'] ?  $_GET['start'] : '0';
        $_GET['itemsPerPage']  =  $_GET['itemsPerPage'] ?  $_GET['itemsPerPage'] : '10';
        $_GET['type'] = 'reply';
        $article_data = $articleObj->getAllCommnetsOrRepliesArticle($_GET);
        if (count($article_data)) {
            $Data['data'] = $article_data;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_noContent'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'addCommentOnArticle'  && $_SERVER['REQUEST_METHOD'] === 'POST' && $USER_DATA['id']) {

    $Req['content'] = trim($Req['content']);
    if (!$Req['article_id'] && !$Req['content']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {
        $article_data = $articleObj->addCommentOnArticle($Req);
        if ($article_data) {
            $data['id']   =   $article_data;
            $data['active']   =  '0';
            $Data['data'] = $articleObj->getOneCommnetsOrRepliesArticle($data);
            $Data['message'] = $Lang['L_commentAddSuccessfullyAndWaitToAccept'];;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_someErrorHappen'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'addReplyOnComment'  && $_SERVER['REQUEST_METHOD'] === 'POST'  && $USER_DATA['id']) {

    $Req['content'] = trim($Req['content']);
    if (!$Req['article_id'] && !$Req['comment_id'] && !$Req['content']) {
        $Data['success'] = false;
        $Data['message'] =  $Lang['L_parameterError'];
    } else {
        $article_data = $articleObj->addReplyOnComment($Req);
        if ($article_data) {
            $data['id']   =   $article_data;
            $data['active']   =  '0';
            $Data['data'] = $articleObj->getOneCommnetsOrRepliesArticle($data);
            $Data['message'] = $Lang['L_replyAddSuccessfullyAndWaitToAccept'];;
            $Data['success'] = true;
        } else {
            $Data['message'] = $Lang['L_someErrorHappen'];;
            $Data['success'] = false;
        }
    }
} else if ($_GET['action'] == 'deleteReplyOrComment'  && $_SERVER['REQUEST_METHOD'] === 'DELETE'  && $USER_DATA['id']) {

    $data['id']   =   $_GET['id'];
    $data['user_id']   =  $USER_DATA['id'];
    $is_mine = $articleObj->checkRelatdToReplyOrComment($data);
    if ($is_mine) {
        if (
            !$_GET['id']
        ) {
            $Data['success'] = false;
            $Data['message'] =   $Lang['L_validationError'];
        } else {
            $article_data = $articleObj->deleteReplyOrComment($_GET['id'],   $USER_DATA['id']);
            if ($article_data) {
                $Data['message'] =  $Lang['L_deleteSeccessfully'];
                $Data['success'] = true;
            } else {
                $Data['success'] = false;
                $Data['message'] =  $Lang['L_someErrorHappen'];
            }
        }
    } else {
        $ret = ["code" => 404, "message" => $Lang['L_access_denied'], "on" => 'ReplyOrComment_id'];
    }
}



if ($Data) {
    $http_response_code_status = 200;
    $ret  = $Data;
} else {
    $ret =  $ret ? $ret : ["code" => 404, "on" => 'no req '];
    $http_response_code_status = $ret['code'];
}

http_response_code($http_response_code_status);
echo str_replace("\'", "'", json_encode($ret));
$userObj->inserInApiTable($http_response_code_status, json_encode($_SERVER), json_encode($apache_request_headers), json_encode($Req, JSON_UNESCAPED_UNICODE), json_encode($_GET, JSON_UNESCAPED_UNICODE), json_encode($ret, JSON_UNESCAPED_UNICODE));
exit();
