<?php

$articleObj = new Article();

class Article
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();
    $this->dateTime = date('Y-m-d H:i:s');
  }



  function getAllCategories($temp)
  {
    $sql = "SELECT a.id   , al.`title` ,a.type ,al.`description` ,al.`meta_keywords` ,al.`meta_description` ,al.alt_image  FROM `categories` a ";
    $sql .= "LEFT JOIN `categories_langs` al ON ( a.`id` = al.`category_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1' AND  a.`type` ='{$temp['type']}'   ";

    
    $sql .= $temp['subject_id'] ? "AND a.subject_id =  '{$temp['subject_id']}' " : '' ;
    $sql .= $temp['searchKey'] ? ' AND (al.title  like "%' . $temp['searchKey'] . '%") ' : '';
    $sql .= " order by a.`sort` asc ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
    LIMIT 0 , 10  ';
    $res = $this->mDb->getAll($sql);
    for ($i = 0; $i < count($res); $i++) {
      if ($res[$i]['type'] == 'article') {
        $res[$i]['count_of_article']  = $this->getContOfArticleOnCategory($res[$i]['id']);
      }
    }
    return $res;
  }

  function getCategoryDetails($category_title)
  {
    $sql = "SELECT a.id , al.`title` ,al.`description` ,al.`meta_keywords` ,al.`meta_description` ,al.alt_image FROM `categories` a ";
    $sql .= "LEFT JOIN `categories_langs` al ON ( a.`id` = al.`category_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1' and al.title='{$category_title}' ";
    $res = $this->mDb->getRow($sql);
    if ($res) {
      $res['count_of_article']  = $this->getContOfArticleOnCategory($res['id']);
    }
    return $res;
  }
  function getContOfArticleOnCategory($category_id)
  {
    $sql = "SELECT count(a.id)   FROM `articles` a  where  a.category_id = '{$category_id}' AND a.`status` ='1'";
    $res = $this->mDb->getOne($sql);
    return $res;
  }



  function getContOfAllCommentsAndRepliesOnArticle($article_id)
  {
    $sql = "SELECT count(a.id)   FROM `article_comments` a  where  a.article_id = '{$article_id}' AND a.`active` ='1'";
    $res = $this->mDb->getOne($sql);
    return $res;
  }


  function getContOfCommentsOnArticle($article_id)
  {
    $sql = "SELECT count(a.id)   FROM `article_comments` a  where  a.article_id = '{$article_id}' AND a.type='comment' AND a.`active` ='1'";
    $res = $this->mDb->getOne($sql);
    return $res;
  }

  function getContOfRepliesOnComments($article_id, $comment_id)
  {
    $sql = "SELECT count(a.id)   FROM `article_comments` a  where  a.article_id = '{$article_id}'  AND a.type='reply' AND a.`active` ='1'  AND a.parent_id = '{$comment_id}' ";
    $res = $this->mDb->getOne($sql);
    return $res;
  }


  function getAllArticles($temp)
  {
    $temp['sort_by'] =  $temp['sort_by'] ?  $temp['sort_by'] : 'sort';
    $temp['sort_type'] =  $temp['sort_type'] ?  $temp['sort_type'] : 'asc';

    $sql = "SELECT a.id , a.canonical_link, a.slug ,a.view_count , a.img  ,a.date_added , al.`title`  ,al.`description` ,al.meta_title ,al.`meta_keywords` ,al.`meta_description`,al.alt_image    FROM `articles` a ";
    $sql .= "LEFT JOIN `articles_langs` al ON ( a.`id` = al.`article_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1' ";
    $sql .= $temp['searchKey'] ? ' AND (al.title  like "%' . $temp['searchKey'] . '%"  || al.description  like "%' . $temp['searchKey'] . '%"  ) ' : '';
    $sql .= $temp['category_id'] ? "AND a.category_id = {$temp['category_id']} " : " ";
    $sql .= $temp['sort_by'] ?   " order by a.{$temp['sort_by']} {$temp['sort_type']} " :  ' ';
    $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
    LIMIT 0 , 10  ';
    $res = $this->mDb->getAll($sql);
    return $res;
  }
  function getArticleDetails($slug)
  {
    $sql = "SELECT a.id , a.canonical_link, a.slug ,a.view_count ,a.date_added , a.img, al.`title` ,al.`description`  ,al.meta_title ,al.`meta_keywords` ,al.`meta_description`,al.alt_image  , cl.title as category_title  FROM `articles` a ";
    $sql .= "LEFT JOIN `articles_langs` al ON ( a.`id` = al.`article_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "LEFT JOIN `categories_langs` cl ON ( a.`category_id` = cl.`category_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1' and a.slug='{$slug}' ";
    $res = $this->mDb->getRow($sql);
    if ($res) {
      $res['count_of_comments']  = $this->getContOfCommentsOnArticle($res['id']);
      $res['count_of_comments_and_replies']  = $this->getContOfAllCommentsAndRepliesOnArticle($res['id']);
    }
    return $res;
  }
  function getAllCommnetsOrRepliesArticle($temp)
  {
    $sql = "SELECT ac.id ,  ac.user_id ,  ac.type , ac.content , u.full_name , u.img as user_img  ,ac.date_added FROM `article_comments` ac ";
    $sql .= "LEFT JOIN `users` u ON ( u.`id` = ac.`user_id` )";
    $sql .= "where ac.active = '1' AND ac.type ='{$temp['type']}' AND ac.article_id = '{$temp['article_id']}' ";
    $sql .=  $temp['type'] == 'reply' ? " AND ac.parent_id = '{$temp['comment_id']}' " : " AND ac.parent_id = '0' ";
    $sql .= " order by id asc ";
    $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']} " : ' 
    LIMIT 0 , 10    ';
    // if($temp['type'] == 'reply'){
    //   p($sql);
    // }
    $res = $this->mDb->getAll($sql);
    if ($res) {
      if ($temp['type'] == 'comment') {

        for ($i = 0; $i < count($res); $i++) {



          $temp['start'] = '0';
          $temp['itemsPerPage'] = '10';
          $temp['comment_id'] = $res[$i]['id'];
          $temp['type'] = 'reply';
          $res[$i]['count_of_relpies']  = $this->getContOfRepliesOnComments($temp['article_id'], $temp['comment_id']);
          $res[$i]['relpies']  = $this->getAllCommnetsOrRepliesArticle($temp);
        }
      }
    }

    return $res;
  }

  function addViewToArticle($slug)
  {
    $sql = "UPDATE `articles` SET view_count = view_count + 1 where slug = '{$slug}'  ";
    $this->mDb->query($sql);
  }
  function getOneCommnetsOrRepliesArticle($temp)
  {
    $sql = "SELECT ac.id ,  ac.user_id , ac.content , u.full_name , u.img as user_img  ,ac.date_added FROM `article_comments` ac ";
    $sql .= "LEFT JOIN `users` u ON ( u.`id` = ac.`user_id` )";
    $sql .= "where ac.active ='{$temp['active']}' AND ac.id ='{$temp['id']}'    ";
    $res = $this->mDb->getRow($sql);
    return $res;
  }

  function deleteReplyOrComment($id, $user_id)
  {
    if (!$id) {
      return;
    }
    $sql = "DELETE  from `article_comments` WHERE (`id`='{$id}' || parent_id =   '{$id}') AND user_id ='{$user_id}' ";
    return $this->mDb->query($sql);
  }



  function addCommentOnArticle($temp)
  {
    global $USER_DATA;
    $temp['content'] = str_replace("'", "\'", $temp['content']);

    $sql = "INSERT INTO `article_comments` SET ";
    $sql .= " `user_id` = '" . $USER_DATA['id'] . "' , ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `article_id` = '{$temp['article_id']}', ";
    $sql .= " `content` = '{$temp['content']}', ";
    $sql .= " `type` = 'comment', ";
    if ($this->mConfig['mode'] == 'develop') {
      $sql .= " `active` = '1', ";
    }
    $sql .= " `date_added` = '{$this->dateTime}'";
    //  p($sql);
    return  $this->mDb->queryReturnLastId($sql);
  }
  function addReplyOnComment($temp)
  {
    global $USER_DATA;
    $temp['content'] = str_replace("'", "\'", $temp['content']);

    $sql = "INSERT INTO `article_comments` SET ";
    $sql .= " `user_id` = '" . $USER_DATA['id'] . "' , ";
    $sql .= " `set_from` = '" . SETFROM . "' , ";
    $sql .= " `article_id` = '{$temp['article_id']}', ";
    $sql .= " `parent_id` = '{$temp['comment_id']}', ";
    $sql .= " `content` = '{$temp['content']}', ";
    $sql .= " `type` = 'reply', ";
    if ($this->mConfig['mode'] == 'develop') {
      $sql .= " `active` = '1', ";
    }

    $sql .= " `date_added` = '{$this->dateTime}'";
    //  p($sql);
    return  $this->mDb->queryReturnLastId($sql);
  }

  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  function checkRelatdToReplyOrComment($temp)
  {
    $sql = "SELECT ac.id   FROM `article_comments` ac ";
    $sql .= "where  ac.id ='{$temp['id']}' AND ac.user_id = '{$temp['user_id']}'  ";
    $res = $this->mDb->getOne($sql);
    return $res;
  }
}
