<?php

$commonObj = new Common();

class Common
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }


  function getSubjectsByStage_id($stage_id, $itemsPerPage)
  {
    $sql = "SELECT f.name , f.img, f.id , f.subject_direction ,  f.description_" . LANGUAGE . " as description  FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1' AND  f.`stage_id` ='{$stage_id}' AND  f.show_in_home ='1' ";
    $sql .= " group by f.name order by f.`sort` asc ";
    $sql .= $itemsPerPage > 0 ? " Limit {$itemsPerPage} " : " ";
    // p($sql);
    return $this->mDb->getAll($sql);
  }



  function getAllStageWithSubjects($country_id)
  {
    $res = $this->getAllStages($country_id, 1);
    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['subjcets'] = $this->getSubjectsByStage_id($res[$i]['id'], 6);
    }
    return $res;
  }



  function getAllContactInfo($position)
  {
    $sql = "SELECT   f.phone , f.whatsapp , f.email , f.img , fl.title  , fl.address  FROM `contact_information` f ";
    $sql .= "LEFT JOIN `contact_information_langs` fl ON ( f.`id` = fl.`contact_information_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where  f.`position` ='{$position}'  AND f.`status` ='1'    ";
    // echo   $sql;
    return $this->mDb->getAll($sql);
  }


  function getStageDetailsWithSubjects($stage_id)
  {

    global $USER_DATA;
    $sql = "SELECT f.id , fl.`name` ,f.img , fl.description   FROM `stages` f ";
    $sql .= "LEFT JOIN `stages_langs` fl ON ( f.`id` = fl.`stage_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where  f.`id` ='{$stage_id}'  AND f.`status` ='1'  AND   f.is_deleted !='1' ";

    // for Testers 
    $sql .= "  AND  ( (f.just_for_tester ='0') ||  (f.just_for_tester ='1' and  f.tester_ids LIKE '%," .  $USER_DATA['id'] . ",%'   ) )    ";

    // echo   $sql;
    $res =  $this->mDb->getRow($sql);
    if ($res) {
      $res['subjcets'] = $this->getSubjectsByStage_id($stage_id, 20);
      return $res;
    }
  }

  function getAllAdvantages()
  {
    $sql = "SELECT a.id ,a.img , al.`title`  , al.`description`  , al.`meta_description`  , al.`meta_title`   , al.`meta_keywords`  , al.alt_image  FROM `advantages` a ";
    $sql .= "LEFT JOIN `advantages_langs` al ON ( a.`id` = al.`advantage_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1'  order by a.`sort` asc ";
    $res = $this->mDb->getAll($sql);
    return $res;
  }
  function getAdvantagesDetails($id)
  {



    $sql = "SELECT a.id,a.video,a.img , al.`title` , al.`description`  , al.`meta_description`  , al.`meta_title`   , al.`meta_keywords`  , al.alt_image FROM `advantages` a ";
    $sql .= "LEFT JOIN `advantages_langs` al ON ( a.`id` = al.`advantage_id`  AND al.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where a.`status` ='1' and a.id='{$id}' ";
    $res = $this->mDb->getRow($sql);
    if ($res) {
      $res['items'] =  $this->getAllAdvantagesItem($res['id']);
      return $res;
    }
  }
  function getAllAdvantagesItem($advantage_id)
  {
    $sql = "SELECT ai.item FROM `advantage_items` ai ";
    $sql .= "where ai.advantage_id = '{$advantage_id}' AND ai.`lang_code`='" . LANGUAGE . "' order by ai.`id` asc ";
    $res = $this->mDb->getAll($sql);
    return $res;
  }

  function getAllExplanations()
  {
    $sql = "SELECT e.id ,e.video,  e.img ,el.title  FROM `explanations` e ";
    $sql .= "LEFT JOIN `explanations_langs` el ON ( e.`id` = el.`explanation_id`  AND el.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where e.`status` ='1'  ";
    return $this->mDb->getAll($sql);
  }


  function getAllSliders($temp)
  {
    $sql = "SELECT s.id,s.url,sl.img  ,s.type , s.title  FROM `sliders` s ";
    $sql .= "LEFT JOIN `sliders_langs` sl ON ( s.`id` = sl.`slider_id`  AND sl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where s.`status` ='1' AND type ='{$temp['type']}'  order by s.`sort`";
    return $this->mDb->getAll($sql);
  }
  function getAllFrequentlQuestions()
  {
    $sql = "SELECT f.id,fl.`title`,fl.`description`  FROM `frequently_questions` f ";
    $sql .= "LEFT JOIN `frequently_questions_langs` fl ON ( f.`id` = fl.`question_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where f.`status` ='1'  order by f.`sort`";
    return $this->mDb->getAll($sql);
  }
  function getAllCountries()
  {
    $sql = "SELECT c.id , c.img , c.country_code , c.valid_count_of_mobile_number	 ,cl.name  FROM `countries` c ";
    $sql .= "LEFT JOIN `countries_langs` cl ON ( c.`id` = cl.`country_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where c.`status` ='1'  order by c.`id`";
    return $this->mDb->getAll($sql);
  }
  function getValid_count_of_mobile_number($country_code)
  {
    $sql = "SELECT   c.valid_count_of_mobile_number FROM `countries` c ";
    $sql .= "where c.`status` ='1' AND c.country_code='{$country_code}'  ";
    return $this->mDb->getOne($sql);
  }

  function getAllStages($country_id, $show_in_home)
  {
    global $USER_DATA;
    $sql = "SELECT f.id , fl.`name` , f.img   FROM `stages` f ";
    $sql .= "LEFT JOIN `stages_langs` fl ON ( f.`id` = fl.`stage_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where f.`status` ='1'  AND f.`country_id` ='{$country_id}'  AND  f.is_deleted !='1' ";
    $sql .= $show_in_home ? " AND  f.show_in_home ='1' " :  " ";
    // for Testers 
    $sql .= "  AND  ( (f.just_for_tester ='0') ||  (f.just_for_tester ='1' and  f.tester_ids LIKE '%," .  $USER_DATA['id'] . ",%'   ) )    ";

    //  p($sql);
    return $this->mDb->getAll($sql);
  }
  
  function getAllGrades($stage_id, $type, $parent_id  = '0')
  {
    $sql = "SELECT f.id , fl.`name` , f.`stage_id`  FROM `grades` f ";
    $sql .= "LEFT JOIN `grades_langs` fl ON ( f.`id` = fl.`grade_id`  AND fl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= "where f.`status` ='1'  AND f.`parent_id` ='{$parent_id}'  AND f.`stage_id` ='{$stage_id}'  AND  f.is_deleted !='1' AND type = '{$type}'   ";
    $sql .= "  order by f.`sort` asc ";
    return  $this->mDb->getAll($sql);
  }
  function getAllGradesWithSpecialize($stage_id)
  {
    $res = $this->getAllGrades($stage_id, 'grade', '0');
    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['specializes'] = $this->getAllGrades($stage_id, 'specialize', $res[$i]['id']);
    }
    return $res;
  }


  function getSettingByName($name)
  {
    $sql  = " SELECT  value  FROM `setting` where name ='{$name}'  ";
    $res  = $this->mDb->getOne($sql);
  }
  function getAllSettings()
  {
    $sql  = " SELECT name,value ";
    $sql .= " FROM `settings` ";
    $sql .= " WHERE    `name`='site_name' OR  `name`='site_keywords' OR `name`='phone'  OR `name`='site_email' OR `name`='address' OR `name`='address_en' OR `name`='facebook' OR `name`='twitter' OR `name`='google_plus' OR `name`='whatsapp'  OR `name`='site_desc'   OR `name`='site_desc_en' OR `name`='linkedin' OR `name`='trial_period_student' OR `name`='trial_period_parent' OR `name`='trial_period_teacher' OR `name`='app_android_version' OR `name`='app_IOS_version' OR name='hide_show_subsecription' OR name='hide_subsecription' OR name='show_all_languages' OR name='force_update' OR name='api_secrit_key_on'  ";

    // p($sql);
    $res  = $this->mDb->getAll($sql);
    foreach ($res as $k => $v) {
      $temp[$v['name']] = $v['value'];
    }

    return $temp;
  }

  function getSchoolYearBuCountryId($country_id)
  {
    $date = date('Y-m-d');

    $sql = "SELECT `id`, `added_by`, `status`, `title`, `country_id`, `first_semester_start`, `first_semester_end`, `second_semester_start`, `second_semester_end`, `date_added` FROM `school_years`";
    $sql .= " WHERE status ='1' AND `country_id` = '{$country_id}' and  second_semester_end > '{$date}'  order by second_semester_end asc ";
    // echo $sql;
    $res =  $this->mDb->getAll($sql);
    if (count($res)) {
      return $res[0];
    }
  }

  function insertToTransactionPaymentLog($temp)
  {
    $sql = "INSERT INTO `fawry_payment_transactions` SET ";
    foreach ($this->mDb->getCols('fawry_payment_transactions',  $temp) as $k => $v) {
      $sql .= ($k == 'cat_name') ? ' ' : "{$k}='{$v}',";
    }
    $sql .= "date_added='{$this->dateTime}'";
    //  echo $sql;die();
    return  $this->mDb->queryReturnLastId($sql);
  }
}
