<?php

$reportObj = new report();

class report
{

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $subjectObj;
    public $testObj;

    public function __construct()
    {
        global $Config;
        $this->subjectObj = new Subject();
        $this->testObj = new Test();
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
    }




    function getAllPerformanceReport($student_subject, $user_id, $user_type)
    {
        $subjectsPerformanceReports = [];

        if ($student_subject && count($student_subject) > 0) {
            for ($is = 0; $is < count($student_subject); $is++) {
                $respons = $this->getPerformanceReportByParams($student_subject[$is]['id'], 'all', $user_id, $user_type);
                if ($respons && $respons['tests_count'] > 0) {
                    $subjectsPerformanceReports[] = $respons;
                }
            }
        }


        $subjectsReportsCount = count($subjectsPerformanceReports);
        $ncounttp = (int)(array_sum(array_column($subjectsPerformanceReports, 'total_percentage')));
        $res['total_tests_count'] = (int)(array_sum(array_column($subjectsPerformanceReports, 'tests_count')));
        $res['total_percentage'] = $subjectsReportsCount > 0 ? (int)(($ncounttp) / ($subjectsReportsCount)) : 0;
        $res['subjects'] = $subjectsPerformanceReports;
        return $res;
    }




    function getPerformanceReportByParams($subject_id, $type, $user_id, $user_type)
    {
        global $USER_DATA;

        $test_arg['subject_id'] = $subject_id;
        $test_arg['user_id'] = $user_id;
        $test_arg['test_status'] = 'completed';
        $test_arg['corrected'] = '1';
        $test_arg['teacher_id'] = $user_type == 'teacher' ? $USER_DATA['id'] : '';
        $test_arg['type'] = $type;
        $test_arg['have_wrong_answers'] = false;
        $tests = $this->testObj->getStudentTestAnswerByParams($test_arg);


        $test_count = count($tests);
        $returnted['tests_count'] = $test_count;
        $returnted['tests'] = $tests;
        $subject_data  = $this->subjectObj->getSubjectData($subject_id);
        $returnted['subject_data']['id'] = $subject_data['id'];
        $returnted['subject_data']['name'] = $subject_data['name'];
        $returnted['subject_data']['subject_direction'] = $subject_data['subject_direction'];

        if ($test_count > 0) {
            $returnted['total_percentage'] = $test_count > 0 ? (int)(array_sum(array_column($tests, 'exam_degree_percentage')) / ($test_count))  : 0;
        } else {
            $returnted['total_percentage'] = 0;
        }
        return $returnted;
    }

    function getWrongsReport($subject_id, $type, $user_id, $user_type)
    {
        global $USER_DATA;
        $test_arg['subject_id'] = $subject_id;
        $test_arg['user_id'] = $user_id;
        $test_arg['test_status'] = 'completed';
        $test_arg['corrected'] = '1';
        $test_arg['type'] = $type;
        $test_arg['teacher_id'] = $user_type == 'teacher' ? $USER_DATA['id'] : '';

        $test_arg['have_wrong_answers'] = true;
        $tests = $this->testObj->getStudentTestAnswerByParams($test_arg);

        $test_count = count($tests);
        $returnted['tests_count'] = $test_count;
        $returnted['tests'] = $tests;

        $subject_data  = $this->subjectObj->getSubjectData($subject_id);
        $returnted['subject_data']['id'] = $subject_data['id'];
        $returnted['subject_data']['name'] = $subject_data['name'];
        $returnted['subject_data']['subject_direction'] = $subject_data['subject_direction'];


        if ($test_count > 0) {
            $returnted['total_percentage'] = $test_count > 0 ? (int)(array_sum(array_column($tests, 'exam_degree_percentage')) / ($test_count)) : 0;
        } else {
            $returnted['total_percentage'] = 0;
        }
        return $returnted;
    }


    // function getGeneralStatistic()
    // {

    //     $test_arg['subject_id'] = '';
    //     $test_arg['type'] = 'unit_test';
    //     $test_arg['have_wrong_answers'] = false;
    //     $test_arg['user_id'] = $USER_DATA['id'];
    //     $test_arg['test_status'] = 'completed';
    //     $test_arg['corrected'] = '1';
    //     $resUnitsTests = $this->testObj->getStudentTestAnswerByParams($test_arg);  // 2 
    //     $sum_units_tests_percentage = (array_sum(array_column($resUnitsTests, 'exam_degree_percentage'))); // 50 + 100 = 150
    //     $units_tests_percentage = count($resUnitsTests) > 0 ? (int)$sum_units_tests_percentage / count($resUnitsTests) : 0;
    //     //75




    //     $test_arg['subject_id'] = '';
    //     $test_arg['type'] = 'general_test';
    //     $test_arg['have_wrong_answers'] = false;
    //     $test_arg['user_id'] = $USER_DATA['id'];
    //     $test_arg['test_status'] = 'completed';
    //     $test_arg['corrected'] = '1';
    //     $resGeneralTests = $this->testObj->getStudentTestAnswerByParams($test_arg); // 3 

    //     $sum_general_tests_percentage = (array_sum(array_column($resGeneralTests, 'exam_degree_percentage'))); //  75 + 50 + 100 = 225
    //     $general_tests_percentage = count($resGeneralTests) > 0 ? (int)$sum_general_tests_percentage / count($resGeneralTests) : 0; //80



    //     $returnted['units_tests_count'] = count($resUnitsTests);
    //     $returnted['general_tests_count'] = count($resGeneralTests);

    //     if ($units_tests_percentage > 0 && $general_tests_percentage > 0) {
    //         $returnted['total_percentage'] = (int)(($units_tests_percentage + $general_tests_percentage) / 2);
    //     } elseif ($units_tests_percentage > 0) {
    //         $returnted['total_percentage'] = (int)$units_tests_percentage;
    //     } elseif ($general_tests_percentage > 0) {
    //         $returnted['total_percentage'] = (int) $general_tests_percentage;
    //     }
    //     return $returnted;
    // }
}
