<?php

$statisticsObj = new Statistics();

class Statistics
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }

  
  public function getStatisticsData()
  {
      $sql_teachers = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE `user_type` = 'teacher' ";
      $returnted['teachers'] = $this->mDb->getOne($sql_teachers);

      $sql_students = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE `user_type` = 'student'";
      $returnted['students'] = $this->mDb->getOne($sql_students);

      $sql_parents = "SELECT COUNT( DISTINCT `id`) FROM `users` WHERE `user_type` = 'parent'";
      $returnted['parents'] = $this->mDb->getOne($sql_parents);

      $sql_subjects = "SELECT COUNT(DISTINCT `id`) FROM `subjects`";
      $returnted['subjects'] = $this->mDb->getOne($sql_subjects);

      $sql_parents = "SELECT COUNT( DISTINCT `id`) FROM `test_questions`  ";
      $returnted['questions'] = $this->mDb->getOne($sql_parents);

      $sql_parents = "SELECT COUNT( DISTINCT `id`) FROM `tests`  WHERE `is_deleted` != '1'  ";
      $returnted['tests'] = $this->mDb->getOne($sql_parents);


      return $returnted;
  }


  function getStatisticsStudent($temp)
  {
    // enum('unit_exercise', 'unit_test', 'general_test')
    $sql = "SELECT   SUM(sta.exam_degree_percentage )  / count(sta.id) as total_degree_percentage from `student_tests_answers` sta ";
    $sql .= " LEFT JOIN `tests` t ON (t.id = sta.test_id) ";
    $sql .= "WHERE sta.user_id ='{$temp['user_id']}' AND sta.corrected ='{$temp['corrected']}'  AND t.type in ('unit_test','general_test')  AND t.is_deleted != '1'  ";
    // echo $sql;die();
    $res['total_degree_percentage'] = $this->mDb->getOne($sql);

    $temp['type'] = 'unit_exercise';
    $res['unit_exercise_count'] = $this->getCountOfTestByType($temp);

    $temp['type'] = 'unit_test';
    $res['unit_test_count'] = $this->getCountOfTestByType($temp);

    $temp['type'] = 'general_test';
    $res['general_test_count'] = $this->getCountOfTestByType($temp);
    return $res;
  }


  function getCountOfTestByType($temp)
  {
    // type	enum('unit_exercise', 'unit_test', 'general_test')
    $sql = "SELECT count(sta.id) from `student_tests_answers` sta ";
    $sql .= " LEFT JOIN `tests` t ON (t.id = sta.test_id) ";
    $sql .= "WHERE sta.user_id ='{$temp['user_id']}' AND sta.corrected ='{$temp['corrected']}' AND t.type ='{$temp['type']}' AND t.is_deleted != '1'  ";
    return $this->mDb->getOne($sql);
  }

  function getStatisticsTeacher($temp)
  {
    // enum('unit_exercise', 'unit_test', 'general_test')
    $sql = "SELECT count(s.id) from `tests_shares` s ";
    $sql .= " LEFT JOIN `tests` t ON (t.id = s.test_id) ";
    $sql .= "WHERE s.teacher_id ='{$temp['user_id']}' AND t.is_deleted != '1'   ";
    $res['share_count'] = $this->mDb->getOne($sql);

    $sql = "SELECT count(s.id) from `groups` s ";
    $sql .= "WHERE s.teacher_id ='{$temp['user_id']}' AND s.is_deleted != '1'   ";
    $res['group_count'] = $this->mDb->getOne($sql);


    return $res;
  }
}
