<?php

$subjectObj = new Subject();

class Subject
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }

  function getSubjectsToSignInOrEdit($grade_id, $specialize_id)
  {
    $sql = "SELECT f.name , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`   ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name  ,f.semester FROM `subjects` f ";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( f.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( f.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( f.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";

    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  !$specialize_id  ? "  AND  f.`grade_id` in ({$grade_id}) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";

    $sql .= " group by f.id   order by f.`sort` asc ";

    return $this->mDb->getAll($sql);
  }


  function getSubjects($grade_id, $specialize_id, $semester)
  {
    global  $USER_DATA;
    $sql = "SELECT f.name ,f.semester  , f.img, f.id , f.id as subject_id , f.subject_direction , f.cover_color  ,f.`stage_id` ,f.`grade_id`,f.`specialize_id`  FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1'    ";
    $sql .=  !$specialize_id  ? "  AND  f.`grade_id` in ({$grade_id}) "  : ' ';
    $sql .= $semester ? "  AND ( f.`semester` = '{$semester}' ||  f.`semester` = 'both' ) "  : ' ';
    $sql .=  $specialize_id ?  " AND ( (f.`grade_id` in ({$grade_id}) AND (f.`specialize_id` is null ||  f.`specialize_id` ='' ) ) || f.`specialize_id` in ({$specialize_id}) ) " :  " ";
    $sql .= " group by f.id   order by f.`sort` asc ";
    return $this->mDb->getAll($sql);
  }


  function getGridIdAndSpecializeIdBySubjectId($subject_id)
  {
    $sql = "SELECT f.specialize_id , f.grade_id ,f.semester    FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.is_deleted !='1' AND id ='{$subject_id}'  ";
    return $this->mDb->getRow($sql);
  }


  function getTeacher_stages($teacher_id)
  {
    $sql = "SELECT  ts.stage_id ,sl.name  as  stage_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `stages` s  ON  ( s.`id` = ts.`stage_id` )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE  ts.user_id = '{$teacher_id}' AND s.is_deleted != '1'   group by  ts.stage_id ";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }
  function getTeacher_grades($teacher_id, $stage_id)
  {
    $sql = "SELECT  ts.specialize_id , ts.grade_id ,gl.name  as  grade_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `grades` g  ON  ( g.`id` = ts.`grade_id` )";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.stage_id = '{$stage_id}' AND g.is_deleted != '1'   group by  ts.grade_id  order by g.sort asc  ";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }
  function getTeacher_specializes($teacher_id,  $grade_id)
  {
    $sql = "SELECT  ts.specialize_id ,spl.name  as specialize_name  FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `grades` g  ON  ( g.`id` = ts.`specialize_id` )";
    $sql .= " LEFT JOIN `grades_langs` spl  ON  ( ts.`specialize_id` = spl.`grade_id`  AND spl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}' AND  ts.grade_id = '{$grade_id}' AND g.is_deleted != '1'   group by  ts.specialize_id  order by g.sort asc  ";
    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }


  function getTeacher_subjects($teacher_id, $grade_id, $specialize_id, $semester)
  {

    $sql = "SELECT  s.* , ts.subject_id  ,ts.specialize_id ,ts.grade_id ,sl.name  as  stage_name ,gl.name  as grade_name ,spl.name  as specialize_name FROM `teacher_subjects` ts ";
    $sql .= " LEFT JOIN `subjects` s  ON  ( s.`id` = ts.`subject_id` )";
    $sql .= " LEFT JOIN `grades_langs` gl  ON  ( ts.`grade_id` = gl.`grade_id`  AND gl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= " LEFT JOIN `grades_langs` spl ON  ( ts.`specialize_id` = spl.`grade_id` AND spl.`lang_code` = '" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `stages_langs` sl  ON  ( ts.`stage_id` = sl.`stage_id`  AND sl.`lang_code` = '" . LANGUAGE . "' )";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'   AND  s.is_deleted !='1'  ";
    $sql .= $semester ? "  AND ( s.`semester` = '{$semester}'  || s.semester='both') "  : ' ';
    $sql .= !$specialize_id  && $grade_id ? " AND   ts.grade_id in ({$grade_id})    " :   " ";
    $sql .=  $specialize_id  && $grade_id  ?  " AND ( (ts.`grade_id` in ({$grade_id}) AND (ts.`specialize_id` is null ||  ts.`specialize_id` ='' ) ) || ts.`specialize_id` in ({$specialize_id}) ) " :  " ";

    // echo $sql;die();
    return $this->mDb->getAll($sql);
  }


  function getUnitOfSubject($subject_id, $semester)
  {


    $sql = "SELECT f.name , f.id , f.semester   FROM `units` f ";
    $sql .= "where f.`status` ='1' AND f.`subject_id` ='{$subject_id}'  AND  f.is_deleted !='1' ";
    $sql .= $semester  ? "  AND ( f.`semester` = '{$semester}' || f.`semester` ='both' ) "  : ' ';
    $sql .= "  order by f.`sort` asc ";
    // echo $sql ;
    return $this->mDb->getAll($sql);
  }

  function getUnitLesson($unit_id)
  {
    $sql = "SELECT f.name , f.id   FROM `unit_lessons` f ";
    $sql .= "where   f.`unit_id` ='{$unit_id}' AND  f.is_deleted !='1'  ";
    $sql .= "  order by f.`id` asc ";
    return $this->mDb->getAll($sql);
  }


  function getSubjectData($subject_id)
  {
    $sql = "SELECT * FROM `subjects` f ";
    $sql .= "where f.`status` ='1' AND f.`id` ='{$subject_id}'  AND  f.is_deleted !='1'  ";
    return $this->mDb->getRow($sql);
  }

  function getUnitData($unit_id)
  {
    $sql = "SELECT * FROM `units` f ";
    $sql .= "where f.`status` ='1' AND f.`id` ='{$unit_id}'  AND  f.is_deleted !='1'  ";
    // echo $sql;
    return $this->mDb->getRow($sql);
  }


  function getLessonData($lesson_id)
  {
    $sql = "SELECT * FROM `unit_lessons` f ";
    $sql .= "where  f.`id` ='{$lesson_id}' AND  f.is_deleted !='1'  ";
    return $this->mDb->getRow($sql);
  }

  function checkCatbyParams($subject_id, $type)
  {
    $sql = "SELECT f.id FROM `categories` f ";
    $sql .= "where f.`status` ='1' AND f.`subject_id` ='{$subject_id}' AND f.`type` ='{$type}'     ";
    // p($sql);
    return $this->mDb->getOne($sql);
  }



  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////
  /////////////////////////////// security ///////////////////////////////

  function checkTeacherRelatedToSubject($teacher_id, $subject_id)
  {
    $sql = "SELECT  ts.id   FROM `teacher_subjects` ts ";
    $sql .= "WHERE   ts.user_id = '{$teacher_id}'  AND ts.`subject_id` ='{$subject_id}' ";
    //  echo $sql;die();
    return $this->mDb->getOne($sql);
  }


  function checkStudentRelatedToSubject($grade_id, $subject_id)
  {
    $sql = "SELECT  s.id   FROM `subjects` s ";
    $sql .= "WHERE   s.grade_id = '{$grade_id}'  AND s.`id` ='{$subject_id}' ";
    //  echo $sql;die();
    return $this->mDb->getOne($sql);
  }
}
