<?php

$subscriptionObj = new Subscription();

class Subscription
{

  public $mDb;
  public $mConfig;
  public $mMailer;
  public $dateTime;
  function __construct()
  {
    global $Config;
    $this->mDb = new iplus();
    $this->mConfig = $Config;
    $this->mMailer = new Mailer();

    $this->dateTime = date('Y-m-d H:i:s');
  }

  function getSubscriptionCostContent()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title    FROM `subscription_cost_content`   ";
    $sql .= "where   `status` ='1' order by sort asc  ";
    //  echo  $sql;
    return $this->mDb->getAll($sql);
  }

  function getSubscriptionCostSteps()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title , description_" . LANGUAGE . " as description    FROM `subscription_cost_steps`   ";
    $sql .= "where `status` ='1' order by sort asc  ";
    // echo  $sql;
    return $this->mDb->getAll($sql);
  }


  function getSubscriptionVideos()
  {
    $sql = "SELECT  title_" . LANGUAGE . " as title ,   video FROM `subscription_cost_videos`   ";
    $sql .= "where `status` ='1' order by sort asc  ";
    // echo  $sql;
    return $this->mDb->getAll($sql);
  }





  function getAllSubscriptionCosts($temp)
  {
    $sql = "SELECT c.id ,  c.trial_period ,c.subscription_type , c.category, c.cost , c.cost_year , c.cost_semester  ,cl.title  ,cl.description , cuntl.`currency_name`  FROM `subscription_costs` c ";
    $sql .= "LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= "where c.`status` ='1' AND c.`category` in ({$temp['category']}) ";

    $sql .= $temp['stage_id'] && $temp['user_type'] == 'student' ? "AND c.`stage_id` ='{$temp['stage_id']}' " : " ";

    $sql .= $temp['grade_id'] && $temp['user_type'] == 'student' ? "AND c.`grade_id` ='{$temp['grade_id']}' " : " ";

    $sql .= $temp['user_type'] ? "AND c.`user_type` ='{$temp['user_type']}' " : " ";
    $sql .= $temp['subscription_type'] ? "AND c.`subscription_type` ='{$temp['subscription_type']}' " : " ";
    $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    // echo $sql ;die();
    return $temp['itemsPerPage'] == '1' ? $this->mDb->getRow($sql) : $this->mDb->getAll($sql);
  }

  function getSubscriptionDetails($id)
  {
    $sql = "SELECT  c.* ,cl.title  ,cl.description , cuntl.`currency_name`  FROM `subscription_costs` c ";
    $sql .= "LEFT JOIN `subscription_costs_langs` cl ON ( c.`id` = cl.`subscription_cost_id`  AND cl.`lang_code`='" . LANGUAGE . "'  )";
    $sql .= " LEFT JOIN `countries_langs` cuntl ON  ( c.`country_id` = cuntl.`country_id` AND cuntl.`lang_code` = '" . LANGUAGE . "'  ) ";
    $sql .= "where c.id = {$id} AND c.`status` ='1'  ";
    //  echo  $sql;
    return $this->mDb->getRow($sql);
  }
  function getSubscription($id)
  {
    $sql = "SELECT  c.*   FROM `subscription_costs` c ";
    $sql .= "where c.id = {$id} AND c.`status` ='1'  ";
    //  echo  $sql;
    return $this->mDb->getRow($sql);
  }




  function addUserSubscription($temp)
  {
    $temp['days']  =  $temp['days'] > 0 ?  $temp['days'] :  0;

    $sql = "INSERT INTO `user_subscription` SET ";
    $sql .= "  `user_id` = '{$temp['user_id']}' ";
    $sql .= " , `start_date` = '{$temp['start_date']}' ";
    $sql .= " , `end_date` = '{$temp['end_date']}' ";
    $sql .= " , `subscription_type` = '{$temp['subscription_type']}' ";
    $sql .= " , `year_title` = '{$temp['year_title']}' ";
    $sql .= $temp['cost'] ? " , `cost` = '{$temp['cost']}' " : " ";
    $sql .= $temp['cost_type'] ? " , `cost_type` = '{$temp['cost_type']}' " : " ";
    $sql .= $temp['fawry_payment_transaction_id'] ? " , `fawry_payment_transaction_id` = '{$temp['fawry_payment_transaction_id']}' " : " ";
    $sql .= " , `date_added` = '{$this->dateTime}' ";


    // echo $sql;die();
    return  $this->mDb->query($sql);
  }




  function getMySubscriptionLog($temp)
  {
    $sql = "SELECT us.* , fpt.responce FROM `user_subscription` us ";
    $sql .= "LEFT JOIN `fawry_payment_transactions` fpt ON ( fpt.`id` = us.`fawry_payment_transaction_id` )";
    $sql .= "where us.`user_id` ='{$temp['user_id']}' and payment_transaction_type = 'subscription'  order by us.id desc   ";
    $sql .=   $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
    $res = $this->mDb->getAll($sql);

    for ($i = 0; $i < count($res); $i++) {
      $res[$i]['responce'] =  json_decode($res[$i]['responce']);
      $res[$i]['currency_name'] = $this->getCurrancyByCountryId();
    }
    return $res;
  }

  function  getCurrancyByCountryId()
  {global $USER_DATA;
    $sql  = "SELECT  currency_name FROM `countries_langs` where country_id = " . $USER_DATA['country_id'] . " ";
    return $this->mDb->getOne($sql);
  }
}
