<?php

/* * *************************************************************************
 *
 *   PROJECT: rhletak
 *   powerd by ashraf hamdy
 *   Copyright 2016 IT Plus Inc
 *   http://it-plus.co/s
 *
 * ************************************************************************* */

/**
 * Converts string to url valid string
 *
 * @param arr $aParams text string
 *
 * @return str
 */
function convert_str($aParams)
{
    $aParams['string'] = strtolower($aParams['string']);
    $aParams['string'] = preg_replace('/[^a-z0-9]+/i', '-', $aParams['string']);
    $aParams['string'] = preg_replace('/\-+/', '-', $aParams['string']);
    $aParams['string'] = trim($aParams['string'], '-');

    return $aParams['string'];
}

/**
 * Returns correct path for a directory
 *
 * @param str $aPath parent category path
 * @param str $aTitle category title
 *
 * @return str
 */
function dir_form_path($aPath, $aTitle)
{
    $params['string'] = $aTitle;
    $title = convert_str($params['string']);

    return $aPath . '/' . $title;
}

function poweredBy()
{

    return "<p> Powered by <a href='www.it-plus.co' target='_blank' >IT Plus </a> </p>";
}

/**
 * Prints navigation menu
 *
 * Note about url template!
 * Url template shoud contain %1 that will be replaced
 * with actual page number.  This is very convenient
 * in case url will be change (e.g. for mod_rewrite purpose
 * it changes from 'index.php?page=2' to 'index2.htm'
 */
function navigation($aTotal, $aStart, $aNum, $aUrl, $aItemsPerPage = 3, $aLinksPerPage = 5)
{
    //    echo $aTotal;    echo '<br/>';
    //    echo $aStart;echo '<br/>';
    //    echo $aNum;echo '<br/>';
    //    echo $aUrl;echo '<br/>';
    //    echo $aItemsPerPage;echo '<br/>';
    //    echo $aLinksPerPage;echo '<br/>';
    //    die();
    global $Lang;
    if ($aTotal && $aTotal > $aItemsPerPage) {

        $num_pages = ceil($aTotal / $aItemsPerPage);
        //        echo $num_pages;
        //        die();
        $current_page = (int) $_GET['page'];
        $current_page = ($current_page < 1) ? 1 : ($current_page > $num_pages ? $num_pages : $current_page);

        $left_offset = ceil($aLinksPerPage / 2) - 1;
        $first = $current_page - $left_offset;
        $first = ($first < 1) ? 1 : $first;

        $last = $first + $aLinksPerPage - 1;
        $last = ($last > $num_pages) ? $num_pages : $last;

        $first = $last - $aLinksPerPage + 1;
        $first = ($first < 1) ? 1 : $first;

        $pages = range($first, $last);

        $out = '<div class="pagination pull-left" style="margin: 0;">    <ul>';

        $delim = ('.php' == strtolower(substr($aUrl, -4))) ? '?' : '&amp;';

        // Previous, First links
        if ($current_page > 1) {
            $prev = $current_page - 1;
            $out .= "<li ><a href=\"{$aUrl}{$delim}page={$prev}{$delim}items=" . (int) $_GET['items'] . "\">&raquo;</a></li>";
        } else {
            $out .= '<li class="disabled"><a href="#">&raquo;</a></li>';
        }

        foreach ($pages as $page) {
            if ($current_page == $page) {
                $out .= " <li class=\"active\"><a href=\"#\">{$page}</a></li>";
            } else {
                $out .= "<li><a href=\"{$aUrl}{$delim}page={$page}{$delim}items=" . (int) $_GET['items'] . "\"> {$page}</a> </li>";
            }
        }

        if ($current_page < $num_pages) {

            $next = $current_page + 1;
            $out .= "<li ><a href=\"{$aUrl}{$delim}page={$next}{$delim}items=" . (int) $_GET['items'] . "\">&laquo;</a></li>";
        } else {
            $out .= '<li class="disabled"><a href="#">&laquo;</a></li>';
        }

        $out .= '</div>';
    }
    $from = ($aTotal > 0) ? $aStart + 1 : $aStart;
    $to = ($aTotal > ($aStart + 1 + $aItemsPerPage)) ? $aStart + $aItemsPerPage : $aTotal;
    $out .= 'من ' . $from . ' الى ' . $to . ' الاجمالي ' . $aTotal;
    return $out;
}

/**
 * Checks if reciprocal link exists
 *
 * @param str $aRecip reciprocal page url
 *
 * @return int
 */
function check_reciprocal($aRecip)
{
    global $gDirConfig;

    $reciprocal = "<(\s*)a (.*)href=(\"{0,1}){$gDirConfig['reciprocal_text']}(\"{0,1})(.*)>(.*)</a>";

    $res = 0;
    $content = @file($aRecip);
    if ($content) {
        if ($ftext = join('', $content)) {
            $res = eregi($reciprocal, $ftext) ? 1 : 0;
        }
    }

    return $res;
}

/**
 * Checks link and returns its header
 *
 * @param str $aUrl page url
 *
 * @return int
 */
function get_link_header($aUrl)
{
    if (preg_match("'^http://'", $aUrl)) {
        $content = @file($aUrl);
        if ($content) {
            $header = join("\n", $http_response_header);
            list(, $http_header,) = split(" ", $header, 3);
        } else {
            $http_header = 0;
        }
    }
    return $http_header;
}

/**
 * Validates email
 *
 * @param str $aEmail email 
 *
 * @return bool
 */
function valid_email($aEmail)
{
    return preg_match('/^[a-z0-9\-_\.]+@[a-z0-9\-_]+(\.[a-z0-9]{2,4})+$/i', $aEmail);
}

/**
 * Converts link description to html
 *
 * @param str $aParams parameters array
 *
 * @return str
 */
function text_to_html($aParams)
{
    $out = '';

    $aParams['aText'] = htmlentities($aParams['aText']);

    $aParams['aText'] = preg_replace('/\[b\]/', '<b>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/b\]/', '</b>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[i\]/', '<i>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/i\]/', '</i>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[u\]/', '<u>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/u\]/', '</u>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[hl\]/', '<span class="highlight">', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/hl\]/', '</span>', $aParams['aText']);

    $aParams['aText'] = nl2br($aParams['aText']);
    if ($aParams['aParagraph']) {
        $paragraphs = explode("\r\n", $aParams['aText']);
        foreach ($paragraphs as $paragraph) {
            if (strlen($paragraph) > 0) {
                $out .= "<p class=\"user\">{$paragraph}</p>\n";
            }
        }
    } else {
        $out = $aParams['aText'];
    }
    return $out;
}

function format($aParam)
{
    return number_format($aParam, 3);
}

function newPassword()
{
    $pass = rand(100000, 1000000);

    return $pass;
}

function generateKey()
{
    $key = rand(100000, 999999);
    return $key;
}


function rename_file($file_name)
{
    $date = date("YmdHms");
    $rand = rand(10000, 99999);
    $encr = md5($date . $rand);
    $mbss = mb_substr($encr, "4", "4", "utf-8");
    $new_name = $date . "_" . $mbss;
    return $new_name;
}

function print_box($aContent = '')
{
    if ($aContent) {
        foreach ($aContent as $key => $value) {
            for ($i = 0; $i < count($value); $i++) {
                $cont .= " <div class='alert alert-{$key}'>
                          <button class='close' data-dismiss='alert' type='button'>×</button>
                          {$value[$i]}
                      </div>";
            }
        }
        return $cont;
    }
}

function print_box2($aId = '', $aTitle = '', $aContent = '', $aIcon = '')
{
    if (MENU_PARENT == $aId) {
        $s = ' <li class = "start active">';
        $s .= '<a href = "javascript:;">
<i class = "icon-puzzle"></i>
<span class = "title">' . $aTitle . '</span>
<span class = "arrow open"></span>
</a>
<ul class="sub-menu" style="display: block;">';
        $s .= $aContent;
        $s .= '</ul>
</li>';
    } else {
        $s = '  <li class = "">';
        $s .= '<a href = "javascript:;">
            ' . $aIcon . '
<span class = "title">' . $aTitle . '</span>
<span class = "arrow open"></span>
</a>
<ul class="sub-menu" style="display: none;">';
        $s .= $aContent;
        $s .= '</ul>
</li>';
    }

    return $s;
}

/**
 * Returns all values of array as string 
 *
 * @param arr $arr 
 *
 * @return str
 */
function fetchArrayValue($arr)
{
    $str = "";
    foreach ($arr as $value) {
        $str .= $value;
        if (next($arr) == true)
            $str .= ",";
    }
    return $str;
}

function time_ago($ptime)
{
    $etime = time() - $ptime;

    if ($etime < 1) {
        return '0 seconds';
    }

    $a = array(
        12 * 30 * 24 * 60 * 60 => 'year',
        30 * 24 * 60 * 60 => 'month',
        24 * 60 * 60 => 'day',
        60 * 60 => 'hour',
        60 => 'minute',
        1 => 'second'
    );

    foreach ($a as $secs => $str) {
        $d = $etime / $secs;
        if ($d >= 1) {
            $r = round($d);
            return $r . ' ' . $str . ($r > 1 ? 's' : '') . ' ago';
        }
    }
}

/**
 * Prints menu elements
 *
 * @param arr $aMenu array of menu elements
 *
 * @return str
 */
function print_menu($aMenu)
{


    foreach ($aMenu as $key => $value) {
        $caption = $value['caption'];
        $url = $value['url'];

        $icon = $value['icon'] ? "<i class=\"{$value['icon']}\"></i>" : '';

        if (THIS_PAGE == $key) {
            $out .= '<li class="active">
<a href=' . $url . '>
    ' . $icon . '
' . $caption . '
</a>
</li>';
        } else {
            $out .= '<li class="">
<a href=' . $url . '>
' . $icon . '
' . $caption . '
</a>
</li>';
        }
    }


    return $out;
}

function in_array_r($needle, $haystack, $strict = false)
{
    foreach ($haystack as $item) {
        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && in_array_r($needle, $item, $strict))) {
            return true;
        }
    }

    return false;
}



function p($value, $die = true)
{
    if (IsTestMode) {
        echo "<pre>";
        print_r($value);
        if ($die == true) {
            die('End Here');
        }
    }
}

function frist_trim_text($input_1, $length, $strip_html = true)
{

    //strip tags, if desired
    if ($strip_html) {
        $input_1 = strip_tags($input_1);
    }
    //no need to trim, already shorter than trim length
    if (mb_strlen($input_1, 'UTF-8') <= $length || !$length) {
        $input_1 =  str_replace(array("&nbsp;"), " ", $input_1);
        return $input_1;
    }
    $last_space = mb_strrpos(mb_substr($input_1, 0, $length, "utf-8"), ' ', "utf-8");
    //    echo $last_space . "<hr>";
    $trimmed_text = mb_substr($input_1, 0, $last_space, "utf-8");

    $trimmed_text =  str_replace(array("&nbsp;"), " ",    $trimmed_text);

    return $trimmed_text . ' ...';
}
function fetchArrayValue_from_dataBase($arr, $column)
{
    $str = "";

    foreach ($arr as $value) {
        $str .= $value[$column];
        if (next($arr) == true)
            $str .= ",";
    }
    $explode = explode(",", $str);
    $explode = array_unique($explode);
    $implode = implode(",", $explode);
    // die();
    return $implode;
}


function retNewLine($value)
{
    return str_replace('<br />', ' <br> ', str_replace(PHP_EOL, '', nl2br($value)));
}

function httpPost($url, $data)
{

    $header = [
        'Content-Type: application/json',
    ];

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
    $response = curl_exec($curl);
    $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $header = substr($response, 0, $header_size);
    $body = substr($response, $header_size);
    curl_close($curl);
    return $body;
}
function httpPostSMS($url, $data)
{

    $header = [
        "Content-Type:application/json",
        "Accept:application/json",
        "Accept-Language:en-US"
    ];

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
    $response = curl_exec($curl);
    $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $header = substr($response, 0, $header_size);
    $body = substr($response, $header_size);
    curl_close($curl);
    return $body;
}
function httpGet($url)
{
    //Initialize cURL.
    $ch = curl_init();

    //Set the URL that you want to GET by using the CURLOPT_URL option.
    curl_setopt($ch, CURLOPT_URL, $url);

    //Set CURLOPT_RETURNTRANSFER so that the content is returned as a variable.
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    //Set CURLOPT_FOLLOWLOCATION to true to follow redirects.
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);

    //Execute the request.
    $data = curl_exec($ch);

    //Close the cURL handle.
    curl_close($ch);

    //Print the data out onto the page.
    return $data;
}

function date_diffr($date_from, $date_to)

{

    if ($date_from < $date_to) {
        $dateTimeObject1 = date_create($date_from);
        $dateTimeObject2 = date_create($date_to);

        $difference = date_diff($dateTimeObject1, $dateTimeObject2);
        $minutes = $difference->days * 24 * 60;
        $minutes += $difference->h * 60;
        $minutes += $difference->i;
        $minutes += $difference->s / 60;
        return $minutes;
    } else {
        return 0;
    }
}

function getFileSizeArr($res, $Folder_name)
{
    for ($i = 0; $i < count($res); $i++) {
        $data = getFileSizeOne($res[$i]['file'], $Folder_name);
        $res[$i]['file_size'] =  $data['file_size'];
        $res[$i]['human_file_size'] =  $data['human_file_size'];
    }
    return $res;
}

function getFileSizeOne($file, $Folder_name)
{
    $item = [];
    $item['file_size'] = filesize('../uploads/' . $Folder_name  . "/" . $file);
    $item['human_file_size'] = human_filesize($item['file_size']);
    return $item;
}

function human_filesize($bytes, $decimals = 1)
{
    $sz = 'BKMGTP';
    $factor = floor((strlen($bytes) - 1) / 3);
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
}

function  renderMathType($textHtml)
{
    if (is_numeric(strpos($textHtml, '<math'))) {
        $arr =  explode("<math", $textHtml);
        for ($i = 1; $i <  count($arr); $i++) {

            $str = "<math" .  substr($arr[$i], 0, strpos($arr[$i], "</math>") + 7);

            $new_arr[$i] = str_replace($str, renderMathTypeComplete($str), "<math" . $arr[$i]);
        }
        return  $arr[0] . implode("", $new_arr);
    } else {
        return $textHtml;
    }
}

function renderMathTypeComplete($data)
{
    $url = 'https://www.wiris.net/demo/plugins/app/showimage?fontFamily=sans-serif&mml=' . urlencode($data);
    $responce = httpGet2($url);
    $responce = json_decode($responce, true);
    return $responce['result']['content'];
}
function httpGet2($url)
{
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
    ));
    $response = curl_exec($curl);
    curl_close($curl);
    return $response;
}
function startsWith($string, $startString)
{
    $len = strlen($startString);
    return (substr($string, 0, $len) === $startString);
}

function GetExt_($filename)
{

    // if file name is not null
    if (!is_null($filename)) {

        // make the file name lower case and crop the ext
        $fileext = strtolower(strrchr(strtolower($filename), '.'));
        // replace the dot (.) with blank
        $fileext = str_replace(".", "", $fileext);
        // return the file ext
        // if($fileext=="webp"){
        //     return("jpg");
        // }
        return ($fileext);
    } else {
        // return false if file name is null
        return (FALSE);
    }
}
function htmlToPlainText($str)
{
    $str = $str ? $str : '';
    if ($str) {
        $str = str_replace('&nbsp;', ' ', $str);
        $str = html_entity_decode($str, ENT_QUOTES | ENT_COMPAT, 'UTF-8');
        $str = html_entity_decode($str, ENT_HTML5, 'UTF-8');
        $str = html_entity_decode($str);
        $str = htmlspecialchars_decode($str);
        $str = strip_tags($str);
    }


    return $str;
}
