<?php

require_once("Factories/QuestionFactory.php");
$testObj = new Test();

class Test
{

    public $mConfig;
    public $mMailer;
    public $notifyObj;
    public $dateTime;
    
    function __construct()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mMailer = new Mailer();
        $this->subjectObj = new Subject();
        $this->notifyObj = new notifications();
        $this->dateTime = date('Y-m-d H:i:s');
        $this->questionFactory = new QuestionFactory;
        $this->questions_table = ["1" => "first_primary","2" => "second_primary",
                    "4" => "third_primary",
                    "9" => "fourth_primary", "10" => "fifth_primary",
                    "11" => "sixth_primary","12" => "first_middle",
                    "13" => "second_middle","14" => "third_middle",
                    "15" => "second_secondary", "16" => "first_secondary",
                    "17" => "third_secondary", "22" => "experimental"];
        
    }

    ////////////////////////////////////////////`tests`////////////////////////////////////////////
    function getTeacher_idForTest_id($test_id)
    {
        // p($techer_subject_ids);
        $sql = "SELECT  `teacher_id` from  `tests`  ";
        $sql .= " where `id`= '{$test_id}'  ";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function updateCorrectColumn($student_tests_answers_id)
    {
        $sql = "select test_id from student_tests_answers where id = {$student_tests_answers_id}";
        $test_id = $this->mDb->getOne($sql);

        $thereManualSolvingQustion = $this->checkIfThereManualSolvingQustionOnTest($test_id);
        if (!$thereManualSolvingQustion) {
            $sql = "UPDATE `student_tests_answers` SET `corrected` = '1'";
            $sql .= " WHERE `id`={$student_tests_answers_id}";
            // echo $sql;die();
            $this->mDb->query($sql);
        }
    }

    function setTestCompleted($student_tests_answers_id)
    {

        $this->test_correction($student_tests_answers_id);
        $sql = "UPDATE `student_tests_answers` SET `test_status` = 'completed'";
        $sql .= " WHERE `id`={$student_tests_answers_id}";
        // echo $sql; die();
        $res = $this->mDb->query($sql);
        if ($res) {
            return $res;
        }
    }

    function getSomeUserData($aUserId)
    {
        $sql = "SELECT full_name   FROM `users`";
        $sql .= "WHERE `id`='{$aUserId}' ";
        //echo $sql;die();
        return $this->mDb->getRow($sql);
    }
    function getGradeIdOfTest($test_id){
        $sql = "SELECT grade_id FROM `tests` WHERE id = '{$test_id}' ";
        return $this->mDb->getOne($sql);
    }
    
    function getGradeIdOfSubject($subject_id){
        $sql = "SELECT grade_id FROM `subjects` WHERE id = '{$subject_id}' ";
        return $this->mDb->getOne($sql);
    }
    function getHeadQuestions($test_id, $test_random_order = 0){
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "
            SELECT 
                pl.*, 
                pl.id as question_id 
            FROM 
                `".$table."_test_questions` pl 
            INNER JOIN 
                (SELECT id FROM `".$table."_test_questions` WHERE `test_id` = :test_id AND `parent_id` = '0' AND `type` = 'head_question') head_questions 
            ON 
                pl.`question_header_id` = head_questions.id 
            WHERE 
                pl.`test_id` = :test_id
            ORDER BY RAND()
        ";
        
        // Prepare and execute the statement
        $stmt = $this->mDb->prepare($sql);
        $stmt->execute([':test_id' => $test_id]);
        
        // Fetch the results
        return $stmt->fetchAll(PDO::FETCH_ASSOC);




    }
    function getOneTestDetails($temp)
    {
        $this->reFactorTest($temp['id']);
        // echo"TEST";die();
        $sql = " SELECT * FROM `tests_" . LANGUAGE . "`";
        $sql .= " WHERE id ='{$temp['id']}' AND status ='1'  AND is_deleted !='1' ";
        // echo $sql;die();
        $result = $this->mDb->getRow($sql);

        if ($result['id'] > 0) {
            if ($result['teacher_id']) {
                $result['teacher'] = $this->getSomeUserData($result['teacher_id']);
            }
            $result['available_to_visitor'] = $this->getAvailableToVisitorOfTest($temp['id']);
            $result['test_question_count'] = $this->getCountOfQustionsOfTest($temp['id']);
            $thereArticleQustuibOnTest = $this->checkIfThereManualSolvingQustionOnTest($temp['id']);
            $result['can_scan_test'] = $thereArticleQustuibOnTest ? false : true;
            if($temp['user_type'] == 'teacher'){
                $result['random_order_status'] = $result['random_order'];
                $result['random_order'] = '0';
            }
            $test_questions = $this->getTestQuestion($temp['id'], '0', $temp['question_id'], $result['random_order']);
          
            if ($temp['user_type'] == 'student') {

                $data_ = $this->getSomeStudent_tests_answersTestData($temp['student_id'], $temp['id'], $temp['share_id'], '');
                // print_r($data_);die();
                $result['completion_percentage'] = $data_['total_question_count'] > 0 && $data_['total_answered_questions_count'] > 0 ? number_format(($data_['total_answered_questions_count'] / $data_['total_question_count'] * 100), 1, '.', '') : 0;
                
                $result['finished_before'] = $this->checkStudentHaveTestCompleted($temp['student_id'], $temp['id'], $temp['share_id']);
            }
            $result['print_PDF'] = 0;
            $result['print_pubblesheet'] = 0;
            $print_type = explode(",", $result['print_type']);
            if (in_array("pdf", $print_type)) {
                $result['print_PDF'] = 1;
            }
            if (in_array("bubble_sheet", $print_type)) {
                $result['print_pubblesheet'] = 1;
            }
            $result['count_of_answers_to_the_test'] = $this->countOfAnswerOnTest($temp['id']);
            
            $questions = $this->customQuestions($test_questions, $temp, $result['random_order']);
            $result['test_questions'] = $questions['test_questions'];
        }
        
        return $result;
    }

    function customQuestions($test_questions, $temp=array(), $random_order = 0, $ref = false)
    {
        // print_r($temp);die();
       
        global $USER_DATA;
        $block_index = 0;
        $q_p_index = 0;
        $result['test_questions'] = $test_questions;
        $count_of_test_questions = count($result['test_questions']);
        $resulte_qustions = $temp['resulte_qustions'];
        for ($i = 0; $i < $count_of_test_questions; $i++) {
            
            $q_p_index = 0;

            $temp['id'] = $test_questions[$i]['test_id'] ? $test_questions[$i]['test_id'] : $temp['id'];

            $student_tests_answers_id = $result['test_questions'][$i]['student_tests_answers_id'] ? $result['test_questions'][$i]['student_tests_answers_id'] : $temp['student_tests_answers_id'];

            $result['test_questions'][$i]['question_answer'] = $student_tests_answers_id ? $this->getAnswesOfQuestions($student_tests_answers_id, $result['test_questions'][$i]['id']) : false;


            if (!$result['test_questions'][$i]['question_answer'] && $USER_DATA['user_type'] == 'student' && $temp['test_status'] == "not_completed") {

                $resulte_qustions = false;
            } else {

                $resulte_qustions = $temp['resulte_qustions'];
            }

            if(isset($temp['for_printable']) && $temp['for_printable']){
                $resulte_qustions = false;
            }

            $result['test_questions'][$i]['question_id'] = $result['test_questions'][$i]['question_answer']['question_id'];
            
            
              if($result['test_questions'][$i]['type'] == 'article'){
                 $result['test_questions'][$i]['is_correct'] = $this->checkArticleQuestionIsCorrected($result['test_questions'][$i]['id'], $temp['id'], $student_tests_answers_id);
              }
            if (
                $result['test_questions'][$i]['type'] == 'choose' ||
                $result['test_questions'][$i]['type'] == 'check'
            ) {
                // echo 'test';die();
                $result['test_questions'][$i]['test_question_options'] = $this->getQuestionOptions($result['test_questions'][$i]['id'], $temp['id'], $resulte_qustions, $random_order);

                $result['test_questions'][$i]['count_of_right_options'] = count($this->getRigthOptionOfQuestion($result['test_questions'][$i]['id'], $temp['id']));
            } else if ($result['test_questions'][$i]['type'] == 'match_it') {

                $result['test_questions'][$i]['test_question_match_options'] = $this->getQuestionMatch_it($result['test_questions'][$i]['id'], $temp['id'], $resulte_qustions, $random_order);

            } else if ($result['test_questions'][$i]['type'] == 'sort_it') {

                    // echo $result['test_questions'][$i]['id'];die();
                $result['test_questions'][$i]['test_question_sort_words'] = $this->getQuestionSort_it($result['test_questions'][$i]['id'],$temp['id'], $resulte_qustions);
                
                if ($USER_DATA['user_type'] == 'teacher') {
                    $result['test_questions'][$i]['test_question_sort_words_orginal'] = $this->getQuestionSort_itOrginal($result['test_questions'][$i]['id'],$temp['id'], false, $random_order);
                    $result['test_questions'][$i]['test_question_sort_words_hide_solution'] = $result['test_questions'][$i]['test_question_sort_words_orginal'];
                }
            } 
            else if ($result['test_questions'][$i]['type'] == 'paragraphs' && !$ref) {
                       
                    
                $result['test_questions'][$i]['test_questions_paragraphs'] = $this->getTestQuestion($temp['id'], $result['test_questions'][$i]['id'], '', $random_order);

                for ($k = 0; $k < count($result['test_questions'][$i]['test_questions_paragraphs']); $k++) {
                   
                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['question_answer'] = $student_tests_answers_id ? $this->getAnswesOfQuestions($student_tests_answers_id, $result['test_questions'][$i]['test_questions_paragraphs'][$k]['id']) : false;
                    if (!$result['test_questions'][$i]['test_questions_paragraphs'][$k]['question_answer'] && $USER_DATA['user_type'] == 'student' && $temp['test_status'] == "not_completed") {
                        $resulte_qustions = false;
                    } else {
                        $resulte_qustions = $temp['resulte_qustions'];

                    }

                    if (
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'choose' ||
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'check'
                    ) {

                        //   echo "TEST";die();
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['q_p_index'] = $q_p_index;
                        $q_p_index++;
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_options'] = $this->getQuestionOptions($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'], $temp['id'], $resulte_qustions, $random_order);

                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['count_of_right_options'] = count($this->getRigthOptionOfQuestion($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'], $temp['id']), $random_order);
                    } else if ($result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'match_it') {
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_match_options'] = $this->getQuestionMatch_it($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'],$temp['id'], $resulte_qustions);
                    } else if ($result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'sort_it') {
                        
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words'] = $this->getQuestionSort_it($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'],$temp['id'], $resulte_qustions);
                        if ($USER_DATA['user_type'] == 'teacher') {
                            $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_orginal'] = $this->getQuestionSort_itOrginal($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'],$temp['id'], false);
                            $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_hide_solution'] = $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_orginal'];
                        }
                    } else if (
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it' ||
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_auto_correct' ||
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_manual_correct'
                    ) {

                        //   print_r($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id']);die();
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['degree'] = $this->getSumOfDegreeOfQuestionsByParent($temp['id'], $result['test_questions'][$i]['test_questions_paragraphs'][$k]['id']);
                        // print_r($result['test_questions'][$i]['test_questions_paragraphs']);die();
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = $this->getTestQuestion($temp['id'], $result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'], '', $random_order);
                        // echo $result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'] . "===>";
                        // print_r($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']);
                        $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = [];


                        if ($result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it' || $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_auto_correct' || $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_manual_correct') {
                            //   echo $result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] ;die();
                            // echo count($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']);die();
                            for ($l = 0; $l < count($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']); $l++) {
                                if ($result['test_questions'][$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_manual_correct') {
                                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show'] = $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['math_type_view_title'];
                                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['math_type_show_title'] = renderMathType($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show']);
                                    
                                } else {
                                    //
                                    $array2 = $this->getQuestionComplete_words($temp['id'], $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['id'], $resulte_qustions, $random_order);
                                    // print_r($array2);die();
                                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['test_questions_complete_it_words'] = $array2;

                                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = array_merge($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'], $array2);


                                    $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show'] = $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title'];
                                    // for ($w = 0; $w < count($array2); $w++) {
                                    // p($array2);
                                    // if ($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['id'] == $array2[$w]['question_id']) {
                                    //   $indexOfTestat_blank = strpos($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show'], 'testat_blank');
                                    //   if ($USER_DATA['user_type'] == 'teacher' && $indexOfTestat_blank) {
                                    //     $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show'] = substr_replace($result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$l]['title_show'], "(#" . $array2[$w]['title'] . "#)", $indexOfTestat_blank, 12);
                                    //   }
                                    // }
                                    // }
                                }
                            }
                            if ($USER_DATA['user_type'] == 'teacher') {
                                $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_orginal'] = $this->getQuestionSort_itOrginal($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'],$temp['id'], false, $random_order);
                                $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_hide_solution'] = $result['test_questions'][$i]['test_questions_paragraphs'][$k]['test_question_sort_words_orginal'];
                            }
                        }


                        // if ($temp['resulte_qustions'] && $result['test_questions'][$i]['test_questions_paragraphs'][$k]['question_answer'] === false) {
                        //   unset($result['test_questions'][$i]['test_questions_paragraphs'][$k]);
                        // }
                        // if (
                        //   $result['test_questions'][$i]['test_questions_paragraphs'][$k]['question_answer']['status'] == 'wrong'
                        //   && $with_wrong_questions
                        //   && !is_numeric(array_search($result['test_questions'][$i]['test_questions_paragraphs'][$k]['id'], $wrong_questions_ids))
                        // ) {
                        //   array_push($wrong_questions_ids, $result['test_questions'][$i]['test_questions_paragraphs'][$k]['id']);

                        //   array_push($result['wrong_questions'], $result['test_questions'][$i]['test_questions_paragraphs'][$k]);
                        //   // $result['wrong_questions'].push($result['test_questions'][$i]);
                        // }
                    }
                    $result['test_questions'][$i]['test_questions_paragraphs'] = array_values($result['test_questions'][$i]['test_questions_paragraphs']);
                }
            } 
            else if ($result['test_questions'][$i]['type'] == 'complete_it' || $result['test_questions'][$i]['type'] == 'complete_it_writing_auto_correct' || $result['test_questions'][$i]['type'] == 'complete_it_writing_manual_correct') {
                $result['test_questions'][$i]['degree'] = $this->getSumOfDegreeOfQuestionsByParent($temp['id'], $result['test_questions'][$i]['id']);

                $result['test_questions'][$i]['test_questions_complete_it_sub'] = $this->getTestQuestion($temp['id'], $result['test_questions'][$i]['id'], '', $random_order);
                $result['test_questions'][$i]['test_questions_complete_it_words'] = [];


                if ($result['test_questions'][$i]['type'] == 'complete_it' || $result['test_questions'][$i]['type'] == 'complete_it_writing_auto_correct') {
                    for ($k = 0; $k < count($result['test_questions'][$i]['test_questions_complete_it_sub']); $k++) {
                        
                        $array2 = $this->getQuestionComplete_words($temp['id'],$result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['id'], $resulte_qustions);


                        $result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['test_questions_complete_it_words'] = $array2;
                        $result['test_questions'][$i]['test_questions_complete_it_words'] = array_merge($result['test_questions'][$i]['test_questions_complete_it_words'], $array2);
                        $result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['title_show'] = $result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['math_type_view_title'];
                        $result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['math_type_show_title'] = renderMathType($result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['title_show']);
                        for ($w = 0; $w < count($array2); $w++) {
                            // p($array2);
                            // if ($result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['id'] == $array2[$w]['question_id']) {
                            //   $indexOfTestat_blank = strpos($result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['title_show'], 'testat_blank');

                            // if ($USER_DATA['user_type'] == 'teacher' && $indexOfTestat_blank) {
                            //   $result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['title_show'] = substr_replace($result['test_questions'][$i]['test_questions_complete_it_sub'][$k]['title_show'], "(#" . $array2[$w]['title'] . "#)", $indexOfTestat_blank, 12);
                            // }
                            // }
                        }
                    }
                }


                $result['test_questions'][$i]['test_questions_complete_it_sub'] = array_values($result['test_questions'][$i]['test_questions_complete_it_sub']);
            }



            if ($temp['just_questions']) {
                
                if ($result['test_questions'][$i]['type'] == 'head_question' || $result['test_questions'][$i]['type'] == 'break') { //VIP
                // print_r($result['test_questions'][$i]);die();
                    if ($result['test_questions'][$i + 1]['id']) {
                        if ($result['test_questions'][$i]['type'] == 'head_question') {
                            $result['test_questions'][$i + 1]['head_title'] = $result['test_questions'][$i]['title'];
                            $result['test_questions'][$i + 1]['break_title'] = $result['test_questions'][$i]['break_title'];
                        }
                        if ($result['test_questions'][$i]['type'] == 'break') {
                            $result['test_questions'][$i + 1]['head_title'] = $result['test_questions'][$i]['head_title'];
                            $result['test_questions'][$i + 1]['break_title'] = $result['test_questions'][$i]['title'];
                        }
                        
                        $result['test_questions'][$i + 1]['head_desc'] = $result['test_questions'][$i]['type'] == 'head_question' ? $result['test_questions'][$i]['extra_desc'] : '';
                    }
                    unset($result['test_questions'][$i]);
                } else {
                     $result['test_questions'][$i]['block_index'] = $block_index;
                    $block_index++;
                }
            } else {
                if ($result['test_questions'][$i]['block_index'] = $result['test_questions'][$i]['type'] == 'head_question' || $result['test_questions'][$i]['type'] == 'break') {
                    $result['test_questions'][$i]['block_index'] = 0;
                } else {
                    $result['test_questions'][$i]['block_index'] = $block_index;
                    $block_index++;
                }
            }



            // if(is_null($result['test_questions'][$i]['title'])){
            //     $result['test_questions'][$i]['title'] = '';
            // }

            // if (
            //   $result['test_questions'][$i]['question_answer']['status'] == 'wrong' && $with_wrong_questions && !is_numeric(array_search($result['test_questions'][$i]['id'], $wrong_questions_ids))
            // ) {
            //   array_push($wrong_questions_ids, $result['test_questions'][$i]['id']);
            //   array_push($result['wrong_questions'], $result['test_questions'][$i]);
            // }
            // print_r($result['test_questions']);die();
        }
        $result['test_questions'] = array_values($result['test_questions']);

        return $result;
    }

    function getGradeBySubjectId($subject_id){
        $sql = "SELECT grade_id FROM `subjects` WHERE id = '{$subject_id}' ";
        return $this->mDb->getOne($sql);
    }

    function getQuestionAnswersDetailsByType($temp)
    {
        $grade = $this -> getGradeBySubjectId($temp['subject_id']);
        $table = $this->questions_table[$grade];
        
        $sql = "SELECT    tq.* ,tq.id as question_id , stad.student_tests_answers_id    ";
        $sql .= " FROM `student_tests_answers_details` stad";
        $sql .= " LEFT JOIN `".$table."_test_questions` tq ON (stad.question_id  =tq.id) ";
        $sql .= " LEFT JOIN `student_tests_answers` sta ON (stad.student_tests_answers_id =sta.id) ";
        $sql .= " LEFT JOIN `tests` te ON (sta.test_id =te.id) ";
        $sql .= " LEFT JOIN `tests_shares` tes ON (sta.test_id =tes.test_id) ";


        $sql .= " WHERE sta.id > 0  AND  te.is_deleted !='1' ";
        $sql .= $temp['user_id'] ? "  AND sta.user_id ='{$temp['user_id']}'  " : " ";
        $sql .= $temp['share_id'] ? "  AND sta.share_id ='{$temp['share_id']}'  " : " ";
        $sql .= $temp['status'] == 'wrong' ? " AND (stad.answer_degree < stad.total_q_degree || stad.answer_degree < tq.degree )  " : " ";
        $sql .= $temp['corrected'] ? "  AND sta.corrected ='{$temp['corrected']}'  " : " ";
        $sql .= $temp['test_status'] ? "  AND sta.test_status ='{$temp['test_status']}'  " : " ";
        $sql .= $temp['subject_id'] ? "  AND te.subject_id ='{$temp['subject_id']}'  " : " ";
        $sql .= $temp['type'] == 'all' ? "  AND ( te.type ='general_test' OR te.type ='unit_test' )  " : "  ";
        $sql .= $temp['type'] != 'all' && $temp['type'] ? "  AND te.type ='{$temp['type']}'  " : "  ";
        $sql .= $temp['teacher_id'] ? "  AND tes.teacher_id ='{$temp['teacher_id']}'  " : " ";
        $sql .= " group by tq.id  ";
        $sql .= $temp['sort_by'] ? " order by sta.{$temp['sort_by']} {$temp['sort_type']} " : ' ';
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';
        return $this->mDb->getAll($sql);
    }

    function getTestsPDFByParams($temp)
    {
        $sql = "SELECT f.name , f.id , f.print_type , f.printable   ,f.type , f.date_added , f.description  ,f.paid  , f.teacher_id, f.available_to_visitor, f.random_order FROM `tests` f ";
        $sql .= "where    f.`status` ='1'  AND  f.is_deleted !='1' AND f.`print_type` like '%{$temp['print_type']}%'";


        $sql .= $temp['type'] ? " AND f.`type` ='{$temp['type']}'   " : ' ';
        $sql .= $temp['month_id'] ? " AND f.`month_id` ='{$temp['month_id']}'   " : ' ';

        $sql .= $temp['subject_id'] ? " AND f.`subject_id` ='{$temp['subject_id']}'   " : ' ';
        // $sql .=  $temp['category_id'] ? " AND f.`category_id` ='{$temp['category_id']}'   " : ' ';
        $sql .= $temp['lesson_id'] ? " AND f.`lesson_id` ='{$temp['lesson_id']}'   " : ' ';
        $sql .= $temp['unit_id'] ? " AND f.`unit_id` ='{$temp['unit_id']}'   " : ' ';
        $sql .= $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
        $sql .= $temp['sort_by'] ? " order by f.{$temp['sort_by']} {$temp['sort_type']} " : ' ';
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' 
    LIMIT 0 , 10  ';
        // echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        
        // for($i=0; $i<count($res); $i++){
        //     $res[$i]['test_question_count'] = $this->getCountOfQustionsOfTest($res[$i]['id']);
        // }
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['print_PDF'] = 0;
            $res[$i]['print_pubblesheet'] = 0;
            $print_type = explode(",", $res[$i]['print_type']);
            if (in_array("pdf", $print_type)) {
                $res[$i]['print_PDF'] = 1;
            }
            if (in_array("bubble_sheet", $print_type)) {
                $res[$i]['print_pubblesheet'] = 1;
            }
            $res[$i]['mode'] = $res[$i]['paid'] > 0 ? "مدفوع" : " مجاني";
            $res[$i]['count_of_answers_to_the_test'] = $this->countOfAnswerOnTest($res[$i]['id']);

            $res[$i]['test_question_count'] = $this->getCountOfQustionsOfTest($res[$i]['id']);
            if ($USER_DATA['user_type'] == 'student') {

                $data_ = $this->getSomeStudent_tests_answersTestData($USER_DATA['id'], $res[$i]['id'], '', '');

                $res[$i]['total_degree'] = $data_['total_degree'];
                $res[$i]['total_answer_degree'] = $data_['total_answer_degree'];
                $res[$i]['completion_percentage'] = $data_['total_answered_questions_count'] > 0 && $data_['total_question_count'] > 0 ? number_format(($data_['total_answered_questions_count'] / $data_['total_question_count'] * 100), 1, '.', '') : 0;


                $res[$i]['finished_before'] = $this->checkStudentHaveTestCompleted($USER_DATA['id'], $res[$i]['id'], '');
            }
        }
        return $res;
    }
    
    function checkTestPaidByid($testId)
    {
        $sql = "SELECT paid FROM `tests` ";
        $sql .= "where  `id` ='{$testId}'  ";
        $res = $this->mDb->getOne($sql);
        return $res;

    }
    
    function getSubjectIdByTestId($testId)
    {
        $sql = "SELECT subject_id FROM `tests` ";
        $sql .= "where  `id` ='{$testId}'  ";
        // echo $sql;die();
        $res = $this->mDb->getOne($sql);
        return $res;

    }

    function getTestsByParams($temp)
    {
        global $USER_DATA;

        $sql = "SELECT f.name , f.id , f.print_type , f.printable   ,f.type , f.date_added , f.description  ,f.paid  , f.teacher_id, f.available_to_visitor, f.random_order FROM `tests` f ";
        $sql .= "where    f.`status` ='1'  AND  f.is_deleted !='1' AND f.type='{$temp['type']}'  ";
        $sql .= $USER_DATA['user_type'] == 'student' ? " AND f.`dedicated_to` = 'all'   " : ' ';
        $sql .= $temp['classification'] ? "  AND f.classification='{$temp['classification']}'  " : ' ';
        // $sql .= $temp['classification'] == 'ready' ? "  AND (f.classification = 'ready')  " : ' ';
        $sql .= $temp['print_type'] ? "  AND f.print_type like '%{$temp['print_type']}%'  " : ' ';
        // $sql .= $temp['print_type'] == 'bubble_sheet' ? "  AND (f.print_type like '%bubble_sheet%')  " : ' ';
        $sql .= $temp['subject_id'] ? " AND f.`subject_id` ='{$temp['subject_id']}'   " : ' ';
        $sql .= $temp['subject_branch_id'] ? " AND f.`subject_branch_id` ='{$temp['subject_branch_id']}'   " : ' ';
        $sql .= $temp['lesson_id'] ? " AND f.`lesson_id` ='{$temp['lesson_id']}'   " : ' ';
        $sql .= $temp['unit_id'] ? " AND f.`unit_id` ='{$temp['unit_id']}'   " : ' ';
        $sql .= $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
        $sql .= $temp['printable'] == 1 ? " AND f.`printable` ='1'   " : ' ';
        $sql .= $temp['semester'] ? "  AND ( f.`semester` = '{$temp['semester']}' ||  f.`semester` = 'both' ) " : ' ';
        $sql .= $temp['sort_by'] ? " order by f.{$temp['sort_by']} {$temp['sort_type']} " : ' ';
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' LIMIT 0 , 50  ';
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);

        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['print_PDF'] = 0;
            $res[$i]['print_pubblesheet'] = 0;
            $print_type = explode(",", $res[$i]['print_type']);
            if (in_array("pdf", $print_type)) {
                $res[$i]['print_PDF'] = 1;
            }
            if (in_array("bubble_sheet", $print_type)) {
                $res[$i]['print_pubblesheet'] = 1;
            }
            $res[$i]['mode'] = $res[$i]['paid'] > 0 ? "مدفوع" : " مجاني";
            $res[$i]['count_of_answers_to_the_test'] = $this->countOfAnswerOnTest($res[$i]['id']);

            $res[$i]['test_question_count'] = $this->getCountOfQustionsOfTest($res[$i]['id']);
            if ($USER_DATA['user_type'] == 'student') {

                $data_ = $this->getSomeStudent_tests_answersTestData($USER_DATA['id'], $res[$i]['id'], '', '');

                $res[$i]['total_degree'] = $data_['total_degree'];
                $res[$i]['total_answer_degree'] = $data_['total_answer_degree'];
                $res[$i]['completion_percentage'] = $data_['total_answered_questions_count'] > 0 && $data_['total_question_count'] > 0 ? number_format(($data_['total_answered_questions_count'] / $data_['total_question_count'] * 100), 1, '.', '') : 0;


                $res[$i]['finished_before'] = $this->checkStudentHaveTestCompleted($USER_DATA['id'], $res[$i]['id'], '');
            }
        }
        return $res;
    }
    
    
    
    
    function getTestsByParamsCount($temp)
    {
        global $USER_DATA;

        $sql = "SELECT COUNT(f.id) FROM `tests` f ";
        $sql .= "where    f.`status` ='1'  AND  f.is_deleted !='1' AND f.type='{$temp['type']}'  ";
        $sql .= $USER_DATA['user_type'] == 'student' ? " AND f.`dedicated_to` = 'all'   " : ' ';
        $sql .= $temp['classification'] ? "  AND f.classification='{$temp['classification']}'  " : ' ';
        $sql .= $temp['print_type'] ? "  AND f.print_type like '%{$temp['print_type']}%'  " : ' ';
        $sql .= $temp['subject_id'] ? " AND f.`subject_id` ='{$temp['subject_id']}'   " : ' ';
        $sql .= $temp['subject_branch_id'] ? " AND f.`subject_branch_id` ='{$temp['subject_branch_id']}'   " : ' ';
        $sql .= $temp['lesson_id'] ? " AND f.`lesson_id` ='{$temp['lesson_id']}'   " : ' ';
        $sql .= $temp['unit_id'] ? " AND f.`unit_id` ='{$temp['unit_id']}'   " : ' ';
        $sql .= $temp['teacher_id'] ? " AND f.`teacher_id` ='{$temp['teacher_id']}'   " : ' ';
        $sql .= $temp['printable'] == 1 ? " AND f.`printable` ='1'   " : ' ';
        $sql .= $temp['semester'] ? "  AND ( f.`semester` = '{$temp['semester']}' ||  f.`semester` = 'both' ) " : ' ';
        $sql .= $temp['sort_by'] ? " order by f.{$temp['sort_by']} {$temp['sort_type']} " : ' ';
        // echo $sql;die();
        $res = $this->mDb->getOne($sql);
        return $res;
    }


    function reFactorTest($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        // updateDegree Of Test
        $this->updateDegreeOfTest($test_id);

        //update  Of Test

        $this->updateDegreeOfAllQuestion($test_id);

        // correct If there is sub question not deleted
        $sql = "SELECT  parent_id From `".$table."_test_questions` ";
        $sql .= "where `test_id`= '{$test_id}' AND parent_id > 0 group by parent_id ";
        $all_groups_of_sub_paragraphQouestin = $this->mDb->getAll($sql);


        for ($i = 0; $i < count($all_groups_of_sub_paragraphQouestin); $i++) {
            $sql = "SELECT  id From `".$table."_test_questions` ";
            $sql .= "where `test_id`= '{$test_id}' AND id='{$all_groups_of_sub_paragraphQouestin[$i]['parent_id']}' ";
            $id = $this->mDb->getOne($sql);
            if (!$id) {
                $this->deleteQuestion($all_groups_of_sub_paragraphQouestin[$i]['parent_id'], $test_id);
            }
        }
    }

    function updateDegreeOfAllQuestion($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "UPDATE `".$table."_test_questions` SET degree = '0'  where (type ='head_question' || type ='paragraphs' || type ='break') and degree > 0 and test_id ='{$test_id}' ";
        // echo $sql;die();
        $this->mDb->query($sql);
    }

    function addTestQuestion($temp, $test_id, $classification)
    {
        $question_id = $this->addEditSingleQuastion($test_id, $temp);
        
        if ($question_id) {
            if ($temp['type'] == 'choose' || $temp['type'] == 'check') {
                // if ($classification == 'by_teacher_selected_from_ready') {
                //     $temp['test_question_options'] = $this->getQuestionOptions($temp['id'], true);
                // }
                // if ($classification == 'by_teacher_selected_from_bank') {
                //     $temp['test_question_options'] = $this->getBankQuestionOptions($temp['id']);
                // }
                for ($i = 0; $i < count($temp['test_question_options']); $i++) {
                    $option = $temp["test_question_options"][$i];
                    if ($option['title'] || $option['option_attachments'][0]['file']) {
                        $option_id = $this->inserQOption($test_id, $question_id, $option);
                        if ($option_id > 0) {
                            $this->addQuestionAttachments($test_id, $question_id, $option_id, 'option', $option['option_attachments'], $classification);
                        }
                    }
                }
            } else if ($temp['type'] == 'sort_it') {

                // if ($classification == 'by_teacher_selected_from_ready') {
                //     $temp['test_question_sort_words'] = $this->getQuestionSort_it($temp['id'], false);
                // }
                // if ($classification == 'by_teacher_selected_from_bank') {
                //     $temp['test_question_sort_words'] = $this->getQuestionBankSort_it($temp['id']);
                // }
                for ($i = 0; $i < count($temp['test_question_sort_words']); $i++) {
                    $sort_word = $temp["test_question_sort_words"][$i];
                    
                    $this->insertIntoSortQuestionWords($test_id, $question_id, $sort_word);
                }
            } else if ($temp['type'] == 'match_it') {


                // if ($classification == 'by_teacher_selected_from_ready') {

                //     $temp['test_question_match_options'] = $this->getQuestionMatch_it($temp['id'], true);
                // }
                // if ($classification == 'by_teacher_selected_from_bank') {
                //     $temp['test_question_match_options'] = $this->getQuestionBankMatch_it($temp['id']);
                // }
                for ($i = 0; $i < count($temp['test_question_match_options']); $i++) {
                    $match_option = $temp["test_question_match_options"][$i];
                    $this->insertIntoMatchQuestionItems($test_id,$question_id, $match_option, $classification, $i);
                }
            } else if ($temp['type'] == 'complete_it' || $temp['type'] == 'complete_it_writing_manual_correct' || $temp['type'] == 'complete_it_writing_auto_correct') {
                $test_questions_complete_it_sub = $temp['test_questions_complete_it_sub'];
                for ($k = 0; $k < count($test_questions_complete_it_sub); $k++) {
                    $questions_complete_it_sub = $test_questions_complete_it_sub[$k];
                    $questions_complete_it_sub['parent_id'] = $question_id;
                    $questions_complete_it_sub['type'] = 'complete_it_sub';
                    $questions_complete_it_sub['parent_type'] = $temp['type'];
                    $questions_complete_it_sub['title_show'] = [];
                    $this->addTestQuestion($questions_complete_it_sub, $test_id, $classification);///'by_teacher_customized'
                }
            } else if ($temp['type'] == 'complete_it_sub') {

                // if ($classification == 'by_teacher_selected_from_ready') {
                //     $temp['test_questions_complete_it_words'] = $this->getQuestionComplete_words($temp['id'], true);
                // }
                // if ($classification == 'by_teacher_selected_from_bank') {
                //     $temp['test_questions_complete_it_words'] = $this->getQuestionBankComplete_words($temp['id']);
                // }
                for ($i = 0; $i < count($temp['test_questions_complete_it_words']); $i++) {
                    if ($temp['parent_type'] === 'complete_it_writing_auto_correct') {
                        $complete_it_word = $temp["test_questions_complete_it_words"][$i];
                    } else if ($temp['parent_type'] === 'complete_it') {
                        $complete_it_word = $temp["test_questions_complete_it_words"][$i];
                        $complete_it_word['word_index'] = $i + 1;
                    }
                    $this->insertIntoTestQuestionCompleteWord($test_id, $question_id, $complete_it_word);
                }
            }

            $this->addQuestionAttachments($test_id, $question_id, '', 'question', $temp['question_attachments'], $classification);
            $this->addQuestionAttachments($test_id, $question_id, '', 'note', $temp['note_attachments'], $classification);
        }

        return $question_id;
    }
    
    
    
    
    function editTestQuestion($temp, $test_id, $classification)
    {
        
        $question_id = $temp['id'];
        $editQuestion = $this->addEditSingleQuastion($test_id, $temp, $question_id);
        
        
        if ($editQuestion) {
            if ($temp['type'] == 'choose' || $temp['type'] == 'check') {
                $this->deleteQOption($test_id, $question_id);
                for ($i = 0; $i < count($temp['test_question_options']); $i++) {
                    $option = $temp["test_question_options"][$i];
                    if ($option['title'] || $option['option_attachments'][0]['file']) {
                        
                        $option_id = $this->inserQOption($test_id, $question_id, $option);
                        if ($option_id > 0) {
                            $this->deleteQuestionAttachments($test_id, $question_id);
                            $this->addQuestionAttachments($test_id, $question_id, $option_id, 'option', $option['option_attachments'], $classification);
                        }
                    }
                }
            } else if ($temp['type'] == 'sort_it') {
                    $this->deleteSortQuestionWords($test_id, $question_id);
                for ($i = 0; $i < count($temp['test_question_sort_words']); $i++) {
                    $sort_word = $temp["test_question_sort_words"][$i];
                    $this->insertIntoSortQuestionWords($test_id, $question_id, $sort_word);
                }
            } else if ($temp['type'] == 'match_it') {
                    $this->deleteMatchQuestionItems($test_id,$question_id);
                for ($i = 0; $i < count($temp['test_question_match_options']); $i++) {
                    $match_option = $temp["test_question_match_options"][$i];
                    $this->insertIntoMatchQuestionItems($test_id,$question_id, $match_option, $classification, $i);
                }
            } else if ($temp['type'] == 'complete_it' || $temp['type'] == 'complete_it_writing_manual_correct' || $temp['type'] == 'complete_it_writing_auto_correct') {
                $test_questions_complete_it_sub = $temp['test_questions_complete_it_sub'];
                for ($k = 0; $k < count($test_questions_complete_it_sub); $k++) {
                    $questions_complete_it_sub = $test_questions_complete_it_sub[$k];
                    $questions_complete_it_sub['parent_id'] = $question_id;
                    $questions_complete_it_sub['type'] = 'complete_it_sub';
                    $questions_complete_it_sub['parent_type'] = $temp['type'];
                    $questions_complete_it_sub['title_show'] = [];
                    $this->editTestQuestion($questions_complete_it_sub, $test_id, $classification);///'by_teacher_customized'
                }
            } else if ($temp['type'] == 'complete_it_sub') {
                    $this->deleteTestQuestionCompleteWord($test_id, $question_id);
                for ($i = 0; $i < count($temp['test_questions_complete_it_words']); $i++) {
                    if ($temp['parent_type'] === 'complete_it_writing_auto_correct') {
                        $complete_it_word = $temp["test_questions_complete_it_words"][$i];
                    } else if ($temp['parent_type'] === 'complete_it') {
                        $complete_it_word = $temp["test_questions_complete_it_words"][$i];
                        $complete_it_word['word_index'] = $i + 1;
                    }
                    $this->insertIntoTestQuestionCompleteWord($test_id, $question_id, $complete_it_word);
                }

            }
            
            $this->deleteQuestionAttachments($test_id, $question_id);

            $this->addQuestionAttachments($test_id, $question_id, '', 'question', $temp['question_attachments'], $classification);
            $this->addQuestionAttachments($test_id, $question_id, '', 'note', $temp['note_attachments'], $classification);
        }
        // echo $editQuestion;die();

        return $editQuestion;
    }
    

    function addEditSingleQuastion($test_id, $temp, $question_id='')
    {
        // echo $question_id;die();
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $temp['degree'] = $temp['type'] == 'head_question' || $temp['type'] == 'paragraphs' || $temp['type'] == 'break' ? '0' : $temp['degree'];
        if ($temp['type'] && $test_id && $question_id == '') {
            $temp['math_type_view_note'] = renderMathType($temp['note']);
            $temp['math_type_view_title'] = renderMathType($temp['title']);
            $temp['source'] = str_replace("'", "\'", $temp['source']);
            $temp['extra_desc'] = str_replace("'", "\'", $temp['extra_desc']);
            $temp['title'] = str_replace("'", "\'", $temp['title']);
            $temp['math_type_view_title'] = str_replace("'", "\'", $temp['math_type_view_title']);
            $temp['note'] = str_replace("'", "\'", $temp['note']);
            $temp['math_type_view_note'] = str_replace("'", "\'", $temp['math_type_view_note']);


            $sql = "INSERT INTO `".$table."_test_questions` SET ";
            $sql .= " `test_id` = '{$test_id}'  ";
            $sql .= $temp['id'] ? ", `refrence_id` = '{$temp['id']}' " : " ";
            $sql .= $temp['parent_id'] ? ", `parent_id` = '{$temp['parent_id']}' " : ' ';
            $sql .= ",`type` = '{$temp['type']}' ";
            $sql .= ", `source` = '{$temp['source']}' ";
            $sql .= $temp['size_article_q'] ? " , `size_article_q` = '{$temp['size_article_q']}' " : " ";
            $sql .= $temp['degree'] ? " , `degree` = '{$temp['degree']}' " : " ";
            $sql .= $temp['extra_desc'] ? " , `extra_desc` = '{$temp['extra_desc']}' " : " ";
            $sql .= $temp['note'] ? " ,`note` = '{$temp['note']}' " : " ";
            $sql .= $temp['answer_form'] ? " ,`answer_form` = '{$temp['answer_form']}' " : NULL;
            $sql .= $temp['math_type_view_note'] ? ", `math_type_view_note` = '{$temp['math_type_view_note']}' " : " ";
            $sql .= ", `title` = '{$temp['title']}' ";
            $sql .= ", `math_type_view_title` = '{$temp['math_type_view_title']}' ";
            // echo $sql;die();
            return $this->mDb->queryReturnLastId($sql);
        }elseif($question_id != ''){
            
            $temp['math_type_view_note'] = renderMathType($temp['note']);
            $temp['math_type_view_title'] = renderMathType($temp['title']);
            $temp['source'] = str_replace("'", "\'", $temp['source']);
            $temp['extra_desc'] = str_replace("'", "\'", $temp['extra_desc']);
            $temp['title'] = str_replace("'", "\'", $temp['title']);
            $temp['math_type_view_title'] = str_replace("'", "\'", $temp['math_type_view_title']);
            $temp['note'] = str_replace("'", "\'", $temp['note']);
            $temp['math_type_view_note'] = str_replace("'", "\'", $temp['math_type_view_note']);

            $sql = "UPDATE `".$table."_test_questions` SET ";
            $sql .= $test_id ? " `test_id` = '{$test_id}'  ":"";
            $sql .= $temp['id'] ? ", `refrence_id` = '{$temp['id']}' " : " ";
            $sql .= $temp['parent_id'] ? ", `parent_id` = '{$temp['parent_id']}' " : ' ';
            $sql .= $temp['type'] ? ",`type` = '{$temp['type']}' ":"";
            $sql .= $temp['source'] ? ", `source` = '{$temp['source']}' ":"";
            $sql .= $temp['size_article_q'] ? " , `size_article_q` = '{$temp['size_article_q']}' " : " ";
            $sql .= $temp['degree'] ? " , `degree` = '{$temp['degree']}' " : " ";
            $sql .= $temp['extra_desc'] ? " , `extra_desc` = '{$temp['extra_desc']}' " : " ";
            $sql .= $temp['note'] ? " ,`note` = '{$temp['note']}' " : " ";
            $sql .= $temp['answer_form'] ? " ,`answer_form` = '{$temp['answer_form']}' " : NULL;
            $sql .= $temp['math_type_view_note'] ? ", `math_type_view_note` = '{$temp['math_type_view_note']}' " : " ";
            $sql .= $temp['title'] ? ", `title` = '{$temp['title']}' ":", `title` = '' ";
            $sql .= $temp['math_type_view_title'] ? ", `math_type_view_title` = '{$temp['math_type_view_title']}' ":", `math_type_view_title` = ''";
            $sql .= " WHERE id = '{$question_id}' ";
            // echo $sql;die();
            return $this->mDb->query($sql);
        
        }
    }


    function inserQOption($test_id, $question_id, $option)
    {

    $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        if (!$option['math_type_view_title']) {
            $option['math_type_view_title'] = renderMathType($option['title']);
        }

        $option['math_type_view_title'] = str_replace("'", "\'", $option['math_type_view_title']);
        $option['title'] = str_replace("'", "\'", $option['title']);

        $sql = "INSERT INTO `test_question_options` SET ";
        $sql .= " `test_question_id` = '{$question_id}'  ";
        $sql .= ", `title` = '{$option['title']}' ";
        $sql .= ", `math_type_view_title` = '{$option['math_type_view_title']}' ";
        $sql .= ", `question_table` = '{$table}' ";
        $sql .= $option['status'] == '1' || $option['status'] == true ? " , `status` = '1' " : " ";
        // echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }
    
    function deleteQOption($test_id, $question_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "DELETE FROM `test_question_options` WHERE `test_question_id` = '{$question_id}' AND `question_table` = '{$table}' ";
        // echo $sql;die();
        return $this->mDb->query($sql);
    }

    function insertIntoMatchQuestionItems($test_id, $question_id, $temp, $classification, $index)
    {


        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $temp['righte_index2'] = $temp['righte_index2'] ? $temp['righte_index2'] : $index + 1;
        if ($classification == 'by_teacher_selected_from_bank') {
            //copy attachments questions_bank_attachments to questions_attachments

            $this->copyFileToServer("questions_bank_attachments", "questions_attachments", $temp['image1']);
            $this->copyFileToServer("questions_bank_attachments", "questions_attachments", $temp['image2']);
        }

        $temp['image1'] = str_replace("'", "\'", $temp['image1']);
        $temp['image2'] = str_replace("'", "\'", $temp['image2']);

        $temp['title1'] = str_replace("'", "\'", $temp['title1']);
        $temp['title2'] = str_replace("'", "\'", $temp['title2']);


        $sql = "INSERT INTO `test_questions_match_items` SET ";
        $sql .= " `question_id` = '{$question_id}'  ";
        $sql .= ", `title1` = '{$temp['title1']}' ";
        $sql .= ", `title2` = '{$temp['title2']}'  ";
        $sql .= ", `image1` = '{$temp['image1']}'  ";
        $sql .= ", `image2` = '{$temp['image2']}'  ";
        $sql .= $temp['righte_index1'] ? ", `righte_index1` = '{$temp['righte_index1']}'  " : "";
        $sql .= ", `righte_index2` = '{$temp['righte_index2']}' ";
        $sql .= ", `question_table` = '{$table}' ";
        return $this->mDb->queryreturnlastid($sql);
    }

    function deleteMatchQuestionItems($test_id, $question_id)
    {
         $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "DELETE FROM `test_questions_match_items` WHERE `question_id` = '{$question_id}' AND `question_table` = '{$table}' ";
        return $this->mDb->query($sql);
        
    }
    function copyFileToServer($sourceFolder, $targetFolder, $file_name)
    {
        $sourceFile = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . $sourceFolder . '/' . $file_name;
        $targetFile = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . $targetFolder . '/' . $file_name;
        copy($sourceFile, $targetFile);
    }

    function insertIntoSortQuestionWords($test_id, $question_id, $temp)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        $temp['title'] = str_replace("'", "\'", $temp['title']);

        $sql = "INSERT INTO `test_questions_sort_words` SET ";
        $sql .= " `question_id` = '{$question_id}' ";
        $sql .= ", `title` = '{$temp['title']}' ";
        $sql .= " ,  `word_index` = '{$temp['word_index']}' ";
        $sql .= " ,  `question_table` = '{$table}' ";
        // echo($sql);die();
        return $this->mDb->queryreturnlastid($sql);
    }
    
    
    function deleteSortQuestionWords($test_id, $question_id)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        $sql = "DELETE FROM `test_questions_sort_words` WHERE  `question_id` = '{$question_id}' ";
        $sql .= " AND `question_table` = '{$table}' ";
        // die($sql);
        return $this->mDb->query($sql);
    }

    function insertIntoTestQuestionCompleteWord($test_id, $question_id, $temp)
    {
        //   print_r($temp);die();
        // echo $temp['word_index']." - ";
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $temp['title'] = str_replace("'", "\'", $temp['title']);
        $temp['word_index'] = $temp['word_index'] === NULL && $temp['word_index'] != 0 ? '1' : $temp['word_index'];
        $sql = "INSERT INTO `test_questions_complete_words` SET ";
        $sql .= " `question_id` = '{$question_id}' ";
        $sql .= ", `title` = '{$temp['title']}' ";
        $sql .= ", `word_index` = '{$temp['word_index']}' ";
        $sql .= ", `question_table` = '{$table}' ";
        // echo($sql);die();
        return $this->mDb->queryreturnlastid($sql);
    }
    
    
    
    function deleteTestQuestionCompleteWord($test_id, $question_id)
    {
        //   print_r($temp);die();
        // echo $temp['word_index']." - ";
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "DELETE FROM `test_questions_complete_words` ";
        $sql .= "WHERE `question_id` = '{$question_id}' ";
        $sql .= "AND `question_table` = '{$table}' ";
        // echo $sql;die();
        return $this->mDb->query($sql);
    }


    function insertTestData($temp)
    {
        global $USER_DATA;
        $temp['printable'] = $temp['printable'] ? $temp['printable'] : '0';
        $temp['name'] = str_replace("'", "\'", $temp['name']);
        $temp['description'] = str_replace("'", "\'", $temp['description']);
        $sql = "INSERT INTO `tests` SET ";
        $sql .= " `teacher_id` = '" . $USER_DATA['id'] . "'  ";
        $sql .= ", `country_id` = '" . $USER_DATA['country_id'] . "'  ";
        $sql .= ", `set_from` = '" . SETFROM . "'  ";
        $sql .= ", `stage_id` = '{$temp['stage_id']}'  ";
        $sql .= ", `grade_id` = '{$temp['grade_id']}'  ";
        $sql .= ", `subject_id` = '{$temp['subject_id']}'  ";
        $sql .= $temp['unit_id'] ? ", `unit_id` = '{$temp['unit_id']}'  " : "   ";
        $sql .= $temp['lesson_id'] ? ", `lesson_id` = '{$temp['lesson_id']}'  " : "    ";
         $sql .= $temp['random_order'] ? ", `random_order` = '{$temp['random_order']}'  " : "";
        $sql .= ", `type` = '{$temp['type']}'  ";
        $sql .= ", `printable` = '{$temp['printable']}'  ";
        $sql .= ", `classification` = '{$temp['classification']}'  ";
        $sql .= ", `name` = '{$temp['name']}' ";
        $sql .= ", `description` = '{$temp['description']}'  ";
        $sql .= ", `status` = '1'  ";
        $sql .= ", `available_to_visitor` = '{$temp['available_to_visitor']}'  ";
        $sql .= ", `sort` = '0'  ";
        $sql .= ", `dedicated_to` = 'all'  ";
        $sql .= ", `date_added` = '{$this->dateTime}'";
        // p($sql);
        return $this->mDb->queryReturnLastId($sql);
    }

    function addTest($temp)
    {
        $test_id = $this->insertTestData($temp);
        
        $this->addQuestions($test_id, $temp); 
        return $test_id;
    }

    function editTest($temp)
    {
        $res = $this->editTestData($temp, $temp['my_test_id']);
        // print_r($temp);die();
        if ($res) {
            $this->deleteAllQuestionOfTest($temp['my_test_id']);
            //   echo $temp['my_test_id'];die();
            if ($temp['my_test_id']) {
                $temp['classification'] = 'by_teacher_selected_from_ready';
                // print_r($temp);die();
                $this->addQuestions($temp['my_test_id'], $temp);
            }
            $this->removeAllQuestionOfTest($temp['my_test_id']);
        }
        return $res;
    }

    function removeAllQuestionOfTest($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "DELETE FROM `".$table."_test_questions` WHERE test_id  = '{$test_id}' AND  is_deleted = '1' ";
        return $this->mDb->query($sql);
    }

    function deleteAllQuestionOfTest($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "UPDATE `".$table."_test_questions` SET is_deleted = '1' WHERE test_id  = '{$test_id}' ";
        return $this->mDb->query($sql);
    }


    function addQuestions($test_id, $temp)
    {
        $questions = $temp['questions'];
        for ($i = 0; $i < count($questions); $i++) {
            $question = $questions[$i];
            $classification = $temp['classification'];
            if ($temp['classification'] == 'by_teacher_selected_from_bank') {
                $is_ready_question = $this->checkIfQuestionExistOnTest($test_id, $questions[$i]['id']);
                if ($is_ready_question) {
                    $classification = 'by_teacher_selected_from_ready';
                }
            }

            $question_id = $this->addTestQuestion($question, $test_id, $classification);

            if ($question['type'] == 'paragraphs') {
                $question_paragraphs = $this->getTestQuestion($question['test_id'], $question['id'], '');
                for ($k = 0; $k < count($questions[$i]['test_questions_paragraphs']); $k++) {

                    $question_paragraph = $questions[$i]['test_questions_paragraphs'][$k];
                    $question_paragraph['parent_id'] = $question_id;
                    $questions_sub = $questions[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'];
                    $classification = $temp['classification'];

                    if ($temp['classification'] == 'by_teacher_selected_from_bank') {
                        $is_ready_question = $this->checkIfQuestionExistOnTest($test_id, $question_paragraphs[$k]['id']);
                        if ($is_ready_question) {
                            $classification = 'by_teacher_selected_from_ready';
                        }
                    }
                    $question_paragraph_id = $this->addTestQuestion($question_paragraph, $test_id, $classification);
                }
            } 
            // else if ($question['type'] == 'complete_it') {
            //     // echo count($question);die();
            //     $complete_its = $question;

            //     for ($k = 0; $k < count($complete_its); $k++) {
            //             $question_complete_it = $complete_its;
            //             // echo count($question) ." - ". $question_complete_it['parent_id'];die();
            //         // if ($temp['classification'] == 'by_teacher_selected_from_ready') {
            //         //     $question_complete_it = $this->getQuestionData($complete_its[$k]['id']);
            //         //     $classification = 'by_teacher_selected_from_ready';
            //         // } else if ($temp['classification'] == 'by_teacher_selected_from_bank') {
            //         //     // cheack if Question Bank Or Ready
            //         //     $is_ready_question = $this->checkIfQuestionExistOnTest($test_id, $complete_its[$k]['id']);
            //         //     if ($is_ready_question) {
            //         //         $question_complete_it = $this->getQuestionData($complete_its[$k]['id']);
            //         //         $classification = 'by_teacher_selected_from_ready';
            //         //     } else {
            //         //         $question_complete_it = $this->getQuestionBankData($complete_its[$k]['id']);
            //         //         $classification = 'by_teacher_selected_from_bank';
            //         //     }
            //         // }
            //     }
            //         $complete_its['parent_id'] = $question_id;

            //         $this->addTestQuestion($complete_its, $test_id, $classification);
            // }
        }
        $this->updateDegreeOfTest($test_id);
    }


    /////////////

    function addQuestionToCustomizedTest($question, $test_id)
    {
        // echo $question['type'];die();
        $question_id = $this->addTestQuestion($question, $test_id, 'by_teacher_customized');
        if ($question['type'] == 'paragraphs') {
            $question_paragraphs = $question['test_questions_paragraphs'];
            for ($k = 0; $k < count($question_paragraphs); $k++) {
                $question_paragraph = $question_paragraphs[$k];
                $question_paragraph['parent_id'] = $question_id;
                $this->addTestQuestion($question_paragraph, $test_id, 'by_teacher_customized');
            }
        }
        $this->updateDegreeOfTest($test_id);
        return $question_id;
    }
    
    
    function editQuestionToCustomizedTest($question, $test_id)
    {
        // print_r($question);die();
        $question_id = $this->editTestQuestion($question, $test_id, 'by_teacher_customized');
        if ($question['type'] == 'paragraphs') {
            $question_paragraphs = $question['test_questions_paragraphs'];
            for ($k = 0; $k < count($question_paragraphs); $k++) {
                $question_paragraph = $question_paragraphs[$k];
                // echo $question_id;
                $question_paragraph['parent_id'] = $question['id'];
               
                // print_r($question_paragraph);
                $this->editTestQuestion($question_paragraph, $test_id, 'by_teacher_customized');
            }
        }
        $this->updateDegreeOfTest($test_id);
        return $question_id;
    }

    function updateDegreeOfTest($test_id)
    {
        $total_degree = $this->getSumOfDegreeOfTestQuestions($test_id);
        $sql = "UPDATE `tests` SET";
        $sql .= "`total_degree`='{$total_degree}' ";
        $sql .= "where `id`= $test_id";
            //  echo $sql;die();
        $this->mDb->query($sql);
    }

    function getSumOfDegreeOfTestQuestions($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT SUM(degree) From `".$table."_test_questions` ";
        $sql .= "where `test_id`= '{$test_id}' AND type!='break' AND type != 'head_question' AND type != 'paragraphs' AND type != 'complete_it' AND type != 'complete_it_writing_auto_correct' AND type != 'complete_it_writing_manual_correct'   
      ";
//   echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getSumOfDegreeOfQuestionsByParent($test_id, $parent_id)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql  = "SELECT SUM(degree) From `".$table."_test_questions` ";
        $sql .= "where `parent_id`= '{$parent_id}'  AND type!='break'  AND type != 'head_question' AND type != 'paragraphs' AND type != 'complete_it'  AND type != 'complete_it_writing_auto_correct' AND type != 'complete_it_writing_manual_correct'    ";
        return $this->mDb->getOne($sql);
    }

    function detectIfStudent_tests_answers_idIsFinishedDuration($student_tests_answers_id)
    {
        $res['test_finish_after_minutes'] = null;
        $res['test_is_finish_duration'] = false;

        $sql = "SELECT  sta.date_added ,sta.share_id, sta.test_id from  `student_tests_answers` sta  ";
        $sql .= " where sta.`id`={$student_tests_answers_id}   ";
        
        $start_test_data = $this->mDb->getRow($sql);
        $start_test_data['date_added'] = $start_test_data['date_added'] ? $start_test_data['date_added'] : $this->dateTime;
        $test_share = $this->getTests_sharesDataTable($start_test_data['share_id'], true);

        if ($test_share && $test_share['test_duration']) {
            $finish_dateTime = date('Y-m-d H:i:s', strtotime('+' . $test_share['test_duration'] . ' minutes', strtotime($start_test_data['date_added'])));
            //  p($finish_dateTime . " : finish_dateTime",false);
            //  p($this->dateTime  . " : start_dateTime",false);
            //  p($finish_dateTime < $this->dateTime . " :  finish_dateTime < this->dateTime");
            // echo "==========>" . $finish_dateTime . " /======/ " . $this->dateTime;die();
            if ($finish_dateTime <= $this->dateTime) {
                $res['test_is_finish_duration'] = true;
                $this->setTestCompleted($student_tests_answers_id);
            } else {
                $res['test_finish_after_minutes'] = date_diffr($this->dateTime, $finish_dateTime);
            }
        }
        return $res;
    }
    function getTestIdByStudentTestsAnswersId($student_tests_answers_id){
        $sql = "SELECT  sta.test_id from  `student_tests_answers` sta  ";
        $sql .= " where sta.`id`={$student_tests_answers_id}   ";
        
        $test_id = $this->mDb->getOne($sql);
        return $test_id;
    }

    function checkTestIfCompleted($student_tests_answers_id)
    {
        $sql = "SELECT `test_status` from `student_tests_answers` where id = '{$student_tests_answers_id}'";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function checkTestStatus($temp)
    {   
        // echo 'test';die();
        global $USER_DATA;
        $current_time = date("Y-m-d H:i:s");
        $test_share = $this->getTests_sharesDataTable($_GET['share_id'], true);
      
        // print_r($test_share);die();
        $student_tests_answers_id = $this->checkStudentHaveTest($temp['student_id'], $temp['test_id'], $temp['share_id']);
        if ($test_share['test_duration'] > 0 && $student_tests_answers_id && strtotime($test_share['scheduled_date']) < strtotime($current_time)) {

            $test_duration_data = $this->detectIfStudent_tests_answers_idIsFinishedDuration($student_tests_answers_id);
        }
        if (!$student_tests_answers_id && strtotime($test_share['scheduled_date']) < strtotime($current_time)) {
          
            $student_tests_answers_id = $this->insertNewTest($temp['student_id'], $temp['test_id'], $temp['share_id']);
            // echo $student_tests_answers_id;die();

            $test_arg['id'] = $temp['test_id'];
            $test_arg['share_id'] = $temp['share_id'];
            $test_arg['just_questions'] = true;
            $test_arg['student_tests_answers_id'] = '';
            $test_arg['resulte_qustions'] = false;
            $test_arg['user_type'] = $USER_DATA['user_type'];
            $test_arg['student_id'] = $USER_DATA['id'];

            $res = $this->getOneTestDetails($test_arg);
        
            if ($test_share['test_duration'] > 0) {
                $test_duration_data = $this->detectIfStudent_tests_answers_idIsFinishedDuration($student_tests_answers_id);
            }
            $res['count_of_answerd_qustions_of_test'] = 0;
        } else {

            $test_arg['id'] = $temp['test_id'];
            $test_arg['share_id'] = $temp['share_id'];
            $test_arg['student_tests_answers_id'] = $student_tests_answers_id;
            $test_arg['just_questions'] = true;
            $test_arg['resulte_qustions'] = false;
            $test_arg['user_type'] = $USER_DATA['user_type'];
            $test_arg['student_id'] = $USER_DATA['id'];
            // print_r($student_tests_answers_id);die();
            $res = $this->getOneTestDetails($test_arg);

            $res['count_of_answerd_qustions_of_test'] = $this->getCountOfAnswerQustionsOfTest($student_tests_answers_id);
           
        }
        $res['student_tests_answers_id'] = $student_tests_answers_id;

        $res['test_status'] = $this->checkTestIfCompleted($student_tests_answers_id);
        $res['scheduled_date'] = $test_share['scheduled_date'];
        $res['scheduled_test'] = $test_share['scheduled_test'];
        $res['test_duration'] = $test_share['test_duration'];
        $res['test_is_finish_duration'] = $res['test_status'] != 'completed' ? $test_duration_data['test_is_finish_duration'] : null;
        $res['test_finish_after_minutes'] = $res['test_status'] != 'completed' ? $test_duration_data['test_finish_after_minutes'] : null;
    
        return $res;
        
    }

    // $just_questions, $resulte_qustions

    ////////////////////////////////////////////`test_questions`////////////////////////////////////////////
    function getAllQuestionsReadyByParams($temp)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfSubject($temp['subject_id'])];
        // echo $temp['subject_id'] . " - " .$table;die();
        $sql = "SELECT tq.id ,  tq.test_id  , tq.parent_id ,  tq.title ,  tq.type ,tq.source ,tq.degree  ,tq.note    , tq.math_type_view_title , tq.math_type_view_note, tq.answer_form FROM `".$table."_test_questions` tq ";

        $sql .= " LEFT JOIN `tests` f  ON (f.id = tq.test_id) ";
        $sql .= "where   tq.`parent_id` = '0' AND f.`status` ='1' AND f.is_deleted !='1' AND f.type='{$temp['type']}' AND classification='{$temp['classification']}' AND f.`subject_id` ='{$temp['subject_id']}'  ";
        $temp['test_id'] ? $sql .= " AND tq.title NOT IN  (select title from `".$table."_test_questions` where test_id = '{$temp['test_id']}') " : " ";
        $sql .= $temp['searchKey'] ? ' AND (tq.title like "%' . $temp['searchKey'] . '%"  ) ' : '';
        $sql .= $temp['lesson_id'] && $temp['type'] == 'unit_exercise' ? " AND f.`lesson_id` ='{$temp['lesson_id']}'   " : ' ';
        $sql .= $temp['unit_id'] && $temp['type'] == 'unit_test' ? " AND f.`unit_id` ='{$temp['unit_id']}'   " : ' ';
        $sql .= " group by tq.id order by  f.`sort` asc , tq.id asc  ";
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';

        //  echo $sql;die();
        $res = $this->mDb->getAll($sql);
        // print_r($res);die();

        if (count($res)) {
            $temp['resulte_qustions'] = true;
            $temp['just_questions'] = false;
            $questions = $this->customQuestions($res, $temp, false);


            //   print_r($questions);die();

            for ($i = 0; $i < count($res); $i++) {

                if (!$questions['test_questions'][$i]['math_type_view_title']) {
                    $questions['test_questions'][$i]['math_type_view_title'] = renderMathType($questions['test_questions'][$i]['title']);
                    $this->updateMathViewBank_questionsTitle($questions['test_questions'][$i]['id'], $questions['test_questions'][$i]['math_type_view_title']);
                }
                if ((!$questions['test_questions'][$i]['math_type_view_note'] && $questions['test_questions'][$i]['note']) || ($questions['test_questions'][$i]['math_type_view_note'] && !$questions['test_questions'][$i]['note'])) {
                    $questions['test_questions'][$i]['math_type_view_note'] = renderMathType($questions['test_questions'][$i]['note']);
                    $this->updateMathViewBank_questionsNote($questions['test_questions'][$i]['id'], $questions['test_questions'][$i]['math_type_view_note']);
                }

                // if($questions['test_questions'][$i]['id'] == '6765676'){
                // }
                // echo $questions['test_questions'][$i]['test_id'];die();
                $questions['test_questions'][$i]['question_attachments'] = $this->getTestQuestionAttachments($questions['test_questions'][$i]['test_id'], $questions['test_questions'][$i]['id'], '', 'question');
                $questions['test_questions'][$i]['note_attachments'] = $this->getTestQuestionAttachments($temp['test_id'], $questions['test_questions'][$i]['id'], '', 'note');
            }
        }

        return $questions['test_questions'];
    }


    function deleteTest($test_id)
    {
        $sql = "SELECT id from `tests` WHERE id  = '{$test_id}' AND  is_deleted != '1' ";
        $id = $this->mDb->getOne($sql);
        if ($id) {
            $sql = "UPDATE `tests` set is_deleted = '1' WHERE `id`='{$test_id}' ";
            $this->mDb->query($sql);
            return $id;
        }
    }

    function deleteQuestion($question_id, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        $sql = "SELECT id from `".$table."_test_questions` WHERE `id`='{$question_id}'  AND test_id  = '{$test_id}'";
        $id = $this->mDb->getOne($sql);

        $sql = "DELETE  from `".$table."_test_questions` WHERE ( `id`='{$question_id}' || parent_id = '{$question_id}') AND test_id  = '{$test_id}'";
        $this->mDb->query($sql);
        //  p($sql);
        return $id;
    }

    function detectIfISSubQustions($question_id, $sub_questions_str, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT count(pl.id) FROM `".$table."_test_questions` pl";
        $sql .= " WHERE pl.`parent_id` = '{$question_id}' AND  pl.id in ({$sub_questions_str}) ";
        // p( $sql );
        return $this->mDb->getOne($sql);
    }


    function updateMathViewTest_question_sort_wordsTitle($test_id, $id, $math_type_view_title)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        if ($id) {
            $sql = "UPDATE `test_questions_sort_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' AND `question_table` = '{$table}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewTest_question_complete_wordsTitle($test_id, $id, $math_type_view_title)
    {   $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        if ($id) {
            $sql = "UPDATE `test_questions_complete_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' AND `question_table` = '{$table}'";
            // p($sql);

            $this->mDb->query($sql);
        }
    }

    function updateMathViewTest_question_test_match_itemsTitle($test_id, $id, $math_type_view_title1, $math_type_view_title2)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        if ($id) {
            $sql = "UPDATE `test_questions_match_items` set math_type_view_title1 = '{$math_type_view_title1}' ,  math_type_view_title2 = '{$math_type_view_title2}' WHERE `id`='{$id}' AND `question_table` = '{$table}'";
            $this->mDb->query($sql);
        }
    }


    function updateMathViewTest_question_OptionTitle($test_id, $id, $math_type_view_title)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        if ($id) {
            $sql = "UPDATE `test_question_options` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' AND `question_table` = '{$table}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewTest_questionsTitle($id, $math_type_view_title, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        if ($id) {
            $sql = "UPDATE `".$table."_test_questions` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewTest_questionsNote($id, $math_type_view_note, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        if ($id) {
            $sql = "UPDATE `".$table."_test_questions` set math_type_view_note = '{$math_type_view_note}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getTestQuestion($test_id, $parent_id, $question_id, $test_random_order = 0)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT pl.*, pl.id AS question_id FROM `".$table."_test_questions` pl";
        $sql .= " WHERE pl.`test_id` = '{$test_id}'";
        $sql .= " AND pl.`parent_id` = '{$parent_id}'";
        $sql .= $question_id ? " AND pl.`id` = '{$question_id}'" : "";
        $sql .= $test_random_order ? " ORDER BY RAND()":"";

        // echo $sql;die(); 
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title'], $res['test_id']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewTest_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note'], $res['test_id']);
            }


            $res[$i]['question_attachments'] = $this->getTestQuestionAttachments($test_id, $res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getTestQuestionAttachments($test_id, $res[$i]['id'], '', 'note');
        }
        // echo"<pre>";print_r($res);echo"<pre>";die();
        return $res;
    }

    function getQuestionData($question_id, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT pl.* FROM `".$table."_test_questions` pl";
        $sql .= " WHERE pl.`id` = '{$question_id}'";
        $res = $this->mDb->getRow($sql);
        if ($res) {

            if (!$res['math_type_view_title']) {
                $res['math_type_view_title'] = renderMathType($res['title']);
                $this->updateMathViewTest_questionsTitle($res['id'], $res['math_type_view_title'], $res['test_id']);
            }
            if ((!$res['math_type_view_note'] && $res['note']) || ($res['math_type_view_note'] && !$res['note'])) {
                $res['math_type_view_note'] = renderMathType($res['note']);
                $this->updateMathViewTest_questionsNote($res['id'], $res['math_type_view_note'], $res['test_id']);
            }


            $res['question_attachments'] = $this->getTestQuestionAttachments($test_id, $res['id'], '', 'question');
            $res['note_attachments'] = $this->getTestQuestionAttachments($test_id, $res['id'], '', 'note');
        }
        return $res;
    }

    function getCountOfQustionsOfTest($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT count(`id`) from  `".$table."_test_questions`  where `test_id`='{$test_id}' and `is_deleted` !='1' and ( type = 'choose'  || type = 'check' || type = 'article' || type ='complete_it' ||  type ='complete_it_writing_auto_correct' || type ='complete_it_writing_manual_correct' || type ='sort_it'  || type ='match_it' ) ";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getAvailableToVisitorOfTest($test_id, $share_id = 0)
    {
        $sql  = "SELECT t.available_to_visitor ";
        $sql .= $share_id > 0 ? ", ts.code  ":"";
        $sql .= "from  `tests` t ";
        $sql .= $share_id > 0 ? " LEFT JOIN `tests_shares` ts ON ts.test_id = t.id AND ts.id = '{$share_id}'":"";
        $sql .= "  where t.`id`='{$test_id}' ";
        // echo $sql;die();
        $res = $this->mDb->getRow($sql);
        return $res;
        // print_r($res);die();
    }

    //////////////////////////////////////////// `test_question_attachments`////////////////////////////////////////////
    function addQuestionAttachments($test_id, $question_id, $option_id = '', $related_to, $attachments, $classification)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        //   echo $question_id;die();
        if (count($attachments) > 0 && is_array($attachments)) {

            for ($i = 0; $i < count($attachments); $i++) {
                # code...

                if ($classification == 'by_teacher_selected_from_bank') {
                    //copy attachments questions_bank_attachments to questions_attachments
                    $this->copyFileToServer("questions_bank_attachments", "questions_attachments", $attachments[$i]['file']);
                }

                $attachments[$i]['file'] = str_replace("'", "\'", $attachments[$i]['file']);
                $sql = "INSERT INTO `test_question_attachments` SET ";
                $sql .= "  `question_id` = '{$question_id}'  ";
                $sql .= ", `related_to` = '{$related_to}'  ";
                $sql .= $option_id ? ", `option_id` = '{$option_id}'  " : "";
                $sql .= ", `file` = '{$attachments[$i]['file']}'  ";
                 $sql .= ", `question_table` = '{$table}'  ";
                $sql .= ", `attachment_type` = '{$attachments[$i]['attachment_type']}' ";
                // echo $sql;
                // die();
                $this->mDb->query($sql);
            }
        }
    }
    
    
    function deleteQuestionAttachments($test_id, $question_id)
    {
         $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SDELETE FROM `test_question_attachments` WHERE question_id  = '{$question_id}' AND `question_table` = '{$table}'";
        return $this->mDb->query($sql);
    }

    function getTestQuestionAttachments($test_id, $question_id, $option_id, $related_to)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT `file`,`attachment_type` , `id`  FROM `test_question_attachments` ";
        $sql .= " WHERE  `question_id` = '{$question_id}' AND `related_to` = '{$related_to}' AND `question_table` = '{$table}'";
        $sql .= $option_id ? " AND `option_id` = '{$option_id}'   " : " ";
        // if($question_id == '6765676'){
        //     echo $test_id;die();
        // }
        $res = $this->mDb->getAll($sql);
        // $res = getFileSizeArr($res, 'questions_attachments');
        return $res;
    }

    //////////////////////////////////////////// `test_question_options`////////////////////////////////////////////

    function getQuestionOptions($question_id,$test_id, $resulte_qustions = false, $random_order = 0)
    {
        global $USER_DATA;
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT  `id`, `title` ,`math_type_view_title` ";
        $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions ? " ,`status`  , `note`  " : '';
        $sql .= " FROM `test_question_options`  ";
        $sql .= " WHERE  `test_question_id` ='{$question_id}' AND `question_table` = '{$table}' ";
        $sql .= $random_order ? " ORDER BY RAND() ":"";
        //  echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {


            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_OptionTitle($test_id, $res[$i]['id'], $res[$i]['math_type_view_title']);
            }


            $res[$i]['option_attachments'] = $this->getTestQuestionAttachments($test_id,$question_id, $res[$i]['id'], 'option');
        }
        return $res;
    }

    function getQuestionComplete_words($test_id, $question_id, $resulte_qustions = false, $random_order = false)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT  `id`, `title` ,`math_type_view_title`  ";
        $sql .= $resulte_qustions ? " , word_index ,question_id " : " ";
        $sql .= " FROM `test_questions_complete_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' AND `question_table` = '{$table}'";
        $sql .= $resulte_qustions ? " ORDER BY word_index, id ":" ORDER BY rand() ";
        // $sql .= $random_order ? " ORDER BY rand() " : "";//ORDER BY word_index, id 
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_complete_wordsTitle($test_id, $res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function compareWordIsCorrectWithAnswer($test_id, $question_id, $student_answer, $word_index)
    {
        // $student_answer = explode("'",$student_answer);
        // $student_answer = implode("\'",$student_answer);
        $student_answer = str_replace("'", "\'", $student_answer);
        // echo "====>".$student_answer;
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $student_answer = trim($student_answer);
        $sql = "SELECT  `id` FROM  `test_questions_complete_words`    ";
        $sql .= " WHERE  `question_id` ='{$question_id}'  AND word_index ='{$word_index}' AND title ='{$student_answer}' AND `question_table` = '{$table}'";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function compareWordIsCorrectWithAnswerById($test_id, $question_id, $student_answer_id, $word_index)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $student_answer_id = trim($student_answer_id);
        $sql = "SELECT  `id` FROM  `test_questions_complete_words`    ";
        $sql .= " WHERE  `question_id` ='{$question_id}'  AND word_index ='{$word_index}' AND  id ='{$student_answer_id}' AND `question_table` = '{$table}'";
        // p($sql);
        return $this->mDb->getOne($sql);
    }


    function getRelatedQuestionComplete_words($question_id)
    {
        $sql = "SELECT  `id`, `title`  ,`math_type_view_title` , word_index ,question_id    ";
        $sql .= " FROM `test_questions_complete_words`   ";
        $sql .= " WHERE  `question_id` ='{$question_id}'  AND word_index > 0  ORDER BY word_index asc   ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_complete_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function getQuestionSort_itOrginal($question_id,$test_id, $random_order = 0)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT  `id`, `title` ,`math_type_view_title` , word_index , question_id   ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions  ? " ,`status`  , `note`  " :  '';
        $sql .= " FROM `test_questions_sort_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' AND `question_table` = '{$table}' ";
        $sql .= $random_order ? " ORDER BY RAND()" : "  ORDER BY id asc ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_sort_wordsTitle($test_id, $res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function getQuestionSort_it($question_id,$test_id, $resulte_qustions = false, $test_oredr_status = 0, $random_order = 0)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT  `id`, `title` ,`math_type_view_title` ,`word_index`  ";
        $sql .= $resulte_qustions ? " , question_id  " : " ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions  ? " ,`status`  , `note`  " :  '';
        $sql .= " FROM `test_questions_sort_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' AND `question_table` = '{$table}'";
        $sql .= $random_order ? " ORDER BY RAND() ": ($resulte_qustions ? "  ORDER BY word_index asc   " : "  ORDER BY id asc ");
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);

        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_question_sort_wordsTitle($test_id, $res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }


    function getQuestionMatch_it($question_id, $test_id, $resulte_qustions = false, $random_order=0)
    {
        
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT `id`,  title1, math_type_view_title1 , title2 ,math_type_view_title2 , image1, image2  ";
        $sql .= $resulte_qustions ? " , righte_index2 ,righte_index1 , question_id  " : " ";
        $sql .= " FROM `test_questions_match_items`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' AND `question_table` = '{$table}'";
        $sql .= $random_order ? " ORDER BY RAND()" :" ORDER BY righte_index2 asc  ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title1'] || !$res[$i]['math_type_view_title2']) {
                $res[$i]['math_type_view_title1'] = renderMathType($res[$i]['title1']);
                $res[$i]['math_type_view_title2'] = renderMathType($res[$i]['title2']);
                $this->updateMathViewTest_question_test_match_itemsTitle($test_id, $res[$i]['id'], $res[$i]['math_type_view_title1'], $res[$i]['math_type_view_title2']);
            }
        }

        return $res;
    }


    function getRightIndexOfMatch_itById($test_id, $id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT   righte_index1  from `test_questions_match_items` where id ='{$id}'  AND `question_table` = '{$table}' ";
        return $this->mDb->getOne($sql);
    }

    function getCountOfItemQuestionComplete_words($test_id, $question_id, $total)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];

        $sql = "  SELECT count(id) From ( SELECT count(id), id FROM `test_questions_complete_words` Where word_index > 0 AND word_index < '{$total}' AND  `question_id` ='{$question_id}'   AND `question_table` = '{$table}' group by  word_index )  id ";
        // echo $sql;die();
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    function getCountOfItemQuestionMatch_it($test_id,$question_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT count(id)  FROM `test_questions_match_items` Where righte_index1 > 0  ";
        $sql .= " AND  `question_id` ='{$question_id}' AND `question_table` = '{$table}'";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    function getRigthOptionOfQuestion($question_id, $test_id, $random_order=0)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)]; 
        $sql  = "SELECT id FROM `test_question_options` ";
        $sql .= $random_order ? " ORDER BY RAND() " : "";
        $sql .= " WHERE `test_question_id` = '{$question_id}' and status ='1' AND `question_table` = '{$table}' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    ////////////////////////////////////////////student_tests_answers`////////////////////////////////////////////

    function getSomeStudent_tests_answersTestData($user_id, $test_id, $share_id, $test_status = '')
    {
        //   echo $test_status;die();
        $sql = "SELECT  id ,total_degree ,total_answer_degree  , total_question_count , total_answered_questions_count from  `student_tests_answers`  ";
        $sql .= "  where  `user_id`={$user_id} AND `test_id`={$test_id} ";
        $sql .= $share_id ? " AND `share_id`= {$share_id}" : ' AND `share_id` = 0';
        $sql .= $test_status ? " AND `test_status`='{$test_status}' " : ' ';
        // $sql .=  $total_answered_questions_count ?  " AND total_answered_questions_count > 0  "  : ' ';

        $sql .= ' order by id desc limit 1 ';
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        return $res[0];
    }


    function countOfAnswerOnTest($test_id)
    {
        $sql = "SELECT  count( `id`  ) from  `student_tests_answers`  ";
        $sql .= "  where `test_id`={$test_id} AND `total_answered_questions_count` > '0'  AND `test_status` = 'completed' ";
        $ret = $this->mDb->getOne($sql);
        return $ret > 0 ? $ret * 1 : 0;
    }

    function getTeacherIdByShare_id($share_id)
    {
        $sql = "SELECT `teacher_id` FROM `tests_shares` WHERE `id`='{$share_id}' ";
        return $this->mDb->getOne($sql);
    }

    function getTestIDByStudent_tests_answers_id($student_tests_answers_id)
    {
        $sql = "SELECT `test_id` FROM `student_tests_answers` WHERE `id`='{$student_tests_answers_id}' ";
        return $this->mDb->getOne($sql);
    }

    function getSomeDataByStudent_tests_answers_id($student_tests_answers_id)
    {
        $sql = "SELECT `test_id`, `share_id` , `user_id` ,`test_status`, show_result_to_student FROM `student_tests_answers` WHERE `id`='{$student_tests_answers_id}' ";
        // echo $sql;die();
        return $this->mDb->getRow($sql);
    }


    // function checkStudentHaveTestNotCompleted($user_id, $test_id, $share_id)
    // {
    //   $res = $this->getSomeStudent_tests_answersTestData($user_id, $test_id, $share_id, 'not_completed');
    //   return $res['id'];
    // }

    function checkStudentHaveTestCompleted($user_id, $test_id, $share_id)
    {
        $res = $this->getSomeStudent_tests_answersTestData($user_id, $test_id, $share_id, 'completed');
        return $res['id'];
    }

    function checkStudentHaveTest($user_id, $test_id, $share_id)
    {
        // echo $user_id;die();
        $res = $this->getSomeStudent_tests_answersTestData($user_id, $test_id, $share_id, '');
        return $res['id'];
    }

    function getTotalDegreeOfTest($test_id)
    {
        $sql = "SELECT `total_degree` from  `tests` where id ='{$test_id}'  ";
        return $this->mDb->getOne($sql);
    }

    function getQuestionDegree($question_id, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT `degree` from  `".$table."_test_questions` where id ='{$question_id}'  ";
        return $this->mDb->getOne($sql);
    }

    function getQuestionDegreeOfManualSolvingQustion($question_id, $test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        
        $sql = "SELECT sum(`degree`) from  `".$table."_test_questions` where ( id ='{$question_id}'  || parent_id = '{$question_id}')   ";
        return $this->mDb->getOne($sql);
    }


    function getQuestionAnswerDegree($student_tests_answers_id, $question_id)
    {
        $sql = "SELECT `answer_degree` from  `student_tests_answers_details` where question_id ='{$question_id}' AND  student_tests_answers_id ='{$student_tests_answers_id}'   ";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getUser_idQuestionAnswerDegree($student_tests_answers_id, $question_id)
    {
        $sql = "SELECT `answer_degree` from  `student_tests_answers` where question_id ='{$question_id}' AND  student_tests_answers_id ='{$student_tests_answers_id}'   ";
        return $this->mDb->getOne($sql);
    }

    function editTestData($temp, $test_id)
    {
        $temp['name'] = str_replace("'", "\'", $temp['name']);
        $temp['description'] = str_replace("'", "\'", $temp['description']);

        $sql = "UPDATE  `tests` SET ";
        $sql .= " `name` = '{$temp['name']}' ";
        $sql .= ", `description` = '{$temp['description']}' ";
        $sql .= ", `available_to_visitor` = '{$temp['available_to_visitor']}'  ";
        $sql .= " where id= '{$test_id}' ";
        // p($sql);
        return $this->mDb->query($sql);
    }

    function insertNewTest($user_id, $test_id, $share_id='')
    {

        // $sqll = "SELECT show_result_to_student FROM `tests_shares` WHERE `id` = '{$share_id}'";
        // $show_result_to_student = $this->mDb->getOne($sqll);
        
        $total_degree = $this->getTotalDegreeOfTest($test_id);
        $sql = "INSERT `student_tests_answers` SET ";
        $sql .= " `user_id`  = '{$user_id}' , ";
        $sql .= " `test_id`  = '{$test_id}' , ";
        $sql .= " `share_id`  = '{$share_id}' , ";
        $sql .= " `test_status`  = 'not_completed' , ";
        $sql .= " `total_degree`  = '{$total_degree}' , ";
        $sql .= " `date_added`  = '{$this->dateTime}'   ";
        // $sql .= $share_id ? " ,`show_result_to_student` = '{$show_result_to_student}' ":"";
        // echo  $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }


    function test_correction($student_tests_answers_id, $AfterSolveTestByTeacher = false)
    {
        
        $test_id = $this->getTestIDByStudent_tests_answers_id($student_tests_answers_id);
        $countOfQustionsOfTest = $this->getCountOfQustionsOfTest($test_id);

        if ($test_id > 0) {

            $total_answer_degree = 0;
            $student_answers = $this->getAllStudent_tests_answers_details($student_tests_answers_id); // get data about answer's student from student_tests_answers_details table
            // print_r($student_answers);die();
            $count_of_answers = count($student_answers); // number of answers of student

            for ($index = 0; $index < $count_of_answers; $index++) { // for loap on number of answer of student

                $student_answers[$index]['student_answer_details'] = json_decode($student_answers[$index]['student_answer_details'], true); // get answer of student deatils from DB
                $questionDegree = $this->getQuestionDegree($student_answers[$index]['question_id'], $student_answers[$index]['test_id']); // get original degree of question that inserted by teacher, admin, manager or any one
                $anwser_degree = 0; // set degree of answer of student equal zero
                
                /***************************************************************************************/
                // Q -> choose && check
                
                if ($student_answers[$index]['question_type'] == 'choose' || $student_answers[$index]['question_type'] == 'check') { // if question is choose or check
                  
                    $count_of_correct_options = 0; 
                    $all_right_options = $this->getRigthOptionOfQuestion($student_answers[$index]['question_id'], $test_id); //get all original right options from DB
                    $all_student_option_array = explode(",", $student_answers[$index]['student_answer_details']['student_option']); // convert answer of student to array
                    for ($i = 0; $i < count($all_right_options); $i++) { // for loap on original naswers
                        if (is_numeric(array_search($all_right_options[$i]['id'], $all_student_option_array, true))) { // if student answer is in original answer
                            $count_of_correct_options += 1; // update number of questions are correcte plus one
                        }
                    }
                    if (count($all_right_options)) { // if number of original answer greater than 0
                        $anwser_degree = ($count_of_correct_options / count($all_right_options)) * $questionDegree; // set anser degree of student equal
                    }
                    // print_r($all_right_options);
                    // echo "count_of_correct_options : " . $count_of_correct_options;
                    // echo "questionDegree : " .$questionDegree;
                    // die();
                } 
                
                
                /***************************************************************************************/
                // Q -> article && complete_it_writing_manual_correct
                
                
                else if ($student_answers[$index]['question_type'] == 'article' || $student_answers[$index]['question_type'] == 'complete_it_writing_manual_correct') { //if arical or manual correct
                    if ($AfterSolveTestByTeacher) { //check if question is corrected by teacher
                        $anwser_degree = $this->getQuestionAnswerDegree($student_tests_answers_id, $student_answers[$index]['question_id']);
                        // echo $anwser_degree;die();
                    }
                }
                
                
                /***************************************************************************************/
                // Q -> sort_it
                
                else if ($student_answers[$index]['question_type'] == 'sort_it') { //if question type is sort it
                    $sort_it_words = $this->getQuestionSort_it($student_answers[$index]['question_id'], $test_id, true);
                    $count_of_correct_sort_it = 0;
                    for ($i = 0; $i < count($sort_it_words); $i++) {
                        if ($sort_it_words[$i]['id'] == $student_answers[$index]['student_answer_details']['questions_sort_words'][$i]) {
                            $count_of_correct_sort_it += 1;
                        }
                    }
                    if ($count_of_correct_sort_it == count($sort_it_words)) {

                        $anwser_degree = $questionDegree;
                    }
                } 
                
                
                /***************************************************************************************/
                // Q -> complete_it && complete_it_writing_auto_correct
                 
                
                else if ($student_answers[$index]['question_type'] == 'complete_it'
                    || $student_answers[$index]['question_type'] == 'complete_it_writing_auto_correct'
                ) {
                    
                    $all_sub_question_degree = 0;

                    for ($sub = 0; $sub < count($student_answers[$index]['student_answer_details']['questions_' . $student_answers[$index]['question_type']]); $sub++) {
                        // $count_of_answers +=1;
                        $countOfItem = 0;
                        $count_of_correct_complete_it = 0;
                        $sub_question_id = $student_answers[$index]['student_answer_details']['questions_' . $student_answers[$index]['question_type']][$sub]['sub_question_id'];
                        $question_degree = $this->getQuestionDegree($sub_question_id, $student_answers[$index]['test_id']);
                        
                        $all_sub_question_degree += $question_degree;


                        $answers = $student_answers[$index]['student_answer_details']['questions_' . $student_answers[$index]['question_type']][$sub]['answer'];
                        $countOfItem = $this->getCountOfItemQuestionComplete_words($test_id, $sub_question_id, count($answers) + 1); // count($answers)+1   علشان لو فيه اجابة غلط واخدة ووورد اندكس غير الزيرو
                        if (count($answers) > 0) {

                            for ($i = 0; $i < count($answers); $i++) {
                                $student_answer = $answers[$i];
                                if ($student_answers[$index]['question_type'] == 'complete_it') {
                                    $is_correct_answer = $this->compareWordIsCorrectWithAnswerById($test_id, $sub_question_id, $student_answer, $i + 1);
                                } else if ($student_answers[$index]['question_type'] == 'complete_it_writing_auto_correct') {
                                    $is_correct_answer = $this->compareWordIsCorrectWithAnswer($test_id, $sub_question_id, $student_answer, $i + 1);
                                    // echo $is_correct_answer;die();
                                }

                                if ($is_correct_answer) {
                                    $count_of_correct_complete_it += 1;
                                    //
                                }
                            }

                            $countOfItem = $countOfItem ? $countOfItem : 0;
                            if ($countOfItem > 0) {
                                // echo $count_of_correct_complete_it ."//". $countOfItem ."//". $question_degree;
                                $anwser_degree += ($count_of_correct_complete_it / $countOfItem * $question_degree);
                            }

                        }
                    }
                    
                    
                    $questionDegree = $all_sub_question_degree;
                                //   echo "questionDegree : " . $questionDegree;die();
                } 
                
                
                /***************************************************************************************/
                // Q -> match_it
                 
                
                else if ($student_answers[$index]['question_type'] == 'match_it') {
                    $match_it_items = $this->getQuestionMatch_it($student_answers[$index]['question_id'], $test_id, true);

                    if (count($match_it_items) > 0) {
                        $count_of_correct_match_it_items = 0;
                        for ($i = 0; $i < count($match_it_items); $i++) {
                            $found_key = array_search($match_it_items[$i]['id'], array_column($student_answers[$index]['student_answer_details']['questions_match_items'], 'id'));
                            if (is_numeric($found_key)) {
                                $righte_index1 = $this->getRightIndexOfMatch_itById($test_id, $student_answers[$index]['student_answer_details']['questions_match_items'][$found_key]['id']);
                                if ($righte_index1 == $student_answers[$index]['student_answer_details']['questions_match_items'][$found_key]['student_answer_item']) {
                                    $count_of_correct_match_it_items += 1;
                                }
                            }
                        }
                        $countOfItem = $this->getCountOfItemQuestionMatch_it($test_id, $student_answers[$index]['question_id']);
                        if ($countOfItem) {
                            $anwser_degree = $count_of_correct_match_it_items / $countOfItem * $questionDegree;
                        }
                    }
                }
                
                
                $questionDegree = $questionDegree ? $questionDegree : 0;
                $total_answer_degree += $anwser_degree;
                
                // echo $total_answer_degree;die();
                // if($student_answers[$index]['question_type'] == 'complete_it_writing_auto_correct'){
                //     // echo $student_tests_answers_id.','. $student_answers[$index]['question_id'].','. $anwser_degree.','. $questionDegree;
                // }
                // echo "questionDegree : ". $questionDegree; die();
                $this->updateStudent_tests_answers_details($student_tests_answers_id, $student_answers[$index]['question_id'], $anwser_degree, $questionDegree);
            }
            $result = array();
            $result['test_id'] = $test_id;
            $result['total_question_count'] = $countOfQustionsOfTest;
            $result['total_degree'] = $this->getTotalDegreeOfTest($test_id);
            $result['total_answer_degree'] = $total_answer_degree;
            $exam_degree_percentage = $result['total_degree'] > 0 ? intval(((($total_answer_degree) / ($result['total_degree'])) * 100)) : 0;
            $result['total_answered_questions_count'] = $countOfQustionsOfTest < $count_of_answers ? $countOfQustionsOfTest : $count_of_answers;
            $result['exam_degree_percentage'] = $exam_degree_percentage;
            $result['student_tests_answers_id'] = $student_tests_answers_id;
            // $result['corrected'] = $result['total_answer_degree'] == $result['total_answered_questions_count'] ? '1':'0';

            if ($AfterSolveTestByTeacher) {
                $corrected = true;
            } else {
                $thereManualSolvingQustion = $this->checkIfThereManualSolvingQustionOnTest($test_id);
                $corrected = $thereManualSolvingQustion ? false : true;
            }

            $answer_id = $this->saveStudentTestAnswer($result, $corrected);
          
            return $answer_id;
        } else {
            
            return false;
        }
        
        // print_r($result);die(); 
    }


    function getCountOfSubQustion($question_id)
    {
        
        $sql = "SELECT `id` FROM `test_questions` WHERE `parent_id` = '{$question_id}'";
        return $this->mDb->getOne($sql);
    }

    function checkIfQuestionExistOnTest($test_id, $question_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT `id` FROM `".$table."_test_questions` WHERE `test_id` = '{$test_id}' AND `id` = '{$question_id}'";
        return $this->mDb->getOne($sql);
    }

    function checkIfThereManualSolvingQustionOnTest($test_id)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
        $sql = "SELECT `id` FROM `".$table."_test_questions` WHERE `test_id` = '{$test_id}' AND `type`  in ( 'article', 'complete_it_writing_manual_correct' )  ";
        return $this->mDb->getOne($sql);
    }

    function countOfManualSolvingQustionOnStudent_tests_answer($student_tests_answers_id)
    {
        $sql = "SELECT count(`id`) FROM `student_tests_answers_details` WHERE `student_tests_answers_id` = '{$student_tests_answers_id}' AND `question_type` in ( 'article', 'complete_it_writing_manual_correct' ) ";
        return $this->mDb->getOne($sql);
    }

    function updateTestStatusToCompleted($student_tests_answers_id)
    {
        $thereArticleQustuibOnTesttAnswer = $this->countOfManualSolvingQustionOnStudent_tests_answer($student_tests_answers_id);
        $corrected = $thereArticleQustuibOnTesttAnswer > 0 ? false : true;

        $sql = "UPDATE `student_tests_answers` SET  `test_status` = 'completed' ";
        $sql .= $corrected ? " , `corrected` = '1'  " : " , `corrected` = '0'  ";
        $sql .= " WHERE `id`={$student_tests_answers_id} ";
        return $this->mDb->query($sql);
    }

    function saveStudentTestAnswer($temp, $corrected)
    {

        $is_before_corrected = $this->cheackIFTestISCorrected($temp['student_tests_answers_id']);

        $sql = "UPDATE `student_tests_answers` SET ";
        $sql .= " `total_degree` = '{$temp['total_degree']}' ";
        $sql .= ", `total_answer_degree` = '{$temp['total_answer_degree']}'  ";
        $sql .= ", `total_question_count` = '{$temp['total_question_count']}'  ";
        $sql .= ", `total_answered_questions_count` = '{$temp['total_answered_questions_count']}'  ";
        // $sql .= $temp['total_question_count'] == $temp['total_answered_questions_count'] ? ", `test_status` = 'completed'  " : ", `test_status` = 'not_completed'  ";
        $sql .= $temp['exam_degree_percentage'] ? ", `exam_degree_percentage` = '{$temp['exam_degree_percentage']}'  " : " , `exam_degree_percentage` = NULL   ";
        $sql .= $corrected && $temp['total_question_count'] == $temp['total_answered_questions_count'] ? ", `corrected` = '1'  " : ", `corrected` = '0'  ";
        $sql .= " WHERE `id`={$temp['student_tests_answers_id']}";
        //  p($sql);
        $res = $this->mDb->query($sql);

        $is_after_corrected = $this->cheackIFTestISCorrected($temp['student_tests_answers_id']);
        // p($is_before_corrected, false);
        // p("-".$is_after_corrected);
        if (!$is_before_corrected && $is_after_corrected) {
            $test_answer_data = $this->getSomeDataByStudent_tests_answers_id($temp['student_tests_answers_id']);

            $parents_of_student = $this->getStudents_parents($test_answer_data['user_id']);
            //Send Notificaiton To Parent

            for ($i = 0; $i < count($parents_of_student); $i++) {
                $notificationToSend['send_user_id'] = $test_answer_data['user_id'];
                $notificationToSend['receive_user_id'] = $parents_of_student[$i]['parent_id'];
                $notificationToSend['redirect_data']['student_tests_answers_id'] = $temp['student_tests_answers_id'];
                $notificationToSend['redirect_data']['test_id'] = $test_answer_data['test_id'];
                $notificationToSend['redirect_data']['share_id'] = $test_answer_data['share_id'];
                $notificationToSend['type'] = 'childTestCorrected';
                $this->notifyObj->sendNotificationByType($notificationToSend);
            }
        }


        return $res;
    }

    public function getStudents_parents($student_id)
    {
        $sql = "SELECT parent_id FROM `students_parents`   ";
        $sql .= "WHERE  student_id = '{$student_id}'    ";
        return $this->mDb->getAll($sql);
    }

    function solveTest($student_tests_answers_id, $questions)
    {
        for ($i = 0; $i < count($questions); $i++) {
            # code...
            $questionDegree = $this->getQuestionDegree($questions[$i]['question_id'], $questions[$i]['test_id']);
            $res = $this->updateStudent_tests_answers_details($student_tests_answers_id, $questions[$i]['question_id'], $questions[$i]['answer_degree'], $questionDegree);
        }
        return $res;
    }

    function updateStudent_tests_answers_details($student_tests_answers_id, $question_id, $answer_degree, $total_q_degree)
    {
        //   echo $student_tests_answers_id."***".$question_id."***".$answer_degree."***".$total_q_degree;
        $sql = "UPDATE  `student_tests_answers_details` SET ";
        $sql .= " `answer_degree` = '{$answer_degree}' ";
        $sql .= ", `total_q_degree` = '{$total_q_degree}' ";
        $sql .= "  where  `student_tests_answers_id` = '{$student_tests_answers_id}' AND `question_id` = '{$question_id}'   ";
        // echo  $sql; die();
        return $this->mDb->query($sql);
    }

    function getUserIdByStudent_tests_answers_id($student_tests_answers_id)
    {
        $sql = "SELECT `user_id` FROM `student_tests_answers` WHERE `id`='{$student_tests_answers_id}'   ";
        // echo  $sql;
        return $this->mDb->getOne($sql);
    }

    function cheackIFTestISCorrected($student_tests_answers_id)
    {
        $sql = "SELECT `id` FROM `student_tests_answers` WHERE `id`='{$student_tests_answers_id}' AND `corrected`='1' ";
        // echo  $sql;die();
        return $this->mDb->getOne($sql);
    }

    function checkTestComplete($student_tests_answers_id)
    {
        $sql = "SELECT `id` FROM `student_tests_answers` WHERE `id`='{$student_tests_answers_id}' AND `test_status`='completed' ";
        // echo  $sql;die();
        return $this->mDb->getOne($sql);
    }

    function repeateTest($student_tests_answers_id)
    {

        $sql = "DELETE  from `student_tests_answers_details` WHERE `student_tests_answers_id`='{$student_tests_answers_id}'";
        $this->mDb->query($sql);

        $sql = "UPDATE `student_tests_answers` SET ";
        $sql .= " `total_question_count` = '0' ";
        $sql .= ", `total_answered_questions_count` = '0' ";
        $sql .= ", `exam_degree_percentage` = NULL ";
        $sql .= ", `corrected` = '0'    ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
        $sql .= ", `test_status`='not_completed'";
        $sql .= " WHERE `id`={$student_tests_answers_id}  ";//AND `test_status`='not_completed'
        // echo $sql;die();
        return $this->mDb->query($sql);
    }


    function getTestStudentResult($student_tests_answers_id)
    {
        global $USER_DATA;
        $sql = " SELECT sta.* , u.full_name, t.subject_id as subject_id FROM student_tests_answers sta ";
        $sql .= " LEFT JOIN users u ON ( u.id= sta.user_id) ";
        $sql .= " LEFT JOIN tests t ON ( t.id= sta.test_id) ";

        $sql .= "  WHERE sta.id ='{$student_tests_answers_id}' ";

        // echo $sql;die();
        $result = $this->mDb->getRow($sql);
        // print_r($result);die();
        if ($result) {
            if ($USER_DATA['user_type'] == 'student') {
                $test_arg['user_type'] = $USER_DATA['user_type'];
                $test_arg['student_id'] = $USER_DATA['id'];
            }
            $test_arg['id'] = $result['test_id'];
            $test_arg['just_questions'] = true;
            $test_arg['student_tests_answers_id'] = $student_tests_answers_id;
            $test_arg['resulte_qustions'] = true;
            $test_arg['test_status'] = $result['test_status'];
            $result['tests_details'] = $this->getOneTestDetails($test_arg);
            $result['manualSolvingQustionCount'] = $this->countOfManualSolvingQustionOnStudent_tests_answer($student_tests_answers_id);
            unset($result['tests_details']['test_question_count']);
        }
        $ch = $this->checkTestIfCompleted($student_tests_answers_id);
        // echo $ch;die();
        if ($ch) {
            return $result;
        }

    }

    ////////////////////////////////////////////student_tests_answers_details`////////////////////////////////////////////

    // function getStudentTestAnswerByParams($temp)
    // {
    //     $temp['sort_by'] = $temp['sort_by'] ? $temp['sort_by'] : 'id';
    //     $temp['sort_type'] = $temp['sort_type'] ? $temp['sort_type'] : 'desc';

    //     $sql = "SELECT   sta.*, sta.id as student_tests_answers_id, te.subject_id, te.unit_id, te.type ,unitl.`name` as 'unit_name' , subjectt.`name` as 'subject_name', te.name  , u.img as user_img , u.full_name as user_full_name, u.visitor_code   ";
    //     $sql .= " FROM `tests_shares` tes "; //`student_tests_answers` sta";
    //     $sql .= " LEFT JOIN `tests_shares_groups` tsg ON (tes.id = tsg.tests_share_id) ";
    //     $sql .= " LEFT JOIN `groups` g ON (g.id = tsg.group_id) ";
    //     $sql .= " LEFT JOIN `group_members` gm ON (gm.group_id = g.id) ";
    //     $sql .= " LEFT JOIN `student_tests_answers` sta ON (sta.user_id = gm.student_id) ";
    //     $sql .= " LEFT JOIN `tests` te ON (sta.test_id =te.id) ";
    //     $sql .= isset($temp['post_id']) && $temp['post_id'] != 'null' ? " LEFT JOIN `group_shared_test_post_relations` gstpr ON  ( sta.`share_id` = gstpr.`share_id`)" : " ";

    //     $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
    //     $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
    //     $sql .= " LEFT JOIN `users` u ON  ( u.`id` = sta.`user_id`)";

    //     $sql .= " WHERE sta.id > 0 AND te.is_deleted != '1' AND tes.id IS NOT NULL AND sta.share_id IS NOT NULL  AND sta.share_id != '0' ";

    //     $sql .= $temp['test_id'] ? "AND sta.test_id = '{$temp['test_id']}' " : " ";
    //     $sql .= $temp['user_id'] ? "  AND sta.user_id ='{$temp['user_id']}'  " : " ";
    //     $sql .= $temp['share_id'] ? "  AND sta.share_id ='{$temp['share_id']}'  " : " ";
    //     $sql .= isset($temp['post_id']) && $temp['post_id'] != 'null' && $temp['post_id'] != '' ? "  AND gstpr.post_id ='{$temp['post_id']}'  " : " ";
    //     $sql .= $temp['corrected'] ? "  AND sta.corrected ='{$temp['corrected']}'  " : " ";
    //     $sql .= $temp['test_status'] ? "  AND sta.test_status ='{$temp['test_status']}'  " : " ";
    //     $sql .= $temp['subject_id'] ? "  AND te.subject_id ='{$temp['subject_id']}'  " : " ";
    //     $sql .= $temp['type'] == 'all' ? "  AND ( te.type ='general_test' OR te.type ='unit_test' OR te.type ='unit_exercise' )  " : "  ";
    //     $sql .= $temp['type'] != 'all' && $temp['type'] ? "  AND te.type ='{$temp['type']}'  " : "  ";
    //     $sql .= $temp['have_wrong_answers'] == true ? "  AND  sta.exam_degree_percentage < '100'   " : " ";
    //     $sql .= $temp['teacher_id'] ? "  AND tes.teacher_id ='{$temp['teacher_id']}'  " : " ";
    //     $sql .= " group by  sta.id ";

    //     $sql .= $temp['sort_by'] ? " order by sta.{$temp['sort_by']} {$temp['sort_type']} " : ' ';

    //     $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';

    //     //  echo $sql;die();
    //     return $this->mDb->getAll($sql);
    // }


    function getStudentTestAnswerByParams($temp)
    {
        $temp['sort_by'] = $temp['sort_by'] ? $temp['sort_by'] : 'id';
        $temp['sort_type'] = $temp['sort_type'] ? $temp['sort_type'] : 'desc';

        $sql = "SELECT   sta.*, sta.id as student_tests_answers_id, te.subject_id, te.unit_id, te.type ,unitl.`name` as 'unit_name' , subjectt.`name` as 'subject_name', te.name  , u.img as user_img , u.full_name as user_full_name, u.visitor_code   ";
        $sql .= " FROM `student_tests_answers` sta ";
        // $sql .= " LEFT JOIN `student_tests_answers` sta ON (sta.user_id = gm.student_id) ";
        $sql .= " LEFT JOIN `tests` te ON (sta.test_id =te.id) ";
        $sql .= isset($temp['post_id']) && $temp['post_id'] != 'null' ? " LEFT JOIN `group_shared_test_post_relations` gstpr ON  ( sta.`share_id` = gstpr.`share_id`)" : " ";

        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `users` u ON  ( u.`id` = sta.`user_id`)";

        $sql .= " WHERE sta.id > 0 AND te.is_deleted != '1' ";

        $sql .= $temp['test_id'] ? "AND sta.test_id = '{$temp['test_id']}' " : " ";
        $sql .= $temp['user_id'] ? "  AND sta.user_id ='{$temp['user_id']}'  " : " ";
        $sql .= $temp['share_id'] ? "  AND sta.share_id ='{$temp['share_id']}'  " : " ";
        $sql .= isset($temp['post_id']) && $temp['post_id'] != 'null' && $temp['post_id'] != '' ? "  AND gstpr.post_id ='{$temp['post_id']}'  " : " ";
        $sql .= $temp['corrected'] ? "  AND sta.corrected ='{$temp['corrected']}'  " : " ";
        $sql .= $temp['test_status'] ? "  AND sta.test_status ='{$temp['test_status']}'  " : " ";
        $sql .= $temp['subject_id'] ? "  AND te.subject_id ='{$temp['subject_id']}'  " : " ";
        $sql .= $temp['type'] == 'all' ? "  AND ( te.type ='general_test' OR te.type ='unit_test' OR te.type ='unit_exercise' )  " : "  ";
        $sql .= $temp['type'] != 'all' && $temp['type'] ? "  AND te.type ='{$temp['type']}'  " : "  ";
        $sql .= $temp['have_wrong_answers'] == true ? "  AND  sta.exam_degree_percentage < '100'   " : " ";
        // $sql .= $temp['teacher_id'] ? "  AND tes.teacher_id ='{$temp['teacher_id']}'  " : " ";
        $sql .= " group by  sta.id ";

        $sql .= $temp['sort_by'] ? " order by sta.{$temp['sort_by']} {$temp['sort_type']} " : ' ';

        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';

        //  echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function getCountStudentTestAnswerByParams($temp)
    {
        $sql = "SELECT  count( sta.id )  ";
        $sql .= " FROM `student_tests_answers` sta";
        $sql .= " LEFT JOIN `tests` te ON (sta.test_id =te.id) ";
        $sql .= $temp['post_id'] ? " LEFT JOIN `group_shared_test_post_relations` gstpr ON  ( sta.`share_id` = gstpr.`share_id`)" : " ";
        $sql .= " LEFT JOIN `units` unitl ON  ( te.`unit_id` = unitl.`id`) ";
        $sql .= " LEFT JOIN `subjects` subjectt ON  ( te.`subject_id` = subjectt.`id`)";
        $sql .= " LEFT JOIN `users` u ON  ( u.`id` = sta.`user_id`)";
        $sql .= " LEFT JOIN `tests_shares` tes ON (sta.test_id =tes.test_id) ";

        $sql .= " WHERE sta.id > 0 AND te.is_deleted != '1' ";
        $sql .= $temp['user_id'] ? "  AND sta.user_id ='{$temp['user_id']}'  " : " ";
        $sql .= $temp['share_id'] ? "  AND sta.share_id ='{$temp['share_id']}'  " : " ";
        $sql .= $temp['post_id'] ? "  AND gstpr.post_id ='{$temp['post_id']}'  " : " ";

        $sql .= $temp['corrected'] ? "  AND sta.corrected ='{$temp['corrected']}'  " : " ";
        $sql .= $temp['test_status'] ? "  AND sta.test_status ='{$temp['test_status']}'  " : " ";
        $sql .= $temp['subject_id'] ? "  AND te.subject_id ='{$temp['subject_id']}'  " : " ";
        $sql .= $temp['type'] == 'all' ? "  AND ( te.type ='general_test' OR te.type ='unit_test' )  " : "  ";
        $sql .= $temp['type'] != 'all' && $temp['type'] ? "  AND te.type ='{$temp['type']}'  " : "  ";

        $sql .= $temp['have_wrong_answers'] == true ? "  AND  sta.exam_degree_percentage < '100'   " : " ";
        $sql .= $temp['teacher_id'] ? "  AND tes.teacher_id ='{$temp['teacher_id']}'  " : " ";
        $sql .= " group by  sta.id ";

        return $this->mDb->getOne($sql);
    }


    function getAnswesOfQuestions($student_tests_answers_id, $question_id)
    {
        $sql = "SELECT  id , question_id , question_type ,answer_degree , student_answer_details ,answer ,status ,student_option,right_option  ";
        // $sql .= $resulte_qustions ? "   " : " ";
        $sql .= "  FROM `student_tests_answers_details`  ";
        $sql .= " WHERE  `student_tests_answers_id` = '{$student_tests_answers_id}' AND `question_id` = '{$question_id}'";
        //  echo $sql;die();
        $answer = $this->mDb->getRow($sql);
        if ($answer) {

            $ret = json_decode($answer['student_answer_details'], true);

            $ret['question_type'] = $answer['question_type'];
            $ret['question_id'] = $answer['question_id'];
            $ret['answer_degree'] = $answer['answer_degree'];
            $ret['student_option'] = $ret['student_option'] ? $ret['student_option'] : $answer['student_option'];
            $ret['article_answer'] = $ret['article_answer'] ? $ret['article_answer'] : $answer['answer'];

            $ret['student_answer_details'] = json_decode($answer['student_answer_details'], true);
            if ($answer['question_type'] == 'article') {
                $ret['answer_attachments'] = $this->getAnswersAttachments($answer['id']);
            }
        }
        return $ret;
    }

    function getCountOfAnswerQustionsOfTest($student_tests_answers_id)
    {
        $sql = "SELECT count(`question_id`) from  `student_tests_answers_details`  where `student_tests_answers_id`='{$student_tests_answers_id}'";
        return $this->mDb->getOne($sql);
    }

    function checkAnsweOnQuestionByStudent_tests_answers_id($student_tests_answers_id, $question_id)
    {
        $sql = "SELECT `id` FROM `student_tests_answers_details` WHERE `student_tests_answers_id`='{$student_tests_answers_id}' AND  `question_id`='{$question_id}'";
        return $this->mDb->getOne($sql);
    }

    function setQuestionAnswer($temp)
    {
        if ($temp['stundet_answer']['questions_complete_it_writing_auto_correct']) {
            for ($i = 0; $i < count($temp['stundet_answer']['questions_complete_it_writing_auto_correct']); $i++) {
                for ($a = 0; $a < count($temp['stundet_answer']['questions_complete_it_writing_auto_correct'][$i]['answer']); $a++) {
                    $temp['stundet_answer']['questions_complete_it_writing_auto_correct'][$i]['answer'][$a] = trim($temp['stundet_answer']['questions_complete_it_writing_auto_correct'][$i]['answer'][$a]);
                }
            }
        }
        $id = $this->checkAnsweOnQuestionByStudent_tests_answers_id($temp['student_tests_answers_id'], $temp['question_id']);
        
        $temp['student_answer_details'] = json_encode($temp['stundet_answer'], JSON_UNESCAPED_UNICODE);
        $temp['student_answer_details'] = explode("'", $temp['student_answer_details']);
        $temp['student_answer_details'] = implode("\'", $temp['student_answer_details']);
        if (!$id) {
            
            $sql = "INSERT INTO `student_tests_answers_details` (`student_answer_details`, `question_type`, `question_id`, `student_tests_answers_id`)";
            $sql .= "VALUES('{$temp['student_answer_details']}', '{$temp['question_type']}', '{$temp['question_id']}', '{$temp['student_tests_answers_id']}')";
            //   $sql = "INSERT INTO `student_tests_answers_details`  SET ";
            //   $sql .= " `student_answer_details`='{$temp['student_answer_details']}' ";
            //   $sql .= ",`question_type`='{$temp['question_type']}'  ";
            //   $sql .= ",`question_id`='{$temp['question_id']}'   ";
            //   $sql .= ",`student_tests_answers_id`='{$temp['student_tests_answers_id']}'";
            // echo "2149 : " . ($sql);die();
            $student_tests_answers_details_id = $this->mDb->queryReturnLastId($sql);
        } else {
            $sql = "UPDATE `student_tests_answers_details` SET";
            $sql .= "`student_answer_details`='{$temp['student_answer_details']}' ";
            $sql .= "where `id`= $id";
            $student_tests_answers_details_id = $id;
            //   echo   $sql;die();
            $is_updated = $this->mDb->query($sql);
        }
        if ($temp['question_type'] == 'article') {
            $this->addAnswersAttachments($student_tests_answers_details_id, $temp['answer_attachments']);
        }
        $up = $this->UpdateTotalAnsweredQuestionsCount($temp['student_tests_answers_id']);       
        return $student_tests_answers_details_id;
    }

    /******************************************************************* */


    function UpdateTotalAnsweredQuestionsCount($student_tests_answers_id)
    {
        $test_id = $this->getTestIDByStudent_tests_answers_id($student_tests_answers_id);
        $countOfQustionsOfTest = $this->getCountOfQustionsOfTest($test_id);
        $student_answers = $this->getAllStudent_tests_answers_details($student_tests_answers_id); // get data about answer's student from student_tests_answers_details table
        $count_of_answers = count($student_answers); // number of answers of student
        $total_answered_questions_count = $countOfQustionsOfTest < $count_of_answers ? $countOfQustionsOfTest : $count_of_answers;  
        $sql = "UPDATE `student_tests_answers` SET ";
        $sql .= " `total_question_count` = '{$countOfQustionsOfTest}'  ";
        $sql .= ", `total_answered_questions_count` = '{$total_answered_questions_count}'  ";
        $sql .= " WHERE `id`={$student_tests_answers_id}";
        // echo $sql;die();
        $res = $this->mDb->query($sql);
    }

    function deleteQuestionAnswer($temp)
    {
        $sql = "DELETE  from `student_tests_answers_details` WHERE `student_tests_answers_id`='{$temp['student_tests_answers_id']}'  &&  `question_id`='{$temp['question_id']}' ";
        // p($sql);
        return $this->mDb->query($sql);
    }

    function getAllStudent_tests_answers_details($student_tests_answers_id)
    {
        $sql = "SELECT staw.`question_id`,staw.`student_answer_details` ,staw.`question_type` ,staw.`answer_degree`, sta.`test_id` FROM `student_tests_answers_details`  staw ";
        $sql .= " LEFT JOIN `student_tests_answers` sta ON sta.`id` = staw.`student_tests_answers_id` ";
        $sql .= " WHERE staw.`student_tests_answers_id` ='{$student_tests_answers_id}'";
            // echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    //////////////////////////////////////////// `test_question_attachments`////////////////////////////////////////////
    function deleteAnswersAttachments($student_tests_answers_details_id)
    {
        $sql = "DELETE  from `student_tests_answers_details_attachments` WHERE `student_tests_answers_details_id`='{$student_tests_answers_details_id}'";
        $this->mDb->query($sql);
    }

    function addAnswersAttachments($student_tests_answers_details_id, $attachments)
    {

        $this->deleteAnswersAttachments($student_tests_answers_details_id);

        for ($i = 0; $i < count($attachments); $i++) {
            # code...
            $attachments[$i]['file'] = str_replace("'", "\'", $attachments[$i]['file']);

            $sql = "INSERT INTO `student_tests_answers_details_attachments` SET ";
            $sql .= " `student_tests_answers_details_id` = '{$student_tests_answers_details_id}'  ";
            $sql .= ", `file` = '{$attachments[$i]['file']}'  ";
            $sql .= ", `attachment_type` = '{$attachments[$i]['attachment_type']}' ";
            // echo $sql;
            // die();
            $this->mDb->query($sql);
        }
    }

    function getAnswersAttachments($student_tests_answers_details_id)
    {
        $sql = "SELECT `file`,`attachment_type` , `id`  FROM `student_tests_answers_details_attachments` ";
        $sql .= " WHERE  `student_tests_answers_details_id` = '{$student_tests_answers_details_id}' ";
        // echo  $sql;
        $res = $this->mDb->getAll($sql);
        $res = getFileSizeArr($res, 'answers_attachments');
        return $res;
    }


    ////////////////////////////////////////////////////// BANK ////////////////////////////////////////////////////////


    function checkIFQustionCodeRelatedToQustionBank($question_id, $subject_id)
    {

        $sql = "SELECT tq.id FROM `questions_bank_questions` tq ";
        $sql .= " LEFT JOIN `questions_bank` f  ON (f.id = tq.questions_bank_id) ";
        $sql .= " Where tq.id = '{$question_id}' and f.is_deleted !='1' and f.subject_id ='{$subject_id}' ";
        // die($sql);
        return $this->mDb->getOne($sql);
    }

    function getAllQ_BankByParams($temp)
    {

        $sql = "SELECT f.name , f.id   FROM `questions_bank` f ";
        $sql .= "where f.`status` ='1'  AND  f.is_deleted !='1' AND f.`subject_id` ='{$temp['subject_id']}'    ";
        $sql .= $temp['branch_id'] ? "AND `branch_id` = '{$temp['branch_id']}' ":"";
        $sql .= $temp['searchKey'] ? ' AND (f.name like "%' . $temp['searchKey'] . '%"  ) ' : '';
        $sql .= $temp['subject_branch_id'] && $temp['subject_branch_id'] != 'null' ? " AND branch_id = '{$temp['subject_branch_id']}'" : "";
        $sql .= $temp['semester'] ? "  AND ( f.`semester` = '{$temp['semester']}' ||  f.`semester` = 'both' ) " : ' ';


        $sql .= "  order by f.`sort` asc ";
        //  echo $sql;die();
        return $this->mDb->getAll($sql);
    }


    function getAllQ_BankQuestionsByParams($temp)
    {
        $table = $this->questions_table[$this->getGradeIdOfTest($temp['test_id'])];
        $sql = "SELECT  tq.answer_form, tq.answer_form_origin, tq.questions_bank_id , tq.id ,  tq.title ,  tq.type  ,  tq.note , tq.source ,tq.degree , f.name , tq.math_type_view_title , tq.math_type_view_note FROM `questions_bank_questions` tq ";
        $sql .= " LEFT JOIN `questions_bank` f  ON (f.id = tq.questions_bank_id) ";
        $sql .= " LEFT JOIN `subjects` s  ON (s.id = f.subject_id) ";
        $sql .= " Where  tq.`parent_id` = '0' AND f.`status` ='1'  AND  f.is_deleted !='1'   ";
        $sql .= $temp['subject_id'] ? "  AND  f.subject_id  ='{$temp['subject_id']}'  " : '';
        $sql .= $temp['test_id'] ? " AND tq.id NOT IN (SELECT refrence_id FROM `".$table."_test_questions` WHERE test_id = '{$temp['test_id']}') " : " ";

        $sql .= $temp['bank_id'] ? "  AND tq.questions_bank_id ='{$temp['bank_id']}'  " : '';
        $sql .= $temp['searchKey'] ? ' AND (tq.title like "%' . $temp['searchKey'] . '%"  ) ' : '';
        $sql .= " group by tq.id  order by tq.questions_bank_id asc ,   tq.id asc  ";
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewBank_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }

            $res[$i]['question_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'note');

            if (
                $res[$i]['type'] == 'choose' ||
                $res[$i]['type'] == 'check'
            ) {
                $res[$i]['test_question_options'] = $this->getBankQuestionOptions($res[$i]['id']);
            } else if ($res[$i]['type'] == 'paragraphs') {

                $res[$i]['test_questions_paragraphs'] = $this->getBankQuestion($res[$i]['questions_bank_id'], $res[$i]['id']);

                for ($k = 0; $k < count($res[$i]['test_questions_paragraphs']); $k++) {
                    if (
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'choose' ||
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'check'
                    ) {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_options'] = $this->getBankQuestionOptions($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'match_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_match_options'] = $this->getQuestionBankMatch_it($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'sort_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_sort_words'] = $this->getQuestionBankSort_it($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if (
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it' || $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_manual_correct'
                        || $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_auto_correct'
                    ) {

                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = $this->getBankQuestion($res[$i]['test_questions_paragraphs'][$k]['questions_bank_id'], $res[$i]['test_questions_paragraphs'][$k]['id']);
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = [];
                        for ($a = 0; $a < count($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']); $a++) {
                            $array2 = $this->getQuestionBankComplete_words($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['id']);
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['test_questions_complete_it_words'] = $array2;
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'], $array2);
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title_show'] = $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title'];
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['math_type_show_title'] = renderMathType($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title_show']);
                            
                        }
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']);
                    }
                }
            } else if ($res[$i]['type'] == 'match_it') {
                $res[$i]['test_question_match_options'] = $this->getQuestionBankMatch_it($res[$i]['id']);
            } else if ($res[$i]['type'] == 'sort_it') {
                $res[$i]['test_question_sort_words'] = $this->getQuestionBankSort_it($res[$i]['id']);
            } else if (
                $res[$i]['type'] == 'complete_it' || $res[$i]['type'] == 'complete_it_writing_manual_correct'
                || $res[$i]['type'] == 'complete_it_writing_auto_correct'
            ) {

                $res[$i]['test_questions_complete_it_sub'] = $this->getBankQuestion($res[$i]['questions_bank_id'], $res[$i]['id']);
                $res[$i]['test_questions_complete_it_words'] = [];
                for ($k = 0; $k < count($res[$i]['test_questions_complete_it_sub']); $k++) {
                    $array2 = $this->getQuestionBankComplete_words($res[$i]['test_questions_complete_it_sub'][$k]['id']);
                    $res[$i]['test_questions_complete_it_sub'][$k]['test_questions_complete_it_words'] = $array2;
                    $res[$i]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_complete_it_words'], $array2);
                    $res[$i]['test_questions_complete_it_sub'][$k]['title_show'] = $res[$i]['test_questions_complete_it_sub'][$k]['title'];
                    $res[$i]['test_questions_complete_it_sub'][$k]['math_type_show_title'] = renderMathType($res[$i]['test_questions_complete_it_sub'][$k]['title_show']);
                    
                }
                $res[$i]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_complete_it_sub']);
            }

            if ($res[$i]['name'] != $res[$i - 1]['name']) { //VIP
                $first_question_id = $this->getQuesionIsFistOnTest($res[$i]['questions_bank_id']);
                if ($first_question_id == $res[$i]['id']) {
                    $res[$i]['show_name'] = true;
                }
            }
        }
        return $res;
    }

    function getQuesionIsFistOnTest($questions_bank_id)
    {
        $sql = "SELECT tq.id FROM `questions_bank_questions` tq where tq.questions_bank_id = '{$questions_bank_id}' LIMIT 1 ";
        $res = $this->mDb->getAll($sql);
        return $res[0]['id'];
    }


    function updateMathViewBank_question_sort_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `questions_bank_sort_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewBank_question_complete_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `questions_bank_complete_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewBank_question_test_match_itemsTitle($id, $math_type_view_title1, $math_type_view_title2)
    {
        if ($id) {
            $sql = "UPDATE `questions_bank_match_items` set math_type_view_title1 = '{$math_type_view_title1}' ,  math_type_view_title2 = '{$math_type_view_title2}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewBank_question_OptionTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `questions_bank_options` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewBank_questionsTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `questions_bank_questions` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewBank_questionsNote($id, $math_type_view_note)
    {


        if ($id) {
            $sql = "UPDATE `questions_bank_questions` set math_type_view_note = '{$math_type_view_note}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getBankQuestionOptions($question_id)
    {

        $sql = "SELECT  `id`, `title`  ,`status`  , math_type_view_title  ";
        $sql .= " FROM `questions_bank_options`  ";
        $sql .= " WHERE  `question_bank_id` ='{$question_id}' ";
        //  echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_question_OptionTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            $res[$i]['option_attachments'] = $this->getBankQuestionAttachments($question_id, $res[$i]['id'], 'option');
        }

        return $res;
    }

    function getBankQuestion($test_id, $parent_id)
    {
        //   echo $test_id;die();
        $sql = "SELECT pl.* FROM `questions_bank_questions` pl";
        $sql .= " WHERE pl.`questions_bank_id` = '{$test_id}'";
        $sql .= " AND pl.`parent_id` = '{$parent_id}'";
        $sql .= " ORDER BY pl.`id` ASC";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);

                $this->updateMathViewBank_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }


            $res[$i]['question_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'note');
        }
        return $res;
    }

    function getBankQuestionAttachments($question_id, $option_id, $related_to)
    {
        $sql = "SELECT `file`,`attachment_type` , `id`  FROM `questions_bank_attachments` ";
        $sql .= " WHERE  `question_bank_id` = '{$question_id}' AND `related_to` = '{$related_to}' ";
        $sql .= $option_id ? " AND `option_id` = '{$option_id}'   " : " ";
        $res = $this->mDb->getAll($sql);
        $res = getFileSizeArr($res, 'questions_bank_attachments');
        return $res;
    }

    function getQuestionBankData($question_id)
    {
        $sql = "SELECT pl.* FROM `questions_bank_questions` pl";
        $sql .= " WHERE pl.`id` = '{$question_id}'";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            if (!$res['math_type_view_title']) {
                $res['math_type_view_title'] = renderMathType($res['title']);

                $this->updateMathViewBank_questionsTitle($res['id'], $res['math_type_view_title']);
            }
            if ($res['math_type_view_note']) {
                $res['math_type_view_note'] = renderMathType($res['note']);
                $this->updateMathViewBank_questionsNote($res['id'], $res['math_type_view_note']);
            }

            $res['question_attachments'] = $this->getBankQuestionAttachments($res['id'], '', 'question');
            $res['note_attachments'] = $this->getBankQuestionAttachments($res['id'], '', 'note');
        }
        return $res;
    }

    function getQuestionBankComplete_words($question_id)
    {
        //   echo "TEST";die();
        $sql = "SELECT  `id`, `title` ,math_type_view_title ,question_id  , word_index ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions  ? " ,`status`  , `note`  " :  '';
        $sql .= " FROM `questions_bank_complete_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql . " ORDER BY word_index asc ";
        $res = $this->mDb->getAll($sql);

        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_question_complete_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function getQuestionBankSort_it($question_id)
    {
        $sql = "SELECT  `id`, `title` ,`math_type_view_title`,question_id  , word_index ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions  ? " ,`status`  , `note`  " :  '';
        $sql .= " FROM `questions_bank_sort_words`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql .= "  ORDER BY word_index asc  ";
        $res = $this->mDb->getAll($sql);

        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_question_sort_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }

        return $res;
    }

    function getQuestionBankMatch_it($question_id)
    {


        $sql = "SELECT `id` ,question_id,  title1, title2 ,  math_type_view_title1, math_type_view_title2 , righte_index2 ,righte_index1  , image1, image2";
        $sql .= " FROM `questions_bank_match_items`  ";
        $sql .= " WHERE  `question_id` ='{$question_id}' ";
        $sql .= " ORDER BY righte_index2 asc  ";
        // p($sql);
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title1'] || !$res[$i]['math_type_view_title2']) {
                $res[$i]['math_type_view_title1'] = renderMathType($res[$i]['title1']);
                $res[$i]['math_type_view_title2'] = renderMathType($res[$i]['title2']);
                $this->updateMathViewBank_question_test_match_itemsTitle($res[$i]['id'], $res[$i]['math_type_view_title1'], $res[$i]['math_type_view_title2']);
            }
        }


        return $res;
    }


    ////////////////////////// share tests
    function addShareTest($temp)
    {
        //  die($this->dateTime);

        $temp['message'] = str_replace("'", "\'", $temp['message']);

        $sql = "INSERT INTO `tests_shares`  SET ";
        $sql .= "`message`='{$temp['message']}' ";
        $sql .= " , `test_id`='{$temp['test_id']}'   ";
        $sql .= " , `teacher_id`='{$temp['teacher_id']}'   ";
        $sql .= " , `target`='{$temp['target']}'  ";
        $sql .= " ,  `show_result_to_student`='{$temp['show_result_to_student']}'  ";
        $sql .= $temp['test_duration'] ? ", `test_duration`='{$temp['test_duration']}' " : ' ';
        $sql .= $temp['scheduled_date'] ? " , `scheduled_date`='{$temp['scheduled_date']}'  " : ' ';
        $sql .= $temp['scheduled_test'] ? ", `scheduled_test`='{$temp['scheduled_test']}'  " : ' ';
        $sql .= $temp['random_order'] ? ", `random_order`='{$temp['random_order']}'  " : '';
        $sql .= $temp['share_classification'] ? ", `share_classification`='{$temp['share_classification']}'  " : ' ';
        $sql .= $temp['code'] ? ", `code`='{$temp['code']}' " : ' ';

        $sql .= " , `date_added`  = '{$this->dateTime}' ";

        // echo $sql;die();
        return $this->mDb->queryReturnLastId($sql);
    }

    function insertTestShareStudent($tests_share_id, $student_id)
    {
        $sql = "INSERT `tests_shares_students` SET ";
        $sql .= " `student_id`  = '{$student_id}' , ";
        $sql .= " `tests_share_id`  = '{$tests_share_id}'  ";
        return $this->mDb->queryReturnLastId($sql);
    }

    function insertTestShareGroup($tests_share_id, $group_id)
    {
        $sql = "INSERT `tests_shares_groups` SET ";
        $sql .= " `group_id`  = '{$group_id}' , ";
        $sql .= " `tests_share_id`  = '{$tests_share_id}' ";
        return $this->mDb->queryReturnLastId($sql);
    }

    function addShareTestPostRelation($temp)
    {
        $sql = "INSERT INTO `group_shared_test_post_relations`  SET ";
        $sql .= "`post_id`='{$temp['post_id']}'  ";
        $sql .= ",`test_id`='{$temp['test_id']}'   ";
        $sql .= ",`group_id`='{$temp['group_id']}'   ";
        $sql .= ",`share_id`='{$temp['share_id']}' ";
        // echo $sql;
        return $this->mDb->queryReturnLastId($sql);
    }

    function getTests_sharesDataTable($share_id, $test_duration = false)
    {
        $sql = "SELECT ts.* From tests_shares ts  ";
        $sql .= " WHERE   ts.id ='{$share_id}'   ";
        $sql .= $test_duration ? " AND ts.test_duration IS NOT NULL " : " ";
        // echo $sql;
        // die();
        return $this->mDb->getRow($sql);
    }

    function detectIFStudentCanShowResult($student_tests_answers_id)
    {
        $someData = $this->getSomeDataByStudent_tests_answers_id($student_tests_answers_id);
        // $share_data = $this->getTests_sharesDataTable($someData['share_id']);

        if (!$someData['share_id']) {
            return true;
        } else if ($share_data['show_result_to_student'] == '1' && $someData['share_id']) {
            return true;
        }else if($someData['show_result_to_student']){
            return true;
        }
    }
    
    
    function editShareTest($temp)
    {
        // $temp['students_id'] = json_decode($temp['students_id']);
        $ids = "(" . implode(",",$temp['students_id']) . ")";
        // $sql = "UPDATE `share_tests` SET show_result_to_student = '1' WHERE `id` IN  '{$share_id}'";
        // return $this->mDb->query($sql);
        
        $sql = "UPDATE `student_tests_answers` SET ";
        $sql .= " `show_result_to_student` = '1' ";
        $sql .= " WHERE `user_id`  IN " . $ids ;
        $sql .= " AND `test_id`  = '{$temp['test_id']}' ";
        $sql .= " AND `share_id`  = '{$temp['share_id']}' ";
        // echo $sql; die();
        return $this->mDb->query($sql);
        
    }


    function getSharedTestDetails($share_id = '', $test_id = '')
    {
        $sql = "SELECT  ts.test_duration , ts.scheduled_test , ts.scheduled_date , te.id ,te.date_added  ,te.type , te.name, te.description  , ";
        $sql .= " sl.`name` as 'stage_name',";
        $sql .= " gl.`name` as 'grade_name' , ";
        $sql .= " u.`name` as 'unit_name' , ";
        $sql .= " l.`name` as 'lesson_name' , ";
        $sql .= " s.`name` as 'subject_name' , s.subject_direction From tests_shares ts ";
        $sql .= " LEFT JOIN `tests` te ON  ( te.`id` = ts.`test_id`)";

        $sql .= " LEFT JOIN `subjects` s ON  ( te.`subject_id` = s.`id`)";
        $sql .= " LEFT JOIN `grades_langs` gl ON  ( te.`grade_id` = gl.`grade_id` AND gl.`lang_code` = '" . LANGUAGE . "')";
        $sql .= " LEFT JOIN `units` u ON  ( te.`unit_id` = u.`id`) ";
        $sql .= " LEFT JOIN `unit_lessons` l ON  ( te.`lesson_id` = l.`id` )";
        $sql .= " LEFT JOIN `stages_langs` sl ON  ( te.`stage_id` = sl.`stage_id` AND sl.`lang_code` = '" . LANGUAGE . "') ";
        $sql .= " WHERE   te.status ='1'  AND te.is_deleted !='1' ";
        $sql .= $share_id ? "AND ts.id ='{$share_id}' " : " ";
        $sql .= $test_id ? "AND ts.test_id ='{$test_id}' " : " ";
        // echo  $sql ;die();
        $res = $this->mDb->getRow($sql);
        $res['test_question_count'] = $this->getCountOfQustionsOfTest($res['id']);


        return $res['id'] ? $res : false;
    }

    function getShare_idByPost_id($post_id)
    {
        $sql = "SELECT share_id FROM `group_shared_test_post_relations` ";
        $sql .= " WHERE  `post_id` = '{$post_id}'   ";
        return $this->mDb->getOne($sql);
    }

    function getPost_idByShare_id($share_id)
    {
        $sql = "SELECT post_id  FROM `group_shared_test_post_relations` ";
        $sql .= " WHERE  `share_id` = '{$share_id}'   ";
        return $this->mDb->getOne($sql);
    }

    function getSharedData($share_id, $teacher_id)
    {
        $sql = "SELECT * FROM `tests_shares` ";
        $sql .= " WHERE  `id` = '{$share_id}' AND teacher_id = '{$teacher_id}' ";
        // echo $sql;die();
        $res = $this->mDb->getRow($sql);
        if ($res['target'] == 'groups') {
            $res['groups'] = $this->getAllGroupsOnShare($share_id);
        } else if ($res['target'] == 'students') {
            $res['students'] = $this->getAllStudentsOnShare($share_id);
        }
        return $res;
    }

    function getAllGroupsOnShare($share_id)
    {
        $sql = "SELECT * FROM `tests_shares_groups` ";
        $sql .= " WHERE  `tests_share_id` = '{$share_id}'";
        return $this->mDb->getAll($sql);
    }

    function getAllStudentsOnShare($share_id)
    {
        $sql = "SELECT * FROM `tests_shares_students` ";
        $sql .= " WHERE  `tests_share_id` = '{$share_id}'";
        return $this->mDb->getAll($sql);
    }

    function getSharing_tests($temp)
    {
        if ($temp['user_type'] == 'student') {
            $sql = "SELECT group_id from `group_members` where student_id = '{$temp['user_id']}' ";
            //   echo $sql;die();
            $ids = implode(',', array_column($this->mDb->getAll($sql), 'group_id'));
            //   print_r($ids);die();
        }
        global $USER_DATA;
        $sql = "SELECT  ts.test_id , ts.id as share_id  , ts.message , ts.target , ts.date_added  , gs.post_id , gs.post_id  FROM `tests_shares` ts ";
        $sql .= " LEFT JOIN `group_shared_test_post_relations` gs  ON (ts.id = gs.share_id) ";
        $sql .= " LEFT JOIN `tests` t  ON (t.id = ts.test_id ) ";
        $sql .= $temp['user_type'] == 'student' ? " LEFT JOIN `tests_shares_students` tss  ON ( ts.id = tss.tests_share_id ) 
    LEFT JOIN `tests_shares_groups` tsg  ON ( ts.id = tsg.tests_share_id )" : " ";
        $sql .= " WHERE ts.id > '0' && t.is_deleted !='1'  ";
        $sql .= $temp['user_type'] == 'teacher' ? "  AND ts.teacher_id  = '{$temp['user_id']}' " : " ";
        $sql .= $temp['user_type'] == 'student' ? "  AND (tss.student_id  = '{$temp['user_id']}' OR tsg.group_id  IN (" . $ids . "))  AND (ts.scheduled_is_send  = '1' || scheduled_test = '0' ) " : " ";
        $sql .= " order by ts.id desc    ";

        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : ' ';
        // echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['shared_test_details'] = $this->getSharedTestDetails($res[$i]['share_id']);

            if ($USER_DATA['user_type'] == 'student') {
                $res[$i]['finished_before'] = $this->checkStudentHaveTestCompleted($USER_DATA['id'], $res[$i]['test_id'], $res[$i]['share_id']);
            }
        }
        return $res;
    }

    function cheackScanShareTest($temp)
    {
        $sql = "SELECT `message` , `id` as share_id ,test_id , `date_added`  
        FROM `tests_shares` ";
        $sql .= " WHERE `scan_finished` = '0'  AND  `test_id` = '{$temp['test_id']}'  AND share_classification ='scan'  ";
        // echo  $sql;die();
        return $this->mDb->getRow($sql);
    }

    function stopScanShareTest($test_id, $share_id)
    {
        $sql = "UPDATE `tests_shares` set scan_finished = '1' WHERE `test_id`='{$test_id}' AND `id`='{$share_id}' ";
        return $this->mDb->query($sql);
    }


    function validateQuestionAddCustomnTest($question)
    {
        //   echo count($question['test_questions_paragraphs']);die();
        if (
            // !$question['title']
            !$question['type']
            || ($question['degree'] <= 0 &&
                ($question['type'] == 'choose' || $question['type'] == 'check' || $question['type'] == 'article' || $question['type'] == 'sort_it' || $question['type'] == 'match_it'))
            || ($question['type'] == 'choose' && count($question['test_question_options']) < 2)
            || ($question['type'] == 'sort_it' && count($question['test_question_sort_words']) < 2)
            || ($question['type'] == 'match_it' && count($question['test_question_match_options']) < 2)
            || ($question['type'] == 'complete_it' && !count($question['test_questions_complete_it_sub']))
            || ($question['type'] == 'complete_it_writing_manual_correct' && !count($question['test_questions_complete_it_sub']))
            || ($question['type'] == 'complete_it_writing_auto_correct' && !count($question['test_questions_complete_it_sub']))
            || ($question['type'] == 'paragraphs' && !count($question['test_questions_paragraphs']))
        ) {
            // echo "TEST";die();
            $error = true;
        }
        // die('sdnfjd');
        if ($question['type'] == 'choose') {
            for ($i = 0; $i < count($question['test_question_options']); $i++) {
                if (
                (!trim($question['test_question_options'][$i]['title']) && !count($question['test_question_options'][$i]['option_attachments']))
                ) {
                    $error = true;
                }
            }
        } else if ($question['type'] == 'sort_it') {
            for ($i = 0; $i < count($question['test_question_sort_words']); $i++) {
                if (
                (!trim($question['test_question_sort_words'][$i]['title']) || !$question['test_question_sort_words'][$i]['word_index'])
                ) {
                    
                    $error = true;
                }
            }
        } else if ($question['type'] == 'match_it') {
            for ($i = 0; $i < count($question['test_question_match_options']); $i++) {
                if (
                (!trim($question['test_question_match_options'][$i]['title2']) && !$question['test_question_match_options'][$i]['image2'])
                ) {
                    $error = true;
                }
            }
        } else if (
            $question['type'] == 'complete_it' ||
            $question['type'] == 'complete_it_writing_manual_correct' ||
            $question['type'] == 'complete_it_writing_auto_correct'
        ) {
            // ech
            for ($i = 0; $i < count($question['test_questions_complete_it_sub']); $i++) {
                if (
                ($question['test_questions_complete_it_sub'][$i]['degree'] <= 0 || !trim($question['test_questions_complete_it_sub'][$i]['title']))
                ) {
                    // p(!trim($question['test_question_match_options'][$i]['title']));
                    // die('asjdhjkh');
                    $error = true;
                }
                for ($j = 0; $j < count($question['test_questions_complete_it_sub'][$i]['test_questions_complete_it_words']); $j++) {
                    // $question['test_questions_complete_it_sub'][$i]['test_questions_complete_it_words'][$j]['word_index'] = $j + 1;
                    if (
                    (!trim($question['test_questions_complete_it_sub'][$i]['test_questions_complete_it_words'][$j]['title']))
                    ) {
                        $error = true;
                    }
                }
            }
        } else if ($question['type'] == 'paragraphs') {
            for ($i = 0; $i < count($question['test_questions_paragraphs']); $i++) {
                $result = $this->validateQuestionAddCustomnTest($question['test_questions_paragraphs'][$i]);
                if ($result['error']) {
                    $ret['error'] = true;
                    return $ret;
                }
                // $error = $result['error'];
                // print_r ($error);die();
            }
        }
        // p($error);
        // echo $error;die();
        $ret['error'] = $error;
        $ret['question'] = $question;
        // print_r($ret['error']);die();

        return $ret;
    }

    function updateMathViewImportant_article_questionsTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `important_article_questions` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewImportant_article_questionsAnswer($id, $math_type_view_answer)
    {

        if ($id) {
            $sql = "UPDATE `important_article_questions` set math_type_view_answer = '{$math_type_view_answer}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function getAllimportantArticleQuestions($temp, $user_id)
    {
        // $text =  '<p style="text-align:right;"><strong>يتحرك جسم بعجلة منتظمة طبقاً للعلاقة&nbsp;&nbsp;احسب سرعته بعد&nbsp;</strong><math xmlns="http://www.w3.org/1998/Math/MathML"><mstyle mathsize="14px"><mn mathvariant="bold">2</mn><mi mathvariant="bold">s</mi></mstyle></math><strong>&nbsp;من بداية الحركة.</strong></p>';
        // $math_type_view_title = renderMathType($text);
        // p($math_type_view_title);
        // print_r($temp);die();
        $sql = "SELECT c.id as category_id, cl.title as category_name, ia.id , ia.title , ia.answer ,ia.source , ia.math_type_view_title , ia.math_type_view_answer ";
        $sql .= " FROM `important_article_questions` ia";
        $sql .= " LEFT JOIN `categories` c ON c.id = ia.category_id";
        $sql .= " LEFT JOIN `categories_langs` cl ON c.id = cl.category_id AND lang_code = '" . LANGUAGE ."'";
        $sql .= " WHERE ia.status  = '1'  AND ia.subject_id ='{$temp['subject_id']}'  ";
        $sql .= $temp['subject_branch_id'] ? " AND ia.branch_id ='{$temp['subject_branch_id']}'  ":"";
        // $sql .= $temp['category_id'] ? "  AND ia.category_id  = '{$temp['category_id']}' " : " ";
        $sql .= $temp['semester'] ? "  AND ( ia.`semester` = '{$temp['semester']}' ||  ia.`semester` = 'both' ) " : ' ';


        $sql .= " group by ia.id  ";
        $sql .= $temp['sort_by'] ? " order by ia.{$temp['sort_by']} {$temp['sort_type']} " : ' ';
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';

        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
$data=[];
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewImportant_article_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if (!$res[$i]['math_type_view_answer']) {
                $res[$i]['math_type_view_answer'] = renderMathType($res[$i]['answer']);
                $this->updateMathViewImportant_article_questionsAnswer($res[$i]['id'], $res[$i]['math_type_view_answer']);
            }
            $res[$i]['is_favourite'] = $this->cheackFavoriteImportantArticleQuestions($res[$i]['id'], $user_id);
            $res[$i]['question_attachments'] = $this->getImportantArticleQuestionsAttachments($res[$i]['id'], 'question');
            $res[$i]['answer_attachments'] = $this->getImportantArticleQuestionsAttachments($res[$i]['id'], 'answer');
            $data[$res[$i]['category_id']]['name'] = $res[$i]['category_name'];
            $data[$res[$i]['category_id']]['questions'][] = $res[$i];
        }

        return $data;
    }

    function getImportantArticleQuestionsAttachments($question_id, $related_to)
    {
        $sql = "SELECT `file`,`attachment_type`, `id`  FROM `important_article_questions_attachments` ";
        $sql .= " WHERE  `question_id` = '{$question_id}' AND `related_to` = '{$related_to}' ";
        // p( $sql);
        $res = $this->mDb->getAll($sql);
        $res = getFileSizeArr($res, 'important_article_questions_attachments');
        return $res;
    }

    function updateMathViewExamine_question_sort_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `examine_question_sort_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewExamine_question_complete_wordsTitle($id, $math_type_view_title)
    {
        if ($id) {
            $sql = "UPDATE `examine_question_complete_words` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewExamine_question_test_match_itemsTitle($id, $math_type_view_title1, $math_type_view_title2)
    {
        if ($id) {
            $sql = "UPDATE `examine_question_match_items` set math_type_view_title1 = '{$math_type_view_title1}' ,  math_type_view_title2 = '{$math_type_view_title2}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewExamine_question_OptionTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `examine_question_options` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewExamine_questionsTitle($id, $math_type_view_title)
    {

        if ($id) {
            $sql = "UPDATE `examine_questions` set math_type_view_title = '{$math_type_view_title}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

    function updateMathViewExamine_questionsNote($id, $math_type_view_note)
    {

        if ($id) {
            $sql = "UPDATE `examine_questions` set math_type_view_note = '{$math_type_view_note}' WHERE `id`='{$id}' ";
            $this->mDb->query($sql);
        }
    }

function getAllimportantArticleQuestionsCount($temp, $user_id)
    {
        $sql = "SELECT COUNT(ia.id) ";
        $sql .= " FROM `important_article_questions` ia";
        $sql .= " WHERE ia.status  = '1'  AND ia.subject_id ='{$temp['subject_id']}'  ";
        $sql .= $temp['subject_branch_id'] ? " AND ia.branch_id ='{$temp['subject_branch_id']}'  ":"";
        $sql .= $temp['semester'] ? "  AND ( ia.`semester` = '{$temp['semester']}' ||  ia.`semester` = 'both' ) " : ' ';


        // echo $sql;die();
        return $this->mDb->getOne($sql);
        
}

function getAllExamineQuestionsCount($temp, $user_id)
    {
        global $USER_DATA;
        // print_r($temp);die();
        $sql = "SELECT COUNT(tq.id) FROM `examine_questions` tq ";
        $sql .= " Where tq.subject_id = '{$temp['subject_id']}' AND tq.`status` = '1' ";
        $sql .= $temp['subject_branch_id'] ? " AND tq.branch_id = '{$temp['subject_branch_id']}'":"";
        $sql .= $temp['searchKey'] ? ' AND (tq.title like "%' . $temp['searchKey'] . '%" ) ' : '';

        $sql .= $temp['semester'] ? "  AND ( tq.`semester` = '{$temp['semester']}' ||  tq.`semester` = 'both' ) " : ' ';

        $sql .= " order by tq.sort asc , tq.id asc ";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }
    
    
    
    function getAllExamineQuestions($temp, $user_id)
    {
        global $USER_DATA;
        // print_r($temp);die();
        $sql = "SELECT c.id as category_id, cl.title as category_name, tq.id , tq.title , tq.type , tq.note , tq.source ,tq.degree , tq.math_type_view_title , tq.math_type_view_note FROM `examine_questions` tq ";
        $sql .= " LEFT JOIN categories c ON c.id = tq.category_id ";
        $sql .= " LEFT JOIN categories_langs cl ON c.id = cl.category_id AND lang_code = '" . LANGUAGE . "'";
        $sql .= " Where tq.`parent_id` = '0' AND tq.subject_id = '{$temp['subject_id']}' AND tq.`status` = '1' ";
        $sql .= $temp['subject_branch_id'] ? " AND tq.branch_id = '{$temp['subject_branch_id']}'":"";
        // $sql .= $temp['category_id'] ? " AND tq.category_id = '{$temp['category_id']}' " : " ";
        $sql .= $temp['searchKey'] ? ' AND (tq.title like "%' . $temp['searchKey'] . '%" ) ' : '';

        $sql .= $temp['semester'] ? "  AND ( tq.`semester` = '{$temp['semester']}' ||  tq.`semester` = 'both' ) " : ' ';

        $sql .= " order by tq.sort asc , tq.id asc ";
        $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $block_index = 0;
        $data = [] ;
        $category_id = $res[0]['category_id'];
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewExamine_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewExamine_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }

            $res[$i]['is_favourite'] = $this->cheackFavoriteExamineQuestions($res[$i]['id'], $user_id);

            $res[$i]['question_attachments'] = $this->getExamineQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getExamineQuestionAttachments($res[$i]['id'], '', 'note');
            $answrd_on_question = $this->checkQuestionExamineAnswer($res[$i]['id'], $USER_DATA['id']);
            $res[$i]['question_answer']['answerd'] = $answrd_on_question ? true : false;

            if (
                $res[$i]['type'] == 'choose' ||
                $res[$i]['type'] == 'check'
            ) {
                $res[$i]['test_question_options'] = $this->getExamineQuestionOptions($res[$i]['id']);
                $res[$i]['count_of_right_options'] = $this->getCountOfCorrectExamineQuestionOptions($res[$i]['id']);
            } else if ($res[$i]['type'] == 'paragraphs') {

                $res[$i]['test_questions_paragraphs'] = $this->getExamineQuestion($res[$i]['id'], $user_id);

                for ($k = 0; $k < count($res[$i]['test_questions_paragraphs']); $k++) {
                    if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'choose' || $res[$i]['test_questions_paragraphs'][$k]['type'] == 'check') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_options'] = $this->getExamineQuestionOptions($res[$i]['test_questions_paragraphs'][$k]['id']);

                        $res[$i]['test_questions_paragraphs'][$k]['count_of_right_options'] = $this->getCountOfCorrectExamineQuestionOptions($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'match_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_match_options'] = $this->getExamineQuestionMatch_it($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'sort_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_sort_words_correct'] = $this->getExamineQuestionSort_it($res[$i]['test_questions_paragraphs'][$k]['id'], true);
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_sort_words'] = $this->getExamineQuestionSort_it($res[$i]['test_questions_paragraphs'][$k]['id'], false);
                    }else if($res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_auto_correct'){
                        
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = $this->getExamineQuestion($res[$i]['id'], $user_id);
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words_correct'] = [];
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = [];
        
                        for ($kk = 0; $kk < count($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']); $kk++) {
                            $array2 = $this->getExamineQuestionComplete_words($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$kk]['id'], true);
                            $res[$i]['test_questions_complete_it_words_correct'] = array_merge($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words_correct'], $array2);
        
                            $array3 = $this->getExamineQuestionComplete_words($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$kk]['id'], false);
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'], $array3);
                        }
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_complete_it_sub']);
                    }
                }
            } else if ($res[$i]['type'] == 'match_it') {
                $res[$i]['test_question_match_options'] = $this->getExamineQuestionMatch_it($res[$i]['id']);
            } else if ($res[$i]['type'] == 'sort_it') {
                $res[$i]['test_question_sort_words'] = $this->getExamineQuestionSort_it($res[$i]['id'], false);
                $res[$i]['test_question_sort_words_correct'] = $this->getExamineQuestionSort_it($res[$i]['id'], true);
            } else if (
                $res[$i]['type'] == 'complete_it'
                // || $res[$i]['type'] == 'complete_it_writing_manual_correct'
                || $res[$i]['type'] == 'complete_it_writing_auto_correct'
            ) {


                $res[$i]['test_questions_complete_it_sub'] = $this->getExamineQuestion($res[$i]['id'], $user_id);

                $res[$i]['test_questions_complete_it_words_correct'] = [];
                $res[$i]['test_questions_complete_it_words'] = [];

                for ($k = 0; $k < count($res[$i]['test_questions_complete_it_sub']); $k++) {
                    $array2 = $this->getExamineQuestionComplete_words($res[$i]['test_questions_complete_it_sub'][$k]['id'], true);
                    $res[$i]['test_questions_complete_it_words_correct'] = array_merge($res[$i]['test_questions_complete_it_words_correct'], $array2);

                    $array3 = $this->getExamineQuestionComplete_words($res[$i]['test_questions_complete_it_sub'][$k]['id'], false);
                    $res[$i]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_complete_it_words'], $array3);
                }
                $res[$i]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_complete_it_sub']);
            }
            
            
            if ($res[$i]['name'] != $res[$i - 1]['name']) { //VIP
                $first_question_id = $this->getQuesionIsFistOnTest($res[$i]['questions_bank_id']);
                if ($first_question_id == $res[$i]['id']) {
                    $res[$i]['show_name'] = true;
                }
            }
            if ($res[$i]['type'] == 'head_question' || $res[$i]['type'] == 'break') { //VIP
                // p($result['test_questions'][$i + 1]['id']);

                if ($res[$i + 1]['id']) {
                    $res[$i + 1]['head_title'] = $res[$i]['type'] == 'head_question' ? $res[$i]['title'] : '';
                    $res[$i + 1]['head_desc'] = $res[$i]['type'] == 'head_question' ? $res[$i]['extra_desc'] : '';
                    $res[$i + 1]['break_title'] = $res[$i]['type'] == 'break' ? $res[$i]['title'] : '';
                }

                unset($res[$i]);
            } else {
                // if($category_id != $res[$i]['category_id']){
                //     $block_index =  0;
                // }
                // $res[$i]['block_index'] = $block_index;
                // $block_index++;
                
                // $category_id = $res[$i]['category_id'];
                
                $res[$i]['block_index'] = count($data[$res[$i]['category_id']]['questions']);
                
            }
            
            $data[$res[$i]['category_id']]['name'] = $res[$i]['category_name'];
            $data[$res[$i]['category_id']]['questions'][] = $res[$i];
            
            
        }
        return $data;
    }

    function getCountOfCorrectExamineQuestionOptions($question_id)
    {
        $sql = "SELECT  count(`id`)   ";
        $sql .= " FROM `examine_question_options` ";
        $sql .= " WHERE `examine_question_id` ='{$question_id}' and `status` = '1' ";
        return $this->mDb->getOne($sql);
    }

    function getExamineQuestionOptions($question_id)
    {

        $sql = "SELECT `id`, `title` ,`status` , math_type_view_title ";
        $sql .= " FROM `examine_question_options` ";
        $sql .= " WHERE `examine_question_id` ='{$question_id}' ";
        // echo $sql;
        // die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewExamine_question_OptionTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }


            $res[$i]['option_attachments'] = $this->getExamineQuestionAttachments($question_id, $res[$i]['id'], 'option');
        }

        return $res;
    }

    function getExamineQuestion($parent_id, $user_id)
    {
        global $USER_DATA;

        $sql = "SELECT pl.* FROM `examine_questions` pl";
        $sql .= " WHERE pl.`parent_id` = '{$parent_id}'";
        $sql .= " ORDER BY pl.`id` ASC";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewExamine_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewExamine_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }

            $res[$i]['is_favourite'] = $this->cheackFavoriteExamineQuestions($res[$i]['id'], $user_id);

            $res[$i]['question_attachments'] = $this->getExamineQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getExamineQuestionAttachments($res[$i]['id'], '', 'note');
            // $res[$i]['question_answer'] =   new stdClass() ;
            $answrd_on_question = $this->checkQuestionExamineAnswer($res[$i]['id'], $USER_DATA['id']);
            $res[$i]['question_answer']['answerd'] = $answrd_on_question ? true : false;
        }
        return $res;
    }

    function getExamineQuestionAttachments($question_id, $option_id, $related_to)
    {
        $sql = "SELECT `file`,`attachment_type`, `id`  FROM `examine_question_attachments` ";
        $sql .= " WHERE `question_id` = '{$question_id}' AND `related_to` = '{$related_to}' ";
        $sql .= $option_id ? " AND `option_id` = '{$option_id}' " : " ";

        $res = $this->mDb->getAll($sql);
        $res = getFileSizeArr($res, 'examine_questions');
        return $res;
    }

    // function getExamineQuestionData($question_id)
    // {
    //   $sql = "SELECT pl.* FROM `examine_questions` pl";
    //   $sql .= " WHERE pl.`id` = '{$question_id}'";
    //   $res = $this->mDb->getRow($sql);
    //   if ($res) {
    //     $res['question_attachments'] = $this->getExamineQuestionAttachments($res['id'], '', 'question');
    //     $res['note_attachments'] = $this->getExamineQuestionAttachments($res['id'], '', 'note');
    //   }
    //   return $res;
    // }
    function getExamineQuestionComplete_words($question_id, $resulte_qustions = true)
    {
        $sql = "SELECT `id`, `title` ,`math_type_view_title` ,question_id , word_index ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions ? " ,`status` , `note` " : '';
        $sql .= " FROM `examine_questions_complete_words` ";
        $sql .= " WHERE `question_id` ='{$question_id}' ";
        $sql .= $resulte_qustions ? " ORDER BY word_index asc   " : "  ORDER BY rand()  ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewExamine_question_complete_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }
        return $res;
    }

    function getExamineQuestionSort_it($question_id, $resulte_qustions = true)
    {
        $sql = "SELECT `id`, `title` ,`math_type_view_title`,question_id , word_index ";
        // $sql .= $USER_DATA['user_type'] == 'teacher' || $resulte_qustions ? " ,`status` , `note` " : '';
        $sql .= " FROM `examine_questions_sort_words` ";
        $sql .= " WHERE `question_id` ='{$question_id}' ";
        $sql .= $resulte_qustions ? " ORDER BY word_index asc " : " ORDER BY id asc ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewExamine_question_sort_wordsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
        }
        return $res;
    }


    function getExamineQuestionMatch_it($question_id)
    {


        $sql = "SELECT `id` ,question_id, title1, title2 , math_type_view_title1 , math_type_view_title2  , righte_index2 ,righte_index1 , image1, image2";
        $sql .= " FROM `examine_questions_match_items` ";
        $sql .= " WHERE `question_id` ='{$question_id}' ";
        $sql .= " ORDER BY righte_index2 asc ";
        // echo($sql);die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            if (!$res[$i]['math_type_view_title1'] || !$res[$i]['math_type_view_title2']) {
                $res[$i]['math_type_view_title1'] = renderMathType($res[$i]['title1']);
                $res[$i]['math_type_view_title2'] = renderMathType($res[$i]['title2']);
                $this->updateMathViewExamine_question_test_match_itemsTitle($res[$i]['id'], $res[$i]['math_type_view_title1'], $res[$i]['math_type_view_title2']);
                
            }
        }
        return $res;
    }

    function checkQuestionExamineAnswer($question_id, $user_id)
    {
        $sql = "SELECT id FROM `examin_question_answers`  WHERE   `question_id` = '{$question_id}' AND user_id='{$user_id}' ";
        return $this->mDb->getOne($sql);
    }

    function setQuestionExamineAnswer($question_id, $user_id)
    {
        $this->deleteQuestionExamineAnswer($question_id, $user_id);
        $sql = "INSERT INTO `examin_question_answers` SET ";
        $sql .= " `question_id` = '{$question_id}',  user_id='{$user_id}'  ";
        return $this->mDb->query($sql);
    }

    function cheackFavoriteImportantArticleQuestions($question_id, $user_id)
    {
        $sql = "SELECT `id` FROM `important_article_questions_favorites`  ";
        $sql .= " where `question_id` = '{$question_id}' and  user_id='{$user_id}'  ";
        return $this->mDb->getOne($sql) ? true : false;
    }

    function toggleFavoriteImportantArticleQuestions($question_id, $user_id)
    {

        $id = $this->cheackFavoriteImportantArticleQuestions($question_id, $user_id);
        // p($id);
        if ($id) {
            $this->deleteFavoriteImportantArticleQuestions($question_id, $user_id);
            return 'remove';
        } else {
            $this->addFavoriteImportantArticleQuestions($question_id, $user_id);
            return 'add';
        }
    }

    function addFavoriteImportantArticleQuestions($question_id, $user_id)
    {
        $sql = "INSERT INTO `important_article_questions_favorites` SET ";
        $sql .= " `question_id` = '{$question_id}',  user_id='{$user_id}'  ";
        return $this->mDb->query($sql);
    }

    function deleteFavoriteImportantArticleQuestions($question_id, $user_id)
    {

        $sql = "DELETE FROM `important_article_questions_favorites` WHERE   `question_id` = '{$question_id}' AND user_id='{$user_id}' ";
        return $this->mDb->query($sql);
    }

    function cheackFavoriteExamineQuestions($question_id, $user_id)
    {
        $sql = "SELECT `id` FROM `examine_questions_favorites`  ";
        $sql .= " where `question_id` = '{$question_id}' and  user_id='{$user_id}'  ";
        return $this->mDb->getOne($sql) ? true : false;
    }

    function toggleFavoriteExamineQuestions($question_id, $user_id)
    {

        $id = $this->cheackFavoriteExamineQuestions($question_id, $user_id);
        // p($id);
        if ($id) {
            $this->deleteFavoriteExamineQuestions($question_id, $user_id);
            return 'remove';
        } else {
            $this->addFavoriteExamineQuestions($question_id, $user_id);
            return 'add';
        }
    }

    function addFavoriteExamineQuestions($question_id, $user_id)
    {
        $sql = "INSERT INTO `examine_questions_favorites` SET ";
        $sql .= " `question_id` = '{$question_id}',  user_id='{$user_id}'  ";
        return $this->mDb->query($sql);
    }

    function deleteFavoriteExamineQuestions($question_id, $user_id)
    {

        $sql = "DELETE FROM `examine_questions_favorites` WHERE   `question_id` = '{$question_id}' AND user_id='{$user_id}' ";
        return $this->mDb->query($sql);
    }


    function deleteQuestionExamineAnswer($question_id, $user_id)
    {
        $id = $this->checkQuestionExamineAnswer($question_id, $user_id);
        if ($id) {
            $sql = "DELETE FROM `examin_question_answers` WHERE   `question_id` = '{$question_id}' AND user_id='{$user_id}' ";
            return $this->mDb->query($sql);
        }
    }

    function getTestIdByGraidId($temp)
    {
        $sql = "SELECT `grade_id` FROM `tests`  ";
        $sql .= " where `id` = '{$temp['test_id']}' AND is_deleted ='0' ";
        return $this->mDb->getOne($sql);
    }

    function getPrintingTestData($test_id)
    {

        $grade_id = $this->getTestIdByGraidId($test_id);
        $sql = "SELECT pdl.name FROM `printable_data` pd  ";
        $sql .= " LEFT JOIN `printable_data_langs` pdl  ON  ( pd.`id` = pdl.`printable_data_id`  AND pdl.`lang_code` = '" . LANGUAGE . "' )";
        $sql .= " where pd.`grade_id` = '{$grade_id}'  AND pd.is_deleted ='0' AND pd.status='1' ";
        //  p($sql) ;
        return $this->mDb->getAll($sql);
    }


    /////////////////////////////// security ///////////////////////////////
    /////////////////////////////// security ///////////////////////////////
    /////////////////////////////// security ///////////////////////////////
    /////////////////////////////// security ///////////////////////////////
    /////////////////////////////// security ///////////////////////////////

    function checkStudentRlatedToThisStudent_tests_answers_id($student_tests_answers_id, $question_id, $student_id)
    {
        $sql = "SELECT  sta.id FROM `student_tests_answers` sta ";
        $sql .= " LEFT JOIN `student_tests_answers_details` stad ON (stad.student_tests_answers_id =sta.id) ";
        $sql .= " WHERE  sta.`id` = '{$student_tests_answers_id}' AND sta.`user_id` = '{$student_id}' ";
        $sql .= $question_id ? "  AND stad.question_id ='{$question_id}'  " : ' ';
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function checkStudentRlatedToTest_id($test_id, $grade_id)
    {
        $sql = "SELECT  `id` from  `tests`  ";
        $sql .= " where `id`= '{$test_id}' AND grade_id = '{$grade_id}' AND `dedicated_to` = 'all'   ";
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function checkTeacherRlatedToTest_id($test_id, $teacher_id)
    {
        $techer_subject = $this->subjectObj->getTeacher_subjects($teacher_id, '', '', '');
        $techer_subject_ids = fetchArrayValue_from_dataBase($techer_subject, 'subject_id');
        // print_r($techer_subject_ids);
        $sql = "SELECT  `id` from  `tests`  ";
        $sql .= " where `id`= '{$test_id}' AND subject_id in ({$techer_subject_ids})    ";
        //  echo $sql;die();
        $res = $this->mDb->getAll($sql);

        return count($res) ? true : false;
    }

    function checkTeacherOwnerForTest_id($test_id, $teacher_id)
    {
        // p($techer_subject_ids);
        $sql = "SELECT  `id` from  `tests`  ";
        $sql .= " where `id`= '{$test_id}' AND teacher_id = '{$teacher_id}'    ";
        //  echo $sql;die();
        return $this->mDb->getOne($sql);
    }


    //////////////////////////////////////////////////////// cron job test

    function updateTestToTransformQuestion($test_id)
    {
        $sql = "UPDATE `tests` SET trasnfrom_math = '1'  where  id ='{$test_id}' ";
        $this->mDb->query($sql);
    }

    function getTestsByParamsTransForm()
    {
        $sql = "SELECT f.id FROM `tests` f ";
        $sql .= "where f.is_deleted !='1' AND  f.trasnfrom_math = '0'  LIMIT  0 , 25  ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $this->updateTestToTransformQuestion($res[$i]['id']);
            $test_arg['id'] = $res[$i]['id'];
            $test_arg['student_tests_answers_id'] = '';
            $test_arg['just_questions'] = false;
            $test_arg['resulte_qustions'] = true;
            $this->getOneTestDetails($test_arg);
        }
        return $res;
    }

    function updateTestToTransformQuestionBank($test_id)
    {
        $sql = "UPDATE `questions_bank` SET trasnfrom_math = '1'  where  id ='{$test_id}' ";
        $this->mDb->query($sql);
    }

    function getTestsByParamsTransFormBank()
    {
        $sql = "SELECT f.id FROM `questions_bank` f ";
        $sql .= "where f.is_deleted !='1' AND  f.trasnfrom_math = '0'  LIMIT  0 , 1  ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $this->updateTestToTransformQuestionBank($res[$i]['id']);
            $ddddd['bank_id'] = $res[$i]['id'];
            $ddddd['start'] = '0';
            $ddddd['itemsPerPage'] = '1000000';
            $this->getAllQ_BankQuestionsByParams($ddddd);
        }
        return $res;
    }
    
    
    function getTestResultsByTestId($test_id){
        
        $sql = "SELECT sta.total_degree, u.full_name FROM `student_tests_answers` sta";
        $sql .= " LEFT JOIN `users` u ON sta.user_id = u.id";
        $sql .= " WHERE sta.test_id = '{$test_id}' AND sta.test_status = 'completed'";
        // echo $sql;die();
        return $this -> mDb -> getAll($sql);
    }
    
    
     function convert_object_to_array($data)
    {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        } else {
            return $data;
        }
    }
   
   
   /*===================================================================*/
   
   
   public function refactoring($temp){
       
      $test_id = $this->insertTestData($temp);
      
    //   echo $test_id ; die();
      if ($test_id) {
          
          foreach($temp['questions'] as $question){
           $questionObj = $this->questionFactory->store($test_id,$question);
            $questionObj->store();   
          }  
        }
           return true;
        
   }
   
   public function getAllQuestionFromAnswers($temp, $ids){
       $sql  = "SELECT stad.question_id, COUNT(*) AS frequency FROM `student_tests_answers_details` stad ";
    $sql .= " LEFT JOIN `student_tests_answers` sta ON (sta.id = stad.student_tests_answers_id) ";
    $sql .= " LEFT JOIN `tests` t ON (sta.test_id  = t.id) ";
    $sql .= " WHERE stad.answer_degree = '0' AND t.subject_id = '{$temp['subject_id']}' AND sta.user_id = '{$temp['student_id']}' AND stad.question_id NOT IN {$ids} ";
    $sql .= "GROUP BY stad.question_id ORDER BY frequency DESC LIMIT 10";
    
    // echo $sql;die();
    return $this->mDb->getAll($sql);
   }
   
   public function filterquestions($temp, $arr){
       $questionOut = [];
       foreach($arr as $question){
        $sqll  = "SELECT stad.id FROM `student_tests_answers_details` stad ";
        $sqll .= " LEFT JOIN `student_tests_answers` sta ON (sta.id = stad.student_tests_answers_id) ";
        $sqll .= " LEFT JOIN `tests` t ON (sta.test_id  = t.id) ";
        $sqll .= " WHERE `question_id` = '{$question['question_id']}' AND stad.answer_degree > 0 AND t.subject_id = '{$temp['subject_id']}' AND sta.user_id = '{$temp['student_id']}'";
        $res = $this->mDb->getRow($sqll);
        if($res){
            $questionOut[] = $question['question_id'];
        }
    }
    // echo $sqll;die();
    return $questionOut;
   }
   public function setExamFromRepeatedwrongs($temp, $ques="(0)"){
       
    $sql = "SELECT stad.question_id, sta.test_id
            FROM `student_tests_answers_details` stad
            LEFT JOIN `student_tests_answers` sta ON (sta.id = stad.student_tests_answers_id)
            LEFT JOIN `tests` t ON (sta.test_id = t.id)
            
            WHERE stad.answer_degree != stad.total_q_degree
              AND t.subject_id = '{$temp['subject_id']}'
              AND sta.user_id = '{$temp['student_id']}'
              AND stad.question_id NOT IN (
              
                SELECT stad_inner.question_id
                FROM `student_tests_answers_details` stad_inner
                LEFT JOIN `student_tests_answers` sta_inner ON (sta_inner.id = stad_inner.student_tests_answers_id)
                LEFT JOIN `tests` t_inner ON (sta_inner.test_id = t_inner.id)
                WHERE `question_id` IN (
                
                  SELECT stad_innermost.question_id
                  FROM `student_tests_answers_details` stad_innermost
                  LEFT JOIN `student_tests_answers` sta_innermost ON (sta_innermost.id = stad_innermost.student_tests_answers_id)
                  LEFT JOIN `tests` t_innermost ON (sta_innermost.test_id = t_innermost.id)
                  WHERE stad_innermost.answer_degree = stad_innermost.total_q_degree
                    AND t_innermost.subject_id = '{$temp['subject_id']}'
                    AND sta_innermost.user_id = '{$temp['student_id']}'
                )
              )
            GROUP BY stad.question_id
            ORDER BY COUNT(*) DESC
            LIMIT 10";
    
    
    // echo $sql;die();
    $questions = $this->mDb->getAll($sql);
    
     $wrong_questions = []; 
     $result = [];
    $parents=[];
    foreach($questions as $question){
        $resQues = $this->getQuestionData($question['question_id'], $question['test_id']);
        
        $wrong_questions[] = $resQues;
    }
    
    
    $customWrongQuestions = $this->customQuestions($wrong_questions, [], "");
    $allParents=[];
    // print_r($customWrongQuestions);die();
    
    foreach($customWrongQuestions['test_questions'] as &$question){
         
        if($question['parent_id'] > 0){
            if(!in_array($question['parent_id'], $allParents)){
                $questionParent = $this->getQuestionData($question['parent_id'], $question['test_id']);
                $allParents[] = $question['parent_id'];
                $tmp = $question;
                $question = $questionParent;
                $question['test_questions_paragraphs'][] = $tmp;
                // $result[] = $question;  
            }else{
                foreach($result as &$item){
                    if($item['id'] == $question['parent_id']){
                        $item['test_questions_paragraphs'][] = $question;
                    }
            }
            continue;
            }
        }
        
        $result[] = $question;
        // if( $question['id'] == '6918256'){
        //     print_r($question);die();
        // }
        
        
    }
    
    
    $test_params['available_to_visitor'] = 0;
    $test_params['description'] = "defualt description";
    $test_params['lesson_id'] = "";
    $test_params['name'] = "default name";
    $test_params['questions'] = $result;
    $test_params['subject_id'] = $temp['subject_id'];
    $test_params['type'] = "general_test";
    $test_params['unit_id'] = "";
    $test_params['classification'] = 'by_teacher_selected_from_ready';
    $test_params['grade_id'] = $temp['student_data']['grade_id'];
    $test_params['stage_id'] = $temp['student_data']['stage_id'];
    $test_params['specialize_id'] = $temp['student_data']['specialize_id'];
    
    $res = $this->addTest($test_params);
    return $res; //count($result);
    
    
   }
   
   
   public function checkArticleQuestionIsCorrected($question_id, $test_id, $student_answer_id){
       
       $sql = "SELECT is_corrected FROM `correcting_article_questions` ";
       $sql .= " WHERE `question_id` = '{$question_id}' AND `test_id` = '{$test_id}' AND `student_answer_id` = '{$student_answer_id}'";
       $res = $this->mDb->getOne($sql);
       if($res){
           return 1;
       }else{
           return 0;
       }
       
   }
   
   public function getTeacherThatAssignedTest($student_answer_id){
       
       $sql = "SELECT id FROM `student_tests_answers_details` ";
       $sql .= "WHERE `student_tests_answers_id` = '{$student_answer_id}' AND (`question_type` = 'article' OR `question_type` = 'complete_it_writing_manual_correct') ";
    //   echo $sql;die();
       $res = $this->mDb->getAll($sql);
    //   echo count($res);die();
       if(count($res) > 0){
           $sql  = "SELECT attt.teacher_id, sta.test_id, sta.id as student_tests_answers_id FROM `assigning_test_to_teacher` attt ";
           $sql .= " LEFT JOIN `student_tests_answers` sta ON (attt.test_id = sta.test_id) ";
           $sql .= " WHERE sta.id = '{$student_answer_id}' AND attt.teacher_id IS NOT NULL ";
           
        //   echo $sql;die();
        return $this->mDb->getAll($sql);
       }
       
       return [];
   }
   
   
  public function getArticleQuestionForCorrecting($temp){
      $table = $this->questions_table[$this->getGradeIdOfTest($temp['test_id'])];
     $sql = "SELECT pl.*, pl.id AS question_id FROM `".$table."_test_questions` pl ";
        $sql .= " LEFT JOIN student_tests_answers_details stad ON stad.question_id = pl.id ";
        $sql .= " WHERE pl.`test_id` = '{$temp['test_id']}' AND stad.`student_tests_answers_id` = '{$temp['student_tests_answers_id']}' AND (stad.`question_type` = 'article' OR stad.`question_type` = 'complete_it_writing_manual_correct')";
        $sql .= " AND pl.`parent_id` = '0'";

        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewTest_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title'], $res['test_id']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewTest_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note'], $res['test_id']);
            }


            $res[$i]['question_attachments'] = $this->getTestQuestionAttachments($temp['test_id'],$res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getTestQuestionAttachments($temp['test_id'],$res[$i]['id'], '', 'note');
        }
        // echo"<pre>";print_r($res);echo"<pre>";die();
    //   print_r($res);die();
       
       
      $questions = $this->customQuestions($res, $temp, 0);
      
      
      return $questions;
  }
  
  public function checkQuestionIsCorrected($params){
      $sql  = "SELECT count(id) FROM `correcting_article_questions` ";
      $sql .= "WHERE `question_id` = '{$params['question_id']}' ";
      $sql .= " AND `test_id` = '{$params['test_id']}' ";
      $sql .= " AND `student_id` = '{$params['student_id']}' ";
      $sql .= " AND `student_answer_id` = '{$params['student_tests_answers_id']}'";
      $res = $this->mDb->getOne($sql);
    //   echo $res;die();
    return $res;
  }
  
  public function checkQuestionAsnswersDetails($params){
      $sql  = "SELECT stad.id, sta.user_id FROM `student_tests_answers_details` stad ";
      $sql .= " LEFT JOIN student_tests_answers sta ON sta.id = stad.student_tests_answers_id";
      $sql .= " WHERE stad.`student_tests_answers_id` = '{$params['student_tests_answers_id']}'";
      $sql .= " AND stad.`question_id` = '{$params['question_id']}'";
      $sql .= " AND sta.`test_id` = '{$params['test_id']}'";
      
    //   echo $sql;die();
      $res = $this->mDb->getRow($sql);
    // echo $res;die();
      return $res;
    
  }
  public function articleQuestionCorrection($temp) {
        
        // Update answer degree
        $updateSql = "UPDATE `student_tests_answers_details` SET `answer_degree` = {$temp['degree']} WHERE `id` = '{$temp['student_tests_answers_details_id']}'";
        // echo $updateSql;die();
        $updateRes = $this->mDb->query($updateSql);
        
        if (!$updateRes) {
            return false;
        }
        
        // Update total answer degree
        $totalDegreeSql = "UPDATE `student_tests_answers` SET `total_answer_degree` = `total_answer_degree` + {$temp['degree']} WHERE `id` = '{$temp['student_tests_answers_id']}'";
        $totalDegreeRes = $this->mDb->query($totalDegreeSql);
    
        $insertCorrectionDataSql  = "INSERT INTO `correcting_article_questions` SET ";
        $insertCorrectionDataSql .= " `question_id` = '{$temp['question_id']}'";
        $insertCorrectionDataSql .= " ,`test_id` = '{$temp['test_id']}'"; 
        $insertCorrectionDataSql .= " ,`student_answer_details_id` = '{$temp['student_tests_answers_details_id']}'";
        $insertCorrectionDataSql .= " ,`student_answer_id` = '{$temp['student_tests_answers_id']}'";
        $insertCorrectionDataSql .= " ,`teacher_id` = '{$temp['teacher_id']}'";
        $insertCorrectionDataSql .= " ,`student_id` = '{$temp['student_id']}'";
        $insertCorrectionDataSql .= " ,`is_corrected` = '1'";
        $insertCorrectionDataSql .= " ,`date_added` = '{$this->dateTime}'";
        // echo $insertCorrectionDataSql;die();
        
        return $this->mDb->query($insertCorrectionDataSql);
    }
    
  public function addCommentOnQuestion($temp){
        
        $sql  = "INSERT INTO `questions_reports` SET ";
        $sql .= " `question_id` = '{$temp['question_id']}' ";
        $sql .= $temp['comment'] ? ", `comment` = '{$temp['comment']}' ":"";
        $sql .= $temp['file'] ? ", `file` = '{$temp['file']}' ":"";
        $sql .= ", `test_id` = '{$temp['test_id']}' ";
        $sql .= ", `grade_id` = '{$temp['grade_id']}' ";
        $sql .= ", `subject_id` = '{$temp['subject_id']}' ";
        $sql .= ", `user_id` = '{$temp['user_id']}' ";
        
        return $this->mDb->query($sql);
    }
    
    function checkTestStatusRefactoring($temp) {

        global $USER_DATA;
        $current_time = date("Y-m-d H:i:s");
        
        $student_tests_answers_id = $this->checkStudentHaveTest($temp['student_id'], $temp['test_id'], $temp['share_id']);
    
        if (!$student_tests_answers_id && strtotime($test_share['scheduled_date']) < strtotime($current_time)) {
            $student_tests_answers_id = $this->insertNewTest($temp['student_id'], $temp['test_id'], $temp['share_id']);
            // echo $student_tests_answers_id;die();
             
            $res = $this->initializeTest($temp, $student_tests_answers_id);
    
            if ($test_share['test_duration'] > 0) {
                $test_duration_data = $this->detectIfStudent_tests_answers_idIsFinishedDuration($student_tests_answers_id);
            }
            $res['count_of_answerd_qustions_of_test'] = 0;
        } else {
            // echo 'test';die();
            $res = $this->getExistingTestDetails($temp, $student_tests_answers_id);
        }
    
        $res = $this->getExistingTestDetails($temp, $student_tests_answers_id);
        
        $res = $this->finalizeTestDetails($res, $student_tests_answers_id, 0, $test_duration_data);
        return $res;
}


// ===== THIS FUNCTION TO HANLDE TEST ==========
private function initializeTest($temp, $student_tests_answers_id) {
    global $USER_DATA;
    $test_arg = [
        'id' => $temp['test_id'],
        'share_id' => $temp['share_id'],
        'just_questions' => true,
        'student_tests_answers_id' => '',
        'resulte_qustions' => false,
        'user_type' => $USER_DATA['user_type'],
        'student_id' => $USER_DATA['id']
    ];

    return $this->getOneTestDetailsRefactoring($test_arg);
}


//======== THIS FUNCTION TO EXSIT ALL TEST DETAILS =======
private function getExistingTestDetails($temp, $student_tests_answers_id) {
    global $USER_DATA;
    $test_arg = [
        'id' => $temp['test_id'],
        'share_id' => $temp['share_id'],
        'student_tests_answers_id' => $student_tests_answers_id,
        'just_questions' => true,
        'resulte_qustions' => false,
        'user_type' => $USER_DATA['user_type'],
        'student_id' => $USER_DATA['id']
    ];

    $res = $this->getOneTestDetailsRefactoring($test_arg);
    $res['count_of_answerd_qustions_of_test'] = $this->getCountOfAnswerQustionsOfTest($student_tests_answers_id);
    return $res;
}

private function finalizeTestDetails($res, $student_tests_answers_id, $test_share, $test_duration_data) {
    $res['student_tests_answers_id'] = $student_tests_answers_id;
    $res['test_status'] = $this->checkTestIfCompleted($student_tests_answers_id);
    $res['scheduled_date'] = $test_share['scheduled_date'];
    $res['scheduled_test'] = $test_share['scheduled_test'];
    $res['test_duration'] = $test_share['test_duration'];
    $res['test_is_finish_duration'] = $res['test_status'] != 'completed' ? $test_duration_data['test_is_finish_duration'] : null;
    $res['test_finish_after_minutes'] = $res['test_status'] != 'completed' ? $test_duration_data['test_finish_after_minutes'] : null;
    return $res;
}

function getOneTestDetailsRefactoring($temp) {
    $this->reFactorTest($temp['id']);
    $sql = "SELECT * FROM `tests_" . LANGUAGE . "` WHERE id ='{$temp['id']}' AND status ='1' AND is_deleted !='1'";
    // echo $sql;die();
    $result = $this->mDb->getRow($sql);
    
    if($temp['share_id'])
    {
        $sqll = "SELECT random_order FROM `tests_shares` WHERE `id` = '{$temp['share_id']}'";
        $result['random_order'] = $this->mDb->getOne($sqll);
        // echo $result['random_order'];die();
    }
    // print_r($result);die();
    if ($result['id'] > 0) {
        $result = $this->enrichTestDetails($result, $temp);
        $test_questions = $this->getTestQuestionRefactoring($temp['id'], '0', $temp['question_id'], $result['random_order'], $temp);
        $result['test_questions'] = $test_questions;
    }
    return $result;
}

//======= THIS FUNCTION TI GET TEST DETAILS =====
private function enrichTestDetails($result, $temp) {
    if ($result['teacher_id']) {
        $result['teacher'] = $this->getSomeUserData($result['teacher_id']);
    }
    $result['available_to_visitor'] = $this->getAvailableToVisitorOfTest($temp['id']);
    $result['test_question_count'] = $this->getCountOfQustionsOfTest($temp['id']);
    $result['can_scan_test'] = $this->checkIfThereManualSolvingQustionOnTest($temp['id']) ? false : true;

    if ($temp['user_type'] == 'student') {
        $data_ = $this->getSomeStudent_tests_answersTestData($temp['student_id'], $temp['id'], $temp['share_id'], '');
        $result['completion_percentage'] = $data_['total_question_count'] > 0 && $data_['total_answered_questions_count'] > 0 ? number_format(($data_['total_answered_questions_count'] / $data_['total_question_count'] * 100), 1, '.', '') : 0;
        $result['finished_before'] = $this->checkStudentHaveTestCompleted($temp['student_id'], $temp['id'], $temp['share_id']);
    }

    $result = $this->handlePrintOptions($result);
    $result['count_of_answers_to_the_test'] = $this->countOfAnswerOnTest($temp['id']);
    return $result;
}


//================ handle Print Options =============
private function handlePrintOptions($result) {
    $result['print_PDF'] = 0;
    $result['print_pubblesheet'] = 0;
    $print_type = explode(",", $result['print_type']);
    if (in_array("pdf", $print_type)) {
        $result['print_PDF'] = 1;
    }
    if (in_array("bubble_sheet", $print_type)) {
        $result['print_pubblesheet'] = 1;
    }
    return $result;
}


// ==== THIS FUNCTION TO GET QUESTIONS ACCORDING TO HEAD QUESTION IF ORDER RANDOM =============
public function getTestQuestionRefactoring($test_id, $parent_id = 0, $question_id, $test_random_order = 0, $temp) {
    $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
    
    $sql = "SELECT pl.*, pl.id AS question_id FROM `".$table."_test_questions` pl WHERE pl.`test_id` = '{$test_id}' AND pl.`parent_id` = '{$parent_id}' AND pl.`question_header_id` = '0'";
    $sql .= $test_random_order ? " ORDER BY RAND()" : "";
    // echo $sql;die();
    
    $res = $this->mDb->getAll($sql);
    // print_r($res);die();
    $questions = array_map(function($question) use ($test_id, $parent_id, $question_id, $test_random_order, $temp) {
        return $this->questionsHandle($question, $test_id, $parent_id, $question_id, $test_random_order, $temp);
    }, $res);

    $result_questions = array_merge([], ...$questions);
    
//      $questions = array_map(function($question) use ($test_id) {
//         $questionObj = $this->questionFactory->store($test_id,$question);
//         $questionObj->getQuestionWithDetails($question, $temp, 0);
//     }, $result_questions);

// return $questions;
    // if($parent_id == '310190'){
    //  print_r($result_questions);die();
    // }
    $sub_questions = $this->customQuestions($result_questions, $temp, $test_random_order, true);
// print_r($sub_questions['test_questions']);die();
    return $sub_questions['test_questions'];
}


// ====== THIS FUNCTION TO GET QUESTION THAT HAVE HEAD QUESTION =============
public function questionsHandle($question, $test_id, $parent_id = 0, $question_id, $test_random_order, $temp) {
    $result_questions = [$question];
    $table = $this->questions_table[$this->getGradeIdOfTest($test_id)];
    if ($question['type'] == 'head_question') {
        $sql = "SELECT pl.*, pl.id AS question_id FROM `".$table."_test_questions` pl WHERE pl.`test_id` = '{$test_id}' AND pl.`parent_id` = '{$parent_id}' AND pl.`question_header_id` = '{$question['id']}'";
        $sql .= $test_random_order ? " ORDER BY RAND()" : "";
        // echo $sql;die();
        $res2 = $this->mDb->getAll($sql);
        foreach ($res2 as &$item) {
            $result_questions[] = $item;
            if ($item['type'] == "paragraphs") {
                $result_questions[count($result_questions) - 1]['test_questions_paragraphs'] = $this->getTestQuestionRefactoring($test_id, $item['id'], $item['id'], $test_random_order, $temp);
            }
        }
    }elseif($question['type'] == "paragraphs") {
                $result_questions[count($result_questions) - 1]['test_questions_paragraphs'] = $this->getTestQuestionRefactoring($test_id, $question['id'], $question['id'], $test_random_order, $temp);
            }
            
            for ($i = 0; $i < count($result_questions); $i++) {

            if (!$result_questions[$i]['math_type_view_title']) {
                $result_questions[$i]['math_type_view_title'] = renderMathType($result_questions[$i]['title']);
                $this->updateMathViewTest_questionsTitle($result_questions[$i]['id'], $result_questions[$i]['math_type_view_title'], $result_questions['test_id']);
            }
            if ((!$result_questions[$i]['math_type_view_note'] && $result_questions[$i]['note']) || ($result_questions[$i]['math_type_view_note'] && !$result_questions[$i]['note'])) {
                $result_questions[$i]['math_type_view_note'] = renderMathType($result_questions[$i]['note']);
                $this->updateMathViewTest_questionsNote($result_questions[$i]['id'], $result_questions[$i]['math_type_view_note'], $result_questions['test_id']);
            }


            $result_questions[$i]['question_attachments'] = $this->getTestQuestionAttachments($test_id, $result_questions[$i]['id'], '', 'question');
            $result_questions[$i]['note_attachments'] = $this->getTestQuestionAttachments($test_id, $result_questions[$i]['id'], '', 'note');
        }
        
        
    return $result_questions;
}


function getAllQ_BankQuestionsById($id)
    {
        $sql = "SELECT  tq.answer_form, tq.answer_form_origin, tq.questions_bank_id , tq.id ,  tq.title ,  tq.type  ,  tq.note , tq.source ,tq.degree , f.name , tq.math_type_view_title , tq.math_type_view_note FROM `questions_bank_questions` tq ";
        $sql .= " LEFT JOIN `questions_bank` f  ON (f.id = tq.questions_bank_id) ";
        $sql .= " LEFT JOIN `subjects` s  ON (s.id = f.subject_id) ";
        $sql .= " Where  tq.`parent_id` = '0' AND f.`status` ='1'  AND  f.is_deleted !='1'   AND tq.`id` = '{$id}'";
        
        
        // $sql .= $temp['subject_id'] ? "  AND  f.subject_id  ='{$temp['subject_id']}'  " : '';
        // $sql .= $temp['test_id'] ? " AND tq.id NOT IN (SELECT refrence_id FROM `test_questions` WHERE test_id = '{$temp['test_id']}') " : " ";

        // $sql .= $temp['bank_id'] ? "  AND tq.questions_bank_id ='{$temp['bank_id']}'  " : '';
        // $sql .= $temp['searchKey'] ? ' AND (tq.title like "%' . $temp['searchKey'] . '%"  ) ' : '';
        // $sql .= " group by tq.id  order by tq.questions_bank_id asc ,   tq.id asc  ";
        // $sql .= $temp['itemsPerPage'] ? " LIMIT {$temp['start']} , {$temp['itemsPerPage']}" : '';
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            if (!$res[$i]['math_type_view_title']) {
                $res[$i]['math_type_view_title'] = renderMathType($res[$i]['title']);
                $this->updateMathViewBank_questionsTitle($res[$i]['id'], $res[$i]['math_type_view_title']);
            }
            if ((!$res[$i]['math_type_view_note'] && $res[$i]['note']) || ($res[$i]['math_type_view_note'] && !$res[$i]['note'])) {
                $res[$i]['math_type_view_note'] = renderMathType($res[$i]['note']);
                $this->updateMathViewBank_questionsNote($res[$i]['id'], $res[$i]['math_type_view_note']);
            }

            $res[$i]['question_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'question');
            $res[$i]['note_attachments'] = $this->getBankQuestionAttachments($res[$i]['id'], '', 'note');

            if (
                $res[$i]['type'] == 'choose' ||
                $res[$i]['type'] == 'check'
            ) {
                $res[$i]['test_question_options'] = $this->getBankQuestionOptions($res[$i]['id']);
            } else if ($res[$i]['type'] == 'paragraphs') {

                $res[$i]['test_questions_paragraphs'] = $this->getBankQuestion($res[$i]['questions_bank_id'], $res[$i]['id']);

                for ($k = 0; $k < count($res[$i]['test_questions_paragraphs']); $k++) {
                    if (
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'choose' ||
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'check'
                    ) {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_options'] = $this->getBankQuestionOptions($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'match_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_match_options'] = $this->getQuestionBankMatch_it($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if ($res[$i]['test_questions_paragraphs'][$k]['type'] == 'sort_it') {
                        $res[$i]['test_questions_paragraphs'][$k]['test_question_sort_words'] = $this->getQuestionBankSort_it($res[$i]['test_questions_paragraphs'][$k]['id']);
                    } else if (
                        $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it' || $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_manual_correct'
                        || $res[$i]['test_questions_paragraphs'][$k]['type'] == 'complete_it_writing_auto_correct'
                    ) {

                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = $this->getBankQuestion($res[$i]['test_questions_paragraphs'][$k]['questions_bank_id'], $res[$i]['test_questions_paragraphs'][$k]['id']);
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = [];
                        for ($a = 0; $a < count($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']); $a++) {
                            $array2 = $this->getQuestionBankComplete_words($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['id']);
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_words'], $array2);
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title_show'] = $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title'];
                            $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['math_type_show_title'] = renderMathType($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'][$a]['title_show']);
                            
                        }
                        $res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_paragraphs'][$k]['test_questions_complete_it_sub']);
                    }
                }
            } else if ($res[$i]['type'] == 'match_it') {
                $res[$i]['test_question_match_options'] = $this->getQuestionBankMatch_it($res[$i]['id']);
            } else if ($res[$i]['type'] == 'sort_it') {
                $res[$i]['test_question_sort_words'] = $this->getQuestionBankSort_it($res[$i]['id']);
            } else if (
                $res[$i]['type'] == 'complete_it' || $res[$i]['type'] == 'complete_it_writing_manual_correct'
                || $res[$i]['type'] == 'complete_it_writing_auto_correct'
            ) {

                $res[$i]['test_questions_complete_it_sub'] = $this->getBankQuestion($res[$i]['questions_bank_id'], $res[$i]['id']);
                $res[$i]['test_questions_complete_it_words'] = [];
                for ($k = 0; $k < count($res[$i]['test_questions_complete_it_sub']); $k++) {
                    $array2 = $this->getQuestionBankComplete_words($res[$i]['test_questions_complete_it_sub'][$k]['id']);
                    $res[$i]['test_questions_complete_it_words'] = array_merge($res[$i]['test_questions_complete_it_words'], $array2);
                    $res[$i]['test_questions_complete_it_sub'][$k]['title_show'] = $res[$i]['test_questions_complete_it_sub'][$k]['title'];
                    $res[$i]['test_questions_complete_it_sub'][$k]['math_type_show_title'] = renderMathType($res[$i]['test_questions_complete_it_sub'][$k]['title_show']);
                    
                }
                $res[$i]['test_questions_complete_it_sub'] = array_values($res[$i]['test_questions_complete_it_sub']);
            }

            if ($res[$i]['name'] != $res[$i - 1]['name']) { //VIP
                $first_question_id = $this->getQuesionIsFistOnTest($res[$i]['questions_bank_id']);
                if ($first_question_id == $res[$i]['id']) {
                    $res[$i]['show_name'] = true;
                }
            }
        }
        
        
        // print_r($res);die();
        return $res[0];
    }
    
    public function get_country_and_stage_by_test_id($test_id){
        $sql = "SELECT name, stage_id, country_id FROM `tests` WHERE `id` = '{$test_id}'";
        return $this->mDb->getRow($sql);
    }
    
}